#include <cstdio>
#include <cstring>
#define N 300000
int t,n,u[N],v[N],du,dv,head[N],nxt[N*2],to[N*2],size[N];
bool vis[N];
void add(int u,int v,int t)
{
	to[t]=v;
	nxt[t]=head[u];
	head[u]=t;
}
void dfs(int x)
{
	vis[x]=1;
	size[x]=1;
	for(int i=head[x];i;i=nxt[i])
	{
		int y=to[i];
		if(!vis[y]&&!((x==du&&y==dv)||(x==dv&&y==du)))
		{
			vis[y]=1;
			dfs(y);
			size[x]+=size[y];
		}
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--)
	{
		memset(head,0,sizeof(head));
		memset(nxt,0,sizeof(nxt));
		memset(to,0,sizeof(to));
		scanf("%d",&n);
		for(int i=1;i<n;i++)
		{
			scanf("%d%d",&u[i],&v[i]);
			add(u[i],v[i],i*2-1);
			add(v[i],u[i],i*2);
		}
		int ans=0;
		for(int i=1;i<n;i++)
		{
			memset(vis,0,sizeof(vis));
			memset(size,0,sizeof(size));
			du=u[i];
			dv=v[i];
			dfs(1);
			//for(int i=1;i<=n;i++)
			//	printf("%d ",size[i]);
			//printf("\n");
			int ans=0;
			for(int i=1;i<=n;i++)
			{
				if(n-size[i]<=n/2)
				{
					bool flag=1;
					for(int j=head[i];j;j=nxt[j])
					{
						int y=to[j];
						if(!((i==du&&y==dv)||(i==dv&&y==du))&&size[y]<size[i]&&size[y]>n/2)
							flag=0;
					}
					if(flag)
						ans+=i;
				}
			}
		}
		printf("%d\n",ans);
	}
	return 0;
}

