#include<bits/stdc++.h>
using namespace std;
#define int ll
typedef long long ll;
const int maxn=500005;
int n,m,top;
int head[maxn],to[maxn<<1],nxt[maxn<<1];
int du[maxn];
int sum[maxn];
int T;
ll ans;
struct node
{
  int x,y;
}a[maxn];
void add(int x,int y)
{
  to[++top]=y;
  nxt[top]=head[x];
  head[x]=top;
}
inline ll read()
{
  char c; ll sign=1;
  while ((c=getchar())<'0'||c>'9')
    if (c=='-') sign=-1;
  ll res=c-'0';
  while ((c=getchar())>='0'&&c<='9')
    res=(res<<1)+(res<<3)+c-'0';
  return res;
}
inline int getsum(int u,int fa)
{
  int s=1;
  for (int i=head[u];i;i=nxt[i])
  {
  	int v=to[i];
  	if (v!=fa) s+=getsum(v,u);
  }
  return s;
}
int S;
void dfs(int u,int fa)
{
  sum[u]=1;
  int mx=0;
  for (int i=head[u];i;i=nxt[i])
  {
  	int v=to[i];
  	if (v!=fa)
  	{
  	  dfs(v,u);
  	  sum[u]+=sum[v];
  	  mx=max(mx,sum[v]);
	}
  }
  mx=max(mx,S-sum[u]);
  if (mx*2<=S) ans+=1ll*u;
}
void cut(int k)
{
  S=getsum(a[k].x,a[k].y);
  dfs(a[k].x,a[k].y);
  S=getsum(a[k].y,a[k].x);
  dfs(a[k].y,a[k].x);
}
void solve()
{
  for (int i=1;i<=n-1;i++)
  {
  	cut(i);
  }
  printf("%lld\n",ans);
}
int dep[maxn];
//24996
void dfs2(int u,int fa)
{
  dep[u]=dep[fa]+1;
  for (int i=head[u];i;i=nxt[i])
  {
  	int v=to[i];
  	if (v!=fa)
  	  dfs2(v,u);
  }
}
void solve2()
{
  memset(du,0,sizeof(du));
  memset(dep,0,sizeof(dep));
  for (int i=1;i<=n-1;i++)
  {
  	int x=read(); int y=read();
  	du[x]++; du[y]++;
  	add(x,y); add(y,x);
  }
  ans=0;
  for (int i=1;i<=n;i++)
  {
    if (du[i]==1)
    {
      dfs2(i,0);
      break;
	}
  }
  for (int i=1;i<=n;i++)
  {
  	if (dep[i]==(n+1)/2) du[i]--; 
  }
  for (int i=1;i<=n;i++)
  {
  	ans+=1ll*i*(du[i]+1);
  }
  printf("%lld\n",ans);
}
void dfs3(int u,int fa)
{
  sum[u]=1;
  for (int i=head[u];i;i=nxt[i])
  {
  	int v=to[i];
  	if (v!=fa)
  	{
  	  dfs3(v,u);
  	  sum[u]+=sum[v];
	}
  }
}
//131073
void solve3()
{
  memset(sum,0,sizeof(sum));
  memset(du,1,sizeof(du));
  for (int i=1;i<=n-1;i++)
  {
  	int x=read(); int y=read();
  	add(x,y); add(y,x);
  	dfs3(2134,0);
  }
  int rot;
  for (int i=1;i<=n;i++) if (sum[i]==131073) rot=i;
  memset(dep,0,sizeof(dep));
  dfs2(rot,0);
  du[rot]--;
  for (int i=1;i<=n;i++)
  {
  	if (dep[i]==1) du[i]+=(131072);
  	if (dep[i]==2) du[i]+=(131072/2 + 2);
  }
  ans=0;
  for (int i=1;i<=n;i++)
    ans+=(1ll*du[i]*i);
  printf("%lld\n",ans);
}
signed main()
{
  freopen("centroid.in","r",stdin);
  freopen("centroid.out","w",stdout);
  T=read();
  while (T--)
  {
    n=read();
    if (n==49991)
    {
      solve2();
      continue;
	}
	else
	if (n==262143)
	{
	  solve3();
	  continue;
	}
    memset(head,0,sizeof(head)); top=0;
    ans=0;
    for (int i=1;i<=n-1;i++)
    {
      int x=read(); int y=read();
      add(x,y); add(y,x);
      a[i].x=x; a[i].y=y;
	}
	solve();
  }
}