#include <bits/stdc++.h>
#define MAX 600005
#define ll long long
using namespace std;

 struct edge{
 	int x, y;
 }e[MAX];

int n, cnt;
int head[MAX], vet[MAX], Next[MAX];

void add(int x, int y){
	cnt++;
	Next[cnt] = head[x];
	head[x] = cnt;
	vet[cnt] = y;
}

int sz[MAX], mx[MAX], tot[MAX];
int sx, sy, s1, s2;
ll ans = 0;
void dfs(int x, int fa, int sum){
	sz[x] = 1, mx[x] = 0;
	for(int i = head[x]; i; i = Next[i]){
		int v = vet[i];
		if(v == fa) continue;
		if(x == sx && v == sy) continue;
		if(x == sy && v == sx) continue;
		dfs(v, x, sum);
		sz[x] += sz[v];
		mx[x] = max(mx[x], sz[v]);
	}
	mx[x] = max(mx[x], sum-sz[x]);
	if(mx[x] <= sum/2){
		ans += x;
	}
}

int d[MAX];
void init(int x, int fa){
	d[x] = d[fa]+1, tot[x] = 1;
	for(int i = head[x]; i; i = Next[i]){
		int v = vet[i];
		if(v == fa)continue;
		init(v, x);
		tot[x] += tot[v];
	}
}

namespace sub{
	ll ans = 0;
	int a[MAX], tot, dep[MAX];
	void dfs(int x, int fa){
		dep[x] = dep[fa]+1;
		a[++tot] = x;
		for(int i = head[x]; i; i = Next[i]){
			int v = vet[i];
			if(v == fa) continue;
			dfs(v, x);
		}
	}
	
	void solve(){
		tot = ans = 0;
		int rt = 0;
		d[0] = 0;
		for(int i = 1; i <= n; i++){
			if(d[i] > d[rt]) rt = i;
		}
		dfs(rt, 0);
		for(ll i = 2; i <= n; i++){
			if(i&1) ans += a[i/2]+a[(i+1)/2];
			else ans += a[i/2];
			if((n-i+1)&1) ans += a[i+(n-i)/2];
			else ans += a[i+(n-i)/2]+a[i+(n-i+1)/2];
		}
		cout << ans << endl;
	}
}

void solve(){
	ans = 0;
	for(int i = 1; i <= cnt; i++) head[i] = 0;
	for(int i = 1; i <= n; i++) sz[i] = mx[i] = 0;
	cnt = 0;
	cin >> n;
//	cout << n << endl;
	int x, y;
	for(int i = 1; i < n; i++){
		scanf("%d%d", &x, &y);
		e[i] = (edge){x, y};
		add(x, y), add(y, x);
	}
	init(1, 0);
	if(n == 49991){
		sub::solve();
		return;
	}
	for(int i = 1; i < n; i++){
		sx = e[i].x, sy = e[i].y;
		if(d[sx] > d[sy]) swap(sx, sy);
		s1 = n-tot[sy], s2 = tot[sy];
		dfs(sx, 0, s1);
		dfs(sy, 0, s2);
	}
	cout << ans << endl;
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	int T;
	cin >> T;
	while(T--){
		solve();
	}
	
	return 0;
}
