#include<cstdio>
#include<cstring>
#include<algorithm>
#define ll long long
#define N 300005
using namespace std;

template<class T>
void read(T &x) {
	x=0;char ch=getchar();bool flag=false;
	for(;ch!='-' && !(ch>='0' && ch<='9');ch=getchar());
	if(ch=='-') ch=getchar(),flag=true;
	for(;ch>='0' && ch<='9';ch=getchar()) x=x*10+ch-48;
	if(flag) x=-x;
}

template<class T>
void write(T x) {
	if(x==0) {putchar('0');return;}
	if(x<0) x=-x,putchar('-');
	static int st[30];int t=0;
	while(x) st[t++]=x%10,x/=10;
	while(t) putchar(st[--t]+48);
}

struct Edge {
	int from,to,ne;
} e[N<<1];

int n,cnt,x,y,g[N];

struct sub1 {
	int root,inde,a[N];
	
	void dfs(int u,int fa) {
		a[++inde]=u;
		for(int i=g[u];i!=-1;i=e[i].ne) {
			int &v=e[i].to;
			if(v==fa) continue;
			dfs(v,u);
		}
	}
	
	void init() {
		for(int i=1;i<=n;i++) {
			if(e[g[i]].ne==-1) {
				root=i;
				break;
			}
		}
		inde=0;
		dfs(root,-1);
	}
	
	ll acht() {
		ll ret=0;int tmp;
		for(int i=1;i<inde;i++) {
			if(i&1) {
				ret+=a[(i>>1)+1];
			} else {
				ret+=a[(i>>1)]+a[(i>>1)+1];
			}
			tmp=inde-i;
			if(tmp&1) {
				ret+=a[i+(tmp>>1)+1];
			} else {
				ret+=a[i+(tmp>>1)]+a[i+(tmp>>1)+1];
			}
		}
		return ret;
	}
};

struct sub2 {
	int siz[N],mx;bool is[N],vis[N];
	
	sub2() {
		memset(siz,0,sizeof siz);
		memset(vis,0,sizeof vis);
	}
	
	void dfs(int u,int fa) {
		siz[u]=1;
		is[u]=true;
		for(int i=g[u];i!=-1;i=e[i].ne) {
			int &v=e[i].to;
			if(v==fa || vis[v]) continue;
			dfs(v,u);
			siz[u]+=siz[v];
			if(siz[v]>mx/2) {
				is[u]=false;
			}
		}
		if(mx-siz[u]>mx/2) {
			is[u]=false;
		}
	}
	
	ll acht() {
		ll ans=0;
		int x,y;
		for(int i=1;i<n;i++) {
			x=e[i*2-1].from;
			y=e[i*2-1].to;
			vis[x]=true;
			vis[y]=true;
			dfs(x,-1);
			dfs(y,-1);
			memset(is,false,sizeof is);
			mx=siz[x];
			dfs(x,-1);
			mx=siz[y];
			dfs(y,-1);
			for(int j=1;j<=n;j++) {
				if(is[j]) {
					ans+=j;
				}
			}
			vis[x]=false;
			vis[y]=false;
		}
		return ans;
	}
};

int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T_T;
	read(T_T);
	while(T_T--) {
		read(n);
		cnt=0;memset(g,-1,sizeof g);
		for(int i=1;i<n;i++) {
			read(x);
			read(y);
			e[cnt]=(Edge){x,y,g[x]};
			g[x]=cnt++;
			e[cnt]=(Edge){y,x,g[y]};
			g[y]=cnt++;
		}
		int tmp=0;
		for(int i=1;i<=n;i++) {
			if(e[g[i]].ne==-1) {
				++tmp;
			}
		}
		if(tmp==2) {
			static sub1 s1;
			s1.init();
			write(s1.acht());
			putchar('\n');
		} else {
			static sub2 s2;
			write(s2.acht());
			putchar('\n');
		}
	}
	return 0;
}
