#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cctype>
inline int getint()
{
	int r = 0,s = 0;char c = getchar();for(;!isdigit(c);c = getchar()) s |= c == '-';
	for(;isdigit(c);c = getchar()) r = (((r << 2) + r) << 1) + (c ^ '0');return s ? -r : r;
}
typedef long long LL;
const int N = 50005;
int head[N],next[N << 1],to[N << 1],tot = 0,deg[N];
inline void addedge(int u,int v)
{
	next[++tot] = head[u],to[tot] = v;head[u] = tot;deg[u]++;
	next[++tot] = head[v],to[tot] = u;head[v] = tot;deg[v]++;
}
int U[N],V[N];
int n,T;
namespace bruteforce
{
	int siz[N],vis[N],rt1,rt2,fa[N];
	inline void dfs(int u,int rt)
	{
		vis[u] = rt;siz[u] = 1;
		for(int i = head[u],v = to[i];~i;v = to[i = next[i]])
		{
			if(v == fa[u] || v == rt1 + rt2 - rt) continue;
			fa[v] = u;dfs(v,rt);siz[u] += siz[v];
		}
	}
	void main()
	{
		LL ans = 0;
		for(int i = 1;i < n;i++)
		{
			rt1 = U[i],rt2 = V[i];
			fa[rt1] = fa[rt2] = 0;
			dfs(rt1,rt1);dfs(rt2,rt2);
			for(int u = 1;u <= n;u++)
			{
				int sz = 0;
				for(int i = head[u],v = to[i];~i;v = to[i = next[i]])
				{
					if(v == fa[u] || v == rt1 + rt2 - vis[u]) continue;
					sz = std::max(sz,siz[v]);
				}
				sz = std::max(sz,siz[vis[u]] - siz[u]);
				if(sz <= (siz[vis[u]] >> 1)) ans += u;
			}
		}
		printf("%lld\n",ans);
	}
}
namespace chain
{
	int a[N],cnt = 0;
	inline void dfs(int u,int f)
	{
		a[++cnt] = u;
		for(int i = head[u],v = to[i];~i;v = to[i = next[i]])
		{
			if(v == f) continue;
			else dfs(v,u);
		}
	}
	void main(int ep)
	{
		cnt = 0;
		dfs(ep,0);
		LL ans = 0;
		for(int i = 1;i < n;i++)
		{
			if(i & 1) ans += a[(1 + i) >> 1];
			else ans += a[(1 + i) >> 1] + a[(2 + i) >> 1];
			if((n - i) & 1) ans += a[(n + i + 1) >> 1];
			else ans += a[(n + i + 1) >> 1] + a[(n + i + 2) >> 1];
		}
		printf("%lld\n",ans);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T = getint();
	while(T--)
	{
		n = getint();
		memset(head,-1,sizeof(head));tot = 0;
		memset(deg,0,sizeof(deg));
		for(int i = 1;i < n;i++) 
		{
			int u = getint(),v = getint();
			U[i] = u,V[i] = v;
			addedge(u,v);
		}
		if(n <= 2000) bruteforce::main();
		else
		{
			int ep = 0,c1 = 0,c2 = 0;
			for(int i = 1;i <= n;i++)
			{
				c1 += deg[i] == 1;
				c2 += deg[i] == 2;
				if(deg[i] == 1) ep = i;
			}
			if(c1 == 2 && c1 + c2 == n) chain::main(ep);
		}
	}
	return 0;
}
