/*
 * Problem "partition" answered by KingOfWA(ZJ-00047)
 * v1.0 O(n!)
 * v1.1 faster but failed
 * v1.2 add debug features
 * v2.0 big changes
 */


#include<iostream>
#include<cstdio>
using namespace std;

const int N = 1000000; // 4MB
int n, type;
int a[N + 10];
#ifdef _DEBUG
    int trace[N + 10];
#endif
unsigned long long ans;

void Solve(int x, unsigned long long last, unsigned long long nowAns){
    if(nowAns > ans) return;
    /*
    if(x == n){
        nowAns += a[x] * a[x];
        if(nowAns > ans) return;
        ++x;
    }
    */
    if(x > n){
        ans = nowAns;
        #ifdef _DEBUG
            for(int i = 1; i <= n; ++i){
                printf("%d ", a[i]);
                if(trace[i]) printf("| ");
            }
            putchar('\n');
        #endif
        return;
    }
    if(a[x] >= last && x < n &&  a[x + 1] >= a[x]){
        #ifdef _DEBUG
            //printf("DIRECT:%d\n",x);
            trace[x] = 1;
        #endif
        Solve(x + 1, a[x], nowAns + a[x] * a[x]);
        #ifdef _DEBUG
            trace[x] = 0;
        #endif
    }
    else {
        unsigned long long t = 0;
        for(int i = x; i <= n; ++i){
            t += a[i];
            if(t >= last){
                #ifdef _DEBUG
                    trace[i] = 1;
                #endif
                Solve(i + 1, t, nowAns + t * t);
                #ifdef _DEBUG
                    trace[i] = 0;
                #endif
                //break; // v1.1 failed
            }
        }
    }
}

int main(){
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
    scanf("%d%d", &n, &type);
    if(type){
    }
    else {
        for(int i = 1; i <= n; ++i){
            scanf("%d", a + i);
        }
        ans = -1;
        Solve(1, 0, 0);
    }
    printf("%lld\n", (signed long long)ans);
    return 0;
}
