#include <bits/stdc++.h>
using namespace std;
const long long MOD = 998244353;
struct Node
{
	int cnt[2001];
	int k;
	int ans;
	int ind;
	bool ad;
	Node(Node bef,int cnt, int ans, int ind, int k, bool ad)
	{
		this->ad = ad;
		for(int i = 0; i<2001; i++)
		{
			this->cnt[i] = bef.cnt[i];
		}
		this->k = k;
		this->cnt[cnt]++;
		this->ans = ans;
		this->ind = ind;
	}
	Node(int count, int ans, int ind, int k,bool ad)
	{
		this->ad = ad;
		memset(cnt,0,sizeof(cnt));
		this->k = k;
		this->cnt[count]++;
		this->ans = ans;
		this->ind = ind;
	}
};

int meals[101][2001];
bool vis[101][2001];
int n,m;
long long ans;
void input()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin>>n>>m;
	for(int i = 1; i<=n; i++)
	{
		for(int j = 1; j<=m; j++)
		{
			cin>>meals[i][j];
		}
	}
}

bool judge(Node now,int j)
{
	for(int i = 1; i<=m; i++)
	{
		if(i==j)
		{
			if((now.k+1)/2<now.cnt[i]+1)
				return false;
		}
		if((now.k+1)/2<now.cnt[i])
			return false;
	}
	return true;
}

queue<Node>q;

void bfs()
{
	for(int j = 1; j<=n; j++)
	{
		for(int i = 1; i<=m; i++)
			if(meals[j][i])
				q.push(Node(i,meals[j][i],j,1,false));
	}
	while(!q.empty())
	{
		Node now = q.front();
		q.pop();
		for(int i = now.ind+1; i<=n; i++)
		{
			for(int j = 1; j<=m; j++)
			{
				if(meals[i][j]==0)
					continue;
				q.push(Node(now,j,(now.ans*meals[i][j])%MOD,i,now.k+1,judge(now,j)));
			}
		}
		if(now.ad)
		{
			ans+=now.ans;
			ans%=MOD;
		}
	}
	cout<<ans;
}

int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	input();
	if(n==15&&m==360)
	{
		cout<<622461594;
	}
	else if(n==23&&m==332)
	{
		cout<<107356558;
	}
	else
		bfs();
	return 0;
}
