// C++ includes used for precompiling -*- C++ -*-

// Copyright (C) 2003-2013 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.

// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
// <http://www.gnu.org/licenses/>.

/** @file stdc++.h
 *  This is an implementation file for a precompiled header.
 */

// 17.4.1.2 Headers

// C
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif
typedef long long ll;
const ll mod=998244353;
#define debug
#ifdef debug
#define s_u_m 1
#else
#define s_u_m 0
#endif
#define she_(x) \
for(ll error_##x=0;(error_##x<s_u_m)&&(puts("error"#x":"),1);++error_##x)
#define she(x) she_(x)
ll readll() {
	ll x=0,w=1;
	char c=getchar();
	for(;'0'>c||'9'<c;(c^'-')||(w=-w),c=getchar());
	for(;'0'<=c&&'9'>=c;x=(x<<1)+(x<<3)+(c^48),c=getchar());
	return x*w;
}
#define IO(x) \
freopen(#x".in","r",stdin);\
freopen(#x".out","w",stdout);
//ll n,m,a[111][1111],f[111],s[111],ans,t[1111];
//void dffs(ll c,ll k) {
//	if(c>n) {
////		ll zs=s[1],sm=1;
////		for(ll i=2;i<=n;i++) 
////		if(s[i]){
////			if(s[i]==zs) {
////				sm++;
////			}
////			else {
////				sm--;
////				if(sm<0) {
////					zs=s[i],sm=1;
////				}
////			}
////		}
//		for(ll i=1;i<=m;i++) {
//			t[i]=0;
//		}
//		ll p=0;
//		for(ll i=1;i<=n;i++) 
//		if(s[i]){
//			p=std::max(p,++t[s[i]]);
//		}
////		ll p=0;
////		for(ll i=1;i<=n;i++)p+=(s[i]==zs);
////		she(_0) {
////			for(ll i=1;i<=n;i++) {
////				printf("%lld ",s[i]);
////			}
////			puts("");
////		}
//		if((p<<1)>k) {
//			she(_1) {
//				for(ll i=1;i<=n;i++) {
//					printf("%lld ",s[i]);
//				}
//				printf("\n%lld\n",-1);
//			}
//			return;
//		}
//		ll sum=1;
//		for(ll i=1;i<=n;i++) 
//		if(s[i]){
//			sum*=a[i][s[i]];
//			sum%=mod;
//		}
//		ans+=sum;
//		ans%=mod;
//		she(_0) {
//			for(ll i=1;i<=n;i++) {
//				printf("%lld ",s[i]);
//			}
//			printf("\n%lld\n",sum);
//		}
//		return;
//	}
//	for(ll i=0;i<=m;i++) {
//		s[c]=i;
//		dffs(c+1,k+!!i);
//	}
//}
ll head[100010],tm[100010],d[100010],to[100010],size[100010],next[100010],maxson[100010],cnt;
void add(ll x,ll y) {
	++cnt;
	to[cnt]=y;
	next[cnt]=head[x];
	head[x]=cnt;
}
ll b,n,ans=0,ti=0,lian=1;
void dfss(ll u) {
	size[u]=1;
	tm[u]=ti;
//	ll p=1;
	maxson[u]=0;
	for(ll i=head[u];i;i=next[i]) 
	if(((i>>1)^b)&&!size[to[i]]){
		dfss(to[i]);
		size[u]+=size[to[i]];
//		if((size[to[i]]<<1)>n)p=0;
		maxson[u]=std::max(maxson[u],size[to[i]]);
	}
//	if((size[u]<<1)<n)p=0;
}
void ddfs(ll u,ll fa) {
	ll p=!!fa;
	for(ll i=head[u];i;i=next[i]) 
	if(to[i]^fa){
		ddfs(to[i],u);
		p++;
		if(p>2)lian=0;
	}
//	if((size[u]<<1)<n)p=0;
}
void work(void) {
	n=readll();
	cnt=1;
	for(ll i=1;i<=n;i++)head[i]=0;
	for(ll i=1;i<n;i++) {
		ll x=readll(),y=readll();
		add(x,y);
		add(y,x);
		d[x]++,d[y]++;
	}
	if(n<=5000) {
		ans=ti=0;
		for(b=1;b<n;b++) {
			ti=0;
			for(ll i=1;i<=n;i++)size[i]=tm[i]=0;
			for(ll i=1;i<=n;i++) 
			if(!size[i]) {
				++ti;
				dfss(i);
				for(ll j=1;j<=n;j++) 
				if(tm[j]==ti&&size[j]*2>=size[i]&&maxson[j]*2<=size[i]){
					ans+=j;
				}
			}
		}
		printf("%lld\n",ans);
	}
	else {
		ans=0;
		ll lian=1;
		for(ll i=1;i<=n;i++)if(d[i]>2)lian=0;
		if(lian) {
			ll ddd=0;
			for(ll ddd=1;ddd<=n;ddd++) {
				if(d[ddd]<2) {
					for(ll u=ddd,last=0,i=1;i<=n;i++) {
						if(i*2-1<=n&&i*2-2>=1)ans+=u;
						if(i*2<=n&&i*2-1>=1)ans+=u;
						if(i*2+1<=n&&i*2>=1)ans+=u;
						ll sdsf=u;
						for(ll j=head[u];j;j=next[j]) 
						if(to[j]^last){
							u=to[j];
						}
						last=sdsf;
					}
				}
			}
			printf("%lld\n",ans);
		}
	}
}
int main() {
	IO(centroid);
	ll t=readll();
	while(t --> 0)work();
	return 0;
}
