#include<bits/stdc++.h>
#define N 100001
using namespace std;

int t, n, cnt;
int son[N], he[N], si[N], fa[N];
bool p[N << 1];
long long res;

struct node{
	int to, ne, st;
}e[N << 1];

void add(int x, int y)
{
	e[++cnt] = {y, he[x], x};
	he[x] = cnt;
}

void dfs(int x)
{
	si[x] = 1, son[x] = 0;
	for(int i = he[x]; i; i = e[i].ne)
	{
		int y = e[i].to;
		if(y == fa[x] || p[i]) continue;
		fa[y] = x, dfs(y), si[x] += si[y];
		if(si[y] > si[son[x]]) son[x] = y;
	}
}

void dfs2(int x, int rt)
{
	for(int i = he[x]; i; i = e[i].ne)
	{
		int y = e[i].to;
		if(y == fa[x] || p[i]) continue;
		dfs2(y, rt);
	}
	if(max(si[rt] - si[x], si[son[x]]) <= si[rt] / 2) res += x;
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &t);
	while(t--)
	{
		cnt = res = 0;
		memset(he, 0, sizeof(he));
		memset(son, 0, sizeof(son));
		memset(si, 0, sizeof(si));
		memset(fa, 0, sizeof(fa));
		memset(e, 0, sizeof(e));
		memset(p, 0, sizeof(p));
		scanf("%d", &n);
		for(int i = 1; i < n; i++)
		{
			int x, y;
			scanf("%d%d", &x, &y), add(x, y), add(y, x);
		}
		for(int x = 1; x <= n; x++)
		{
			for(int i = he[x]; i; i = e[i].ne)
			{
				int y = e[i].to;
				if(y == fa[x]) continue;
				p[i] = 1;
				if(e[i + 1].to == x && e[i + 1].st == y) p[i + 1] = 1;
				else p[i - 1] = 1;
				dfs(1), dfs(y), dfs2(1, 1), dfs2(y, y);
				p[i] = 0;
				if(e[i + 1].to == x && e[i + 1].st == y) p[i + 1] = 0;
				else p[i - 1] = 0;
			}
		}
		printf("%lld\n", res);
	}
	return 0;
}
