#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
typedef long long LL;

const int N = 105, M = 2005, mod = 998244353, base = 102;

int a[N][M], n, m;
LL f[2][N << 1], ans = 1, sum[N];

void solve(int x) {
	memset(f, 0, sizeof(f));
	int flag = 1;
	f[1][base] = 1;
	f[0][base] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = -i; j <= i; ++j) {
			f[flag][j + base] = (f[flag][j + base] + 1LL * a[i][x] * f[flag ^ 1][j - 1+base] % mod) % mod;
			f[flag][j + base] = (f[flag][j+base] + 1LL * (sum[i] - a[i][x]) * f[flag ^ 1][j + 1+base] % mod) % mod;
		}
		flag ^= 1;
		for (int j = -i; j <= i; ++j)
			f[flag][base + j] = f[flag ^ 1][base + j];
	
	}
	flag ^= 1;
	for (int i = 1; i <= n; ++i)
		ans = (ans - f[flag][base + i]) % mod;
}

int main() { //100pts N^2M
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			scanf("%d", &a[i][j]);
			sum[i] = (sum[i] + a[i][j]) % mod;
		}
		ans = (ans * (sum[i] + 1)) % mod;
	}
	ans--;
	
	for (int i = 1; i <= m; ++i)
		solve(i);
	ans = (ans % mod + mod) % mod;
	printf("%lld\n", ans);
	return 0;
}
