#include <cstdio>
#include <cstring>
typedef long long ll;
const int mod = 998244353;
const int maxn = 112;
const int maxm = 2123;
ll dp[45][45][45][45], zz[maxn][maxm]; 
int n, m; 
ll DP(int i, int a, int b, int c){
	if(dp[i][a][b][c] != -1) return dp[i][a][b][c];
	if(i > n){
		int x = (a + b + c) / 2;
		return dp[i][a][b][c] = (a <= x && b <= x && c <= x);	
	}
	ll &now = dp[i][a][b][c];
	now = 0;
	for(int j(1); j <= m; ++j){
		if(zz[i][j] == 0) continue;
		if(j == 1){
			now += DP(i + 1, a + 1, b, c)*zz[i][j];
		}
		else if(j == 2){
			now += DP(i + 1, a, b + 1, c)*zz[i][j];
		}
		else{
			now += DP(i + 1, a, b, c + 1)*zz[i][j];
		}
		now %= mod;
	}
	now += DP(i + 1, a, b, c);
	return now %= mod;
}
int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	memset(dp, -1, sizeof(dp));
	for(int i(1); i <= n; ++i){
		for(int j(1); j <= m; ++j){
			scanf("%lld", &zz[i][j]);
		}
	}	
	dp[n+1][0][0][0] = 0;
	printf("%lld\n", DP(1, 0, 0, 0));
	return 0;
}

