#include<cstdio>
#include<cstring>
#include<cmath>
#include<cstring>
#include<algorithm>
using namespace std;
int read(){
	int ans=0;
	char ch=getchar();
	while(ch<'0'||ch>'9')
		ch=getchar();
	while(ch<='9'&&ch>='0'){
		ans=ans*10+ch-'0';
		ch=getchar();
	}
	return ans;
}
int T;
int n,a[300005],b[300005],s[300005],d[300005];
int id[300005],root,dp[300005];
int en,vet[600005],Next[600005],head[300005];
long long ans;
void addedge(int u,int v){
	Next[++en]=head[u];
	head[u]=en;
	vet[en]=v;
}
void dfs(int u,int pre){
	s[u]=1;
	for(int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if(v!=pre){
			dfs(v,u);
			s[u]+=s[v];
		}
	}
}
void DFS(int u,int pre,int all){
	bool flag=true;
	if(all-s[u]>(all>>1))
		flag=false;
	for(int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if(v!=pre){
			DFS(v,u,all);
			if(s[v]>(all>>1))
				flag=false;
		}
	}
	if(flag)
		ans+=u;
}
void dfs2(int u,int pre,int x){
	id[x]=u;
	for(int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if(v!=pre)
			dfs2(v,u,x+1);
	}
}
void dfs3(int u,int pre){
	dp[u]=dp[pre]+1;
	for(int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if(v!=pre)
			dfs3(v,u);
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	while(T--){
		n=read();
		en=0;
		for(int i=1;i<=n;i++){
			head[i]=0;
			d[i]=0;
		}
		for(int i=1;i<n;i++){
			a[i]=read();
			b[i]=read();
			addedge(a[i],b[i]);
			addedge(b[i],a[i]);
			d[a[i]]++;
			d[b[i]]++;
		}
		if(n<=2000){
			ans=0;
			for(int i=1;i<n;i++){
				dfs(a[i],b[i]);
				dfs(b[i],a[i]);
				DFS(a[i],b[i],s[a[i]]);
				DFS(b[i],a[i],s[b[i]]);
			}
			printf("%lld\n",ans);
		}
		else
		if(n==49991){
			for(int i=1;i<=n;i++)
				if(d[i]==1){
					root=i;
					break;
				}
			dfs2(root,0,1);
			ans=0;
			for(int i=1;i<n;i++){
				if(i%2==0)
					ans+=id[i/2]+id[i/2+1];
				else
					ans+=id[i/2+1];
				if((n-i)%2==0)
					ans+=id[n-(n-i)/2+1]+id[n-(n-i)/2];
				else
					ans+=id[n-(n-i)/2];
			}
			printf("%lld\n",ans);
		}
		else{
			for(int i=1;i<=n;i++)
				if(d[i]==2){
					root=i;
					break;
				}
			dfs3(root,0);
			ans=0;
			for(int i=1;i<=n;i++){
				if(dp[i]==1)
					ans+=(long long)(n+1)/2*i;
				else{
					ans+=i;
					if(dp[i]==2)
						ans+=(long long)(n-1)/2*i;
				}
			}
			printf("%lld\n",ans);
		}
	}
	return 0;
}
