#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int Md = 998244353;
const int N = 1005;

inline int Add(const int &x, const int &y) { return (x + y >= Md) ? (x + y - Md) : (x + y); }
inline int Sub(const int &x, const int &y) { return (x - y < 0) ? (x - y + Md) : (x - y); }
inline int Mul(const int &x, const int &y) { return (ll)x * y % Md; }
int Powe(int x, int y) {
  int ans = 1;
  for(; y; y >>= 1, x = Mul(x, x)) if(y & 1) ans = Mul(ans, x);
  return ans;
}

int n, m;
int a[N][N];

void Bo() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
}

namespace Brute {
  const int M = 50;
  
  int f1[M][M][M][M];
  int f2[M][M][M];

  int Solver1() {
    memset(f2, 0, sizeof f2);
    f2[0][0][0] = 1;
    for(int i = 1; i <= n; i++) {
      for(int j = 0; j < i; j++) {
	for(int k = 0; k < i; k++) {
	  f2[i][j][k] = Add(f2[i][j][k], f2[i - 1][j][k]);
	  f2[i][j + 1][k] = Add(f2[i][j + 1][k], Mul(f2[i - 1][j][k], a[i][1]));
	  f2[i][j][k + 1] = Add(f2[i][j][k + 1], Mul(f2[i - 1][j][k], a[i][2]));
	}
      }
    }
    int res = 0;
    for(int i = 1; i <= n; i++) res = Add(res, f2[n][i][i]);
    return res;
  }

  int Solver2() {
    memset(f1, 0, sizeof f1);
    f1[0][0][0][0] = 1;
    for(int i = 1; i <= n; i++) {
      for(int j = 0; j < i; j++) {
	for(int k = 0; k < i; k++) {
	  for(int l = 0; l < i; l++) {
	    f1[i][j][k][l] = Add(f1[i][j][k][l], f1[i - 1][j][k][l]);
	    f1[i][j + 1][k][l] = Add(f1[i][j + 1][k][l], Mul(f1[i - 1][j][k][l], a[i][1]));
	    f1[i][j][k + 1][l] = Add(f1[i][j][k + 1][l], Mul(f1[i - 1][j][k][l], a[i][2]));
	    f1[i][j][k][l + 1] = Add(f1[i][j][k][l + 1], Mul(f1[i - 1][j][k][l], a[i][3]));
	  }
	}
      }
    }
    int res = 0;
    for(int i = 0; i <= n; i++) {
      for(int j = 0; j <= n; j++) {
	for(int k = 0; k <= n; k++) {
	  int tot = i + j + k;
	  if(tot == 0) continue;
	  if(i <= tot / 2 && j <= tot / 2 && k <= tot / 2) res = Add(res, f1[n][i][j][k]);
	}
      }
    }
    return res;
  }
  
  void main() {
    int ans = 0;
    if(m == 2) ans = Solver1();
    else ans = Solver2();
    printf("%d\n", ans);
  }
}

int main() {
  Bo();
  scanf("%d%d", &n, &m);
  for(int i = 1; i <= n; i++) {
    for(int j = 1; j <= m; j++) {
      scanf("%d", &a[i][j]);
    }
  }
  Brute::main();
  return 0;
}
