#include <bits/stdc++.h>
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define dep(i, a, b) for (int i = (a); i >= (b); --i)
using namespace std;

namespace tree {

  const int N = 2000 + 10;
  int cnt = 0, n;
  long long Ans = 0;
  int fst[N * 2], lst[N * 2], des[N * 2], nxt[N * 2], vis[N], sz[N];

  void init() {
    memset(fst, 0, sizeof fst);
    memset(lst, 0, sizeof lst);
    memset(des, 0, sizeof des);
    memset(nxt, 0, sizeof nxt);
    Ans = 0, cnt = 0;
  }

  void add(int u, int v) {
    if (!fst[u]) fst[u] = ++cnt;
    else nxt[lst[u]] = ++cnt;
    des[cnt] = v, lst[u] = cnt;
  }

  void dfs1(int u, int fa, int lmt) {
    sz[u] = 1, vis[u] = 1;
    for (int i = fst[u]; i; i = nxt[i])
      if (i == lmt * 2 || i == lmt * 2 - 1) continue;
      else {
	if (des[i] != fa) {
	  dfs1(des[i], u, lmt);
	  sz[u] += sz[des[i]];
	}
      }
  }

  void dfs2(int u, int fa, int lmt, int root) {
    int flag = 1;
    for (int i = fst[u]; i; i = nxt[i])
      if (i == lmt * 2 || i == lmt * 2 - 1) continue;
      else {
	if (des[i] != fa) {
	  dfs2(des[i], u, lmt, root);
	  if (sz[des[i]] > sz[root] / 2) flag = 0;
	}
      }
    if (sz[root] - sz[u] > sz[root] / 2) flag = 0;
    if (flag) Ans += u;
  }

  const int MaxN = 300000 + 10;
  int ff[MaxN * 2], ll[MaxN * 2], nn[MaxN * 2], dd[MaxN * 2], p[MaxN], d[MaxN];

  void addedge(int u, int v) {
    if (!ff[u]) ff[u] = ++cnt;
    else nn[ll[u]] = ++cnt;
    ll[u] = cnt, dd[cnt] = v;
  }

  void ddfs(int u, int fa, int num) {
    p[num] = u;
    for (int i = ff[u]; i; i = nn[i])
      if (dd[i] == fa) continue;
      else ddfs(dd[i], u, num + 1);
  }

  void init2() {
    memset(ff, 0, sizeof ff);
    memset(nn, 0, sizeof nn);
    memset(ll, 0, sizeof ll);
    memset(dd, 0, sizeof dd);
    cnt = 0, Ans = 0;
  }

  void solve2() {
    init2();
    rep(i, 1, n - 1) {
      int u, v; scanf("%d%d", &u, &v);
      d[u] ++, d[v] ++;
      addedge(u, v), addedge(v, u);
    }
    int temp = 0;
    rep(i, 1, n) if (d[i] == 1) {
      temp = i;
      break;
    }
    ddfs(temp, temp, 1);
    rep(i, 2, n) {
      if (i % 2 == 0) Ans += p[i / 2];
      else Ans += (p[i / 2] + p[i / 2 + 1]);
      if ((n - i) % 2 == 0) Ans += p[(i + n) / 2];
      else Ans += (p[(i + n) / 2] + p[(i + n) / 2 + 1]);
    }
    cout << Ans << endl;
  }

  void solve() {
    scanf("%d", &n);
    if (n > 2000) solve2();
    else {
      rep(i, 1, n - 1) {
	int u, v; scanf("%d%d", &u, &v);
	add(u, v), add(v, u);
      }
      rep(i, 1, n - 1) {
	memset(sz, 0, sizeof sz);
	memset(vis, 0, sizeof vis);
	rep(j, 1, n) if (!vis[j]) {
	  dfs1(j, j, i);
	  dfs2(j, j, i, j);
	}
      }
      cout << Ans << endl;
    }
  }

}

int main() {

  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);

  int T; scanf("%d", &T);
  while (T --) {
    tree::init();
    tree::solve();
  }

}
