//brackets
#include <cstdio>
#include <cstring>

inline int GetChar() {
#define MAX (1 << 15)
	static char Buffer[MAX];
	static char *l = Buffer, *r = Buffer;
	if (l == r) {
		l = Buffer;
		r = Buffer + fread(Buffer, 1, MAX, stdin);
	}
	return *l++;
}

inline void Read(int &x) {
	static char ch;
	for (ch = GetChar(); ch < 48 || ch > 57; ch = GetChar());
	for (x = 0; ch > 47 && ch < 58; x = (x << 1) + (x << 3) + (ch ^ 48), ch = GetChar());
	return;
}

#define Maxn 500010
int n;
char A[Maxn], B[Maxn];
int To[Maxn << 1], Cnt[Maxn], Deep;
long long Ans, Rec[Maxn];
struct edge {
	int To, Next;
	edge() {}
	edge(int _To, int _Next) : To(_To), Next(_Next) {}
};
edge Edge[Maxn << 1];
int Start[Maxn], Used;

inline void AddEdge(int x, int y);
void Calc(int u, int Fa);

int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	Read(n);
	for (int i = 1; i <= n; ++i) {
		A[i] = GetChar();
		while (A[i] != '(' && A[i] != ')') A[i] = GetChar();
	}
	for (int i = 2, x; i <= n; ++i) {
		Read(x);
		AddEdge(x, i), AddEdge(i, x);
	}
	Deep = n + 1;
	memset(To, 255, sizeof(To));
	To[Deep] = 0;
	if (A[1] == '(') ++Deep; else --Deep;
	Calc(1, 0);
	printf("%lld\n", Ans);
	return 0;
}


inline void AddEdge(int x, int y) {
	Edge[++Used] = edge(y, Start[x]);
	Start[x] = Used;
	return;
}

void Calc(int u, int Fa) {
	int Temp = To[Deep];
	Rec[u] = Rec[Fa];
	if (A[u] == ')') {
		if (To[Deep] != -1) Cnt[u] = Cnt[To[Deep]] + 1;
		else Cnt[u] = 0;
		Rec[u] += Cnt[u];
		To[Deep] = u;
	} else {
		Cnt[u] = 0;
		To[Deep] = u;
	}
	Ans ^= 1LL * u * Rec[u];
	for (int t = Start[u]; t; t = Edge[t].Next) {
		int v = Edge[t].To;
		if (v == Fa) continue;
		if (A[v] == '(') ++Deep; else --Deep;
		Calc(v, u);
		if (A[v] == '(') --Deep; else ++Deep;
	}
	To[Deep] = Temp;
	return;
}
