//meal
#include <cstdio>

inline int GC() {
#define MAX (1 << 15)
	static char Buffer[MAX];
	static char *l = Buffer, *r = Buffer;
	if (l == r) {
		l = Buffer;
		r = Buffer + fread(Buffer, 1, MAX, stdin);
	}
	return *l++;
}

inline void Read(int &x) {
	static char ch;
	for (ch = GC(); ch < 48 || ch > 57; ch = GC());
	for (x = 0; ch > 47 && ch < 58; x = (x << 1) + (x << 3) + (ch ^ 48), ch = GC());
	return;
}

#define Maxn 110
#define Maxm 2010
#define Mod 998244353
int n, m, A[Maxn][Maxm], Sum[Maxn];
int UnLi[Maxn][Maxn], Li[Maxn][Maxn][Maxn], Ans;
int Sigma[Maxn];

inline void Add(int &x, int y) {
	x = x + y >= Mod ? x + y - Mod : x + y;
	return;
}

inline int del(int x, int y) {
	return x < y ? x + Mod - y : x - y;
}

inline void Del(int &x, int y) {
	x = x < y ? x + Mod - y : x - y;
	return;
}

inline void Solve1() {
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j) 
			Add(Sum[i], A[i][j]);
	UnLi[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		UnLi[i][0] = 1;
		for (int j = 1; j <= i; ++j)
			UnLi[i][j] = (1LL * UnLi[i - 1][j - 1] * Sum[i] % Mod + UnLi[i - 1][j]) % Mod;
	}
	Ans = 0;
	for (int i = 1; i <= n; ++i) Add(Ans, UnLi[n][i]);
	for (int i = 1; i <= m; ++i) {
		Li[0][0][0] = 1;
		for (int j = 1; j <= n; ++j) {
			Li[j][0][0] = 1;
			for (int k = 1; k <= j; ++k) {
				Li[j][k][0] = (1LL * Li[j - 1][k - 1][0] * del(Sum[j], A[j][i]) % Mod + Li[j - 1][k][0]) % Mod;
				for (int l = 1; l <= k; ++l) {
					Li[j][k][l] = (1LL * Li[j - 1][k - 1][l] * del(Sum[j], A[j][i]) % Mod + Li[j - 1][k][l]) % Mod;
					Add(Li[j][k][l], 1LL * Li[j - 1][k - 1][l - 1] * A[j][i] % Mod);
				}
			}
		}
		for (int j = 1; j <= n; ++j)
			for (int k = j / 2 + 1; k <= j; ++k)
				Del(Ans, Li[n][j][k]);
	}
	printf("%d\n", Ans);
	return;
}

inline void Solve2() {
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j) 
			Add(Sum[i], A[i][j]);
	UnLi[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		UnLi[i][0] = 1;
		for (int j = 1; j <= i; ++j)
			UnLi[i][j] = (1LL * UnLi[i - 1][j - 1] * Sum[i] % Mod + UnLi[i - 1][j]) % Mod;
	}
	Ans = 0;
	for (int i = 1; i <= n; ++i) Add(Ans, UnLi[n][i]);
	for (int i = 1; i <= n; ++i) 
		for (int j = 1; j <= n; ++j)
			Add(Sigma[i], del(Sum[i], A[i][j]));
	Li[0][0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		Li[i][0][0] = 1;
		for (int j = 1; j <= i; ++j) {
			Li[i][j][0] = (1LL * Li[i - 1][j - 1][0] * Sigma[i] % Mod + 1LL * Li[i - 1][j][0]) % Mod;
			for (int k = 1; k <= j; ++k) {
				Li[i][j][k] = (1LL * Li[i - 1][j - 1][k] * Sigma[i] % Mod + 1LL * Li[i - 1][j][k]) % Mod;
				Add(Li[i][j][k], 1LL * Li[i - 1][j - 1][k - 1] * Sum[i] % Mod);
			}
		}
	}
	for (int i = 1; i <= n; ++i)
		for (int j = i / 2 + 1; j <= i; ++j)
			Del(Ans, Li[n][i][j]);
	printf("%d\n", Ans);
	return;
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	Read(n); Read(m);
	for (int i = 1; i <= n; ++i) 
		for (int j = 1; j <= m; ++j)
			Read(A[i][j]);
	if (n <= 40 && m <= 500) Solve1();
	else Solve2();
//	Solve2();
	return 0;
}
