#include<bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 3e5;
int T, n, d[N], son[N], t, weigh;
int tot, head[N], ver[N*2], Next[N*2];
ll ans;
struct node{int x, y;}e[N];
int read() {
	int x = 0, s = 1; char ch = getchar();
	while (ch < '0' || ch > '9') {if (ch == '-') s = -1; ch = getchar();}
	while (ch >= '0' && ch <= '9') {x=x*10+ch-'0'; ch = getchar();}
	return x * s;
}
void add(int x, int y) {
	tot ++; ver[tot] = y; Next[tot] = head[x]; head[x] = tot;
}
void init() {
	tot = ans = 0;
	memset(head, 0, sizeof(head));
	memset(d, 0, sizeof(d));
	memset(son, 0, sizeof(son));
}
void dfs(int x) {
	son[x] = 1;
	for (int i = head[x]; i; i = Next[i]) {
		int y = ver[i];
		if (d[y]) continue;
		d[y] = d[x] + 1;
		dfs(y);
		son[x] += son[y];
	}
}
void solve(int x, int v, int fa) {
	bool flag = 1;
	for (int i = head[x]; i; i = Next[i]) {
		int y = ver[i];
		if (x == t && y == v) continue;
		if (son[y] > son[t] / 2) flag = 0;
	}
	if (flag && son[t] - son[x] -1 <= son[t] / 2) ans += x;
	for (int i = head[x]; i; i = Next[i]) {
		int y = ver[i];
		if (y == fa || (x == t && y == v)) continue;
		solve(y, v, x);
	}
}
int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = read();
	while (T -- ) {
		init();
		n = read();
		for (int i = 1; i < n; i ++ ) {
			e[i].x = read(), e[i].y = read();
			add(e[i].x, e[i].y); add(e[i].y, e[i].x);
		}
		d[1] = 1; dfs(1);
		for (int i = 1; i < n; i ++ ) {
			if (d[e[i].x] < d[e[i].y]) son[e[i].x] -= son[e[i].y];
			else son[e[i].y] -= son[e[i].x];
			if (son[e[i].x] == 1) ans += e[i].x;
			else t = e[i].x, solve(t, e[i].y, 0);
			if (son[e[i].y] == 1) ans += e[i].y;
			else t = e[i].y, solve(t, e[i].x, 0);
			if (d[e[i].x] < d[e[i].y]) son[e[i].x] += son[e[i].y];
			else son[e[i].y] += son[e[i].x];
		}
		printf("%lld\n", ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
