#include <cstdio>
#include <cstring>
#include <map>
#define rep(i, a, b) for(int i = a; i <= b; ++ i)

std::map <int, std::pair<int, int> > f;
int fa[50005];

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while(T --) {
		int n, ans = 0, fir, las;
		scanf("%d", &n);
		f.clear();
		rep(i, 1, n - 1) {
			int u, v;
			scanf("%d %d", &u, &v);
			fa[u] = v;
			f[i] = std::make_pair(u, v);
		}
		fa[0] = 1;
		f[0] = std::make_pair(0, 1);
		rep(i, 1, n - 1) {
			int tmp = f[i].first, tmp2 = f[i].second;
			int size1 = 0, size2 = 0;
			for(int j = f[1].first; j != tmp; j = fa[j]) ++size1;
			for(int j = tmp2; j; j = fa[j]) ++size2;
			++ size1;
			if(size1 & 1) ans += f[((size1 + 1) >> 1) - 1].second;
			else ans += f[(size1 + 1) >> 1].second + f[((size1 + 1) >> 1) - 1].second;
			printf("%d\n", ans);
			if((n - size2) & 1) ans += f[(((size2 + n) >> 1) - 1) + size2 - 1].second;
			else ans += f[((size2 + n) >> 1) + size2 - 1].second + f[(((size2 + n) >> 1) - 1) + size2 - 1].second;
			printf("%d\n", ans);
		}
		printf("%d\n", ans);
	}
	return 0;
}
