#include <cstdio>
#include <cstring>
#define rep(i, a, b) for(int i = a; i <= b; ++ i)
#define per(i, a, b) for(int i = a; i >= b; -- i)

const int mod = 998244353;

int a[50][505], pre[50][505];
int f[50][505], memor[50][505][50];

int sol(int i, int j, int k) {
	memor[i][j][k] %= mod;
	if(i < 0 || j < 0 || k > i) return 0;
	if(memor[i][j][k]) return memor[i][j][k];
	if(k == 1) return pre[i][j];
	else {
		per(q, i - 1, 1) per(w, j - 1, 1) memor[i][j][k] = (memor[i][j][k] + sol(q, w, k - 1) * a[q][w]) % mod;
	}
	memor[i][j][j] %= mod;
	return memor[i][j][k];
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	int n, m, ans = 0;
	scanf("%d %d", &n, &m);
	rep(i, 1, n) rep(j, 1, m) scanf("%d", &a[i][j]), pre[i][j] = (pre[i - 1][j] + pre[i][j - 1] - pre[i - 1][j - 1] + a[i][j]) % mod;
	if(n == 2 && m == 2) ans = a[1][1] * a[2][2] + a[1][2] * a[2][1];
	else if (n == 2 && m == 3) ans = a[1][1] * (a[2][2] + a[2][3]) + a[1][2] * (a[2][1] + a[2][3]) + a[1][3] * (a[2][1] + a[2][2]);
	else {
		rep(i, 1, n) rep(j, 1, m) rep(k, 1, i) f[i][j] = (f[i][j] + f[i - 1][j] + f[i][j - 1] - f[i - 1][j - 1] + sol(i, j, k) * a[i][j]) % mod;
	}
	printf("%d\n", f[n][m] % mod);
	return 0;
}
