#include <bits/stdc++.h>
#define rep(i, n) for (rint i = 1; i <= (n); i++)
#define re0(i, n) for (rint i = 0; i < (int) n; i++)
#define travel(i, u) for (rint i = head[u]; i; i = e[i].nxt)
#define rint register int
using namespace std;

typedef long long lo;

template <class T> inline void read(T &x) {
	x = 0; char c = getchar(); int f = 0;
	for (; c < '0' || c > '9'; f |= c == '-', c = getchar());
	for (; c >= '0' && c <= '9'; x = x * 10 + c - '0', c = getchar());
	if (f) x = -x;
}

namespace bf {
const int N = 6e5 + 233;
const int M = N << 1;
struct E {
	int nxt, to;
} e[M]; int ban[M];
int head[N], e_cnt = 1;
int id[N], clk, sz[N], f[N], Min;
int n;

inline void replace() {
	re0 (i, n + 2) {
		head[i] = id[i] = sz[i] = f[i] = 0;
	}
	Min = clk = 0;
	n = 0;
	e_cnt = 1;
}

inline void adde(int x, int y) {
	e[++e_cnt] = (E) { head[x], y }; head[x] = e_cnt;
}

inline int F(int u) { return max(f[u], clk - sz[u]); }

inline void dfs(int u, int fat) {
	id[++clk] = u; sz[u] = 1; f[u] = 0;
	travel (i, u) if (!ban[i]) {
		int v = e[i].to;
		if (v != fat) {
			dfs(v, u);
			sz[u] += sz[v];
			f[u] = max(f[u], sz[v]);
		}
	}
}

inline int calc(int x) {
	clk = 0; Min = n + 1;
	dfs(x, 0);
	int ans = 0;
	int Min = n + 1;
	rep (k, clk) Min = min(Min, F(id[k]));
	// cout << Min << "\n";
	rep (k, clk) if (F(id[k]) == Min) ans += id[k];
	return ans;
}

inline void doit() {
	rep (i, n - 1) {
		int x, y; read(x); read(y);
		adde(x, y); adde(y, x);
	}
	lo ans = 0;
	for (int i = 2; i <= e_cnt; i += 2) {
		int x = e[i].to, y = e[i ^ 1].to;
		ban[i] = true; ban[i ^ 1] = true;
		int L = calc(x), R = calc(y);
		// cout << x << " " << y << " " << L << " " << R << "\n";
		ans += L;
		ans += R;
		// exit(0);
		ban[i] = false; ban[i ^ 1] = false;
	}
	cout << ans << "\n";
}

}

namespace lian {
	const int N = 6e5 + 233;
	const int M = N << 1;
	struct E {
		int nxt, to;
	} e[M];
	int head[N], e_cnt = 1;
	int id[N], clk, rev[N], deg[N];
	int n;
	inline void replace() {
		re0 (i, n + 2) {
			head[i] = id[i] = rev[i] = deg[i] = 0;
		}
		n = clk = 0;
		e_cnt = 1;
	}
	inline void adde(int x, int y) {
		e[++e_cnt] = (E) { head[x], y }; head[x] = e_cnt;
	}
	inline void dfs(int u, int fat) {
		id[++clk] = u;
		travel (i, u) {
			int v = e[i].to;
			if (v != fat) dfs(v, u);
		}
	}
	inline int calc(int id[], int len) {
		int mid = (len + 1) / 2;
		if (len % 2 == 0) return id[mid] + id[mid + 1];
		else return id[mid];
	}
	inline void doit() {
		rep (i, n - 1) {
			int x, y; read(x); read(y);
			adde(x, y); adde(y, x);
			++deg[x]; ++deg[y];
		}
		rep (i, n) if (deg[i] == 1) {
			dfs(i, 0);
			break;
		}
		rep (i, n) rev[i] = id[i];
		reverse(rev + 1, rev + n + 1);
		lo ans = 0;
		for (int cut = 1; cut <= n - 1; cut++) {
			ans += calc(id, cut);
			ans += calc(rev, n - cut);
		}
		cout << ans << "\n";
	}
}

namespace binary {
	const int N = 3e5 + 233;
	const int M = N << 1;
	struct E {
		int nxt, to;
	} e[M]; bool ban[M];
	int head[N], e_cnt = 1;
	int n, x, y, Min; lo Sumid;
	int gao_cnt = 0;
	int dfn[N], out[N], clk, dep[N], fa[N], fa_edge[N], sz[N], gao[N], FF[N];
	inline void replace() {
		memset(ban, 0, sizeof ban);
		re0 (i, n + 2) {
			gao[i] = FF[i] = head[i] = dfn[i] = out[i] = dep[i] = fa[i] = fa_edge[i] = sz[i] = 0;
		}
		Min = Sumid = x = y = n = clk = gao_cnt = 0;
		e_cnt = 1;
	}
	inline void adde(int x, int y) {
		e[++e_cnt] = (E) { head[x], y }; head[x] = e_cnt;
	}
	inline bool contain(int x, int y) {
		return dfn[x] <= dfn[y] && out[y] <= out[x];
	}
	inline void dfs(int u, int fat) {
		dep[u] = dep[fa[u] = fat] + 1;
		dfn[u] = ++clk;
		sz[u] = 1;
		travel (i, u) {
			int v = e[i].to;
			if (v != fat) {
				fa_edge[v] = i;
				dfs(v, u);
				sz[u] += sz[v];
			}
		}
		out[u] = clk;
	}
	inline void up(int mx, int u) {
		if (mx < Min) Min = mx, Sumid = u;
		else if (mx == Min) Sumid += u;
	}
	inline int G(int u, bool upd = false) {
		int mx = sz[x] - sz[u];
		travel (i, u) {
			int v = e[i].to;
			if (ban[i] || v == fa[u]) continue;
			mx = max(mx, sz[v]);
		}
		if (upd) up(mx, u);
		return mx;
	}
	inline void calc_son(int u, int fat) {
		G(u, true);
		int best = n + 1, id = 0;
		travel (i, u) {
			int v = e[i].to;
			if (ban[i] || v == fat) continue;
			int cur = G(v);
			if (cur < best) best = cur, id = v;
		}
		if (id) calc_son(id, u);
	}
	inline int F(int u, int flag, bool upd = false) {
		int mx = 0;
		if (gao[u] == gao_cnt) mx = FF[u];
		else {
			gao[u] = gao_cnt;
			if (!flag || u == 1) {
				mx = n - sz[u] - (contain(u, x) ? 0 : sz[x]);
				travel (i, u) {
					int v = e[i].to;
					if (ban[i] || v == fa[u]) continue;
					mx = max(mx, contain(v, x) ? sz[v] - sz[x] : sz[v]);
				}
			} else {
				mx = n - sz[u] - sz[x];
				travel (i, u) {
					int v = e[i].to;
					if (ban[i] || v == fa[u]) continue;
					mx = max(mx, sz[v]);
				}
			}
			FF[u] = mx;
		}
		if (upd) up(mx, u);
		// cerr << u << " " << mx << "\n";
		return mx;
	}
	inline void calc_fa(int u, int fat, bool flag) {
		F(u, flag, true);
		int best = n + 1, id = 0;
		travel (i, u) {
			int v = e[i].to;
			if (ban[i] || v == fat) continue;
			int cur = F(v, flag);
			if (cur < best) best = cur, id = v;
		}
		if (id) calc_fa(id, u, flag || (id == 1));
	}
	inline void doit() {
		rep (i, n - 1) {
			int x, y; read(x); read(y);
			adde(x, y); adde(y, x);
		}
		dfs(1, 0);
		lo ans = 0;
		for (x = 2; x <= n; x++) {
			++gao_cnt;
			y = fa[x];
			ban[fa_edge[x]] = ban[fa_edge[x] ^ 1] = true;
			Min = n + 1; Sumid = 0;
			calc_son(x, 0);
			// cerr << x << " " << Sumid << "\n";
			ans += Sumid;
			Min = n + 1; Sumid = 0;
			calc_fa(y, 0, y == 1);
			// cerr << y << " " << Sumid << "\n";
			ans += Sumid;
			ban[fa_edge[x]] = ban[fa_edge[x] ^ 1] = false;
		}
		cout << ans << "\n";
	}
}

inline void rsolve() {
	int n;
	read(n);
	bf::n = lian::n = binary::n = n;
	if (n <= 2000) bf::doit(), bf::replace();
	else if (n % 10 == 1) lian::doit(), lian::replace();
	else binary::doit(), binary::replace();
}

int main(void) {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; for (read(T); T--; rsolve());
}

