#include <bits/stdc++.h>
#define rep(i, n) for (rint i = 1; i <= (n); i++)
#define re0(i, n) for (rint i = 0; i < (int) n; i++)
#define travel(i, u) for (rint i = head[u]; i; i = e[i].nxt)
#define rint register int
using namespace std;

typedef long long lo;

template <class T> inline void read(T &x) {
	x = 0; char c = getchar(); int f = 0;
	for (; c < '0' || c > '9'; f |= c == '-', c = getchar());
	for (; c >= '0' && c <= '9'; x = x * 10 + c - '0', c = getchar());
	if (f) x = -x;
}

#define int long long
#define sqr(x) ((x) * (x))

const int N = 4e7 + 2333;
const int inf = 4.1e18;
int n, tp, sum[N], vec[N], dp[N];

inline void generate() {
	if (tp == 0) {
		rep (i, n) read(sum[i]);
	} else {
#define b sum
		int x, y, z, m;
		const int MOD = (1 << 30) - 1;
		read(x); read(y); read(z); read(b[1]); read(b[2]); read(m);
		for (int i = 3; i <= n; i++)
			b[i] = (x * b[i - 1] + y * b[i - 2] + z) & MOD;
		int pre = 0;
		rep (k, m) {
			int p, l, r;
			read(p); read(l); read(r);
			// cout << pre << " " << p << " " << l << " " << r << "\n";
			for (int i = pre + 1; i <= p; i++) {
				b[i] = b[i] % (r - l + 1) + l;
			}
			pre = p;
		}
		rep (i, n) assert(b[i] >= 0);
	}
}

signed main(void) {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	read(n); read(tp);
	generate();
	rep (i, n) sum[i] += sum[i - 1];
	rep (i, n) dp[i] = inf;
	int r = 0;
	for (int nxt = 1; nxt <= n; nxt++) {
		r = max(r, vec[nxt]);
		int bound = sum[nxt] - sum[r];
		dp[nxt] = dp[r] + sqr(bound);
		int trans = lower_bound(sum + nxt + 1, sum + n + 1, bound + sum[nxt]) - sum;
		vec[trans] = max(vec[trans], nxt);
	}
	cout << dp[n] << "\n";
}

