#include <bits/stdc++.h>

typedef long long LL;

const int MOD = 998244353;
const int N = 1e2, M = 2e3;

int n, m, a[N + 5][M + 5];

namespace Subtask1 {
	const int N = 40, M = 20;
	
	int f[N + 1][N + 1][M + 1];
	
	void add(int &x, const int y) {
		(x += y) >= MOD && (x -= MOD);
	}
	void main() {
		for (int i = 1; i <= m; i++) {
			f[1][1][1] = a[1][1];
			f[1][1][0] = a[1][2];
			f[1][0][0] = 1;
		}
		int k = n / 2;
		for (int i = 2; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				for (int a1 = 0; a1 <= std::min(j, k); a1++) {
					add(f[i][j][a1], f[i - 1][j][a1]);
					if (j > 0 && a1 > 0) add(f[i][j][a1], (LL)f[i - 1][j - 1][a1 - 1] * a[i][1] % MOD);
					if (j > a1) add(f[i][j][a1], (LL)f[i - 1][j - 1][a1] * a[i][2] % MOD);
				}
			}
		}
		int ans = 0;
		for (int i = 1; i <= n; i++) {
			int k = i / 2;
			for (int j = 0; j <= std::min(i, k); j++) {
				if (j <= k && (i - j) <= k) add(ans, f[n][i][j]);
			}
		}
		printf("%d\n", ans);
	}
}
namespace Subtask2 {
	const int N = 40, M = 20;
	
	int f[N + 1][N + 1][M + 1][M + 1];
	
	void add(int &x, const int y) {
		(x += y) >= MOD && (x -= MOD);
	}
	void main() {
		for (int i = 1; i <= m; i++) {
			f[1][1][1][0] = a[1][1];
			f[1][1][0][1] = a[1][2];
			f[1][1][0][0] = a[1][3];
			f[1][0][0][0] = 1;
		}
		int k = n / 2;
		for (int i = 2; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				for (int a1 = 0; a1 <= std::min(j, k); a1++) {
					for (int a2 = 0; a2 <= std::min(j - a1, k); a2++) {
						add(f[i][j][a1][a2], f[i - 1][j][a1][a2]);
						if (j > 0 && a1 > 0) add(f[i][j][a1][a2], (LL)f[i - 1][j - 1][a1 - 1][a2] * a[i][1] % MOD);
						if (j > 0 && a2 > 0) add(f[i][j][a1][a2], (LL)f[i - 1][j - 1][a1][a2 - 1] * a[i][2] % MOD);
						if (j > a1 + a2) add(f[i][j][a1][a2], (LL)f[i - 1][j - 1][a1][a2] * a[i][3] % MOD);
					}
				}
			}
		}
		int ans = 0;
		for (int i = 1; i <= n; i++) {
			int up = i / 2;
			for (int j = 0; j <= std::min(i, up); j++) {
				for (int k = 0; k <= std::min(i - j, up); k++) {
					if (j <= up && k <= up && (i - j - k) <= up) add(ans, f[n][i][j][k]);
				}
			}
		}
		printf("%d\n", ans);
	}
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			scanf("%d", &a[i][j]);
		}
	}
	if (m == 2) {
		Subtask1::main();
	}
	if (m == 3) {
		Subtask2::main();
	}
	return 0;
}
