#include<iostream>
#include<cstdio>
using namespace std;
struct Edge{
	int to,nxt;
}e[600005];
int T,n,mark,num_edge;
int u[300005],v[300005],h[300005],pa[300005],f[300005];
long long ans;
void add(int from,int to){
	e[++num_edge].to=to;
	e[num_edge].nxt=h[from];
	h[from]=num_edge;
}
void dfs(int fa,int u){
	int v,i;
	f[u]++;
	pa[u]=fa;
	for(i=h[u];i;i=e[i].nxt){
		v=e[i].to;
		if(v==fa)
			continue;
		dfs(u,v);
		f[u]+=f[v];
	}
}
bool check(int fa,int u,int r){
	if(f[r]-f[u]>(f[r]>>1))
		return 0;
	int i,v;
	for(i=h[u];i;i=e[i].nxt){
		v=e[i].to;
		if(fa!=v&&f[v]>(f[r]>>1))
			return 0;
	}
	return 1;
}
int centro(int r){
	int res=0,i;
	for(i=0;i<=n;i++)
		pa[i]=f[i]=0;
	dfs(0,r);
	for(i=1;i<=n;i++)
		if(f[i]&&check(pa[i],i,r))
			res+=i;
	return res;
}
int work(){
	int i;
	num_edge=0;
	for(i=0;i<=n;i++)
		h[i]=pa[i]=0;
	for(i=0;i<=(n<<1);i++)
		e[i].to=e[i].nxt=0;
	for(i=1;i<n;i++)
		if(i!=mark){
			add(u[i],v[i]),add(v[i],u[i]);
		}
	return centro(u[mark])+centro(v[mark]);
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int i;
	scanf("%d",&T);
	while(T--){
		ans=0;
		scanf("%d",&n);
		for(i=1;i<n;i++)
			scanf("%d%d",&u[i],&v[i]);
		if(n<=10000)
			for(i=1;i<n;i++){
				mark=i;
				ans+=work();
			}
		else{
			for(i=1;i<n;i++){
				if(i%2==1)
					ans+=((i+1)>>1);
				else
					ans+=(i>>1)+(i>>1)+1;
				if((n-i)%2==0)
					ans+=((n-i)>>1)+i+((n-i)>>1)+i+1;
				else
					ans+=((n-i)>>1)+i+1;
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}
