#include <bits/stdc++.h>
#define int long long
using namespace std;

const int M = 600000;
int t, n, m, ans=0;
int head[M], nex[M], to[M], tot=0;
int siz[M], s[3][M], top[3];
struct xtw{
    int from, to;
}a[M];

template <typename Tp>
inline void read(Tp &x)
{
    char ch=getchar(); bool f=0; x=0;
    for(;ch<'0' || ch>'9';ch=getchar()) f^=(ch=='-');
    for(;ch>='0' && ch<='9';ch=getchar()) x=x*10+(ch-'0');
    x=f?-x:x;
}

inline void add_edge(int x,int y)
{
    to[++tot]=y;
    nex[tot]=head[x];
    head[x]=tot;
}

inline int check(int x,int typ)
{
    for(int i=1;i<=top[typ];++i)
    {
        if(x==s[typ][i]) return 1;
    }
    return 0;
}

inline void dfs1(int x,int fa,int typ)
{
    s[typ][++top[typ]]=x;
    for(int i=head[x];i;i=nex[i])
    {
        int p=to[i];
        if(p!=fa) dfs1(p,x,typ);
    }
}

inline void dfs2(int x,int fa,int typ)
{
    // if(x==endd) return ;
    for(int i=head[x];i;i=nex[i])
    {
        int p=to[i];
        if(p==fa || check(p,typ)==0) continue;
        dfs2(p,x,typ);
        // if(p==endd) continue;
        siz[x] += siz[p];
    }
}

signed main()
{
    freopen("centroid.in","r",stdin);
    freopen("centroid.out","w",stdout);
    read(t);
    while(t--)
    {
        read(n);
        for(int i=1;i<n;++i)
        {
            read(a[i].from), read(a[i].to);
            add_edge(a[i].from, a[i].to);
            add_edge(a[i].to, a[i].from);
        }
        ans=0;
        for(int i=1;i<n;++i)
        {
            // memset(s,0,sizeof(s));
            top[1] = top[2] = 0;
            dfs1(a[i].from, a[i].to, 1);
            dfs1(a[i].to, a[i].from, 2);
            // for(int j=1;j<=top[1];++j) printf("%lld ",s[1][j]); printf(" xxxxxxx  ");
            // for(int j=1;j<=top[2];++j) printf("%lld ",s[2][j]);
            // printf("%lld %lld\n",top[1],top[2]);
            // printf("When we delete the edge (%lld,%lld), The centroid will be: ",a[i].from,a[i].to);
            for(int j=1;j<=top[1];++j) 
            {
                for(int k=1;k<=n;++k) siz[k]=1;
                dfs2(s[1][j],0,1);
                bool flag=1;
                for(int k=head[s[1][j]];k;k=nex[k])
                {
                    int p=to[k]; //printf("size[%d] == %d, ",p,siz[p]);
                    if(siz[p] > n/2) flag=0;
                }
                if(flag==1) {ans+=s[1][j]; /*printf("%lld ",s[1][j]);*/}
            }
            for(int j=1;j<=top[2];++j) 
            {
                for(int k=1;k<=n;++k) siz[k]=1;
                dfs2(s[2][j],0,2);
                bool flag=1;
                for(int k=head[s[2][j]];k;k=nex[k])
                {
                    int p=to[k]; //printf("size[%d] == %d, ",p,siz[p]);
                    if(siz[p] > n/2) flag=0;
                }
                if(flag==1) {ans+=s[2][j]; /*printf("%lld ",s[2][j]);*/}
            }
            // printf("\n");
        }
        printf("%lld\n",ans);
    }
    return 0;
}