#include <bits/stdc++.h>
using namespace std;

typedef int INT;
#define int long long

const int N = 300000 + 10;
const int M = 2000 + 10;
#define Mx(x, y) ((x) > (y) ? (x) : (y))

int T, n;
int X, Y;
int a[N], b[N], s[M];
int head[N], len[N], cnt;
struct edge { int x, y; } L[N];
struct node { int nxt, to; } e[N << 1];
long long ans;

int read()
{
	int sum = 0;
	char c = getchar(), f;
	while(c < '0' || c > '9') f = c, c = getchar();
	while(c >= '0' && c <= '9') sum = sum * 10 + c - '0', c = getchar();
	if(f == '-') sum *= -1;
	return sum;
}

bool Pd1()
{
	for(int i = 1; i <= n; i++)
		if(len[i] > 2) return 0;
	return 1;
}

bool Pd2()
{
	int cxk = n + 1;
	while(cxk > 1)
	{
		if(cxk % 2 == 1) return 0;
		cxk /= 2;
	}
	return 1;
}

void Add()
{
	int x = read();
	int y = read();
	len[x]++; e[++cnt] = (node) { head[x], y }; head[x] = cnt;
	len[y]++; e[++cnt] = (node) { head[y], x }; head[y] = cnt;
	L[cnt / 2].x = x;
	L[cnt / 2].y = y;
}

void DFS(int u)
{
	b[u] = s[u] = 1;
	for(int i = head[u]; i; i = e[i].nxt)
	{
		int v = e[i].to;
		if(b[v]) continue;
		DFS(v);
		s[u] += s[v];
	}
	b[u] = 0;
}

void Fnd(int u)
{
	int mx = s[0] - s[u];
	b[u] = 1;
	for(int i = head[u]; i; i = e[i].nxt)
	{
		int v = e[i].to;
		if(b[v]) continue;
		Fnd(v);
		mx = Mx(mx, s[v]);
	}
	if(mx * 2 <= s[0]) ans += u;
	b[u] = 0;
}

void Solve1()
{
	for(int i = 1; i < n; i++)
	{
		memset(s, 0, sizeof(s));
		X = L[i].x;
		Y = L[i].y;
		b[Y] = 1; DFS(X); b[Y] = 0;
		b[X] = 1; DFS(Y); b[X] = 0;
		b[Y] = 1; s[0] = s[X]; Fnd(X); b[Y] = 0;
		b[X] = 1; s[0] = s[Y]; Fnd(Y); b[X] = 0;
	}
	printf("%lld\n", ans);
}

void Solve2()
{
	for(int i = 1; i <= n; i++)
		if(len[i] == 1) a[1] = i;
	a[2] = e[head[a[1]]].to;
	for(int i = 2; i < n; i++)
	{
		int x = e[head[a[i]]].to;
		int y = e[e[head[a[i]]].nxt].to;
		if(x == a[i - 1]) a[i + 1] = y;
		if(y == a[i - 1]) a[i + 1] = x;
	}
	for(int i = 1; i <= n; i++) ans += a[i];
	if(n <= 4) ans *= 2; else
	if(n % 2 == 1) ans = ans * 3 - a[1] - a[n] - a[(n + 1) / 2];
	if(n % 2 == 0) ans = ans * 3 - a[1] - a[n] - a[n / 2] - a[n / 2 + 1];
	printf("%lld\n", ans);
}

void Solve3()
{
	int rt = 0, rl, rr;
	for(int i = 1; i <= n; i++) if(len[i] == 2) rt = i;
	rl = e[head[rt]].to;
	rr = e[e[head[rt]].nxt].to;
	ans = n * (n + 1) / 2;
	ans += (rt + rl + rr) * (n - 1) / 2;
	printf("%lld\n", ans);
}

void Solve()
{
	memset(len, 0, sizeof(len)); ans = 0;
	memset(head, 0, sizeof(head)); cnt = 0;
	n = read();
	for(int i = 2; i <= n; i++) Add();
	if(n <= 2000) Solve1(); else
	if(Pd1()) Solve2(); else
	if(Pd2()) Solve3();
}

INT main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = read();
	while(T--) Solve();
	return 0;
}
