#include <cstdio>
#include <cstring>
typedef long long LL;
const int N = 3e5 + 10, E = 6e5 + 10;
inline void maxup(int& h, int g) {
  if (h < g) h = g;
}
LL ans = 0;
int n, first[N];
int to[E], nxt[E], id[E], cnt = 0;
int s[N], top = 0;
int idcnt = 0, ill[E];

int in[N], maxin, vis[N];

struct Edge {
  int u, v;
} e[E];
int siz[N], maxson[N];
void adde(int u, int v) {
  to[++cnt] = v;
  id[cnt] = idcnt;
  nxt[cnt] = first[u];
  first[u] = cnt;
}
void dfs(int u, int f) {
  siz[u] = 1; maxson[u] = 0; // clean is not needed
  s[++top] = u;
  for (int p = first[u]; p; p = nxt[p]) {
    if (ill[id[p]]) continue;
    int v = to[p]; if (v == f) continue;
    dfs(v, u);
    maxup(maxson[u], siz[v]);
    siz[u] += siz[v];
  }
}
void solve(int rt) {
  dfs(rt, 0);
  for (int i = 1; i <= top; ++i) {
    int u = s[i];
    maxup(maxson[u], siz[rt] - siz[u]);
    if (maxson[u] <= siz[rt] / 2)
      ans += u;
  }
  top = 0;
}
int gate() {
  ans = 0;
  for (int i = 1; i <= idcnt; ++i) {
    ill[i] = 1;
    solve(e[i].u);
    solve(e[i].v);
    ill[i] = 0;
  }
  printf("%lld\n", ans);
  return 0;
}
void solve1(int l, int r) {
  int d = (r - l) + 1, mid = (l + r) / 2;
  if (d & 1) {
    ans += s[mid];
  }
  else {
    ans += s[mid];
    ans += s[mid + 1];
  }
}
int gate1() {
  int st = 0;
  for (int i = 1; i <= n; ++i) {
    vis[i] = 0;
    if (in[i] == 1)
      st = i;
  }
  top = 0;
  s[++top] = st;
  vis[st] = 1;
  while (true) {
    int tmp = 0;
    for (int p = first[st]; p; p = nxt[p]) {
      int v = to[p];
      if (not vis[v]) {
        tmp = 1;
        st = v;
        s[++top] = st;
        vis[st] = 1;
        break;
      }
    }
    if (tmp == 0)
      break;
  }
  ans = 0;
  for (int i = 1; i <= top - 1; ++i) {
    solve1(1, i);
    solve1(i + 1, top);
  }
  printf("%lld\n", ans);
  return 0;
}
int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  int t; scanf("%d", &t);
  while (t--) {
    cnt = 0; idcnt = 0;
    
    maxin = 0;
    
    scanf("%d", &n);
    for (int i = 1; i <= n - 1; ++i) {
      int u, v; scanf("%d %d", &u, &v);
      e[i].u = u, e[i].v = v;
      ++idcnt;
      maxup(maxin, ++in[u]);
      maxup(maxin, ++in[v]);
      adde(u, v); adde(v, u);
    }
    if (maxin == 2)
      gate1();
    else
      gate();
    memset(first, 0, (n + 1) * sizeof(int));
    memset(nxt, 0, (cnt + 1) * sizeof(int));
    memset(in, 0, (n + 1) * sizeof(int));
  }
  return 0;
}
