#include <cstdio>
#include <algorithm>

long long read()
{
	char last = '+', ch = getchar();
	while (ch < '0' || ch > '9') last = ch, ch = getchar();
	long long tmp = 0;
	while (ch >= '0' && ch <= '9') tmp = tmp * 10 + ch - 48, ch = getchar();
	if (last == '-') tmp = -tmp;
	return tmp;
}

const long long INF = (long long)4 * 1000000000 * 1000000000;
const int _n = 5000000 + 10;
int n, type;
long long x[_n], s[_n];
long long f[5000 + 10][5000 + 10];
long long ans;

int main()
{
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	n = read();
	type = read();
	for (int i = 1; i <= n; i++)
	{
		x[i] = read();
		s[i] = s[i - 1] + x[i];
	}
	f[0][0] = 0;
	for (int j = 1; j <= n; j++)
	{
		int k = j;
		long long minf = INF;
		f[j][0] = ((double)s[j] * s[j] > INF) ? INF : s[j] * s[j];
		for (int i = j + 1; i <= n; i++)
		{
			while (k > 0 && s[j] - s[k - 1] <= s[i] - s[j])
			{
				k--;
				minf = std::min(minf, f[j][k]);
			}
			f[i][j] = ((double)minf + (double)(s[i] - s[j]) * (s[i] - s[j]) > INF) ? INF : minf + (s[i] - s[j]) * (s[i] - s[j]);
		}
	}
	ans = INF;
	for (int i = 0; i < n; i++)
	{
		ans = std::min(ans, f[n][i]);
	}
	printf("%lld\n", ans);
	return 0;
}



