#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
#include<set>
#include<iostream>
using namespace std;
inline void judge(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
}
int n;
struct node{
	int ch[2],v;
}T[10000005];
int num;
void newnode(int *x){
	T[++num]=T[*x];
	*x=num;
}
void add(int *u,int x,int y){
	int l=1,r=n;
	newnode(u);
	T[*u].v+=y;
	while(l<r){
		int mid=l+((r-l)>>1);
		if(x<=mid)r=mid,u=&T[*u].ch[0];
		else l=mid+1,u=&T[*u].ch[1];
		newnode(u);
		T[*u].v+=y;	
	}
}
void add1(int *u,int x,int y){
	int l=1,r=n;
	if(!*u)newnode(u);
	T[*u].v+=y;
	while(l<r){
		int mid=l+((r-l)>>1);
		if(x<=mid)r=mid,u=&T[*u].ch[0];
		else l=mid+1,u=&T[*u].ch[1];
		if(!*u)newnode(u);
		T[*u].v+=y;	
	}
}
struct edge{
	int s,t,nxt;
}e[600005];
int e_cnt,last[300005];
void ins(int a,int b){
	e[e_cnt]=(edge){a,b,last[a]};
	last[a]=e_cnt++;
}
long long ans;
int fa[300005],size[300005],mx[300005],c[300005],L[300005],R[300005],p[300005],tot,f[300005][20];
void dfs0(int x){
	L[x]=R[x]=++tot;
	p[tot]=x;
	size[x]=1;
	f[x][0]=fa[x];
	mx[x]=0;
	for(int i=1;i<=19;i++)f[x][i]=f[f[x][i-1]][i-1];
	for(int i=last[x];i!=-1;i=e[i].nxt)if(e[i].t!=fa[x]){
		fa[e[i].t]=x;
		dfs0(e[i].t);
		mx[x]=(size[e[i].t]>size[mx[x]]?e[i].t:mx[x]);
		size[x]+=size[e[i].t];
		R[x]=R[e[i].t];
	}
	if(x!=1){
		if(size[x]==1)c[x]=x,ans+=x;
		else{
			c[x]=c[mx[x]];
			while(size[fa[c[x]]]<=size[x]/2)c[x]=fa[c[x]];
			if(size[c[x]]*2==size[x])ans+=c[x]+fa[c[x]];
			else ans+=fa[c[x]];
		}
	//	printf("%d %d %lld\n",x,c[x],ans);
	}
}
vector<int> q0,q1,tq0,tq1;
bool check(int res){
	int tem=0;
	for(int i=0;i<q0.size();i++)tem+=T[T[q0[i]].ch[0]].v;
	for(int i=0;i<q1.size();i++)tem-=T[T[q1[i]].ch[0]].v;
	return tem>=res;
}
int query(int k){
	int l=1,r=n,res=0;
	tq0=q0; tq1=q1;
	while(l<r){
		int mid=l+((r-l)>>1);
		//cout<<res<<' '<<l<<' '<<r<<' '<<mid<<' '<<k<<endl;
		if(k<=mid){
			r=mid;
			for(int i=0;i<q0.size();i++)q0[i]=T[q0[i]].ch[0];
			for(int i=0;i<q1.size();i++)q1[i]=T[q1[i]].ch[0];
		}else{
			l=mid+1;
			for(int i=0;i<q0.size();i++)res+=T[T[q0[i]].ch[0]].v;
			for(int i=0;i<q1.size();i++)res-=T[T[q1[i]].ch[0]].v;
			for(int i=0;i<q0.size();i++)q0[i]=T[q0[i]].ch[1];
			for(int i=0;i<q1.size();i++)q1[i]=T[q1[i]].ch[1];
		}
	}
	for(int i=0;i<q0.size();i++)res+=T[q0[i]].v;
	for(int i=0;i<q1.size();i++)res-=T[q1[i]].v;
	//printf("%d\n",res);
	q0=tq0; q1=tq1;
	l=1; r=n;
	while(l<r){
		int mid=l+((r-l)>>1);
		if(k<=mid||check(res)){
			r=mid;
			for(int i=0;i<q0.size();i++)q0[i]=T[q0[i]].ch[0];
			for(int i=0;i<q1.size();i++)q1[i]=T[q1[i]].ch[0];
		}else{
			l=mid+1;
			for(int i=0;i<q0.size();i++)res-=T[T[q0[i]].ch[0]].v;
			for(int i=0;i<q1.size();i++)res+=T[T[q1[i]].ch[0]].v;
			for(int i=0;i<q0.size();i++)q0[i]=T[q0[i]].ch[1];
			for(int i=0;i<q1.size();i++)q1[i]=T[q1[i]].ch[1];
		}
	}
	return l;
}
int ro[300005],root;
set<int> w[300005];
int q(int x,int l,int r){
	int a=*w[x].begin(),b=*w[x].rbegin();
	if(a<l)return a;
	if(b>r)return b;
	return -1;
}
void dfs1(int x){
	//cerr<<x<<endl;
	if(x!=1){
		if(n-size[x]>1){
			int tem=(n-size[x])/2;
			int a,u=x;
			if(size[fa[x]]-size[x]>tem)a=-1;
			else{
				for(int k=19;k>=0;k--)if(size[f[u][k]]-size[x]<=tem)u=f[u][k];
				a=size[u]-size[x];
			}
			q0.clear();
			q1.clear();
			q0.push_back(ro[n]);
			q0.push_back(ro[L[x]-1]);	
			q1.push_back(ro[R[x]]);
			q1.push_back(root);
			int b=query(tem);
			//cerr<<"ok"<<endl;
			//cerr<<a<<' '<<b<<endl;
			//printf("%d %d %d %d\n",x,tem,a,b);
			if(a==-1||tem-b<tem-a){
				int XX=p[q(b,L[x],R[x])];
				if(b*2==n-size[x])ans+=XX,ans+=fa[XX];
				else ans+=fa[XX];
			}else{
				if(a*2==n-size[x])ans+=u,ans+=fa[u];
				else ans+=fa[u];
			}
		}else{
			ans+=fa[x];
		}
		//printf("%lld\n",ans);
	}
	add1(&root,size[x],1);
	w[size[x]].erase(L[x]);
	for(int i=last[x];i!=-1;i=e[i].nxt)if(e[i].t!=fa[x])dfs1(e[i].t);
	add1(&root,size[x],-1);
	w[size[x]].insert(L[x]);
}
int main(){
	judge();
	int T;
	scanf("%d",&T);
	while(T--){
		scanf("%d",&n);
		e_cnt=0;
		num=0;
		tot=0;
		ans=0;
		memset(last,-1,sizeof(last));
		for(int i=1;i<=n;i++)w[i].clear();
		for(int i=1;i<n;i++){
			int u,v;
			scanf("%d%d",&u,&v);
			ins(u,v);
			ins(v,u);
		}
		fa[1]=1;
		dfs0(1);
		//printf("%lld\n",ans);
		for(int i=1;i<=n;i++)ro[i]=ro[i-1],add(&ro[i],size[p[i]],1);
		for(int i=1;i<=n;i++)w[size[i]].insert(L[i]);
		dfs1(1);
		printf("%lld\n",ans);
	}
	return 0;
}
