#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#define For(i, l, r) for(int i = (int)(l); i <= (int)(r); ++i)
#define Rep(i, r, l) for(int i = (int)(r); i >= (int)(l); --i)

using namespace std;
typedef long long LL;
const LL INF = 0x3f3f3f3f3f3f3f3f;
const int N = 5010;

LL dp[N][N], a[N], pre[N];

inline LL read() {
	LL x = 0, f = 1;
	char ch = getchar();
	while(!isdigit(ch) && ch != '-') ch = getchar();
	if (ch == '-') {f = -1; ch = getchar();}
	while(isdigit(ch)) {
		x = (x << 1) + (x << 3) + (ch ^ 48);
		ch = getchar();
	}
	return x * f;
}

inline LL sqrr(LL x) {
	return x * x;
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	int n = read(), tp = read();
	if (tp == 0) {
		For(i, 1, n) {
			a[i] = read();
			pre[i] = pre[i - 1] + a[i];
		}
		memset(dp, 0x3f, sizeof dp);
		dp[0][0] = 0;
		For(i, 1, n) dp[i][i] = sqrr(pre[i]);
		For(i, 1, n) {
			int now = 1;
			while (dp[i][now] == INF) ++now;
			For(j, i + 1, n) {
				if (pre[j] - pre[i] >= pre[i] - pre[i - now]) dp[j][j - i] = min(dp[j][j - i], dp[i][now] + sqrr(pre[j] - pre[i]));
			}
		}
		LL ans = INF;
		For(i, 1, n) ans = min(ans, dp[n][i]);
		printf("%lld\n", ans);
	}
	fclose(stdin); fclose(stdout);
	return 0;
}
