#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
typedef long long ll;
inline int read(){
	int x=0,f=1; char c=getchar();
	while (c<'0'||c>'9') {
		if (c=='-') f=-1;
		c=getchar();
	}
	while (c>='0'&&c<='9'){
		x=x*10+c-'0';
		c=getchar();
	}
	return x*f;
}
void write(ll x){
	if (x<0) putchar('-'),x=-x;
	if (x>9) write(x/10);
	putchar(x%10+'0');
}
inline void writeln(ll x){
	write(x); puts("");
}
const int N=2005,NA=50005;
struct edge{
	int link,next;
}e[NA<<1];
struct ed{
	int u,v;
}ee[NA<<1];
ll ans;
int tot,n,head[NA<<1];
bool can[N<<1];
inline void add_edge(int u,int v){
	e[++tot]=(edge){v,head[u]}; head[u]=tot;
}
inline void insert(int u,int v){
	add_edge(u,v); add_edge(v,u);
}
inline void init(){
	n=read(); tot=0;
	for (int i=1;i<=2*n;i++) can[i]=1;
	memset(head,0,sizeof head);
	for (int i=1;i<n;i++){
		int u=read(),v=read();
		insert(u,v);
		ee[i].u=u; ee[i].v=v;
	}
}
int sz,dp[N];
inline void dfs(int u,int fa){
	dp[u]=1; int mx=0;
	for (int i=head[u];i;i=e[i].next){
		int v=e[i].link;
		if (v!=fa&&can[i]){
			dfs(v,u);
			dp[u]+=dp[v];
		}
	}
}
inline void dfs2(int u,int fa){
	int mx=0;
	for (int i=head[u];i;i=e[i].next){
		int v=e[i].link;
		if (v!=fa&&can[i]){
			mx=max(dp[v],mx);
			dfs2(v,u);
		}
	}
	mx=max(mx,sz-dp[u]);
	if (mx<=sz/2) ans+=u;
}
inline void sol(int rt){
	dfs(rt,0); sz=dp[rt];
	dfs2(rt,0);
}
inline void solve(){
	ans=0;
	for (int i=1;i<n;i++){
		can[2*i-1]=0; can[2*i]=0;
		sol(ee[i].u); sol(ee[i].v);
		memset(dp,0,sizeof dp);
		can[2*i-1]=1; can[2*i]=1;
	}
	writeln(ans);
}
int b[NA],du[NA],rt;
void dfs3(int u,int fa){
	b[++tot]=u;
	for (int i=head[u];i;i=e[i].next){
		int v=e[i].link;
		if (v!=fa){
			dfs3(v,u);
		}
	}
}
inline void A(){
	tot=0; ans=0;
	for (int i=1;i<n;i++){
		du[ee[i].u]++; du[ee[i].v]++;
	}
	for (int i=1;i<=n;i++){
		if (du[i]==1) {
			rt=i; break;
		} 
	}
	dfs3(rt,0);
	for (int i=1;i<n;i++){
		if (i%2==1) ans+=b[i/2+1]; 
			else ans+=b[i/2]+b[i/2+1]; 
		int len=n-i;
		if (len%2==1) ans+=b[n-len/2];
			else ans+=b[n-len/2]+b[n-len/2+1];
	}
	writeln(ans);
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=read();
	while (T--){
		init(); 
		if (2000<=n&&n<=49991){
			A();
			continue;
		} 
		if (n>49991) {
			ans=(n+1)*n*2;
			writeln(ans);
			continue;
		}
		solve();
	}
	return 0;
}
