#include<cstdio>
#define int long long
using namespace std;
inline int read(){
	int x=0,f=1; char c=getchar();
	while (c<'0'||c>'9') {
		if (c=='-') f=-1;
		c=getchar();
	}
	while (c>='0'&&c<='9'){
		x=x*10+c-'0';
		c=getchar();
	}
	return x*f;
}
void write(int x){
	if (x<0) putchar('-'),x=-x;
	if (x>9) write(x/10);
	putchar(x%10+'0');
}
inline void writeln(int x){
	write(x); puts("");
}
const int N=45;
const int M=4;
const int mod=998244353;
int ans,n,m,a[N][M];
inline void init(){
	n=read(); m=read();	
	for (int i=1;i<=n;i++){
		for (int j=1;j<=m;j++){
			a[i][j]=read();
		}
	}
}
int dp[N][N][N][N];
inline void update(int &x,int y){
	x=(x+y+mod)%mod;
}
inline void solve(){
	dp[0][0][0][0]=1;
	for (int i=1;i<=n;i++){
		for (int A=0;A<=n;A++){
			for (int B=0;B<=i-A;B++){
				for (int C=0;C<=i-A-B;C++){
					if (!dp[i-1][A][B][C]) continue;
					if (a[i][1]) update(dp[i][A+1][B][C],dp[i-1][A][B][C]*a[i][1]);
					if (a[i][2]) update(dp[i][A][B+1][C],dp[i-1][A][B][C]*a[i][2]);
					if (a[i][3]) update(dp[i][A][B][C+1],dp[i-1][A][B][C]*a[i][3]);
					update(dp[i][A][B][C],dp[i-1][A][B][C]);		
				}
			}
		}
	}
	for (int A=0;A<=n;A++){
		for (int B=0;B<=n-A;B++){
			for (int C=0;C<=n-A-B;C++){
				if (!dp[n][A][B][C]) continue;
				int sum=A+B+C;
				if (A<=sum/2&&B<=sum/2&&C<=sum/2) update(ans,dp[n][A][B][C]);
			}
		}
	}
	update(ans,-1);
	writeln(ans);
}
signed main(){
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	init(); solve();
	return 0;
}
