/*/Saya-Javelin/*/
#include <cstdio>
#define Fo freopen ("centroid.in", "r", stdin), freopen ("centroid.out", "w", stdout)
#define Fc fclose (stdin), fclose (stdout)
#define rgt register
#define iln inline
#define int long long

const int S=1000000;
char RRR[S];
char *SSR, *UR;

iln char fgc () {
	if (UR==SSR) UR= (SSR=RRR) + fread (RRR, 1, S, stdin);
	return UR==SSR ? EOF : *SSR++;
}

#define getchar fgc

iln int read (int &ur) {
	rgt int ssr=1; rgt char rrr; ur=0;
	while (rrr=getchar(), rrr>'9' || rrr<'0')
	if (rrr=='-') ssr=-ssr;
	while (rrr>='0' && rrr<='9')
	ur=ur*10+(rrr-'0'), rrr=getchar();
	return ur=ur*ssr;
}

iln void write (int ur) {
	if (ur<0) putchar ('-'), ur=-ur;
	if (ur>9) write (ur/10);
	putchar (ur%10+'0');
}

iln void wts (int ur) {
	write (ur), putchar (' ');
}

iln void wtn (int ur) {
	write (ur), putchar ('\n');
}

const int MAX=300005;
int T;
int n;
int u, v;
int head[MAX], k=1, root;
int size[MAX], num[3], num_cnt, dig[MAX];
bool del[MAX<<1];
int ans;

struct edge {
	int f, t, ne;
} e[MAX<<1];

iln void add (int i, int j) {
	e[++k]= (edge) {i, j, head[i]};
	head[i]=k;
}

iln void get_size (int now, int fa) {
	size[now]=1;
	for (rgt int i=head[now]; i; i=e[i].ne){
		int to=e[i].t;
		if (to==fa || del[i]) continue;
		get_size (to, now), size[now]+=size[to];
	}
}

iln void dfs (int now, int fa) {
	rgt int cnt=0, tot=0;
	for (rgt int i=head[now]; i; i=e[i].ne){
		int to=e[i].t;
		if (to==fa || del[i]) continue;
		dfs (to, now), tot++;
		if (size[to]<=(size[root]>>1)) cnt++;
	}
	tot++, cnt+=(size[root]-size[now]<=(size[root]>>1));
	if (cnt==tot) num[++num_cnt]=now;
}

int max_deep, max_pos, val[MAX], cur[MAX], list_cnt;

iln void get_deepest (int now, int fa, int deep) {
	if (deep>max_deep) max_pos=now, max_deep=deep;
	for (rgt int i=head[now]; i; i=e[i].ne) {
		int to=e[i].t;
		if (to==fa) continue;
		get_deepest (to, now, deep+1);
	}
}

iln void get_list (int now, int fa) {
	val[now]=++list_cnt, cur[list_cnt]=now;
	for (rgt int i=head[now]; i; i=e[i].ne) {
		int to=e[i].t;
		if (to==fa) continue;
		get_list (to, now);
	}
}

signed main (void) {
	Fo;
	read (T);
	while (T--) {
		read (n), k=1, ans=0;
		for (rgt int i=1; i<=n; ++i) head[i]=dig[i]=0;
		for (rgt int i=1; i<n; ++i)
			read (u), read (v), add (u, v), add (v, u), dig[u]++, dig[v]++;
		rgt int sum1=0, sum2=0, sum3=0;
		for (rgt int i=1; i<=n; ++i) {
			if (dig[i]==1) sum1++;
			else if (dig[i]==2) sum2++;
			else sum3++;
		}
		if (sum2==n-2 && sum1==2) {
			max_deep=0;
			get_deepest (1, 0, 0);
			list_cnt=0;
			get_list (max_pos, 0);
			for (rgt int i=1; i<n; ++i) {
				if (i&1) ans+=cur[(i+1)>>1];
				else ans+=cur[i>>1]+cur[(i>>1)+1];
				if ((n-i)&1) ans+=cur[(i+1+n)>>1];
				else ans+=cur[(i+n)>>1]+cur[((i+n)>>1)+1];
			}
			//1~i, i+1~n
			wtn (ans);
			continue;
		} 
//		if (n&1 && sum3==1 && sum2==n/2-1 && sum3==n/2) {
//			
//			continue;
//		}
		for (rgt int i=1; i<n; ++i) {
			del[i<<1]=del[i<<1|1]=1;
			num[1]=num[2]=0, root=e[i<<1].f;
//			puts ("-----------------");
			get_size (e[i<<1].f, 0), num_cnt=0, dfs (e[i<<1].f, 0);
			ans+=num[1]+num[2];
//			wts (e[i<<1].f), wts (num[1]), wtn (num[2]);//
//			for (rgt int j=1; j<=n; ++j) wts (size[j]); puts ("");//
			num[1]=num[2]=0, root=e[i<<1].t;
//			puts ("-----------------");
			get_size (e[i<<1].t, 0), num_cnt=0, dfs (e[i<<1].t, 0);
			ans+=num[1]+num[2];
//			wts (e[i<<1].t), wts (num[1]), wtn (num[2]);//
//			for (rgt int j=1; j<=n; ++j) wts (size[j]); puts ("");//
			del[i<<1]=del[i<<1|1]=0;
		}
		wtn (ans);
	}
	Fc;
	return 0;
}
