#include <cstdio>
using namespace std;

typedef long long LL;
const LL mod = 998244353LL;
const int maxn = 105;
const int maxm = 2005;
int a[maxn][maxm];
int k, n, m;
LL ans;
int used[maxm];
int methods_used;

void dfs(int curr, LL ans_cnt)
{
    if (curr > n)
    {
        if (methods_used == k)
        {
            ans += ans_cnt;
            ans %= mod;
        }
        return;
    }
    dfs(curr + 1, ans_cnt);
    methods_used++;
    for (int i = 1; i <= m; i++)
    {
        if (a[curr][i] == 0)
            continue;
        if (used[i] + 1 > (k >> 1))
            continue;
        used[i]++;
        dfs(curr + 1, ans_cnt * a[curr][i] % mod);
        used[i]--;
    }
    methods_used--;
}

void read()
{
    scanf("%d %d", &n, &m);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            scanf("%d", &a[i][j]);
}

void solve()
{
    read();
    for (k = 2; k <= n; k++)
    {
        dfs(1, 1LL);
    }
    printf("%lld\n", ans);
}

int main()
{
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    solve();
    fclose(stdin);
    fclose(stdout);
    return 0;
}
