#include <bits/stdc++.h>
using namespace std;

#define ll long long 
const ll N = 5e3 + 9;
const ll INF = 4e18;

inline ll read() {
	ll x = 0, F = 1;
	char op = getchar();
	while (op < '0' || op > '9') {
		if (op == '-') F = -1;
		op = getchar();
	}
	while (op >= '0' && op <= '9') {
		x = (x << 1) + (x << 3) + (op & 15);
		op = getchar(); 
	}
	return x * F;
}

ll n, type, a[N], sum[N], f[N][N];

namespace Subtask1 {
	
ll ans = INF;

void work() {
	register ll i, j, k;
	for (i = 0; i <= n; i ++) {
		for (j = 0; j <= n; j ++) {
			f[i][j] = INF;
		}
	}
	for (i = 1; i <= n; i ++) f[i][1] = sum[i] * sum[i];
	for (i = 2; i <= n; i ++) {
		for (j = 2; j <= i; j ++) {
			for (k = 1; k < j; k ++) {
				if (f[j - 1][k] == INF) continue ; 
				if (sum[i] - sum[j - 1] < sum[j - 1] - sum[k - 1]) continue ;
				f[i][j] = min(f[i][j], (sum[i] - sum[j - 1]) * (sum[i] - sum[j - 1]) + f[j - 1][k]);
			}
		}
	}
		
	for (i = 1; i <= n; i ++) {
		ans = min(ans, f[n][i]);
	}
	printf("%lld\n", ans);
}
	
}

namespace Subtask2 {
	
ll ans = INF, mn[N][N];

ll Find(ll pos, ll x) {
	ll l = 0, r = pos - 1, res = INF - 1;
	while (l <= r) {
		ll mid = (l + r) >> 1;
		if (sum[pos] - sum[mid] <= x) {
			r = mid - 1;
			res = mid;
		} else l = mid + 1;
	}
	return res + 1;
}
	
void work() {
	register ll i, j;
	for (i = 0; i <= n; i ++) {
		for (j = 0; j <= n; j ++) {
			f[i][j] = mn[i][j] = INF;
		}
	}
	for (i = 1; i <= n; i ++) f[i][1] = sum[i] * sum[i];
	
	mn[1][1] = f[1][1];
	for (i = 2; i <= n; i ++) {
		for (j = 2; j <= i; j ++) {
			ll tmp = Find(j - 1, sum[i] - sum[j - 1]);
			if (tmp != INF) {
				f[i][j] = (sum[i] - sum[j - 1]) * (sum[i] - sum[j - 1]) + mn[j - 1][tmp];
 			}
		}
		for (j = i; j >= 1; j --) {
			if (j == i) mn[i][j] = f[i][j];
			else mn[i][j] = min(mn[i][j + 1], f[i][j]);
		}
	}
	
	for (i = 1; i <= n; i ++) {
		ans = min(ans, f[n][i]);
	}
	printf("%lld\n", ans);
	
	return ; 
}	

}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	
	register ll i, j;
	
	n = read(), type = read();
	
	for (i = 1; i <= n; i ++) {
		a[i] = read();	
		sum[i] = sum[i - 1] + a[i];
	}
	
	if (n <= 400) Subtask1 :: work();
	else Subtask2 :: work();
	return 0;
}

