#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<vector>
using namespace std;
const int MAXN=3e5+10;

struct edge
{
	int u,v,nex;
};

edge e[MAXN<<1];
int head[MAXN],cnt=0;
int sz[MAXN],ccsz[MAXN],sz1,sz2;
int ccrt,dep[MAXN],ans1sz,ans2sz;
bool used[MAXN<<1],flag=true;
vector<int> ans1,ans2;
long long ans=0;
int n;

int pos[MAXN],which[MAXN],dfscnt=0;

void ddfs(int u,int fa)
{
	pos[++dfscnt]=u;
	which[u]=dfscnt;
	for(int i=head[u];i;i=e[i].nex)
	{
		int v=e[i].v;
		if(v==fa) continue;
		ddfs(v,u);
	}
}

inline void solve1()
{
	ddfs(ccrt,0);
//	for(int i=1;i<=n;i++)
//		cout<<pos[i]<<" ";
//	cout<<endl;
	for(int i=2;i<=cnt;i+=2)
	{
		int u=e[i].u,v=e[i].v;
		int pos1=which[e[i].u],pos2=which[e[i].v];
		if(pos1>pos2) swap(pos1,pos2);
//		cout<<pos1<<" "<<pos2<<endl;
		if(pos1%2==0)
		{
//			cout<<"case1.1 "<<pos1/2<<" "<<pos1/2+1<<endl;
			ans+=pos[pos1/2];
			ans+=pos[pos1/2+1];
		}
		else ans+=pos[pos1/2+1];
		if((n-pos2+1)%2==0)
		{
//			cout<<"case2.1 "<<pos1+(n-pos2+1)/2+1<<" "<<pos1+(n-pos2+1)/2<<endl;
			ans+=pos[pos1+(n-pos2+1)/2+1];
			ans+=pos[pos1+(n-pos2+1)/2];
		}
		else ans+=pos[pos1+(n-pos2+1)/2+1];
	}
	printf("%lld\n",ans);
}

inline void init()
{
	flag=true;
	cnt=1,sz1=sz2=ccrt=0;
	dfscnt=0;
	memset(pos,0,sizeof(pos));
	memset(which,0,sizeof(which));
	memset(head,0,sizeof(head));
	memset(sz,0,sizeof(sz));
	memset(ccsz,0,sizeof(ccsz));
	memset(dep,0,sizeof(dep));
	memset(used,false,sizeof(used));
	ans1.clear(),ans2.clear();
	ans=0;
}

inline void add(int u,int v)
{
	e[++cnt].u=u;
	e[cnt].v=v;
	e[cnt].nex=head[u];
	head[u]=cnt;
}

void dfs(int u,int fa)
{
	bool flag=true;
	for(int i=head[u];i;i=e[i].nex)
	{
		int v=e[i].v;
		if(v==fa) continue;
		dfs(v,u);
		flag=false;
	}
	if(flag)
		ccrt=u;
}

void check(int u,int fa)
{
	sz[u]=1;
	int cctot=0;
	for(int i=head[u];i;i=e[i].nex)
	{
		int v=e[i].v;
		if(v==fa) continue;
		dep[v]=dep[u]+1;
		check(v,u);
		sz[u]+=sz[v];
		cctot++;
	}
	if(cctot>=2)
		flag=false;
}

void dfs1(int u,int fa)
{
	int mx=0;
	ccsz[u]=1;
	for(int i=head[u];i;i=e[i].nex)
	{
		int v=e[i].v;
		if(used[i]||v==fa) continue;
		dfs1(v,u);
		ccsz[u]+=ccsz[v];
		mx=max(mx,ccsz[v]);
	}
	mx=max(mx,sz1-ccsz[u]);
	if(mx<ans1sz)
	{
		ans1sz=mx;
		ans1.clear();
		ans1.push_back(u);
	}
	else if(mx==ans1sz)
	{
		ans1.push_back(u);
	}
}

void dfs2(int u,int fa)
{
	int mx=0;
	ccsz[u]=1;
	for(int i=head[u];i;i=e[i].nex)
	{
		int v=e[i].v;
		if(used[i]||v==fa) continue;
		dfs2(v,u);
		ccsz[u]+=ccsz[v];
		mx=max(mx,ccsz[v]);
	}
	mx=max(mx,sz2-ccsz[u]);
	if(mx<ans2sz)
	{
		ans2sz=mx;
		ans2.clear();
		ans2.push_back(u);
	}
	else if(mx==ans2sz)
	{
		ans2.push_back(u);
	}
}

int T;

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--)
	{
		init();
		scanf("%d",&n);
	 	for(int i=1;i<n;i++)
		{
			int x,y;
			scanf("%d %d",&x,&y);
			add(x,y);
			add(y,x);
		}
		dfs(1,0);
//		cout<<ccrt<<endl;
		dep[ccrt]=1;
		check(ccrt,0);
//		cout<<flag<<endl;
		if(flag)
		{
			solve1();
			continue;
		}
//		for(int i=1;i<=n;i++)
//		{
//			cout<<sz[i]<<" "<<dep[i]<<endl;
//		}
//		cout<<endl;
		for(int i=2;i<=cnt;i+=2)
		{
			for(int j=1;j<=n;j++)
				ccsz[j]=0;
//			cout<<e[i^1].u<<" "<<e[i^1].v<<endl;
			used[i]=used[i^1]=true;
			ans1.clear(),ans2.clear();
			if(dep[e[i].u]>dep[e[i].v])
			{
				sz1=sz[e[i].u],sz2=n-sz[e[i].u];
			}
			else
			{
				sz1=n-sz[e[i].v],sz2=sz[e[i].v];
			}
//			cout<<sz1<<" "<<sz2<<endl;
			ans1sz=99999999,ans2sz=99999999;
			dfs1(e[i].u,0),dfs2(e[i].v,0);
//			cout<<"emm"<<endl;
//			cout<<ans1sz<<" "<<ans2sz<<endl;
//			cout<<"qaq"<<endl;
			for(int j=0;j<ans1.size();j++)
				ans+=ans1[j];
//			cout<<endl;
			for(int j=0;j<ans2.size();j++)
				ans+=ans2[j];
//			cout<<endl;
//			cout<<"qwq"<<endl;
			used[i]=used[i^1]=false;
		}
		printf("%lld\n",ans);
	}
	return 0;
}
