#include<cstdio>
#include<algorithm>
using namespace std;
int addnum,vel[600010],ne[600010],he[600010],siz[300010];
long long ans;
int tot,d,maxn,a[300010],du[300010];
int n,x[300010],y[300010];
int read()
{
	int ans=0;
	char ch=getchar();
	while (ch<'0'||ch>'9') ch=getchar();
	while (ch>='0'&&ch<='9') ans=(ans<<1)+(ans<<3)+ch-'0',ch=getchar();
	return ans;
}
void add(int u,int v)
{
	addnum++,vel[addnum]=v,ne[addnum]=he[u],he[u]=addnum;
}
void dfs(int u,int fa,int k){
	siz[u]=1;
	for (int e=he[u];e;e=ne[e])
	{
		int v=vel[e];
		if (v==fa) continue;
		if (e/2==k) continue;
		dfs(v,u,k);
		siz[u]+=siz[v];
	}
}
void dfs1(int u,int fa,int k,int s)
{
	int flag=1;
	for (int e=he[u];e;e=ne[e])
	{
		int v=vel[e];
		if (v==fa) continue;
		if (e/2==k) continue;
		dfs1(v,u,k,s);
		if (2*siz[v]>s) flag=0;
	}
	if ((s-siz[u])*2>s) flag=0;
	if (flag) ans+=u;
}
void dfsd(int u,int fa)
{
	a[++tot]=u;
	if (tot>maxn) 
	{
		maxn=tot;
		d=a[maxn/2+1];
	 } 
	for (int e=he[u];e;e=ne[e])
	{
		int v=vel[e];
		if (v==fa) continue;
		dfsd(v,u);
	}
	tot--;
}
void dfd(int u,int fa)
{
	siz[u]=1;
	for (int e=he[u];e;e=ne[e])
	{
		int v=vel[e];
		if (v==fa) continue;
		dfd(v,u);
		siz[u]+=siz[v];
	}
	int td=1;
	while (td<=n)
	{
		if (siz[u]>=n-siz[u]-td)
			ans=ans+1ll*u*((n+1)/(td+1)-max(1,(siz[u]+1)/(td+1)));
		td=td+td+1;
	}
	td=1;
	while (td<siz[u])
	{
		if (n-siz[u]<=siz[u]-td&&siz[u]-1<=n-td)
			ans=ans+1ll*u*((siz[u]+1)/(td+1));
		td=td+td+1;
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=read();
	while (T--)
	{
		n=read();
		addnum=1;
		for (int i=1;i<=n;i++) he[i]=0,du[i]=0;
		for (int i=1;i<n;i++)
		{
			x[i]=read(),y[i]=read();
			add(x[i],y[i]),add(y[i],x[i]);
			du[x[i]]++,du[y[i]]++;
		}
		if (n<=2000)
		{
			ans=0;
			for (int i=1;i<n;i++)
			{
				dfs(x[i],-1,i);
				dfs1(x[i],-1,i,siz[x[i]]);
				dfs(y[i],-1,i);
				dfs1(y[i],-1,i,siz[y[i]]);
			}
			printf("%lld\n",ans);
			continue;
		}
		int num=0,flag=1;
		for (int i=1;i<=n;i++)
			if (du[i]>2) flag=0;
			else if (du[i]==1) num++;
		if (num==2&&flag)
		{
			int rt=0;
			ans=0;
			for (int i=1;i<=n;i++)
				if (du[i]==1)
				{
					rt=i;
					break;
				}
			a[1]=rt;
			for (int i=2;i<=n;i++)
			{
				for (int e=he[a[i-1]];e;e=ne[e])
				{
					int v=vel[e];
					if (v==a[i-2]) continue;
					a[i]=v;
					break;
				}
			}
			for (int i=1;i<=n;i++)
			{
				if (i+i-2<n&&i+i-2>0) ans+=a[i];
				if (i+i-1<n) ans+=a[i];
				if (i+i<n) ans+=a[i];
				int t=n-i+1;
				if (t+t-2<n&&t+t-2>0) ans+=a[i];
				if (t+t-1<n) ans+=a[i];
				if (t+t<n) ans+=a[i];
			}
			printf("%lld\n",ans);
			continue;
		}
		for (int i=1;i<=n;i++)
			if (du[i]==1) 
			{
				num=i;
				break;
			}
		maxn=0; tot=0;
		dfsd(num,-1);
		ans=0;
		for (int i=1;i<=n;i++) ans+=i;
		ans-=d;
		dfd(d,-1);
		printf("%lld\n",ans);
	}
}
