#include <bits/stdc++.h>

#define REP(i, l, r) for (int i = (l); i <= (r); ++i)
#define rep(i, l, r) for (int i = (l); i < (r); ++i)
#define RREP(i, r, l) for (int i = (r); i >= (l); --i)
#define foredge(i, u) for (int i = la[u]; i; i = ne[i])
#define mem(a) memset(a, 0, sizeof(a))
#define tpn typename
#define fr(a) freopen(a, "r", stdin)
#define fw(a) freopen(a, "w", stdout)
#define dbg(x) cout << #x << " = " << x << endl

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

template <tpn A>
inline void read(A &x) {
    A neg = 1;
    char c;
    do c = getchar();
    while ((c < '0' || c > '9') && c != '-');
    if (c == '-') neg = -1, c = getchar();
    x = 0;
    do {
        x = x * 10 + c - 48;
        c = getchar();
    } while (c >= '0' && c <= '9');
    x *= neg;
}
template <tpn A, tpn B>
inline void read(A &a, B &b) { read(a), read(b); }
const int N = 50005;
int la[N], ne[N << 1], en[N << 1], edgenum;
inline void add(int x, int y) {
    ne[++edgenum] = la[x];
    en[edgenum] = y;
    la[x] = edgenum;
}
int T, n, x[N], y[N];
int siz[N], cur, ans, qaq;
namespace task {
int d[N], cnt, st;
ll ans, p[N];
void dfs(int u, int fa) {
    p[++cnt] = u;
    foredge(i, u) if (en[i] != fa) dfs(en[i], u);
}
inline void solve() {
    REP(i, 1, n) d[i] = 0;
    rep(i, 1, n) ++d[x[i]], ++d[y[i]];
    REP(i, 1, n)
    if (d[i] == 1) {
        st = i;
        break;
    }
    cnt = ans = 0;
    dfs(st, 0);
    rep(i, 1, n) {
        ans += p[i / 2 + 1];
        if (!(i & 1)) ans += p[i / 2];
        ans += p[(n + i) / 2 + 1];
        if (!(n - i & 1)) ans += p[(n + i) / 2];
    }
    printf("%lld\n", ans);
}
}
void dfs(int u, int p) {
    siz[u] = 1;
    foredge(i, u)
    if (en[i] != p) dfs(en[i], u), siz[u] += siz[en[i]];
}
void work(int u, int p) {
    qaq = 1;
    if (cur - siz[u] > cur / 2) qaq = 0;
    foredge(i, u)
    if (en[i] != p && siz[en[i]] > cur / 2) qaq = 0;
    ans += qaq * u;
    foredge(i, u) if (en[i] != p) work(en[i], u);
}
int main() {
    fr("centroid.in");
    fw("centroid.out");
    read(T);
    while (T--) {
        read(n);
        edgenum = ans = 0;
        REP(i, 1, n) la[i] = 0;
        rep(i, 1, n) {
            read(x[i], y[i]);
            add(x[i], y[i]);
            add(y[i], x[i]);
        }
        if (n == 49991) task::solve();
        rep(i, 1, n) {
            dfs(x[i], y[i]);
            cur = siz[x[i]];
            work(x[i], y[i]);
            dfs(y[i], x[i]);
            cur = siz[y[i]];
            work(y[i], x[i]);
        }
        printf("%d\n", ans);
    }
    return 0;
}