#include <iostream>
#include <cstdio>
using std::cin; using std::cout; using std::endl; using std::cerr;
typedef int T;
typedef long long ll;
#define rep(i, l, r) for(int i = (l); i <= (r); ++i)
const int N = 110, M = 2010, p = 998244353;

T f[N], g[N][M][N], a[N][M];

#define dbg(x) cerr << #x << " = " << x << endl;

int main(){
	freopen("meal.in", "r", stdin); freopen("meal.out", "w", stdout);
	std::ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m; cin >> n >> m;
	rep(i, 1, n) rep(j, 1, m) cin >> a[i][j];
	f[0] = 1;
	rep(i, 1, m) g[0][i][0] = 1;
	for(int k = 1; k <= n; ++k){
		ll sum = 0;
		for(int i = 1; i <= m; ++i) sum += a[k][i];
		sum %= p;
		// dbg(sum);
		for(int i = k; i >= 1; --i) f[i] = (f[i] + f[i-1]*sum%p)%p;
		for(int l = k; l >= 1; --l)
			for(int i = m; i >= 1; --i){
				for(int j = k; j >= 1; --j)
					g[l][i][j] = (g[l][i][j] + (ll)g[l-1][i][j-1] * a[k][i]%p + g[l-1][i][j] * (sum-a[k][i])%p ) %p;
				g[l][i][0] = (g[l][i][0] + g[l-1][i][0] * (sum-a[k][i])%p) %p;
			}
	}
	ll ans = 0;

	for(int k = 2; k <= n; ++k){
		ans += f[k];
		for(int i = 1; i <= m; ++i)
			for(int j = k/2+1; j <= n; ++j)
				ans -= g[k][i][j];
		ans %= p;
		// dbg(ans);
	}
	cout << (ans+p)%p << endl;
	return 0;
}
