#include<bits/stdc++.h>

using namespace std;

typedef long long LL;
#define N 320000

int t,n,x,y,tot,clk,cnt,head[N],dfn[N],lst[N],pos[N],sz[N],seg[N<<5],ls[N<<5],rs[N<<5],s1[N<<2],s2[N<<2],rt[N];
LL ans;
struct edge{int v,nxt;}e[N<<1];

void add(int x,int y){
	e[++tot].v=y; e[tot].nxt=head[x]; head[x]=tot;
}

void dfs(int u,int fa){
	dfn[u]=lst[u]=++clk; pos[clk]=u;
	sz[u]=1;
	for (int i=head[u],v;i;i=e[i].nxt)
		if ((v=e[i].v)!=fa){
			dfs(v,u);
			sz[u]+=sz[v];
			lst[u]=lst[v];
		}
}

void mdf(int &x,int y,int l,int r,int t){
	x=++cnt; seg[x]=seg[y]; ls[x]=ls[y]; rs[x]=rs[y];
	if (l==r){++seg[x]; return;}
	int mid=(l+r)>>1;
	if (t<=mid) mdf(ls[x],ls[y],l,mid,t);
	if (t>mid) mdf(rs[x],rs[y],mid+1,r,t);
	seg[x]=seg[ls[x]]+seg[rs[x]];
}

int qry(int x,int l,int r,int L,int R){
	if (!x||L>R||R<l||L>r) return 0;
	if (l>=L&&r<=R) return seg[x];
	int mid=(l+r)>>1,ret=0;
	if (L<=mid) ret+=qry(ls[x],l,mid,L,R);
	if (R>mid) ret+=qry(rs[x],mid+1,r,L,R);
	return ret;
}

int ask(int s[],int x,int l,int r,int L,int R){
	if (L>R||R<l||L>r) return 0;
	if (l>=L&&r<=R) return s[x];
	int mid=(l+r)>>1,ret=0;
	if (L<=mid) ret+=ask(s,x<<1,l,mid,L,R);
	if (R>mid) ret+=ask(s,x<<1|1,mid+1,r,L,R);
	return ret;
}

void chg(int s[],int x,int l,int r,int t,int k){
	if (l==r){s[x]+=k; return;}
	int mid=(l+r)>>1;
	if (t<=mid) chg(s,x<<1,l,mid,t,k);
	else chg(s,x<<1|1,mid+1,r,t,k);
	s[x]=s[x<<1]+s[x<<1|1];
}

int QRY(int x,int y,int l,int r){
	return qry(rt[y],1,n,l,r)-qry(rt[x-1],1,n,l,r);
}

void calc(int u,int fa){
	int m1=0,m2=0;
	for (int i=head[u],v;i;i=e[i].nxt)
		if ((v=e[i].v)!=fa){
			if (sz[v]>sz[m2]) m2=v;
			if (sz[m2]>sz[m1]) swap(m1,m2);
		}
	for (int i=head[u],v;i;i=e[i].nxt)
		if ((v=e[i].v)!=fa){
			int t=m1;
			if (t==v) t=m2;
			if (n-sz[u]>sz[t]) t=n-sz[u];
			else t=sz[t];
			int l=sz[v]*2-n,r=n-t*2;
			ans+=(LL)u*QRY(dfn[v],lst[v],l,r);
		}
	int t=sz[m1];
	int l=(n-sz[u])*2-n,r=n-t*2;
	ans+=(LL)u*(QRY(1,n,l,r)-QRY(dfn[u],lst[u],l,r)-ask(s1,1,1,n,l,r)+ask(s2,1,1,n,l,r));
	chg(s1,1,1,n,sz[u],1);
	for (int i=head[u],v;i;i=e[i].nxt)
		if ((v=e[i].v)!=fa){
			chg(s2,1,1,n,n-sz[v],1);
			calc(v,u);
			chg(s2,1,1,n,n-sz[v],-1);
		}
	chg(s1,1,1,n,sz[u],-1);
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while (t--){
		scanf("%d",&n);
		memset(head,0,sizeof head); tot=0;
		for (int i=1;i<n;++i){
			scanf("%d%d",&x,&y);
			add(x,y); add(y,x);
		}
		clk=0;
		dfs(1,0);
		cnt=0; memset(rt,0,sizeof rt);
		for (int i=1;i<=n;++i){
			mdf(rt[i],rt[i-1],1,n,sz[pos[i]]);
		}
		ans=0;
		calc(1,0);
		printf("%lld\n",ans);
	}
	
	return 0;
}
			
