#include<bits/stdc++.h>
using namespace std;

const int MN=4e7+20;
int n, type;
long long a[MN];

long long lS(long long x){
	return x*x;
}

const int wq=100;
struct BigInt{
	int val[1005];
	int w;
}ans, cl;
void PBI(BigInt x){
	printf("%d", x.val[x.w]);
	for(int i=x.w-1; i>=1; i--){
		if(x.val[i]<10) printf("0");
		printf("%d", x.val[i]);
	}
	printf("\n");
}
BigInt L2BI(long long x){
	BigInt res;
	memset(res.val, 0, sizeof res.val);
	res.w=0;
	while(x>0){
		res.val[++res.w]=x%wq;
		x/=wq;
	}
	return res;
}
BigInt Add(BigInt a, BigInt b){
	BigInt c;
	memset(c.val, 0, sizeof c.val);
	c.w=max(a.w, b.w);
	int x=0;
	for(int i=1; i<=c.w; i++){
		c.val[i]=x+a.val[i]+b.val[i];
		x=c.val[i]/wq;
		c.val[i]%=wq;
	}
	while(x>0){
		c.w++;
		c.val[c.w]=x;
		x=c.val[c.w]/wq;
	}
	return c;
}
bool cmp(BigInt a, BigInt b){
	if(a.w<b.w) return true;
	if(a.w>b.w) return false;
	for(int i=a.w; i>=1; i--){
		if(a.val[i]<b.val[i]) return true;
		if(a.val[i]>b.val[i]) return false;
	}
	return false;
}
BigInt Clean(){
	BigInt ans;
	for(int i=1; i<=1000; i++)
		ans.val[i]=1000000;
	ans.w=1000000;
	return ans;
}

namespace sub1{
	long long lap=-1, las=-1;
	BigInt dfs(long long p, long long s){
		BigInt res, tmp, ans;
		res=ans=cl;
		long long s1=0;
		long long tmp1=p, tmp2=s;
		for(int i=tmp1+1; i<=n; i++){
			s1+=a[i];
			if(s1>=tmp2){
				if(i<n){
					res=L2BI(lS(s1));
					p=i;
					s=s1;
					tmp=dfs(p, s);
					if(tmp.w>=1020) continue;
					res=Add(res, tmp);
					if(cmp(res, ans)) ans=res;
					lap=tmp1;
					las=tmp2;
				}
				if(i==n){
					res=L2BI(lS(s1));
					if(cmp(res, ans)) ans=res;
				}
			}
		}
		return ans;
	}
	void ma(){
		ans=dfs(0, 0);
		PBI(ans);
	}
}

namespace sub2{
	long long f[55][55][55];
	long long sum[55];
	void ma(){
		ans=cl;
		sum[0]=0;
		for(int i=1; i<=n; i++)
			sum[i]=sum[i-1]+a[i];
		for(int d=1; d<n; d++)
			for(int i=1; i+d<=n; i++){
				int j=i+d;
				for(int k=i; k<j; k++){
					if(k==i){
						f[i][j][k]=lS(a[i])+lS(sum[j]-sum[k]);
						continue;
					}
					f[i][j][k]=4e18+20;
					for(int t=i; t<k; t++){
						if(sum[k]-sum[t]>sum[j]-sum[k])
							continue; 
						long long res=f[i][k][t]+lS(sum[j]-sum[k]);
						if(res<f[i][j][k])
							f[i][j][k]=res;
					}
				}
			}
		for(int i=1; i<n; i++)
			if(cmp(L2BI(f[1][n][i]), ans)&&f[1][n][i]!=0)
				ans=L2BI(f[1][n][i]);
		PBI(ans);
	}
}

int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	cl=Clean();
	srand(time(NULL));
	scanf("%d%d", &n, &type);
	BigInt yy;
	yy.w=min(yy.w, 1000);
	if(type==0){
		a[0]=0;
		for(int i=1; i<=n; i++)
			scanf("%d", &a[i]);
		if(n<=10) sub1::ma();
		else if(n<=50) sub2::ma();
		else ans=yy, PBI(ans);
	}
	return 0;
}
