#include<cstdio>
#include<algorithm>
#include<iostream>
using namespace std;
#define ll long long
const int N=300000;

int n,sz,sum,size[N],first[N],nxt[N],edge[N<<1],w,Mx[N],T,u[N],v[N];
int MxDeg,Deg1,Deg2,Deg3,point[N],deg[N],fa[N],lson[N],rson[N];
ll ans;

void add(int x,int y)
{
	edge[++w]=y;nxt[w]=first[x];first[x]=w;
}

void getsize(int x,int fat)
{
	sz++;
	for (int i=first[x];i;i=nxt[i])
		if (edge[i]!=fat) getsize(edge[i],x);
}

void dfs(int x,int fat)
{
	size[x]=1;Mx[x]=0;
	for (int i=first[x];i;i=nxt[i])
	{
		int u=edge[i];if (u==fat) continue;
		dfs(u,x);size[x]+=size[u];Mx[x]=max(Mx[x],size[u]);
	}
	Mx[x]=max(Mx[x],sz-size[x]);
	sum=min(Mx[x],sum);
}

void Centroid(int x,int fat)
{
	if (Mx[x]==sum) ans+=x;
	for (int i=first[x];i;i=nxt[i])
		if (edge[i]!=fat) Centroid(edge[i],x);
}

void getroot(int x,int fat)
{
	sz=0;sum=n+1;getsize(x,fat);
	dfs(x,fat);Centroid(x,fat);
}

void DFS(int x,int fat,int dep)
{
	point[dep]=x;
	for (int i=first[x];i;i=nxt[i])
		if (edge[i]!=fat) DFS(edge[i],x,dep+1);
}

void workline()
{
	int rt=0;
	for (int i=1;i<=n;i++) if (deg[i]==1) {rt=i;break;}
	DFS(rt,0,1);
	for (int i=1;i<n;i++)
	{
		if (i&1) ans+=point[(i+1)>>1];
			else ans+=point[(i>>1)+1]+point[i>>1];
		if ((i+1+n)&1) ans+=point[(i+1+n)>>1]+point[((i+1+n)>>1)+1];
			else ans+=point[(i+1+n)>>1];
	}
}

void Dfs(int x,int fat)
{
	fa[x]=fat;lson[x]=rson[x]=0;
	for (int i=first[x];i;i=nxt[i])
	{
		if (edge[i]!=fat) Dfs(edge[i],x);
		if (!lson[x]) lson[x]=edge[i];else rson[x]=edge[i];
	}
}

void workbinary()
{
	int rt=0;
	for (int i=1;i<=n;i++) if (deg[i]==2) {rt=i;break;}
	Dfs(rt,0);
	for (int i=1;i<n;i++)
		if (fa[u[i]]==v[i]) 
		{
			ans+=u[i];int t=fa[u[i]],yt=u[i];
			while (t!=rt) yt=t,t=fa[t];
			if (yt==lson[rt]) ans+=rson[rt];
				else ans+=lson[rt];
		} else
		{
			ans+=v[i];int t=fa[v[i]],yt=v[i];
			while (t!=rt) yt=t,t=fa[t];
			if (yt==lson[rt]) ans+=rson[rt];
				else ans+=lson[rt];
		}
}

bool bi(int x)
{
	int ans=1;
	while (ans<=x) ans<<=1;
	if (ans==x+1) return true;return false;
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--)
	{
		scanf("%d",&n);
		for (int i=1;i<n;i++)
		{
			scanf("%d%d",&u[i],&v[i]);
			add(u[i],v[i]);add(v[i],u[i]);
			deg[u[i]]++,deg[v[i]]++;
		}
		MxDeg=Deg1=Deg2=Deg3=0;
		for (int i=1;i<=n;i++)
		{
			MxDeg=max(MxDeg,deg[i]);
			if (deg[i]==1) Deg1++;
			if (deg[i]==2) Deg2++;
			if (deg[i]==3) Deg3++;
		}
		if (MxDeg<=2) workline();
		//	else if (bi(n)&&Deg1+Deg2+Deg3==n&&Deg1==(n+1)/2&&Deg2==1)
		//		workbinary();
					else{
						for (int i=1;i<=n;i++)
							getroot(u[i],v[i]),getroot(v[i],u[i]);
				 		}
		printf("%lld\n",ans);ans=0;
		w=0;for (int i=1;i<=n*2;i++) first[i]=nxt[i]=edge[i]=deg[i]=0;
	}
	return 0;
}
