#include <cstdio>
#include <cstring>

using namespace std;

const int MOD = 998244353;

int n, m;
long long a[110][2100];
int ans;

void work2() {
    int f[2][50][50];
    memset(f, 0, sizeof(f));
    f[0][0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        memset(f[1], 0, sizeof(f[1]));
        for (int j = 0; j <= i; ++j) {
            for (int k = 0; j + k <= i; ++k) {
                f[1][j][k] = f[0][j][k];
                if (j > 0) {
                    f[1][j][k] = (f[1][j][k] + f[0][j - 1][k] * a[i][1]) % MOD;
                }
                if (k > 0) {
                    f[1][j][k] = (f[1][j][k] + f[0][j][k - 1] * a[i][2]) % MOD;
                }
            }
        }
        memcpy(f[0], f[1], sizeof(f[0]));
    }
    ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (i > 0) {
            ans = (ans + f[0][i][i]) % MOD;
        }
    }
}

void work3() {
    int f[2][50][50][50];
    memset(f, 0, sizeof(f));
    f[0][0][0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        memset(f[1], 0, sizeof(f[1]));
        for (int i1 = 0; i1 <= i; ++i1) {
            for (int i2 = 0; i1 + i2 <= i; ++i2) {
                for (int i3 = 0; i1 + i2 + i3 <= i; ++i3) {
                    f[1][i1][i2][i3] = f[0][i1][i2][i3];
                    if (i1 > 0) {
                        f[1][i1][i2][i3] = (f[1][i1][i2][i3] + f[0][i1 - 1][i2][i3] * a[i][1]) % MOD;
                    }
                    if (i2 > 0) {
                        f[1][i1][i2][i3] = (f[1][i1][i2][i3] + f[0][i1][i2 - 1][i3] * a[i][2]) % MOD;
                    }
                    if (i3 > 0) {
                        f[1][i1][i2][i3] = (f[1][i1][i2][i3] + f[0][i1][i2][i3 - 1] * a[i][3]) % MOD;
                    }
                }
            }
        }
        memcpy(f[0], f[1], sizeof(f[0]));
    }
    ans = 0;
    for (int i1 = 0; i1 <= n; ++i1) {
        for (int i2 = 0; i1 + i2 <= n; ++i2) {
            for (int i3 = 0; i1 + i2 + i3 <= n; ++i3) {
                if (i1 * 2 <= i1 + i2 + i3 && i2 * 2 <= i1 + i2 + i3 &&
                    i3 * 2 <= i1 + i2 + i3 && i1 + i2 + i3 > 0) {
                    ans = (ans + f[0][i1][i2][i3]) % MOD;
                }
            }
        }
    }
}

int main() {
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    scanf("%d%d", &n, &m);
    for (int i = 1; i <= n; ++i) {
        a[i][0] = 1;
        for (int j = 1; j <= m; ++j) {
            scanf("%lld", &a[i][j]);
        }
    }
    if (m == 2) {
        work2();
    } else {
        work3();
    }
    printf("%d\n", ans);
    fclose(stdin);
    fclose(stdout);
    return 0;
}