#include <cstdio>
#include <cstring>
using namespace std;
const int N=3e5;
int n,T,tot,Ans;
int fir[N], nxt[N<<1], to[N<<1], cant[N], siz[N],indx[N];
struct edge{
	int x,y;
}E[N];
inline void link(int x,int y){to[++tot]=y, nxt[tot]=fir[x], fir[x]=tot;}
inline void reset(){memset(fir,0,sizeof fir), tot=1, Ans=0;}
void Dfs1(int x,int fa){
	siz[x]=1;
	for (int i=fir[x],y=to[i];i;i=nxt[i],y=to[i]) if (y!=fa&&!cant[i]){
		Dfs1(y,x);
		siz[x]+=siz[y];
	}
}
void Dfs2(int x,int fa,int rt){
	bool flg=1;
	for (int i=fir[x],y=to[i];i;i=nxt[i],y=to[i]) if (y!=fa&&!cant[i]){
		if (siz[y]>siz[rt]/2) flg=0; 
		Dfs2(y,x,rt);
	}
	if (siz[rt]-siz[x]>siz[rt]/2) flg=0;
	if (flg) Ans+=x;
}
namespace A{
	int rt, stk[N];
	void Dfs(int x,int fa){
		stk[++stk[0]]=x;
		for (int i=fir[x],y=to[i];i;i=nxt[i],y=to[i]) if (y!=fa) Dfs(y,x);
	}
	void Solve(){
		for (int i=1;i<=n;i++) if (indx[i]==1) {rt=i; break;}
		Dfs(rt,0);
		for (int i=1;i<n;i++){ // i  i+1
			int len1=i, len2=n-i;
			int p1=(1+i)/2,p2=n+1,p3=(i+1+n)/2,p4=n+1;
			if (len1%2==0) p2=p1+1;
			if (len2%2==0) p4=p3+1;
			Ans+=stk[p1]+stk[p2]+stk[p3]+stk[p4];
		}
		printf("%d\n",Ans);
	}
}
int main(){
freopen("centroid.in","r",stdin);
freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--){
		reset();
		bool flg1=1;
		scanf("%d",&n);
		for (int i=1,x,y;i<n;i++){
			scanf("%d%d",&x,&y);
			link(x,y), link(y,x);
			E[i]=(edge){x,y};
			indx[x]++, indx[y]++;
			if (indx[x]>2) flg1=0; if (indx[y]>2) flg1=0;
		}
		if (flg1) A::Solve(); else{
			for (int i=1;i<n;i++){
				cant[i*2]=1; cant[(i*2)^1]=1;
				Dfs1(E[i].x,0), Dfs2(E[i].x,0,E[i].x);
				Dfs1(E[i].y,0), Dfs2(E[i].y,0,E[i].y);
				cant[i*2]=0; cant[(i*2)^1]=0;
			}
			printf("%d\n",Ans);	
		}
	}
	return 0;
}
