/*
  问：NOIP 和 CSP-J/S 是否有关系？
  答：没有关系。
  ——摘自 NOI 官网
  人民警察才不会相信你的鬼话。
  ——LCA, NOIWC 2019 语录
 */
#include <cstdio>
#include <cstring>
#include <algorithm>
const int MAXN = 5e5 + 10;
typedef long long LL;

int n, a[MAXN];
namespace {
  template <class T> void chmin(T &a, T b) { a = std::min(a, b); }
}
  
namespace solver1 {
  const int MAXN = 5000 + 10;
  const int INF = 2e9;
  const LL INFLL = 4e18 + 233;
  
  LL f[MAXN][MAXN];
  LL sum[MAXN];
  void main() {
    memset(f, 63, sizeof f);
    f[0][0] = 0;
    for (int i = 1; i <= n; i++) {
      sum[i] = sum[i - 1] + a[i];
      if (sum[i] <= INF) f[1][i] = sum[i] * sum[i];
      else f[1][i] = INFLL;
    }

    for (int j = 1; j <= n; j++) {
      LL cur = INFLL;

      for (int k = j - 1, i = j; i <= n && k >= 1 && sum[i] - sum[j - 1] <= INF; i++) {
        while(k >= 1 && sum[j - 1] - sum[k - 1] <= sum[i] - sum[j - 1]) {
          chmin(cur, f[k][j - 1]);
          k--;
        }
        chmin(f[j][i], cur + (sum[i] - sum[j - 1]) * (sum[i] - sum[j - 1]));
              
      }
    }

    LL ans = INFLL;

    for (int i = 1; i <= n; i++) {
      chmin(ans, f[i][n]);
    }

    printf("%lld\n", ans);
                      


  }
}
int main() {
#ifndef LOCAL
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
#endif

  int type;
  scanf("%d%d", &n, &type);
  if (type == 0) {
    for (int i = 1; i <= n; i++) {
      scanf("%d", a + i);
    }
    solver1::main();
  }
}
