#include <bits/stdc++.h>

using namespace std;

const int N=299995+5;
struct Edge{
	int v,id,next;
} edge[(N-1)*2];
int head[N+1],u[N],v[N],cnt,n,size[N+1];
long long ans;

inline void addEdge(int u,int v,int id){
	edge[cnt].v=v;
	edge[cnt].id=id;
	edge[cnt].next=head[u];
	head[u]=cnt++;
}

inline void addUndiEdge(int u,int v,int id){
	addEdge(u,v,id);
	addEdge(v,u,id);
}

void dfs1(int k,int fa,int e){
	size[k]=1;
	for (int i=head[k];i>=0;i=edge[i].next)
		if (edge[i].id!=e) {
			int v=edge[i].v;
			if (v!=fa) {
				dfs1(v,k,e);
				size[k]+=size[v];
			}
		}
}


void dfs(int k,int fa,int e,int n){
	bool flag=true;
	for (int i=head[k];i>=0;i=edge[i].next)
		if (edge[i].id!=e) {
			int v=edge[i].v;
			if (v!=fa) {
				dfs(v,k,e,n);
				if (size[v]>n/2) flag=false;
			}
		}
	if (n-size[k]>n/2) flag=false;
	if (flag) ans+=k;
}

int calc(int n){
	if (n%2==1) return n/2+1;
	else return n+1;
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	while (t--){
		scanf("%d",&n);
		memset(head,-1,sizeof head);
		cnt=0;
		bool flag=true;
		for (int i=1;i<n;++i){
			scanf("%d%d",u+i,v+i);
			if (u[i]>v[i]) swap(u[i],v[i]);
			addUndiEdge(u[i],v[i],i);
			if (abs(u[i]-v[i])!=1) flag=false;
		}
		if (flag){
			for (int i=1;i<n;++i) ans+=calc(u[i])+calc(n-v[i]+1);
			printf("%lld",ans);
			return 0;
		}
		ans=0;
		for (int i=1;i<n;++i) {
			int tmp;
//			puts("#################");
			dfs1(u[i],u[i],i);
			tmp=size[u[i]];
			dfs(u[i],u[i],i,tmp);
//			puts("#################");
			dfs1(v[i],v[i],i);
			tmp=size[v[i]];
			dfs(v[i],v[i],i,tmp);
		}
		printf("%lld\n",ans);
	}
	return 0;
}
