#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ri register int
#define For(i , x , y) for(ri i = x ; i <= y ; ++ i)
inline int read() {
	int s = 0 , w = 1; char ch = getchar();
	while(ch < 48 || ch > 57) {if(ch == '-') w = -1; ch = getchar();}
	while(ch >= 48 && ch <= 57) s = (s << 1) + (s << 3) + (ch ^ 48) , ch = getchar();
	return s * w;
}
const int N = 2e5 + 5;
int n , m , T  , tot , head[N] , siz[N] , f[N];
struct Edge{int to , nxt;} e[N << 1];
void addedge(int x , int y) {e[++ tot].to = y , e[tot].nxt = head[x] , head[x] = tot;}
bool flag[2005][2005];
int mn , pos1 , pos2;
ll Ans;
void dfs(int u , int par) {
	siz[u] = 1; f[u] = 0;
	for(ri i = head[u] ; i ; i = e[i].nxt) {
		int v = e[i].to;
		if(flag[u][v] || flag[v][u]) continue;
		if(v == par) continue;
		dfs(v , u) ; siz[u] += siz[v]; f[u] = max(f[u] , siz[v]);
	}
}

int solve(int rt) {
	For(i , 0 , n) siz[i] = 0;
	For(i , 0 , n) f[i] = 0;
	mn = 1e9 , pos1 = pos2 = 0;
	dfs(rt , 0);
	For(i , 1 , n) 
		if(siz[i] != 0) {
			f[i] = max(f[i] , siz[rt] - siz[i]);
			if(f[i] < mn) mn = f[i] , pos1 = i , pos2 = 0;
			else if(f[i] == mn) pos2 = i;
		}
	return pos1 + pos2;
}

int w[N] , du[N];

void dfs1(int u , int par , int depth) {
	w[depth] = u;
	for(ri i = head[u] ; i ; i = e[i].nxt) if(e[i].to != par) dfs1(e[i].to , u , depth + 1);
}

void subtask1() {
	int rt = 0;
	For(i , 1 , n) if(du[i] == 1) {rt = i ; break;}
	dfs1(rt , 0 , 1);
	For(i , 1 , n - 1) {
		ll res = (i & 1) ? w[i / 2 + 1] : w[i / 2 + 1] + w[i / 2];
		Ans += res;
		res = ((n - i) & 1) ? w[ (i + 1 + n) / 2] : w[ (i + 1 + n) / 2] + w[ (i + 1 + n) / 2 + 1];
		Ans += res;
	}
	printf("%lld\n" , Ans);
}
int main() {
	freopen("centroid.in" , "r" , stdin);
	freopen("centroid.out" , "w" , stdout);
	T = read() ;
	while(T --) {
		tot = Ans = 0 ; memset(head , 0 , sizeof(head));
		memset(du , 0 , sizeof(du));
		n = read() ; 
		For(i , 1 , n - 1) {
			int u = read() , v = read() ; addedge(u , v) , addedge(v , u);
			++ du[u] , ++ du[v];
		}
		if(n % 10 == 1) {subtask1() ; continue;}
		For(i , 1 , n) 
			for(ri j = head[i] ; j ; j = e[j].nxt) {
				int v = e[j].to;
				flag[i][v] = flag[v][i] = 1;
				Ans = Ans + solve(i) + solve(v);
				flag[i][v] = flag[v][i] = 0;
			}
		printf("%d\n" , Ans / 2);
	}
	return 0;
}
