#include<bits/stdc++.h>

using namespace std;

#define N 300005
typedef long long ll;

int T, n, head[N], nxt[N << 1], to[N << 1], cnt = 0;

void add(int x, int y)
{
	cnt++;
	to[cnt] = y;
	nxt[cnt] = head[x];
	head[x] = cnt;
}

ll ans = 0, size[N];

int t1, t2, son[N], k1[2], k2[2], ans1[2], ans2[2];

void dfs1(int x)
{
	son[x] = 0;
	size[x] = 1;
	for(int p = head[x]; p; p = nxt[p])
	{
		int v = to[p];
		if(size[v] || v == t1) continue;
		dfs1(v);
		size[x] += size[v];
		if(size[v] > son[x]) son[x] = size[v];
	}
}

void dfs2(int x)
{
	son[x] = 0;
	size[x] = 1;
	for(int p = head[x]; p; p = nxt[p])
	{
		int v = to[p];
		if(size[v] || v == t2) continue;
		dfs2(v);
		size[x] += size[v];
		if(size[v] > son[x]) son[x] = size[v];
	}
}

void dfs3(int x, int fa)
{
	if(size[t2] - size[x] > son[x]) son[x] = size[t2] - size[x];
	if(son[x] < k1[0])
	{
		k1[0] = son[x], ans1[0] = x;
		k1[1] = INT_MAX, ans1[1] = 0;
	}
	else if(son[x] == k1[0])
	{
		k1[1] = son[x], ans1[1] = x;
	}
	for(int p = head[x]; p; p = nxt[p])
	{
		int v = to[p];
		if(v == fa || v == t1) continue;
		dfs3(v, x);
	}
}

void dfs4(int x, int fa)
{
	if(size[t1] - size[x] > son[x]) son[x] = size[t1] - size[x];
	if(son[x] < k2[0])
	{
		k2[0] = son[x], ans2[0] = x;
		k2[1] = INT_MAX, ans2[1] = 0;
	}
	else if(son[x] == k2[0])
	{
		k2[1] = son[x], ans2[1] = x;
	}
	for(int p = head[x]; p; p = nxt[p])
	{
		int v = to[p];
		if(v == fa || v == t2) continue;
		dfs4(v, x);
	}
}

int p[N], num = 0;

void dfs(int x, int fa)
{
	p[++num] = x;
	for(int p = head[x]; p; p = nxt[p])
	{
		int v = to[p];
		if(v == fa) continue;
		dfs(v, x);
	}
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d", &T);
	while(T--)
	{
		ans = 0;
		cnt = 0;
		memset(head, 0, sizeof(head));
		scanf("%d", &n);
		for(int i = 1; i <= n - 1; i++)
		{
			int x, y;
			scanf("%d%d", &x, &y);
			add(x, y);
			add(y, x);
		}
		if(n == 49991)
		{
			for(int i = 1; i <= n; i++)
				if(nxt[head[i]] == 0)
				{
					dfs(i, 0);
					break;
				}
			for(int i = 1; i < n; i++)
			{
				if(i & 1) ans += p[i / 2 + 1];
				else ans += p[i / 2] + p[i / 2 + 1];
				int len = n - i;
				if(len & 1) ans += p[n - len / 2];
				else ans += p[n - len / 2] + p[n - len / 2 + 1];
			}
			cout << ans << endl;
		}
		else
		{
			for(int i = 1; i <= n; i++)
			{
				for(int p = head[i]; p; p = nxt[p])
				{
					memset(size, 0, sizeof(size));
					int v = to[p];
					t1 = v, t2 = i;
					dfs1(i), dfs2(v);
					ans1[0] = 0, ans2[0] = 0, k1[0] = INT_MAX, k2[0] = INT_MAX;
					ans1[1] = 0, ans2[1] = 0, k1[1] = INT_MAX, k2[1] = INT_MAX;
					dfs3(i, 0), dfs4(v, 0);
					ans += ans1[0] + ans2[0] + ans1[1] + ans2[1];	
	//				cout << i << ' ' << v << ' ' << ans1[0] << ' ' << ans1[1] << ' ' << ans2[0] << ' ' << ans2[1] << endl;
				}
			}
			cout << ans / 2 << endl;
		}
	}
	return 0;
}
