#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#define N 300010
#define ll long long
using namespace std;
int nxt[N<<1],to[N<<1],head[N],cnt=1;
int in[N];
int num[N];
bool cut[N<<1];
void add(int u,int v)
{
	nxt[++cnt]=head[u];
	to[cnt]=v;
	head[u]=cnt;
	in[v]++;
}
struct trzx
{
	int root,root2,siz;
	void reset(int u){root=root2=0;siz=get_len(u,0);}
	int get_len(int u,int pre)
	{
		int res=1;
		for(int i=head[u];i;i=nxt[i])
		if(!cut[i] && to[i]!=pre) res+=get_len(to[i],u);
		return res;
	}
	int dfs(int u,int pre)
	{
		int msiz=0,allsiz=1;
		for(int i=head[u];i;i=nxt[i])
		if(!cut[i])
		{
			int v=to[i];
			if(v==pre) continue;
			int p=dfs(v,u);
			allsiz+=p;
			msiz=max(msiz,p);
		}
		msiz=max(msiz,siz-allsiz);
		if(msiz<=siz>>1)
		{
			if(root) root2=u;
			else root=u;
		}
		return allsiz;
	}
}tr1,tr2;
int dep[N];
void make_dep(int u,int pre)
{
	dep[u]=dep[pre]+1;
	for(int i=head[u];i;i=nxt[i])
	{
		int v=to[i];
		if(v!=pre) make_dep(v,u);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	while(t--)
	{
		int n;
		scanf("%d",&n);
		memset(head,0,sizeof(head));
		memset(in,0,sizeof(in));
		cnt=1;
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			add(u,v);
			add(v,u);
		}
		bool line=true;
		for(int i=1;i<=n;i++) if(in[i]>2) line=false;
		if(line)
		{
			memset(num,0,sizeof(num));
			int u=0;
			for(int i=1;i<=n;i++)
			if(in[i]==1) u=i;
			int tot=0,pre=u;
			num[++tot]=u;
			u=to[head[u]];
			while(in[u]>1)
			{
				num[++tot]=u;
				for(int i=head[u];i;i=nxt[i])
				if(to[i]!=pre){pre=u;u=to[i];break;}
			}
			num[++tot]=u;
			ll ans=0;
			for(int i=2;i<=n;i++)
			{
				if((i-1)&1) ans+=num[i>>1];
				else ans+=num[i>>1]+num[(i+1)>>1];
				if((n-i+1)&1) ans+=num[(i+n)>>1];
				else ans+=num[(i+n)>>1]+num[(i+n+1)>>1];
			}
			printf("%lld\n",ans);
			continue;
		}
		bool best=true;
		int cnt1=0,cnt2=0,rt=0;
		for(int res=n;res;res=res>>1) if(res%2==0) best=false;
		for(int i=1;i<=n;i++)
		if(in[i]>3) best=false;
		else if(in[i]==1) cnt1++;
		else if(in[i]==2) cnt2++,rt=i;
		ll ans=0;
		if(best && (n&1) && cnt2==1 && cnt1==(n+1)>>1)
		{
			dep[0]=0;
			make_dep(rt,0);
			for(int i=1;i<=n;i++)
			if(dep[i]==1) ans+=1ll*((n+1)>>1)*i;//cut the leave
			else
			{
				ans+=i;//cut the root
				if(dep[i]==2) ans+=1ll*(n>>1)*i;//cut others
			}
			printf("%lld\n",ans);
			continue;
		}
		for(int u=1;u<=n;u++)
		{
			for(int i=head[u];i;i=nxt[i])
			{
				int v=to[i];
				if(u>v) continue;
				cut[i]=cut[i^1]=true;
				tr1.reset(u);
				tr2.reset(v);
				tr1.dfs(u,0);
				tr2.dfs(v,0);
				ans+=tr1.root+tr1.root2+tr2.root+tr2.root2;
				cut[i]=cut[i^1]=false;
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}

