#include<iostream>
#include<cstdio>
#include<cstring>

using namespace std;

int T,n,nex[600010],head[300010],vet[600010],f[300010],g[300010],
	siz[300010],fa[300010],tot,u,v,flag,d[300010],id[300010];
long long ans;

int read(){
	int ret=0;
	char c=getchar();
	while (c<'0'||c>'9') c=getchar();
	while (c>='0'&&c<='9'){
		ret=ret*10+c-'0';
		c=getchar();
	}
	return ret;
}

void add(int u,int v){
	nex[++tot]=head[u];
	head[u]=tot;
	vet[tot]=v;
}

int gr1(int u,int num){
	int mid=num>>1;
	for (int i=head[u];i;i=nex[i]){
		int v=vet[i];
		if (v!=fa[u]){
			if (siz[v]>mid) return gr1(v,num);
			if (num-siz[v]==mid) return u+v;
		}
	}
	return u;
}

int gr2(int u,int num){
	int mid=num>>1;
	if (n-siz[fa[u]]>mid) return gr2(fa[u],num);
	if (num-(n-siz[fa[u]])==mid) return fa[u]+fa[fa[u]];
	for (int i=head[fa[u]];i;i=nex[i]){
		int v=vet[i];
		if (v!=u&&v!=fa[fa[u]]){
			if (siz[v]>mid) return gr1(v,num);
			if (num-siz[v]==mid) return fa[u]+v;
		}
	}
	return fa[u];
}

void dfs1(int u){
	siz[u]=1;
	for (int i=head[u];i;i=nex[i]){
		int v=vet[i];
		if (v!=fa[u]){
			fa[v]=u;
			dfs1(v);
			siz[u]+=siz[v];
		}
	}
	if (u!=1) f[u]=gr1(u,siz[u]);
}

void dfs2(int u){
	if (u!=1) g[u]=gr2(u,n-siz[u]);
	for (int i=head[u];i;i=nex[i]){
		int v=vet[i];
		if (v!=fa[u]) dfs2(v);
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--){
		n=read();
		tot=0;
		flag=1;
		memset(head,0,sizeof(head));
		for (int i=1;i<n;i++){
			u=read();
			v=read();
			d[u]++;
			d[v]++;
			add(u,v);
			add(v,u);
		}
		for (int i=1;i<=n;i++)
			if (d[i]>2) flag=0;
		if (flag){
			ans=0;
			for (int i=1;i<=n;i++)
				if (d[i]==1) id[1]=i;
			for (int i=1;i<n;i++)
				for (int j=head[id[i]];j;j=nex[j])
					if (vet[j]!=id[i-1]) id[i+1]=vet[j];
			for (int i=1;i<n;i++){
				if (i&1) ans+=id[(i+1)>>1];
				else ans+=id[i>>1]+id[(i>>1)+1];
				if ((n-i)&1) ans+=id[(n+i+1)>>1];
				else ans+=id[(n+i)>>1]+id[((n+i)>>1)+1];
			}
			printf("%lld\n",ans);
			continue;
		}
		dfs1(1);
		dfs2(1);
		ans=0;
		for (int i=2;i<=n;i++)
			ans+=f[i]+g[i];
		printf("%lld\n",ans);
	}
	return 0;
}
