#include <bits/stdc++.h>

#define coint const int

using namespace std;

bool bmm1;

// Start

typedef long long ll;

coint SZN = 100 + 5;
coint SZM = 2000 + 5;
coint MOD = 998244353;

int n, m;
ll ai[SZN][SZM];

struct P64 {
    ll dp[42][42][42];

    ll solve(void) {
        ll ans = 0;
        for (int cnt = 2; cnt <= n; ++cnt) {
            coint half = cnt / 2;
            for (int j = 0; j <= half; ++j)
                for (int k = 0; k <= half && j + k <= cnt; ++k)
                    for (int l = 0; l <= half && j + k + l <= cnt; ++l)
                        dp[j][k][l] = 0;
            dp[0][0][0] = 1;
            for (int ind = 1; ind <= n; ++ind) {
                coint tmp = min(ind, half), tmpCnt = min(cnt, ind);
                for (int j = tmp; j >= 0; --j)
                    for (int k = min(tmpCnt - j, half); k >= 0; --k)
                        for (int l = min(half, tmpCnt - j - k); l >= 0; --l) {
                            ll tmp = 0;
                            if (j) tmp += dp[j - 1][k][l] * ai[ind][1];
                            if (k) tmp += dp[j][k - 1][l] * ai[ind][2];
                            if (l) tmp += dp[j][k][l - 1] * ai[ind][3];
                            dp[j][k][l] = (dp[j][k][l] + tmp) % MOD;
                        }
            }
            for (int j = 0; j <= half; ++j)
                for (int k = 0; k <= half && j + k <= cnt; ++k) {
                    coint l = cnt - j - k;
                    if (l > half) continue;
                    ans += dp[j][k][l];
                }
            ans %= MOD;
        }
        return ans;
    }
} p64;

// End

bool bmm2;

/* Todo:
     * [x] 内存
     * [x] 文件 IO
     * [x] 下标未越界
     * [x] 输出语句
     * [x] 数据类型
     * [x] 取模
     * [x] 初始化
 */

int main(void) {
    //printf("%f\n", (&bmm2 - &bmm1) / 1024.0 / 1024.0);
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    scanf("%d%d", &n, &m);
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j) scanf("%lld", &ai[i][j]);
    printf("%lld\n", p64.solve());
    return 0;
}

