#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#define maxn 300010
#define LL long long
using namespace std;

int rd() {
	char ch=getchar(); int s=0, f=1;
	while (ch<'0' || ch>'9') { if (ch=='-') f=-f; ch=getchar(); }
	while (ch>='0' && ch<='9') { s=(s<<1)+(s<<3)+ch-'0'; ch=getchar(); }
	return s*f;
}

int tail[maxn], past[maxn<<1], ver[maxn<<1];
int st[maxn], ed[maxn], dep[maxn], Siz[maxn];
int maxp[2010], siz[2010];
int T, N, tot, S1, S2, p1, p2, totv, INF=1e9;

void eadd(int u,int v) {
	ver[++tot]=v;
	past[tot]=tail[u], tail[u]=tot;
}

void Dfs(int u,int f) {
	dep[u]=dep[f]+1;
	Siz[u]=1;
	for (int i=tail[u]; i; i=past[i]) {
		int v=ver[i];
		if (v==f) continue;
		Dfs(v, u);
		Siz[u]+=Siz[v];
	}
}

void dfs(int u,int f) {
	siz[u]=1;
	for (int i=tail[u]; i; i=past[i]) {
		int v=ver[i];
		if (v==f) continue;
		dfs(v, u);
		maxp[u]=max(maxp[u], siz[v]);
		siz[u]+=siz[v];
	}
	maxp[u]=max(maxp[u], totv-siz[u]);
	if (maxp[u]<maxp[p1]) p1=u, p2=0;
	else if (maxp[u]==maxp[p1]) p2=p1, p1=u;
}

int du[maxn], p[maxn], S, cnt;

void get_p(int u,int f) {
	p[++cnt]=u;
	for (int i=tail[u]; i; i=past[i]) {
		int v=ver[i];
		if (v==f) continue;
		get_p(v, u);
	}
}

void work1() {
	for (int i=1; i<=N; i++)
	if (du[i]==1) {
		S=i;
		break;
	}
	get_p(S, 0);
	//for (int i=1; i<=N; i++) printf("%d ", p[i]); printf("\n");
	LL ans=0;
	for (int i=1; i<N; i++) {
		if (i%2==1) ans+=(LL)p[i/2+1];
		else ans+=(LL)(p[i/2]+p[i/2+1]);
		int r=N-i;
		if (r%2==1) ans+=(LL)p[i+r/2+1];
		else ans+=(LL)(p[i+r/2]+p[i+r/2+1]);
	}
	printf("%lld\n", ans);
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T=rd(); 
	while (T--) {
		memset(tail, 0, sizeof(tail));
		memset(dep, 0, sizeof(dep));
		memset(Siz, 0, sizeof(Siz));
		N=rd(); tot=0;
		for (int i=1; i<N; i++) {
			st[i]=rd(), ed[i]=rd();
			du[st[i]]++, du[ed[i]]++;
			eadd(st[i], ed[i]), eadd(ed[i], st[i]);
		}
		int flag=1;
		for (int i=1; i<=N; i++)
		if (du[i]>2) {
			flag=0;
			break;
		}
		if (N>=2000 && flag) {
			work1();
			continue;
		}
		Dfs(1, 0);
		LL ans=0;
		for (int i=1; i<N; i++) {
			S1=st[i], S2=ed[i];
			if (dep[S1]<dep[S2]) swap(S1, S2);
			//printf("E:%d %d\n", S1, S2);
			//printf("size:%d %d\n", Siz[S1], N-Siz[S1]);
			memset(maxp, 0, sizeof(maxp)); maxp[0]=INF;
			memset(siz, 0, sizeof(siz));
			p1=p2=0, totv=Siz[S1], dfs(S1, S2);
			ans+=(LL)(p1+p2);
			//for (int i=1; i<=N; i++) printf("%d ", maxp[i]); printf("\n");
			//printf("S1:%d %d\n", p1, p2);
			memset(maxp, 0, sizeof(maxp)); maxp[0]=INF;
			memset(siz, 0, sizeof(siz));
			p1=p2=0, totv=N-Siz[S1], dfs(S2, S1);
			ans+=(LL)(p1+p2);
			//for (int i=1; i<=N; i++) printf("%d ", maxp[i]); printf("\n");
			//printf("S2:%d %d\n", p1, p2);
		}
		printf("%lld\n", ans);
	}
	return 0;
}
