#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#define maxn 110
#define maxm 2010
#define LL long long
using namespace std;

int rd() {
	char ch=getchar(); int s=0, f=1;
	while (ch<'0' || ch>'9') { if (ch=='-') f=-f; ch=getchar(); }
	while (ch>='0' && ch<='9') { s=(s<<1)+(s<<3)+ch-'0'; ch=getchar(); }
	return s*f;
}

int N, M, P=998244353;
LL a[maxn][maxm]; 

LL f1[41][41][41];
void work1() {
	memset(f1, 0, sizeof(f1));
	f1[0][0][0]=1;
	for (int i=1; i<=N; i++)
	for (int j=0; j<=i; j++) 
	for (int k=0; k+j<=i; k++) 
	for (int l=0; l<i; l++) {
		if (j>0) f1[i][j][k]=(f1[i][j][k]+f1[l][j-1][k]*a[i][1])%P;
		if (k>0) f1[i][j][k]=(f1[i][j][k]+f1[l][j][k-1]*a[i][2])%P;
	}
	
	LL ans=0;
	for (int i=1; i<=N; i++) 
	for (int j=0; j<=i; j++) 
	for (int k=0; k+j<=i; k++) {
		if (j+k<=1) continue;
		int mx=(j+k)/2;
		if (j<=mx && k<=mx) ans=(ans+f1[i][j][k])%P;
	}
	printf("%lld\n", ans);
}

LL f2[41][41][41][41];
void work2() {
	memset(f2, 0, sizeof(f2));
	f2[0][0][0][0]=1;
	for (int i=1; i<=N; i++)
	for (int j=0; j<=i; j++) 
	for (int k=0; k+j<=i; k++) 
	for (int l=0; j+k+l<=i; l++) 
	for (int p=0; p<i; p++) {
		if (j>0) f2[i][j][k][l]=(f2[i][j][k][l]+f2[p][j-1][k][l]*a[i][1])%P;
		if (k>0) f2[i][j][k][l]=(f2[i][j][k][l]+f2[p][j][k-1][l]*a[i][2])%P;
		if (l>0) f2[i][j][k][l]=(f2[i][j][k][l]+f2[p][j][k][l-1]*a[i][3])%P;
	}
	LL ans=0;
	for (int i=1; i<=N; i++)
	for (int j=0; j<=i; j++) 
	for (int k=0; k+j<=i; k++) 
	for (int l=0; j+k+l<=i; l++) {
		//printf("%d %d %d %d %d\n", i, j, k, l, f2[i][j][k][l]);
		if (j+k+l<=1) continue;
		int mx=(j+k+l)/2;
		if (j<=mx && k<=mx && l<=mx) ans=(ans+f2[i][j][k][l])%P;
	}
	printf("%lld\n", ans);
}

LL f[maxn][maxn];
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	N=rd(), M=rd();
	for (int i=1; i<=N; i++)
	for (int j=1; j<=M; j++) a[i][j]=rd();
	if (M==2) {
		work1();
		return 0;
	}
	if (M==3) {
		work2();
		return 0;
	}
	return 0;
}
