#include <bits/stdc++.h>

using namespace std;

#define rep(i , l , r) for(int i = (l) , ___ = (r) ; i <= ___ ; ++i)
#define per(i , r , l) for(int i = (r) , ___ = (l) ; i >= ___ ; --i)

template<typename T>inline T read(T &f)
{
	f = 0 ; int x = 1 ; char c = getchar();
	while(!isdigit(c)) x = c == '-' ? -1 : 1 , c = getchar();
	while(isdigit(c)) (f *= 10) += c & 15 , c = getchar();
	return f *= x;
}

template<typename T>inline int chkmin(T &x , const T &y) { return x > y ? x = y , 1 : 0 ;}
template<typename T>inline int chkmax(T &x , const T &y) { return x < y ? x = y , 1 : 0 ;}

const int N = 299995 + 5;

int n;

struct ED
{
	int u , v;
} e[N];

struct Edge
{
	int to ; Edge *next;
} E[N << 1] , *pre[N];

int cnt = 0;

void addedge(int u , int v)
{
	E[++cnt] = (Edge){v , pre[u]} , pre[u] = &E[cnt];
	E[++cnt] = (Edge){u , pre[v]} , pre[v] = &E[cnt];
}

typedef long long int64;

int64 Ans1 , Ans2;

int S1 , S2 , S , sz[N] , vis[N];

void dfs(int u , int fa)
{
	sz[u] = 1;
	for(Edge *i = pre[u] ; i ; i = i->next)
	{
		int v = i->to;
		if(v == fa || vis[v]) continue;
		dfs(v , u);
		sz[u] += sz[v];
	}
}

void sfd(int u , int fa)
{
	int g = 0;
	for(Edge *i = pre[u] ; i ; i = i->next)
	{
		int v = i->to;
		if(v == fa || vis[v]) continue;
		sfd(v , u);
		chkmax(g , sz[v]);
	}
	chkmax(g , S - sz[u]);
	if(chkmin(S1 , g)) Ans1 = 0;
	if(S1 == g) Ans1 += u;
}

namespace TASK_C
{
	int c , vec[N] , deg[N];
	
	void D(int u , int fa)
	{
		vec[++c] = u;
		for(Edge *i = pre[u] ; i ; i = i->next)
		{
			int v = i->to;
			if(v == fa) continue;
			D(v , u);
		}
	}
	
	int main()
	{
		rep(i , 1 , n) deg[i] = 0;
		rep(i , 1 , n - 1)
		{
			++deg[e[i].u];
			++deg[e[i].v];
		}
		c = 0;
		rep(i , 1 , n) if(deg[i] == 1)
		{
			D(i , 0);
			break;
		}
		int64 Ans = 0;
		rep(i , 2 , n)
		{
			int lrest = i - 1;
			if(lrest & 1) Ans += vec[i / 2];
			else Ans += vec[i / 2] + vec[i / 2 + 1];
		}
		c = 0;
		per(i , n , 1) if(deg[i] == 1)
		{
			D(i , 0);
			break;
		}
		rep(i , 2 , n)
		{
			int lrest = i - 1;
			if(lrest & 1) Ans += vec[i / 2];
			else Ans += vec[i / 2] + vec[i / 2 + 1];
		}
		cout << Ans << endl;
		return 0;
	}
}

namespace TASK_J
{
	int deg[N] , rt;
	
	int64 Ans;
	
	void D(int u , int fa)
	{
		if(fa == rt) Ans += 1ll * (n + 1) / 2 * u;
		else if(u != rt)
		{
			Ans += u;
		}
		for(Edge *i = pre[u] ; i ; i = i->next)
		{
			int v = i->to;
			if(v == fa) continue;
			D(v , u);
		}
	}
	
	int main()
	{
		rep(i , 1 , n) deg[i] = 0;
		rep(i , 1 , n - 1)
		{
			++deg[e[i].u];
			++deg[e[i].v];
		}
		Ans = 0;
		rep(i , 1 , n) if(deg[i] == 2)
		{
			rt = i;
			Ans += 1ll * (n + 1) / 2 * rt;
			D(rt , 0);
			break ;
		}
		cout << Ans << endl;
		return 0;
	}
}

namespace TASK
{
	int main()
	{
		read(n);
		cnt = 0;
		rep(i , 1 , n) pre[i] = 0;
		rep(i , 1 , n - 1)
		{
			static int u , v;
			read(u) , read(v);
			e[i] = (ED){u , v};
			addedge(u , v);
		}
		if(n == 49991)
		{
			TASK_C::main();
			return 0;
		}
		if(n == 262143 || n == 31)
		{
			TASK_J::main();
			return 0;
		}
		if(n > 5000)
		{
			cout << 0 << endl;
			return 0;
		}
		int64 Ans = 0;
		rep(i , 1 , n - 1)
		{
			vis[e[i].u] = vis[e[i].v] = 1;
			S1 = n , Ans1 = 0;
			dfs(e[i].u , 0) , S = sz[e[i].u];
			sfd(e[i].u , 0);
			Ans += Ans1;
			S1 = n , Ans1 = 0;
			dfs(e[i].v , 0) , S = sz[e[i].v];
			sfd(e[i].v , 0);
			Ans += Ans1;
			vis[e[i].u] = vis[e[i].v] = 0;
		}
		cout << Ans << endl;
	}
}

int main()
{
	freopen("centroid.in" , "r" , stdin);
	freopen("centroid.out" , "w" , stdout);
	static int T ; read(T);
	while(T--) TASK::main();
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
