#include <bits/stdc++.h>

using namespace std;

#define rep(i , l , r) for(int i = (l) , ___ = (r) ; i <= ___ ; ++i)
#define per(i , r , l) for(int i = (r) , ___ = (l) ; i >= ___ ; --i)

template<typename T>inline T read(T &f)
{
	f = 0 ; int x = 1 ; char c = getchar();
	while(!isdigit(c)) x = c == '-' ? -1 : 1 , c = getchar();
	while(isdigit(c)) (f *= 10) += c & 15 , c = getchar();
	return f *= x;
}

template<typename T>inline int chkmin(T &x , const T &y) { return x > y ? x = y , 1 : 0 ;}
template<typename T>inline int chkmax(T &x , const T &y) { return x < y ? x = y , 1 : 0 ;}

const int N = 100 + 5 , M = 2000 + 5 , KCZ = 998244353;

int n , m , A[N][M] , S[N];

inline int inc(const int &x) { return x >= KCZ ? x - KCZ : x; }
inline int dec(const int &x) { return x < 0 ? x + KCZ : x; }

inline void add(int &x , const int &y) { x = inc(x + y); }
inline void sub(int &x , const int &y) { x = dec(x - y); }

int f[N][N] , g[2][N][N];

int main()
{
	freopen("meal.in" , "r" , stdin);
	freopen("meal.out" , "w" , stdout);
	read(n) , read(m);
	rep(i , 1 , n)
	{
		rep(j , 1 , m)
		{
			read(A[i][j]) , add(S[i] , A[i][j]);
		}
	}
	f[0][0] = 1;
	rep(i , 1 , n)
	{
		rep(j , 0 , i)
		{
			f[i][j] = f[i - 1][j];
			if(j > 0) add(f[i][j] , 1ll * f[i - 1][j - 1] * S[i] % KCZ);
		}
	}
	int Ans = 0;
	rep(i , 1 , n) add(Ans , f[n][i]);
	rep(x , 1 , m)
	{
		rep(i , 0 , n)
		rep(j , 0 , i) g[0][i][j] = g[1][i][j] = 0;
		g[0][0][0] = 1;
		int cur = 0;
		rep(i , 1 , n)
		{
			cur ^= 1;
			rep(j , 0 , i)
			rep(k , 0 , j)
			{
				g[cur][j][k] = g[cur ^ 1][j][k];
				if(j > 0) add(g[cur][j][k] , 1ll * g[cur ^ 1][j - 1][k] * dec(S[i] - A[i][x]) % KCZ);
				if(k > 0) add(g[cur][j][k] , 1ll * g[cur ^ 1][j - 1][k - 1] * A[i][x] % KCZ);
			}
		}
		rep(j , 0 , n)
		{
			int d = (j / 2) + 1;
			rep(k , d , j)
			{
				sub(Ans , g[cur][j][k]);
			}
		}
	}
	cout << Ans << endl;
	return 0;
}
