#include <bits/stdc++.h>

using namespace std;

#define rep(i , l , r) for(int i = (l) , ___ = (r) ; i <= ___ ; ++i)
#define per(i , r , l) for(int i = (r) , ___ = (l) ; i >= ___ ; --i)

template<typename T>inline T read(T &f)
{
	f = 0 ; int x = 1 ; char c = getchar();
	while(!isdigit(c)) x = c == '-' ? -1 : 1 , c = getchar();
	while(isdigit(c)) (f *= 10) += c & 15 , c = getchar();
	return f *= x;
}

template<typename T>inline int chkmin(T &x , const T &y) { return x > y ? x = y , 1 : 0 ;}
template<typename T>inline int chkmax(T &x , const T &y) { return x < y ? x = y , 1 : 0 ;}

const int N = 5000 + 5;

int n , type , A[N];

typedef long long int64;

const int64 INF = 1ll << 62;

int64 S[N] , f[N][N] , g[N][N] , h[N][N];

inline int64 sq(const int64 &x)
{
	return x * x;
}

int main()
{
	freopen("partition.in" , "r" , stdin);
	freopen("partition.out" , "w" , stdout);
	read(n) , read(type);
	rep(i , 1 , n)
	{
		read(A[i]) , S[i] = S[i - 1] + A[i];
	}
	rep(i , 0 , n)
	rep(j , 0 , i) f[i][j] = INF;
	f[0][0] = 0;
	rep(i , 1 , n)
	{
		f[i][0] = sq(S[i]);
		g[i][0] = 2ll * S[i];
		rep(j , 1 , i - 1)
		{
			int l = 0 , r = j - 1 , ret = -1 , mid;
			while(l <= r)
			{
				mid = (l + r) >> 1;
				if(g[j][mid] <= S[i])
				{
					ret = mid , r = mid - 1;
				}
				else
				{
					l = mid + 1;
				}
			}
			// cerr << i << ' ' << j << ' ' << ret << endl;
			g[i][j] = 2ll * S[i] - S[j];
			if(ret == -1 || h[j][ret] == INF)
			{
				continue;
			}
			f[i][j] = h[j][ret] + sq(S[i] - S[j]);
			// cerr << f[i][j] << endl;
		}
		h[i][i] = INF;
		per(j , i - 1 , 0) h[i][j] = h[i][j + 1] , chkmin(h[i][j] , f[i][j]);
	}
//	rep(i , 1 , n)
//	{
//		rep(j , 0 , i) cout << (f[i][j] == INF ? -1 : f[i][j]) << ' ';
//		cout << endl;
//	}
	int64 Ans = INF;
	rep(j , 0 , n - 1) chkmin(Ans , f[n][j]);
	cout << Ans << endl;
	return 0;
}

