#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <iostream>
#include <algorithm>
using namespace std;
typedef long long ll;

template <typename Tp> inline void getint(Tp &num){
	register int ch, neg = 0;
	while(!isdigit(ch = getchar())) if(ch == '-') neg = 1;
	num = ch & 15;
	while(isdigit(ch = getchar())) num = num * 10 + (ch & 15);
	if(neg) num = -num;
}

int n, m;
ll a[105][2005], f[2005][105][105], g[105][105];

int main(){
	freopen("meal.in", "r", stdin), freopen("meal.out", "w", stdout);
	getint(n), getint(m);
	for(register int i = 1; i <= n; i++)
		for(register int j = 1; j <= m; j++) getint(a[i][j]);
	for(register int t = 0; t <= n; t++) f[0][0][t] = 1;
	for(register int i = 1; i <= m; i++){
		memset(g, 0, sizeof(g));
		for(register int k = 0; k <= n; k++) g[k][0] = 1;
		for(register int j = 1; j <= n; j++)
			for(register int k = j; k <= n; k++)
				g[k][j] = g[k - 1][j] + g[k - 1][j - 1] * a[k][i];
		for(register int j = 0, k; j <= n; j++){
			for(k = j; j - k <= (j >> 1); k--)
				f[i][j][j] = f[i][j][j] + f[i - 1][k][j] * g[n][j - k];
			for(register int t = j + 1; t <= n; t++)
				if(k < 0 || j - k > (t >> 1)) f[i][j][t] = f[i][j][t - 1];
				else f[i][j][t] = f[i][j][t - 1] + f[i - 1][k][t] * g[n][j - k], k--;
		}
	}
	register ll ans = 0;
	for(register int i = 1; i <= n; i++) ans = ans + f[m][i][i];//, printf("%lld\n", f[m][i][i]);
	return printf("%lld\n", ans), 0;
}
