#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define file "centroid"
const int maxn=300002;
int read(){
	char c=getchar();
	while(c<'0' || c>'9')
		c=getchar();
	int x=0;
	while(c>='0' && c<='9'){
		x=x*10+c-'0';
		c=getchar();
	}
	return x;
}
struct segtree{
	int tag[maxn*4],mx[maxn*4];
	void init(int n){
		for(int i=1;i<=n*4;i++)
			tag[i]=mx[i]=0;
	}
	int ul,ur,uv;
	void add(int o,int l,int r){
		if (ul<=l && ur>=r){
			tag[o]+=uv;
			mx[o]+=uv;
			return;
		}
		int mid=(l+r)/2;
		if (ul<=mid)
			add(o*2,l,mid);
		if (ur>mid)
			add(o*2+1,mid+1,r);
		mx[o]=(mx[o*2]>mx[o*2+1]?mx[o*2]:mx[o*2+1])+tag[o];
	}
	struct node{
		bool fl;
		int o,v;
	}a[maxn];
	int cur;
	void add2(int o,int l,int r){
		if (ul<=l && ur>=r){
			tag[o]+=uv;
			mx[o]+=uv;
			a[++cur].fl=0;
			a[cur].o=o,a[cur].v=uv;
			return;
		}
		int mid=(l+r)/2;
		if (ul<=mid)
			add2(o*2,l,mid);
		if (ur>mid)
			add2(o*2+1,mid+1,r);
		a[++cur].fl=1;
		a[cur].o=o,a[cur].v=mx[o];
		mx[o]=(mx[o*2]>mx[o*2+1]?mx[o*2]:mx[o*2+1])+tag[o];
	}
	void clear(){
		for(register int i=cur;i;i--){
			if (a[i].fl)
				mx[a[i].o]=a[i].v;
			else mx[a[i].o]-=a[i].v,tag[a[i].o]-=a[i].v;
		}
	}
	int qr,qv; //last >=qv
	int query2(int o,int l,int r,int tg){
		if (mx[o]+tg<qv)
			return 0;
		if (l==r)
			return l;
		int mid=(l+r)/2;
		int ans=query2(o*2+1,mid+1,r,tg+tag[o]);
		if (ans)
			return ans;
		return query2(o*2,l,mid,tg+tag[o]);
	}
	int query(int o,int l,int r,int tg){
		if (mx[o]+tg<qv)
			return 0;
		if (l==r)
			return l;
		int mid=(l+r)/2;
		if (qr<=mid)
			return query(o*2,l,mid,tg+tag[o]);
		int ans=query(o*2+1,mid+1,r,tg+tag[o]);
		if (ans)
			return ans;
		else return query2(o*2,l,mid,tg+tag[o]);
	}
}t;
struct graph{
	int n,m;
	struct edge{
		int to,next;
	}e[maxn*2];
	int first[maxn];
	void addedge(int from,int to){
		e[++m]=(edge){to,first[from]};
		first[from]=m;
	}
	void init(int n){
		this->n=n;
		m=0;
		memset(first,0,(n+1)*4);
	}
	int dep[maxn],sz[maxn],top[maxn],st[maxn],en[maxn],fa[maxn],son[maxn],dfn[maxn];
	void dfs(int u){
		sz[u]=1;
		son[u]=0;
		for(int i=first[u];i;i=e[i].next){
			int v=e[i].to;
			if (v==fa[u])
				continue;
			fa[v]=u;
			dep[v]=dep[u]+1;
			dfs(v);
			sz[u]+=sz[v];
			if (sz[v]>sz[son[u]])
				son[u]=v;
		}
	}
	int cl;
	void dfs2(int u,int tp){
		top[u]=tp;
		st[u]=++cl;
		dfn[cl]=u;
		if (son[u])
			dfs2(son[u],tp);
		for(int i=first[u];i;i=e[i].next){
			int v=e[i].to;
			if (v!=fa[u] && v!=son[u])
				dfs2(v,v);
		}
		en[u]=cl;
	}
	void prep(){
		t.init(n);
		dfs(1);
		cl=0;
		dfs2(1,1);
		for(int i=1;i<=n;i++){
			t.ul=t.ur=st[i],t.uv=sz[i];
			t.add(1,1,n);
		}
	}
	ll work(){
		ll ans=0;
		for(int i=2;i<=n;i++){
			t.qr=en[i],t.qv=(sz[i]+1)/2;
			int p=dfn[t.query(1,1,n,0)];
			ans+=p;
//			printf("on %d ans1=%d\n",i,p);
//			printf("%d %d %d\n",sz[i],sz[p]==sz[i]/2,sz[i]%2==0);
			if ((sz[i]%2==0) && (sz[p]==sz[i]/2)){
				ans+=fa[p];
//				printf("on %d ans2=%d\n",i,fa[p]);
			}
		}
//		fprintf(stderr,"WTF\n");
		for(int i=2;i<=n;i++){
			int u=i;
//			fprintf(stderr,"i=%d WTF\n",i);
			t.cur=0;
			while(u){
				t.ul=st[top[u]],t.ur=st[u],t.uv=-sz[i];
//				fprintf(stderr,"%d %d %d\n",t.ul,t.ur,t.uv);
				t.add2(1,1,n);
				u=fa[top[u]];
			}
//			fprintf(stderr,"i=%d WTF\n",i);
			u=i;
			t.qr=n,t.qv=(n-sz[u]+1)/2;
			int p=dfn[t.query(1,1,n,0)];
//			printf("on %d p=%d\n",i,p);
			if (st[p]>=st[u] && st[p]<=en[u]){
				t.qr=st[u]-1,t.qv=(n-sz[u]+1)/2;
				p=dfn[t.query(1,1,n,0)];
			}
//			printf("on %d p=%d\n",i,p);
//			fprintf(stderr,"i=%d WTF\n",i);
			ans+=p;
			int qwq=sz[p];
			if (st[p]<=st[u] && en[p]>=st[u])
				qwq-=sz[u];
			if (((n-sz[u])%2==0) && (qwq==(n-sz[u])/2)){
				ans+=fa[p];
//				printf("fa[p]=%d\n",fa[p]);
			}
			/*while(u){
				t.ul=st[top[u]],t.ur=st[u],t.uv=sz[i];
//				fprintf(stderr,"%d %d %d\n",t.ul,t.ur,t.uv);
				t.add(1,1,n);
				u=fa[top[u]];
			}*/
			t.clear();
		}
		return ans;
	}
}g;
int main(){
	freopen(file".in","r",stdin);
	freopen(file".out","w",stdout);
	int T=read();
	while(T--){
		int n=read();
		g.init(n);
		for(int i=1;i<n;i++){
			int u=read(),v=read();
			g.addedge(u,v);
			g.addedge(v,u);
		}
//		fprintf(stderr,"WTF\n");
		g.prep();
//		fprintf(stderr,"WTF\n");
		printf("%lld\n",g.work());
//		fprintf(stderr,"WTF\n");
	}
//	fprintf(stderr,"%.5f\n",1.0*clock()/CLOCKS_PER_SEC);
}
