#include<cstdio>
using namespace std;
int t=0,n=0,u=0,v=0,ans=0;
int nodetot[300000]={},fa[300000]={};
struct edge
{
	int to,next;
};
edge e[600000]={};
int head[300000]={},cnt=0;
void addedge(int from,int to)
{
	e[cnt].to=to;
	e[cnt].next=head[from];
	head[from]=cnt;
	cnt++;
}
int init(int node,int from)
{
	nodetot[node]=1;
	fa[node]=from;
	for(int i=head[node];i!=-1;i=e[i].next)
	{
		if(e[i].to!=from)
		{
			nodetot[node]+=init(e[i].to,node);
		}
	}
	return nodetot[node];
}
int dfs(int node,int from,int lim,int root)
{
	int res=0,nds=0,tot=1;
	bool ok=true;
	for(int i=head[node];i!=-1;i=e[i].next)
	{
		if(e[i].to==from)continue;
		if(nodetot[e[i].to]>nodetot[node])
			nds=nodetot[root]-nodetot[node];
		else
			nds=nodetot[e[i].to];
		if(nds>lim/2)ok=false;
		tot+=nds;
		if(e[i].to!=from)
			res+=dfs(e[i].to,node,lim,root);
	}
	if(lim-tot>lim/2)ok=false;
	if(ok)
		res+=node+1;
	return res;
}
int centre(int node,int cannot)
{
	int lim=nodetot[node],res=0,root=0;
	if(lim>nodetot[cannot])lim=n-nodetot[cannot];
	root=node;
	while(fa[root]!=root&&fa[root]!=cannot)
		root=fa[root];
	res=dfs(node,cannot,lim,root);
	return res;
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d",&n);
		cnt=0;
		ans=0;
		for(int i=0;i<n;i++)head[i]=-1;
		for(int i=0;i<n-1;i++)
		{
			scanf("%d%d",&u,&v);u--,v--;
			addedge(u,v);
			addedge(v,u);
		}
		init(0,0);
		for(int i=0;i<n-1;i++)
		{
			u=e[2*i+1].to;
			v=e[2*i+0].to;
			ans+=centre(u,v)+centre(v,u);
		}
		printf("%d\n",ans);
	}
	return 0;
}
