#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn=300005;
int n,he[maxn],ne[maxn<<1],to_[maxn<<1],tot,sz[maxn],id_[maxn<<1];
int hson[maxn],shson[maxn];
ll ans,tr[maxn<<1];
inline void add_edge(int u,int v) { to_[tot]=v,ne[tot]=he[u],he[u]=tot++; }
#define lowbit(x) ((x)&-(x))
inline void update(int x,ll y)
{
    for(;x<=n;x+=lowbit(x))
        tr[x]+=y;
}
inline ll query(int x)
{
    ll res=0;
    if(x>=n) x=n;
    for(;x;x-=lowbit(x))
        res+=tr[x];
    return res;
}
void initdfs(int u,int fa)
{
    int i;
    sz[u]=1,hson[u]=shson[u]=0,id_[++tot]=u;
    for(i=he[u];i!=-1;i=ne[i])
        if(to_[i]!=fa)
        {
            initdfs(to_[i],u);
            sz[u]+=sz[to_[i]];
            if(sz[to_[i]]>=sz[hson[u]]) shson[u]=hson[u],hson[u]=to_[i];
            else if(sz[to_[i]]>sz[shson[u]]) shson[u]=to_[i];
        }
    id_[++tot]=-u;
}
void solve1(int u,int fa)
{
    int i,maxx,v;
    ans+=query(sz[u]);
    for(i=he[u];i!=-1;i=ne[i])
        if(to_[i]!=fa)
        {
            v=to_[i];
            if(v==hson[u]) maxx=sz[shson[u]];
            else maxx=sz[hson[u]];
            maxx=max(maxx,n-sz[u]);
            if(n-2*maxx>=0 && 2*sz[v]-n<=n-2*maxx)
            {
                update(max(2*sz[v]-n,1),u);
                update(n-2*maxx+1,-u);
            }
            solve1(v,u);
            if(n-2*maxx>=0 && 2*sz[v]-n<=n-2*maxx)
            {
                update(max(2*sz[v]-n,1),-u);
                update(n-2*maxx+1,u);
            }
        }
}
void solve2(int u,int fa)
{
    int i;
    if(fa!=-1 && sz[u]>=2*sz[hson[u]]) ans+=u;
    ans+=(query(2*sz[u])-query(max(0,2*sz[hson[u]]-1)))*u;
    if(fa!=-1) update(sz[u],1);
    for(i=he[u];i!=-1;i=ne[i])
        if(to_[i]!=fa)
            solve2(to_[i],u);
    if(fa!=-1) update(sz[u],-1);
}
void solve3(int u,int fa)
{
    int i;
    if(fa!=-1) update(n-sz[u],1);
    ans-=(query(2*sz[u])-query(max(0,2*sz[hson[u]]-1)))*u;
    for(i=he[u];i!=-1;i=ne[i])
        if(to_[i]!=fa)
            solve3(to_[i],u);
    if(fa!=-1) update(n-sz[u],-1);
}
inline void solve()
{
    int i,u,v;
    scanf("%d",&n);
    for(tot=0,i=1;i<=n;i++) he[i]=-1;
    for(i=1;i<n;i++)
        scanf("%d%d",&u,&v),add_edge(u,v),add_edge(v,u);
    sz[0]=0,tot=0,initdfs(1,-1);
    ans=0;
    for(i=1;i<=n;i++) tr[i]=0;
    solve1(1,-1);
    for(i=1;i<=2*n;i++) tr[i]=0;
    solve2(1,-1);
    for(i=1;i<=2*n;i++) tr[i]=0;
    for(i=2;i<=n;i++) update(n-sz[i],1);
    for(i=2;i<=n;i++) ans+=(query(2*sz[i])-query(max(2*sz[hson[i]]-1,0)))*i;
    for(i=1;i<=2*n;i++) tr[i]=0;
    solve3(1,-1);
    for(i=1;i<=2*n;i++) tr[i]=0;
    for(i=1;i<=2*n;i++)
    {
        u=abs(id_[i]);
        if(id_[i]>0)
        {
            if(u!=1) update(n-sz[u],1);
            if(u!=1) ans+=(query(2*sz[u])-query(max(0,2*sz[hson[u]]-1)))*u;
        }
        if(id_[i]<0 && u!=1) ans-=(query(2*sz[u])-query(max(0,2*sz[hson[u]]-1)))*u;
    }
    printf("%lld\n",ans);
}
int main()
{
    int T;
    freopen("centroid.in","r",stdin),freopen("centroid.out","w",stdout);
    scanf("%d",&T);
    while(T--) solve();
    fclose(stdin),fclose(stdout);
    return 0;
}

