#include<bits/stdc++.h>
const int maxn = 300035;
const int maxm = 600035;

int T,n,u[maxn],v[maxn],son[maxn],stk[maxn],top;
int bloTot,size[maxn],id,mson;
long long ans;
bool tag[maxn];
int edgeTot,head[maxn],nxt[maxm],edges[maxm],deg[maxn];

void addedge(int u, int v)
{
	edges[++edgeTot] = v, nxt[edgeTot] = head[u], head[u] = edgeTot;
	edges[++edgeTot] = u, nxt[edgeTot] = head[v], head[v] = edgeTot;
}
void count(int x, int fa)
{
	++bloTot;
	for (int i=head[x]; i!=-1; i=nxt[i])
	{
		int v = edges[i];
		if (v!=fa&&(!tag[x]||!tag[v])) count(v, x);
	}
}
void getRoot(int x, int fa)
{
	size[x] = 1, son[x] = 0;
	for (int i=head[x]; i!=-1; i=nxt[i])
	{
		int v = edges[i];
		if (v!=fa&&(!tag[x]||!tag[v])){
			getRoot(v, x), size[x] += size[v];
			son[x] = std::max(son[x], size[v]);
		}
	}
	son[x] = std::max(son[x], bloTot-size[x]);
	if (son[x] < mson) mson = son[x], id = x;
	else if (son[x]==mson) id += x;
}
void makeans(int x)
{
	bloTot = 0;
	count(x, x);
	id = 0, mson = bloTot, getRoot(x, x);
	ans += id;
}
bool chainChk;
int ptchain;
void fndChain(int x, int fa)
{
	stk[++top] = x;
	for (int i=head[x]; i!=-1; i=nxt[i])
	{
		int v = edges[i];
		if (v==fa) continue;
		fndChain(v, x);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	for (scanf("%d",&T); T; --T)
	{
		scanf("%d",&n);
		for (int i=1; i<=n; i++) head[i] = -1, deg[i] = 0;
		edgeTot = ans = 0, chainChk = true, ptchain = -1;
		for (int i=1; i<n; i++)
		{
			scanf("%d%d",&u[i],&v[i]), addedge(u[i], v[i]);
			++deg[u[i]], ++deg[v[i]];
			if (deg[u[i]] > 2||deg[v[i]] > 2) chainChk = false;
		}
		if (chainChk){
			for (int i=1; i<=n; i++)
				if (deg[i]==1) ptchain = i;
//			printf("ptchain:%d\n",ptchain);
			top = 0;
			fndChain(ptchain, ptchain);
			for (int i=1; i<n; i++)
			{
				if (i&1) ans += stk[(i+1)>>1];
				else ans += stk[i>>1]+stk[(i>>1)+1];
				if ((n-i)&1) ans += stk[(i+n)/2+1];
				else ans += stk[(i+n)/2]+stk[(i+n)/2+1];
			}
		}else{
			for (int i=1; i<n; i++)
			{
				tag[u[i]] = tag[v[i]] = true;
				makeans(u[i]);
				makeans(v[i]);
				tag[u[i]] = tag[v[i]] = false;
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}
