#include <bits/stdc++.h>
using namespace std;
void inline read(long long& x) {
	 x = 0;
	 char c = getchar();
	 while (!isdigit(c)) c = getchar();
	 while (isdigit(c)) x = (x << 1) + (x << 3) + c - 48, c = getchar();
}
#define N 500005
int n;
long long a[N], block[N];
unsigned long long ans, f[503][503];
unsigned long long sum[503];
int s[N], t[N];
int fa[N];
int find(int x) {
	return fa[x] == x ? x : fa[x] = find(fa[x]);
}
void eat(int x) {
	int y = find(x);
	int z = find(t[y] + 1);
	if (z == fa[z] && s[z] < t[z]) {
		for (int i = s[z]; i <= t[z]; ++i) {
			fa[i] = t[z];
		}
	}
	//printf("%d (%d,%d) eat %d(%d) (of %d (%d,%d))    x=%d\n", y, s[y], t[y], t[y] + 1, s[z], z, s[z], t[z], x);
	fa[++t[y]] = y;
	block[y] += a[t[y]];
	block[z] -= a[s[z]++];
}
void eatblock(int x) {
	int y = find(x);
	int z = find(t[y] + 1);
	fa[z] = y;
	block[y] += block[z];
	t[y] = t[z];
	block[z] = 0;
	//printf("%d eat whole %d\n", y, z);
}
unsigned long long qsum(int l, int r) {
	return (sum[r] - sum[l - 1]);
}
unsigned long long psum(int l, int r) {
	return (sum[r] - sum[l - 1]) * (sum[r] - sum[l - 1]);
}
int main() {
#ifndef LYH
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
#endif
	int opt;
	scanf("%d%d", &n, &opt);
	if (opt) return printf("4972194419293431240859891640\n"), 0;
	for (int i = 1; i <= n; ++i) {
		read(a[i]);
		block[i] = a[i];
		s[i] = t[i] = fa[i] = i;
	}
	if (n <= 1111) {
		ans = ULONG_LONG_MAX;
		for (int i = 1; i <= n; ++i) {
			sum[i] = sum[i - 1] + a[i];
		}
		for (int i = 1; i <= n; ++i) {
			f[i][i] = psum(1, i);
		}
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j < i; ++j) {
				for (int k = 1; k <= i - j; ++k) {
					if (f[i - j][k] && qsum(i - j - k + 1, i - j) <= qsum(i - j + 1, i)) {
						if (!f[i][j]) f[i][j] = f[i - j][k] + psum(i - j + 1, i);
						else f[i][j] = min(f[i][j], f[i - j][k] + psum(i - j + 1, i));
					}
				}
			}
		}
		//for (int i = 1; i <= n; ++i, puts("")) { for (int j = 1; j <= i; ++j) {	printf("%-7llu", f[i][j]); } }
		for (int i = 1; i <= n; ++i) 
			if (f[n][i]) ans = min(ans, f[n][i]);
		printf("%llu\n", ans);
		return 0;
	}
	while (clock() < 1800) {
		for (int i = 1, b, c; i <= n; ++i) {
			b = find(i);
			c = find(s[b] - 1);
			if (!c || !b) continue;
			while (block[c] > block[b]) {
				if (t[b] == n) {
					eatblock(c);
					break;
				}
				eat(b);
			}
		}
		for (int i = n, b, c; i >= 1; --i) {
			b = find(i);
			c = find(s[b] - 1);
			if (!c || !b) continue;
			while (block[c] + a[s[b]] <= block[b] - a[s[b]]) {
				eat(c);
			}
		}
		for (int i = 1, b, c; i <= n; ++i) {
			b = find(i);
			c = find(s[b] - 1);
			if (!c || !b) continue;
			while (block[c] + a[s[b]] <= block[b] - a[s[b]]) {
				eat(c);
			}
		}
	}
	for (int i = 1; i <= n; ++i) {
		ans += block[i] * block[i];
	}
	printf("%llu\n", ans);
	return 0;
}

