#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#define P 998244353
#define N 300010
using namespace std;
typedef long long LL;
int n,T,fi[N],ne[N<<1],b[N<<1],E,siz[N],fa[N],deg[N];
void dfs(int u,int pre){
	siz[u]=1,fa[u]=pre;
	for(int i=fi[u];i;i=ne[i]){
		int v=b[i];
		if(v==pre)continue;
		dfs(v,u);
		siz[u]+=siz[v];
	}
}
namespace subtask1{
	LL ans;
	int son[2010],sum,Siz[2010];
	void getroot(int u,int pre,int ban){
		Siz[u]=1;
		for(int i=fi[u];i;i=ne[i]){
			int v=b[i];
			if(v==pre||v==ban)continue;
			getroot(v,u,ban);
			son[u]=max(son[u],Siz[v]);
			Siz[u]+=Siz[v];
		}
		son[u]=max(son[u],sum-Siz[u]);
		if(son[u]<=sum/2)ans+=u;
	}
	void solve(){
		ans=0;
		for(int i=2;i<=n;i++){
			memset(son,0,sizeof(son));
			sum=siz[i];
			getroot(i,fa[i],0);
			sum=n-siz[i];
			getroot(1,0,i);
		}
		printf("%lld\n",ans);
	}
}
namespace subtask2{
	int p[N],cnt;
	void dfs(int u,int pre){
		cnt++,p[cnt]=u;
		for(int i=fi[u];i;i=ne[i]){
			int v=b[i];
			if(v==pre)continue;
			dfs(v,u);
		}
	}
	void solve(){
		cnt=0; LL ans=0;
		int L1=0,L2=0;
		for(int i=1;i<=n;i++)
		if(deg[i]==1)if(!L1)L1=i;else L2=i;
		dfs(L1,0);
//		for(int i=1;i<=n;i++)printf("%d ",p[i]);puts("");
		for(int i=1;i<n;i++){
			//[1,i]+[i+1,n]
			if(i&1)ans+=p[i/2+1];
			else ans+=p[i/2]+p[i/2+1];
			if((n-i)&1)ans+=p[(n+i)/2+1];
			else ans+=p[(n+i)/2]+p[(n+i)/2+1];
//			puts("");
		}
		printf("%lld\n",ans);
	}
}
namespace subtask3{
	int Siz[N],son[N],rt;
	void getroot(int u,int pre){
		Siz[u]=1;
		for(int i=fi[u];i;i=ne[i]){
			int v=b[i];
			if(v==pre)continue;
			getroot(v,u);
			son[u]=max(son[u],Siz[v]);
			Siz[u]+=Siz[v];
		}
		son[u]=max(son[u],n-Siz[u]);
		if(son[u]<=n/2)rt=u;
	}
	void solve(){
		memset(son,0,sizeof(son));
		getroot(1,0);
		int lc=0,rc=0;
		for(int i=fi[rt];i;i=ne[i]){
			int v=b[i];
			if(!lc)lc=v;else rc=v;
		}
//		cout<<rt<<" "<<lc<<" "<<rc<<endl;
		LL ans=1ll*lc*(n-1)/2+1ll*rc*(n-1)/2+1ll*rt*(n+1)/2;
		ans=(ans+1ll*n*(n+1)/2-rt);
		printf("%lld\n",ans);
	}
}
void clear(){
	memset(fi,0,sizeof(fi)),E=0;
	memset(deg,0,sizeof(deg));
}
void add(int x,int y){
	ne[++E]=fi[x],fi[x]=E,b[E]=y;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		bool flag1=1,flag2=1;
		clear();
		scanf("%d",&n);
		for(int i=1;i<n;i++){
			int x,y;
			scanf("%d%d",&x,&y);
			add(x,y),add(y,x);
			deg[x]++,deg[y]++;
			if(deg[x]>2||deg[y]>2)flag1=0;
//			cout<<x<<" "<<deg[x]<<endl;
		}
		dfs(1,0);
		if(n<=2000)subtask1::solve();
		else if(flag1)subtask2::solve();
		else subtask3::solve();
	}
	return 0;
}
