#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 51, M = 51 * 51 / 2;
int n, m;
ll f[N][M], a[N], all[M], qz[N];

ll pf(ll x) {
  return x * x;
}

int get(ll x) {
  return lower_bound(all + 1, all + 1 + m, x) - all;
}

namespace task1 {
  const int N = 5e5 + 10;
  ll a[N], qz[N];
  
  bool check(int x) {
    ll lt = 0;
    int ans = 0;
    for(int i = 1; i <= n; ++i) {
      int be = 0;
      for(int j = i; j <= n; ++j) {
        if(qz[j] - qz[i - 1] >= lt) {
          be = j;
          break;
        }
      }
      if(be) {
        ans++;
        lt = qz[be] - qz[i - 1];
        i = be;
      } else return ans >= x;
    }
    return ans >= x;
  }
  
  int judge(ll lt, int be) {
    int now = 0;
    for(int i = be; i <= n; ++i) {
      int nw = 0;
      for(int j = be; j <= n; ++j) {
        if(qz[j] - qz[i - 1] >= lt) {
          nw = j;
          break;
        }
      }
      if(nw) {
       now++;
       lt = qz[nw] - qz[i - 1]; 
       i = nw;
      } else {
        return now;
      }
    }
    return now;
  }
  
  void solve() {
    for(int i = 1; i <= n; ++i) {
      scanf("%lld", &a[i]);      
      qz[i] = qz[i - 1] + a[i];
    }
    int l = 1, r = n, ans = 0;
    while(l <= r) {
      int mid = (l + r) >> 1;
      if(check(mid)) ans = mid, l = mid + 1;
      else r = mid - 1;
    }
    int now = 0;
    ll da = 0, lt = 0;
    for(int i = 1; i <= n; ++i) {
      for(int j = n; j >= i; --j) {
        if(qz[j] - qz[i - 1] >= lt && now + 1 + judge(qz[j] - qz[i - 1], j + 1) == ans) {
          da += (qz[j] - qz[i - 1]) * (qz[j] - qz[i - 1]);
          now++;
          lt = qz[j] - qz[i - 1];
          i = j;
          break;
        }
      }
    }
    printf("%lld\n", da);
  }
}

namespace task2 {
  void solve() {
    ll ans = 0;
    for(int i = 1; i <= n; ++i) {
      ll x;
      scanf("%lld", &x);
      ans += x;
    }
    printf("%lld\n", ans * ans);
  }
}

int main() {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
  int tp;
  scanf("%d%d", &n, &tp);
  if(n <= 50) {
    for(int i = 1; i <= n; ++i) {
      scanf("%lld", &a[i]);
      qz[i] = qz[i - 1] + a[i];
    }
    int res = 0;
    for(int i = 1; i <= n; ++i) {
      ll pos = 0;
      for(int j = i; j <= n; ++j) {
        pos += a[j];
        all[++res] = pos;
      }
    }
    sort(all + 1, all + 1 + res);
    m = unique(all + 1, all + 1 + res) - all - 1;
  //  printf("%d %d\n", get(7), get(6));
    memset(f, 0x3f, sizeof f);
    f[0][0] = 0;
    for(int i = 1; i <= n; ++i) {
      ll pos = qz[i];
      f[i][get(pos)] = pf(pos);
      for(int j = 1; j < i; ++j) {
        ll tmp = qz[i] - qz[j];
        int id = get(tmp);
        for(int k = 1; k <= id; ++k) {
          f[i][id] = min(f[i][id], f[j][k] + pf(tmp));
        }
      }
  /*    for(int j = 1; j <= m; ++j) {
        if(f[i][j] != f[50][100])
          printf("f[%d][%d] = %lld\n", i, j, f[i][j]);
      }*/
    }
    ll ans = 1e18;
    for(int i = 1; i <= m; ++i) ans = min(ans, f[n][i]);
    printf("%lld\n", ans);
  } else if(n <= 5e5) {
    task1::solve();
  } else {
    task2::solve();
  }
  return 0;
}
