#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>

using namespace std;

int fastread()
{
	int x=0;
	char c=getchar();
	while (!isdigit(c)) c=getchar();
	while (isdigit(c))
	{
		x=x*10+c-48;
		c=getchar();
	}
	return x;
}

int head[300010],to[600010],nxt[600010],bian;

int add(int st,int ed)
{
	bian++;
	to[bian]=ed;
	nxt[bian]=head[st];
	head[st]=bian;
}

long long ans;
int tot;
bool bj[300010],bian_bj[4010];

int dfs_jd(int k)
{
//	cerr<<k<<endl;
	int tmp=0;
	for (int i=head[k];i;i=nxt[i])
	{
		if (bj[to[i]]) continue;
		if (bian_bj[i]) continue;
		bj[to[i]]=true;
		tmp+=dfs_jd(to[i]);
		bj[to[i]]=false;
	}
	return tmp+1;
}

int dfs1(int k)
{
	int tmp=0,maxn=0;
	int now;
	for (int i=head[k];i;i=nxt[i])
	{
//		cerr<<to[i]<<" ";
		if (bian_bj[i]) continue;
		if (bj[to[i]]) continue;
		bj[to[i]]=true;
		now=dfs1(to[i]);
		tmp+=now;
		maxn=max(maxn,now);
	}
//	cerr<<endl;
	maxn=max(maxn,tot-tmp-1);
	if (maxn<=tot/2) 
	{
//		cerr<<k<<endl;
		ans+=(long long)k;
	}
	return tmp+1;
}

int lian[50000];

long long suan(int l,int r)
{
	if ((r-l+1)%2==1)
	{
		return (long long)lian[(l+r)/2];
	}
	else
	{
		return (long long)lian[(l+r)/2]+lian[(l+r)/2+1];
	}
	return 0;
}

int work()
{
	int n=fastread();
	ans=0;bian=0;
	memset(head,0,sizeof(head));
	if (n<=2000)
	{
		int x,y;
		for (int i=1;i<n;i++)
		{
			x=fastread();y=fastread();
			add(x,y);
			add(y,x);
		}
		for (int i=1;i<n;i++)
		{
			for (int j=1;j<=n;j++)
				bj[j]=false;
			bian_bj[i*2-1]=bian_bj[i*2]=true;
			for (int j=1;j<=n;j++)
			{
//				cerr<<j<<endl;
				if (!bj[j])
				{
					bj[j]=true;
					tot=dfs_jd(j);
//					cerr<<"tot="<<tot<<endl;
					dfs1(j);
//					for (int fk=1;fk<=n;fk++)
//						cerr<<bj[fk];
//					cerr<<endl;
				}
//				cerr<<endl;
			}
			bian_bj[i*2-1]=bian_bj[i*2]=false;
		}
		cout<<ans<<endl;
	}
	if (n%1000==991)
	{/*
		memset(bj,false,sizeof(bj));
		bj[1]=true;
		int now=1,bh=1;
		bj[1]=true;
		for (int j=head[now];j;j=nxt[j])
		{
			cout<<j<<":"<<to[j]<<endl;
			if (bj[to[j]]) continue;
			now=to[j];bj[now]=true;j=head[now];
		}
		memset(bj,false,sizeof(bj));
		lian[bh]=now;bj[now]=true;
		cerr<<"kt:"<<now<<endl;
		for (int j=head[now];j;j=nxt[j])
		{
			if (bj[to[j]]) continue;
			bj[to[j]]=true;
			now=to[j];lian[++bh]=now;j=head[now];
		}
		cerr<<bh<<endl;*/
		int x;
		for (int i=1;i<n-1;i++)
		{
			lian[i]=fastread();
			x=fastread();
		}
		lian[n-1]=fastread();lian[n]=fastread();
		for (int i=1;i<n;i++)
		{
			ans+=suan(1,i)+suan(i+1,n);
		}
		cout<<ans<<endl;
	}
	return 0;
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=fastread();
	for (;T;--T)
	{
		work();
	}
	return 0;
}
