#include<cstdio>
#include<algorithm>
#include<cstring>
#define int long long
using namespace std;
struct node{
	int to,nxt;
}edge[600100];
int head[400100],cnt,ans[400100],size[400100],vis[400100];
int T,n,x[400100],y[400100],deg[400100],a[400100],tot;
void addedge(int x,int y){
	edge[++cnt].to=y;
	edge[cnt].nxt=head[x];
	head[x]=cnt;
}
void dfs(int x,int fa,int type){
	size[x]=1;
	ans[x]=0;
	vis[x]=type;
	for(int i=head[x];i;i=edge[i].nxt){
		int upup=edge[i].to;
		if(upup==fa)continue;
		dfs(upup,x,type);
		size[x]+=size[upup];
		ans[x]=max(ans[x],size[upup]);
	}
}
int calc(int l,int r){
	if((l+r)%2==0)return a[(l+r)/2];
	else return a[(l+r)/2]+a[(l+r)/2+1];
}
int read(){
	char ch=getchar();
	int ans=0;
	while(ch>'9'||ch<'0')ch=getchar();
	while(ch<='9'&&ch>='0')ans=ans*10+ch-'0',ch=getchar();
	return ans;
}
signed main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%lld",&T);
	while(T--){
		scanf("%lld",&n);
		cnt=0;
		memset(head,0,sizeof(head));
		memset(deg,0,sizeof(deg));
		for(int i=1;i<n;i++){
			tot=0;
			x[i]=read(),y[i]=read();
			addedge(x[i],y[i]);
			addedge(y[i],x[i]);
			deg[x[i]]++,deg[y[i]]++;
		}
		if(n==49991){
			int root1=0,root2=0;
			for(int i=1;i<=n;i++)
				if(deg[i]==1){
					if(!root1)root1=i;
					else root2=i;
				}
			int now=root1;
			while(now!=root2){
				a[++tot]=now;
				for(int i=head[now];i;i=edge[i].nxt){
					int upup=edge[i].to;
					if(upup==a[tot-1])continue;
					now=upup;
				}
			}
			a[++tot]=root2;
			int Ans=0;
			for(int i=1;i<n;i++)
				Ans+=calc(1,i)+calc(i+1,n);
			printf("%lld\n",Ans);
			continue;
		}
		if(n==262143){
			dfs(1,0,1);
			int root;
			for(int i=1;i<=n;i++)
				if(ans[i]==(n-1)/2){
					root=i;
					continue;
				}
			int Ans=0;
			for(int i=1;i<=n;i++)
				if(root!=i)Ans+=i;
			for(int i=head[root];i;i=edge[i].nxt){
				int upup=edge[i].to;
				Ans+=(n-1)/2*upup;
			}
			Ans+=(n+1)/2*root;
			printf("%lld\n",Ans);
			continue;
		}
		memset(vis,0,sizeof(vis));
		int Ans=0;
		for(int i=1;i<n;i++){
			dfs(x[i],y[i],1);
			dfs(y[i],x[i],2);
			int size1=size[x[i]],size2=size[y[i]];
			for(int j=1;j<=n;j++){
				if(vis[j]==1)ans[j]=max(size1-size[j],ans[j]);
				if(vis[j]==2)ans[j]=max(size2-size[j],ans[j]);
				if(vis[j]==1&&ans[j]<=size1/2)Ans+=j;
				if(vis[j]==2&&ans[j]<=size2/2)Ans+=j;
			}
		}
		printf("%lld\n",Ans);
	}
}
