#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int n,type;
ll a[500005];

namespace solve1{
	ll dp[405][405],INF=0x3f3f3f3f3f3f3f3f;
	void solve(){
		memset(dp,0x3f,sizeof dp);
		for (int i=1;i<=n;++i){
			for (int j=0;j<i;++j){
				if (j==0){
					dp[i][j]=a[i]*a[i];
					continue;
				}
				for (int k=0;k<j;++k){
					if (a[i]-a[j]>=a[j]-a[k]){
						dp[i][j]=min(dp[i][j],dp[j][k]+(a[i]-a[j])*(a[i]-a[j]));
					}
				}
			}
		}
		ll ans=INF;
		for (int i=0;i<=n;++i) ans=min(ans,dp[n][i]);
		cout<<ans<<endl;
	}
}

namespace solve2{
	ll dp[5005][5005],s[5005][5005],INF=0x3f3f3f3f3f3f3f3f;
	void solve(){
		memset(dp,0x3f,sizeof dp);
		memset(s,0x3f,sizeof s);
		for (int i=1;i<=n;++i){
			s[i][0]=dp[i][0]=a[i]*a[i];
			int now=0;
			for (int j=1;j<i;++j){
				while (now+1<j && a[i]-a[j]<a[j]-a[now]) now++;
				if (a[i]-a[j]>=a[j]-a[now]) dp[i][j]=min(dp[i][j],s[j][now]+(a[i]-a[j])*(a[i]-a[j]));
			}
			for (int j=i-1;j>=0;--j) s[i][j]=min(s[i][j+1],dp[i][j]);
		}
		ll ans=INF;
		for (int i=0;i<=n;++i) ans=min(ans,dp[n][i]);
		cout<<ans<<endl;
	}
}

namespace solve3{
	priority_queue <pair<ll,int> > q;
	ll dp[500005];
	void solve(){
		int now=0;
		for (int i=1;i<=n;++i){
			while (!q.empty() && -q.top().first<=a[i]){
				now=max(now,-q.top().second);
				q.pop();
			}
			dp[i]=max(dp[i],dp[now]+(a[i]-a[now])*(a[i]-a[now]));
			q.push(make_pair(-(a[i]+a[i]-a[now]),-i));
		}
		cout<<dp[n]<<endl;
	}
}

int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	cin>>n>>type;
	if (type==0){
		for (int i=1;i<=n;++i) scanf("%lld",&a[i]);
	}else return 0;
	for (int i=1;i<=n;++i) a[i]+=a[i-1];
	if (n<=400) solve1::solve();
	else if (n<=5000) solve2::solve();
	else solve3::solve();
	return 0;
}
