//Leo
#include <cstdio>
#include <iostream>
#include <cstring>
#include <algorithm>
#include <cmath>
#define N 100000
using namespace std;
int T,n,ans,cnt,vet[N+N],Next[N+N],head[N];
int flag[N],maxd[N],maxdd[N],f[N],siz[N],x[N],y[N],dlm[N];

inline int read()
{
	int x=0,f=1;char ch=getchar();
	while(ch<'0' || ch>'9'){if(ch=='-') f=-1;ch=getchar();}
	while(ch>='0' && ch<='9'){x=(x<<3)+(x<<1)+ch-'0';ch=getchar();}
	return x*f;
}

void add_edge(int u,int v)
{
	vet[++cnt]=v;Next[cnt]=head[u];head[u]=cnt;
}

void dfs1(int u,int fa)
{
	siz[u]=1;
	for(int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if(v==fa) continue;
		f[v]=u;
		dfs1(v,u);
		siz[u]+=siz[v];
	}
}

void dfs(int u,int fa)
{
	dlm[u]=1;
	for(int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if(v==fa) continue;
		dfs(v,u);
	}
}

void dfs2(int u,int fa)
{
	flag[u]=1;
	for(int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if(v==fa) continue;
		dfs2(v,u);
	}
}

int solve(int X,int Y,int id)
{
	if(((n-siz[Y]==1) && id) || ((siz[Y]==1) && !id))return X;
	
	for(int i=1;i<=n;i++) flag[i]=0;
	dfs2(X,0);
	int m=0,res=0;
	for(int i=1;i<=n;i++) if(flag[i]) m++;
	for(int u=1;u<=n;u++){
		if(!flag[u]) continue;
		bool P=true;
		for(int i=head[u];i;i=Next[i]){
			int v=vet[i];
			for(int j=1;j<=n;j++) dlm[j]=0;
			dfs(v,u);
			int num=0;
			for(int j=1;j<=n;j++) if(dlm[j]) num++;
			if(num>(int)(m/2)){P=false;break;}
		}
		if(P) res+=u;
	}
	return res;
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	while(T--){
		n=read();
		cnt=0;
		for(int i=1;i<=n;i++) head[i]=0;
		for(int i=1;i<n;i++){
			x[i]=read(),y[i]=read();
			add_edge(x[i],y[i]);
			add_edge(y[i],x[i]);
		}
		
		ans=0;
		dfs1(1,0);
		for(int i=1;i<n;i++){
			cnt=0;
			for(int j=1;j<=n;j++) head[j]=0;
			for(int j=1;j<n;j++)
				if(j != i){add_edge(x[j],y[j]);add_edge(y[j],x[j]);}
			ans+=solve(x[i],y[i],f[x[i]]==y[i] ? 0 : 1);
			ans+=solve(y[i],x[i],f[y[i]]==x[i] ? 0 : 1);
		}
		printf("%d\n",ans);
	}
	return 0;
}
