#include <bits/stdc++.h>
#define N 105
#define M 2019
#define mod 998244353
using namespace std;

int a[N][M], b[N], c[M];

int n, m;

int calc1() {
  long long total = 1, fix = 1;
  for (int i = 1; i <= n; ++ i) {
    total = total * ((long long) b[i] + 1) % mod;
    fix = (fix + b[i]) % mod;
  }
  return (total - fix + mod) % mod;
}

int f[N][M];

int calc2(int k, int j) {
  int result = 0;
  for (int i = floor(k / 2) + 1; i <= min(k, c[j]); ++ i) {
    result = (result + f[i][k - i]) % mod;
  }
  return result;
}

void dp(int j) {
  for (int i = 0; i <= n; ++ i) {
    memset(f[i], 0, sizeof f[i]);
  }
  f[0][0] = 1;
  for (int d = 1; d <= n; ++ d) {
    for (int fa = d; ~fa; -- fa) {
      for (int fb = d - fa; ~fb; -- fb) {
        if (fa) {
          f[fa][fb] = (f[fa][fb] + (long long) f[fa - 1][fb] * a[d][j] % mod) % mod;
        }
        if (fb) {
          f[fa][fb] = (f[fa][fb] + (long long) f[fa][fb - 1] * (b[d] - a[d][j] + mod) % mod) % mod;
        }
      }
    }
  }
}

int main() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);

  scanf("%d%d", &n, &m);
  for (int i = 1; i <= n; ++ i) {
    for (int j = 1; j <= m; ++ j) {
      scanf("%d", &a[i][j]);
      b[i] = (b[i] + a[i][j]) % mod;
      c[j] += (a[i][j] ? 1 : 0);
    }
  }

  int ans = calc1();
  // printf("calc1 = %d\n", ans);
  for (int j = 1; j <= m; ++ j) {
    dp(j);
    for (int i = 2; i <= n; ++ i) {
      ans = (ans - calc2(i, j) + mod) % mod;
    }
  }

  printf("%d\n", ans);
  return 0;
}
