#include <iostream>
#include <algorithm>

using namespace std;

const long long mod = 998244353;
int n, m, a[110][2010], f[2010];
long long ans = 0;

void dfs(int x, int len, long long tot, int Max)
{
	if (x > n)
	{
		if (Max + Max <= len)
			ans = (ans + tot) % mod;
		return;
	}
	for (int i = 1; i <= m; i++)
	{
		f[i]++;
		dfs(x + 1, len + 1, tot * a[x][i] % mod, max(Max, f[i]));
		f[i]--;
	}
	dfs(x + 1, len, tot, Max);
}

int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			cin >> a[i][j];
	dfs(1, 0, 1, 0);
	cout << (ans + mod - 1) % mod << endl;
	
	return 0;
}
