#include<cstdio>
#include<cstring>
using namespace std;
const int N = 5e3 + 10;
int fi[N], di[N << 1], ne[N << 1], si[N], f[N], l;
long long s;
bool v[N];
inline int re()
{
	int x = 0;
	char c = getchar();
	bool p = 0;
	for (; c < '0' || c > '9'; c = getchar())
		p |= c == '-';
	for (; c >= '0' && c <= '9'; c = getchar())
		x = x * 10 + c - '0';
	return p ? -x : x;
}
inline void add(int x, int y) { di[++l] = y; ne[l] = fi[x]; fi[x] = l; }
inline int maxn(int x, int y) { return x > y ? x : y; }
void dfs(int x, int fa, int bn)
{
	int i, y;
	si[x] = 1; f[x] = 0; v[x] = 1;
	for (i = fi[x]; i; i = ne[i])
		if ((i >> 1) ^ bn && (y = di[i]) ^ fa)
		{
			dfs(y, x, bn);
			si[x] += si[y];
			f[x] = maxn(f[x], si[y]);
		}
}
void dfs_2(int x, int fa, int bn, int ro)
{
	int i, y;
	f[x] = maxn(f[x], si[ro] - si[x]);
	if (f[x] <= (si[ro] >> 1))
		s = s + x;
	for (i = fi[x]; i; i = ne[i])
		if ((i >> 1) ^ bn && (y = di[i]) ^ fa)
			dfs_2(y, x, bn, ro);
}
int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int i, x, y, n, T, j;
	T = re();
	while (T--)
	{
		n = re(); l = 1;
		memset(fi, 0, sizeof(fi));
		for (i = 1; i < n; i++)	
		{
			x = re(); y = re();
			add(x, y); add(y, x);
		}
		s = 0;
		for (i = 1; i < n; i++)
		{
			memset(v, 0, sizeof(v));
			for (j = 1; j <= n; j++)
				if (!v[j])
				{
					dfs(j, 0, i);
					dfs_2(j, 0, i, j);
				}
		}
		printf("%lld\n", s);
	}
	return 0;
}
