#define setIO(s) freopen(s".in","r",stdin),freopen(s".out","w",stdout);
#include <cstdio>
#include <iostream>
#include <cstring>
#include <algorithm>
using namespace std;
double A;
#define int long long
template <class T> bool checkmin(T &a,T b){return (b<a ? a=b,1 : 0);}
template <class T> bool checkmax(T &a,T b){return (b>a ? a=b,1 : 0);}
template <class T> T _max(T &a,T b){return (b>a ? b : a);}
const int mod=998244353;
int flag=1;
int n,m,a[105][2005];
void init()
{
    scanf("%lld%lld",&n,&m);
    for (int i=1;i<=n;++i)
    {
        for (int j=1;j<=m;++j)
        {
            scanf("%lld",&a[i][j]);
            if (a[i][j]>1) flag=0;
        }
    }
}

namespace solver1
{
int ans=0,tot[4];
void dfs(int row,int sum,int mul)
{
    if (row>n)
    {
        if (sum==0) return;
        for (int i=1;i<=m;++i)
        {
            if (tot[i]>sum/2) return;
        } 
        //cout<<mul<<endl;
        //for (int i=1;i<=m;++i) cout<<tot[i]<<" ";cout<<endl;
        ans=(ans+mul)%mod;
        return;
    }
    
    dfs(row+1,sum,mul);
    for (int i=1;i<=m;++i)
    {
        if (a[row][i])
        {
            ++tot[i];
            dfs(row+1,sum+1,mul*a[row][i]%mod);
            --tot[i];
        }
    }    
}

void main()
{
    dfs(1,0,1);
    printf("%lld\n",ans);
}

int dp[41][41][41];
void main2()
{
    ans=0;
    dp[1][0][0]=1;
    dp[1][0][1]=a[1][2];
    dp[1][1][0]=a[1][1];
    for (int i=2;i<=n;++i)
    {
        for (int p=0;p<=i;++p)
        {
            for (int q=0;q<=i;++q)
            {
                dp[i][p][q]=dp[i-1][p][q];
                if (p) dp[i][p][q]=(dp[i][p][q]+dp[i-1][p-1][q]*a[i][1]%mod)%mod;
                if (q) dp[i][p][q]=(dp[i][p][q]+dp[i-1][p][q-1]*a[i][2]%mod)%mod;
                //cout<<i<<" "<<p<<" "<<q<<" "<<dp[i][p][q]<<endl;
            }
        }
    }
    for (int i=1;i<=n;++i)
    {
        ans=(ans+dp[n][i][i])%mod;
    }
    printf("%lld\n",ans);
}

int f[2][41][41][41];
void main3()
{
    ans=0;
    f[1][0][0][0]=1;
    f[1][0][0][1]=a[1][3];
    f[1][0][1][0]=a[1][2];
    f[1][1][0][0]=a[1][1];
    for (int i=2;i<=n;++i)
    {
        memset(f[i&1],0,sizeof f[i&1]);
        for (int p=0;p<=i;++p)
        {
            for (int q=0;q<=i;++q)
            {
                for (int r=0;r<=i;++r)
                {
                    f[i&1][p][q][r]=f[(i-1)&1][p][q][r];
                    if (p) f[i&1][p][q][r]=(f[i&1][p][q][r]+f[(i-1)&1][p-1][q][r]*a[i][1]%mod)%mod;
                    if (q) f[i&1][p][q][r]=(f[i&1][p][q][r]+f[(i-1)&1][p][q-1][r]*a[i][2]%mod)%mod;
                    if (r) f[i&1][p][q][r]=(f[i&1][p][q][r]+f[(i-1)&1][p][q][r-1]*a[i][3]%mod)%mod;
                    //cout<<i<<" "<<p<<" "<<q<<" "<<r<<" "<<f[i&1][p][q][r]<<endl;
                }
            }
        }
    }
    for (int i=0;i<=n;++i)
    {
        for (int j=0;j<=n;++j)
        {
            for (int k=0;k<=n;++k)
            {
                if (i+j+k==0) continue;
                if (_max(i,_max(j,k))>(i+j+k)/2) continue;
                ans=(ans+f[n&1][i][j][k])%mod;
            }
        }
        
    }
    printf("%lld\n",ans);
}
}

namespace solver2
{

void main()
{
	
}
}

void solve()
{
    if (n<=10) solver1::main();
    else if (m==2) solver1::main2();
    else if (m==3) solver1::main3();
    else solver1::main();
}

#undef int
int main()
{
    A=clock();
	setIO("meal");
	init();
	solve();
	fclose(stdin),fclose(stdout);
	return 0;
}
