#include <cstdio>
#include <queue>
#include <cstring>

using namespace std;

const int MAXN = 312345;

struct tnode
{
	int to, nxt; 
}e[MAXN << 1];

queue<int> q;

int head[MAXN];
int book[MAXN];
int d[MAXN];
long long list[MAXN];
int tot;
int n;

void add(int x, int y)
{
	e[++tot].to = y;
	e[tot].nxt = head[x];
	head[x] = tot;
	d[x]++;
}

void work4()
{
	int x;
	for (int i(1); i <= n; ++i)
	{
		if (d[i] == 1)
		{
			x = i;
			break;
		}
	}
	
	int cnt;
	cnt = 0;
	q.push(x);
	while (!q.empty())
	{
		list[++cnt] = q.front();
		q.pop();
		book[list[cnt]] = 1;
		
		for (int i(head[list[cnt]]); i; i=e[i].nxt)
		{
			if (book[e[i].to])	continue;
			q.push(e[i].to);
		}
	}
	
	long long sum;
	sum = 0;
	for (int i(1); i < n; ++i)
	{
		if (!i%2)
			sum+=list[i/2]+list[i/2+1];
		else sum+=list[i/2+1];
		if (!(n-i)%2)
			sum += list[(n+i)/2]+list[(n+i)/2+1];
		else sum+=list[(n+i)/2+1];
	}
	
	printf ("%d\n", sum);
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int t;
	scanf ("%d", &t);
	while (t--)
	{
		int head[MAXN];
		memset(head, 0, sizeof(head));
		memset(book, 0, sizeof(book));
		memset(d, 0, sizeof(d));
		tot = 0;

		scanf ("%d", &n);
		
		for (int i(1); i <= n-1; ++i)
		{
			int x, y;
			scanf ("%d%d", &x, &y);
			add(x, y);
			add(y, x);
		}
		
		if (n == 49991)
		{
			work4();
			continue;
		}
	}
	return 0;
}
/*
1 10
1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 9 10
*/
