#include <bits/stdc++.h>

const int MAXN = 2010;
typedef long long LL;
int head[MAXN], nxt[MAXN << 1], to[MAXN << 1], tot;
void addedge(int b, int e) {
	nxt[++tot] = head[b]; to[head[b] = tot] = e;
	nxt[++tot] = head[e]; to[head[e] = tot] = b;
}
int sznow, rt, rtv;
int getroot(int u, int fa = 0) {
	int sz = 1, maxv = 0;
	for (int i = head[u]; i; i = nxt[i])
		if (to[i] != fa) {
			int res = getroot(to[i], u);
			maxv = std::max(maxv, res);
			sz += res;
		}
	maxv = std::max(maxv, sznow - sz);
	if (maxv < rtv) rtv = maxv, rt = u;
	else if (maxv == rtv) rt += u;
	return sz;
}
int n;
int getd(int u, int sz, int fa) {
	sznow = sz, rt = 0, rtv = 0x3f3f3f3f;
	getroot(u, fa);
	return rt;
}
LL ans = 0;
int dfs(int u, int fa = 0) {
	int sz = 1;
	for (int i = head[u]; i; i = nxt[i])
		if (to[i] != fa) {
			int res = dfs(to[i], u);
			ans += getd(to[i], res, u);
			ans += getd(u, n - res, to[i]);
			sz += res;
		}
	return sz;
}
void solve() {
	std::cin >> n;
	for (int i = 1, t1, t2; i < n; ++i)
		std::cin >> t1 >> t2, addedge(t1, t2);
	dfs(1);
	std::cout << ans << std::endl;
	memset(head, 0, n + 1 << 2); ans = tot = 0;
}
int main() {
#define FILENAME "centroid"
#ifdef FILENAME
	freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".usr", "w", stdout);
#endif
	std::ios_base::sync_with_stdio(false), std::cin.tie(0);
	int T; std::cin >> T;
	while (T --> 0) solve();
	return 0;
}
