#include <bits/stdc++.h>

typedef long long LL;
const int MAXN = 5010;
int n, A[MAXN], typ;
LL dp[MAXN][MAXN], pre[MAXN];
LL suc[MAXN][MAXN];
inline LL pows(LL x) { return x * x; }
inline LL sum(int l, int r) { return pre[r] - pre[l - 1]; }
int main() {
#define FILENAME "partition"
#ifdef FILENAME
	freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".out", "w", stdout);
#endif
	std::ios_base::sync_with_stdio(false), std::cin.tie(0);
	std::cin >> n >> typ;
	for (int i = 1; i <= n; ++i) std::cin >> A[i], pre[i] = pre[i - 1] + A[i];
	memset(dp, 0x3f, sizeof dp);
	memset(suc, 0x3f, sizeof suc);
	for (int i = 1; i <= n; ++i)
		dp[1][i] = pows(sum(1, i));
	suc[1][1] = dp[1][1];
	for (int r = 2; r <= n; ++r) {
		int lcur = 1;
		for (int l = 2; l <= r; ++l) {
			const LL S = sum(l, r), SP = pows(sum(l, r));
			while (sum(lcur, l - 1) > S) ++lcur;
			dp[l][r] = suc[lcur][l - 1] + SP;
		}
		suc[r][r] = dp[r][r];
		for (int l = r - 1; l; --l)
			suc[l][r] = std::min(suc[l + 1][r], dp[l][r]);
	}
	LL ans = 0x3f3f3f3f3f3f3f3fLL;
	for (int i = 1; i <= n; ++i)
		ans = std::min(ans, dp[i][n]);
	std::cout << ans << '\n';
	return 0;
}
