#include<bits/stdc++.h>
#define ll long long
using namespace std;

const int N = 2005;
ll fac[N], inv[N], ans;
int n, m, a[105][N];

const ll mod = 998244353;
inline ll M(ll a){return a%mod;} 
inline ll add(ll a, ll b){return a+b>mod ? a+b-mod : a+b;}
inline ll sub(ll a, ll b){return a-b<0   ? a-b+mod : a-b;}
inline ll mul(ll a, ll b){return M(a*b);}
inline ll C(ll n, ll m) { return mul(fac[n], mul(inv[m], inv[n-m]));}
inline ll P(ll a, ll b) {
	ll c = 1;
	while(b) {
		if(b&1) c = mul(c,a);
		b >>= 1;
		a = mul(a, a);
	}	
	return c;
}
inline void init() {
	scanf("%d%d", &n, &m);
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++)
			scanf("%d", &a[i][j]), ans += a[i][j];
}

inline void prep() {
	ll Ni = N-2;
	fac[0] = 1;
	for(int i = 1; i <= Ni;  i++) 
		fac[i] = mul(fac[i-1], i);
	inv[Ni] = P(fac[Ni], mod-2);
	for(int i = Ni; i; i--)
		inv[i-1] = mul(inv[i], i);
} 

inline void work() {
	ans = C(ans, n)/2;
}

inline void outo() {
	printf("%lld\n", ans);
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	init();
	prep();
	work();
	outo();
	return 0;
}
