#include <bits/stdc++.h>
using namespace std;
typedef long long LL;

const int N = 105;
const int M = 2e3 + 5;
const int mod = 998244353;

inline int mul(int a, int b) {
  return (LL) a * b % mod;
}
inline void add(int &a, int b) {
  a += b; if(a >= mod) a -= mod;
}
inline void sub(int &a, int b) {
  a -= b; if(a < 0) a += mod;
}

int ans, n, m, ret[N], a[N][M], dp[N][N], cur[N][N];
int A[N], B[N], C[N];

inline void read(int &x) {
  x = 0; char c = getchar();
  for(; !isdigit(c); c = getchar());
  for(;  isdigit(c); c = getchar())
    x = x * 10 + (c ^ 48);
}

void init() {
  cur[0][0] = 1;
  for(int i = 1; i <= n; ++i) {
    for(int j = 1; j <= i; ++j)
      add(cur[i][j], mul(A[i], cur[i - 1][j - 1]));
    for(int j = 0; j <= i; ++j)
      add(cur[i][j], cur[i - 1][j]);
  }
}
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
  read(n), read(m);
  for(int i = 1; i <= n; ++i)
    for(int j = 1; j <= m; ++j) {
      read(a[i][j]);
      add(A[i], a[i][j]);
    }
  for(int x = 1; x <= m; ++x) {
    for(int i = 1; i <= n; ++i) {
      B[i] = a[i][x];
      C[i] = A[i];
      sub(C[i], B[i]);
    }
    memset(dp, 0, sizeof dp);
    dp[0][0] = 1;
    for(int i = 1; i <= n; ++i) {
      for(int j = i - 1; ~j; --j)
	for(int k = j; ~k; --k) {
	  add(dp[j + 1][k], mul(dp[j][k], C[i]));
	  add(dp[j + 1][k + 1], mul(dp[j][k], B[i]));
	}
    }
    for(int i = 1; i <= n; ++i) {
      for(int j = i / 2 + 1; j <= i; ++j) 
	sub(ret[i], dp[i][j]);
    }
  }
  init();
  for(int i = 1; i <= n; ++i) {
    add(ret[i], cur[n][i]);
    add(ans, ret[i]);
  }
  printf("%d\n", ans);
  return 0;
}

