/*DennyQi 2019*/
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <queue>
#define int long long
using namespace std;
const int N = 100010;
const int P = 998244353;
const int INF = 0x3f3f3f3f;
inline int Min(const int& a, const int& b){ return (a<b) ? a : b; }
inline int Max(const int& a, const int& b){ return (a>b) ? a : b; }
inline int mul(const int& a, const int& b){ return 1ll*a*b%P; }
inline int add(const int& a, const int& b){ return (a+b>=P) ? a+b-P : a+b; }
inline int sub(const int& a, const int& b){ return (a-b<0) ? a-b+P : a-b; }
inline int read(){
	int x = 0, w = 0; char c = getchar();
	while(c^'-' && (c<'0' || c>'9')) c = getchar();
	if(c=='-') w = 1, c = getchar();
	while(c>='0' && c<='9') x = x*10+c-'0', c = getchar(); return w ? -x : x;
}
int n,m,ans,a[110][110];
int dp2[45][45][45],dp3[45][45][45][45],b[45],c[45];
inline int DP2(){
	int res = 0;
	dp2[0][0][0] = 1;
	for(int i = 1; i <= n; ++i){
		dp2[i][0][0] = 1;
		for(int j = 0; j <= i; ++j){
			for(int k = 0; k <= j; ++k){
				dp2[i][j][k] = dp2[i-1][j][k];
				if(k>0 && k>0){
					dp2[i][j][k] = add(dp2[i][j][k],mul(dp2[i-1][j-1][k-1],a[i][1]));
				}
				if(j>0){
					dp2[i][j][k] = add(dp2[i][j][k],mul(dp2[i-1][j-1][k],a[i][2]));
				}
			}
		}
	}
	for(int j = 2; j <= n; ++j){
		for(int k = 0; k <= j; ++k){
			if(k <= j/2 && (j-k) <= j/2){
				res = add(res,dp2[n][j][k]);
			}
		}
	}
	return res;
}
inline int DP3(){
	int res = 0;
	dp3[0][0][0][0] = 1;
	for(int i = 1; i <= n; ++i){
		dp3[i][0][0][0] = 1;
		for(int j = 1; j <= i; ++j){
			for(int k = 0; k <= j; ++k){
				for(int q = 0; k+q <= j; ++q){
					dp3[i][j][k][q] = add(dp3[i-1][j][k][q],mul(dp3[i-1][j-1][k][q],a[i][3]));
//					printf("dp3[%d][%d][%d][%d]=d3[%d][%d][%d][%d]+dp[%d][%d][%d][%d]*a[%d][3]",i,j,k,q,i-1,j,k,q,i-1,j-1,k,q,i);
					if(k>0){
						dp3[i][j][k][q] = add(dp3[i][j][k][q],mul(dp3[i-1][j-1][k-1][q],a[i][1]));
//						printf("+dp[%d][%d][%d][%d]*a[%d][1]",i-1,j-1,k-1,q,i);
					}
					if(q>0){
						dp3[i][j][k][q] = add(dp3[i][j][k][q],mul(dp3[i-1][j-1][k][q-1],a[i][2]));
//						printf("+dp[%d][%d][%d][%d]*a[%d][2]",i-1,j-1,k,q-1,i);
					}
//					printf("\n");
//					printf("dp3[%d][%d][%d][%d]=%d\n",i,j,k,q,dp3[i][j][k][q]);
				}
			}
		}
	}
	for(int j = 2; j <= n; ++j){
		for(int k = 0; k <= j; ++k){
			for(int q = 0; k+q <= j; ++q){
				if(k<=j/2 && q<=j/2 && (j-k-q) <= j/2 && (j-k-q)>=0 && j>1){
					res = add(res,dp3[n][j][k][q]);
//					printf("	res += %d\n",dp3[n][j][k][q]);
				}
			}
		}
	}
	return res;
}
inline void check(){
	memset(c,0,sizeof(c));
	int cnt = 0;
	for(int i = 1; i <= n; ++i){
		if(b[i] != 0){
			++cnt;
			c[b[i]]++;
		}
	}
	if(cnt < 1) return;
	for(int i = 1; i <= m; ++i){
		if(c[i] > cnt/2) return;
	}
//	for(int i = 1; i <= n; ++i){
//		printf("%d ",b[i]);
//	}
//	printf("    ===>   ");
	int res = 1;
	for(int i = 1; i <= n; ++i){
		if(!b[i]) continue;
		res = mul(res,a[i][b[i]]);
//		printf("*%d",a[i][b[i]]);
	}
//	printf("=%d\n",res);
	ans = add(ans,res);
}
void dfs(int x){
	if(x > n){
		check();
		return;
	}
	for(int i = 0; i <= m; ++i){
		b[x] = i;
		dfs(x+1);
	}
}
#undef int
int main(){
#define int long long
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	n = read(), m = read();
	for(int i = 1; i <= n; ++i){
		for(int j = 1; j <= m; ++j){
			a[i][j] = read();
		}
	}
	if(m == 2){
		printf("%lld\n",DP2());
		return 0;
	}
	if(m == 3){
		printf("%lld\n",DP3());
		return 0;
	}
	dfs(1);
	printf("%lld\n",ans);
	return 0;
}

