#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<vector>
#define mod 998244353
using namespace std;
template<typename T>inline void read(T &a)
{
	T x=0,t=1;
	char ch=getchar();
	while(ch<'0'||ch>'9')
	{
		if(ch=='-')t=-1;
		ch=getchar();
	}
	while(ch>='0'&&ch<='9')x*=10,x+=ch-'0',ch=getchar();
	a=x*t;
}
template<typename T>inline void print(T x)
{
	if(x<0)putchar('-'),x=-x;
	if(x>=10)print(x/10);
	putchar('0'+x%10);
}
template<typename T>inline void printfn(T x){print(x),putchar('\n');}
template<typename T>inline void Printf(T x){print(x),putchar(' ');}
int n;
vector<int>p[270001];
int Broke;
long long ans=0;
int siz[270001],mxs[270001],fa[270001];
void dfs(int x,int root)
{
	siz[x]=1;
	for(int i=0;i<p[x].size();i++)
	{
		int v=p[x][i];
		if(!siz[v]&&v!=Broke)fa[v]=x,dfs(v,root),siz[x]+=siz[v],mxs[x]=max(mxs[x],siz[v]);
		else if(!siz[v]&&v==Broke)fa[v]=x;
	}
}
void check(int x,int root)
{
	for(int i=0;i<p[x].size();i++)
	{
		int v=p[x][i];
		if(v!=fa[x]&&v!=Broke)check(v,root);
	}
	int sum;
	if(root==1)sum=siz[1];
	else sum=siz[Broke];
	sum>>=1;
	
	if(mxs[x]<=sum&&siz[root]-siz[x]<=sum)ans+=x;//printf("broke=%d x=%d\n",Broke,x);//,printf("x=%d sum=%d mxs=%d root=%d siz[root]=%d\n",x,sum,mxs[x],root,siz[root]);
}
int used[270001];
void bfsa(int x)
{
	int h=0,e=1,t=1;
	used[1]=x;
	while(h<e)
	{
		int u=used[++h];
		int l=t-1,r=n-t;
		ans+=u+u+u;
		if(l==r||!l||!r)ans-=u;
		for(int i=0;i<p[u].size();i++)
			if(used[h-1]!=p[u][i])used[++e]=p[u][i];
		t++;
	}
}
void worka()
{
	memset(used,0,sizeof(used));
	int root;
	for(int i=1;i<=n;i++)if(p[i].size()==1){root=i;break;}
//	printf("root=%d\n",root);
	bfsa(root);
	printfn(ans);
}
int dep[270001];
int p2[270001],pow2[21];
void dfsb(int x)
{
	printfn(x);
	siz[x]=1;
	for(int i=0;i<p[x].size();i++)
	{
		int v=p[x][i];
		if(v!=fa[x])dep[v]=dep[x]+1,fa[v]=x,dfsb(v),siz[x]+=siz[v];
	}
}
void workb()
{
	int root;
	for(int i=1;i<=n;i++)if(p[i].size()==2){root=i;break;}
	ans+=(1+n)*n/2;
	ans-=root;
	memset(fa,0,sizeof(fa)),memset(mxs,0,sizeof(mxs)),memset(siz,0,sizeof(siz));
	dep[root]=1;
	dfsb(root);
	for(int i=1;i<=n;i++)
	{
		if(i==root)continue;
		int tmp=siz[i]-siz[root]+siz[i];
		int k1=p2[siz[root]+1],k2=p2[tmp+1];
		ans+=pow2[k1-dep[i]+1-k2]*i;
	}
	printfn(ans);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
int TTMP=1;
for(int i=0;i<=18;i++)
{
	pow2[i]=TTMP;
	p2[TTMP]=i;
	TTMP*=2;
}
int T;
read(T);
while(T--)
{
	read(n);
	ans=0;
	for(int i=1;i<=n;i++)p[i].clear();
	for(int i=1;i<n;i++)
	{
		int a,b;
		read(a),read(b);
		p[a].push_back(b),p[b].push_back(a);
	}
	int cnt1=0,cnt2=0,cnt3=0;
	for(int i=1;i<=n;i++)
	{
		if(p[i].size()==1)cnt1++;
		if(p[i].size()==2)cnt2++;
		if(p[i].size()==3)cnt3++;
	}
	if(cnt1==2&&cnt2==n-2){worka();continue;}
	if(cnt2==1&&cnt1==(n+1)/2&&cnt1+cnt2+cnt3==n){workb();continue;}
	for(int i=2;i<=n;i++)
	{
		memset(siz,0,sizeof(siz)),memset(mxs,0,sizeof(mxs));
		memset(fa,0,sizeof(fa));
		Broke=i,dfs(1,1),dfs(i,i);
		check(1,1),check(i,i);
//		for(int j=1;j<=n;j++)
//			printf("i=%d siz=%d mxs=%d fa=%d\n",j,siz[j],mxs[j],fa[j])
	}
	printfn(ans);
}
}
