#include<cstdio>
#include<cstring>
#include<iostream>
#define ll long long
using namespace std;
const int N = 300010;
int n,h[N],cnt,p[N],p2[N],t[N],vis[N];
struct Edge
{
	int to,nxt;
}e[N*2];
void add(int u,int v)
{
	e[++cnt].to=v;
	e[cnt].nxt=h[u];
	h[u]=cnt;
}
void dfs(int u)
{
	for(int i=h[u];~i;i=e[i].nxt)
	{
		int v=e[i].to;
		if(vis[v])continue;
		vis[v]=1;
		p[p2[u]+1]=v;
		p2[v]=p2[u]+1;
		dfs(v);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		cnt=0;
		memset(e,0,sizeof(e));
		memset(h,-1,sizeof(h));
		memset(t,0,sizeof(t));
		memset(vis,0,sizeof(vis));
		memset(p,0,sizeof(p));
		memset(p2,0,sizeof(p2));
		scanf("%d",&n);
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			add(u,v),add(v,u);
			t[u]++,t[v]++;
		}
		int s=0;
		for(int i=1;i<=n;i++)
			if(t[i]==1){s=i;break;}
		vis[s]=1;
		p[1]=s;
		p2[s]=1;
		dfs(s);
		ll ans=0;
		for(int i=1;i<n;i++)
		{
			int x=(1+i)/2,y=(i+1+n)/2;
			if((i+1)%2==0)ans+=(ll)p[x];
			else ans+=(ll)p[x]+p[x+1];
			if((i+1+n)%2==0)ans+=(ll)p[y];
			else ans+=(ll)p[y]+p[y+1];
		}
		printf("%lld\n",ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
