#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <algorithm>
using namespace std;

const int N=100;
const int M=2000;

int n,m,ans=0;
int a[N+10][M+10];
int id[N+10][M+10],len[N+10];
int p[N+10],t[M+10];

bool check() {
	int sum=0;
	memset(t,0,sizeof(t));
	for (int i=1;i<=n;i++) {
		t[p[i]]+=a[i][p[i]];
		sum+=a[i][p[i]];
	}
	if (sum==0) return false;
	for (int i=1;i<=m;i++)
		if (t[i]>sum/2)
			return false;
	return true;
}

void dfs(int dep,int num) {
	p[dep]=num;
	if (dep==n) {
		if (check()) ans++;
		return;
	}
	dfs(dep+1,0);
	for (int i=1;i<=len[dep+1];i++)
		dfs(dep+1,id[dep+1][i]);
	p[dep]=0;
}

int main() {
	#ifndef OFFLINE_JUDGE
		freopen("meal.in","r",stdin);
		freopen("meal.out","w",stdout);
	#endif
	scanf("%d%d",&n,&m);
	for (int i=1;i<=n;i++) {
		for (int j=1;j<=m;j++) {
			scanf("%d",&a[i][j]);
			if (a[i][j]==1)
				id[i][++len[i]]=j;
		}
	}
	dfs(0,0);
	printf("%d\n",ans);
	return 0;
}

