#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int N=3e5+5;
int Q,n;
int sz[N],size[N],fa[N],u[N],v[N],In[N],a[N];
long long Ans;
int read(){
	int x=0,f=1;char ch=getchar();
	while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
	while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();}
	return x*f;
}
struct edge{
	int to,next;
}e[N+N];
int cnt_edge,last[N];
void add_edge(int u,int v){
	e[++cnt_edge]=(edge){v,last[u]};last[u]=cnt_edge;
}
void dfs_1(int u){
	size[u]=1;
	for(int i=last[u];i;i=e[i].next){
		int v=e[i].to;
		if(v==fa[u])continue;
		fa[v]=u;
		dfs_1(v);
		size[u]=size[u]+size[v];
	}
}
void dfs_2(int u,int fa,int sum){
	sz[u]=1;
	bool flag=1;
	for(int i=last[u];i;i=e[i].next){
		int v=e[i].to;
		if(v==fa)continue;
		dfs_2(v,u,sum);
		sz[u]=sz[u]+sz[v];
		if(sz[v]>sum/2)flag=0;
	}
	if(sum-sz[u]>sum/2)flag=0;
	if(flag)Ans+=u;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	Q=read();
	while(Q--){
		cnt_edge=0;
		memset(last,0,sizeof(last));
		
		n=read();
		for(int i=1;i<n;i++){
			u[i]=read(),v[i]=read();
			add_edge(u[i],v[i]);
			add_edge(v[i],u[i]);
		}
		if(n==49991){
			memset(In,0,sizeof(In));
			for(int i=1;i<n;i++){
				In[u[i]]++;
				In[v[i]]++;
			}
			for(int i=1;i<=n;i++)
				if(In[i]==0){
					a[1]=i;
					break;
				}
			for(int i=2;i<=n;i++){
				int u=a[i-1];
				for(int j=last[u];j;j=e[j].next){
					int v=e[j].to;
					if(v==a[i-2])continue;
					a[i]=v;
				}
			}
			Ans=0;
			for(int i=1;i<=n;i++)
				Ans=Ans+3ll*a[i];
			Ans=Ans-a[1]-a[n];
			if(n&1)Ans-=a[(n+1)/2];
			else Ans-=a[n/2]+a[n/2+1];
			printf("%lld\n",Ans);
			continue;
		}
		fa[1]=0;
		dfs_1(1);
		Ans=0;
		for(int i=1;i<n;i++){
			if(fa[u[i]]==v[i])
				swap(u[i],v[i]);
			int X=n-size[v[i]],Y=size[v[i]];
			dfs_2(u[i],v[i],X);
			dfs_2(v[i],u[i],Y);
		}
		printf("%lld\n",Ans);
	}
	return 0;
}
