#include <bits/stdc++.h>
using namespace std;
#define N 115
#define M 2015
#define lowbit(x) (x&(-x))

bool s1;

const int mo = 998244353;

void Add(int &res,int x) {
	res += x;
	( (res >= mo) && (res -=mo) );
	( (res < 0) && (res += mo) );
	return ;
}

int n,m;
int A[N][M];

struct Score_32 {

	int Ans;
	int dp[20][1<<10|5],F[1<<10|5];

	int Way(int id,int h) {
		int res = 1;
		for(int i=0; i<n; i++) if(h&(1<<i)) res = 1LL*res*A[i+1][id]%mo;
		return res;
	}

	void Calc(int lim) {
		int t = lim/2;
		memset(dp,0,sizeof(dp));
		dp[0][0] = 1;
		for(int i=1; i<=m; i++) {
			for(int j=0; j<(1<<n); j++) {
				if(!dp[i-1][j]) continue;
				int k = (1<<n)-1;
				k ^= j;
				for(int e=k; e; e=(e-1)&k) {
					if(F[e] > t) continue;
					Add(dp[i][j|e],1LL * dp[i-1][j] * Way(i,e) % mo);
				}
				Add(dp[i][j],dp[i-1][j]);
			}
		}
		for(int i=0; i<(1<<n); i++) if(F[i] == lim) Add(Ans,dp[m][i]);
		return ;
	}


	int Count(int x) {
		int res = 0;
		while(x) ++res,x -= lowbit(x);
		return res;
	}

	void Solve() {
		for(int i=0; i<(1<<n); i++) F[i] = Count(i);
		Ans = 0;
		for(int i=2; i<=n; i++) Calc(i);
		printf("%d\n",Ans);
		return ;
	}
} S32;

int Ans,S[105];
int dp[105][105][105],F[105][105];

struct Score_64 {

	void Calc(int lim) {
		int tmp = F[n][lim],he = 0,c = lim/2+1;
		for(int j=1; j<=m; ++j) {

			for(int i=0; i<=n; ++i) for(int d=0; d<=lim; ++d) for(int k=0; k<=c; ++k) dp[i][d][k] = 0;
			dp[0][0][0] = 1;
			for(int i=1; i<=n; ++i) {
				for(int d=0; d<=min(i,lim); ++d) {
					for(int k=0; k<=min(c,d); ++k) {
						if(d + 1 <= lim) {
							Add(dp[i][d+1][min(k+1,c)],1LL* dp[i-1][d][k] * A[i][j]%mo);
							Add(dp[i][d+1][k],1LL*dp[i-1][d][k] * (S[i] - A[i][j])%mo);
						}
						Add(dp[i][d][k],dp[i-1][d][k]);
					}
				}
			}

			int t = dp[n][lim][c];
			Add(he,t);
		}
		Add(Ans,tmp - he);
		return ;
	}

	void Solve() {
		for(int i=1; i<=n; i++) for(int j=1; j<=m; ++j) Add(S[i],A[i][j]);

		memset(F,0,sizeof(F));
		F[0][0] = 1;
		for(int i=1; i<=n; i++) {
			for(int j=0; j<i; j++) {
				Add(F[i][j],F[i-1][j]);
				Add(F[i][j+1],1LL*F[i-1][j]*S[i]%mo);
			}
		}


		Ans = 0;
		for(int i=2; i<=n; ++i) Calc(i);
		printf("%d\n",Ans);
		return ;
	}
} S64;

struct Score_100 {

#define reg register
	int he[105];
	void Calc() {
		int c = n/2+1;
		for(reg int j=1; j<=m; ++j) {

			for(reg int i=0; i<=n; ++i) for(int d=0; d<=i; ++d) for(int k=0; k<=c; ++k) dp[i][d][k] = 0;

			dp[0][0][0] = 1;
			for(reg int i=1; i<=n; ++i) {
				for(reg int d=0; d<=i; ++d) {
					for(reg int k=0; k<=min(c,d); ++k) {
						if(d + 1 <= i) {
							Add(dp[i][d+1][min(k+1,c)],1LL* dp[i-1][d][k] * A[i][j]%mo);
							Add(dp[i][d+1][k],1LL*dp[i-1][d][k] * (S[i] - A[i][j])%mo);
						}
						Add(dp[i][d][k],dp[i-1][d][k]);
					}
				}
			}

			for(reg int lim=2; lim<=n; ++lim) {
				for(reg int i=lim/2+1; i<=lim; ++i) Add(he[lim],dp[n][lim][i]);
			}
		}

		for(int i=2; i<=n; i++) Add(Ans,F[n][i] - he[i]);
		return ;
	}

	void Solve() {
		for(int i=1; i<=n; i++) for(int j=1; j<=m; ++j) Add(S[i],A[i][j]);

		memset(F,0,sizeof(F));
		F[0][0] = 1;
		for(int i=1; i<=n; i++) {
			for(int j=0; j<i; j++) {
				Add(F[i][j],F[i-1][j]);
				Add(F[i][j+1],1LL*F[i-1][j]*S[i]%mo);
			}
		}

		Ans = 0;
		Calc();

		printf("%d\n",Ans);
		return ;
	}
} S100;

bool s2;

int main() {
//	printf("%.2lf\n",(&s2 - &s1)/1024.0/1024);
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);

	cin >> n >> m;
	for(int i=1; i<=n; i++) for(int j=1; j<=m; ++j) scanf("%d",&A[i][j]);

	if(n <= 10) S32.Solve();
	else if(n <= 40 && m <= 3) S64.Solve();
	else S100.Solve();

	return 0;
}
