#include<bits/stdc++.h>
#define For(i,a,b) for(int i=(a);i<=(b);++i)
#define Rep(i,a,b) for(int i=(a);i>=(b);--i)
using namespace std;
inline int read()
{
	char c=getchar();int x=0,f=1;
	for(;!isdigit(c);c=getchar())if(c=='-')f=-1;
	for(;isdigit(c);c=getchar())x=x*10+c-48;
	return x*f;
}
#define maxn 300005
int t,n,uu[maxn],vv[maxn];
struct edge{
	int to,nxt;
}e[maxn<<1];
int tot,head[maxn];
inline void adde(int u,int v){
	e[++tot]=(edge){v,head[u]};
	head[u]=tot;
}

namespace force{
	int du,dv,tot;
	int sz[maxn],mxp[maxn];
	inline bool isdel(int u,int v){
		if(u>v)swap(u,v);
		return u==du&&v==dv;
	}
	void dfs(int u,int fa)
	{
		sz[u]=1;tot++;
		for(int i=head[u];i;i=e[i].nxt)
		{
			int v=e[i].to;
			if(v==fa)continue;
			dfs(v,u);
			sz[u]+=sz[v];
			mxp[u]=max(mxp[u],sz[v]);
		}
	}
	int getans(int u,int v){
		memset(mxp,0,sizeof mxp);
		memset(sz,0,sizeof sz);
		tot=0;
		dfs(u,v);
		int res=0;
	//	cout<<u<<' '<<v<<endl;
		For(i,1,n)
			if(sz[i])mxp[i]=max(mxp[i],tot-sz[i]);
	//	For(i,1,n)cout<<mxp[i]<<' ';puts("");
		For(i,1,n)
			if(sz[i]&&mxp[i]<=tot/2)res+=i;
		return res;
	}
	void solve()
	{
		long long res=0;
		For(i,2,n)
		{
			du=uu[i],dv=vv[i];
	//		if(du>dv)swap(du,dv);
			res+=getans(du,dv)+getans(dv,du);
		}cout<<res<<endl;
	}
}

namespace chain{
	long long p[maxn];
	inline long long getans(int l,int r){
	//	cout<<l<<' '<<r<<' ';
	//	if((l+r)%2)cout<<p[(l+r)/2]+p[(l+r)/2+1]<<endl;
	//	else cout<<p[(l+r)/2]<<endl;
		if((l+r)%2)return p[(l+r)/2]+p[(l+r)/2+1];
		return p[(l+r)/2];
	}
	inline void solve()
	{
		For(i,2,n)
			p[i]=vv[i];
		p[1]=uu[2];
	//	For(i,1,n)cout<<p[i]<<' ';puts("");
		long long res=0;
		For(i,2,n)
			res+=getans(1,i-1)+getans(i,n);
		cout<<res<<endl;
	}
}

namespace tree{
	int rt,f[maxn],lc[maxn],rc[maxn],dep[maxn];;
	long long ww[101],dg[101];
	void dfs1(int u,int fa,int deep)
	{
	//	cout<<u<<' ';
		f[u]=fa;
		dep[u]=deep;
		ww[deep]+=u;
		for(int i=head[u];i;i=e[i].nxt){
			int v=e[i].to;
			if(v==fa)continue;
			if(lc[u])rc[u]=v;
			else lc[u]=v;
			dfs1(v,u,deep+1);
		}
	}
	int du,dv,tot;
	int sz[maxn],mxp[maxn];
	inline bool isdel(int u,int v){
		if(u>v)swap(u,v);
		return u==du&&v==dv;
	}
	void dfs(int u,int fa)
	{
		sz[u]=1;tot++;
		for(int i=head[u];i;i=e[i].nxt)
		{
			int v=e[i].to;
			if(v==fa)continue;
			dfs(v,u);
			sz[u]+=sz[v];
			mxp[u]=max(mxp[u],sz[v]);
		}
	}
	void getans(int u,int v){
		memset(mxp,0,sizeof mxp);
		memset(sz,0,sizeof sz);
		tot=0;
		dfs(u,v);
		For(i,1,n)
			if(sz[i])mxp[i]=max(mxp[i],tot-sz[i]);
		For(i,1,n)
			if(sz[i]&&mxp[i]<=tot/2)
				dg[dep[i]]++;
	}
	void solve()
	{
		memset(dg,0,sizeof dg);
		memset(dep,0,sizeof dep);
		memset(lc,0,sizeof lc);
		memset(ww,0,sizeof ww);
		memset(f,0,sizeof f);
		memset(rc,0,sizeof rc);
		rt=uu[2];
		dfs1(rt,0,1);
		for(int u=rt;u;u=lc[u])
		{
			int v=lc[u];
			memset(sz,0,sizeof sz);
			memset(mxp,0,sizeof mxp);
			getans(u,v);getans(v,u);
		}
		long long res=0;
		For(i,1,100)
			res+=ww[i]*dg[i];
		cout<<res<<endl;
	}
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	t=read();
	while(t--)
	{
		n=read();
		tot=0;For(i,1,n)head[i]=0;
		bool ischain=1;
		For(i,2,n){
			uu[i]=read(),vv[i]=read();
			int u=uu[i],v=vv[i];
			if(i>2&&uu[i]!=vv[i-1])ischain=0;
			adde(u,v);adde(v,u);
		}
		if(ischain)chain::solve();
		else force::solve();
	}
	return 0;
}
