#include <cstdio>
#include <iostream>
#include <algorithm>
#define mul(a, b) (static_cast<long long> (a) * (b) % mod)
#define mul_(a, b) (static_cast<long long> (a) * (b))
const int maxm = 2010, mod = 998244353;
inline void reduce(int &x) { x += x >> 31 & mod; }
inline void up(int &x) { x -= mod, x += x >> 31 & mod; }

int n, m, a[105][maxm], sum[105], Prod = 1;
int f[105][105];
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0);
	std::cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			std::cin >> a[i][j], up(sum[i] += a[i][j]);
	for (int i = 1; i <= n; ++i) Prod = mul(Prod, sum[i] + 1);
	reduce(Prod -= 1);
//	printf("%d\n", Prod);
	for (int i = 1; i <= m; ++i) {
		for (int j = 0; j <= n; ++j)
			for (int k = 0; k <= n; ++k) f[j][k] = 0;
		f[0][0] = 1;
		for (int j = 1; j <= n; ++j) {
			const int x = a[j][i], y = (sum[j] + mod - a[j][i]) % mod;
//			printf("%d %d\n", x, y);
			for (int k = j; k; --k) {
				for (int l = k; l; --l)
					f[k][l] = (mul_(f[k - 1][l - 1], x) + f[k][l]
							+ mul_(f[k - 1][l], y)) % mod;
				f[k][0] = (mul_(f[k - 1][0], y) + f[k][0]) % mod;
			}
//			for (int j = 0; j <= n; ++j) {
//				for (int k = 0; k <= n; ++k) printf("%d ", f[j][k]);
//				puts("");
//			}
//			puts("");
		}
//		printf("%d: ------------------\n", i);
//		for (int j = 0; j <= n; ++j) {
//			for (int k = 0; k <= n; ++k) printf("%d ", f[j][k]);
//			puts("");
//		}
		for (int j = 1; j <= n; ++j)
			for (int k = (j >> 1) + 1; k <= j; ++k) reduce(Prod -= f[j][k]);
//		printf("Prod: %d\n", Prod);
	}
	std::cout << Prod << '\n';
	return 0;
}
