#include <bits/stdc++.h>
#define ll long long
#define MxN 105
#define N 45
#define MxM 2005
using namespace std;
const int P = 998244353;

int n, m; ll a[MxN][MxM];

namespace sub1{
	ll dp[N][N];
	int main(){
		memset(dp, 0, sizeof dp); dp[0][0] = 1;
		for(int i = 1; i <= n; ++i)
			for(int j = i; j >= 1; --j)
				for(int x = j; x >= 0; --x){
					dp[j][x] = (dp[j][x] + dp[j - 1][x] * a[i][2]) % P;
					dp[j][x] = (dp[j][x] + dp[j - 1][x - 1] * a[i][1]) % P;
				}
		ll ans = 0;
		for(int j = 1; j + j <= n; ++j) ans = (ans + dp[j + j][j]) % P;
		printf("%lld\n", ans);
		return 0;
	}
}

namespace sub2{
	ll dp[N][N][N];
	int main(){
		memset(dp, 0, sizeof dp); dp[0][0][0] = 1;
		for(int i = 1; i <= n; ++i)
			for(int j = i; j >= 1; --j)
				for(int x = j; x >= 0; --x)
					for(int y = j - x; y >= 0; --y){
						dp[j][x][y] = (dp[j][x][y] + dp[j - 1][x][y] * a[i][3]) % P;
						dp[j][x][y] = (dp[j][x][y] + dp[j - 1][x][y - 1] * a[i][2]) % P;
						dp[j][x][y] = (dp[j][x][y] + dp[j - 1][x - 1][y] * a[i][1]) % P;
					}
		ll ans = 0;
		for(int j = 1; j <= n; ++j)
			for(int x = 0; x + x <= j; ++x)
				for(int y = (j + 1) / 2 - x; y + y <= j; ++y)
					ans = (ans + dp[j][x][y]) % P;
		printf("%lld\n", ans);
		return 0;
	}
}

namespace sub3{
	ll ans;
	int num[MxM], mx, tot;
	inline bool check(){return (tot && mx + mx <= tot);}
	void dfs(int k, ll sum){
		if(k > n){
			if(check()) ans = (ans + sum) % P;
			return;
		}
		if(mx + mx > n - k + 1 + tot) return;
		int mx1 = mx;
		for(int i = 1; i <= m; i++){
			if(!a[k][i]) continue;
			num[i]++; mx = max(mx, num[i]); tot++;
			dfs(k + 1, sum * a[k][i] % P);
			num[i]--; mx = mx1; tot--;
		}
		dfs(k + 1, sum);
	}
	int main(){
		memset(num, 0, sizeof num); tot = 0;
		mx = 0; ans = 0; dfs(1, 1); printf("%lld\n", ans);
	}
}

int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	
	scanf("%d%d", &n, &m);
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++)
			scanf("%d", &a[i][j]);
	if(m == 2) sub1::main();
	else if(m == 3) sub2::main();
	else sub3::main();
	
	return 0;
}
