#include<cstdio>
#include<cstring>
#include<iostream>
using namespace std;
struct EDGE{
	int to,next,from,last;
}e[600000];
int s[300000],head[300000],top,fa[300000];
void add(int u,int v){
	e[top].from=u;
	e[top].to=v;
	e[top].last=-1;
	e[top].next=head[u];
	e[e[top].next].last=top;
	head[u]=top;
	top++;
}
void dfs(int rt){
	int i;
	s[rt]=1;
	for(i=head[rt];i!=-1;i=e[i].next){
		if(e[i].to==fa[rt]) continue;
		fa[e[i].to]=rt;
		dfs(e[i].to);
		s[rt]+=s[e[i].to];
	}
}
int find(int rt,int s_){
	int i,max_=0,pos,ans=0,sum=0;
	for(i=head[rt];i!=-1;i=e[i].next){
		if(e[i].to==fa[rt]) continue;
		sum+=s[e[i].to];
		if(s[e[i].to]>max_){
			max_=s[e[i].to];
			pos=e[i].to;
		}
	}
	if(max(max_,s_-sum-1)<=(s_>>1)) ans+=rt;
	if(max_>=s_-max_) ans+=find(pos,s_);
	return ans;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	int i;
	for(i=1;i<=t;i++){
		top=0;
		memset(head,255,sizeof(head));
		memset(fa,255,sizeof(fa));
		long long ans=0;
		int n;
		scanf("%d",&n);
		int j,u,v;
		for(j=1;j<n;j++){
			scanf("%d%d",&u,&v);
			add(u,v);
			add(v,u);
		}
		fa[1]=-1;
		dfs(1);
		int t,t_;
		for(j=1;j<n;j++){
			t=(j<<1)-1;
			if(fa[e[t].from]==e[t].to) t^=1;
			t_=e[t].from;
			while(t_!=-1){
				s[t_]-=s[e[t].to];
				t_=fa[t_];
			}
			if(e[t].last==-1) head[e[t].from]=e[t].next;
			else e[e[t].last].next=e[t].next;
			t^=1;
			if(e[t].last==-1) head[e[t].from]=e[t].next;
			else e[e[t].last].next=e[t].next;
			t^=1;
			ans+=find(e[t].to,s[e[t].to])+find(1,s[1]);
			if(e[t].last==-1) head[e[t].from]=t;
			else e[e[t].last].next=t;
			t^=1;
			if(e[t].last==-1) head[e[t].from]=t;
			else e[e[t].last].next=t;
			t^=1;
			t_=e[t].from;
			while(t_!=-1){
				s[t_]+=s[e[t].to];
				t_=fa[t_];
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}

