#include<bits/stdc++.h>
using namespace std;
const int MAXN=3e5+5;
int n,t,a,b;
int fa[MAXN],deep[MAXN];
int tail[MAXN],tot;
int visit[MAXN];
int size[MAXN];
bool flag[MAXN];
struct point {
	int from,to;
	int near;
} edge[MAXN<<1];
struct info {
	int x;
	int step;
};
void add(int from,int to) {
	edge[++tot].from=from;
	edge[tot].to=to;
	edge[tot].near=tail[from];
	tail[from]=tot;
}
void prepare() {
	tot=0;
	memset(tail,0,sizeof(tail));
	scanf("%d",&n);
	for(int i=1; i<n; ++i) {
		scanf("%d%d",&a,&b);
		add(a,b);
		add(b,a);
		visit[a]++;
		visit[b]++;
	}
	int x=1;
	for(int i=1; i<=n; ++i)
		if(visit[i]==1)x=i;
	memset(flag,0,sizeof(flag));
	deep[x]=1;
	info g;
	g.x=x;
	g.step=1;
	queue<info>Q;
	Q.push(g);
	while(!Q.empty()) {
		g=Q.front();
		Q.pop();
		for(int i=tail[g.x]; i; i=edge[i].near) {
			int k=edge[i].to;
			if(flag[k])continue;
			fa[k]=g.x;
			flag[k]=1;
			deep[k]=deep[g.x]+1;
			info syh;
			syh.step=deep[k];
			syh.x=k;
			Q.push(syh);
		}
	}
}
void dfs(int id) {
	size[id]=1;
	flag[id]=1;
	for(int i=tail[id]; i; i=edge[i].near) {
		int k=edge[i].to;
		if(flag[k])continue;
		dfs(k);
		size[id]+=size[k];
	}
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--) {
		prepare();
		long long ans=0;
		for(int i=1; i<=n; ++i)
			if(visit[i]==1||n/2+1==deep[i])ans+=i*2;
			else ans+=i*3;
		printf("%lld\n",ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}

