#include <cstdio>
#include <queue>
#include <cstring>
#define ll long long
using namespace std;
const int Mod = 998244353;
struct Edge{
	int to,next;
}edge[5000005];
struct Node{
	int x;
	int mark[10];
	int flag;
	int pos;
};
queue <Node> que;
ll a[205][2005];
ll ans;
int n,m,cnt;
int head[1000005];
void add_edge(int fr,int to){
	cnt ++;
	edge[cnt].next = head[fr];
	head[fr] = cnt;
	edge[cnt].to = to;
}
int get(int x,int y){
	if(x == 0) return y;
	return (x - 1) * (m + 1) + y + 1; 
}
int getx(int re){
	return (re - 1) / (m + 1) + 1;
}
int gety(int re){
	return (re - 1) % (m + 1);
}
void check(Node f){
	if(f.flag <= 1) return;
	int stard = f.flag / 2;
	for(int i = 1;i <= m;i ++)
		if(f.mark[i] > stard) return;
	ans += f.pos;
	ans = ans % Mod;
}
void bfs(){
	Node s;
	s.x = 0;
	s.pos = 1;
	memset(s.mark,0,sizeof(s.mark));
	s.flag = 0;
	que.push(s);
	while(! que.empty()){
		Node f = que.front();
		que.pop();
		if(f.x  == get(n + 1,0)){
			 check(f);
			 continue;
		}
		for(int i = head[f.x];i;i = edge[i].next){
			int toi = edge[i].to;
			Node t;
			t.x = toi;
			t.pos = f.pos;
			t.flag = f.flag;
			for(int j = 1;j <= m;j ++) t.mark[j] = f.mark[j];
			if(a[getx(toi)][gety(toi)]){
				t.flag = f.flag + 1;
				int mid = gety(toi);
				t.mark[mid] ++;
				t.pos = f.pos * a[getx(toi)][gety(toi)] % Mod;
			}
			que.push(t);
		}
	}
}
int main(){
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);	
	scanf("%d%d",&n,&m);
	for(int i = 1;i <= n;i ++)
		for(int j = 1;j <= m;j ++)
			scanf("%lld",&a[i][j]);
	for(int i = 1;i <= n - 1;i ++){
		for(int j = 1;j <= m;j ++){
			if(a[i][j])
				add_edge(get(i,j),get(i + 1,0));
			for(int k = 1;k <= m;k ++){
				if(a[i][j] && a[i + 1][k])
					add_edge(get(i,j),get(i + 1,k));
			}
		}
	}
	for(int i = 0;i < n;i ++)
		for(int j = 0;j <= m;j ++)
			add_edge(get(i,0),get(i + 1,j));
	for(int i = 0;i <= m;i ++){
		add_edge(get(n,i),get(n + 1,0));
	}
	bfs();
	printf("%lld",ans);
	return 0;
}
