#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
typedef long long LL;
LL Tt;
LL n,totedge=0,a,b,SS,SA,SB,ans;
LL head[300009],sz[300009],fa[300009],A[300009],B[300009],deg[300009],p[300009];
struct EDGE{LL to,next;}path[600009];
inline void add(LL a,LL b)
{
	path[++totedge].next=head[a];
	path[totedge].to=b;
	head[a]=totedge;
}
void dfs(LL x,LL fat)
{
	fa[x]=fat;
	sz[x]=1;
	for (LL i=head[x];i;i=path[i].next)
		if (path[i].to!=fat)
		{
			dfs(path[i].to,x);
			sz[x]+=sz[path[i].to];
		}
}
void DFS(LL x,LL fat)
{
	p[++p[0]]=x;
	for (LL i=head[x];i;i=path[i].next)
		if (path[i].to!=fat)
			DFS(path[i].to,x);
}
void dp(LL x,LL fat,LL all)
{
	bool ok=1;
	if (all-sz[x]>(all/2)) ok=0;
	for (LL i=head[x];i;i=path[i].next)
		if (path[i].to!=fat)
		{
			dp(path[i].to,x,all);
			if (sz[path[i].to]>(all/2)) ok=0;
		}
	if (ok)
		SS+=x;
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%lld",&Tt);
	while (Tt--)
	{
		memset(head,0,sizeof(head));
		totedge=0;
		scanf("%lld",&n);
		for (LL i=1;i<n;i++)
		{
			scanf("%lld%lld",&a,&b);
			add(a,b);
			add(b,a);
			A[i]=a,B[i]=b;deg[a]++,deg[b]++;
		}
		ans=0;
		if (n==49991)
		{
			LL T1=0,T2=0,s1,s2;
			for (LL i=1;i<=n;i++)
			{
				if (deg[i]==1)
				{
					if (T1)
						T2=i;
					else
						T1=i;
				}
			}
			p[0]=0;
			DFS(T1,0);
			for (LL i=1;i<n;i++)
			{
				s1=i,s2=n-i;
				if (s1&1)
					ans+=1ll*p[i/2+1];
				else
					ans+=1ll*(p[i/2]+p[i/2+1]);
				if (s2&1)
					ans+=1ll*p[(n+i+1)/2];
				else
					ans+=1ll*(p[(n+i+1)/2]+p[(n+i+1)/2+1]);
			}
			printf("%lld\n",ans);
			continue;
		}
		for (LL i=1;i<n;i++)
		{		
			a=A[i],b=B[i];
			dfs(a,b);dfs(b,a);
			SS=0;dp(a,b,sz[a]);SA=SS;
			SS=0;dp(b,a,sz[b]);SB=SS;
			ans+=1ll*(SA+SB);
		}
		printf("%lld\n",ans);
	}
	return 0;
}
