#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
typedef long long LL;
const LL pp=998244353;
inline LL ksm(LL x,LL y=pp-2)
{
	LL ans=1;
	while (y)
	{
		if (y&1) ans=ans*x%pp;
		y>>=1;
		x=x*x%pp;
	}
	return ans;
}
int n,m;
LL ans1,ans2,PA,ans,sump;
LL a[2009][109],sum[109],b[2009][109],p[2009][109],f[109][109][109],sufp[109],fac[2009],inv[2009];
LL C(LL n,LL m)
{
	if (m<0 || m>n)
		return 0;
	return fac[n]*inv[m]%pp*inv[n-m]%pp;
}
int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	scanf("%d%d",&n,&m);
	fac[0]=inv[0]=1ll;
	for (int i=1;i<=max(n,m);i++)
		fac[i]=fac[i-1]*(1ll*i)%pp,inv[i]=ksm(fac[i]);
	for (int i=1;i<=n;i++)
		for (int j=1;j<=m;j++)
			scanf("%lld",&a[j][i]);
	ans1=1ll;
	for (int i=1;i<=n;i++)
	{
		sum[i]=0;
		for (int j=1;j<=m;j++)
			sum[i]=(sum[i]+a[j][i])%pp;
		ans1=ans1*(sum[i]+1ll)%pp;
	}
	ans1-=1ll;
	if (ans1<0) ans1+=pp;
	ans2=0ll;
	for (int o=1;o<=m;o++)
	{
		PA=1ll;
		for (int i=1;i<=n;i++)
			b[o][i]=(sum[i]-a[o][i]+pp)%pp;
		memset(f,0,sizeof(f));
		for (int i=n;i>=1;i--)
			for (int j=1;j<=n-i+1;j++)
			{
				if (j==1)
				{
					for (int k=i;k<=n;k++)
						f[i][j][0]=(f[i][j][0]+a[o][k])%pp,f[i][j][1]=(f[i][j][1]+b[o][k])%pp;
					continue;
				}
				for (int k=0;k<=j;k++)
				{
					f[i][j][k]=(a[o][i]*f[i+1][j-1][k]+f[i+1][j][k])%pp;
					if (k)
						f[i][j][k]+=b[o][i]*f[i+1][j-1][k-1]%pp;
					f[i][j][k]%=pp;
				}
			}
		for (int k=1;k<=n;k++)
			for (int t=k/2+1;t<=k;t++)
				for (int i=1;i<=1;i++)
					ans2=(ans2+f[i][k][k-t])%pp;
	}
	ans=ans1-ans2;
	ans=(ans%pp+pp)%pp;
	printf("%lld\n",ans);
	return 0;
}
