#include <cctype>
#include <cstdio>

void openFile() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
}

inline int read() {
	char c; for (c = getchar(); !isdigit(c); c = getchar());
	int x; for (x = 0; isdigit(c); c = getchar()) { x = x * 10 + c - '0'; } return x;
}

const int mod = 998244353;

inline int add(int x, int y) {
	return x + y >= mod ? x + y - mod : x + y;
}
inline int sub(int x, int y) {
	return x - y >= 0 ? x - y : x - y + mod;
}

const int N = 2e2 + 5, M = 2e3 + 5;

int n, m, ans, sum[N], a[N][M], f[N];

int main() {
	openFile(); // 100 pts.
	n = read(); m = read(); ans = 1;
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < m; j++) {
			a[i][j] = read(); sum[i] = add(sum[i], a[i][j]);
		}
		ans = 1ll * ans * add(sum[i], 1) % mod;
	}
	for (int k = 0; k < m; k++) {
		for (int i = 0; i <= n * 2; i++) { f[i] = 0; }
		f[0] = 1;
		for (int i = 1; i <= n; i++) {
			int w0 = a[i][k];
			int w1 = 1;
			int w2 = sub(sum[i], a[i][k]);
			int lim = i * 2;
			for (int j = lim; j >= 0; j--) {
				f[j] = 1ll * f[j] * w0 % mod;
				if (j >= 1) { f[j] = add(f[j], 1ll * f[j - 1] * w1 % mod); }
				if (j >= 2) { f[j] = add(f[j], 1ll * f[j - 2] * w2 % mod); }
			}
		}
		for (int i = 0; i < n; i++) { ans = sub(ans, f[i]); }
	}
	ans = sub(ans, 1);
	printf("%d\n", ans);
	return 0;
}
