#include <bits/stdc++.h>
#define For(a,b,c) for(int a=b;a<=c;++a)
#define LL long long
#define N 50001

using namespace std;

int T,n,x[N],y[N],id,head[N],fa[N],sz[N],S,cnt[N],a[N];
LL ans;
bool vis[N];
struct Edge{int to,next;}edge[N+N];

inline void add(int u,int v){
	edge[++id].to=v;
	edge[id].next=head[u];
	head[u]=id;
}

void dfs(int u){
	vis[u]=1,sz[u]=1;
	for(int i=head[u];i;i=edge[i].next){
		int v=edge[i].to;
		if(!vis[v]){
			fa[v]=u;
			dfs(v);
			sz[u]+=sz[v];
		}
	}
}

inline bool check(int u){
	if(S-sz[u]>(S>>1))return 0;
	for(int i=head[u];i;i=edge[i].next){
		int v=edge[i].to;
		if(v!=fa[u]&&sz[v]>(S>>1))return 0;
	}
	return 1;
}

void find(int u,int num){
	a[num]=u,vis[u]=1;
	for(int i=head[u];i;i=edge[i].next){
		int v=edge[i].to;
		if(!vis[v])find(v,num+1);
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		scanf("%d",&n);
		id=0;
		For(i,1,n)head[i]=0;
		For(i,1,n-1){
			scanf("%d%d",x+i,y+i);
			add(x[i],y[i]);
			add(y[i],x[i]);
		}
		ans=0;
		if(n<=2000){
			For(j,1,n-1){
				For(i,1,n)vis[i]=fa[i]=sz[i]=0;
				vis[y[j]]=1;
				dfs(x[j]);
				S=sz[x[j]];
				For(i,1,n)
					if(sz[i]&&check(i))ans+=i;
				
				For(i,1,n)fa[i]=sz[i]=0;
				dfs(y[j]);
				S=sz[y[j]];
				For(i,1,n)
					if(sz[i]&&check(i))ans+=i;
			}
		}else{
			For(i,1,n)cnt[i]=0;
			For(i,1,n-1)++cnt[x[i]],++cnt[y[i]];
			int k=1;
			for(;cnt[k]==2;++k);
			For(i,1,n)vis[i]=0;
			find(k,1);
			For(i,2,n){
				if(i&1)ans+=a[i>>1]+a[(i+1)>>1];else ans+=a[i>>1];
				if((n-i)&1)ans+=a[(n+i)>>1]+a[(n+i+1)>>1];else ans+=a[(n+i)>>1];
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}
