#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 110;
const ll p = 998244353;

ll a[N][N * 20];
ll ji[N * 20];
bool flag[N];
ll ans;
ll nw[N * 20];
int k;
int n, m;

ll times(ll a, ll b)
{
	ll ans = 0;
	for (;b; b >>= 1)
		if (b & 1){
			ans = (ans + a) % p;
		}
		else a = (a << 1) % p;
	return ans;
}
ll mul(ll a, ll b)
{
	ll ans = 1;
	for (; b; b >>= 1){
		if (b & 1)
			ans = times(ans, a) % p;
		else a = times(a, a) % p;
	}
	return ans;
}
ll c(ll a, ll b)
{
	if (a == b)
		return 1;
	ll ans = ji[b];
	ll sum = times(ji[a], ji[b - a]);
	sum = mul(sum, p - 2);
	return times(ans, sum);
}
void dfs(int xi, ll sum, int last)
{
	if (xi > k){
		ans = (ans + sum) % p;
		return;
	}
	for (int i = last + 1;i <= n; i++)
		if (! flag[i]){
			flag[i] = true;
			for (int j = 1;j <= m; j++){
				if (! a[i][j])
					continue;
				for (int give = 1; nw[j] + 1 <= k / 2 && give <= a[i][j]; give ++){
					nw[j] ++;
					dfs(xi + 1, 1, i);
					nw[j] --;
				}
			}
			flag[i] = false;
		}
}
int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1;i <= n; i++)
		for (int j = 1;j <= m;j ++)
			scanf("%lld", &a[i][j]);
	ji[1] = 1;
	for (int i = 2;i <= 1000; i++)
		ji[i] = times(i, ji[i - 1]);
	for (k = 1;k <= n; k++)
		dfs(1, 1, 0);
	printf("%lld\n", ans % p);
	return 0;
}
