#include<iostream>
#include<fstream>
#include<cstring>
#include<cstdio>
#include<cmath>
#define MAXN 6000
using namespace std;

const int NIL=-1;
const long long INF=1e15+7;
struct Num{long long val,len;}F[MAXN][MAXN];
struct TreeSet{
	int left,right,node;
	long long val,len;
}tree[MAXN][MAXN];
long long s[MAXN],Ans=INF;
int n,type,a[MAXN],num[MAXN];
inline int read(){
	int res=0;
	char op=getchar();
	while (!isdigit(op))	op=getchar();
	while (isdigit(op)){res=(res<<3)+(res<<1)+op-48;op=getchar();}
	return res;
}
void Init(){
	scanf("%d%d",&n,&type);
	if (type==0)	for (int i=1; i<=n; i++)	a[i]=read(),s[i]=a[i]+s[i-1];
	if (type==1){
		
	}
}
void Solve1(){
	memset(F,0,sizeof(F));
	for (register int i=1; i<=n; i++)
		for (register int j=0; j<=n; j++)
			F[i][j].val=INF;
	for (register int i=1; i<=n; i++){
		F[i][i].len=s[i];F[i][i].val=s[i]*s[i];
		for (register int t=1; t<=i; t++){
			F[i][t].len=s[i]-s[i-t];
			for (register int j=1; j<=i-t; j++){
			//	printf("[%d,%d]=%lld--%lld\n",i,t,F[i][t].len,F[i-t][j].len);
				if (F[i-t][j].len>F[i][t].len)	break;
				F[i][t].val=min(F[i][t].val,F[i-t][j].val+(s[i]-s[i-t])*(s[i]-s[i-t]));
			//	printf("#[%d,%d]=%lld\n",i,t,F[i][t].val);system("pause");
			}
		}
	}
	for (register int i=1; i<=n; i++)	Ans=min(Ans,F[n][i].val);
	printf("%lld\n",Ans);
}
void Insert(int state,int p,long long len,long long val){
//	printf("%d %d %lld %lld\n",state,p,len,val);system("pause");
	if (tree[state][p].node==NIL){
		if (num[state]==0)	tree[state][p].node=++num[state];
		else				tree[state][p].node=num[state];
		tree[state][p].len=len;
		tree[state][p].val=val;
		return;
	}
	if (len<tree[state][p].len){
		if (tree[state][p].left==NIL){
			tree[state][p].left=++num[state];
			Insert(state,tree[state][p].left,len,val);
		}
	}
	else{
		if (tree[state][p].right==NIL){
			tree[state][p].right=++num[state];
			Insert(state,tree[state][p].right,len,val);
		}
	}
	tree[state][p].val=min(tree[state][tree[state][p].left].val,tree[state][tree[state][p].right].val);
}
long long Query(int state,int p,long long len){
	if (tree[state][p].node==NIL)	return 0;
	if (len<tree[state][p].len){
		if (tree[state][p].left==NIL)	return INF;
		else							return Query(state,tree[state][p].left,len);
	}
	else{
		if (tree[state][p].right==NIL)	return tree[state][p].val;
		else							return Query(state,tree[state][p].right,len);
	}
}
void Solve2(){
	memset(F,0,sizeof(F));
	memset(tree,-1,sizeof(tree));
	for (register int i=1; i<=n; i++)
		for (register int j=0; j<=n; j++)
			F[i][j].val=INF;
	for (register int i=1; i<=n; i++){
		F[i][i].len=s[i];F[i][i].val=s[i]*s[i];
		for (register int t=1; t<=i; t++){
			F[i][t].len=s[i]-s[i-t];
			for (register int j=1; j<=i-t; j++){
			//	printf("[%d,%d]=%lld--%lld\n",i,t,F[i][t].len,F[i-t][j].len);
				F[i][t].val=Query(i-t,1,s[i]-s[i-t])+(s[i]-s[i-t])*(s[i]-s[i-t]);
				Insert(i,1,s[i]-s[i-t],F[i][t].val);
			//	printf("#[%d,%d]=%lld\n",i,t,F[i][t].val);system("pause");
			}
		}
	}
	for (register int i=1; i<=n; i++)	Ans=min(Ans,F[n][i].val);
	printf("%lld\n",Ans);
}
int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	Init();
	if (n<=5000)Solve1();
	else		Solve2();
	return 0;
}
