#include<iostream>
#include<cstdio>
#include<cstring>

typedef long long ll;
ll read()
{
	ll x=0,f=1;
	char c=getchar();
	while(c<'0'||c>'9')
	{
		if(c=='-')f=-1;
		c=getchar();
	}
	while(c>='0'&&c<='9')
	{
		x=x*10+c-'0';
		c=getchar();
	}
	return f*x;
}

#define MAXN 200011
struct Edge
{
	ll v,nxt;
}e[MAXN<<1|1];
ll ecnt=0,last[MAXN];
void adde(ll u,ll v)
{
	e[++ecnt].v=v;
	e[ecnt].nxt=last[u],last[u]=ecnt;
}

ll ans=0,size[MAXN],cnt=0,ff[MAXN];
bool vis[MAXN];
void build(ll u)
{
	for(ll i=last[u];i;i=e[i].nxt)
	{
		ll v=e[i].v;
		if(v==ff[u])continue;
		ff[v]=u;
		build(v);
	}
}
void count(ll u,ll fa=0)
{
	++cnt;
	vis[u]=1;
	for(ll i=last[u];i;i=e[i].nxt)
	{
		ll v=e[i].v;
		if(v==fa)continue;
		count(v,u);
	}
}
void dfs(ll u,ll fa)
{
	size[u]=1;
	for(ll i=last[u];i;i=e[i].nxt)
	{
		ll v=e[i].v;
		if(v==fa)continue;
		dfs(v,u);
		size[u]+=size[v];
	}
	for(ll i=last[u];i;i=e[i].nxt)
	{
		ll v=e[i].v;
		if(v==fa)continue;
		if(size[v]>cnt/2)return;
	}
	if(cnt-size[u]>cnt/2)return;
	ans+=u;
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ll task=read();
	while(task--)
	{
		ans=0;
		memset(last,0,sizeof last);
		ecnt=0;
		ll n=read();
		for(ll i=1;i<n;++i)
		{
			ll u=read(),v=read();
			adde(u,v);adde(v,u);
		}
		build(1);
		for(ll i=2;i<=n;++i)
		{
			cnt=0;count(i,ff[i]);
			dfs(i,ff[i]);
			cnt=0;count(ff[i],i);
			dfs(ff[i],i);
			//printf("del %lld,ans=%lld\n",i,ans);
		}
		printf("%lld\n",ans);
	}
	fclose(stdin);fclose(stdout);
	return 0;
}
