#include <cstdio>
#include <cstring>
#define max_n 262143
#define max_m max_n-1<<2
#define ll long long
using namespace std;
struct node{
	int v,nxt;
	node(){}
	node(int _v,int _nxt):v(_v),nxt(_nxt){}
};
struct graph{
	int head[max_n+1];
	int cnt;
	node edge[max_m];
	void build(){
		memset(head,-1,sizeof(head));
		cnt=-1;
	}
	void insert(int u,int v){
		push(u,v);
		push(v,u);
	}
	void push(int u,int v){
		edge[++cnt]=node(v,head[u]);
		head[u]=cnt;
	}
};
graph g;
int deg[max_n+1];
int a[max_n+1];
void dlian(int n,int rt){
	int cnt=1;
	a[1]=rt;
	for(int i=1; ++i<=n; a[i]=g.edge[g.head[a[i-1]]].v==a[i-2]?g.edge[g.edge[g.head[a[i-1]]].nxt].v:g.edge[g.head[a[i-1]]].v);
	long long ans=0;
//	for(int i=0; ++i<=n; printf("%d:%d\n",i,(int((i<<1)<n)+int((i<<1)-1<n)+int((i<<1)-2<n&&i>1)+int((n-i+1<<1)<n)+int((n-i+1<<1)-1<n)+int((n-i+1<<1)-2<n&&i<n))));
	for(int i=0; ++i<=n; ans+=(long long)(int((i<<1)<n)+int((i<<1)-1<n)+int((i<<1)-2<n&&i>1)+int((n-i+1<<1)<n)+int((n-i+1<<1)-1<n)+int((n-i+1<<1)-2<n&&i<n))*a[i]);
	printf("%lld\n",ans);
}
int non;
ll times[max_n+1];
int siz[max_n+1],mxsiz[max_n+1],mxszs[max_n+1];
void sizing(int rt,int p){
	siz[rt]=1,mxsiz[rt]=0,mxszs[rt]=0;
	for(int i=g.head[rt]; ~i; i=g.edge[i].nxt){
		if((i>>1)==non||g.edge[i].v==p)
			continue;
		sizing(g.edge[i].v,rt);
		siz[rt]+=siz[g.edge[i].v],siz[g.edge[i].v]>mxsiz[rt]&&(mxsiz[rt]=siz[g.edge[i].v],mxszs[rt]=g.edge[i].v);
	}
}
void dfs(int rt,int elsiz){
	if(elsiz>(siz[rt]+elsiz>>1))
		return;
	mxsiz[rt]<=(siz[rt]+elsiz>>1)&&(++times[rt]);
	mxszs[rt]&&(dfs(mxszs[rt],siz[rt]+elsiz-mxsiz[rt]),0);
}
void rting(int u){
	sizing(u,0);
	dfs(u,0);
}
void test(){
	int n;
	scanf("%d",&n);
	if(n==1){
		puts("0");
		return;
	}
	g.build();
	memset(deg,0,sizeof(deg));
	for(int i=n,u,v; --i; g.insert(u,v),++deg[u],++deg[v])
		scanf("%d%d",&u,&v);
	int rt;
	bool flag=1;
	for(rt=0; deg[++rt]!=1; flag&=bool(deg[rt]<=2));
	for(int i=rt; ++i<=n; flag&=bool(deg[i]<=2));
//	printf("rt:%d,flag:%d\n",rt,int(flag));
	if(flag){
		dlian(n,rt);
		return;
	}
	if(n>2000){
		for(rt=0; deg[++rt]!=2; );
		ll ans=(ll)(n>>1)*(rt+g.edge[g.head[rt]].v+g.edge[g.edge[g.head[rt]].nxt].v)+(ll)(1+n)*n/2;
		printf("%lld\n",ans);
		return;
	}
	memset(times,0,sizeof(times));
	for(non=-1; ++non<n-1; ){
		rting(g.edge[non<<1].v);
		rting(g.edge[non<<1|1].v);
	}
	ll ans=0;
	for(int i=0; ++i<=n; ans+=times[i]*i);
	printf("%lld\n",ans);
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	while(test(),--t);
	return 0;
}
