#include<bits/stdc++.h>
#define ll long long
using namespace std;
const ll N=3e5+1e3;

ll read()
{
	ll s=0;
	char c=getchar(),lc='+';
	while (c<'0'||'9'<c) lc=c,c=getchar();
	while ('0'<=c&&c<='9') s=s*10+c-'0',c=getchar();
	return lc=='-'?-s:s;
}
void write(ll x)
{
	if (x<0)
	{
		putchar('-');
		x=-x;
	}
	if (x<10) putchar(x+'0');
	else
	{
		write(x/10);
		putchar(x%10+'0');
	}
}
void print(ll x,char c='\n')
{
	write(x);
	putchar(c);
}
struct edge
{
	bool cut;
	ll to,next;
}e[2*N];
ll head[N],cnt,ans=0,n,size[N],Max[N],m;
void add(ll u,ll v)
{
	e[++cnt].to=v;
	e[cnt].next=head[u];
	e[cnt].cut=0;
	head[u]=cnt;
}
void dfs(ll now,ll father)
{
	ll ret=0;
	Max[now]=0;
	size[now]=1;
	for (ll i=head[now];i>=0;i=e[i].next)
	if (e[i].cut==0&&e[i].to!=father)
	{
		int to=e[i].to;
		dfs(to,now);
		size[now]+=size[to];
		Max[now]=max(Max[now],size[to]);
	}
}
ll count(ll now,ll father)
{
	ll ret=0;
	for (ll i=head[now];i>=0;i=e[i].next)
	if (e[i].cut==0&&e[i].to!=father) ret+=count(e[i].to,now);
	Max[now]=max(Max[now],m-size[now]);
	if (Max[now]<=m/2) ret+=now;
	return ret;
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);

	ll T=read();
	while (T--)
	{
		ans=0;
		cnt=-1;
		memset(head,-1,sizeof(head));
		n=read();
		for (ll i=1;i<n;i++)
		{
			ll u=read(),v=read();
			add(u,v);
			add(v,u);
		}
		for (ll i=1;i<n;i++)
		{
			ll Cut=i*2-2;
			e[Cut].cut=1;
			e[Cut^1].cut=1;
			for (ll j=1;j<=n;j++) size[j]=0;
			for (ll j=1;j<=n;j++) if (size[j]==0)
			{
				dfs(j,0);
				m=size[j];
				ans+=count(j,0);
			}
			e[Cut^1].cut=0;
			e[Cut].cut=0;
		}
		print(ans);
	}

	return 0;
}
