#include <cstdio>
#include <cmath>
#include <cstring>
#include <vector>
#include <map>

const int N = 110;
const int M = 10;
const int MOD = 998244353;

int n, m;
int a[N][M];
int tot[M];
int ans;
std::vector<std::pair<int, int> > p;
bool operator<(std::vector<std::pair<int, int> > v1, std::vector<std::pair<int, int> > v2) { return true; }
std::map<std::vector<std::pair<int, int> >, bool> vis;

void Dfs(int dep, int k) {
  // if (p.size() == 1 && dep == 3)
  //   printf("qwq\n");
  // printf("%d\n", dep);
  if (dep == n + 1 || p.size() == k) {
    // printf("qwq\n");
    if (p.size() != k)
      return;
    if (vis[p])
      return;
    vis[p] = true;
    int sum = 1;
    for (int i = 0; i < (int)p.size(); ++i) {
      // printf("%d %d\n", p[i].first, p[i].second);
      sum = 1ll * sum * a[p[i].first][p[i].second] % MOD;
    }
    // printf("==========\n");
    ans += sum;
    return;
  }
  if (k - p.size() > k - dep + 2)
    return;
  int sum = 0;
  for (int i = 1; i <= m; ++i) {
    if (tot[i] < floor(k / 2.0) && a[dep][i]) {
      // printf("%d %d\n", dep, i);
      ++tot[i];
      p.push_back(std::make_pair(dep, i));
      Dfs(dep + 1, k);
      --tot[i];
      p.pop_back();
    }
    Dfs(dep + 1, k);
  }
}

int main() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  scanf("%d%d", &n, &m);
  for (int i = 1; i <= n; ++i)
    for (int j = 1; j <= m; ++j)
      scanf("%d", &a[i][j]);
  for (int i = 2; i <= n; ++i) {
    // printf("i: %d\n", i);
    Dfs(1, i);
    // printf("%d\n", ans);
  }
  printf("%d\n", ans);
  return 0;
}
