#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ifstream fin("partition.in");
ofstream fout("partition.out");

const int kMaxN = 5005;
int n, t;
const ll kInf = 5e18;
ll a[kMaxN], ans = kInf;

void solve(int l, int r, ll last, ll res) {
	if (res > ans) {
		return;
	}
	if (l > n) {
//		cerr << res << endl;
		ans = min(ans, res);
		return;
	}
	ll sum = 0;
	for (int i = l; i <= r; ++i) {
		sum = sum + a[i];
		if (sum >= last) {
			solve(i + 1, r, sum, res + sum * sum);
		}
	}
}

void resolve() {
	for (int i = 1; i <= n; ++i) {
		fin >> a[i];
	}
	solve(1, n, 0, 0); // 24pts for random data
	fout << ans << endl;
}

namespace Fake {
ll f[kMaxN][kMaxN], g[kMaxN][kMaxN], a[kMaxN];

void resolve() {
	for (int i = 1; i <= n; ++i) {
		fin >> a[i];
	}
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j) {
			f[i][j] = kInf;
			g[i][j] = 0;
		}
	}
	f[0][0] = 0;
	g[0][0] = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= i; ++j) {
			if (f[i - 1][j - 1] + a[i] * a[i] <= f[i - 1][j] + 2LL * g[i - 1][j] * a[i] + a[i] * a[i]) {
				g[i][j] = a[i] * a[i];
				f[i][j] = f[i - 1][j - 1] + a[i] * a[i];
			} else {
				g[i][j] = g[i - 1][j] + 2LL * g[i - 1][j] * a[i] + a[i] * a[i];
				f[i][j] = f[i - 1][j] + 2LL * g[i - 1][j] * a[i] + a[i] * a[i];
			}
//			cerr << f[i][j] << " ";
		}
//		cerr << endl;
	}
	ll ans = f[n][1];
	for (int i = 1; i <= n; ++i) {
		ans = min(ans, f[n][i]);
	}
	fout << ans << endl;
}
}

int main() {
	fin >> n >> t;
	if (t == 0) {
		if (n <= 400) {
			resolve();
		} else {
			Fake::resolve();
		}
		return 0;
	}
	return 0;
}

