#include <cstdio>
#include <cstring>
#include <cassert>
using namespace std;
const int N = 3000005;
int n,head[N],v[N * 2],nxt[N * 2],w[N * 2],ptr,rm_id;
inline void add_edge(int uu,int vv)
{ v[ptr] = vv;nxt[ptr] = head[uu];head[uu] = ptr++; }
struct Edge{int a,b;} e[N];
int sz[N],root;
long long ans = 0;
void dfs(int pos,int fa)
{
	sz[pos] = 1;
	for (int i = head[pos];i != -1;i = nxt[i])
		if (v[i] != fa) dfs(v[i],pos),sz[pos] += sz[v[i]];
	//printf("Size of %d is %d\n",pos,sz[pos]);
}
void dfs2(int pos,int fa)
{
	bool check = (sz[root] - sz[pos] <= sz[root] / 2);
	for (int i = head[pos];i != -1;i = nxt[i])
		if (v[i] != fa)
		{
			dfs2(v[i],pos);
			check &= (sz[v[i]] <= sz[root] / 2);
		}
	if (check) ans += pos/*,printf("Centroid %d\n",pos)*/;
}
namespace SLink
{
	int id[N],deg[N],idx;
	void dfs(int pos,int fa)
	{
		id[++idx] = pos;
		for (int i = head[pos];i != -1;i = nxt[i])
			if (v[i] != fa) dfs(v[i],pos);
	}
	void solve()
	{
		memset(deg,0,sizeof(deg));int l = 0;
		for (int i = 1;i < n;i++) ++deg[e[i].a],++deg[e[i].b];
		for (int i = 1;i <= n;i++)
			if (deg[i] == 1) l = i;
		idx = 0;dfs(l,0);
		long long ans = 0;
		for (int i = 1;i < n;i++) //Split on (i,i + 1)
		{
			int l = 1,r = i;
			if ((r - l + 1) & 1) ans += id[(l + r) >> 1];
			else ans += id[(l + r) / 2] + id[(l + r) / 2 + 1];
			l = i + 1;r = n;
			if ((r - l + 1) & 1) ans += id[(l + r) >> 1];
			else ans += id[(l + r) / 2] + id[(l + r) / 2 + 1];
		}
		printf("%lld\n",ans);
	}
}
int main ()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;scanf("%d",&T);
	while (T--)
	{
		scanf("%d",&n);
		memset(head,-1,sizeof(head));ptr = 0;
		int t1,t2;
		for (int i = 1;i < n;i++)
		{
			scanf("%d%d",&t1,&t2);e[i].a = t1,e[i].b = t2;
			add_edge(t1,t2);add_edge(t2,t1);
		}
		if (n % 10 == 1) { SLink::solve();continue; }
		ans = 0;
		for (int i = 1;i < n;i++)
		{
			//printf("RMEdge%d %d\n",e[i].a,e[i].b);
			dfs(e[i].a,e[i].b);dfs(e[i].b,e[i].a);
			// puts("Cur Tree");
			root = e[i].a;dfs2(e[i].a,e[i].b);//puts("Another Tree:");
			root = e[i].b;dfs2(e[i].b,e[i].a);
		}
		printf("%lld\n",ans);
		
	}
	fclose(stdin);fclose(stdout);
	return 0;
}
