// Developed by Nekroz
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define int long long
#define MOD 998244353
#define N 105
#define B 300
//const int BUF = 1 << 21;
//char buf[BUF], *p1 = buf, *p2 = buf;
//#define gc() (p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, BUF, stdin)), p1 == p2 ? EOF : *p1++)
#define gc() getchar()
class Scanner {
public:
	inline int nextInt() {
		int num = 0, sign = 1; char ch = gc();
		while (ch < '0' || ch > '9') sign = ch == '-' ? -1 : 1, ch = gc();
		while (ch >= '0' && ch <= '9') num = (num << 3) + (num << 1) + (ch ^ '0'), ch = gc();
		return num * sign;
	}
} cin;
int n, m, ans;
int g[N], a[N][N];
inline bool check() {
	int sum = 0;
	for (int i = 1; i <= m; i++) sum += g[i];
	if (sum == 0) return false;
	for (int i = 1; i <= m; i++)
		if (g[i] > sum / 2) return false;
	return true;
}
inline void solve1(int t) {
	if (t > n) {
		if (check()) ans++;
		return;
	}
	for (int i = 1; i <= m; i++) {
		solve1(t + 1);
		for (int j = 1; j <= a[t][i]; j++) {
			g[i] += j;
			solve1(t + 1);
			g[i] -= j;
		}
	}
}
inline int ModularPow(int a, int p, int k) {
	int ans = 1; 
	while (p) {
		if (p & 1) (ans *= a) %= k;
		(a *= a) %= k;
		p >>= 1;
	}
	return ans;
}
inline void plus(long long &a, long long b) {
	a += b; if (a > MOD) a -= MOD;
}
inline void minus(long long &a, long long b) {
	a -= b; if (a < 0) a += MOD;
}
inline int C(int n, int m) {
	int ans1 = 1, ans2 = 1;
	for (int i = 1; i <= m; i++)
		(ans1 *= (n - i + 1)) %= MOD, (ans2 *= i) %= MOD;
	return ans1 * ModularPow(ans2, MOD - 2, MOD) % MOD;
}
long long f[2][B << 1];
inline long long solve2(int major) {
	memset(f, 0, sizeof f);
	int cur = 1;
	for (int i = 1; i <= m; i++) {
		int sign = i == major ? 1 : -1;
		for (int j = 1; j <= a[1][i]; j++)
			f[0][sign * j + B] += C(a[1][i], j);
	}
	for (int i = 2; i <= n; i++, cur ^= 1) {
		int choice1 = a[i][major], choice2 = 0;
		for (int j = 1; j <= m; j++)
			if (j != major) choice2 = std::max(choice2, a[i][j]);
		memcpy(f[cur], f[cur ^ 1], sizeof f);
		for (int j = 1; j <= choice1; j++) {
			int number = C(choice1, j);
			for (int k = 0; k < 2 * B; k++) 
				if (k >= j)	plus(f[cur][k], f[cur ^ 1][k - j] * number % MOD);
		}
		for (int j = 1; j <= choice2; j++)
			for (int k = 1; k <= m; k++)
				if (k != major && a[i][k] >= j) {
					int number = C(a[i][k], j);
					for (int l = 0; l < 2 * B; l++)
						if (k + j < 2 * B)
							plus(f[cur][k], f[cur ^ 1][k + j] * number);
				}
	}
	int ans = 0;
	for (int i = 1; i < 2 * B; i++) plus(ans, f[cur ^ 1][i]);
	return ans;
}
signed main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	n = cin.nextInt(), m = cin.nextInt(); int max = 0;
	for (int i = 1; i <= n; i++) for (int j = 1; j <= m; j++) a[i][j] = cin.nextInt(), max = std::max(a[i][j], max);
	if (max == 1) solve1(1);
	else {
		long long ans = 1;
		for (int i = 1; i <= n; i++) {
			long long tmp = 0;
			for (int j = 1; j <= m; j++) plus(tmp, ModularPow(2, a[i][j], MOD) - 1);  
			(ans *= tmp + 1) %= MOD;
		}
		for (int i = 1; i <= m; i++)
		minus(ans, solve2(i));
	}
	std::cout << ans << std::endl;
	return 0;
}

