#include <bits/stdc++.h>
using namespace std;
const int N=300005;
int vet[N<<1],nxt[N<<1],head[N<<1],edgenum,n;
struct node { int u,v; } E[N<<1];
void Add(int u,int v) {
	vet[++edgenum]=v; nxt[edgenum]=head[u]; head[u]=edgenum;
}
namespace S1 {
	int deg[N],p[N],cnt;
	void dfs(int x,int fa) {
		p[++cnt]=x;
		for (int e=head[x]; e; e=nxt[e]) {
			int v=vet[e]; if (v==fa) continue;
			dfs(v,x);
		}
	}
	void main() {
		cnt=0; for (int i=1; i<=n; i++) deg[i]=0;
		for (int i=1; i<n; i++) deg[E[i].u]++,deg[E[i].v]++;
		int top=0;
		for (int i=1; i<=n; i++)
			if (deg[i]==1) top=i;
		dfs(top,0); 
		long long ans=0;
		for (int i=1; i<n; i++) {
			int l1=1,r1=i,l2=i+1,r2=n;
			if ((l1+r1)%2==0) ans+=(long long)p[(l1+r1)/2];
			else ans+=(long long)p[(l1+r1)/2]+p[(l1+r1+1)/2];
			if ((l2+r2)%2==0) ans+=(long long)p[(l2+r2)/2];
			else ans+=(long long)p[(l2+r2)/2]+p[(l2+r2+1)/2];
		}
		printf("%lld\n",ans);
	}
}
namespace S2 {
	bool flag[N<<1];
	int n1,sz[N];
	long long ans;
	void dfs1(int x,int fa) {
		sz[x]=1;
		for (int e=head[x]; e; e=nxt[e]) {
			int v=vet[e]; if (v==fa || flag[e]) continue;
			dfs1(v,x); sz[x]+=sz[v];
		}
	}
	void dfs2(int x,int fa) {
		int maxn=0;
		for (int e=head[x]; e; e=nxt[e]) {
			int v=vet[e]; if (v==fa || flag[e]) continue;
			dfs2(v,x); maxn=max(maxn,sz[v]);
		}
		maxn=max(maxn,n1-sz[x]);
		if (maxn<=n1/2) ans+=(long long)x;
	}
	void main() {
		ans=0;
		for (int i=1; i<n; i++) {
			flag[i*2]=flag[i*2-1]=1;
			dfs1(E[i].u,0); dfs1(E[i].v,0);
			n1=sz[E[i].u]; dfs2(E[i].u,0); 
			n1=sz[E[i].v]; dfs2(E[i].v,0);
			flag[i*2]=flag[i*2-1]=0;
		}
		printf("%lld\n",ans);
	}
}
namespace S3 {
	bool flag[N<<1];
	int n1,sz[N],deg[N],FA[N];
	long long ans;
	void dfs1(int x,int fa) {
		sz[x]=1;
		for (int e=head[x]; e; e=nxt[e]) {
			int v=vet[e]; if (v==fa || flag[e]) continue;
			dfs1(v,x); sz[x]+=sz[v];
		}
	}
	void dfs2(int x,int fa,int d) {
		int maxn=0;
		if (d>5) return;
		for (int e=head[x]; e; e=nxt[e]) {
			int v=vet[e]; if (v==fa || flag[e]) continue;
			dfs2(v,x,d+1); maxn=max(maxn,sz[v]);
		}
		maxn=max(maxn,n1-sz[x]);
		if (maxn<=n1/2) ans+=(long long)x;
	}
	void dfs3(int x,int f) {
		FA[x]=f;
		for (int e=head[x]; e; e=nxt[e]) {
			int v=vet[e]; if (v==f || flag[e]) continue;
			dfs3(v,x); 
		}
	}
	void main() {
		for (int i=1; i<=n; i++) deg[i]=0;
		for (int i=1; i<n; i++) deg[E[i].u]++,deg[E[i].v]++;
		int id=0;
		for (int i=1; i<=n; i++)
			if (deg[i]==2) id=i;
		dfs3(id,0);
		ans=0;
		for (int i=1; i<n; i++) {
			flag[i*2]=flag[i*2-1]=1;
			dfs1(E[i].u,0); dfs1(E[i].v,0);
			if (FA[E[i].u]==E[i].v) {
				n1=sz[E[i].u]; dfs2(E[i].u,0,0); 
				n1=sz[E[i].v]; dfs2(id,0,0);
			} else {
				n1=sz[E[i].u]; dfs2(id,0,0); 
				n1=sz[E[i].v]; dfs2(E[i].v,0,0);
			}
			flag[i*2]=flag[i*2-1]=0;
		}
		printf("%lld\n",ans);
	}
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T; scanf("%d",&T);
	while (T--) {
		scanf("%d",&n);
		for (int i=1; i<=edgenum; i++) head[i]=nxt[i]=vet[i]=0;
		edgenum=0;
		for (int i=1; i<n; i++) {
			int u,v; scanf("%d%d",&u,&v);
			Add(u,v),Add(v,u);
			E[i].u=u,E[i].v=v;
		}
		if (n==49991) 
		S1::main();
		else if (n==262143)
		S3::main();
		else S2::main();
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7

1
11
7 8
8 6
6 10
10 3
3 5
5 4
4 9
9 1
1 11
11 2

*/
