#include<bits/stdc++.h>
using namespace std;
#define ll long long
int n;
namespace Sub1
{
	const int N=2005;
	struct Edge
	{
		int v,nxt,id;
	};
	Edge edge[N*2];
	int fir[N];
	int ss;
	int del=0;
	ll ans=0;
	void add(int u,int v,int id)
	{
		ss++;
		edge[ss].v=v;edge[ss].nxt=fir[u];
		edge[ss].id=id;
		fir[u]=ss;
		ss++;
		edge[ss].v=u;edge[ss].nxt=fir[v];
		edge[ss].id=id;
		fir[v]=ss;
	}
	int siz[N];
	bool vis[N];
	int tot;
	int bfs(int u)
	{
		for(int i=1;i<=n;i++) vis[i]=0;
		vis[u]=1;
		int ans=1;
		queue<int> q;
		q.push(u);
		while(!q.empty())
		{
			int x=q.front();
			q.pop();
//			cout<<x<<endl;
			for(int i=fir[x];i!=0;i=edge[i].nxt)
			{
				if(edge[i].id==del) continue;
				int v=edge[i].v;
				if(!vis[v])
				{
//					printf("%d %d %d\n",x,i,v);
					ans++;
					vis[v]=1;
					q.push(v);
				}
			}
		}
		return ans;
	}
	void dfs(int u,int fa)
	{
		siz[u]=1;
		bool ok=1;
		for(int i=fir[u];i!=0;i=edge[i].nxt)
		{
			if(edge[i].id==del) continue;
			int v=edge[i].v;
			if(v==fa) continue;
			dfs(v,u);
			siz[u]+=siz[v];
			if(siz[v]>tot/2) ok=0;
		}
		if(tot-siz[u]>tot/2) ok=0;
		if(ok) ans+=u;
	}
	void Main()
	{
		for(int i=1;i<=n;i++) fir[i]=0;
		ss=0;
		ans=0;
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d %d",&u,&v);
			add(u,v,i);
		}
		for(int i=1;i<n;i++)
		{
//			cout<<i<<" : \n";
			del=i;
			tot=bfs(1);
//			cout<<tot<<endl;
			for(int j=1;j<=n;j++) siz[j]=0;
			dfs(1,0);
			tot=n-tot;
			for(int j=1;j<=n;j++)
			{
				if(!siz[j])
				{
					dfs(j,0);break;
				}
			}
		}
		cout<<ans<<endl;
	}
};
namespace Sub2
{
	const int N=50005;
	struct Edge
	{
		int v,nxt;
	};
	Edge edge[N*2];
	int fir[N];
	int dgr[N];
	int ss;
	ll ans=0;
	int a[N];
	void add(int u,int v)
	{
		ss++;
		edge[ss].v=v;edge[ss].nxt=fir[u];
		fir[u]=ss;
		ss++;
		edge[ss].v=u;edge[ss].nxt=fir[v];
		fir[v]=ss;
	}
	void work(int l,int r)
	{
		if((r-l+1)%2==1)
		{
			ans+=a[(r+l)/2];
		}
		else
		{
			ans+=a[(r+l)/2]+a[(r+l+1)/2];
		}
	}
	void Main()
	{
		for(int i=1;i<=n;i++) a[i]=0;
		for(int i=1;i<=n;i++) dgr[i]=0;
		for(int i=1;i<=n;i++) fir[i]=0;
		ss=0;
		ans=0;
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d %d",&u,&v);
			add(u,v);
			dgr[u]++,dgr[v]++;
		}
		int beg=0;
		for(int i=1;i<=n;i++)
		{
			if(dgr[i]==1)
			{
				beg=i;break;
			}
		}
		int cur=beg,las=0;
		for(int i=1;i<=n;i++)
		{
			a[i]=cur;
			int x=cur;
			for(int j=fir[cur];j!=0;j=edge[j].nxt)
			{
				int v=edge[j].v;
				if(v!=las)
				{
					cur=v;break;
				}
			}
			las=x;
		}
//		for(int i=1;i<=n;i++) printf("%d ",a[i]);
//		cout<<'\n';
		for(int i=1;i<n;i++)
		{
			work(1,i),work(i+1,n);
		}
		cout<<ans<<endl;
	}
};
namespace Sub3
{
	const int N=300005;
	int u[N],v[N];
	struct Edge
	{
		int v,nxt;
	};
	Edge edge[N*2];
	int fir[N];
	int dgr[N];
	int ss;
	void add(int u,int v)
	{
		ss++;
		edge[ss].v=v;edge[ss].nxt=fir[u];
		fir[u]=ss;
		ss++;
		edge[ss].v=u;edge[ss].nxt=fir[v];
		fir[v]=ss;
	}
	void Main(int m)
	{
		for(int i=1;i<=n;i++) dgr[i]=0;
		for(int i=1;i<=n;i++) fir[i]=0;
		ss=0;
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d %d",&u,&v);
			add(u,v);
			dgr[u]++,dgr[v]++;
		}
		ll ans=0;
		for(int i=1;i<=n;i++) ans+=i;
		for(int i=1;i<=n;i++)
		{
			if(dgr[i]==2)
			{
				ans+=1LL*i*((1LL<<(m-1))-1);
				for(int j=fir[i];j!=0;j=edge[j].nxt)
				{
					int v=edge[j].v;
					ans+=1LL*v*((1LL<<(m-1))-1);
				}
				break;
			}
		}
		cout<<ans<<endl;
	}
}
void work()
{
	scanf("%d",&n);
	if(n<=2000)
	{
		Sub1::Main();
		return ;
	}
	if(n%10==1)
	{
		Sub2::Main();
		return ;
	}
	int s3=0;
	for(int i=1;i<=18;i++)
	{
		if((1LL<<i)-1==n) s3=i;
	}
	if(s3!=0)
	{
		Sub3::Main(s3);
		return ;
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	cin>>T;
	while(T--) work();
	return 0;
}
