#include<bits/stdc++.h>
#define For(i, j, k) for(int i = (j); i <= (k); i++)
using namespace std;
const int MAXN = 300005;
int n, deg[MAXN];
struct Edge {
	int u, v, nxt;
}e[MAXN << 1];
int lst[MAXN], tot = 0;
void addedge(int u, int v) {
	e[++tot] = (Edge) {u, v, lst[u]};
	lst[u] = tot;
}

int vis[MAXN], siz[MAXN], res = 0;
void dfs1(int u, int fa, int del) {
	siz[u] = vis[u] = 1;
	for(int i = lst[u]; ~i; i = e[i].nxt) {
		int v = e[i].v;
		if(v == fa || (i^1) == del || i == del) continue;
		dfs1(v, u, del);
		siz[u] += siz[v];
	}
}
void dfs2(int u, int fa, int del) {
	int t, l;
	if(~fa) {
		t = siz[fa], l = siz[u];
		siz[fa] -= siz[u];
		siz[u] = t;
	}
	int ok = 1;
	for(int i = lst[u]; ~i; i = e[i].nxt) {
		int v = e[i].v;
		if((i^1) == del || i == del) continue;
//		cout << v << ' ' << siz[v] << endl;
		if(siz[v] > siz[u] / 2) ok = 0;
	}
//	cout << ok << ' ' << u << endl;
	res += ok * u;
	for(int i = lst[u]; ~i; i = e[i].nxt) {
		int v = e[i].v;
		if(v == fa || (i^1) == del || i == del) continue;
		dfs2(v, u, del);
	}
	if(~fa) {
		siz[fa] = t;
		siz[u] = l;
	}
}
void solve(int del) {
	dfs1(1, -1, del);
//	For(i, 1, n) cout << siz[i] << endl;
	dfs2(1, -1, del); 
//	cout << "***" << endl;
	For(i, 1, n) {
		if(!vis[i]) {
			dfs1(i, -1, del);
			dfs2(i, -1, del);
			break;
		}
	}
//	cout << res << endl;
}
int checkSUB1() {
	int pos = 0;
	For(i, 1, n) {
		if(deg[i] == 1) pos = i;
		else if(deg[i] != 2) return 0;
	}
	return pos;
}
int num[MAXN], idx;
void dfs3(int u, int fa) {
	num[++idx] = u;
	for(int i = lst[u]; i; i = e[i].nxt) {
		int v = e[i].v;
		if(v == fa) continue;
		dfs3(v, u);
	}
}
void init() {
	memset(lst, -1, sizeof(lst)); tot = -1;
	idx = 0; memset(deg, 0, sizeof(deg));
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; cin >> T;
	while(T--) {
		init();
		scanf("%d", &n);
		For(i, 1, n-1) {
			int u, v;
			scanf("%d %d", &u, &v);
			addedge(u, v); addedge(v, u);
			deg[u]++, deg[v]++;
		}
		if(n <= 0) {
			int ans = 0;
			For(i, 1, n-1) {
				res = 0;
				For(j, 1, n) siz[j] = 0;
				For(j, 1, n) vis[j] = 0;
				solve((i-1)*2);
				ans += res;
			}
			cout << ans << endl;
			continue;
		}
		int pos;
		if(pos = checkSUB1()) {
			dfs3(pos, -1);
			long long ans = 0;
			For(i, 1, n-1) {
				if(i % 2 == 0)
					ans += num[i/2];
				ans += num[i/2+1];
				if((n-i) % 2 == 0) ans += num[i+(n-i)/2];
				ans += num[i+1+(n-i)/2];
			}
			cout << ans << endl;
			continue;
		}
		
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/

