#include <iostream>
#include <algorithm>
#include <cstdio>

template <typename Tp>
inline void read(Tp &x) {
    x = 0;
    bool f = true; char ch = getchar();
    for ( ; ch < '0' || ch > '9'; ch = getchar()) f ^= ch == '-';
    for ( ; ch >= '0' && ch <= '9'; ch = getchar()) x = x * 10 + (ch ^ 48);
    x = f ? x : -x;
}

const int N = 105, P = 998244353;

int Tot[N];
bool Flg[N];

struct Node {
    int x, y, w;
};
Node A[N];

inline int Calc(int x) {
    int ret = 0;
    for (int i = 0; i <= 20; ++i) if ((1 << i) & x) ++ret;
    return ret;  
}

int main() {
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    int n, m;
    read(n), read(m);
    int k = 0;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j) {
            int x;
            read(x);
            if (x) A[++k].x = i, A[k].y = j, A[k].w = x;
        }
    int Ans = 0;
    for (int i = 1; i < (1 << k); ++i) {
        int x = Calc(i);
        if (x > n) continue;
        std::fill(Tot + 1, Tot + m + 1, 0);
        std::fill(Flg + 1, Flg + n + 1, false);
        bool F = true;
        int Sum = 1;
        for (int j = 1; j <= k; ++j) {
            if (!((1 << (j - 1)) & i)) continue;
            Sum = 1LL * Sum * A[j].w % P;
            if (Flg[A[j].x]) {
                F = false;
                break;
            }
            Flg[A[j].x] = true;
            if (++Tot[A[j].y] > x / 2) {
                F = false;
                break;
            }
        }
        if (F) Ans = (Ans + Sum) % P;
    }
    printf("%d\n", Ans);
    return 0;
}