#include <bits/stdc++.h>
using namespace std;

const int N = 5e5 + 5;

typedef long long LL;
const LL INF = 4e18 + 1;
const LL Sqinf = 2e9 + 1;

int n, m,  ty;
LL A[N], S[N];

LL fix(LL x) {
  return min(x, INF);
}

LL Sqr(LL x) {
  x = min(x, Sqinf);
  return x * x;
}

void read(LL &x) {
  x = 0; char ch = getchar();
  while(!isdigit(ch)) ch = getchar();
  while(isdigit(ch)) {
    x = x * 10 + ch - '0';
    ch = getchar();
  }
}

namespace solver1 {
  LL dp[5005][5005];
  void main() {
    for(int i = 0; i <= n; ++ i) {
      for(int j = 0; j <= n; ++ j) {
	dp[i][j] = INF;
      }
    }
  
    dp[0][0] = 0;
    for(int i = 1; i <= n; ++ i) {
      dp[i][0] = fix(Sqr(S[i]));
    }
    for(int i = 1; i <= n; ++ i) {
      for(int j = i - 1; j >= 0; -- j)
	dp[i][j] = min(dp[i][j], dp[i][j + 1]);
      //for(int j = 0; j <= n; ++ j) cerr << i <<" " << j <<" " << dp[i][j] << endl;
      int p = i;
      for(int j = i + 1; j <= n; ++ j) {
	while(p > 0 && S[i] - S[p - 1] <= S[j] - S[i]) -- p;
	//if(j == 3) cerr << j <<" " << i <<" " << p <<" " << dp[i][p] <<" " << Sqr(S[j] - S[i]) << endl;
	dp[j][i] = fix(dp[i][p] + Sqr(S[j] - S[i]));
      }
    }
    cout << dp[n][0] << endl;    
  }
}

namespace solver2 {
  LL dp[N], q[N], cnt, L[N];
  void main() {
    int p = 1;
    cnt = 0;
    L[0] = 0;
    q[++ cnt] = 0;
    for(int i = 1; i <= n; ++ i) {
      while(p < cnt && S[i] >= L[q[p + 1]]) ++ p;
      dp[i] = fix(dp[q[p]] + Sqr(S[i] - S[q[p]]));
      L[i] = 2 * S[i] - S[q[p]];
      while(L[q[cnt]] >= L[i]) -- cnt;
      q[++ cnt] = i;
    }
    cout << dp[n] << endl;
  }
}

int main() {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
  scanf("%d%d", &n, &ty);
  for(int i = 1; i <= n; ++ i)
    read(A[i]), S[i] = S[i - 1] + A[i];
  if(n <= 5000) solver1 :: main();
  else
    solver2 :: main();
}
