#include<algorithm>
#include<cstdio>
#include<cstring>
#include<string>
#include<iostream>

using namespace std;

void read(int &x)
{
	char c=getchar();
	x=0;
	while (c<'0'||c>'9') c=getchar();
	while ('0'<=c&&c<='9') x=x*10+c-'0',c=getchar();
}

const int N=300300;

struct p
{
	int x,y;
} a[N];
int Next[N*2],head[N],to[N*2],size[N],fa[N],cnt=0;
ll ans;

void add(int x,int y)
{
	Next[++cnt]=head[x];
	to[cnt]=y;
	head[x]=cnt;
}

void dfs1(int x)
{
	size[x]=1;
	for (int i=head[x];i;i=Next[i])
	{
		if (to[i]!=fa[x]) fa[to[i]]=x,dfs1(to[i]),size[x]+=size[to[i]];
	}
}

void dfs(int x,int y,int pos)
{
	int flag=1;
	if (pos-size[x]>pos/2) flag=0;
//	if (flag) return ;
	for (int i=head[x];i;i=Next[i])
		if (to[i]!=y&&to[i]!=fa[x]) 
		{
			if (size[to[i]]>pos/2) flag=0;
			dfs(to[i],y,pos);
		}
	ans+=flag*x;
//	if (flag) cout<<x<<" ";
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	read(T);
	while (T--)
	{
		int n;
		read(n);
		ans=0;cnt=0;
		memset(head,0,sizeof head);
		memset(fa,0,sizeof fa);
		memset(size,0,sizeof size);

		for (int i=1;i<n;i++)
		{
			read(a[i].x);read(a[i].y);
			add(a[i].x,a[i].y);add(a[i].y,a[i].x);
		}
		fa[1]=0;
		dfs1(1);
		for (int i=1;i<n;i++)
		{
			if (a[i].y==fa[a[i].x]) swap(a[i].x,a[i].y);
			int qxq=a[i].x;
			while (qxq) size[qxq]-=size[a[i].y],qxq=fa[qxq];
//		for (int i=1;i<=n;i++) cout<<size[i]<<" ";
//		cout<<"||"<<endl;
			dfs(1,a[i].y,size[1]);
//			cout<<" ;;;  "<<size[1]<<" "<<size[3];
//			cout<<endl;
			dfs(a[i].y,a[i].x,size[a[i].y]);
//			cout<<endl;
			qxq=a[i].x;
			while (qxq) size[qxq]+=size[a[i].y],qxq=fa[qxq];
		}
		cout<<ans<<endl;
	}
	return 0;
}
