#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long LL;

inline LL in()
{
    LL x = 0, flag = 1;char ch = getchar();
    while (!isdigit(ch)) { if (ch == '-') flag = -1;ch =  getchar(); }
    while (isdigit(ch)) x = (x << 3) + (x << 1) + (ch ^ 48), ch = getchar();
    return x * flag;
}

int n, m;

const LL MOD = 998244353;

LL f[42][42][42][42];
LL a[102][1002];

void add(LL & x, LL y)
{
    x += y;
    x %= MOD;
}

int main()
{
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    n = in();
    m = in();
    for (int i = 1; i <= n; ++ i)
	for (int j = 1; j <= m; ++ j)
	    a[i][j] = in();
    f[0][0][0][0] =1;
    LL ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
	for (int j = 0; j <= i; ++ j)
	    for (int k = 0; j + k <= i; ++ k)
		for (int p = 0; j + k + p <= i; ++ p)
		{
		    if (j > 0) add(f[i][j][k][p], f[i - 1][j - 1][k][p] * a[i][1] % MOD);
		    if (k > 0) add(f[i][j][k][p], f[i - 1][j][k - 1][p] * a[i][2] % MOD);
		    if (p > 0) add(f[i][j][k][p], f[i - 1][j][k][p - 1] * a[i][3] % MOD);
		    add(f[i][j][k][p], f[i - 1][j][k][p]);
//		    printf("f[%d][%d][%d][%d] = %lld\n", i, j, k, p, f[i][j][k][p]);
		    if (i == n)
		    {
			int tot = j + k + p;
			if (tot >= 1 && p <= tot / 2 && j <= tot / 2 && k <= tot / 2)
			{
//			    printf("f[%d][%d][%d] = %lld\n", j, k, p, f[i][j][k][p]);
			    add(ans, f[i][j][k][p]);
			}
		    }
		}
    }
    printf("%lld\n", ans);
    return 0;
}
