#include<bits/stdc++.h>
#define N 600000
using namespace std;

int T, n, tot, ans, num, num1, num2, U[N], V[N], Size[N], head[N], ver[N], Next[N];
bool flag[N]; 

void add(int u, int v) {
	ver[++tot] = v;
	Next[tot] = head[u];
	head[u] = tot;
}

void dfs_size(int u, int fa) {
	num++;
	for (int i = head[u]; i; i = Next[i]) {
		int v = ver[i];
		if (v == fa) continue;
		dfs_size(v, u);
	}
}

void dfs(int u, int fa, int s) {
	Size[u] = 1;
	for (int i = head[u]; i; i = Next[i]) {
		int v = ver[i];
		if (v == fa) continue;
		dfs(v, u, s);
		Size[u] += Size[v]; 
		if (Size[v] > s / 2) flag[u] = 1;
	}
	if (s - Size[u] > s / 2) flag[u] = 1;
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T--) {
		memset(head, 0, sizeof(head));
		scanf("%d", &n);
		bool check = 1;
		for (int i = 1; i < n; i++) {
			scanf("%d%d", &U[i], &V[i]);
			add(U[i], V[i]); add(V[i], U[i]);
			if (U[i] != V[i] + 1 && V[i] != U[i] + 1) check = 0;
		}
		if (n <= 10000) {
			ans = 0;
			for (int i = 1; i < n; i++) {
				num = 0;
				memset(flag, 0, sizeof(flag));
				dfs_size(U[i], V[i]);
				num1 = num, num2 = n - num1;
				dfs(U[i], V[i], num1); dfs(V[i], U[i], num2);
				for (int i = 1; i <= n; i++)
					if (!flag[i]) ans += i;
			}
			printf("%d\n", ans);
			continue;
		}
		if (check) {
			long long now = 0;
			for (int i = 1; i < n; i++) {
				if (i % 2 == 0) now += (long long) i / 2 + i / 2 + 1;
				else now += (long long) i / 2 + 1;
				if ((n - (i + 1) + 1) % 2 == 0) now += (long long) (i + 1 + n) / 2 + (i + 1 + n) / 2 + 1;
				else now += (long long) (i + 1 + n) / 2; 
			}
			printf("%lld\n", now);
			continue;
		}
	}
	return 0;
}
