#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
typedef long long ll;
template <typename T>
inline void read (T &x) {
    x = 0;
    char ch = getchar();
    while (!isdigit(ch))
        ch = getchar();
    while (isdigit(ch)) {
        x = x * 10 + ch - '0';
        ch = getchar();
    }
}
const int N = 100 + 1, M = 2000 + 1;
const ll mod = 998244353;
int n, m, lim, p[N], cnt[M];
ll a[N][M], ans;
bool used[N];
void dfs (int dep, int pre) {
    // printf("%d %d %d\n", lim, dep, pre);
    if (dep == lim) {
        ll cur = 1;
        for (int i = 1; i <= n; i++)
            if (p[i])
                cur = (cur * a[i][p[i]]) % mod;
        // for (int i = 1; i <= n; i++)
        //     if (p[i])
        //         printf("[%d %d] ", i, p[i]);
        // puts("");
        ans = (ans + cur) % mod;
        // printf("%lld %lld\n", cur, ans);
        return;
    }
    int maxi = n - (lim - dep - 1);
    for (int i = pre + 1; i <= maxi; i++)
        for (int j = 1; j <= m; j++) {
            if (!a[i][j] || cnt[j] >= (lim >> 1))
                continue;
            // printf("choose %d %d\n", i, j);
            p[i] = j, ++cnt[j];
            dfs(dep + 1, i);
            p[i] = 0, --cnt[j];
            // printf("revert %d %d\n", i, j);
        }
}
int main () {
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    read(n), read(m);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            read(a[i][j]);
    for (int k = 2; k <= n; k++)
        lim = k, dfs(0, 0);
    printf("%lld\n", ans);
}