#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 105, M = 2005, mod = 998244353;
int n, m, a[N][M], w[N], f[N][N], g[N][M], h[N][N][N];
void precalc () {
	f[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j <= i; ++j) {
			if (j) {
				f[i][j] = (1ll * f[i - 1][j - 1] * w[i] + f[i][j]) % mod;
			}
			f[i][j] = (f[i - 1][j] + f[i][j]) % mod;
		}
	}
	for (int k = 1; k <= m; ++k) {
		for (int i = 0; i <= n; ++i) {
			for (int j = 0; j <= n; ++j) {
				for (int k = 0; k <= n; ++k) {
					h[i][j][k] = 0;
				}
			}
		}
		h[0][0][0] = 1;
		for (int i = 1; i <= n; ++i) {
			for (int j = 0; j <= i; ++j) {
				for (int l = 0; l <= j; ++l) {
					h[i][j][l] = (h[i][j][l] + h[i - 1][j][l]) % mod;
					if (j && l) {
						h[i][j][l] = (1ll * h[i - 1][j - 1][l - 1] * a[i][k] + h[i][j][l]) % mod;
					}
					if (j) {
						h[i][j][l] = (1ll * h[i - 1][j - 1][l] * (w[i] - a[i][k] + mod) + h[i][j][l]) % mod;
					}
				}
			}
		}
		for (int i = 1; i <= n; ++i) {
			for (int j = i / 2 + 1; j <= i; ++j) {
				g[i][k] = (g[i][k] + h[n][i][j]) % mod;
			}
		}
	}
}
int solve () {
	int ret = 0, dlt = 0;
	for (int i = 1; i <= n; ++i) {
		ret = (ret + f[n][i]) % mod;
		for (int j = 1; j <= m; ++j) {
			dlt = (dlt + g[i][j]) % mod;
		}
	}
	ret = (ret - dlt + mod) % mod;
	ret = (ret % mod + mod) % mod;
	return ret;
}
int main () {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			scanf("%d", &a[i][j]);
			w[i] = (w[i] + a[i][j]) % mod;
		}
	}
	precalc();
	printf("%d\n", solve());
	return 0;
}
