#include <iostream>

using namespace std;

const long long modification = 998244353;

int n,m;
int a[200][2100];
long long ans = 0;

int useOf[2100];
long long now = 1;

void dfs(int me_index) {
	if(me_index > n) {
		
		int dishNum = 0;
		for(int i = 1; i <= m; i++) {
			dishNum += useOf[i];
		}
		if(dishNum == 0) return;
		
		bool yazidAgreement = true;
		for(int i = 1; i <= m; i++) {
			if( useOf[i] * 2 > dishNum ) {
				yazidAgreement = false;
				break;
			}
		}
		
		if(yazidAgreement) {
			ans = (ans + now) % modification;
		}
		
		return;
	}
	
	dfs(me_index + 1);
	
	for(int i = 1; i <= m; i++) {
		if( a[me_index][i] > 0 && useOf[i] <= a[me_index][i] ) {
			useOf[i]++;
			long long temp = now;
			now = ( now * a[me_index][i] ) % modification;
			dfs(me_index + 1);
			useOf[i]--;
			now = temp;
		}
	}
}

int main() {
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	
	cin >> n >> m;
	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= m; j++) {
			cin >> a[i][j];
		}
	}
	
	dfs(1);
	cout << ans;
	return 0;
}
