#include <iostream>
#include <climits>
#include <vector>

using namespace std;

int n,type;
int a[5100];
int ans = INT_MAX;

vector<int> v;

void dfs(int index) {
	if(index > n) {
		int size = v.size();
		int sum = 0;
		for(int i = 0; i < size - 1; i++) {
			if(v[i] > v[i+1]) return;
			sum += v[i] * v[i];
		}
		sum += v[size - 1] * v[size - 1];
		if(sum == 0) {
			cout<<"*********";
			for(int i=0;i<size;i++) cout << v[i] <<" ";
			cout<<"*********";
			cout << endl;
		}
		
		if(sum < ans) ans = sum;
		return;
	}
	v.push_back(a[index]);
	dfs(index + 1);
	v.pop_back();
	if(v.size() > 0) {
		v[v.size() - 1] += a[index];
		dfs(index + 1);
		v[v.size() - 1] -= a[index];
	}
}

int main() {
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	
	cin >> n >> type;
	if(type == 0) {
		for(int i = 1; i <= n; i++) {
			cin >> a[i];
		}
		dfs(1);
	}
	cout << ans;
	return 0;
}
