#include <bits/stdc++.h>
using namespace std;
const int N = 1e5 + 10;
int T, n;
int e1[N],e2[N],head[N],cnt = 0;
struct Edge{int to,next;}edge[N << 1];
void addedge(int x,int y) {edge[++cnt].to = y;edge[cnt].next = head[x]; head[x] = cnt;}
int root1,root2,Max = 0,size[N],gf;
void init() {
	for(int i = 1; i <= n; i++) head[i] = 0;
	cnt = 0;
}
void getsz(int x,int fa) {
	size[x] = 1;
	for(int i = head[x]; i; i = edge[i].next) {
		int v = edge[i].to;
		if(v == fa) continue;
		getsz(v,x);
		size[x] += size[v];
	}
}
void dfs(int x,int fa) {
	int mx = 0;
	for(int i = head[x]; i; i = edge[i].next) {
		int v = edge[i].to;
		if(v == fa) continue;
		mx = max(mx,size[v]);
	}
	mx = max(mx,size[gf] - size[x]);
	if(mx == Max) root2 = x;
	if(mx < Max) root1 = x, root2 = 0, Max = mx;
	// cout << "$$$ " << x << " " << mx << endl;
	for(int i = head[x]; i; i = edge[i].next) {
		int v = edge[i].to;
		if(v == fa) continue;
		dfs(v,x);
	}
}
void calc(int x,int y) {
	// cout << "# " << x << " " << y << endl; 
	Max = 1e9;
	root1 = root2 = 0;
	gf = x;
	getsz(x,y);
	dfs(x,y);
	// for(int i = 1; i <= n; i++) cout << "^^ " << i << " " << size[i] << endl;
	// cout << root1 << " " << root2 << endl;
}
int main(int argc,char *argv[]) {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--) {
		scanf("%d",&n);
		init();
		for(int i = 1; i < n; i++) {
			int x, y; scanf("%d %d",&x,&y);
			e1[i] = x, e2[i] = y;
			addedge(x, y); addedge(y, x);
		}
		int ans = 0;
		for(int i = 1; i < n; i++) {
			for(int i = 1; i <= n; i++) size[i] = 0;
			calc(e1[i],e2[i]);
			ans += root1 + root2;
			calc(e2[i],e1[i]);
			ans += root1 + root2;
		}
		printf("%d\n",ans);
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
