#include <bits/stdc++.h>
#define N 2000
using namespace std;

struct NODE{
	int number,sum;
	int Friend[N];
	int Friends;
};

NODE Map[N];
int n;
int Kill[N][2];
int ans;
bool Find[N];

void init(){
	memset(Map,0,sizeof(Map));
	memset(Kill,0,sizeof(Kill));
	cin>>n;
	Map[1].number=1;
	for(int i=2;i<=n;i++){
		Map[i].number=i;
		int x,y;
		cin>>x>>y;
		Kill[i-1][0]=x;
		Kill[i-1][1]=y;
		Map[x].sum++;
		Map[y].sum++;
		Map[x].Friend[++Map[x].Friends]=y;
		Map[y].Friend[++Map[y].Friends]=x;
	}
	ans=0;
}

bool judge(int i,int key){
	for(int j=1;j<=n;j++){
		if(Find[j])	continue;
		if(Map[i].Friend[j]==key)
			return true;
	}
	for(int j=1;j<=n;j++){
		if(Find[i])	continue;
		Find[i]=true;
		bool FIND=judge(Map[i].Friend[j],key);
		Find[i]=false;
		if(FIND)
			return true;
	}
	return false;
}

int solve(int key,int who){
	int node[N];
	int len=1;
	node[len]=Map[key].number;
	for(int i=1;i<=Map[key].Friends;i++){
		if(Map[key].Friend[i]==who)
			continue;
		if(judge(i,key))
			node[++len]=Map[key].Friend[i];
	}
	int Max=-1;
	int a=0;
	for(int i=1;i<=len;i++){
		if(Map[node[i]].sum>Max)
			Max=Map[node[i]].sum;
	}
	for(int i=1;i<=len;i++){
		if(Map[node[i]].sum==Max)
			a+=Map[node[i]].number;
	}
	return a;
}

void solve(){
	for(int i=1;i<n;i++){
		Map[Kill[i][0]].sum--;
		Map[Kill[i][1]].sum--;
		ans+=solve(Kill[i][0],Kill[i][1]);
		ans+=solve(Kill[i][1],Kill[i][0]);
		Map[Kill[i][0]].sum++;
		Map[Kill[i][1]].sum++;
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int TIME;
	cin>>TIME;
	while(TIME--){
		init();
		solve();
		cout<<ans<<endl;
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
