#include<cstdio>
#include<cstring>
#include<algorithm>
typedef long long ll;
using std::min;
using std::max;
inline int read()
{
	int res=0;
	char ch;
	while((ch=getchar())<'0'||ch>'9');
	for(;ch>='0'&&ch<='9';ch=getchar())
		res=res*10+ch-'0';
	return res;
}
const int N=3e5+5;
int n,idx;
ll ans;
namespace bit
{
	int sum[N];
	inline void init()
	{
		register int i;
		for(i=1;i<=n;i++)
			sum[i]=0;
		return;
	}
	inline void add(int x,int k)
	{
		while(x<=n)
			sum[x]+=k,x+=x&-x;
		return;
	}
	inline int ask(int x)
	{
		int res=0;
		while(x)
			res+=sum[x],x&=x-1;
		return res;
	}
}
int x[N],y[N],deg[N];
int pool[N<<1],cnt[N];
int *ptr,*e[N];
int c,size[N],max_size[N],hson[N];
int id[N],dsize[N];
void get_id(int x,int father)
{
	register int i;
	id[x]=++idx;dsize[idx]=size[x];
	if(hson[x])
		get_id(hson[x],x);
	for(i=0;i<deg[x];i++)
		if(e[x][i]!=father&&e[x][i]!=hson[x])
			get_id(e[x][i],x);
	return;
}
void calc(int x,int father,int f)
{
	register int i;
	size[x]=1;max_size[x]=0;hson[x]=0;
	for(i=0;i<deg[x];i++)
		if(e[x][i]!=father)
		{
			calc(e[x][i],x,f);
			size[x]+=size[e[x][i]];
			if(size[e[x][i]]>max_size[x])
				max_size[x]=size[e[x][i]],hson[x]=e[x][i];
		}
	if(f&&(n-size[x]>max_size[x]))
		max_size[x]=n-size[x];
	if(f&&(!c||max_size[x]<max_size[c]))
		c=x;
	return;
}
//void dfs2(int x,int father,int k)
//{
//	register int i;
//	bit::add(size[x],k);
//	for(i=0;i<deg[x];i++)
//		if(e[x][i]!=father)
//			dfs2(e[x][i],x,k);
//	return;
//}
void dfs(int x,int father)
{
	int l,r,k,m;
	register int i,j;
	if(father)
	{
		k=n-size[x];m=max_size[x];
		r=min(n-2*m,k);l=max(2*k-n,1);
		if(l<=r)
			ans+=(ll)x*(bit::ask(r)-bit::ask(l-1));
	}
	if(!hson[x])
	{
		bit::add(1,1);
		return;
	}
	for(i=id[hson[x]]+size[hson[x]];i<=id[x]+size[x]-1;i++)
		bit::add(dsize[i],1);
//	for(i=0;i<deg[x];i++)
//		if(e[x][i]!=father&&e[x][i]!=hson[x])
//			dfs2(e[x][i],x,1);
	bit::add(n-size[hson[x]],1);
	dfs(hson[x],x);
	bit::add(n-size[hson[x]],-1);
	for(i=0;i<deg[x];i++)
		if(e[x][i]!=father&&e[x][i]!=hson[x])
		{
			for(j=id[e[x][i]];j<=id[e[x][i]]+size[e[x][i]]-1;j++)
				bit::add(dsize[j],-1);
//			dfs2(e[x][i],x,-1);
			bit::add(n-size[e[x][i]],1);
			dfs(e[x][i],x);
			bit::add(n-size[e[x][i]],-1);
		}
	bit::add(size[x],1);
	return;
}
inline void solve()
{
	int l,r,m,k;
	register int i,j;
	n=read();ans=0;idx=0;
//	fprintf(stderr,"%d\n",n);
	memset(deg+1,0,sizeof(int)*n);
	memset(cnt+1,0,sizeof(int)*n);
	for(i=1;i<=n-1;i++)
		x[i]=read(),y[i]=read(),deg[x[i]]++,deg[y[i]]++;
	ptr=pool;
	for(i=1;i<=n;i++)
		e[i]=ptr,ptr+=deg[i];
	for(i=1;i<=n-1;i++)
		e[x[i]][cnt[x[i]]++]=y[i],e[y[i]][cnt[y[i]]++]=x[i];
	c=0;
	calc(1,0,1);
	calc(c,0,0);
	get_id(c,0);
	bit::init();
	dfs(c,0);
	bit::init();
	for(i=0;i<deg[c];i++)
		if(e[c][i]==hson[c])
		{
			for(j=id[e[c][i]];j<=id[e[c][i]]+size[e[c][i]]-1;j++)
				bit::add(dsize[j],1);
//			dfs2(e[c][i],c,1);
			k=size[e[c][i]];m=0;
			for(j=0;j<deg[c];j++)
				if(e[c][j]!=hson[c]&&size[e[c][j]]>m)
					m=size[e[c][j]];
			r=min(n-2*m,k);l=max(2*k-n,1);
			if(l<=r)
				ans+=(ll)c*(bit::ask(r)-bit::ask(l-1));
			for(j=id[e[c][i]];j<=id[e[c][i]]+size[e[c][i]]-1;j++)
				bit::add(dsize[j],-1);
//			dfs2(e[c][i],c,-1);
		}
		else
		{
			for(j=id[e[c][i]];j<=id[e[c][i]]+size[e[c][i]]-1;j++)
				bit::add(dsize[j],1);
//			dfs2(e[c][i],c,1);
			k=size[e[c][i]];m=max_size[c];
			r=min(n-2*m,k);l=max(2*k-n,1);
			if(l<=r)
				ans+=(ll)c*(bit::ask(r)-bit::ask(l-1));
			for(j=id[e[c][i]];j<=id[e[c][i]]+size[e[c][i]]-1;j++)
				bit::add(dsize[j],-1);
//			dfs2(e[c][i],c,-1);
		}
	printf("%lld\n",ans);
	return;
}
signed main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	T=read();
	while(T--)
		solve();
	return 0;
}
