#include <cstdio>
#include <cstring>
#include <queue>
#define LL long long
using namespace std;
const int maxn = 3e5 + 5;
struct E{
	int to, nxt;
}e[maxn << 1];
int head[maxn], tot;
void addedge(int u, int v){
	e[++tot].to = v, e[tot].nxt = head[u];
	head[u] = tot;
}
int n, a[maxn], cnt;
//void dfs(int cur, int fa){
//	for (int i = head[cur]; i; i = e[i].nxt){
//		int v = e[i].to;
//		if (v != fa) a[++cnt] = v, dfs(v, cur);
//	}
//}
bool vis[maxn];
void bfs(int s){
	queue <int> q; while (!q.empty()) q.pop();
	q.push(s); memset(vis, 0, sizeof vis); vis[s] = 1;
	while (!q.empty()){
		int cur = q.front(); q.pop();
		for (int i = head[cur]; i; i = e[i].nxt)
			if (!vis[e[i].to]){
				a[++cnt] = e[i].to; q.push(e[i].to), vis[e[i].to] = 1;
			}
	}
}
int sz[maxn];
void dfs2(int cur, int fa){
	sz[cur] = 1;
	for (int i = head[cur]; i; i = e[i].nxt){
		int v = e[i].to;
		if (v != fa){
			dfs2(v, cur);
			sz[cur] += sz[v];
		}
	}
}
LL ans; int ind[maxn], c[maxn];
int u[maxn], v[maxn];
int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; scanf("%d", &T);
	while (T--){
		memset(ind, 0, sizeof ind);
		memset(head, 0, sizeof head); tot = 0;
		memset(c, 0, sizeof c); cnt = 0; ans = 0;
		scanf("%d", &n);
		for (int i = 1; i < n; i++){
			scanf("%d%d", &u[i], &v[i]);
			addedge(u[i], v[i]); addedge(v[i], u[i]);
			++ind[u[i]], ++ind[v[i]];
		}
		if (n % 10 == 1){
			int S, T;
			for (int i = 1; i <= n; i++)
				if (ind[i] == 1) S = i;	
			a[cnt = 1] = S; bfs(S);
			for (int i = 1; i < n; i++){
				if (i % 2 == 1) c[i / 2 + 1]++;
				else c[i / 2]++, c[i / 2 + 1]++;
				if ((n - i) % 2 == 1) c[i + (n - i) / 2 + 1]++;
				else c[i + (n - i) / 2 + 1]++, c[i + (n - i) / 2]++;
			}               
			for (int i = 1; i <= n; i++) ans = ans + 1ll * c[i] * a[i];
			printf("%lld\n", ans);
		}
		if (n == 7 || n == 5 || n % 10 == 9){
			for (int i = 1; i < n; i++){
				memset(sz, 0, sizeof sz);
				dfs2(u[i], v[i]);
				for (int cur = 1; cur <= n; cur++){
					if (!sz[cur] || (sz[u[i]] - sz[cur]) > sz[u[i]] / 2) continue; bool f = 1;
					for (int j = head[cur]; j; j = e[j].nxt)
						if (sz[e[j].to] > sz[u[i]] / 2 && sz[e[j].to] < sz[cur]) f = 0;
					c[cur] += f;
				}
				memset(sz, 0, sizeof sz);
				dfs2(v[i], u[i]);
				for (int cur = 1; cur <= n; cur++){
					if (!sz[cur] || (sz[v[i]] - sz[cur]) > sz[v[i]] / 2) continue; bool f = 1;
					for (int j = head[cur]; j; j = e[j].nxt)
						if (sz[e[j].to] > sz[v[i]] / 2 && sz[e[j].to] < sz[cur]) f = 0;
					c[cur] += f;
				}
			}
			for (int i = 1; i <= n; i++)
				ans += 1ll * c[i] * i;
			printf("%lld\n", ans);
		}
	}
	return 0;         
}                     
