#include <cstdio>
#include <cstring>
#include <algorithm>
#define LL long long
using namespace std;
const LL INF = 0x3f3f3f3f3f3f3f3f;
const int maxn = 4e6 + 5;
int n, opt, b[maxn], tot;
LL f[maxn][2], s[maxn][2], c[maxn][2], a[maxn];
LL ans = 0;
void dfs(int dep){
	if (dep == n + 1){
		LL res = 0;
		for (int i = 1; i <= tot; i++) res += 1ll * b[i] * b[i];
		ans = min(ans, res);
		return;
	}
	if (a[dep] >= b[tot]){
		b[++tot] = a[dep];
		dfs(dep + 1); --tot;
		return;
	}
	if (a[dep] < b[tot]){
		b[tot] += a[dep];
		dfs(dep + 1);
		b[tot] -= a[dep];
		if (dep != n){
			a[dep + 1] += a[dep];
			dfs(dep + 1);
			a[dep + 1] -= a[dep];
		}
	}
}
int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &opt);
//	if (opt == 0){
//		for (int i = 1; i <= n; i++) scanf("%d", a + i);
//		b[tot = 1] = a[1];
//		for (int i = 2; i < n; i++)
//			if (b[tot] <= a[i]) b[++tot] = a[i];
//			else if (b[tot] + a[i] > a[i + 1]) a[i + 1] += a[i];
//			else b[tot] += a[i];
//		if (a[n] < b[tot]) b[tot] += a[n];
//		else b[++tot] = a[n];
//		for (int i = 1; i <= tot; i++) ans += 1ll * b[i] * b[i];
//		printf("%lld\n", ans);
//	}
	for (int i = 1; i <= n; i++) scanf("%lld", a + i);
	if (n <= 20){
		ans = INF;
		dfs(1);
		printf("%lld\n", ans);
		return 0;
	}
	memset(f, 0x3f, sizeof f); memset(s, 0x3f, sizeof s); memset(c, 0x3f, sizeof c);
	f[1][1] = 0; s[1][1] = a[1]; c[1][1] = a[1];
	for (int i = 2; i <= n; i++){
		if (s[i - 1][0] != INF){
			if (s[i - 1][0] + a[i] >= c[i - 1][0]){
				if (f[i][1] < f[i - 1][0] + 2ll * s[i - 1][0] * a[i]) continue;
				if (f[i][1] == f[i - 1][0] + 2ll * s[i - 1][0] * a[i]){
					s[i][1] = min(s[i][1], s[i - 1][0] + a[i]);
					continue;
				}
				s[i][1] = s[i - 1][0] + a[i];
				f[i][1] = f[i - 1][0] + 2ll * s[i - 1][0] * a[i];
			}
			else if (s[i - 1][0] + a[i] < c[i - 1][0]){
				if (f[i][0] < f[i - 1][0] + 2ll * s[i - 1][0] * a[i]) continue;
				if (f[i][0] > f[i - 1][0] + 2ll * s[i - 1][0] * a[i])
					s[i][0] = s[i - 1][0] + a[i], c[i][0] = c[i - 1][0],
					f[i][0] = f[i - 1][0] + 2ll * s[i - 1][0] * a[i];
				else if (f[i][0] == f[i - 1][0] + 2ll * s[i - 1][0] * a[i])
					s[i][0] = min(s[i][0], s[i - 1][0] + a[i]), c[i][0] = min(c[i][0], c[i - 1][0]);
			}
		}
		if (s[i - 1][1] != INF){
			if (s[i - 1][1] <= a[i]){
				if (f[i][1] < f[i - 1][1]) continue;
				if (f[i][1] > f[i - 1][1]) f[i][1] = f[i - 1][1], s[i][1] = a[i];
				else s[i][1] = min(s[i][1], a[i]);
			}
			else if (s[i - 1][1] > a[i]){
				if (f[i][1] > f[i - 1][1] + 2ll * s[i - 1][1] * a[i])
					f[i][1] = f[i - 1][1] + 2ll * s[i - 1][1] * a[i],
					s[i][1] = s[i - 1][1] + a[i];
				else if (f[i][1] == f[i - 1][1] + 2ll * s[i - 1][1] * a[i]) s[i][1] = min(s[i][1], s[i - 1][1] + a[i]);
				if (f[i][0] > f[i - 1][1])
					f[i][0] = f[i - 1][1],
					s[i][0] = a[i],
					c[i][0] = s[i - 1][1];
				else if (f[i][0] == f[i - 1][1]) s[i][0] = min(s[i][0], a[i]), c[i][0] = min(c[i][0], s[i - 1][1]);
			}
		}
	}
	for (int i = 1; i <= n; i++) ans += 1ll * a[i] * a[i];
	printf("%lld\n", f[n][1] + ans);
	return 0;
}
