#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
const long long MOD = 998244353;
int n, m, a[101][2001], cnt[2001];
long long ans;
void dfs(int len, int left, int now, long long sum)
{
	if (!left)
	{
		ans = (ans + sum) % MOD;
		return;
	}
	if (n - now >= left)
	{
		dfs(len, left, now + 1, sum);
	}
	for (int i = 1; i <= m; i++)
	{
		if (!a[now][i])
		{
			continue;
		}
		if (cnt[i] < len / 2)
		{
			cnt[i]++;
			dfs(len, left - 1, now + 1, sum * a[now][i] % MOD);
			cnt[i]--;
		}
	}
}
int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			scanf("%d", &a[i][j]);
		}
	}
	for (int i = 2; i <= n; i++)
	{
		dfs(i, i, 1, 1);
	}
	printf("%lld", ans);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
