#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstdlib>
#include<cstring>
#include<cmath>
using namespace std;
const int maxn=300010;
int t,n,e=0,head[maxn],siz[maxn],r1,r2;
long long ans;
struct edge{int from,to,next;bool del;}ed[maxn<<1];
inline void addedge(int x,int y)
{
	ed[++e].to=y;
	ed[e].from=x;
	ed[e].next=head[x];
	head[x]=e;
	ed[e].del=0;
}
bool check(int x)
{
	for(int i=head[x];i;i=ed[i].next)
	{
		if(!ed[i].del)
			if(siz[ed[i].to]>n/2)
				return 0;
	}
	return 1;
}
void dfs1(int x,int fa)
{
	siz[x]=1;
	for(int i=head[x];i;i=ed[i].next)
	{
		int y=ed[i].to;
		if(y==fa||ed[i].del)continue;
		dfs1(y,x);
		siz[x]+=siz[y];
	}
}
void dfs2(int x,int fa)
{
	if(check(x))
	{
		ans+=x;
		for(int i=head[x];i;i=ed[i].next)
		{
			int y=ed[i].to;
			if(y==fa||ed[i].del)continue;
			if(check(y))ans+=y;
		}
	}
	else
	{
		for(int i=head[x];i;i=ed[i].next)
		{
			int y=ed[i].to;
			if(y==fa||ed[i].del)continue;
			int r3=siz[x],r4=siz[y];
			siz[x]-=r4;
			siz[y]+=r3;
			dfs2(y,x);
			siz[x]=r3;
			siz[y]=r4;
		}
	}
}

inline void init()
{
	ans=0;
	scanf("%d",&n);
	memset(head,0,sizeof(head));
	for(int i=1;i<n;i++)
	{
		scanf("%d%d",&r1,&r2);
		addedge(r1,r2);
		addedge(r2,r1);
	}
	memset(siz,0,sizeof(siz));
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--)
	{
		init();
		for(int i=1;i<e;i+=2)
		{
			ed[i].del=1;
			ed[i+1].del=1;
			dfs1(ed[i].from,0);
			dfs2(ed[i].from,0);
			dfs1(ed[i].to,0);
			dfs2(ed[i].to,0);
			ed[i].del=0;
			ed[i+1].del=0;
		}
		printf("%lld\n",ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
