#include <bits/stdc++.h>

using namespace std;

#define MS(a, b) memset(a, b, sizeof(a))
#define REP(a, b, c) for (register int a = b; a <= c; ++a)
#define DREP(a, b, c) for (register int a = b; a >= c; --a)
#define FOR(a, b, c) for (register int a = b; a < c; ++a)
#define EREP(a, b) for (register int a = head[b]; a; a = edge[a].nxt)

int rd () {
	int x = 0; bool f = 0; char c = getchar();
	while (c < '0' && c != '-') c = getchar();
	if (c == '-') f = 1, c = getchar();
	while (c >= '0') x = (x << 3) + (x << 1) + (c ^ 48), c = getchar();
	return f ? -x : x;
}

int T, n;

namespace PBaoli {
	const int SIZE = 2005;
	int ans = 0;
	int head[SIZE], ecnt;
	struct Edge {
		int v, nxt;
	} edge[SIZE << 1];
	void Add_Edge (int u, int v) {
		++ecnt;
		edge[ecnt].v = v;
		edge[ecnt].nxt = head[u];
		head[u] = ecnt;
	}
	
	int SZ[SIZE];	
	int f[SIZE];
	void dfs (int u) {
		SZ[u] = 1;
		EREP (i, u) {
			Edge& e = edge[i];
			if (e.v == f[u]) continue;
			f[e.v] = u;
			dfs(e.v);
			SZ[u] += SZ[e.v];
		}
	}
	int tot;
	
	int sz[SIZE];
	void DFS (int u, int fa) {
		sz[u] = 1;
		int mx = 0;
		EREP (i, u) {
			int v = edge[i].v;
			if (v == fa) continue;
			DFS(v, u);
			mx = max(mx, sz[v]);
			sz[u] += sz[v];
		}
		if (tot - sz[u] > mx) mx = tot - sz[u];
		if (mx <= tot / 2) ans += u;
	}
	
	void solve () {
		ans = 0;
		ecnt = 0; MS(head, 0);
		FOR (i, 1, n) {
			int u = rd(), v = rd();
			Add_Edge(u, v);
			Add_Edge(v, u);
		}
		dfs(1);
		REP (u, 1, n) EREP (j, u) {
			int v = edge[j].v;
			if (f[v] != u) continue;
			tot = n - SZ[v];
			DFS(u, v);
			tot = SZ[v];
			DFS(v, u);
		}
		printf ("%d\n", ans);
	}
}

namespace PChain {
	void solve () {
		long long ans = 0;
		FOR (mid, 1, n) {
			if (mid & 1) {
				ans += (1 + mid) / 2;
			} else {
				ans += (1 + mid);
			}
			if ((n + mid + 1) & 1) {
				ans += n + mid + 1;
			} else {
				ans += (n + mid + 1) / 2;
			}
		}
		printf ("%lld\n", ans);
	}
}

namespace PER {
	long long ans;
	int SSS;
	void Calc (int x, int sz) {
		if (x > n) return;
		ans += x;
		if ((n - 1) / 2 <= (n - sz) / 2) ans += 1;
		if (((n - 1) / 2 - 1) / 2 <= (n - sz) / 2 && (n - sz - (n - 1) / 2) <= (n - sz) / 2) ans += SSS;
		Calc((x << 1), (sz - 1) / 2);
		Calc((x << 1 | 1), (sz - 1) / 2);
	}
	void solve () {
		ans = 0;
		SSS = 2;
		Calc(3, (n - 1) / 2);
		SSS = 3;
		Calc(2, (n - 1) / 2);
		printf ("%lld\n", ans);
	}
}

int main () {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = rd();
	while (T--) {
		n = rd();
		if (n <= 2000) PBaoli::solve();
		else {
			bool flag1 = 1, flag2 = 1;
			FOR (i, 1, n) {
				int u = rd(), v = rd();
				if (u > v) swap(u, v);
				if (v != u + 1) flag1 = 0;
				if (u != (v >> 1)) flag2 = 0;
			}
			if (flag1) PChain::solve();
			else if (flag2) PER::solve();
		}
	}
	return 0;
}
