#include <bits/stdc++.h>

using namespace std;

#define MS(a, b) memset(a, b, sizeof(a))
#define REP(a, b, c) for (register int a = b; a <= c; ++a)
#define DREP(a, b, c) for (register int a = b; a >= c; --a)
#define FOR(a, b, c) for (register int a = b; a < c; ++a)
#define EREP(a, b) for (register int a = head[b]; a; a = edge[a].nxt)
#define lson (p << 1)
#define rson (p << 1 | 1)

int rd () {
	int x = 0; bool f = 0; char c = getchar();
	while (c < '0' && c != '-') c = getchar();
	if (c == '-') f = 1, c = getchar();
	while (c >= '0') x = (x << 3) + (x << 1) + (c ^ 48), c = getchar();
	return f ? -x : x;
}

int n, typ;

namespace P88 {
	const int SIZE = 500005;
	long long sum[SIZE];
	int L[SIZE];
	int a[SIZE];
	
	struct Node {
		int L, R;
		long long Mi;
	} tree[SIZE << 2];
	void Build (int L, int R, int p) {
		tree[p].L = L, tree[p].R = R;
		tree[p].Mi = 1e15;
		if (L == R) return;
		int mid = (L + R) >> 1;
		Build(L, mid, lson), Build(mid + 1, R, rson);
	}
	void Update (int x, int p) {
		if (tree[p].L == tree[p].R) {
			tree[p].Mi = sum[x] * 2 - sum[L[x] - 1];
			return;
		}
		int mid = (tree[p].L + tree[p].R) >> 1;
		if (x <= mid) Update(x, lson);
		else Update(x, rson);
		tree[p].Mi = min(tree[lson].Mi, tree[rson].Mi);
	}
	long long tot;
	int Query (int p) {
		if (tree[p].L == tree[p].R) return tree[p].L;
		if (tree[rson].Mi <= tot) return Query(rson);
		else return Query(lson);
	}
	
	void solve () {
		Build(1, n, 1);
		REP (i, 1, n) a[i] = rd();
		REP (i, 1, n) sum[i] = sum[i - 1] + a[i];
		REP (i, 1, n) {
			tot = sum[i];
			if (tree[1].Mi > tot) L[i] = 1;
			else L[i] = Query(1) + 1;
			Update(i, 1);
		}
		int now = n;
		long long ans = 0;
		while (now) {
			ans += (sum[now] - sum[L[now] - 1]) * (sum[now] - sum[L[now] - 1]);
			now = L[now] - 1;
		}
		printf ("%lld\n", ans);
	}
}

int main () {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	n = rd(), typ = rd();
	if (n <= 500000) P88::solve();
	return 0;
}
