#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
template<typename _Tp>inline _Tp max(_Tp a,_Tp b){return a>b?a:b;}
template<typename _Tp>inline void chmax(_Tp &a,_Tp b){(a<b)&&(a=b);}
template<typename _Tp>void read(_Tp &x)
{
	char ch(getchar());
	bool f(false);
	while(ch<48||ch>57) f|=ch=='-',ch=getchar();
	x=ch&15,ch=getchar();
	while(ch>=48&&ch<=57) x=(((x<<2)+x)<<1)+(ch&15),ch=getchar();
	if(f) x=-x;
}
const int N=300005;
const int inf=0x3f3f3f3f;
typedef long long ll;
struct edge{
	int v,nxt;
}c[N<<1];
int front[N],cnt;
inline void add(int u,int v)
{
	c[++cnt]=(edge){v,front[u]},front[u]=cnt;
}
int siz[N];
bool vis[N];
int maxx[N];
int getsiz(int x,int fa)
{
	maxx[x]=0;
	vis[x]=true;
	siz[x]=1;
	for(int i=front[x];i;i=c[i].nxt)
	{
		if(c[i].v!=fa)
		{
			siz[x]+=getsiz(c[i].v,x);
			chmax(maxx[x],siz[c[i].v]);
		}
	}
	return siz[x];
}
int E[N][2];
int dg[N];
namespace subtask1
{
	ll ans;
	void MAIN(int n)
	{
		ans=0;
		for(int i=1;i<n;++i)
		{
			memset(vis,0,4*(n+3));
			int _siz=getsiz(E[i][0],E[i][1]);
			int res=inf,tmp=0;
			for(int j=1;j<=n;++j)
			{
				if(vis[j])
				{
					chmax(maxx[j],_siz-siz[j]);
					if(maxx[j]<res)
					{
						res=maxx[j];
						tmp=j;
					}
					else if(maxx[j]==res)
					{
						tmp+=j;
					}
				}
			}
			ans+=tmp;
			memset(vis,0,4*(n+3));
			_siz=getsiz(E[i][1],E[i][0]);
			res=inf,tmp=0;
			for(int j=1;j<=n;++j)
			{
				if(vis[j])
				{
					chmax(maxx[j],_siz-siz[j]);
					if(maxx[j]<res)
					{
						res=maxx[j];
						tmp=j;
					}
					else if(maxx[j]==res)
					{
						tmp+=j;
					}
				}
			}
			ans+=tmp;
		}
		printf("%lld\n",ans);
	}
}
namespace subtask2
{
	int a[N],pos;
	void dfs(int x,int fa)
	{
		a[++pos]=x;
		for(int i=front[x];i;i=c[i].nxt)
		{
			if(c[i].v!=fa)
			{
				dfs(c[i].v,x);
			}
		}
	}
	void MAIN(int n,int id)
	{
		pos=0;
		dfs(id,0);
		ll ans=0;
		for(int i=1;i<n;++i)// [1,i] [i+1,n]
		{
			int len=i;
			if(len&1) ans+=a[(i+1)>>1];
			else ans+=a[i>>1]+a[(i>>1)+1];
			len=n-i;
			if(len&1) ans+=a[i+(((len+1)>>1))];
			else ans+=a[i+(len>>1)]+a[i+(len>>1)+1];
		}
		printf("%lld\n",ans);
	}
}
void MAIN()
{
	int n;
	read(n);
	cnt=0;
	memset(front,0,4*(n+3));
	memset(dg,0,4*(n+3));
	int x,y;
	for(int i=1;i<n;++i)
	{
		read(x),read(y);
		add(x,y),add(y,x);
		E[i][0]=x,E[i][1]=y;
		++dg[x],++dg[y];
	}
	if(n<=2000)
	{
		subtask1::MAIN(n);
		return;
	}
	int id=0;
	for(int i=1;i<=n;++i)
	{
		if(dg[i]==1)
		{
			id=i;
		}
	}
	subtask2::MAIN(n,id);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int _;
	read(_);
	while(_--)
	{
		MAIN();
	}
	return 0;
}
