#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
template<typename _Tp>inline _Tp max(_Tp a,_Tp b){return a>b?a:b;}
template<typename _Tp>inline void chmax(_Tp &a,_Tp b){(a<b)&&(a=b);}
template<typename _Tp>inline void chmin(_Tp &a,_Tp b){(a>b)&&(a=b);}
template<typename _Tp>void read(_Tp &x)
{
	char ch(getchar());
	bool f(false);
	while(ch<48||ch>57) f|=ch=='-',ch=getchar();
	x=ch&15,ch=getchar();
	while(ch>=48&&ch<=57) x=(((x<<2)+x)<<1)+(ch&15),ch=getchar();
	if(f) x=-x;
}
const int N=500005;
typedef long long ll;
ll a[N];
ll sum[N];
inline ll sqr(ll a)
{
	return a*a;
}
namespace subtask1
{
	ll dp[405][405];
	void MAIN(int n)
	{
		memset(dp,63,sizeof(dp));
		for(int i=1;i<=n;++i)
		{
			dp[i][i]=sqr(sum[i]);
			for(int j=1;j<i;++j)
			{
				ll qwq=sum[i]-sum[i-j];
				for(int k=1;k<=i-j&&qwq>=sum[i-j]-sum[i-j-k];++k)
				{
					chmin(dp[i][j],dp[i-j][k]+sqr(sum[i]-sum[i-j]));
				}
			}
		}
		ll ans=0x7fffffffffffffff;
		for(int i=1;i<=n;++i)
		{
			chmin(ans,dp[n][i]);
		}
		printf("%lld\n",ans);
	}
}
namespace subtask2
{
	ll dp[N];
	int opt[N];
	void MAIN(int n)
	{
		for(int i=1;i<=n;++i)
		{
			dp[i]=sum[i];
			opt[i]=0;
			for(int j=i-1;j>=1;--j)
			{
				if(sum[i]-sum[j]>=dp[j])
				{
					dp[i]=sum[i]-sum[j];
					opt[i]=j;
					break;
				}
			}
		}
		ll ans=0;
		int cur=n;
		while(cur)
		{
			ans+=sqr(dp[cur]);
			cur=opt[cur];
		}
		printf("%lld\n",ans);
	}
}
namespace subtask3
{
	struct seg_tr{
		struct Node{
			int ls,rs;
			int maxx;
		}f[N*83];
		int node_cnt;
		void Update(int &cur,ll l,ll r,ll pos,int val)
		{
			if(!cur)
			{
				cur=++node_cnt;
			}
			chmax(f[cur].maxx,val);
			if(l==r)
			{
				return;
			}
			ll mid=(l+r)>>1ll;
			if(pos<=mid) Update(f[cur].ls,l,mid,pos,val);
			else Update(f[cur].rs,mid+1,r,pos,val);
		}
		int Query(ll l,ll r,ll val,int cur)
		{
			if(!cur) return 0;
			if(r<=val)
			{
				return f[cur].maxx;
			}
			ll mid=(l+r)>>1ll;
			if(val>mid)
			{
				return max(Query(l,mid,val,f[cur].ls),Query(mid+1,r,val,f[cur].rs));
			}
			return Query(l,mid,val,f[cur].ls);
		}
	}tr;
	ll dp[N];
	int opt[N];
	void MAIN(int n)
	{
		ll tot=sum[n]<<1ll;
		int root=0;
		tr.Update(root,1,tot,1,0);
		for(int i=1;i<=n;++i)
		{
			dp[i]=sum[i];
			opt[i]=tr.Query(1,tot,sum[i],root);
			dp[i]=sum[i]-sum[opt[i]];
			tr.Update(root,1,tot,dp[i]+sum[i],i);
		}
		ll ans=0;
		int cur=n;
		while(cur)
		{
			ans+=sqr(dp[cur]);
			cur=opt[cur];
		}
		printf("%lld\n",ans);
	}
}
int main()
{
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	int n,type;
	read(n),read(type);
	for(int i=1;i<=n;++i)
	{
		read(a[i]);
		sum[i]=sum[i-1]+a[i];
	}
	if(n<=400)
	{
		subtask1::MAIN(n);
		return 0;
	}
	if(n<=5000)
	{
		subtask2::MAIN(n);
		return 0;
	}
	subtask3::MAIN(n);
	return 0;
}
