#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define ll long long

using namespace std;

const int maxn = 5e5 + 7;
int n, type;
ll a[maxn];

struct node {
	int l, r;
	ll sum; 
} e[maxn];

int tot = 1;
ll ans = 4e18;

void dfs(int x, ll now, ll need) {
	if (x == n + 1) {
		if (now < need) return;
		ll tmp = 0;
		for (int i = 1; i <= tot; i++) 
			tmp += e[i].sum * e[i].sum;
		ans = min(ans, tmp);
		return;
	}
	if (now < need) {
		e[tot].r = x;
		e[tot].sum += a[x];
		now += a[x];
		need = max(now, need);
		dfs(x + 1, now, need);
	} else {
		int tmp1 = e[tot].r;
		ll tmp2 = need;
		e[tot].r = x;
		e[tot].sum += a[x];
		now += a[x];
		need = now;
		dfs(x + 1, now, need);
		e[tot].r = tmp1;
		e[tot].sum -= a[x];
		now -= a[x];
		need = tmp2;
		
		tmp2 = now;
		e[++tot] = (node) {x, x, a[x]};
		now = a[x];
		dfs(x + 1, now, need);
		now = tmp2;
		tot--;
	}
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &type);
	for (int i = 1; i <= n; i++)
		scanf("%lld", &a[i]);
	e[1] = (node) {1, 1, 0}; 
	dfs(1, 0, 1);
	printf("%lld\n", ans);
	return 0;
}
