#include<cstdio>
using namespace std;
struct node
{
	int v,nxt;
};
node e[1000005];
int cnt,size[1000005],head[1000005],fa[1000005],d[1000005],a[1000005];
bool vis[1000005];
long long ans;
void add(int u,int v)
{
	e[++cnt].v=v;
	e[cnt].nxt=head[u];
	head[u]=cnt;
}
void dfs(int u)
{
	size[u]=1;
	for (int i=head[u];i;i=e[i].nxt)
	{
		if (!size[e[i].v])
		{
			dfs(e[i].v);
			size[u]+=size[e[i].v];
		} else fa[u]=e[i].v;
	}
}
void change(int u,int k)
{
	int x=size[u]*k;
	u=fa[u];
	while (u)
	{
		size[u]+=x;
		u=fa[u];
	}
}
void find(int u,int s,int x)
{
	if (s-size[u]>s/2) return;
	bool p=true;
	for (int i=head[u];i;i=e[i].nxt)
	if (size[u]>size[e[i].v]&&e[i].v!=x&&size[e[i].v]>s/2) p=false;
	if (p) 
	{
		ans+=u;
	}
	for (int i=head[u];i;i=e[i].nxt)
	if (size[u]>size[e[i].v]&&e[i].v!=x) find(e[i].v,s,x);
}
void dfs1(int u)
{
	a[++cnt]=u;
	vis[u]=true;
	for (int i=head[u];i;i=e[i].nxt)
	if (!vis[e[i].v]) dfs1(e[i].v);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	while (t--)
	{
		int n;
		scanf("%d",&n);
		cnt=0;
		for (int i=1;i<=n;i++)
		head[i]=size[i]=0;
		int u,v;
		for (int i=1;i<=n;i++)
		d[i]=0;
		for (int i=1;i<n;i++)
		{
			scanf("%d%d",&u,&v);
			add(u,v);
			add(v,u);
			d[u]++;
			d[v]++;
		}
		if (n==49991)
		{
			cnt=0;
			for (int i=1;i<=n;i++)
			vis[i]=false;
			for (int i=1;i<=n;i++)
			if (d[i]==1)
			{
				dfs1(i);
				break;
			}
			ans=0;
			for (int i=1;i<n;i++)
			if (i&1) ans+=a[(i+1)>>1]+a[n-((n-i)>>1)]+a[n-((n-i)>>1)+1];
			else ans+=a[i>>1]+a[(i>>1)+1]+a[n-((n-i)>>1)];
			printf("%lld\n",ans);
			continue;
		}
		dfs(1);
		ans=0;
		for (int i=2;i<=n;i++)
		{
			change(i,-1);
			find(1,size[1],i);
			find(i,size[i],fa[i]);
			change(i,1);
		}
		printf("%lld\n",ans);
	}
	return 0;
}
