#include <bits/stdc++.h>
using namespace std;

const int Maxn = 40, MOD = 998244353;
int n, m, a[Maxn + 2][5];

inline void Add(int &x, int y) {
	(x += y) >= MOD && (x -= MOD);
}

namespace Sub0 {
	int c[Maxn + 5], ans = 0, cnt[Maxn + 5];
	inline void Check() {
		int s = 0, res = 1;
		for (int i = 1; i <= m; ++i) cnt[i] = 0;
		for (int i = 1; i <= n; ++i) if (c[i]) ++s;
		if (s < 2) return;
		for (int i = 1; i <= n; ++i) {
			if (!c[i]) continue;
			++cnt[c[i]];
			if (cnt[c[i]] > s / 2) return;
			res = 1LL * res * a[i][c[i]] % MOD;
		}
		Add(ans, res);
	}
	void Dfs(int x) {
		if (x > n) return (void) (Check());
		for (int i = m; i >= 0; --i) {
			c[x] = i;
			Dfs(x + 1);
		}
	}
	inline void Solve() {
		Dfs(1);
		printf("%d\n", ans);
	}
}

namespace Sub1 {
	const int N = 40;
	int dp[N + 2][N + 2][N + 2];
	void Solve() {
		dp[2][1][0] = a[1][1] + a[2][1], dp[2][0][1] = a[1][2] + a[2][2];
//		dp[2][2][0] = a[1][1] * a[2][1], dp[2][0][2] = a[1][2] * a[2][2];
//		dp[2][1][1] = a[1][1] * a[2][2] + a[1][2] * a[2][1];
		for (int i = 2; i <= n; ++i) {
			for (int j = 0; j <= i / 2; ++j) {
				for (int k = 0, kk = min(i - j, i / 2); k <= kk; ++k) {
					if (!j && !k) continue;
					for (int l = i + 1; l <= n; ++l) {
						Add(dp[l][j][k], dp[i][j][k]);
						Add(dp[l][j][k], dp[i][j][k]);
						if (j + 1 <= (j + k + 1) / 2) Add(dp[l][j + 1][k], 1LL * dp[i][j][k] * a[l][1] % MOD);
						if (k + 1 <= (j + k + 1) / 2) Add(dp[l][j][k + 1], 1LL * dp[i][j][k] * a[l][2] % MOD);
					}
				}
			}
		}
		int ans = 0;
		for (int i = 0; i <= n / 2; ++i)
			for (int j = 0; j <= n / 2; ++j)
				Add(ans, dp[n][i][j]);
		printf("%d\n", ans);
	}
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			scanf("%d", &a[i][j]);
	if (n == 1) return puts("0"), 0;
	if (n <= 10) return Sub0::Solve(), 0;
	if (m == 2) Sub1::Solve();
	return 0;
}
/*
2 3
1 0 1
0 1 1
3 2
3 0
0 2
4 4
*/
