#include <bits/stdc++.h>
using namespace std;
typedef long long LL;

template <class T>
inline void read(T &x) {
	x = 0;
	char c = getchar();
	bool f = 0;
	for (; !isdigit(c); c = getchar()) f ^= c == '-';
	for (; isdigit(c); c = getchar()) x = x * 10 + (c ^ 48);
	x = f ? -x : x;
}

template <class T>
inline void write(T x) {
	if (x < 0) {
		putchar('-');
		x = -x;
	}
	T y = 1;
	int len = 1;
	for (; y <= x / 10; y *= 10) ++len;
	for (; len; --len, x %= y, y /= 10) putchar(x / y + 48);
}

const int MAXN = 100, MAXM = 2e3, MOD = 998244353;
int n, m, a[MAXN + 5][MAXM + 5];

namespace Subtask {
	int ans;
	bool f[MAXN + 5][MAXM + 5];
	
	void dfs(int x) {
		if (x > n) {
			bool flag = 1;
			int k = 0;
			for (int i = 1; i <= n; ++i)
				for (int j = 1; j <= m; ++j)
					k += f[i][j];
			for (int i = 1; i <= m; ++i) {
				int sum = 0;
				for (int j = 1; j <= n; ++j)
					sum += f[j][i];
				if (sum > k / 2) {
					flag = 0;
					break;
				}
			}
			if (!flag) return;
			int res = 1;
			for (int i = 1; i <= n; ++i)
				for (int j = 1; j <= m; ++j)
					if (f[i][j])
						res = 1ll * res * a[i][j] % MOD;
			ans = (ans + res) % MOD;
			return;
		}
		dfs(x + 1);
		for (int i = 1; i <= m; ++i)
			if (a[x][i]) {
				f[x][i] = 1;
				dfs(x + 1);
				f[x][i] = 0;
			}
	}
	
	inline void main() {
		dfs(1);
		write((ans + MOD - 1) % MOD);
		putchar('\n');
		exit(0);
	}
}

namespace Subtask2 {
	const int MAXN = 40;
	int ans, f[MAXN + 5][MAXN + 5][MAXN + 5];
	
	inline void main() {
		for (int i = 0; i <= n; ++i) f[i][0][0] = 1;
		for (int i = 1; i <= n; ++i)
			for (int j = 0; j <= i; ++j)
				for (int k = 0; k <= i; ++k) {
					if (!j && !k) continue;
					f[i][j][k] = (f[i - 1][j][k] + 
					1ll * f[i - 1][j - 1][k] * a[i][1] % MOD + 
					1ll * f[i - 1][j][k - 1] * a[i][2] % MOD) % MOD;
				}
		for (int i = 1; i <= n / 2; ++i)
			ans = (ans + f[n][i][i]) % MOD;
		write(ans);
		putchar('\n');
		exit(0);
	}
}

namespace Subtask3 {
	const int MAXN = 40;
	int ans, f[MAXN + 5][MAXN + 5][MAXN + 5][MAXN + 5];
	
	inline void main() {
		for (int i = 0; i <= n; ++i) f[i][0][0][0] = 1;
		for (int i = 1; i <= n; ++i)
			for (int j = 0; j <= i; ++j)
				for (int k = 0; k <= i; ++k)
					for (int l = 0; l <= i; ++l) {
						if (!j && !k && !l) continue;
						f[i][j][k][l] = (f[i - 1][j][k][l] + 
						1ll * f[i - 1][j - 1][k][l] * a[i][1] % MOD + 
						1ll * f[i - 1][j][k - 1][l] * a[i][2] % MOD + 
						1ll * f[i - 1][j][k][l - 1] * a[i][3] % MOD) % MOD;
					}
		for (int i = 0; i <= n; ++i)
			for (int j = 0; j <= n; ++j)
				for (int k = 0; k <= n; ++k) {
					int sum = i + j + k;
					if (sum && i <= sum / 2 && j <= sum / 2 && k <= sum / 2)
						ans = (ans + f[n][i][j][k]) % MOD;
				}
		write(ans);
		putchar('\n');
		exit(0);
	}
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	read(n), read(m);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			read(a[i][j]);
	if (n <= 10) Subtask::main();
	if (m == 2) Subtask2::main();
	if (m == 3) Subtask3::main();
	return 0;
}
