#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;

template <class T>
inline void read(T &x) {
	x = 0;
	char c = getchar();
	bool f = 0;
	for (; !isdigit(c); c = getchar()) f ^= c == '-';
	for (; isdigit(c); c = getchar()) x = x * 10 + (c ^ 48);
	x = f ? -x : x;
}

template <class T>
inline void write(T x) {
	if (x < 0) {
		putchar('-');
		x = -x;
	}
	T y = 1;
	int len = 1;
	for (; y <= x / 10; y *= 10) ++len;
	for (; len; --len, x %= y, y /= 10) putchar(x / y + 48);
}

const int MAXN = 5e3;
const ULL INF = 4e18;
int n, a[MAXN + 5];
ULL ans = INF, pre[MAXN + 5], f[MAXN + 5][MAXN + 5];
bool type;

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	read(n), read(type);
	if (n <= 400) {
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= i; ++j)
				f[i][j] = INF;
		for (int i = 1; i <= n; ++i) {
			read(a[i]);
			pre[i] = pre[i - 1] + a[i];
			f[i][1] = pre[i] * pre[i];
		}
		for (int i = 2; i <= n; ++i)
			for (int j = 1; j <= i; ++j) {
	//			int pos = j;
	//			for (int l = 1, r = j - 1; l <= r; ) {
	//				int mid = (l + r) >> 1;
	//				if (pre[i] - pre[j - 1] >= pre[j - 1] - pre[mid - 1]) {
	//					pos = mid;
	//					r = mid - 1;
	//				} else l = mid + 1;
	//			}
				for (int k = j - 1; k && pre[i] - pre[j - 1] >= pre[j - 1] - pre[k - 1]; --k)
					f[i][j] = min(f[i][j], f[j - 1][k] + (pre[i] - pre[j - 1]) * (pre[i] - pre[j - 1]));
			}
		for (int i = 1; i <= n; ++i) ans = min(ans, f[n][i]);
		write(ans);
		putchar('\n');
	} else {
		ans = INF;
		for (int i = 1; i <= n; ++i) read(a[i]);
		for (int i = 1; i <= n; ++i) {
			ULL res = 0, las = 0, sum = 0;;
			for (int j = 1; j <= i; ++j) las += a[j];
			res += las * las;
			for (int j = i + 1; j <= n; ++j) {
				sum += a[j];
				if (sum >= las) {
					res += sum * sum;
					las = sum;
					sum = 0;
				}
			}
			if (sum)
				res += (sum + las) * (sum + las) - las * las;
			ans = min(ans, res);
		}
		write(ans);
		putchar('\n');
	}
	return 0;
}
