#include <cstdio>
#include <cstring>
#include <algorithm>

#define add(x, y) (x = ((x) + (y)) % TT)

#define maxn 105
#define maxm 2005

using namespace std;

const int TT = 998244353;
int n, m, a[maxn][maxm], f[maxn][maxn][maxn], g[maxn];
int ans = 1;

inline int read()
{
	char ch = getchar();
	int ret = 0, f = 1;
	while (ch > '9' || ch < '0')
	{
		if (ch == '-')
			f = -f;
		ch = getchar();
	}
	while (ch >= '0' && ch <= '9')
		ret = ret * 10 + ch - '0', ch = getchar();
	return ret * f;
}

int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	n = read(), m = read();
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
			a[i][j] = read();
		for (int j = 1; j <= m; ++j)
			a[i][0] += a[i][j];
	}
	for (int i = 1; i <= n; ++i)
		ans = 1ll * ans * (a[i][0] + 1) % TT;
	ans = (ans - 1 + TT) % TT;
	for (int v = 1; v <= m; ++v)
	{
		for (int i = 1; i <= n; ++i)
			g[i] = a[i][0] - a[i][v];
		for (int i = 0; i <= n + 1; ++i)
		{
			for (int j = 0; j <= i + 1; ++j)
			{
				for (int k = 0; k <= i - j + 1; ++k)
					f[i][j][k] = 0;
			}
		}
		f[0][0][0] = 1;
		for (int i = 0; i < n; ++i)
		{
			for (int j = 0; j <= i; ++j)
			{
				for (int k = 0; k <= i - j; ++k)
				{
					add(f[i + 1][j][k], f[i][j][k]);
					add(f[i + 1][j + 1][k], 1ll * f[i][j][k] * a[i + 1][v] % TT);
					add(f[i + 1][j][k + 1], 1ll * f[i][j][k] * g[i + 1] % TT);
				}
			}
		}
		for (int j = 1; j <= n; ++j)
		{
			for (int k = 0; k < j; ++k)
			{
				ans = (ans - f[n][j][k] + TT) % TT;
//				printf("%d %d %d\n", j, k, f[n][j][k]);
			}
		}
	}
	printf("%d\n", ans);
	return 0;
}
