#include<bits/stdc++.h>
#define LL long long
#define fi first
#define se second
#define P pair<int,int>
const LL N=3e5+10;
const LL mod=1e9+7;
const LL inf=0x3f3f3f3f;
using namespace std;
template <typename tp> inline void read(tp &x)
{
	x=0; char c=getchar(); bool f=0;
	for(;c<'0'||c>'9';f|=(c=='-'),c=getchar());
	for(;c>='0'&&c<='9';x=(x<<1)+(x<<3)+c-'0',c=getchar());
	if(f) x=-x;
}
int T,n;
struct Edge{int next,to;} edge[N<<2];
int head[N],cnt,siz[N],du[N];
void add(int from,int to)
{
	edge[++cnt].next=head[from];
	edge[cnt].to=to;
	head[from]=cnt;
}
void insert(int from,int to) { add(from,to); add(to,from);}
void dfs(int now,int fa)
{
	siz[now]=1;
	for(int i=head[now];i;i=edge[i].next)
	{
		int to=edge[i].to;
		if(to==fa) continue;
		dfs(to,now);
		siz[now]+=siz[to];
	}
}
LL ans;
int num[2020];
void find(int now,int fa)
{
	num[siz[now]]++;
	for(int i=head[now];i;i=edge[i].next)
	{
		int to=edge[i].to;
		if(to==fa) continue;
		find(to,now);
	}
}
vector<int> vec;
void check(int now,int to)
{
	vec.clear();
	for(int i=head[now];i;i=edge[i].next)
		if(edge[i].to!=to)
			vec.push_back(siz[edge[i].to]);
	sort(vec.begin(),vec.end());
	if(vec.size()==0)
	{
		ans+=num[n-1]*now+num[n-2]*now;
		return ;
	}
	for(int i=1;i<=n;i++)
		if(num[i])
		{
			int maxn=(n-i)/2;
			if(siz[to]-i<=maxn&&vec[vec.size()-1]<=maxn)
				ans+=now*num[i];
		}	
}
vector<int> A;
void dfs_solveA(int now,int fa)
{
	A.push_back(now);
	for(int i=head[now];i;i=edge[i].next)
	{
		int to=edge[i].to;
		if(to==fa) continue;
		dfs_solveA(to,now);
	}
}
void solveA()
{
	int st=0;
	A.clear();
	for(int i=1;i<=n;i++)
		if(du[i]==1)
		{
			st=i;
			break;
		}
	dfs_solveA(st,st);
	int siz=A.size();
	int x,y;
	if(siz%2) x=siz/2,y=-1;
	else x=siz/2,y=x-1;
	for(int i=0;i<siz;i++)
	{
		if(i==0) ans+=A[i]*(siz>1?2:1);
		else if(i==siz-1) ans+=A[i]*(siz>1?2:1);
		else if(i==x||i==y) ans+=A[i]*2;
		else ans+=A[i]*3;
	}
	printf("%lld\n",ans);
	return ;
}
void dfs_get(int now,int fa)
{
	for(int i=head[now];i;i=edge[i].next)
	{
		int to=edge[i].to;
		if(to==fa) continue;
		dfs_get(to,now);
	}
	ans+=now;
}
void solveB()
{
	int st=0;
	for(int i=1;i<=n;i++) 
		if(du[i]==2) 
		{
			st=i;
			break;
		}
	dfs(st,st);
	dfs_get(st,st);
	if(n>=7) 
	{
		for(int i=head[st];i;i=edge[i].next)
		{
			int to=edge[i].to;
			ans+=to*((n+1)/2-1);
		}
	}
	ans+=st*(n+1)/2-st;
	printf("%lld\n",ans);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	read(T);
	while(T--)
	{
		read(n); ans=0; cnt=0;
		memset(head,0,sizeof(head));
		memset(du,0,sizeof(du));
		for(int i=2,u,v;i<=n;i++) read(u),read(v),insert(u,v),du[u]++,du[v]++;
		if(n<=2000)
		{
			for(int i=1;i<=n;i++)
			{
				dfs(i,i);
				for(int j=head[i];j;j=edge[j].next)
				{
					for(int k=1;k<=n;k++) num[k]=0;
					find(edge[j].to,i);
					check(i,edge[j].to);
				}
			}
			printf("%lld\n",ans);
			continue;
		}
		int task2=0;
		for(int i=1;i<=n;i++)
			if(du[i]==2)
				task2++;
		if(task2==n-2)
		{
			solveA();
			continue;
		}
		solveB();
	}
	return 0;
}
