#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;
typedef long long LL;
#define dd c=getchar()
inline LL read(){
    LL a=0,b=1;int dd;
    while(!isdigit(c)){if(c=='-')b=-b;dd;}
    while(isdigit(c)){a=a*10+c-'0';dd;}
    return a*b;
}
inline void print(LL x){
    static int c[23];
    static int n;
    if(x==0){
        putchar('0');
        return;
    }
    if(x<0){
        putchar('-');
        x=-x;
    }
    n=0;
    while(x>0){
        c[n++]=x%10+'0';
        x/=10;
    }
    while(n-->0){
        putchar(c[n]);
    }
}
inline void println(LL x){
    print(x);
    putchar('\n');
}
#undef dd 
const int N=300003;
int T;
int n;
vector<int>e[N];
LL ans;
int sz[N];
int pl[N];
void gsz(int u,int fa){
    sz[u]=1;
    for(unsigned i=0;i<e[u].size();i++){
        int&v=e[u][i];
        if(v==fa)continue;
        gsz(v,u);
        sz[u]+=sz[v];
    }
}
void gzx(int u,int fa,int m){
    int tot=m-sz[u];
    for(unsigned i=0;i<e[u].size();i++){
        int&v=e[u][i];
        if(v==fa)continue;
        gzx(v,u,m);
        tot=max(tot,sz[v]);
    }
    if(tot<=m/2)ans+=u;
}
void gl(int u,int v){
    gsz(u,v);
    gzx(u,v,sz[u]);
    gsz(v,u);
    gzx(v,u,sz[v]);
}
void gas(int l,int r){
    int m=r-l+1;
    ans+=pl[(l+r)/2];
    if(m&1)return;
    ans+=pl[(l+r)/2+1];
}
int main(){
    freopen("centroid.in","r",stdin);
    freopen("centroid.out","w",stdout);
    T=read();
    while(T-->0){
        n=read();
        for(int i=1;i<=n;i++){
            e[i].clear();
        }
        for(int i=1;i<n;i++){
            int x=read();
            int y=read();
            e[x].push_back(y);
            e[y].push_back(x);
        }
        ans=0;
        for(int i=1;i<=n;i++){
            if(e[i].size()==1){
                pl[1]=i;
                break;
            }
        }
        for(int i=1;i<n;i++){
            int u=pl[i];
            for(unsigned j=0;j<e[u].size();j++){
                int&v=e[u][j];
                if(v==pl[i-1])continue;
                pl[i+1]=v;
            }
        }
        if(pl[n]){
            for(int i=1;i<n;i++){
                gas(1,i);
                gas(i+1,n);
            }
            //puts("list");
            println(ans);
        }else if(n<=2000){
            for(int u=1;u<=n;u++){
                for(unsigned i=0;i<e[u].size();i++){
                    int&v=e[u][i];
                    if(u<v){
                        gl(u,v);
                    }
                }
            }
            println(ans);
        }
    }
    return 0;
}