#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long

using namespace std;

const int Nlink = 56789;

namespace solve1 {
	int pto[Nlink][3], ld[Nlink], tot;
	void build(int pre, int cur, int end) {
		while(cur != end) {
			ld[tot++] = cur;
			int tmp = cur;
			if(pto[cur][1] == pre) cur = pto[cur][2];
			else cur = pto[cur][1];
			pre = tmp;
		}
		ld[tot++] = end;
		
	}
	int calc(int l, int r) {
		if((r - l) % 2)
			return ld[(r+l) / 2] + ld[(r+l+1) / 2];
		return ld[(r+l) >> 1];
	}
	void main(int n) {
		memset(pto, 0, sizeof(pto));
		memset(ld, 0, sizeof(ld));
		tot = 0;
		int u, v, start = -1, end = -1;
		for(int i = 1; i < n; ++i) {
			scanf("%d %d", &u, &v);
			pto[u][++pto[u][0]] = v;
			pto[v][++pto[v][0]] = u;
		}
		for(int i = 1; i <= n; ++i) {
			if(pto[i][0] == 1) {
				if(start == -1) start = i;
				else end = i;
			}
		}
		build(0, start, end);
		ll ans = 0;
		for(int i = 0; i < tot - 1; ++i) {
			ans += calc(0, i);
			ans += calc(i + 1, tot - 1);
		}
		printf("%lld\n", ans);
	}
};

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int t, n;
	scanf("%d", &t);
	while(t--) {
		scanf("%d", &n);
		solve1::main(n);
	}
	return 0;
}

