#include <cstdio>
#include <cstring>
#include <queue>
#define ll long long

using namespace std;

const int N = 5678;
struct node {
	ll sum, val;	
	node() {}
	node(int SUM, int VAL): sum(SUM), val(VAL) {}
};

ll a[N], p[N], f[N];
deque<node> q[N];

int lb(int id, int l, int r, ll key) {
	if(q[id].empty() || q[id][0].sum > key) return -1;
	while(l < r) {
		int mid = (l + r + 1) >> 1;
		if(key >= q[id][mid].sum) l = mid;
		else r = mid - 1; 
	}
	return l;
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	memset(f, 0x3f, sizeof(f));
	int n, type;
	scanf("%d %d", &n, &type);
	for(int i = 1; i <= n; ++i) scanf("%lld", a + i);
	for(int i = 1; i <= n; ++i) p[i] = p[i-1] + a[i];
	f[0] = 0;
	f[1] = a[1]*a[1];
	q[0].push_back(node(0, 0));
	q[1].push_back(node(a[1], a[1]*a[1]));
	for(int i = 2; i <= n; ++i) {
		for(int pre = i - 1; ~pre; --pre) {
			if(q[pre].empty()) continue;
			ll dis = (p[i] - p[pre]) * (p[i] - p[pre]);
			int t = lb(pre, 0, q[pre].size() - 1, p[i]-p[pre]);
			if(t == -1) continue;
			f[i] = min(f[i], q[pre][t].val + dis);
			if(q[i].empty() || q[i].back().val > q[pre][t].val + dis) q[i].push_back(node(p[i]-p[pre], q[pre][t].val + dis));
		}
	}
	printf("%lld\n", f[n]);
	return 0;	
}
