/*#include<cstdio>
#include<cctype>
#include<climits>
#include<algorithm>
inline int getint() {
	register char ch;
	while(!isdigit(ch=getchar()));
	register int x=ch^'0';
	while(isdigit(ch=getchar())) x=(((x<<2)+x)<<1)+(ch^'0');
	return x;
}
typedef long long int64;
const int N=401;
int64 a[N],pre[N],f[N][N];
inline int64 sqr(const int64 &x) {
	return x*x;
}
int main() {
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	const int n=getint(),type=getint();
	for(register int i=1;i<=n;i++) {
		a[i]=getint();
		pre[i]=pre[i-1]+a[i];
	}
	for(register int i=1;i<=n;i++) {
		f[i][0]=sqr(pre[i]);
		for(register int j=1;j<i;j++) {
			f[i][j]=LLONG_MAX;
			for(register int k=0;k<j;k++) {
				if(f[j][k]==LLONG_MAX) continue;
				if(pre[i]-pre[j]>=pre[j]-pre[k]) {
					f[i][j]=std::min(f[i][j],f[j][k]+sqr(pre[i]-pre[j]));
				}
			}
		}
	}
	int64 ans=LLONG_MAX;
	for(register int i=0;i<n;i++) {
		ans=std::min(ans,f[n][i]);
	}
	printf("%lld\n",ans);
	return 0;
}*/
#include<cstdio>
#include<cctype>
#include<climits>
#include<algorithm>
inline int getint() {
	register char ch;
	while(!isdigit(ch=getchar()));
	register int x=ch^'0';
	while(isdigit(ch=getchar())) x=(((x<<2)+x)<<1)+(ch^'0');
	return x;
}
typedef long long int64;
const int N=5001;
int64 a[N],pre[N],f[N][N],g[N][N];
inline int64 sqr(const int64 &x) {
	return x*x;
}
int main() {
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	const int n=getint(),type=getint();
	for(register int i=1;i<=n;i++) {
		a[i]=getint();
		pre[i]=pre[i-1]+a[i];
	}
	for(register int i=1;i<=n;i++) {
		f[i][0]=sqr(pre[i]);
		f[i][i]=g[i][i]=LLONG_MAX;
		for(register int j=1;j<i;j++) {
			f[i][j]=LLONG_MAX;
			int l=0,r=j-1,k;
			while(l<=r) {
				k=(l+r)/2;
				if(pre[i]-pre[j]>=pre[j]-pre[k]) {
					r=k-1;
				} else {
					l=k+1;
				}
			}
			k=r+1;
			if(pre[i]-pre[j]<pre[j]-pre[k]) continue;
			if(g[j][k]==LLONG_MAX) continue;
			f[i][j]=g[j][k]+sqr(pre[i]-pre[j]);
		}
		for(register int j=i-1;j>=0;j--) {
			g[i][j]=std::min(g[i][j+1],f[i][j]);
		}
	}
	printf("%lld\n",g[n][0]);
	return 0;
}
