#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
using namespace std;

int x; char c;
int read() {
	x = 0; c = getchar();
	for (; c < '0' || '9' < c; c = getchar());
	for (; '0' <= c && c <= '9'; c = getchar()) x = (x << 3) + (x << 1) + (c ^ '0');
	return x;
}
void write(int x) {
	if (x >= 10) write(x / 10);
	putchar(x % 10 ^ '0');
}

#define P 998244353
#define MAXN 110
#define MAXM 2020
int n, m, a[MAXN][MAXM];
int k, vis[MAXN], ans;
int dfs(int i, int t, int s, int p) {
	if (t == k + 1) {
		if (vis[p] <= (k >> 1)) {
			return s;
		}
		else {
			return 0;
		}
	}
	if (i == n + 1) {
		return 0;
	}
	int cnt = dfs(i + 1, t, s, p);
	for (register int j = 1; j <= m; j++) {
		if (a[i][j] > 0) {
			if (++vis[j] > vis[p]) {
				cnt += dfs(i + 1, t + 1, s * a[i][j] % P, j);
			}
			else {
				cnt += dfs(i + 1, t + 1, s * a[i][j] % P, p);
			}
			--vis[j];
		}
	}
	return cnt;
}

#define fre(f) freopen(#f".in", "r", stdin), freopen(#f".out", "w", stdout)
int main() {
	fre(meal);
	n = read(); m = read();
	for (register int i = 1; i <= n; i++) {
		for (register int j = 1; j <= m; j++) {
			a[i][j] = read();
		}
	}
	vis[0] = -0x7fffffff;
	for (k = 2; k <= n; k++) {
		ans = (ans + dfs(1, 1, 1, 0)) % P;
	}
	write(ans);
	return 0;
}
