#include<bits/stdc++.h>
using namespace std;

const int maxn=300005;

struct Edge{
	int next,to,flag;
}edge[maxn*2];

int n,nedge=0;
int head[maxn],sz[maxn],f[maxn],vis[maxn];

vector<int> v;

void addedge(int a,int b){
	edge[nedge].next=head[a];
	edge[nedge].to=b;
	edge[nedge].flag=0;
	head[a]=nedge++;
}

void build(int u,int fa){
	f[u]=fa;
	for (int i=head[u];i!=-1;i=edge[i].next){
		int v=edge[i].to;
		if (v==fa) continue;
		build(v,u);
	}
}

void init(int u,int fa){
	sz[u]=1;
	for (int i=head[u];i!=-1;i=edge[i].next){
		if (edge[i].flag) continue;
		int v=edge[i].to;
		if (v==fa) continue;
		init(v,u);
		sz[u]+=sz[v];
	}
}

int dfs(int u,int fa,int rt){
	int max_size=sz[rt]-sz[u];
	for (int i=head[u];i!=-1;i=edge[i].next){
		if (edge[i].flag) continue;
		int v=edge[i].to;
		if (v==fa) continue;
		max_size=max(max_size,sz[v]);
	}
	if (max_size<=sz[rt]/2) v.push_back(u);
	for (int i=head[u];i!=-1;i=edge[i].next){
		if (edge[i].flag) continue;
		int v=edge[i].to;
		if (v==fa) continue;
		dfs(v,u,rt);
	}
}

int work(int a){
	v.clear();
	dfs(a,0,a);
	int ans=0;
	for (int i=0;i<v.size();i++){
		ans+=v[i];
	}
	return ans;
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int cas;
	scanf("%d",&cas);
	while(cas--){
		memset(vis,0,sizeof(vis));
		nedge=0;
		memset(head,-1,sizeof(head));
		scanf("%d",&n);
		for (int i=1;i<n;i++){
			int a,b;
			scanf("%d%d",&a,&b);
			addedge(a,b);
			addedge(b,a);
		}
		long long ans=0;
		build(1,0);
		for (int i=1;i<=n;i++){
			for (int j=head[i];j!=-1;j=edge[j].next){
				int v=edge[j].to;
				if (v==f[i] || vis[j]) continue;
				edge[j].flag=edge[j^1].flag=1;
				vis[j]=vis[j^1]=1;
				init(1,0);
				init(v,0);
				ans+=1ll*(work(1)+work(v));
				edge[j].flag=edge[j^1].flag=0;
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}
