#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<cctype>
#define ll long long
using namespace std;
ll read(){
	ll x=0;char ch=getchar(),zf=1;
	while(!isdigit(ch)&&ch!='-')ch=getchar();
	if(ch=='-')ch=getchar(),zf=-1;
	while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
	return x*zf;
}
void write(ll x){
	if(x<0)putchar('-'),x=-x;
	if(x>=10)write(x/10);putchar(x%10+'0');
}
void writeln(ll x){write(x);putchar('\n');}
int k,m,n;
int dfn[300010],F[600010],N[600010],a[600010],fa[600010],size[300010],cnt,sz1[300010];
int to[300010];
void add(int x,int y){
	a[++k]=y;
	N[k]=F[x];F[x]=k;
}
void dfs(int x,int pre){
	fa[x]=pre;dfn[x]=++cnt;size[x]=1;
	to[cnt]=x;
	for(int i=F[x];i;i=N[i])if(a[i]!=pre){
		dfs(a[i],x);size[x]+=size[a[i]];
	}
}
bool bel(int x,int y){
	return dfn[x]<=dfn[y]&&dfn[x]+size[x]-1>=dfn[y];
}
bool belong(int Root,int x,int y){//y in x?
	if(x!=fa[Root])return bel(x,y);
	else return !bel(Root,y);
}
ll ans=0;
int query(int L,int R,int lim){
	int ret=0;
	for(int i=L;i<=R;i++)ret+=(sz1[i]<=lim);return ret;	
}
int query(int L,int R,int lim1,int lim2){
	if(lim1>=lim2)return query(L,R,lim1)-query(L,R,lim2-1);else return 0;
}
void solve(int x){
	int fir=0,sec=0,idf=0,ids=0;
	for(int i=F[x];i;i=N[i]){
		int sum=size[a[i]];
		if(a[i]==fa[x])sum=n-size[x];
		if(sum>fir)ids=idf,idf=a[i],sec=fir,fir=sum;
		else if(sum>sec)sec=sum,ids=a[i];
	}
	int ret=0;
	if(bel(x,idf))ret=query(dfn[idf],dfn[idf]+size[idf]-1,n-sec*2,fir*2-n),
	ret+=query(1,dfn[idf]-1,n-fir*2)+query(dfn[idf]+size[idf],n,n-fir*2);
	else ret=query(1,n,n-sec*2,fir*2-n)-query(dfn[x],dfn[x]+size[x]-1,n-sec*2,fir*2-n),
	ret+=query(dfn[x],dfn[x]+size[x]-1,n-fir*2);
	ans+=1ll*ret*x;
}
void dfssolve(int x){
	sz1[dfn[fa[x]]]=n-size[x];solve(x);
	for(int i=F[x];i;i=N[i])if(a[i]!=fa[x])dfssolve(a[i]);
	sz1[dfn[fa[x]]]=size[fa[x]];
}
int t;
int d[300010];
int q[300010];
bool subl(){
	t=0;ll ans=0;
	int mx=d[1];
	for(int i=2;i<=n;i++)if(mx<d[i])mx=d[i];if(mx>2)return 0;
	for(int i=1;i<=n;i++)if(d[i]==1){
		q[1]=i;
		for(int j=2;j<=n;j++)
		for(int k=F[q[j-1]];k;k=N[k])if(a[k]!=q[j-2])q[j]=a[k];
		for(int j=1;j<n;j++){
			//[i,j],[j+1,n]
			if(1+j&1)ans+=q[(1+j)/2]+q[(1+j+1)/2];else ans+=q[(1+j)/2];
			if(j+1+n&1)ans+=q[(j+1+n)/2]+q[(j+2+n)/2];else ans+=q[(j+1+n)/2];
		}
		break;
	}
	cout<<ans<<endl;return 1;
}
void subs(){
	int rt=1;
	for(int i=1;i<=n;i++)if(d[i]==2)rt=i;ans=0;
	for(int i=1;i<=n;i++)ans+=i;
	ans+=1ll*rt*(n-1)/2;
	for(int i=F[rt];i;i=N[i])
	ans+=1ll*a[i]*(n-1)/2;
	cout<<ans<<endl;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);

	int T=read();
	while(T--){
		k=0;cnt=0;
		n=read();
		for(int i=1;i<=n;i++)d[i]=0;
		for(int i=1;i<n;i++){
			int x=read(),y=read();
			add(x,y);add(y,x);
			d[x]++;d[y]++;
		}
		if(subl()){
			for(int i=1;i<=n;i++)F[i]=dfn[i]=size[i]=0;
			for(int i=1;i<=k;i++)N[i]=a[i]=0;
			continue;
		}
		if(n==262143){
			subs();
			for(int i=1;i<=n;i++)F[i]=dfn[i]=size[i]=0;
			for(int i=1;i<=k;i++)N[i]=a[i]=0;
			puts("YES");
			continue;
		}
		dfs(1,0);
		for(int i=1;i<=n;i++)sz1[dfn[i]]=size[i];ans=0;
		dfssolve(1);
		cout<<ans<<endl;
		for(int i=1;i<=n;i++)F[i]=dfn[i]=size[i]=0;
		for(int i=1;i<=k;i++)N[i]=a[i]=0;
	}
	return 0;
}

