#include <stdio.h>

typedef struct
{
    int M[120][1020];
} matrix;

matrix meal;
int user[1020] = {0};

void voi_bzr(int *A, int n = 1010)
{
    while (n--)
    {
        A[n] = 0;
    }
    return;
}

int dfs(matrix &A, int *user, const int n, const int m, const int t = 0, int k = 0, const int mod = 998244353)
{
    if (!t)
    {
        voi_bzr(user, n + 3);
        return dfs(A, user, n, m, 1, 0);
    }
    if (t == m + 1)
    {
        if (k <= 1)
        {
            return 0;
        }
        for (int i = 1; i <= n; i++)
        {
            if ((user[i] << 1) > k)
            {
                return 0;
            }
        }
        return 1;
    }
    int ans = dfs(A, user, n, m, t + 1, k) % mod;
    k++;
    for (int i = 1; i <= n; i++)
    {
        user[i]++;
        ans += A.M[i][t] * dfs(A, user, n, m, t + 1, k);
        ans %= mod;
        user[i]--;
    }
    return ans;
}

int main()
{
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    int n, m;
    scanf("%d%d", &n, &m);
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            scanf("%d", &meal.M[i][j]);
        }
    }
    printf("%d\n", dfs(meal, user, n, m));
    return 0;
}

