#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>

#define MO 998244353

using namespace std;

int n, m;
int a[40][3];

namespace simple_solve {
	long long ans = 0;
	bool choose[40][3];
	int x[3];
	inline void dfs(int u) {
		//printf("%d %d %d %d\n", u, x[1], x[2], x[3]);
		if (u > n) {
			int sum = 0;
			for (int i = 1; i <= m; ++i)
				sum += x[i];
			sum /= 2;
			for (int i = 1; i <= m; ++i)
				if (x[i] > sum)
					return;
			long long b = 1;
			bool flag = 1;
			for (int i = 1; i <= n; ++i)
				for (int j = 1; j <= m; ++j)
					if (choose[i][j]) {
						b *= a[i][j];
						flag = 0;
					}
			if (!flag)
				ans += b;
			ans %= MO;
			return;
		} 
		dfs(u + 1);
		for (int i = 1; i <= m; ++i) {
			if (a[u][i] != 0) {
				choose[u][i] = 1;
				++x[i];
				dfs(u + 1);
				--x[i];
				choose[u][i] = 0;
			}
		}
	}
	int main() {
		memset(x, 0, sizeof(x));
		memset(choose, 0, sizeof(choose));
		dfs(1);
		printf("%lld\n", ans%MO);
		return 0;
	}
}

inline bool ck(int a, int b, int c) {
	return (a <= (a + b + c)/2) && (b <= (a + b + c)/2) && (c <= (a + b + c)/2);
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	long long f[40][40][40][4];
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i) 
		for (int j = 1; j <= m; ++j) {
			scanf("%d", &a[i][j]);
		}
	if ((m <= 2 && n <= 39) || (m == 3 && n <= 39)) {
		simple_solve::main();
	}
	else {
	for (int i = 0; i <= 1; ++i) {
		for (int j = 0; j <= n; ++j)
			for (int k = 0; k <= n; ++k)
				for (int l = 0; l <= n; ++l)
					f[i][j][k][l] = 1 - i;
	}
	for (int i = 1; i <= n; ++i) {
		if (i > 1)
		for (int j = 0; j <= n; ++j) {
			for (int k = 0; k <= n; ++k) {
				for (int l = 0; l <= n; ++l)
					f[i][j][k][l] = f[i - 1][j][k][l] % MO;
			}
		}
		f[i][0][0][0] =1;
		for (int j = 0; j < i; ++j) {
			for (int k = 0; k < i; ++k) {
				for (int l = 0; l < i; ++l) {
					for (int p = 1; p <= m; ++p) {
						/*if (p == 1 && a[i][p] != 0)
							f[i][j + 1][k][l] = max(f[i][j + 1][k][l], f[i - 1][j][k][l] * a[i][p]);
						else if (p == 2 && a[i][p] != 0)
							f[i][j][k + 1][l] = max(f[i][j][k + 1][l], f[i - 1][j][k][l] * a[i][p]);
						else if (p == 3 && a[i][p] != 0)
							f[i][j][k][l + 1] = max(f[i][j][k][l + 1], f[i - 1][j][k][l] * a[i][p]);*/
						if (p == 1 && a[i][p] != 0)
							f[i][j + 1][k][l] += f[i - 1][j][k][l] * a[i][p];
						else if (p == 2 && a[i][p] != 0)
							f[i][j][k + 1][l] += f[i - 1][j][k][l] * a[i][p];
						else if (p == 3 && a[i][p] != 0)
							f[i][j][k][l + 1] += f[i - 1][j][k][l] * a[i][p];
					}
				}
			}
		}
	}
	long long ans = 0;
	for (int i = 0; i <= n; ++i)
		for (int j = 0; j <= n; ++j)
			for (int k = 0; k <= n; ++k)
				if (i + j + k <= n && i + j + k > 0 && i <= (i + j + k)/2 && j <= (i + j + k)/2 && k <= (i + j + k)/2) {
					ans += f[n][i][j][k];
					ans += MO;
					ans %= MO;
				}
	printf("%lld\n", ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
