#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

unsigned long long ans = 0;
int n, type;
bool b[55];
unsigned long long f[55];
int a[10005];
unsigned long long sum[10005];
unsigned long long ct[10005];

inline void dfs(int u, int pre, int tot, int sum) {
	if (u == n) {
		if (tot + a[u] < pre)
			return;
		sum += (tot + a[u]) * (tot + a[u]);
		if (sum < ans)
			ans = sum;
		return;
	}
	b[u] = 0;
	dfs(u + 1, pre, tot + a[u], sum);
	b[u] = 1;
	if (tot + a[u] >= pre) {
		dfs(u + 1, tot + a[u], 0, sum + (tot + a[u]) * (tot + a[u]));
	}
	b[u] = 0;
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &type);
	if (type == 0) {
		for (int i = 1; i <= n; ++i)
			scanf("%d", &a[i]);
	}
	else {
		for (int i = 1; i <= n; ++i) {
			printf("F**k ccf\n");
		}
	}
	if (n <= 25) {
		b[n] = 1;
		memset(f, 1000000000000000003, sizeof(f));
		ans = 1000000000000000003;
		dfs(1, 0, 0, 0);
		printf("%llu\n", ans);
	}
	else {
		for (int i = 1; i <= n; ++i) {
			sum[i] = sum[i - 1] + a[i];
			f[i] = 1000000000000000003;
			ct[i] = 0;
		}
		f[0] = 0;
		for (int i = 1; i <= n; ++i) {
			for (int j = 0; j < i; ++j) {
				if (sum[i] - sum[j] >= ct[j] && (f[j] + (sum[i] - sum[j]) * (sum[i] - sum[j]) <= f[i])) {
					f[i] = f[j] + (sum[i] - sum[j]) * (sum[i] - sum[j]);
					ct[i] = sum[i] - sum[j];
				}
			}
		}
		printf("%llu\n", f[n]);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
