#include <algorithm>
#include <string.h>
#include <iostream>
#include <stdio.h>

using namespace std;

const int MAXN = 3e6 + 5;

typedef long long LL;

int Head[MAXN], vet[MAXN << 1], Next[MAXN << 1];
int size[MAXN], flag[MAXN], tot, tx, ty, pp[MAXN];
int size1, size2, n;
LL ans;

struct s{
	int x, y;
}a[MAXN];

void add(int a, int b) {
	Next[++tot] = Head[a];
	vet[tot] = b;
	Head[a] = tot;
}

void dfs1(int x, int pre) {
	size[x] = 1;
	for (int i = Head[x]; i; i = Next[i]) {
		int y = vet[i];
		if (y == pre || y == tx || y == ty) continue;
		dfs1(y, x);
		size[x] += size[y];
	}
}

void dfs2(int x, int pre, int type) {
	size[x] = 1;
	pp[x] = type;
	int low = (type ? size2 : size1);
	low >>= 1;
	for (int i = Head[x]; i; i = Next[i]) {
		int y = vet[i];
		if (y == pre || y == tx || y == ty) continue;
		dfs2(y, x, type);
//		printf("x = %d %d low = %d \n", x, size[y], low);
		if (size[y] > low) flag[x] = 0;
		size[x] += size[y];
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int t;
	scanf("%d", &t);
	while (t--) {
		ans = 0;
		memset(Head, 0, sizeof Head);
		scanf("%d", &n);
		for (int i = 1; i < n; ++i ) {
			int x, y;
			scanf("%d %d", &x, &y);
			a[i].x = min(x, y);
			a[i].y = max(x, y);
			add(x, y);
			add(y, x);
		}
		for (int i = 1; i < n; ++i ) {
			for (int j = 1; j <= n; ++j ) flag[j] = 1;
			tx = a[i].x; ty = a[i].y;
//			printf("tx = %d ty = %d\n", tx, ty);
			dfs1(tx, 0);
			dfs1(ty, 0);
			size1 = size[tx];
			size2 = size[ty];
//			memset(size, 0, sizeof size);
//			printf("size1 = %d   size2 = %d\n", size1, size2);
			dfs2(tx, 0, 0);
			dfs2(ty, 0, 1);
//			if (i == n - 1) printf("flag[3] = %d  size[3] = %d size[2] = %d \n", flag[3], size[3], size[2]);
//			printf("%d\n", flag[3]);
			for (int j = 1; j <= n; ++j ) {
				if (flag[j] == 0) continue;
				int low = (pp[j] == 1 ? size2 : size1);
				if ((low - size[j]) <= (low >> 1)) {
//					printf("%d   ", j);
					ans += j;
				}
			}
//			puts("");
		}
		printf("%lld\n", ans);
	}
	return 0;
}
