#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>

int T,n,X[300050],Y[300050];

struct edge{int to,nxt;}E[600050];
int H[300050],tot;
void add_edge(int a,int b){
	E[++tot]=(edge){b,H[a]},H[a]=tot;
	E[++tot]=(edge){a,H[b]},H[b]=tot;
}

namespace subtask1{ // n<=1999
	bool checker(){
		return n<=2000;
	}
	int G1,G2,fulsz,sz[2050];
	long long ans;
	int getsize(int now,int fa){
		int sz=1;
		for (int i=H[now];i;i=E[i].nxt)
			if (E[i].to!=fa) sz+=getsize(E[i].to,now);
		return sz;
	}
	void getG(int now,int fa){
		sz[now]=1;
		int mxsz=0;
		for (int i=H[now];i;i=E[i].nxt){
			if (E[i].to!=fa){
				getG(E[i].to,now);
				sz[now]+=sz[E[i].to];
				mxsz=std::max(mxsz,sz[E[i].to]);
			}
		}
		mxsz=std::max(mxsz,fulsz-sz[now]);
		if (mxsz<=fulsz/2) (G1?G2:G1)=now;
	}
	void main(){
		ans=0;
		for (int i=1;i<n;i++){
			G1=G2=0;
			fulsz=getsize(X[i],Y[i]);
			getG(X[i],Y[i]);
			ans+=G1+G2;
//			printf("G=(%d,%d)\n",G1,G2);

			G1=G2=0;
			fulsz=getsize(Y[i],X[i]);
			getG(Y[i],X[i]);
			ans+=G1+G2;
//			printf("G=(%d,%d)\n",G1,G2);
		}
		printf("%lld\n",ans);
	}
}

namespace subtask2{ // A
	int D[50000];
	bool checker(){
		for (int i=1;i<=n;i++) D[i]=0;
		for (int i=1;i<n;i++) D[X[i]]++,D[Y[i]]++;
		for (int i=1;i<=n;i++) if (D[i]>2) return false;
		return true;
	}
	int seq[50000],top;
	void dfs(int now,int fa){
		seq[++top]=now;
		for (int i=H[now];i;i=E[i].nxt)
			if (E[i].to!=fa) dfs(E[i].to,now);
	}
	long long ans;
	void main(){
		top=ans=0;
		int d=0;
		for (int i=1;i<=n;i++) if (D[i]==1) d=i;
		dfs(d,0);
		for (int i=1;i<n;i++){
			if (i&1) ans+=seq[(i>>1)+1];
			else ans+=seq[i>>1]+seq[(i>>1)+1];
		}
		std::reverse(seq+1,seq+n+1);
		for (int i=1;i<n;i++){
			if (i&1) ans+=seq[(i>>1)+1];
			else ans+=seq[i>>1]+seq[(i>>1)+1];
		}
		printf("%lld\n",ans);
	}
}

namespace subtask3{ // B
	int D[524288];
	bool checker(){
//		return (n&(n+1))==0;
//		fake checker, just for test
		return n==262143;
	}
	long long sumnd[20];
	void dfs(int now,int fa=0,int dep=0){
		sumnd[dep]+=now;
		for (int i=H[now];i;i=E[i].nxt)
			if (E[i].to!=fa) dfs(E[i].to,now,dep+1);
	}
	int G1,G2,fulsz,sz[524288],dep[524288];
	int getsize(int now,int fa){
		int sz=1;
		for (int i=H[now];i;i=E[i].nxt)
			if (E[i].to!=fa) sz+=getsize(E[i].to,now);
		return sz;
	}
	long long ans;
	void getG(int now,int fa){
		sz[now]=1;
		int mxsz=0;
		for (int i=H[now];i;i=E[i].nxt){
			if (E[i].to!=fa){
				getG(E[i].to,now);
				sz[now]+=sz[E[i].to];
				mxsz=std::max(mxsz,sz[E[i].to]);
			}
		}
		mxsz=std::max(mxsz,fulsz-sz[now]);
		if (mxsz<=fulsz/2) (G1?G2:G1)=now;
	}
	void main(){
		ans=0;
		for (int i=1;i<=n;i++) D[i]=0;
		for (int i=1;i<n;i++) D[X[i]]++,D[Y[i]]++;
		for (int i=0;i<20;i++) sumnd[i]=0;
		int d=0;
		for (int i=1;i<=n;i++) if (D[i]==2) d=i;
		dfs(d);
//		for (int i=0;i<20;i++) printf("%lld ",sumnd[i]);
//		putchar(10);
		memset(E,0,sizeof(E));
		memset(H,0,sizeof(H));
		tot=0;
		dep[1]=0;
		for (int i=1;i<=(n>>1);i++) add_edge(i,i<<1),add_edge(i,i<<1|1),dep[i<<1]=dep[i]+1,dep[i<<1|1]=dep[i]+1;
		for (int i=1;i<<1<=n;i<<=1){
//			printf("i=%d\n",i);
			G1=G2=0;
			fulsz=getsize(i,i<<1);
			getG(i,i<<1);
			ans+=sumnd[dep[G1]]*(i<<1>>dep[G1]);
			if (G2) ans+=sumnd[dep[G2]]*(i<<1>>dep[G2]);
//			printf("G=(%d,%d)\n",G1,G2);

			G1=G2=0;
			fulsz=getsize(i<<1,i);
			getG(i<<1,i);
			ans+=sumnd[dep[G1]]*(i<<1>>dep[G1]);
			if (G2) ans+=sumnd[dep[G2]]*(i<<1>>dep[G2]);
//			printf("G=(%d,%d)\n",G1,G2);
		}
		printf("%lld\n",ans);
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--){
		scanf("%d",&n);
		for (int i=1;i<n;i++) scanf("%d%d",&X[i],&Y[i]),add_edge(X[i],Y[i]);
		if (subtask1::checker()) subtask1::main();
		else if (subtask2::checker()) subtask2::main();
		else if (subtask3::checker()) subtask3::main();

		// clear
		memset(E,0,sizeof(E));
		memset(H,0,sizeof(H));
		tot=0;
	}
}
