#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
template<class T>void Read(T &x) {
	x = 0;
	T f = 1;
	char ch = getchar();
	for(; !isdigit(ch); ch = getchar())
		if(ch == '-')
			f = -1;
	for(; isdigit(ch); ch = getchar())
		x = x * 10 + (ch - 48);
	x *= f;
}
void file() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
}
int T, n;
namespace Sqr {
	const int maxn = 2005;
	vector<int>G[maxn];
	int fr[maxn], to[maxn], bidx,bidy, ans, siz[maxn], sz[maxn], fa[maxn];
	int Del(int x, int y) {
		return (x == bidx && y == bidy) || (y == bidx && x == bidy);
	}
	void Find(const int &s, int u, int f = 0) {
		sz[u] = 1;
		int maxs = 0;
		for(int i = 0; i < (int)G[u].size(); ++ i) {
			int v = G[u][i];
			if(v == f || Del(u, v))
				continue;
			Find(s, v, u), sz[u] += sz[v], maxs = max(maxs, sz[v]);
		}
		if(maxs <= s / 2 && sz[u] >= (s + 1) / 2)
			ans += u;
	}
	void Getsize(int x, int y, int &sx, int &sy) {
		// cerr << x << " " << y << endl;
		if(y == fa[x])
			sx = siz[x], sy = n - sx;
		if(x == fa[y])
			sy = siz[y], sx = n - sy;
	}
	void Prework(int u = 1) {
		siz[u] = 1;
		for(int i =0; i < (int)G[u].size(); ++ i) {
			int v = G[u][i];
			if(v == fa[u])
				continue;
			fa[v] = u, Prework(v), siz[u] += siz[v];
		}
	}
	void Solve() {
		ans = 0;
		for(int i = 1; i < n; ++ i)
			Read(fr[i]), Read(to[i]), G[fr[i]].push_back(to[i]), G[to[i]].push_back(fr[i]);
		Prework();
		// for(int i = 1; i <= n; ++ i)
			// cerr << i << " " << sz[i] << " " << fa[i] << endl;
		for(int i = 1, six, siy; i < n; ++ i)
			bidx = fr[i], bidy = to[i], Getsize(bidx, bidy, six, siy), Find(six, bidx), Find(siy, bidy);
		printf("%d\n", ans);
		for(int i = 1; i <= n; ++ i)
			G[i].clear(), fa[i] = 0;
	}
}
const int maxn = 300005;
int fr[maxn], to[maxn];
namespace Chain {
	vector<int>G[maxn];
	int id[maxn], pos[maxn], deg[maxn];
	ll ans;
	int Check() {
		for(int i = 1; i <= n; ++ i)
			deg[i] = 0;
		for(int i = 1; i < n; ++ i)
			++ deg[fr[i]], ++ deg[to[i]];
		for(int i = 1; i <= n; ++ i)
			if(deg[i] > 2)
				return 0;
		return 1;
	}
	void Work(int u) {
		for(int i = 0; i < (int)G[u].size(); ++ i) {
			int v = G[u][i];
			if(pos[v])
				continue;
			pos[v] = pos[u] + 1, id[pos[v]] = v, Work(v);
		}
	}
	void Plus(int l, int r) {
		int len = r - l + 1;
		if(len & 1) {
			int mid = (l + r) >> 1;
			ans += id[mid];
		}
		else {
			int mid = (l + r) >> 1;
			ans += id[mid] + id[mid + 1];
		}
	}
	void Solve() {
		ans = 0;
		for(int i = 1; i < n; ++ i)
			G[fr[i]].push_back(to[i]), G[to[i]].push_back(fr[i]);
		int rt = 0;
		for(int i = 1; i < n; ++ i)
			if(deg[i] == 1)
				rt = i;
		assert(rt);
		pos[rt] = 1, id[1] = rt, Work(rt);
		/*for(int i = 1; i <= n; ++ i)
			cerr << id[i] << " ";
		cerr << endl;
		for(int i = 1; i <= n; ++ i)
			cerr << pos[i] << " ";
		cerr << endl;*/
		for(int i = 1; i < n; ++ i) {
			int x = fr[i], y = to[i];
			// cerr << "Now Solve :" << x << " -> " << y << endl;
			if(pos[x] > pos[y])
				swap(x, y);
			Plus(1, pos[x]), Plus(pos[y], n);
		}
		printf("%lld\n", ans);
		for(int i = 1; i <= n; ++ i)
			pos[i] = id[i] = 0, G[i].clear();
	}
}
namespace Perf {
	vector<int>G[maxn];
	int sz[maxn], fa[maxn], dep[maxn], cen, maxdep, le, ri;
	ll ans;
	int Check() {
		int x = n + 1;
		while(!(x & 1))
			x >>= 1;
		return x == 1;
	}
	void GetC(int u, int f = 0) {
		sz[u] = 1;
		int maxs = 0;
		for(int i = 0; i < (int)G[u].size(); ++ i) {
			int v = G[u][i];
			if(v == f)
				continue;
			GetC(v, u), sz[u] += sz[v], maxs = max(maxs, sz[v]);
		}
		if(maxs <= n / 2 && sz[u] >= (n + 1) / 2)
			cen = u;
	}
	void Work(int u) {
		sz[u] = 1;
		for(int i = 0; i < (int)G[u].size(); ++ i) {
			int v = G[u][i];
			if(v == fa[u])
				continue;
			fa[v] = u, dep[v] = dep[u] + 1, Work(v), sz[u] += sz[v];
		}
		maxdep = max(maxdep, dep[u]);
	}
	void Solve() {
		ans = le = ri = cen = 0;
		for(int i = 1; i < n; ++ i)
			G[fr[i]].push_back(to[i]), G[to[i]].push_back(fr[i]);
		GetC(1);
		Work(cen);
		for(int i = 0; i < (int)G[cen].size(); ++ i)
			if(le)
				assert(!ri), ri = G[cen][i];
			else
				le = G[cen][i];
		for(int i = 1; i < n; ++ i) {
			int x = fr[i], y = to[i];
			if(dep[x] > dep[y])
				swap(x, y);
			if(dep[y] == maxdep)
				ans += cen;
			if(x == cen) {
				if(y == le)
					ans += ri;
				else
					ans += le;
				ans += y;
				continue;
			}
			ans += y;
			for(int tmp = x; tmp; tmp = fa[tmp])
				sz[tmp] -= sz[y];
			if(sz[le] > sz[ri])
				ans += le;
			else
				ans += ri;
			for(int tmp = x; tmp; tmp = fa[tmp])
				sz[tmp] += sz[y];
		}
		printf("%lld\n", ans);
		for(int i = 1; i <= n; ++ i)
			G[i].clear();
	}
}
int main() {
	file();
	for(Read(T); T --; ) {
		Read(n);
		if(n <= 2000) {
			Sqr :: Solve();
			continue;
		}
		for(int i = 1; i < n; ++ i)
			Read(fr[i]), Read(to[i]);
		if(Chain :: Check())
			Chain :: Solve();
		if(Perf :: Check())
			Perf :: Solve();
	}
}
