#include <iostream>
#include <cstdio>
const int maxn = 110, maxm = 2010, mod = 998244353;
inline void up(int& x) {
	if ((x += mod) >= mod) x -= mod;
}
int rsum[maxn], a[maxn][maxm], f[maxn], g[maxn][maxn];
int main() {
	freopen("meal.in", "r", stdin), freopen("meal.out", "w", stdout);
	std::ios_base::sync_with_stdio(0), std::cin.tie(0);
	int n, m; std::cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j) {
			std::cin >> a[i][j];
			up(rsum[i] += a[i][j] - mod);
		}
	for (int i = 0; i <= n; ++i)
		f[i] = 0;
	f[0] = 1;
	for (int i = 1; i <= n; ++i)
		for (int j = n; j; --j)
			f[j] = (1ll * f[j - 1] * rsum[i] + f[j]) % mod;
	int ans = 0;
	for (int i = 1; i <= n; ++i)
		up(ans += f[i] - mod);
	for (int l = 1; l <= m; ++l) {
		for (int i = 0; i <= n; ++i)
			for (int j = 0; j <= n; ++j)
				g[i][j] = 0;
		g[0][0] = 1;
		for (int i = 1; i <= n; ++i)
			for (int s = i; s; --s)
				for (int j = s; ~j; --j) {
					g[s][j] = (g[s][j] + 1ll * (j ? g[s - 1][j - 1] : 0) * a[i][l] + 1ll * g[s - 1][j] * (rsum[i] - a[i][l] + mod)) % mod;
				}
		for (int k = 1; k <= n; ++k)
			for (int i = (k >> 1) + 1; i <= k; ++i)
				up(ans -= g[k][i]);
	}
	std::cout << ans << std::endl;
}
