#include <bits/stdc++.h>

#define INF 0x3f3f3f3f3f3fLL

typedef unsigned long long ll;

template<typename T> inline int chkmin(T &x, T y) { return x > y ? x = y, 1 : 0; }

const int N = 4e7 + 9;

int n, tp, a[N];

ll ans = INF, sum[N];

inline ll sqr(int x) { return 1LL * x * x; }

namespace Subtask1 // n^3
{
	const int MAXN = 409;
	ll f[MAXN][MAXN];
	
	void Work()
	{
		for (int i = 1; i <= n; ++i) 
		{
			f[i][1] = sqr(sum[i]);
			for (int j = 2; j <= i; ++j)
			{
				f[i][j] = INF;
				for (int k = j - 1; k; --k) 
				{
					if (sum[j - 1] - sum[k - 1] > sum[i] - sum[j - 1])
						break;
					chkmin(f[i][j], f[j - 1][k]);
				}
				f[i][j] += sqr(sum[i] - sum[j - 1]);	
			}
		}
		
		for (int i = 1; i <= n; ++i)
			chkmin(ans, f[n][i]);
		
		printf("%lld\n", ans);
	}
}

namespace Subtask2 // n^2 
{
	const int MAXN = 5009;
	ll f[MAXN][MAXN];
	int border[MAXN];
	
	void Work()
	{
		for (int i = 1; i <= n; ++i) 
		{
			f[i][1] = sqr(sum[i]);
			border[i] = 1;
			for (int j = 2; j <= i; ++j) 
			{
				f[i][j] = f[i][j - 1];
				if (sum[i] - sum[j - 1] < sum[j - 1] - sum[border[j - 1] - 1])
					continue;
				border[i] = j;
				f[i][j] = f[j - 1][border[j - 1]] + sqr(sum[i] - sum[j - 1]);	
			}
		}
		
		for (int i = 1; i <= n; ++i)
			chkmin(ans, f[n][i]);
		
		printf("%lld\n", ans);
	}
}

int main() 
{
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	
	scanf("%d%d", &n, &tp);
	for (int i = 1; i <= n; ++i) 
	{
		scanf("%d", &a[i]);
		sum[i] = sum[i - 1] + a[i];
	}
	
	if (n <= 400)
		Subtask1::Work();
	else
		Subtask2::Work();

	return 0;
}
