#include<bits/stdc++.h>
#define LL long long
using namespace std;
const int N = 50000 + 5;

int nxt[N << 1], to[N << 1], tot, hd[N];

inline void add(int u, int v) {
	to[++tot] = v;
	nxt[tot] = hd[u];
	hd[u] = tot;
}

int T, n;

struct S1 {
	int U[N], V[N], siz[N], delu, delv, root;
	
	void dfs0(int u, int fa = 0) {
		siz[u] = 1;
		for (int i = hd[u]; i; i = nxt[i]) {
			int v = to[i];
			if (v == fa) continue;
			if (u == delu && v == delv) continue;
			if (v == delu && u == delv) continue;
			dfs0(v, u);
			siz[u] += siz[v];
		}
	}
	
	int dfs1(int u, int fa = 0) {
		int res = 0;
		int MaxSiz = 0;
		for (int i = hd[u]; i; i = nxt[i]) {
			int v = to[i];
			if (v == fa) continue;
			if (u == delu && v == delv) continue;
			if (v == delu && u == delv) continue;
			res += dfs1(v, u);
			MaxSiz = max(MaxSiz, siz[v]);
		}
		MaxSiz = max(MaxSiz, siz[root] - siz[u]);
		if (MaxSiz <= siz[root] / 2) res += u;
		//printf("siz[%d] = %d, maxsiz[%d] = %d\n", u, siz[u], u, MaxSiz);
		return res; 
	}
	
	void work() {
		int ans = 0;
		for (int i = 1; i <= n - 1; i++) {
			scanf("%d%d", &U[i], &V[i]);
			add(U[i], V[i]), add(V[i], U[i]);
		}
		for (int i = 1; i <= n - 1; i++) {
			delu = U[i], delv = V[i];
			root = U[i], dfs0(U[i]), ans += dfs1(U[i]);
			root = V[i], dfs0(V[i]), ans += dfs1(V[i]);
		}
		printf("%d\n", ans);
	}
}s1;

struct S2 {
	int du[N], cnt, a[N];
	
	void work(void) {
		cnt = 1;
		memset(du, 0, sizeof(du));
		for (int i = 1; i <= n - 1; i++) {
			int u, v; scanf("%d%d", &u, &v);
			add(u, v), add(v, u);
			++du[u], ++du[v];
		}
		for (int i = 1; i <= n; i++) {
			if (du[i] == 1) {
				a[1] = i;
				break;
			}
		}
		while (cnt < n) {
			for (int i = hd[a[cnt]]; i; i = nxt[i]) {
				if (cnt == 1 || to[i] != a[cnt - 1]) {
					a[++cnt] = to[i];
					break;
				}
			}
		}
		LL ans = 0;
		
		for (int i = 1; i <= n - 1; i++) {
			if (i & 1) ans += 1LL * a[(i + 1) >> 1];
			else ans += 1LL * a[i >> 1] + a[(i >> 1) + 1];
			if ((n - i) & 1) ans += 1LL * a[n - ((n - i - 1) >> 1)];
			else ans += 1LL * a[n - ((n - i) >> 1)] + a[n - ((n - i) >> 1) + 1];
		}
		printf("%lld\n", ans);
		return ;
	}
}s2;

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	scanf("%d", &T);
	while (T--) {
		tot = 0;
		memset(hd, 0, sizeof(hd));
		scanf("%d", &n);
		if (n <= 2000) s1.work();
		else if (n == 49991) s2.work();
	}
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
