#include <bits/stdc++.h>

#define Rep(i,l,r) for (int i=l; i<=r; ++i)
#define Per(i,r,l) for (int i=r; i>=l; --i)

const int Extra=5,Max_N=3e5;

int Read(){
	int x=0,f=0,ch=getchar();
	while (!isdigit(ch)) f^=!(ch^'-'),ch=getchar();
	while (isdigit(ch)) x=(x<<1)+(x<<3)+ch-'0',ch=getchar();
	return f?-x:x;
}

void Check_Judge(){
	freopen("centroid.in","r",stdin),freopen("centroid.out","w",stdout);
}

long long ans;
int n,tot,siz[Max_N+Extra],lnk[Max_N+Extra],to[2*Max_N+Extra],nxt[2*Max_N+Extra];

void Add(int x,int y){
	++tot,to[tot]=y,nxt[tot]=lnk[x],lnk[x]=tot;
}
//
int vis[2*Max_N+Extra];

void DFS1(int x,int fa){
	siz[x]=1;
	for (int i=lnk[x]; i; i=nxt[i])
		if (vis[i]&&to[i]!=fa)
			DFS1(to[i],x),siz[x]+=siz[to[i]];
}

void DFS2(int x,int fa,int tot){
	for (int i=lnk[x]; i; i=nxt[i])
		if (vis[i]&&to[i]!=fa)
			DFS2(to[i],x,tot);
	if (tot/2<(tot-siz[x]))
		return;
	for (int i=lnk[x]; i; i=nxt[i])
		if (vis[i]&&to[i]!=fa)
			if (siz[to[i]]>tot/2)
				return;
	ans+=x;
}


void Solve1(){
	memset(vis,1,sizeof vis);
	Rep(i,1,n-1){
		vis[2*i-1]=0,vis[2*i]=0;
		memset(siz,0,sizeof siz);
		Rep(k,1,n)
			if (siz[k]==0){
				DFS1(k,0);
				DFS2(k,0,siz[k]);
			}
		vis[2*i-1]=1,vis[2*i]=1;
	}
	printf("%lld\n",ans);		
}
//

//
int l[Max_N+Extra],r[Max_N+Extra];

void DFS3(int x,int fa){
	for (int i=lnk[x]; i; i=nxt[i])
		if (to[i]!=fa)
			r[x]=to[i],l[to[i]]=x,DFS3(to[i],x);
}

void Solve2(){
	int hd=0,tl=0;
	Rep(i,1,n)
		if (nxt[lnk[hd]]==0)
			if (hd==0)
				hd=i;
			else
				tl=i;
	DFS3(hd,0);
	int now=hd,mid=hd;
	while (r[now]){
		ans+=mid;
		now=r[now];
		ans+=mid+r[mid];
		now=r[now];
		mid=r[mid];
	}
	now=tl,mid=tl;
	while (l[now]){
		ans+=mid;
		now=l[now];
		ans+=mid+l[mid];
		now=l[now];
		mid=l[mid];
	}
	printf("%lld\n",ans);
}
//

//
int rt;

void DFS4(int x,int fa){
	siz[x]=1;
	for (int i=lnk[x]; i; i=nxt[i])
		if (to[i]!=fa){
			DFS4(to[i],x),siz[x]+=siz[to[i]];
			if (siz[to[i]]==n/2)
				rt=x;
		}
}

void Solve3(){
	ans=(n-4)*rt+to[lnk[rt]]+to[nxt[lnk[rt]]]+1LL*n*(n-1)/2;
}
//
int main(){
	Check_Judge();
	Per(T,Read(),1){
		n=Read();
		tot=0,memset(lnk,0,sizeof lnk);
		Rep(i,2,n){
			int x=Read(),y=Read();
			Add(x,y),Add(y,x);
		}
		ans=0;
		if (n<=2000){
			Solve1();
			continue;
		}
		if (n==49991){
			Solve2();
			continue;
		}
		if (n==262143){
			Solve3();
			continue;
		}
	}
	return 0;
}
