#include <bits/stdc++.h>
#define pii pair<int,int>
#define x first
#define y second
using namespace std;
template<class t> inline t read(t &x){
	x=0;char c=getchar();bool f=0;
	while(!isdigit(c)) f|=c=='-',c=getchar();
	while(isdigit(c)) x=(x<<1)+(x<<3)+(c^48),c=getchar();
	if(f) x=-x;return x;
}
template<class t> inline void write(t x){
	if(x<0){putchar('-'),write(-x);}
	else{if(x>9)write(x/10);putchar('0'+x%10);}
}
const int N=2005,CN=3e5+5;
int sz[CN],csz[N][N],n,t,en,h[CN],du[CN],ch[CN],m;
long long ans;
bool v[CN];
pii data[CN];
struct edge{
	int n,v;
}e[CN<<1];
void add(int x,int y){
	e[++en]=(edge){h[x],y};
	h[x]=en;
}
void dfs(int x,int fa){
	sz[x]=1;
	for(int i=h[x];i;i=e[i].n){
		int y=e[i].v;
		if(y==fa) continue;
		dfs(y,x);
		csz[x][y]=sz[y];
		sz[x]+=sz[y];
	}
}
void up(int x,int fa,int val){
	csz[x][fa]+=val;
	for(int i=h[x];i;i=e[i].n){
		int y=e[i].v;
		if(y==fa) continue;
		up(y,x,val);
	}
}
void get(int x,int fa,int aim){
	bool flag=1;
	if(csz[x][fa]>aim/2) flag=0;
	for(int i=h[x];i;i=e[i].n){
		int y=e[i].v;
		if(y==fa) continue;
		if(csz[x][y]>aim/2) flag=0;
		get(y,x,aim);
	}
	if(flag) ans+=x;
}
void init(){
	en=ans=0;
	for(int i=1;i<=n;i++) h[i]=du[i]=v[i]=0;
	if(n>1999) return ;
	for(int i=1;i<=n;i++)
		for(int j=1;j<=n;j++)
			csz[i][j]=0x3f3f3f3f;
}
void getchain(int x){
	ch[++m]=x;
	v[x]=1;
	for(int i=h[x];i;i=e[i].n){
		x=e[i].v;
	}
	v[x]=1;
	ch[++m]=x;
	while(du[x]!=1){
		for(int i=h[x];i;i=e[i].n){
			x=e[i].v;
			if(!v[x]) break; 
		}
		ch[++m]=x;
		v[x]=1;
	}
}
int dealit(int l,int r){
	if((r-l+1)%2==0){
		return ch[(l+r)/2]+ch[(l+r+1)/2];
	}
	else{
		return ch[(l+r)/2]; 
	}
}
void chainsub(){
	m=0;
	for(int i=1;i<=n;i++) if(du[i]==1){
		getchain(i);
		break;
	}
	for(int i=1;i<n;i++){
		ans+=dealit(1,i);
		ans+=dealit(i+1,n);
	}
	write(ans);puts("");
}
void ddfs(int x,int fa){
	sz[x]=1;
	for(int i=h[x];i;i=e[i].n){
		int y=e[i].v;
		if(y==fa) continue;
		ddfs(y,x);
		sz[x]+=sz[y];
	}
}
bool cdfs(int x,int fa){
	int now=(sz[x]-1)/2;
	bool flag=0;
	for(int i=h[x];i;i=e[i].n){
		int y=e[i].v;
		if(y==fa) continue;
		if(sz[y]!=now) return 0;
		int tp=cdfs(y,x);
		flag|=tp;
		if(flag) return 0;
	}
	return 1;
}
bool check(){
	int cnt=0,rt;
	for(int i=1;i<=n;i++) if(du[i]==1) cnt++; else if(du[i]==2) rt=i;
	if(cnt!=(n+1)/2) return 0;
	ddfs(rt,0);
	return cdfs(rt,0);
}
void persub(){
	int rt=0,hh=0;
	for(int i=1;i<=n;i++) if(du[i]==2){
		rt=i;
		break;
	}
	for(int i=h[rt];i;i=e[i].n){
		int y=e[i].v;
		ch[++hh]=y;
	}
	ans=1ll*(1+n)/2*n;
	ans-=rt+ch[1]+ch[2];
	ans+=1ll*(rt+ch[1]+ch[2])*(n+1)/2;
	write(ans);puts("");
}
void doit(){
	bool chainflag=1;
	read(n);
	init();
	for(int i=1,x,y;i<n;i++){
		read(x);read(y);
		data[i]=make_pair(x,y);
		du[x]++;
		du[y]++;
		if(du[x]>2||du[y]>2) chainflag=0;
		add(x,y);
		add(y,x);
	}
	if(chainflag){
		chainsub();
		return ;
	}
	if(n>1999){
		persub();
		return ;
	}
	for(int i=1;i<=n;i++) dfs(i,0);
	for(int i=1;i<n;i++){
		int u=data[i].x,v=data[i].y;
		int tp1=csz[u][v],tp2=csz[v][u];
		up(u,v,-tp1);
		up(v,u,-tp2);
		csz[u][v]=csz[v][u]=0;
		get(u,v,tp2);
		get(v,u,tp1);
		up(u,v,tp1);
		up(v,u,tp2);
		csz[u][v]=tp1,csz[v][u]=tp2;
	}
	write(ans);puts("");
}
signed main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	read(t);
	while(t--) doit();
}
