#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>

using namespace std;
typedef long long ll;
const int maxn=400+10;

int n,TYPE;
ll a[maxn],s[maxn],f[maxn][maxn][maxn];

ll Sigma(int l,int r){
	return 1ll*s[r]-1ll*s[l-1];
}
ll Min(ll a,ll b){
	return a<b?a:b;
}

int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	scanf("%d%d",&n,&TYPE);
	for (int i=1;i<=n;i++) scanf("%lld",&a[i]);
	s[0]=0ll;
	for (int i=1;i<=n;i++) s[i]=s[i-1]+a[i];
	memset(f,0x7f7f,sizeof(f));
	f[0][0][0]=0ll;
	for (int j=1;j<=n;j++)
	    for (int i=1;i<=n;i++)
	        for (int k=1;k<=i;k++){
	        	for (int m=0;m<=k-1;m++)
	        	    if (Sigma(m,k-1)<=Sigma(k,i))
						f[i][j][k]=Min(f[i][j][k],f[k-1][j-1][m]+Sigma(k,i)*Sigma(k,i));
			}
	ll ans=Sigma(1,n)*Sigma(1,n);
	for (int j=1;j<=n;j++)
		for (int k=1;k<=n;k++)
		    ans=min(ans,f[n][j][k]);
	printf("%lld\n",ans);
	return 0;
}
