#include <bits/stdc++.h>
using namespace std;

int n;

namespace subtask1 {
	const int N = 1e5 + 5;
	int to[N], nxt[N], H[N], num; 
	
	void add(int u, int v) {
		to[++num] = v;
		nxt[num] = H[u];
		H[u] = num;	
	}
	
	int siz[N];
	
	void dfs(int u, int fa) {
		siz[u] = 1;
		for (int e = H[u]; e; e = nxt[e]) {
			int v = to[e];
			if (v == fa) 
				continue;
			dfs(v, u);
			siz[u] += siz[v];
		}	
	}
	
	int x[N], y[N];
	
	void solve() {
		for (int i = 1; i < n; ++i)
			scanf("%d %d", &x[i], &y[i]);
		int ans = 0;
		for (int i = 1; i < n; ++i) {
			memset(H, 0, sizeof(H));
			num = 0;
			for (int j = 1; j < n; ++j)
				if (i != j)
					add(x[j], y[j]), add(y[j], x[j]);	
			for (int j = 1; j <= n; ++j) {
				memset(siz, 0, sizeof(siz));
				dfs(j, 0);
				bool flag = 1;
				for (int e = H[j]; e; e = nxt[e]) 
					if (siz[to[e]] > siz[j] / 2) {
						flag = 0;
						break;
					}
				if (flag)
					ans += j;
			}
		}
		printf("%d\n", ans);
	}	
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int t;
	scanf("%d", &t);
	while (t--) {
		scanf("%d", &n);
		subtask1 :: solve();
	}
	return 0;
}
