#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int MOD = 998244353;

int n, m;
ll a[105][2005];

namespace subtask1 {

	int cnt[2005];
	ll ans;
	void dfs(int t, int num, int k, ll sum) {
		if (num >= k) {
			ans = (ans + sum) % MOD;
			return;		
		}
		if (t > n)
			return;
		dfs(t + 1, num, k, sum);
		for (int i = 1; i <= m; ++i)
			if (cnt[i] < k / 2) {
				++cnt[i];
				dfs(t + 1, num + 1, k, sum * a[t][i] % MOD);	
				--cnt[i];
			}
	}

	void solve() {
		for (int i = 2; i <= n; ++i)
			dfs(1, 0, i, 1);
		printf("%lld\n", ans);
	}	
}

namespace subtask2 {
	ll f[41][41][41][41];
	
	void solve() {
		f[0][0][0][0] = 1;
		for (int i = 1; i <= n; ++i) 
			for (int j = 0; j <= i; ++j)
				for (int x = 0; x <= j; ++x)
					for (int y = 0; y <= j - x; ++y)
						f[i][j][x][y] = (f[i - 1][j][x][y] + f[i - 1][j - 1][x - 1][y] * a[i][1] % MOD + f[i - 1][j - 1][x][y - 1] * a[i][2] % MOD) % MOD;
		ll ans = 0;
		for (int i = 2; i <= n; i += 2)
				ans = (ans + f[n][i][i / 2][i / 2]) % MOD;
		printf("%lld\n", ans);
	}	
}

namespace subtask3 {
	ll f[41][41][41][41][41];
	
	void solve() {
		f[0][0][0][0][0] = 1;
		for (int i = 1; i <= n; ++i) 
			for (int j = 0; j <= i; ++j)
				for (int x = 0; x <= j; ++x)
					for (int y = 0; y <= j - x; ++y)
						for (int z = 0; z <= j - x - y; ++z)
							f[i][j][x][y][z] = (f[i - 1][j][x][y][z] + f[i - 1][j - 1][x - 1][y][z] * a[i][1] % MOD + f[i - 1][j - 1][x][y - 1][z] * a[i][2] % MOD + f[i - 1][j - 1][x][y][z - 1] * a[i][3] % MOD) % MOD;
		ll ans = 0;
		for (int i = 2; i <= n; ++i) 
			for (int x = 0; x <= i / 2; ++x)
				for (int y = 0; y <= min(i - x, i / 2); ++y)
					if (i - x - y <= i / 2)
						ans = (ans + f[n][i][x][y][i - x - y]) % MOD;
		printf("%lld\n", ans);
	}
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d %d", &n, &m);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			scanf("%lld", &a[i][j]);
	if (n <= 10)
		subtask1 :: solve();	
	if (n == 40 && m == 2) 
		subtask2 :: solve();
	if (n == 40 && m == 3)
		subtask3 :: solve();
	return 0;
}
