#include<fstream>
#include<algorithm>
using namespace std;
ifstream fin("centroid.in");
ofstream fout("centroid.out");
const int N=3e5;
int n,head[N],v[N*2],nxt[N*2],e,sz[N],ans,ans2,m,deg[N],num[N],dep[N],anss[50];
inline void add_edge(int u,int v)
{
	::v[++e]=v;
	nxt[e]=head[u];
	head[u]=e;
}
void dfs(int k,int fat,int cut,bool cnt)
{
	sz[k]=1;
	bool flag=true;
	for(int i=head[k];i;i=nxt[i])
		if((i+1)/2!=cut&&v[i]!=fat)
		{
			dfs(v[i],k,cut,cnt);
			sz[k]+=sz[v[i]];
			if(sz[v[i]]>m/2)
				flag=false;
		}
	if(flag&&m-sz[k]<=m/2&&cnt)
	{
		ans+=k;
		ans2+=k;
	}
}
void bfs(int k,int fat)
{
	for(int i=head[k];i;i=nxt[i])
		if(v[i]!=fat)
		{
			dep[v[i]]=dep[k]+1;
			bfs(v[i],k);
		}
}
int main()
{
	int t;
	fin>>t;
	while(t--)
	{
		fin>>n;
		fill(head+1,head+n+1,0);
		fill(deg+1,deg+n+1,0);
		e=0;
		for(int i=1;i<n;i++)
		{
			int u,v;
			fin>>u>>v;
			deg[u]++;deg[v]++;
			add_edge(u,v);
			add_edge(v,u);
		}
		if(n==49991)
		{
			int k,i;
			for(k=1;k<=n;k++)
				if(deg[k]==1)
					break;
			num[1]=k;
			k=v[head[k]];
			for(i=2;deg[k]==2;i++)
			{
				num[i]=k;
				if(v[head[k]]==num[i-1])
					k=v[nxt[head[k]]];
				else
					k=v[head[k]];
			}
			num[i]=k;
			long long ans=0;
			for(int i=1;i<n;i++)
				if(i&1)
					ans+=num[(1+i)/2]+num[(i+n)/2]+num[(i+n)/2+1];
				else
					ans+=num[i/2]+num[i/2+1]+num[(i+1+n)/2];
			fout<<ans<<endl;
		}
		else if(n==262143)
		{
			dep[1]=1;
			bfs(1,0);
			long long ans=0;
			fill(anss+1,anss+50,0);
			for(int i=1;i<n;i++)
			{
				if(anss[min(dep[v[i*2-1]],dep[v[i*2]])])
				{
					ans+=anss[min(dep[v[i*2-1]],dep[v[i*2]])];
					continue;
				}
				ans2=0;
				dfs(1,0,i,false);
				m=sz[1];
				fill(sz+1,sz+n+1,0);
				dfs(1,0,i,true);
				for(int j=1;j<=n;j++)
					if(!sz[j])
					{
						dfs(j,0,i,false);
						m=sz[j];
						dfs(j,0,i,true);
						break;
					}
				ans+=(anss[min(dep[v[i*2-1]],dep[v[i*2]])]=ans2);
			}
			fout<<ans<<endl;
		}
		else
		{
			ans=0;
			for(int i=1;i<n;i++)
			{
				dfs(1,0,i,false);
				m=sz[1];
				fill(sz+1,sz+n+1,0);
				dfs(1,0,i,true);
				for(int j=1;j<=n;j++)
					if(!sz[j])
					{
						dfs(j,0,i,false);
						m=sz[j];
						dfs(j,0,i,true);
						break;
					}
			}
			fout<<ans<<endl;
		}
	}
	return 0;
}
