#include<fstream>
#include<algorithm>
using namespace std;
ifstream fin("partition.in");
ofstream fout("partition.out");
const int N=5005;
const long long INF=4e18;
long long a[N],f[N][N],sum[N];
void build(int i,int id,int l,int r)
{
	if(l==r)
		tree[i][id]=f[i][l];
	else
	{
		int mid=(l+r)/2;
		build(i,id*2,l,mid);
		build(i,id*2+1,mid+1,r);
		tree[i][id]=min(tree[i][id*2],tree[i][id*2+1]);
	}
}
long long query(int i,int id,int l,int r,int ql,int qr)
{
	if(ql<=l&&qr>=r)
		return tree[i][id];
	int mid=(l+r)/2;
	if(qr<=mid)
		return query(i,id*2,l,mid,ql,qr);
	if(ql>mid)
		return query(i,id*2+1,mid+1,r,ql,qr);
	return min(query(i,id*2,l,mid,ql,qr),query(i,id*2+1,mid+1,r,ql,qr));
}
int main()
{
	int n,type;
	fin>>n>>type;
	for(int i=1;i<=n;i++)
	{
		fin>>a[i];
		sum[i]=sum[i-1]+a[i];
	}
	for(int i=1;i<=n;i++)
	{
		int ql=1,qr=0,qid=i-1;
		for(int j=1;j<i;j++)
		{
			for(;qid&&sum[i-j]-sum[qid-1]<=sum[i]-sum[i-j];qid--)
			{
				for(;ql<=qr&&f[i-j][i-j-qid+1]<=f[i-j-1];qr--);
				val[++qr]=f[i-j][i-j-qid+1];
				id[qr]=qid;
			}
			if(id[ql]>i-j)
				ql++;
			if(ql<=qr)
				f[i][j]=val[ql]+(sum[i]-sum[i-j])*(sum[i]-sum[i-j]);
			else
				f[i][j]=INF;
		}
		f[i][i]=sum[i]*sum[i];
	}
//	fout<<*min_element(f[n]+1,f[n]+n+1)<<endl;
	for(int i=1;i<=n;i++)
	{
		for(int j=1;j<=i;j++)
			fout<<f[i][j]<<' ';
		fout<<endl;
	}
	return 0;
}
