#include<iostream>
#include<cstdio>
#include<cstring>
#define maxN 301000
#define maxE 602000
using namespace std;
int T,n,x,y,tot,Head,Tail,Last[maxN],degre[maxN],OtN[maxN],NtO[maxN],father[maxN],cnt[maxN];
bool Child[maxN];
long long ans;
struct recEdge{int pre,to;} E[maxE];
void addEdge(int U,int V){
	E[++tot].pre=Last[U];Last[U]=tot;
	E[tot].to=V;
}
void getChain(){
	int p=Head,q=0;
	memset(OtN,0,sizeof(OtN));
	while (p!=Tail){
		OtN[p]=++q;
		for (int ed=Last[p];ed;ed=E[ed].pre){
			if (!OtN[E[ed].to]){
				p=E[ed].to;
				break;
			}
		}
	}
	OtN[Tail]=++q;
	for (int i=1;i<=n;i++){NtO[OtN[i]]=i;}
	if (n&1){
		ans=2ll*(long long)(NtO[1]+NtO[n]+NtO[(n>>1)+1]);
		for (int i=2;i*2<n;i++){ans+=3ll*(long long)(NtO[i]+NtO[n-i+1]);}
	} else {
		ans=2ll*(long long)(NtO[1]+NtO[n>>1]+NtO[(n>>1)+1]+NtO[n]);
		for (int i=2;i*2<n;i++){ans+=3ll*(long long)(NtO[i]+NtO[n-i+1]);}
	}
	printf("%lld\n",ans);
}
void read(int &x){
	char ch=getchar();
	for(;ch<'0' || ch>'9';ch=getchar());
	for(x=0;ch>='0' && ch<='9';ch=getchar())x=x*10+ch-48;
}
void dfs(int x,int fa){
	father[x]=fa;
	cnt[x]=1;
	for (int ed=Last[x];ed;ed=E[ed].pre){
		if (E[ed].to==fa) continue;
		dfs(E[ed].to,x);
		cnt[x]+=cnt[E[ed].to];
	}
}
void getChild(int x,int fa){
	Child[x]=1;
	for (int ed=Last[x];ed;ed=E[ed].pre){
		if (E[ed].to==fa) continue;
		getChild(E[ed].to,x);
	}
}
void getAns(int fa,int x){
	memset(Child,0,sizeof(Child));
	getChild(x,fa);
	for (int now=fa;now;now=father[now]){
		cnt[now]-=cnt[x];
	}
	bool flag;
	for (int i=1;i<=n;i++){
		if (Child[i]){
			flag=(cnt[x]-cnt[i]<=cnt[x]/2);
			for (int ed=Last[i];ed && flag;ed=E[ed].pre){
				if (E[ed].to==father[i]) continue;
				flag=flag &&(cnt[E[ed].to]<=cnt[x]/2);
			}
		} else {
			flag=(cnt[1]-cnt[i]<=cnt[1]/2);
			for (int ed=Last[i];ed && flag;ed=E[ed].pre){
				if (E[ed].to==father[i]) continue;
				if (i==fa && E[ed].to==x) continue;
				flag=flag &&(cnt[E[ed].to]<=cnt[1]/2);
			}
		}
		if (flag){
			ans+=(long long)i;
		}
	}
	for (int now=fa;now;now=father[now]){
		cnt[now]+=cnt[x];
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	read(T);
	while (T--){
		read(n);
		memset(Last,0,sizeof(Last));
		memset(degre,0,sizeof(degre));
		tot=0;ans=0ll;
		for (int i=1;i<n;i++){
			read(x);read(y);
			addEdge(x,y);
			addEdge(y,x);
			degre[x]++;
			degre[y]++;
		}
		Head=0;Tail=0;
		for (int i=1;i<=n;i++){
			if (degre[i]==2)continue;
			if (degre[i]>2){Tail=0;break;}
			if (Head==0) Head=i; else{
				if (Tail==0) Tail=i;
					else{Tail=0;break;}
			}
		}
		if (Tail!=0){
			getChain();
			continue;
		}
		tot=0;
		dfs(1,0);
		for (int i=2;i<=n;i++){
			getAns(father[i],i);
		}
		printf("%lld\n",ans);
	}
	return 0;
}
