#include <cstdio>
#include <cctype>
#include <cstring>
#include <iostream>
#include <algorithm>

#define reg register
#define ll long long
#define rep(i, a, b) for (reg int i = (a), i##end = (b); i <= i##end; ++i)
#define dep(i, a, b) for (reg int i = (a), i##end = (b); i >= i##end; --i)
using namespace std;

template <typename _typer> inline _typer read() {
    _typer init = 0; int ch = getchar(), k = 0;
    for ( ; !isdigit(ch); ch = getchar()) k = (ch == '-');
    for ( ; isdigit(ch); ch = getchar())
        init = (init << 3) + (init << 1) + (ch ^ 48);
    return k ? -init : init;
}
const ll N = 105, INF = 1e9;
const ll M = 2005, Mod = 998244353;


char aaa;


int n, m, A[N][M];

void Upd(int &x, int y) { ((x += y) >= Mod && (x -= Mod)); }

namespace p32 {
const ll N = 10, M = 10;
int f[M][N + 5][1 << N];
void Work() {
    f[0][0][0] = 1;
    int uplim = (1 << n) - 1;
    rep (i, 0, m - 1) rep (j, 0, n) rep (s, 0, uplim) if (f[i][j][s]) {
        int tmp = f[i][j][s];
//         cerr << i << " " << j << " " << s << " " << tmp << endl;
        int tot = uplim ^ s, x = tot;
        for ( ; ; x = (x - 1) & tot) {
            int res = 1, cnt = 0;
            rep (d, 1, n) if (x & (1 << d >> 1))
                res = 1ll * res * A[d][i + 1] % Mod, ++cnt;
//             cerr << x << " " << res << " " << cnt << endl;
            Upd(f[i + 1][max((int) j, cnt)][s | x], 1ll * tmp * res % Mod);
            if (!x) break;
        }
    }
    int Ans = 0;
    rep (j, 0, n) rep (s, 1, uplim) if (f[m][j][s]) {
        int cnt = 0;
        rep (i, 1, n) if (s & (1 << i >> 1)) ++cnt;
//         cerr << m << " " << j << " " << s << " " << f[m][j][s] << endl;
        if (j <= cnt / 2) Upd(Ans, f[m][j][s]);
    }
    printf("%d\n", Ans);
}
}

namespace p84 {
const ll N = 45, M = 505;
int sum[N];
int t[N][N];
int f[N][N][N];
int res[N];
void T() {
    t[0][0] = 1;
    rep (i, 1, n) rep (j, 0, i)
        Upd(t[i][j], (t[i - 1][j] +
                      1ll * t[i - 1][j - 1] * sum[i] % Mod) % Mod);
}
void S(int j) {
    memset(f, 0, sizeof f);
    f[0][0][0] = 1;
    rep (i, 0, n - 1) rep (x, 0, i) rep (d, 0, i) if (f[i][x][d]) {
         int tmp = f[i][x][d];
         Upd(f[i + 1][x][d], tmp);
         Upd(f[i + 1][x + 1][d + 1], 1ll * tmp * A[i + 1][j] % Mod);
         Upd(f[i + 1][x][d + 1],
             1ll * tmp * ((sum[i + 1] + Mod - A[i + 1][j]) % Mod) % Mod);
    }
}
void Work() {
    rep (i, 1, n) rep (j, 1, m) Upd(sum[i], A[i][j]);
    T();
    rep (i, 1, m) {
        S(i);
        rep (k, 2, n) {
            rep (x, k / 2 + 1, k)
                Upd(res[k], f[n][x][k]);
        }
    }
    int Ans = 0;
    rep (i, 2, n) {
//         cerr << i << " " << t[n][i] << " " << res[i] << endl;
        Upd(Ans, (t[n][i] + Mod - res[i]) % Mod);
    }
    printf("%d\n", Ans);
}
}

namespace p100 {
const ll N = 45, M = 505;
int sum[N];
int t[N][N];
int f[N][N << 1];
int res[N];
void T() {
    t[0][0] = 1;
    rep (i, 1, n) rep (j, 0, i)
        Upd(t[i][j], (t[i - 1][j] +
                      1ll * t[i - 1][j - 1] * sum[i] % Mod) % Mod);
}
void S(int j) {
    memset(f, 0, sizeof f);
    f[0][n] = 1;
    rep (i, 0, n - 1) rep (x, 1, n + n - 1) if (f[i][x]) {
         int tmp = f[i][x];
         Upd(f[i + 1][x], tmp);
         Upd(f[i + 1][x + 1], 1ll * tmp * A[i + 1][j] % Mod);
         Upd(f[i + 1][x - 1],
             1ll * tmp * ((sum[i + 1] + Mod - A[i + 1][j]) % Mod) % Mod);
    }
}
void Work() {
    rep (i, 1, n) rep (j, 1, m) Upd(sum[i], A[i][j]);
    T();
    int Ans = 0;
    rep (i, 1, n) Upd(Ans, t[n][i]);
    rep (i, 1, m) {
        S(i);
        rep (j, n + 1, n + n) Upd(Ans, (Mod - f[n][j]) % Mod);
    }
    printf("%d\n", Ans);
}
}

char bbb;


int _main() {
//     cerr << (&bbb - &aaa) / 1024.0 / 1024 << endl;

    n = read<int>(), m = read<int>();
    rep (i, 1, n) rep (j, 1, m) A[i][j] = read<int>();

//     p84::Work();
//     p100::Work();

    if (n <= 10 && m <= 7) p32::Work();
    else if (n <= 40 && m <= 500) p84::Work();
    else p100::Work();
    return 0;
}

int main() {
#define offline
#ifdef offline
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    _main();
    fclose(stdin); fclose(stdout);
#else
    _main();
#endif
    return 0;
}

