#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int N=3E5+100;
int T,n;
int hd[N],nxt[N<<1],to[N<<1],cnt;
int siz[N],d[N],q[N];
long long ans;
inline void init(int x,int y){
	cnt++;
	nxt[cnt]=hd[x];
	hd[x]=cnt;
	to[cnt]=y;
}
inline void find(int x,int pre){
	siz[x]=1;
	for(int i=hd[x];i;i=nxt[i]){
		int u=to[i];
		if(u!=pre){
			find(u,x);
			siz[x]+=siz[u];
		}
	}
}
inline void ck(int x,int pre,int S){
	int fl=1;
	for(int i=hd[x];i;i=nxt[i]){
		int u=to[i];
		if(u!=pre){
			if(siz[u]>S/2) fl=0;
			ck(u,x,S);
		}
	}
	if(fl&&S-siz[x]<=S/2) ans+=x;
}
inline void ck(int x,int y){
	find(x,y);
	find(y,x);
	ck(x,y,siz[x]);
	ck(y,x,siz[y]);
}
inline void dfs(int x,int pre){
	for(int i=hd[x];i;i=nxt[i]){
		int u=to[i];
		if(u!=pre){
			ck(u,x);
			dfs(u,x);
		}
	}
	
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		scanf("%d",&n);
		memset(hd,0,sizeof(hd));cnt=0;
		memset(d,0,sizeof(d));
		for(int i=1;i<n;i++){
			int x,y;
			scanf("%d%d",&x,&y);
			init(x,y);init(y,x);
			d[x]++,d[y]++;
		}
		int fl=1;
		for(int i=1;i<=n;i++) if(d[i]>2) fl=0;
		if(fl){
			ans=0;
			for(int i=1;i<=n;i++){
				if(d[i]==1){
					q[1]=i;
					break;
				}
			}
			for(int i=1;i<n;i++){
				for(int j=hd[q[i]];j;j=nxt[j]){
					int u=to[j];
					if(u!=q[i-1]) q[i+1]=u;
				}
			}
			for(int i=1;i<=n;i++) ans+=3ll*q[i];
			ans-=q[1]+q[n];if(n&1) ans-=q[(n+1)/2];
			printf("%lld\n",ans);
			continue;
		}
		if(n<2000){
			ans=0;
			dfs(1,1);
			printf("%lld\n",ans);
			continue;
		}
		int rt;
		for(int i=1;i<=n;i++){
			if(d[i]==2){
				rt=i;
				break;
			}
		}
		ans=1ll*n*(n+1)/2+1ll*rt*((n+1)/2-1);
		for(int i=hd[rt];i;i=nxt[i]){
			int u=to[i];
			ans+=1ll*u*((n+1)/2-1);
		}
		printf("%lld\n",ans);
	}
	return 0;
}
