#include <iostream>
#include <stdio.h>
#include <string.h>
using namespace std;
struct edge {
	int to,nxt;
} e[500005];
struct node {
	int x,y;
} s[500005];
int n,m,head[500005],t[500005],sz1[2],cnt=0,sz[500005],father[500005];
int read() {
	register int x=0,w=1;
	char ch=getchar();
	while(!isdigit(ch)) ch=getchar();
	while(isdigit(ch)) x=x*10+ch-'0',ch=getchar();
	return x*w;
}
void addedge(int x,int y) {
	++cnt;
	e[cnt].to=y;
	e[cnt].nxt=head[x];
	head[x]=cnt;
}
void dfs(int x,int fa,int typ) {
	sz1[typ]++;
	father[x]=fa;
	sz[x]=1;
	t[x]=typ;
	for (int i=head[x]; ~i; i=e[i].nxt) {
		int v=e[i].to;
		if(v==fa) continue;
		dfs(v,x,typ);
		sz[x]+=sz[v];
	}
}
bool check(int x) {
	int sum=0,sum1=0;
	for (int i=head[x]; ~i; i=e[i].nxt) {
		int v=e[i].to;
		int res;
		if(v!=father[x]) res=sz[v],sum+=sz[v];
		if(v!=father[x]) if(res>sz1[t[x]]/2) return false;
	}
	if((sz1[t[x]]-sum-1)>(sz1[t[x]]/2)) return false;
	return true;
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=read();
	while(T--) {
		memset(head,-1,sizeof(head));cnt=0;
		memset(sz,0,sizeof(sz));
		memset(father,0,sizeof(father));
		n=read();
		for (int i=1; i<n; ++i) {
			int x=read(),y=read();
			addedge(x,y);
			addedge(y,x);
			s[i].x=x,s[i].y=y;
		}
		long long ans=0;
		for (int i=1; i<n; ++i) {
			memset(t,0,sizeof(t));
			memset(sz1,0,sizeof(sz1));
			dfs(s[i].x,s[i].y,0);
			dfs(s[i].y,s[i].x,1);
			for (int j=1; j<=n; ++j) if(check(j)) ans+=1ll*j;
		}
		printf("%lld\n",ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
