#include<iostream>
#include<cstdio>
#include<cstring>
#define ll long long
using namespace std;

const int N  = 111, M = 2002, Mod = 998244353;

int n, m, tot;
int cnt[M], b[N], xx[M << 4], yy[M << 4];

bool v[N][M];

ll ans;
ll sum[N];
ll ch[N][M], dp[N][M];

template <typename T>
inline void read(T &x){
	x = 0;
	char c = getchar();
	T op = 1;
	for(; c < '0' || c > '9'; c = getchar())
		if(c == '-')	op = -1;
	for(; c <= '9' && c >= '0'; c = getchar())
		x = (x << 3) + (x << 1) + c - '0';
	x *= op;
}

inline void dfs(int x, int y, ll sum, int s){
	if(s != 1) sum *= ch[x][y], ans = ((ll)ans + sum + Mod) % Mod;
	int k = tot;
	for(int i = 1; i <= n; ++i){
		if(b[i])	continue;
		b[i] = 1;
		for(int j = 1; j <= m; ++j)
			if(cnt[j] + 1 <= (s + 1) >> 1 && ch[i][j] && !v[i][j]){
				++cnt[j];
				xx[++tot] = i, yy[tot] = j;
				v[i][j] = 1;
				dfs(i, j, sum, s + 1);
				--cnt[j];
		}
		b[i] = 0;
	}
	while(tot > k){
		v[xx[tot]][yy[tot]] = 0;
		--tot;
	}
}

int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	read(n), read(m);
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= m; ++j)	read(ch[i][j]);
	if(n <= 10){
		for(int i = 1; i < n; ++i){
		b[i] = 1;
		for(int j = 1; j <= m; ++j, tot = 0)
			if(ch[i][j]){
				++cnt[j];
				dfs(i, j, ch[i][j], 1);
				--cnt[j];
			}
		}
		printf("%lld\n", ans);
		return 0;
	}
	for(int i = 1; i <= m; ++i)	
		if(ch[1][i]) dp[1][i] = ch[1][i], sum[1] += dp[1][i], ++cnt[i];
	for(int i = 2; i <= n; ++i){
		for(int j = 1; j <= m; ++j){
			if(!ch[i][j])	continue;
			++cnt[j];
			if(ch[i - 1][j] && cnt[j] << 1 <= i){
				dp[i][j] = sum[i - 1] - dp[i - 1][j] + sum[i - 2] - dp[i - 2][j];
			}
			else dp[i][j] = sum[i - 1];
			dp[i][j] *= ch[i][j];
			dp[i][j] %= Mod;
			ans += dp[i][j], ans %= Mod;
			sum[i] += dp[i][j], sum[i] %= Mod;
		}
	}
	printf("%lld\n", ans);
	return 0;
}

