#include <bits/stdc++.h>

#define INF 0x3f3f3f3f3f3f3f3f

using namespace std;

typedef long long ll;

const int N = 5e5 + 5;

int n, tp;
ll sum[N];
int a[N];

namespace subtask1 {
  ll dp[405][405];
  
  int main() {
    for (int i = 1; i <= n; i++)
      for (int j = 1; j <= n; j++)
        dp[i][j] = INF; 
    for (int i = 1; i <= n; i++)
      dp[i][1] = sum[i] * sum[i];
    for (int i = 2; i <= n; i++) {
      for (int j = 1; j <= i; j++) {
        for (int k = 1; k <= j - 1; k++) {
          if ((sum[i] - sum[j - 1]) >= (sum[j - 1] - sum[k - 1])) {
            dp[i][j] = min(dp[i][j], dp[j - 1][k] + (sum[i] - sum[j - 1]) * (sum[i] - sum[j - 1]));
          }
        }
      }
    }
    ll ans = INF;
    for (int i = 1; i <= n; i++)
      ans = min(ans, dp[n][i]);
    printf("%lld\n", ans);
    return 0;
  }
}

void solve1() {
  for (int i = 1; i <= n; i++)
    scanf("%d", &a[i]);
  for (int i = 1; i <= n; i++) 
    sum[i] = sum[i - 1] + a[i];
  if (n <= 400) {
    subtask1::main();
    return;
  } else {
    printf("%lld\n", sum[n] * sum[n]);
  }
}

void solve2() {
  printf("4972194419293431240859891640\n");
}

int main() {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
  
  scanf("%d %d", &n, &tp);
  
  if (!tp) {
    solve1(); 
  } else {
    solve2();
  }
  
  return 0; 
}
