#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cctype>
#include <algorithm>
#define MAXN 3000
using namespace std;

int a[MAXN][MAXN], used[MAXN], n, m;
long long ans;

inline int read () {
	register int s = 0, w = 1;
	register char ch = getchar ();
	while (! isdigit (ch)) {if (ch == '-') w = -1; ch = getchar ();}
	while (isdigit (ch)) {s = (s << 3) + (s << 1) + (ch ^ 48); ch = getchar ();}
	return s * w;
}

void DFS (int now, long long res, int lim, int chosen) {
	if (chosen >= lim) {ans += res; return;}
	if (now > n) return;
	for (register int i = 1; i <= m; i++)
		if (used[i] < lim / 2 && a[now][i] != 0) {
			used[i]++;
			DFS (now + 1, res * (long long) a[now][i], lim, chosen + 1);
			used[i]--; 
		}
	DFS (now + 1, res, lim, chosen);
}

int main () {
    freopen ("meal.in", "r", stdin); freopen ("meal.out", "w", stdout);
	n = read (), m = read ();
	for (register int i = 1; i <= n; i++)
		for (register int j = 1; j <= m; j++)
			a[i][j] = read ();
	for (register int i = 2; i <= n; i++)
		memset (used, 0, sizeof used), DFS (1, (long long) 1, i, 0);
	printf ("%lld\n", ans);
	return 0;
}
/*
5 5
1 0 0 1 1
0 1 0 1 0
1 1 1 1 0
1 0 1 0 1
0 1 1 0 1
*/
