#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cctype>
#include <algorithm>
#define MAXN 10000
using namespace std;

int a[MAXN], sum[MAXN], d[MAXN], ans, n;

inline int read () {
	register int s = 0, w = 1;
	register char ch = getchar ();
	while (! isdigit (ch)) {if (ch == '-') w = -1; ch = getchar ();}
	while (isdigit (ch)) {s = (s << 3) + (s << 1) + (ch ^ 48); ch = getchar ();}
	return s * w;
}

inline int cmin (int a, int b) {return (a > b) ? b : a;}
inline int cmax (int a, int b) {return (a > b) ? a : b;}
inline int sqr (int a) {return a * a;}

inline void check () {
    int lst = 0, res = 0, lstsum = 0;
    for (register int i = 1; i < n; i++)
        if (d[i]) {
            if (sum[i] - sum[lst] < lstsum) return;
            res += sqr (sum[i] - sum[lst]), lstsum = sum[i] - sum[lst], lst = i;
        }
    if (sum[n] - sum[lst] < lstsum) return;
    res += sqr (sum[n] - sum[lst]);
    ans = cmin (ans, res);
}

void DFS (int now) {
	if (now == n) {check (); return;}
	d[now] = 1, DFS (now + 1);
	d[now] = 0, DFS (now + 1);
}

int main () {
    freopen ("partition.in", "r", stdin); freopen ("partition.out", "w", stdout);
	n = read (); int opt = read ();
	for (register int i = 1; i <= n; i++)
		a[i] = read (), sum[i] = sum[i - 1] + a[i];
	ans = sqr (sum[n]);
	DFS (1);
	printf ("%d\n", ans);
	return 0;
}
/*
5 0
5 1 7 9 9
*/
