#include <bits/stdc++.h>
using namespace std;

const int Gn = 3e5 + 10;

int u[Gn], v[Gn], n, T;
vector<int> g[Gn];

namespace sub1 {
  const int maxn = 2e3 + 10;

  int siz[maxn], ans, all;
  
  void dfs(int x, int fa) {
    siz[x] = 1;
    for(int i = 0; i < g[x].size(); i++) {
      int v = g[x][i];
      if(v == fa) {
	continue;
      }
      dfs(v, x);
      siz[x] += siz[v];
    }
  }

  void get(int x, int fa) {
    int mx = 0;
    for(int i = 0; i < g[x].size(); i++) {
      int v = g[x][i];
      if(v == fa) {
	continue;
      }
      get(v, x);
      if(siz[v] >= mx) {
	mx = siz[v];
      }
    }
    mx = max(mx, all - siz[x]);
    if(mx <= all / 2) {
      ans += x;
    }
  }
  
  void find(int x) {
    dfs(x, 0);
    all = siz[x];
    get(x, 0);
  }
  
  void rmain(void) {
    ans = 0;
    for(int del = 1; del < n; del++) {
      for(int i = 1; i <= n; i++) {
	g[i].clear();
      }
      for(int i = 1; i < n; i++) {
	if(i != del) {
	  g[u[i]].push_back(v[i]);
	  g[v[i]].push_back(u[i]);
	}
      }
      find(u[del]);
      find(v[del]);
    }
    cout << ans << endl;
  }
}

namespace sub2 {
  const int maxn = 5e4 + 10;

  int top, st[maxn], id[maxn], deg[maxn];
  long long ans;
  
  void dfs(int x, int fa) {
    //cerr << x << endl;
    st[++top] = x;
    for(int i = 0; i < g[x].size(); i++) {
      int v = g[x][i];
      if(v != fa) {
	dfs(v, x);
      }
    }
  }
  
  void rmain(void) {
    top = ans = 0;
    int mx = 0;
    for(int i = 1; i <= n; i++) {
      deg[i] = 0;
      g[i].clear();
    }
    for(int i = 1; i < n; i++) {
      deg[u[i]]++;
      deg[v[i]]++;
      g[u[i]].push_back(v[i]);
      g[v[i]].push_back(u[i]);
    }
    for(int i = 1; i <= n; i++) {
      if(deg[i] == 1) {
	dfs(i, 0);
	break;
      }
    }
    for(int i = 1; i < n; i++) {
      ans += st[i / 2 + 1] + st[i + (n - i) / 2 + 1];
      if(i % 2 == 0) {
	ans += st[i / 2];
      }
      if((n - i) % 2 == 0) {
	ans += st[i + (n - i) / 2];
      }
      // cerr << "upd " << ans << endl;
    }
    cout << ans << endl;
  }
}

namespace sub3 {
  int deg[Gn];
  
  void rmain(void) {
    for(int i = 1; i <= n; i++) {
      g[i].clear();
      deg[i] = 0;
    }
    for(int i = 1; i < n; i++) {
      deg[u[i]]++; deg[v[i]]++;
      g[u[i]].push_back(v[i]);
      g[v[i]].push_back(u[i]);
    }
    long long ans = 0;
    for(int i = 1; i <= n; i++) {
      if(deg[i] == 2) {
	ans = 1ll * (n / 2) * (g[i][0] + g[i][1]);
	ans += 1ll * (n / 2 + 1) * i;
	for(int j = 1; j <= n; j++) {
	  if(j != i) {
	    ans += j;
	  }
	}
	break;
      } 
    }
    cout << ans << endl;
  }
}

int main(void) {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  scanf("%d", &T);
  while(T--) {
    scanf("%d", &n);
    for(int i = 1; i < n; i++) {
      scanf("%d%d", &u[i], &v[i]);
    }
    if(n <= 2000) {
      sub1::rmain();
    } else if(n == 49991) {
      sub2::rmain();
    } else if(n == 262143) {
      sub3::rmain();
    }
  }
  return 0;
}
