#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <cctype>

inline int get_uint () {
  register char c = getchar();
  register int x = 0;
  while (!isdigit(c)) c = getchar();
  for (; isdigit(c); c = getchar()) x = (((x << 2) + x) << 1) + (c ^ 48);
  return x;
}

const int MAXN = 5010;

int n, type, a[MAXN];
long long s[MAXN], f[MAXN][MAXN];

inline long long sqr (long long x) {
  return x * x;
}

int main () {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
  n = get_uint();
  type = get_uint();
  for (int i = 1; i <= n; i++) a[i] = get_uint();
  if (type == 1) {
    // Fuck you CCF
    return 19260817;
  }
  for (int i = 1; i <= n; i++) s[i] = s[i - 1] + a[i];
  memset(f, 0x3F, sizeof(f));
  f[1][1] = sqr(a[1]);
  for (int i = 2; i <= n; i++) {
    f[1][i] = sqr(s[i]);
    int p = i - 1;
    for (int j = i; j <= n; j++) {
      while(p > 1 && s[i - 1] - s[p - 2] <= s[j] - s[i - 1]) p--;
      if (s[i - 1] - s[p - 1] <= s[j] - s[i - 1]) {
        f[i][j] = f[p][i - 1] + sqr(s[j] - s[i - 1]);
      }
      // printf("%lld f[%d][%d] <- f[%d][%d]\n", f[i][j], i, j, p, i - 1);
    }
    for (int j = i; j > 1; j--) f[j - 1][i] = std::min(f[j - 1][i], f[j][i]);
  }
  long long ans = f[1][n];
  for (int i = 2; i <= n; i++) ans = std::min(ans, f[i][n]);
  printf("%lld\n", ans);
  // puts("");
  // for (int i = 1; i <= n; i++) {
  //   for (int j = i; j <= n; j++) printf("f[%d][%d] = %lld\n", i, j, f[i][j]);
  // }
  return 0;
}