#include <bits/stdc++.h>

#define ll long long
#define Max 300005

using namespace std;

inline char gc(){
	static char buf[100000],*p1=buf,*p2=buf;
	return p1==p2&&(p2=(p1=buf)+fread(buf,1,100000,stdin),p1==p2)?EOF:*p1++;
}
#define gc getchar
inline ll read(){
	ll x=0;char ch=gc();bool positive=1;
	for(;!isdigit(ch);ch=gc())if(ch=='-')positive=0;
	for(;isdigit(ch);ch=gc())x=x*10+ch-'0';
	return positive?x:-x;
}

inline void write(ll x){
	if(x<0)x=-x,putchar('-');
	if(x>9)write(x/10);putchar(x%10+'0');
}

inline void writeln(ll x){
	write(x);puts("");
}

struct Edge{
	ll v,to;
}e[Max*2];

ll t,n,l,r,rt,cnt,ans,now,num,size,id[Max],dep[Max],deg[Max],sum[Max],son[Max],tot[Max],head[Max];

inline void add(ll u,ll v){
	e[++size].v=v;e[size].to=head[u];head[u]=size;
}

inline void dfs(ll u,ll fa){
	dep[u]=dep[fa]+1;
	sum[u]=1;
	for(ll i=head[u];i;i=e[i].to){
		ll v=e[i].v;
		if(v==fa)continue;
		dfs(v,u);
		sum[u]+=sum[v];
	}
	return;
}

inline void getrt(ll u,ll fa){
	son[u]=1;
	tot[u]=0;
	for(ll i=head[u];i;i=e[i].to){
		ll v=e[i].v;
		if(v==fa)continue;
		getrt(v,u);
		son[u]+=son[v];
		tot[u]=max(tot[u],son[v]);
	}
	tot[u]=max(tot[u],now-son[u]);
	if(tot[u]==tot[rt])num+=u;
	if(tot[u]<tot[rt]){
		rt=u;
		num=u;
	}
	return;
}

inline void dfs1(ll u,ll fa){
	id[++cnt]=u;
	for(ll i=head[u];i;i=e[i].to){
		ll v=e[i].v;
		if(v==fa)continue;
		dfs1(v,u);
	}
	return;
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	t=read();
	tot[0]=1e9;
	while(t--){
		n=read();
		size=1;
		for(ll i=1;i<=n;i++)deg[i]=head[i]=0;
		for(ll i=1;i<n;i++){
			l=read();r=read();
			add(l,r);
			add(r,l);
			deg[l]++;deg[r]++;
		}
		ll maxn=0;
		for(ll i=1;i<=n;i++)maxn=max(maxn,deg[i]);
		if(maxn==2){
//			cout<<"23333"<<endl;
//			cout<<n<<endl;
			cnt=0;
			for(ll i=1;i<=n;i++){
				if(deg[i]==1){
					dfs1(i,i);
					break;
				}
			}
			ans=0;
			for(ll i=1;i<n;i++){
				if(i&1){
					ans+=id[(i+1)/2];
					ans+=id[n-(i+1)/2+1];
				}else{
					ans+=id[i/2]+id[i/2+1];
					ans+=id[n-(i/2)+1]+id[n-(i/2+1)+1];
				}
			}
			writeln(ans);
			continue;
		}
		now=n;
		getrt(1,0);
		dfs(rt,rt);
		ll sxd=0,zyy=0;
		for(int i=1;i<=n;i++){
			zyy=max(zyy,dep[i]);
		}
		for(int i=1;i<=n;i++){
			if(dep[i]==zyy)sxd++;
		}
		if(sxd==(n+1)/2){
//			cout<<"233333"<<endl;
			for(int i=1;i<=n;i++){
				if(deg[i]==2){
					rt=i;
					dfs(i,0);
					ans=i*(n/2)+i;
					break;
				}
			}
			for(int i=1;i<=n;i++){
				if(dep[i]!=1)ans+=i;
				if(dep[i]==2){
					ans+=i*(n-1)/2;
				}
			}
			writeln(ans);
			continue;
		}
//		cout<<endl;
		dfs(1,0);
		ans=0;
		for(ll u=1;u<=n;u++){
			for(ll j=head[u];j;j=e[j].to){
				ll v=e[j].v;
//				cout<<u<<" "<<v<<":";
				if(dep[u]>dep[v]){
//					cout<<"!";
					now=sum[u];
					rt=num=0;
					getrt(u,v);
					ans+=num;
//					cout<<now<<" "<<rt<<" ";
					now=sum[1]-sum[u];
					rt=num=0;
					getrt(v,u);
					ans+=num;
//					cout<<now<<" "<<rt<<endl;
				}else{
//					cout<<"@";
					now=sum[v];
					rt=num=0;
					getrt(v,u);
					ans+=num;
//					cout<<now<<" "<<rt<<" ";
					now=sum[1]-sum[v];
					rt=num=0;
					getrt(u,v);
					ans+=num;
//					cout<<now<<" "<<rt<<endl;
				}
			}
		}
		writeln(ans/2);
	}
	return 0;
}
