// 40pts O(n^2)
#include <bits/stdc++.h>
using namespace std;
#define file_io_locat(name){freopen(name".in","r",stdin);freopen(name".out","w", stdout);}

template <typename nt> nt read() {
    bool flg = 0; nt nit = 0; char ch = getchar();
    while (!isdigit(ch) && ch != '-') ch = getchar(); if (ch == '-') {flg = 1; ch = getchar();}
    while(isdigit(ch)) {nit = (((nit<< 2)+nit)<<1)+(ch&15);ch= getchar();} return flg?(~nit+1):nit;
}

int n;
int to[600003], nxt[600003], head[300003], edges_cnt = 0;
int child[600003];
long long ans;
int cuted;

void getSize(int u, int fa)
{
    child[u] = 1;
    for (int i = head[u]; ~i; i = nxt[i]) {
        if ((i >> 1) != cuted && to[i] != fa) {
            getSize(to[i], u);
            child[u] += child[to[i]];
        }
    }
    // printf("child[%d] = %d.\n", u, child[u]);
}

long long dfs(int u, int fa, int limit)
{
    bool isWeightHeart = 1;
    long long ans = 0;
    for (int i = head[u]; ~i; i = nxt[i]) {
        if ((i >> 1) != cuted && to[i] != fa) {
            ans += dfs(to[i], u, limit);
            if (child[to[i]] > limit / 2) isWeightHeart = 0;
        }
    }
    if (limit - child[u] > limit / 2) isWeightHeart = 0;
    // if (isWeightHeart) printf("%d is WeightHeart\n", u);
    return isWeightHeart ? ans + u : ans;
}

int main()
{
    file_io_locat("centroid");
    int T = read<int>();
    while (T--) {
        edges_cnt = 0;
        memset(head, -1, sizeof(head));
        n = read<int>();
        for (int u, v, i = 1; i < n; i++) {
            u = read<int>();
            v = read<int>();
            to[edges_cnt] = v;
            nxt[edges_cnt] = head[u];
            head[u] = edges_cnt;
            edges_cnt++;
            to[edges_cnt] = u;
            nxt[edges_cnt] = head[v];
            head[v] = edges_cnt;
            edges_cnt++;
        }
        ans = 0;
        for (cuted = 0; cuted < n - 1; cuted++) {
            // printf("cut edge<%d, %d>\n", to[cuted << 1], to[cuted << 1 | 1]);
            getSize(to[cuted << 1], 0);
            getSize(to[cuted << 1 | 1], 0);
            ans += dfs(to[cuted << 1], 0, child[to[cuted << 1]]) + dfs(to[cuted << 1 | 1], 0, child[to[cuted << 1 | 1]]);
        }
        printf("%d\n", ans);
    }
    return 0;
}