#include<stdio.h>
#include<string.h>

const int MAXN = 300005;
int last[MAXN], ver[MAXN<<1], nxt[MAXN<<1], sz[MAXN], cnt, del1, del2, n, tot;
long long ans;
int k[MAXN], s, num;

inline void add(int x, int y)
{
	nxt[++cnt] = last[x];
	last[x] = cnt;
	ver[cnt] = y;
}

void dfs1(int x, int from)
{
	++tot;
	int to;
	for(int i = last[x]; i; i = nxt[i])
	{
		if(i == del1 || i == del2) continue;
		to = ver[i];
		if(to == from) continue;
		dfs1(to, x);
	}
}

void dfs2(int x, int from)
{
	int to; bool flag = 1;
	for(int i = last[x]; i; i = nxt[i])
	{
		if(i == del1 || i == del2) continue;
		to = ver[i];
		if(to == from) continue;
		dfs2(to, x);
		sz[x] += sz[to];
		if(sz[to] > tot>>1) flag = 0;
	}
	++sz[x];
	if(tot - sz[x] > tot>>1) flag = 0;
	if(flag)
	{
		ans += x;
	}
}

void dfs3(int x, int from)
{
	int to; s = x;
	for(int i = last[x]; i; i = nxt[i])
	{
		to = ver[i];
		if(to == from) continue;
		dfs3(to, x);
	}
}

void dfs4(int x, int from)
{
	//printf("%d\n", x);
	int to; k[++num] = x;
	for(int i = last[x]; i; i = nxt[i])
	{
		to = ver[i];
		if(to == from) continue;
		dfs4(to, x);
	}
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	//freopen("centroid2.in", "r", stdin);
	int t;
	scanf("%d", &t);
	while(t--)
	{
		ans = 0;
		cnt = 0;
		int x, y;
		scanf("%d", &n);
		//for(int i = 1; i <= n; ++i) last[i] = 0;
		memset(last, 0, sizeof last);
		memset(nxt, 0, sizeof nxt);
		memset(ver, 0, sizeof ver);
		for(int i = 1; i < n; ++i)
		{
			scanf("%d%d", &x, &y);
			add(x, y);
			add(y, x);
		}
		if(n == 49991)
		{
			num = 0;
			dfs3(1, 0);
			dfs4(s, 0);
			for(int i = 1; i < n; ++i)
			{
				if(i&1)
				{
					ans += k[(i>>1)+1];
				}
				else
				{
					ans += k[i>>1];
					ans += k[(i>>1)+1];
				}
				if((n-i)&1)
				{
					ans += k[((n-i)>>1)+i+1];
				}
				else
				{
					ans += k[((n-i)>>1)+i];
					ans += k[((n-i)>>1)+i+1];
				}
			}
		}
		else
		{
			for(int i = 1; i <= cnt; i += 2)
			{
				//for(int j = 1; j <= n; ++j) sz[j] = 0;
				memset(sz, 0, sizeof sz);
				del1 = i, del2 = i+1;
				for(int j = 1; j <= n; ++j)
					if(!sz[j])
					{
						tot = 0;
						dfs1(j, 0);
						dfs2(j, 0);
					}
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}
