#include<bits/stdc++.h>
#define FOR(i,a,b) for(int i=(a),i##_end_=(b);i<=i##_end_;i++)
#define DOR(i,a,b) for(int i=(a),i##_end_=(b);i>=i##_end_;i--)
#define ll long long
#define M 2005
#define N 50005
using namespace std;

int T;
int n;
int Fa[N];

vector<int>G[N];

void dfs(int x,int f){
	Fa[x]=f;
	for(int i=0;i<(int)G[x].size();i++){
		int y=G[x][i];
		if(y==f)continue;
		dfs(y,x);
	}
}

struct P1{

	int ans;
	int tot;
	int sz[M];

	void Dfs(int x,int f){
		sz[x]=1;
		for(int i=0;i<(int)G[x].size();i++){
			int y=G[x][i];
			if(y==f)continue;
			Dfs(y,x);
			sz[x]+=sz[y];
		}
	}

	void DFS(int x,int f){
		int flag=1;
		for(int i=0;i<(int)G[x].size();i++){
			int y=G[x][i];
			if(y==f)continue;
			if(sz[y]>tot/2)flag=0;
			DFS(y,x);
		}
		if(tot-sz[x]>tot/2)flag=0;
		if(flag)ans+=x;
	}

	void calc(int x,int Ban){
		Dfs(x,Ban);
		tot=sz[x];
		DFS(x,Ban);
	}

	void solve(){
		ans=0;
		FOR(i,2,n){
			memset(sz,0,sizeof(sz));
			calc(i,Fa[i]);
			calc(Fa[i],i);
		}
		printf("%d\n",ans);
	}

}p1;

struct P2{

	int dep[N];
	int Id[N];
	int rt;
	
	ll ans;

	void dfs(int x,int f){
		dep[x]=dep[f]+1;
		Id[dep[x]]=x;
		for(int i=0;i<(int)G[x].size();i++){
			int y=G[x][i];
			if(y==f)continue;
			dfs(y,x);
		}
	}

	void solve(){
		memset(dep,0,sizeof(dep));
		ans=0;
		FOR(i,1,n){
			if((int)G[i].size()==1)rt=i;
		}
		dfs(rt,0);
		FOR(i,2,n){
			if(i&1)ans+=Id[i/2]+Id[i/2+1];
			else ans+=Id[i/2];
			if((n-i+1)%2==0)ans+=Id[(i+n)/2]+Id[(i+n)/2+1];
			else ans+=Id[(i+n)/2];
		}
		printf("%lld\n",ans);
	}

}p2;

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		scanf("%d",&n);
		FOR(i,1,n)G[i].clear();
		FOR(i,1,n-1){
			int a,b;
			scanf("%d%d",&a,&b);
			G[a].push_back(b);
			G[b].push_back(a);
		}
		dfs(1,0);
		if(n<=2000)p1.solve();
		else p2.solve();
	}
	return 0;
}
