#include <bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;

using std::cin;
using std::cout;
using std::endl;

const int N = 3e5 + 5;

struct Edge {
	int to, nxt;
}e[N << 1];

int head[N], vis[N], num[N], ind[N];
int cnt;

void AddEdge(int u, int v) {
	e[cnt].to = v;
	e[cnt].nxt = head[u];
	head[u] = cnt++;
}

void dfs(int p, int dep) {
	num[dep] = p;
	for(int i = head[p]; i != -1; i = e[i].nxt) {
		if(vis[e[i].to]) continue;
		vis[e[i].to] = 1;
		dfs(e[i].to, dep + 1);
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int t;
	scanf("%d", &t);
	while(t--) {
		int n;
		scanf("%d", &n);
		cnt = 0;
		memset(head, -1, sizeof(head));
		memset(ind, 0, sizeof(ind));
		for(int i = 1; i < n; i++) {
			int u, v;
			scanf("%d%d", &u, &v);
			ind[u]++; ind[v]++;
			AddEdge(u, v);
			AddEdge(v, u);
		}
		memset(vis, 0, sizeof(vis));
		//if(n == 49991) {
			int top;
			for(int i = 1; i <= n; i++) if(ind[i] == 1) top = i;
			dfs(top, 1);
			ll ans = 0;
			for(int i = 2; i <= n; i++) {
				int l = i - 1;
				int r = i;
				//cout << ans << '\n';
				if(l % 2 == 0) ans += num[(l + 1) >> 1] + num[((l + 1) >> 1) + 1];
				else ans += num[(l + 1) >> 1];
				if((n - r + 1) % 2 == 0) ans += num[(n + r) >> 1] + num[((n + r) >> 1) + 1];
				else ans += num[((n + r) >> 1)];
			}
			printf("%lld\n", ans);
		//}
	}
	return 0;
}
