#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
const int N=300001;
int T,n;
int x[N],y[N];
struct Edge
{
	int to,next;
}edge[N<<1];
int head[N],cnt;
void add_edge(int u,int v)
{
	cnt++;
	edge[cnt].to=v;
	edge[cnt].next=head[u];
	head[u]=cnt;
	return;
}
int in[N];
int tmp[N],tot;
namespace Subtask1
{
int size[N];
int fa[N];
bool res[N];
int Max;
void init(int u,int father)
{
	fa[u]=father;
	size[u]=1;
	for(int i=head[u];i;i=edge[i].next)
	{
		int v=edge[i].to;
		if(v==father) continue;
		init(v,u);
		size[u]+=size[v];
	}
	return;
}
bool book[N];
void dfs(int u,int father)
{
	book[u]=true;
	for(int i=head[u];i;i=edge[i].next)
	{
		int v=edge[i].to;
		if(v==father) continue;
		dfs(v,u);
		if(size[v]>Max/2) book[u]=false;
	}
	if(Max-size[u]>Max/2) book[u]=false;
	return;
}
int main()
{
	long long ans=0;
	for(int i=1;i<n;i++)
	{
		memset(book,false,sizeof(book));
		memset(head,0,sizeof(head));
		cnt=0;
		for(int j=1;j<n;j++)
			if(i!=j) add_edge(x[j],y[j]),add_edge(y[j],x[j]);
		init(x[i],0);
		init(y[i],0);
		int m1=size[x[i]],m2=size[y[i]];
		Max=m1;
		dfs(x[i],0);
		Max=m2;
		dfs(y[i],0);
		for(int j=1;j<=n;j++)
			if(book[j]) ans+=j;
	}
	printf("%lld\n",ans);
	return 0;
}
}
namespace Subtask2
{
	int Index;
	int S;
	int dfn[N],w[N];
	void dfs(int u,int father)
	{
		dfn[u]=++Index;
		w[Index]=u;
		for(int i=head[u];i;i=edge[i].next)
		{
			int v=edge[i].to;
			if(v==father) continue;
			dfs(v,u);
		}
		return;
	}
	int main()
	{
		S=tmp[1];
		for(int i=1;i<n;i++)
			add_edge(x[i],y[i]),add_edge(y[i],x[i]);
		Index=0;
		dfs(S,0);
		long long ans=0;
		for(int i=1;i<n;i++)
		{
			int u=dfn[x[i]],v=dfn[y[i]];
			if(u>v) swap(u,v);
			if(u&1) ans+=u/2;
			else ans+=u/2+u/2+1;
			if((n-v+1)&1) ans+=(n-v+1)/2;
			else ans+=(n-v+1)/2+(n-v+1)/2+1;
		}
		printf("%lld\n",ans);
		return 0;
	}
}
void solve()
{
	memset(in,0,sizeof(in));
	scanf("%d",&n);
	for(int i=1;i<n;i++)
		scanf("%d%d",&x[i],&y[i]),in[x[i]]++,in[y[i]]++;
	tot=0;
	for(int i=1;i<=n;i++)
		if(in[i]==1) tmp[++tot]=i;
	if(n>1999) Subtask2::main();
	else Subtask1::main();
	return;
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--)
		solve();
	return 0; 
}
