#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
const int N=101,M=2001;
const int MOD=998244353;
int n,m;
int a[N][N];
int b[N];
int cha[M];
long long ans;
bool check(int tot)
{
	memset(cha,0,sizeof(cha));
	for(int i=1;i<=tot;i++)
		cha[b[i]]++;
	for(int i=1;i<=m;i++)
		if(cha[i]>tot/2) return false;
	return true;
}
long long calc(int tot)
{
	long long res=1;
	for(int i=1;i<=tot;i++)
		res=res*a[i][b[i]]%MOD;
	return res;
}
void dfs(int step)
{
	if(step>=2)
	{
		if(check(step)) ans=(ans+calc(step))%MOD;
	}
	if(step>=n) return;
	for(int i=1;i<=m;i++)
	{
		if(a[step+1][i]==0) continue; 
		b[step+1]=i;
		dfs(step+1);
	}
	return;
}
int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++)
		for(int j=1;j<=m;j++)
			scanf("%d",&a[i][j]);
	dfs(0);
	printf("%lld",ans);
	return 0;
}
