#include <bits/stdc++.h>

using namespace std;

#define DEBUG(x) cerr << #x << " = " << x << endl

inline int read () {
	int x = 0, f = 1; char ch;
	do {ch = getchar (); if (ch == '-') f = -1;} while (ch > '9' || ch < '0');
	do {x = x * 10 + ch - '0'; ch = getchar ();} while (ch <= '9' && ch >= '0');
	return f * x;
}

typedef long long ll;

const int N = 100 + 5;
const int M = 2000 + 5;
const int mod = 998244353;

int n, m, a[N][M], sum1[N], sum2[N];
	
inline void file () {
	freopen ("meal.in", "r", stdin);
	freopen ("meal.out", "w", stdout);
}

namespace subtask1 {
	int f[15][2005][2005];
	inline void main () {
		f[0][0][0] = 1;
		for (int i = 1; i <= n; i ++ ) {
			for (int j = 1; j <= m; j ++ ) {
				for (int k = 0; k <= sum1[i]; k ++ ) {
					for (int l = 0; l <= sum2[i]; l ++ ) {
						f[i][k][l] += f[i - 1][k][l];
						if (j == 1 && a[i][j] >= 1)
							f[i][k][l] += f[i - 1][k - 1][l] * a[i][j];
						if (j == 2 && a[i][j] >= 1)
							f[i][k][l] += f[i - 1][k][l - 1] * a[i][j];
						f[i][k][l] %= mod;
					}
				}
			}
		}
		ll ans = 0;
		for (int j = 1; j <= max (sum1[n], sum2[n]); j ++ ) ans += f[n][j][j];
		cout << ans << endl;
	}
}
/*
namespace subtask1 {
	const int MM = 3 * 1000 + 5;
	const int NN = 40 + 5;
	
	int f[NN][MM];
	
//	f[i][k] = f[j][k - l] * c[a[i][j]][l];
	
	inline void main () {
		memset (f, 1, sizeof (f));
		for (int i = 1; i <= n; i ++ ) {
			for (int j = 1; j <= i; j ++ ) {
				for (int k = 0; k <= sum[i]; k ++ ) {
					for (int l = 1; l <= m; l ++ ) {
						for (int s = 0; s <= min (a[i][l], k / 2); s ++ ) {
							f[i][k] += f[j][k - s] * c[a[i][l]][s];
						}
					}
				}
			}
		}
		ll ans = 0;
		for (int i = 1; i <= n; i ++ ) for (int j = 0; j <= sum[n]; j ++ ) ans += f[i][j] - 1;
		cout << ans << endl;
	}
}
*/

int main () {
	file ();
	n = read (); m = read ();
	for (int i = 1; i <= n; i ++ ) {
		for (int j = 1; j <= m; j ++ ) {
			a[i][j] = read ();
			sum1[i] += (j == 1) * a[i][j];
			sum2[i] += (j == 2) * a[i][j];
		}
	}
	subtask1::main ();
	return 0;
}
