#include <bits/stdc++.h>

using namespace std;

#define DEBUG(x) cerr << #x << " = " << x << endl

inline int read () {
	int x = 0, f = 1; char ch;
	do {ch = getchar (); if (ch == '-') f = -1;} while (ch > '9' || ch < '0');
	do {x = x * 10 + ch - '0'; ch = getchar ();} while (ch <= '9' && ch >= '0');
	return f * x;
}

typedef long long ll;

#define int ll

template <typename T> void chkmin (T &x, T y) {
	if (y == -1) return;
	if (x == -1) x = y;
	x = x > y ? y : x;
}

int n;

namespace subtask1 {
	const int N = 50 + 5;
	const int M = 50 * 1e3 + 7;
	
	ll f[N][M], sum[N], a[N];
	
	inline void main () {
		for (int i = 1; i <= n; i ++ ) a[i] = read (), sum[i] = sum[i - 1] + a[i];
		memset (f, -1, sizeof (f));
		f[0][0] = 0;
		for (int i = 1; i <= n; i ++ ) {
			for (int j = 0; j <= n; j ++ ) {
				for (int k = 0; k <= sum[i] - sum[j]; k ++ ) {
					if (f[j][k] == -1) continue;
					chkmin (f[i][sum[i] - sum[j]], f[j][k] + 1ll * (sum[i] - sum[j]) * (sum[i] - sum[j]));
				}
			}
		}
		ll ans = -1;
		for (int k = 0; k <= sum[n]; k ++ ) chkmin (ans, f[n][k]);
		cout << ans << endl;
		exit (0);
	}
}

namespace subtask2 {
	
	const int N = 400 + 5;
	
	ll f[N][N], sum[N], a[N];
	inline void main () {
		for (int i = 1; i <= n; i ++ ) a[i] = read (), sum[i] = sum[i - 1] + a[i];
		memset (f, -1, sizeof (f));
		f[0][0] = 0;
		for (int i = 1; i <= n; i ++ ) {
			for (int j = 0; j <= i; j ++ ) {
				for (int k = 0; k <= j; k ++ ) {
					if (f[j][k] == -1) continue;
					if (sum[i] - sum[j] >= sum[j] - sum[k]) {
						chkmin (f[i][j], f[j][k] + (sum[i] - sum[j]) * (sum[i] - sum[j]));
					}
				}
			}
		}
		ll ans = -1;
		for (int i = 0; i <= n; i ++ ) chkmin (ans, f[n][i]);
		cout << ans << endl;
		exit (0);
	}
}

inline void file () {
	freopen ("partition.in" , "r", stdin);
	freopen ("partition.out", "w", stdout);
}

signed main () {
	file ();
	n = read (); int type = read ();
	if (n <= 50) subtask1 :: main ();
	else if (n <= 400) subtask2 :: main();//36pts
}
