#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <string>
using namespace std;

typedef long long LL;
const int MAXN=103, MAXM=2003;
const int Md=998244353;
int a[MAXN][MAXM];
int f[2][MAXM][2*MAXN], g[MAXN], sum[MAXN];
int n, m, ans;

inline void read(int &x) {
  char ch=getchar(); int f=1; x=0;
  while(!isdigit(ch)) {if(ch=='-') f=-1;if(ch==EOF) return;ch=getchar();}
  while(isdigit(ch)) {x=x*10+(ch-'0');ch=getchar();} x*=f;
}

inline int Add(int x, int y) {
  return x+y>=Md ? x+y-Md : x+y;
}

inline int Sub(int x, int y) {
  return x-y<0 ? x-y+Md : x-y;
}

inline int Mul(int x, int y) {
  return 1ll*x*y%Md;
}

int main() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  scanf("%d%d", &n, &m);
  //read(n); read(m);
  for(int i=1;i<=n;++i) {
    for(int j=1;j<=m;++j) {
      scanf("%d", &a[i][j]);
      //read(a[i][j]);
    }
  }
  memset(f, 0, sizeof f);
  memset(g, 0, sizeof g);
  memset(sum, 0, sizeof sum);
  g[0]=1;
  for(int i=1;i<=n;++i) {
    int tmp=0;
    for(int j=1;j<=m;++j) {
      tmp=Add(tmp, a[i][j]);
    }
    sum[i]=tmp;
    for(int j=n;j>0;--j) {
      g[j]=Add(g[j], Mul(g[j-1], tmp));
    }
  }
  ans=0;
  for(int i=1;i<=n;++i) {
    ans=Add(ans, g[i]);
  }
  for(int j=1;j<=m;++j) {
    f[0][j][n]=1;
    for(int i=1;i<=n;++i) {
      int it=i&1, ni=it^1, spa=Sub(sum[i], a[i][j]);
      for(int k=max(1, n-i);k<=n+i && k<2*n;++k) {
	f[it][j][k]=Add(Add(Mul(f[ni][j][k+1], spa), Mul(f[ni][j][k-1], a[i][j])), f[ni][j][k]);
      }
      f[it][j][0]=Add(Mul(f[ni][j][1], spa), f[ni][j][0]);
      f[it][j][2*n]=Add(Mul(f[ni][j][2*n-1], a[i][j]), f[ni][j][2*n]);
    }
    for(int k=n+2;k<=2*n;++k) {
      f[n&1][j][k]=Add(f[n&1][j][k], f[n&1][j][k-1]);
    }
  }
  for(int i=1;i<=m;++i) {
    ans=Sub(ans, f[n&1][i][2*n]);
  }
  printf("%d\n", ans);
  fclose(stdin);
  fclose(stdout);
  return 0;
}
