#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
using namespace std;
#define mkpr make_pair
#define ft first
#define sd second

typedef long long LL;
typedef pair<LL, LL> PLL;
const int MAXN=5011;
const LL INF=0x7f7f7f7f7f7f7f7f;
LL a[MAXN], s[MAXN];
LL f[MAXN][MAXN], g[MAXN][MAXN], tmpf[MAXN], tmpg[MAXN];
int cnt[MAXN], pnt[MAXN];
int n, type, m, h, t, wh, wt;

inline void read(int &x) {
  char ch=getchar(); x=0;
  while(!isdigit(ch)) {if(ch==EOF) return;ch=getchar();}
  while(isdigit(ch)) {x=x*10+(ch-'0');ch=getchar();}
}

inline void read(LL &x) {
  char ch=getchar(); x=0;
  while(!isdigit(ch)) {if(ch==EOF) return;ch=getchar();}
  while(isdigit(ch)) {x=x*10+(ch-'0');ch=getchar();}
}

LL Calc(int pos, LL sum) {
  while(pnt[pos]<cnt[pos] && f[pos][pnt[pos]+1]<=sum) ++pnt[pos];
  //int loc=upper_bound(f[pos], f[pos]+1+cnt[pos], sum)-f[pos]-1;
  return g[pos][pnt[pos]]+sum*sum;
}

int main() {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
  read(n); read(type);
  s[0]=0;
  for(int i=1;i<=n;++i) {
    //scanf("%lld", &a[i]);
    read(a[i]);
    s[i]=s[i-1]+a[i];
    pnt[i]=0;
  }
  cnt[0]=1;
  f[0][1]=0ll;
  g[0][1]=0ll;
  for(int i=1;i<=n;++i) {
    for(int j=i;j>=1;--j) {
      LL sum=s[i]-s[j-1];
      tmpf[i-j+1]=sum;
      tmpg[i-j+1]=Calc(j-1, sum);
      //printf(" ~ (%lld %lld)\n", sum, Calc(j-1, sum));
    }
    cnt[i]=0;
    f[i][0]=0ll;
    g[i][0]=INF/3;
    for(int j=1;j<=i;++j) {
      if(j==1 || tmpf[j]!=tmpf[j-1]) {
	++cnt[i];
	f[i][cnt[i]]=tmpf[j];
	g[i][cnt[i]]=tmpg[j];
      } else g[i][cnt[i]]=min(g[i][cnt[i]], tmpg[j]);
    }
    for(int j=1;j<=cnt[i];++j) {
      g[i][j]=min(g[i][j], g[i][j-1]);
    }
    //printf("%d : %lld\n", i, f[i][cnt[i]].sd);
  }
  LL ans=INF;
  for(int i=1;i<=cnt[n];++i) {
    ans=min(ans, g[n][i]);
  }
  printf("%lld\n", ans);
  fclose(stdin);
  fclose(stdout);
  return 0;
}
