#define FILE_NAME "partition"
//*INDENT OFF*
#include<bits/stdc++.h>
using namespace std;
template<typename T>
bool tomin(T &x,T y) { if(y<x) { x=y; return true; } return false; }
template<typename T>
bool tomax(T &x,T y) { if(x<y) { x=y; return true; } return false; }
typedef long long ll;
#define FILE_IO freopen(FILE_NAME".in","r",stdin);freopen(FILE_NAME".out","w",stdout)
//*INDENT ON*
const int M=4e7+5;
int n,Type,A[M];
ll Sum[M];
namespace P_12 {
	ll dfs(int x,int v) {
		ll ret=INT_MAX;
		if(x==n) return 0;
		for(int i=x+1;i<=n;i++) {
			if(Sum[i]-Sum[x]>=v)
			tomin(ret,dfs(i,Sum[i]-Sum[x])+(Sum[i]-Sum[x])*(Sum[i]-Sum[x]));
		}
		return ret;
	}
	void Solve() {
		cout<<dfs(0,0)<<endl;
	}
}
namespace P_36 {
	bool Check(int mid,int n) {
		ll K=Sum[n]-Sum[mid-1];
		int L=mid-1,R=mid-1;
		while(L>0) {
			while(L>0 && Sum[R]-Sum[L-1]<=K) --L;
			++L;
			if(L>R) return false;
			K=Sum[R]-Sum[L-1];
			R=L-1;
			L=L-1;
		}
		return true;
	}
	int Get(int n) {
		int Ans=n;
		while(Ans>0 && !Check(Ans,n)) --Ans;
		return Ans;
	}
	void Solve() {
		ll Ans=0;
		int L=n;
		while(L!=0) {
			int t=Get(L);
			Ans+=(ll)(Sum[L]-Sum[t-1])*(Sum[L]-Sum[t-1]);
			L=t-1;
		}
		cout<<Ans<<endl;
	}
}
namespace P_85 {
	bool Check(int mid,int n) {
		ll K=Sum[n]-Sum[mid-1];
		int L=mid-1,R=mid-1;
		while(L>0) {
			while(L>0 && Sum[R]-Sum[L-1]<=K) --L;
			++L;
			if(L>R) return false;
			K=Sum[R]-Sum[L-1];
			R=L-1;
			L=L-1;
		}
		return true;
	}
	int Get(int n) {
		int L=1,R=n,mid,Ans=1;
		while(L<=R) {
			mid=(L+R)>>1;
			if(Check(mid,n)) {
				Ans=mid;
				L=mid+1;
			} else R=mid-1;
		}
		return Ans;
	}
	void Solve() {
		ll Ans=0;
		int L=n;
		while(L!=0) {
			int t=Get(L);
			Ans+=(ll)(Sum[L]-Sum[t-1])*(Sum[L]-Sum[t-1]);
			L=t-1;
		}
		cout<<Ans<<endl;
	}
}
int main() {
	FILE_IO;
	scanf("%d%d",&n,&Type);
	if(Type==0) {
		for(int i=1;i<=n;i++)
			scanf("%d",&A[i]);
	} else {
		/*
		int x,y,z,b1,b2,m;
		cin>>x>>y>>z>>b1>>b2>>m;
		for(int i=1;i<=m;i++) {
		}
		*/
	}
	for(int i=1;i<=n;i++)
		Sum[i]=Sum[i-1]+A[i];
	if(n<=10) P_12::Solve();
	else if(n<=5000) P_36::Solve();
	else P_85::Solve();
	return 0;
}
/*
*/
