#define FILE_NAME "tree"
//*INDENT OFF*
#include<bits/stdc++.h>
using namespace std;
template<typename T>
bool tomin(T &x,T y) { if(y<x) { x=y; return true; } return false; }
template<typename T>
bool tomax(T &x,T y) { if(x<y) { x=y; return true; } return false; }
typedef long long ll;
typedef pair<int,int> PII;
#define FILE_IO freopen(FILE_NAME".in","r",stdin);freopen(FILE_NAME".out","w",stdout)
//*INDENT ON*
const int M=2005;
int T,n,A[M],pos[M],fa[M];
bool MarkDel[M<<1];
PII Go[M];
vector<int>E[M],Edge;
/*
void dfs0(int x,int f,int d) {
	fa[x]=f; dep[x]=d; siz[x]=1;
	for(int i=0;i<E[x].size();i++) {
		int v=Edge[E[x][i]];
		if(v==f) continue;
		dfs0(v,x,d+1);
		siz[x]+=siz[v];
		if(siz[son[x]]<siz[v]) son[x]=v;
	}
}
void dfs1(int x,int K) {
	top[x]=K;
	if(son[x]) dfs1(son[x],K);
	for(int i=0;i<E[x].size();i++) {
		int v=Edge[E[x][i]];
		if(v==fa[x] || v==son[x]) continue;
		dfs1(v,v);
	}
}
int GetLCA(int x,int y) {
	while(top[x]!=top[y]) {
		if(dep[top[x]]<dep[top[y]])
			y=fa[top[y]];
		else
			x=fa[top[x]];
	}
	return dep[x]<dep[y]?x:y;
}
*/
namespace P_10 {
	int P[25],Ans[M],tmppos[25];
	void Check() {
		for(int i=1;i<n;i++) {
			int x=Edge[P[i]*2],y=Edge[(P[i]*2)^1];
			swap(A[x],A[y]);
		}
		for(int i=1;i<=n;i++)
			tmppos[A[i]]=i;
		for(int i=1;i<=n;i++) {
			if(tmppos[i]<Ans[i]) {
				for(int j=1;j<=n;j++) 
					Ans[j]=tmppos[j];
			} else if(tmppos[i]>Ans[i]) return;
		}
	}
	void Solve() {
		Ans[1]=n+1;
		for(int i=1;i<n;i++)
			P[i]=i-1;
		do {
			for(int i=1;i<=n;i++)
				A[pos[i]]=i;
			Check();
		} while(next_permutation(P+1,P+n));
		for(int i=1;i<=n;i++) 
			printf("%d%c",Ans[i],i==n?'\n':' ');
	}
}
namespace P_30 {
	int tmppos[M];
	PII dfs0(int x,int f) {
		fa[x]=f;
		PII &ret=Go[x],t;
		ret=(PII){-1,-1};
		for(int i=0;i<E[x].size();i++) {
			if(MarkDel[E[x][i]]) continue;
			int v=Edge[E[x][i]];
			if(v==f) continue;
			t=dfs0(v,x);
			if(ret.first==-1 || tomin(ret.first,t.first)) {
				ret.first=t.first;
				ret.second=E[x][i];
			}
		}
		if(ret.first==-1) ret.first=x;
		return ret;
	}
	void dfs1(int x,int f) {
		if(Go[x].second!=-1) dfs1(Edge[Go[x].second],x);
		swap(A[x],A[Edge[Go[x].second]]);
		MarkDel[Go[x].second]=true;
		MarkDel[Go[x].second^1]=true;
	}
	void Solve() {
		for(int x=1;x<=n;x++) {
			dfs0(x,x);
			cerr<<x<<" "<<Go[x].first<<endl;
			for(int i=0;i<E[x].size();i++) {
				if(MarkDel[E[x][i]]) continue;
				int v=Edge[E[x][i]];
				if(v==fa[x] || v==Edge[Go[x].second]) continue;
				swap(A[x],v);
				MarkDel[E[x][i]]=true;
				MarkDel[E[x][i]^1]=true;
			}
			dfs1(x,x);
		}
		for(int i=1;i<=n;i++)
			tmppos[A[i]]=i;
		for(int i=1;i<=n;i++) 
			printf("%d%c",tmppos[i],i==n?'\n':' ');
	}
}
void Clear() {
	for(int i=0;i<Edge.size();i++) MarkDel[i]=false;
	for(int i=1;i<=n;i++) E[i].clear();
	Edge.clear();
}
int main() {
	FILE_IO;
	scanf("%d",&T);
	for(int cas=1;cas<=T;cas++) {
		scanf("%d",&n);
		for(int i=1;i<=n;i++) {
			scanf("%d",&pos[i]);
			A[pos[i]]=i;
		}
		int x,y;
		for(int i=1;i<n;i++) {
			scanf("%d%d",&x,&y);
			E[x].push_back(Edge.size());
			Edge.push_back(y);
			E[y].push_back(Edge.size());
			Edge.push_back(x);
		}
		bool MarkP30=true;
		for(int i=1;i<=n;i++) 
			if(E[x].size()>2) MarkP30=false;
		P_10::Solve();
//		if(MarkP30) P_30::Solve();
		/*
		if(n<=10) P_10::Solve();
		else if(MarkP30) P_30::Solve();
		*/
		Clear();
	}
	return 0;
}
/*
*/
