#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define LL long long
#define Maxn 300010
using namespace std;
int head[Maxn<<1],fxksize1[3],tot,cnt1,co1[Maxn],flag[Maxn<<1],T,n,ans;
struct node{int nxt,v;}edge[Maxn<<1];
struct nodeq{int x,y;}q[Maxn<<1];
int read()
{
	int s=0,w=1;char ch=getchar();
	while (!isdigit(ch))
	{
		if (ch=='-') w=-1;
		ch=getchar();
	}
	while (isdigit(ch)) s=(s<<1)+(s<<3)+(ch^48),ch=getchar();
	return s*w;
}
void add(int x,int y){edge[++tot]=(node){head[x],y},head[x]=tot;}
int dfs(int x,int fa)
{
	int nowsize=1;
	for (int i=head[x];i;i=edge[i].nxt)
	{
		if (flag[i]) continue;
		int v=edge[i].v;
		if (v==fa) continue;
		nowsize+=dfs(v,x);
	}
	return nowsize;
}
int check(int x,int bs)
{
	for (int i=head[x];i;i=edge[i].nxt) 
	{
 		flag[i]=1;
		if (i&1) flag[i+1]=1;
		else flag[i-1]=1;
	}
	int nowflag=1;
	for (int i=1;i<=n;i++)
		if (co1[i]==co1[x]&&i!=x)
			if (dfs(i,0)>fxksize1[co1[i]]/2&&fxksize1[co1[i]]>1)
			{
				nowflag=0;
				break;
			}
	for (int i=head[x];i;i=edge[i].nxt) 
	{
 		flag[i]=0;
		if (i&1) flag[i+1]=0;
		else flag[i-1]=0;
	}
	flag[bs*2-1]=1,flag[bs*2]=1;
	return (nowflag);
}
void dfs_co1(int x,int fa)
{
	co1[x]=cnt1;fxksize1[cnt1]++;
	for (int i=head[x];i;i=edge[i].nxt)
	{
		if (flag[i]) continue;
		int v=edge[i].v;
		if (v==fa) continue;
		dfs_co1(v,x);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	while (T--)
	{
		n=read();
		memset(head,0,sizeof(head));
		tot=0,ans=0;
		for (int i=1;i<n;i++)
		{
			q[i].x=read(),q[i].y=read();
			add(q[i].x,q[i].y),add(q[i].y,q[i].x);
		}
		for (int bs=1;bs<n;bs++)
		{
			memset(flag,0,sizeof(flag));
			flag[bs*2-1]=1,flag[bs*2]=1;
			memset(co1,0,sizeof(co1));
			memset(fxksize1,0,sizeof(fxksize1));
			cnt1=0;
			for (int i=1;i<=n;i++)
				if (!co1[i])
				{
					++cnt1;
					dfs_co1(i,0);
				}
			for (int i=1;i<=n;i++) 
				if (check(i,bs)) 
					ans+=i;
		}
		printf("%d\n",ans);
	}
	return 0;
}
