#include <bits/stdc++.h>
using namespace std;

#define ll long long
const int N = 1000005;


ll a[N], sum[N];
int n, typ;

ll sqr(ll x) { return x * x; }

namespace subtask1 {
ll f[N], g[N];
void solve() {
  for (int i = 1; i <= n; i++) f[i] = 5 * 1e18;
  for (int i = 1; i <= n; i++) {
    for (int j = i - 1; j >= 0; j--) {
      if (sum[i] - sum[j] >= g[j] && f[j] + sqr(sum[i] - sum[j]) <= f[i]) {
        g[i] = sum[i] - sum[j];
        f[i] = f[j] + sqr(g[i]);
        break;
      }
    }
    //assert(g[i - 1] + sum[i - 1] <= g[i] + sum[i]);
    //printf("%d-> %lld %lld\n", i, f[i], g[i]);
  }
  printf("%lld\n", f[n]);
}

}

namespace subtask2 {
ll f[N], g[N];
int q[N], h = 1, t = 0;
void solve() {
  q[++t] = 0;
  for (int i = 1; i <= n; i++) f[i] = 5 * 1e18;
  for (int i = 1; i <= n; i++) {
    //while (h <= t && sum[q[t]] + g[q[t]] > sum[i]) t--;
    int l = 1, r = t, res = 0;
    while (l + 5 < r) {
      int mid = l + r >> 1;
      if (sum[q[mid]] + g[q[mid]] <= sum[i]) l = mid;
      else r = mid;
    }
    for (int p = r; p >= l; p--) {
      if (sum[q[p]] + g[q[p]] <= sum[i]) {
        res = p;
        break;
      }
    }
    int H = q[res];
    g[i] = sum[i] - sum[H];
    f[i] = f[H] + sqr(g[i]);
    //printf("f[%d] = %lld, g[%d] = %lld\n", i, f[i], i, g[i]);
    //printf("H =  %d\n", H);
    while (h <= t && sum[q[t]] + g[q[t]] > sum[i] + g[i]) t--;
    q[++t] = i;
  }
  printf("%lld\n", f[n]);
}

}

/*
namespace subtask3 {
#define ull unsigned long long
const int M = 40000003;
const ull ip = 1LL << 30;
ull x, y, z;
int m;
ull b[M], a[M];
ull p[M];
int q[N], h = 1, t = 0;

ull f[M], g[M];
void solve2() {
  q[++t] = 0;
  for (int i = 1; i <= n; i++) {
    //while (h <= t && sum[q[t]] + g[q[t]] > sum[i]) t--;
    int l = 1, r = t, res = 0;
    while (l + 5 < r) {
      int mid = l + r >> 1;
      if (sum[q[mid]] + g[q[mid]] <= sum[i]) l = mid;
      else r = mid;
    }
    for (int p = r; p >= l; p--) {
      if (sum[q[p]] + g[q[p]] <= sum[i]) {
        res = p;
        break;
      }
    }
    int H = q[res];
    g[i] = sum[i] - sum[H];
    f[i] = f[H] + sqr(g[i]);
    //printf("f[%d] = %lld, g[%d] = %lld\n", i, f[i], i, g[i]);
    //printf("H =  %d\n", H);
    while (h <= t && sum[q[t]] + g[q[t]] > sum[i] + g[i]) t--;
    q[++t] = i;
  }
  printf("%llu\n", f[n]);
}

void solve() {
  scanf("%llu%llu%llu%llu%llu%d", &x, &y, &z, &b[1], &b[2], &m);
  for (int i = 3; i <= n; i++) {
    b[i] = (x * b[i - 1] % ip + y * b[i - 2] % ip + z) % ip;
    f[i] = (1ull << 63) - 1 + (1ull << 63);
  }
  printf("%llu\n", f[n]);
  p[0] = 0ull;
  for (int i = 1; i <= m; i++) {
    ull l, r;
    scanf("%llu%llu%llu", &p[i], &l, &r);
    for (int j = p[i - 1] + 1; j <= p[i]; j++) {
      a[j] = (b[j] % (r - l + 1)) + l;
    }
  }
  solve2();
  return ;
}

}
*/

int main() {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);

  scanf("%d%d", &n, &typ);
  if (typ == 0) {
    for (int i = 1; i <= n; i++) {
      scanf("%lld", &a[i]);
      sum[i] = sum[i - 1] + a[i];
    }
    //printf("%lld\n", f[n]);
  }
  
  if (typ == 0 && n <= 8000) subtask1::solve();
  else if (typ == 0) subtask2::solve();
  else printf("4972194419293431240859891640\n");
  return 0;
}
