#define LL long long

#include <bits/stdc++.h>

using namespace std;

void rd(int &x) {
	x = 0;
	char c = getchar();
	while (c < '0' || c > '9')
		c = getchar();
	while (c >= '0' && c <= '9')
		x = (x << 3) + (x << 1) + (c & 15), c = getchar();
}

const int N = 3e5 + 5;

int top, head[N], go[N * 2], nex[N * 2], id[N * 2];
void add(int u, int v, int w) {
	nex[++top] = head[u], head[u] = top, go[top] = v, id[top] = w;
}

int no, siz[N];
void dfs(int u, int pre = 0) {
	siz[u] = 1;
	for (int i = head[u]; i; i = nex[i]) {
		if (id[i] == pre || id[i] == no)
			continue;
		int v = go[i];
		dfs(v, id[i]);
		siz[u] += siz[v];
	}
}

LL ans;
int nn;
void dfs2(int u, int pre = 0) {
	int mx = 0;
	for (int i = head[u]; i; i = nex[i]) {
		if (id[i] == pre || id[i] == no)
			continue;
		int v = go[i];
		dfs2(v, id[i]);
		mx = max(mx, siz[v]);
	}
	mx = max(mx, nn - siz[u]);
	if (mx <= nn / 2)
		ans += u;
}

int p[N];
void dfsp(int u, int dep, int pre = 0) {
	p[dep] = u;
	for (int i = head[u]; i; i = nex[i]) {
		if (id[i] == pre)
			continue;
		int v = go[i];
		dfsp(v, dep + 1, id[i]);
	}
}

int u[N], v[N], deg[N];
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; rd(T);
	while (T--) {
		int n; rd(n);
		ans = top = 0;
		for (int i = 1; i <= n; ++i)
			head[i] = 0;
		for (int i = 1; i < n; ++i) {
			rd(u[i]), rd(v[i]);
			add(u[i], v[i], i), add(v[i], u[i], i);
		}
		if (n <= 2000) {
			for (no = 1; no < n; ++no) {
				dfs(u[no]), nn = siz[u[no]], dfs2(u[no]);
				dfs(v[no]), nn = siz[v[no]], dfs2(v[no]);
			}
		}
		else {
			for (int i = 1; i <= n; ++i)
				deg[i] = 0;
			for (int i = 1; i < n; ++i)
				++deg[u[i]], ++deg[v[i]];
			for (int i = 1; i <= n; ++i)
				if (deg[i] == 1) {
					dfsp(i, 1);
					break;
				}
			for (no = 1; no < n; ++no) {
				int l = no, r = no + 1;
				if (l % 2 == 1)
					ans += p[(l + 1) / 2];
				else
					ans += p[(l + 1) / 2] + p[(l + 1) / 2 + 1];
				if ((n - r + 1) % 2 == 1)
					ans += p[(n + r) / 2];
				else
					ans += p[(n + r) / 2] + p[(n + r) / 2 + 1];
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}
