#include<bits/stdc++.h>
using namespace std;

int n,m;
int a[105][2005];

const int mod=998244353;
int add(int x,int y) {
	long long z=x+y;
	return (z%mod+mod)%mod;
}
int mul(int x,int y) {
	long long z=1ll*x*y;
	return (z%mod+mod)%mod;
}

namespace task1 {
	int f[45][45][45];
	void work() {
		memset(f,0,sizeof(f));
		f[0][0][0]=1;

		for(int i=1; i<=n; i++)
			for(int x=0; x<=n; x++)
				for(int y=0; y<=n; y++) {
					if(x+y>i) continue;
					f[i][x][y]=f[i-1][x][y];
					if(x>=1) f[i][x][y]=add(f[i][x][y],mul(f[i-1][x-1][y],a[i][1]));
					if(y>=1) f[i][x][y]=add(f[i][x][y],mul(f[i-1][x][y-1],a[i][2]));
				}

		int ans=0;
		for(int x=0; x<=n; x++)
			for(int y=0; y<=n; y++)
				if(x+y<=n&&x+y>0&&x<=y&&y<=x)
					ans=add(ans,f[n][x][y]);
		printf("%d\n",ans);
	}
}

namespace task2 {
	int f[45][45][45][45];

	void work() {
		memset(f,0,sizeof(f));
		f[0][0][0][0]=1;

		for(int i=1; i<=n; i++)
			for(int x=0; x<=n; x++)
				for(int y=0; y<=n; y++)
					for(int z=0; z<=n; z++) {
						if(x+y+z>i) continue;
						f[i][x][y][z]=f[i-1][x][y][z];
						if(x>=1) f[i][x][y][z]=add(f[i][x][y][z],mul(f[i-1][x-1][y][z],a[i][1]));
						if(y>=1) f[i][x][y][z]=add(f[i][x][y][z],mul(f[i-1][x][y-1][z],a[i][2]));
						if(z>=1) f[i][x][y][z]=add(f[i][x][y][z],mul(f[i-1][x][y][z-1],a[i][3]));
					}
		int ans=0;
		for(int x=0; x<=n; x++)
			for(int y=0; y<=n; y++)
				for(int z=0; z<=n; z++)
					if(x+y+z<=n&&x+y+z>0&&x<=y+z&&y<=x+z&&z<=x+y)
						ans=add(ans,f[n][x][y][z]);
		printf("%d\n",ans);
	}
}

int main() {
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	srand(19260817);
	scanf("%d%d",&n,&m);
	for(int i=1; i<=n; i++)
		for(int j=1; j<=m; j++) scanf("%d",&a[i][j]);
	
	if(m==2) task1::work();
	else
	if(m==3) task2::work();
	else 
	printf("%lld\n",1ll*rand()*rand()*rand()%mod);
	fclose(stdin);
	fclose(stdout);
	return 0;
}

