#include <bits/stdc++.h>

const int N = 300009;
int T, n, cnt, cen1, cen2;
int head[N], nxt[N << 1], to[N << 1];
int deg[N];
long long w[N], ans;
int subA;
int mx1[N], mx2[N];

int read() {
	int x = 0; char c; bool flag = 0;
	for (c = getchar(); c < '0' || c > '9'; c = getchar()) (c == '-') && (flag = 1);
	while (c >= '0' && c <= '9') x = x * 10 + c - '0', c = getchar();
	return flag ? -x : x;
}

void file() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
}

void add(int a, int b) {
	int u = head[a], v = ++cnt;
	nxt[v] = u, to[v] = b;
	head[a] = v;
}
/*
namespace trash{
inline void update(int u, int v) {
	if (size[v] > size[mx1[u]]) mx2[u] = mx1[u], mx1[u] = v;
	else if (size[v] > size[mx2[u]]) mx2[u] = v;
}


void dfs1(int u, int fa) {
	size[u] = 1, pre[u] = fa;
	for (int i = head[u]; i; i = nxt[i]) {
		if (to[i] == fa) continue;
		dfs1(to[i], u);
		update(u, to[i]), size[u] += size[to[i]];
	}
}

void dfs2(int u, int fa, int temp) {
	od[u] = temp;
	for (int i = head[u]; i; i = nxt[i]) {
		if (to[i] == fa) continue;
		dfs2(to[i], u, temp + size[u] - size[to[i]]);
	}
	if (size[mx1[u]] <= n / 2 && od[u] <= n / 2) {
		if (cen1) cen2 = u;
		else cen1 = u;
	}
}
/*
namespace subtask1 {
	long long ans = 0;
	
	inline void change(int u, int v, int p) {
		if (j == mx1[pre[i]]) {
			
		}
	}
	
	void f(int u, int v) {
		for (int i = pre[u], j = u; i; i = pre[i], j = i) {
			change(i, j, 1);
		}
	}
	
	void dfs(int u) {
		for (int i = head[u]; i; i = nxt[i]) {
			if (to[i] == pre[u]) continue;
			f(u, to[i]);	
			dfs(to[i]);
		}
	}
	
	void solve() {
		dfs(1);
	}
}


int main() {
	file();
	T = read();
	while (T--) {
		n = read();
		for (int i = 1; i < n; i++) {
			int a = read(), b = read();
			add(a, b), add(b, a);
		}
		dfs1(1, 0);
		dfs2(1, 0, 0);
		printf("%d %d\n", cen1, cen2);
		//if (n <= 2000) subtask1::solve();
		
		return 0;
	}
	return 0;
}*/

void init() {
	for (int i = 1; i <= n; i++) head[i] = deg[i] = w[i] = 0;
	for (int i = 1; i <= cnt; i++) nxt[i] = to[i] = 0;
	cnt = ans = 0;
}

void solve() {
	int rt = 0;
	long long ans = n;
	for (int i = 1; i <= n; i++) if (deg[i] == 0) {
		rt = i;
		break;
	}
	printf("%lld\n", ans * (ans + 1) / 2 + rt * (ans - 2));
	exit(0);
}

int main() {
	file();
	T = read();
	while (T--) {
		init();
		n = read();
		for (int i = 1; i < n; i++) {
			int a = read(), b = read();
			add(a, b), add(b, a);
			deg[a]++, deg[b]++;
		}
		/*for (int i = 1; i <= n; i++) if (deg[i] == 2) subA++;
		if (subA != n - 2) solve();*/
		for (int i = 1; i <= n; i++) {
			if (deg[i] % 2 == 1)  {
				w[1] = i;
				break;
			}
		}
		for (int j = 2, i = w[1]; j <= n; j++) {
			for (int k = head[i]; k; k = nxt[k]) {
				if (w[j - 2] == to[k]) continue;
				i = w[j] = to[k];
			}
		}
		for (int i = 1; i <= n; i++) ans += w[i];
		ans *= 3;
		ans = ans - w[1] - w[n] - w[n / 2 + 1];
		if (n % 2 == 0) ans -= w[n / 2];
		printf("%lld\n", ans);
	}
	return 0;
}
