#include <vector>
#include <cstring>
#include <fstream>
#include <utility>
#include <algorithm>
std::ifstream Fin("centroid.in"); std::ofstream Fout("centroid.out");
const int N = 3E5;
int n,u[N],v[N],ans;
namespace sub0
{
	const int N = 2000;
	bool E[N][N];
	int fa[N],size_[N];
	int DFS0(int O,int fa)
	{
		sub0::fa[O] = fa,size_[O] = 1;
		for (int i = 1;i <= n;++ i)
			if (E[O][i] && i != fa)
				size_[O] += DFS0(i,O);
		return size_[O];
	}
	int m,size[N];
	void DFS(int O,int fa)
	{
		bool F = 1; size[O] = 1;
		bool * E = sub0::E[O]; for (int i = 1;i <= n;++ i)
			if (E[i] && i != fa)
			{
				DFS(i,O),size[O] += size[i];
				F &= size[i] <= m >> 1;
			}
		if (F &= m - size[O] <= m >> 1)
			ans += O;
	}
	void main()
	{
		std::memset(E,0,sizeof(E));
		for (int i = 1;i < n;++ i)
			E[u[i]][v[i]] = E[v[i]][u[i]] = 1;
		DFS0(1,0);
		for (int i = 1;i < n;++ i)
		{
			int u = ::u[i],v = ::v[i];
			if (fa[u] == v) std::swap(u,v);
			m = n - size_[v],DFS(u,v);
			m = size_[v],DFS(v,u);
		}
	}
}
namespace sub1
{
	const int N = 5E4;
	std::vector <int> E[N];
	std::vector <int> V;
	void DFS(int O,int fa)
	{
		V.push_back(O);
		for (int i = 0;i < E[O].size();++ i)
			if (E[O][i] != fa) DFS(E[O][i],O);
	}
	void calc()
	{
		for (int i = 0;i < V.size();++ i)
		{
			if (i + 1 << 1 < n)
				ans += V[i];
			if (i << 1 | 1 < n)
				ans += V[i];
			if (i << 1 < n)
				ans += V[i];
		}
	}
	void main()
	{
		for (int i = 1;i <= n;++ i) E[i].clear();
		for (int i = 1;i < n;++ i)
			E[u[i]].push_back(v[i]),E[v[i]].push_back(u[i]);
		int i = 1; for (;i < n;++ i)
			if (E[i].size() == 1) break;
		V.clear(),DFS(i,0);
		calc();
		std::reverse(V.begin(),V.end());
		calc();
	}
}
namespace sub2
{
	void main() { }
}
void solve()
{
	Fin >> n;
	for (int i = 1;i < n;++ i)
		Fin >> u[i] >> v[i];
	ans = 0;
	if (n < 2000) sub0::main();
	else if (n == 49991) sub1::main();
	else sub2::main();
	Fout << ans << '\n';
}
int main()
{
	int T; for (Fin >> T;T --;) solve();
}
