#include <cstring>
#include <fstream>
std::ifstream Fin("meal.in"); std::ofstream Fout("meal.out");
const int N = 100,M = 2000;
int n,a[N][M],S[N];
const int mod = 998244353;
inline void reduce(int & x) { x += x >> 31 & mod; }
inline void add(int & x,int y) { reduce(x += y - mod); }
inline int mul(int a,int b) { return static_cast <long long>(a) * b % mod; }
class poly
{
	int F[N + 1][N + 1];
public:
	inline poly()
	{
		for (int i = 0;i <= n;++ i)
			std::memset(F[i],0,n + 1 - i << 2);
		* * F = 1;
	}
	inline void mul(int a,int b)// 1 + ax + by
	{
		static int T[N + 1][N + 1];
		for (int i = 0;i <= n;++ i)
			std::memcpy(T[i],F[i],n + 1 - i << 2);
		for (int i = 0;i < n;++ i)
			for (int j = 0;i + j <= n;++ j)
				add(T[i + 1][j],::mul(a,F[i][j]));
		for (int i = 0;i <= n;++ i)
			for (int j = 0;i + j < n;++ j)
				add(T[i][j + 1],::mul(b,F[i][j]));
		for (int i = 0;i <= n;++ i)
			std::memcpy(F[i],T[i],n + 1 - i << 2);
	}
	inline int coef(int a,int b) { return F[a][b]; }
}P0,P1[M];
int main()
{
	int m; Fin >> n >> m;
	for (int i = 0;i < n;++ i)
	{
		for (int j = 0;j < m;++ j)
			Fin >> a[i][j],add(S[i],a[i][j]);
		P0.mul(S[i],0);
	}
	for (int i = 0;i < m;++ i)
		for (int j = 0;j < n;++ j)
			P1[i].mul(a[j][i],mod + S[j] - a[j][i]);
	int ans = 0;
	for (int k = 1;k <= n;++ k)
	{
		int res = 0;
		for (int x = (k >> 1) + 1;x <= k;++ x)
			for (int i = 0;i < m;++ i)
				add(res,P1[i].coef(x,k - x));
		add(ans,P0.coef(k,0)),reduce(ans -= res);
	}
	Fout << ans << '\n';
}
