#include<cstdio>
#include<iostream>
#include<cstring>
using namespace std;

struct EDGE
{
	int from,to,nxt;
}edge[600010];

int T,n,num_edge,a,b,size_son,cho;
int head[300010],son[300010];
unsigned long long ans;

void _add(int from,int to)
{
	edge[++num_edge].nxt=head[from];
	edge[num_edge].to=to;
	edge[num_edge].from=from;
	head[from]=num_edge;
}

void dfs(int x,int cut)
{
	son[x]=1;
	for(int p=head[x];p;p=edge[p].nxt)
	{
		if(!son[edge[p].to]&&edge[p].to!=cut)
		{
			dfs(edge[p].to,cut);
			son[x]+=son[edge[p].to];
		}
	}
}

void solve(int u,int v,int cut)
{
	if(cho==2) return;
	bool f=0;
	memset(son,0,sizeof(son));
	dfs(u,cut);
	for(int p=head[u];p;p=edge[p].nxt)
	{
		if(edge[p].to!=cut)
			if((son[edge[p].to])>(son[u]>>1))
				f=1;
	}
	for(int p=head[u];p;p=edge[p].nxt)
	{
		if(edge[p].to!=v)
			solve(edge[p].to,u,cut);
	}
	if(!f) ans+=u,cho++;
}

inline void clear_all()
{
	memset(head,0,sizeof(head));
	memset(son,0,sizeof(son));
	ans=0;
	num_edge=0;
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--)
	{
		clear_all();
		scanf("%d",&n);
		for(int i=1;i<n;i++)
		{
			scanf("%d%d",&a,&b);
			_add(a,b),_add(b,a);
		}
		for(int i=1;i<=num_edge;i++)
		{
			cho=0;
			solve(edge[i].from,edge[i].to,edge[i].to);
		}
		printf("%d\n",ans);
	}
}

