#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 3e5+5, M = 6e5+5;
int T, n, u[N], v[N], edgenum, Head[N], Next[M], vet[M], deg[N], S; ll ans;
inline void add(int u, int v) {
	Next[++edgenum] = Head[u];
	Head[u] = edgenum;
	vet[edgenum] = v;
}
namespace bf {
	void calcsize(int u, int fa) {
		S ++;
		for (int e=Head[u]; e; e=Next[e]) {
			int v=vet[e];
			if (v ^ fa) calcsize(v, u);
		}
	}
	int getgc(int u, int fa) {
		int Max = 0, siz = 1;
		for (int e=Head[u]; e; e=Next[e]) {
			int v=vet[e];
			if (v ^ fa) {
				int _ = getgc(v, u);
				Max = max(Max, _);
				siz += _;
			}
		}
		if (max(Max, S - siz) <= S >> 1)
			ans += u;
		return siz;
	}
	inline void solve() {
		ans = 0;
		for (int i=1; i<n; i++) {
			S = 0, calcsize(u[i], v[i]);
			getgc(u[i], v[i]);
			S = n - S, getgc(v[i], u[i]);
		} printf ("%lld\n", ans);
	}
}
namespace Chain {
	int now, a[N], lst;
	inline void solve() {
		for (int i=1; i<=n; i++)
			if (deg[i] == 1) {
				now = i; break;
			}
		a[1] = now, lst = 0;
		for (int i=2; i<=n; i++) {
			if (vet[Head[now]] == lst)
				lst = now, now = vet[Next[Head[now]]];
			else
				lst = now, now = vet[Head[now]];
			a[i] = now;
		} ans = 0;
		for (int i=1; i<n; i++) {
			if (i & 1)
				ans += a[i + 1 >> 1];
			else
				ans += a[i >> 1] + a[(i >> 1) + 1];
			if (n - i & 1)
				ans += a[i + (n - i + 1 >> 1)];
			else
				ans += a[i + (n - i >> 1)] + a[i + (n - i >> 1) + 1];
		} cout << ans << endl;
	}
}
namespace BT {
	int rt, seq[N], ID[N], bel[N];
	void dfs(int u, int id) {
		seq[id] = u, ID[u] = id;
		if (! seq[3]) bel[u] = 2; else bel[u] = 3;
		for (int e=Head[u]; e; e=Next[e]) {
			int v=vet[e];
			if (! ID[v])
				if (seq[id << 1])
					dfs(v, id << 1 | 1);
				else
					dfs(v, id << 1);
		}
	}
	inline void solve() {
		memset (ID, 0, sizeof ID);
		memset (seq, 0, sizeof seq);
		for (int i=1; i<=n; i++)
			if (deg[i] == 2) {
				rt = i; break;
			}
		dfs(rt, 1), ans = 0;
		for (int i=1; i<n; i++) {
			int U = u[i], V = v[i];
			if (ID[V] == ID[U] >> 1)
				swap(U, V);
			ans += V;
			ans += bel[V] == 2 ? seq[3] : seq[2];
			if (ID[V] << 1 > n) ans += rt;
		} cout << ans << endl;
	}
}
int main() {
	freopen ("centroid.in", "r", stdin);
	freopen ("centroid1.out", "w", stdout);
	cin >> T;
	while (T--) {
		edgenum = 0, memset (Head, 0, sizeof Head);
		memset (deg, 0, sizeof deg);
		scanf ("%d", &n);
		if (n == 1) { puts ("0"); continue; }
		for (int i=1; i<n; i++)
			scanf ("%d%d", &u[i], &v[i]), add(u[i], v[i]), add(v[i], u[i]), deg[u[i]] ++, deg[v[i]] ++;
		Chain :: solve();
	} return 0;
}
