#include<cstdio>
#include<cstring>
#include<algorithm>
#define ll long long
#define N 110
#define M 2010
using namespace std;

template<class T>
void read(T &x) {
	x=0;char ch=getchar();bool flag=false;
	for(;ch!='-' && !(ch>='0' && ch<='9');ch=getchar());
	if(ch=='-') ch=getchar(),flag=true;
	for(;ch>='0' && ch<='9';ch=getchar()) x=x*10+ch-48;
	if(flag) x=-x;
}

template<class T>
void write(T x) {
	if(x==0) {putchar('0');return;}
	if(x<0) x=-x,putchar('-');
	static int st[30];int t=0;
	while(x) st[t++]=x%10,x/=10;
	while(t) putchar(st[--t]+48);
}

const ll P=998244353ll;
int n,m;
ll a[N][M];

struct sub1 {
	ll d[105][105][105];
	
	ll acht() {
		d[0][0][0]=1;
		for(int i=1;i<=n;i++) {
			for(int j=0;j<=100;j++) {
				for(int k=0;k<=100;k++) {
					if(j!=0) {
						(d[i][j][k]+=d[i-1][j-1][k]*a[i][1])%=P;
					}
					if(k!=0) {
						(d[i][j][k]+=d[i-1][j][k-1]*a[i][2])%=P;
					}
					(d[i][j][k]+=d[i-1][j][k])%=P;
				}
			}
		}
		ll ret=0;
		for(int i=1;i<=100;i++) {
			(ret+=d[n][i][i])%=P;
		}
		return ret;
	}
};

struct sub2 {
	ll d[50][25][25][25];
	
	ll acht() {
		d[0][0][0][0]=1;
		for(int i=1;i<=n;i++) {
			for(int j=0;j<=22;j++) {
				for(int k=0;k<=22;k++) {
				for(int p=0;p<=22;p++) {
					if(j!=0) {
						(d[i][j][k][p]+=d[i-1][j-1][k][p]*a[i][1])%=P;
					}
					if(k!=0) {
						(d[i][j][k][p]+=d[i-1][j][k-1][p]*a[i][2])%=P;
					}
					if(p!=0) {
						(d[i][j][k][p]+=d[i-1][j][k][p-1]*a[i][3])%=P;
					}
					(d[i][j][k][p]+=d[i-1][j][k][p])%=P;
				}
				}
			}
		}
		ll ret=0;int tmp;
		for(int i=0;i<=22;i++) {
			for(int j=0;j<=22;j++) {
				for(int k=0;k<=22;k++) {
					if(i==0 && j==0 && k==0) continue;
					tmp=(i+j+k)/2;
					if(i>tmp || j>tmp || k>tmp) continue;
					(ret+=d[n][i][j][k])%=P;
				}
			}
		}
		return ret;
	}
};

int main() {
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	read(n);read(m);
	for(int i=1;i<=n;i++) {
		for(int j=1;j<=m;j++) {
			read(a[i][j]);
		}
	}
	if(m==2) {
		static sub1 s1;
		write(s1.acht());
		putchar('\n');
		return 0;
	}
	if(m==3) {
		static sub2 s2;
		write(s2.acht());
		putchar('\n');
		return 0;
	}
	return 0;
}
