#include<bits/stdc++.h>
#define maxn 2000001
using namespace std;

inline int read()
{
	int lin = 0;
	char x = getchar();
	while(x < '0' || x > '9') x = getchar();
	while(x >= '0' && x <= '9')
	{
		lin = (lin << 1) + (lin << 3) + x - '0';
		x = getchar();
	}
	return lin;
}

struct st{
	int u,v,nex,us;
}s[maxn];
int tot,head[maxn],n,u,v,yess[maxn];
void add(int u,int v)
{
	s[++tot] = (st) { u,v,head[u],1 };
	head[u] = tot;
}

int sz[maxn],fa[maxn],t2[maxn];

void dfs(int now,int fat)
{
	fa[now] = fat;
	sz[now] = 1;
	for(int i = head[now]; i; i = s[i].nex)
		if(s[i].v != fat && s[i].us)
		{
			dfs(s[i].v,now);
			sz[now] += sz[s[i].v];
		}
}

void get_root(int now,int fat,int tsize)
{
	bool check = 1;
	if(tsize - sz[now] > (int) ( tsize / 2 ) )
		check = 0;
	for(int i = head[now]; i; i = s[i].nex)
		if(s[i].v != fat && s[i].us)
		{
			get_root(s[i].v,now,tsize);
			if(sz[s[i].v] > (int) ( tsize / 2 ) )
				check = 0;
		}
	yess[now] = check;
}

int cut_edge(int num)
{
	s[num].us = s[num + 1].us = 0;
	int u = s[num].u;
	int v = s[num].v;
	dfs(u,u);
	dfs(v,v);
	get_root(u,u,sz[u]);
	get_root(v,v,sz[v]);
	s[num].us = s[num + 1].us = 1;
	int ans = 0;
	for(int i = 1; i <= n; i++)
		if(yess[i])
			ans += i;
	return ans;
}



void test1()
{
	int ans = 0;
	for(int i = 1; i <= tot; i += 2)
		ans += cut_edge(i);
	printf("%d\n",ans);	
}

int deg[maxn],pp[maxn],tt;

void dfss(int now,int fat)
{
	pp[++tt] = now;
	for(int i = head[now]; i; i = s[i].nex)
		if(s[i].v != fat)
			dfss(s[i].v,now);
}

int gett(int le,int re)
{
	int mid = le + re >> 1;
	int ans = pp[mid];
	if((le + re) & 1)
		ans += pp[mid + 1];
	return ans;
}

void test2()
{
	int root;
	tt = 0;
	for(int i = 1; i <= n; i++)
		if(deg[i] == 1)
		{
			root = i;
			break;
		}
	dfss(root,root);
	int ans = 0;
	for(int i = 1; i < n; i++)
	{
		ans += gett(1,i) + gett(i + 1,n);
	}
	printf("%d\n",ans);
}

void clearr()
{
	tot = 0;
	for(int i = 1; i <= 2 * n; i++)
	{
		head[i] = 0;
		deg[i] = 0;
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T = read();
	while(T--)
	{
		n = read();
		clearr();
		for(int i = 1; i < n; i++)
		{
			u = read(); v = read();
			++deg[u];
			++deg[v];
			add(u,v); add(v,u);
		}
		
		if(n <= 5000)
			test1();
		else
			test2();
	}
}
