#include<bits/stdc++.h>
using namespace std;
int head[1000010],cnt=0,in[1000010],ok;
int sz[1000010],dep[1000010],id[1000010];
vector<int> d[2];
struct node
{
	int to,next;
} a[1000010];
struct edge
{
	int x,y;
} h[1000010];
void add(int u,int v)
{
	a[++cnt].to=v;
	a[cnt].next=head[u];
	head[u]=cnt;
}
void dfs(int u,int fa,int k)
{
	d[k].push_back(u);
	for(int i=head[u]; i!=-1; i=a[i].next)
	{
		int v=a[i].to;
		if(v==fa) continue;
		dfs(v,u,k);
	}
}
void DFS(int u,int fa,int x,int y,int k)
{
	if(u==y&&fa==x||!ok) return;
	sz[u]=1;
	for(int i=head[u]; i!=-1; i=a[i].next)
	{
		int v=a[i].to;
		if(v==fa) continue;
		if(u==x&&v==y) continue;
		DFS(v,u,x,y,k);
		sz[u]+=sz[v];
		if(sz[v]>k) ok=0;
	}
}
void get_dep(int u,int fa)
{
	dep[u]=dep[fa]+1;
	id[dep[u]]=u;
	for(int i=head[u]; i!=-1; i=a[i].next)
	{
		int v=a[i].to;
		if(v==fa) continue;
		get_dep(v,u);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T,i,n,j,x,y;
	long long ans;
	scanf("%d",&T);
	while(T--)
	{
		ans=0;
		memset(in,0,sizeof(in));
		cnt=0;
		memset(head,-1,sizeof(head));
		scanf("%d",&n);
		for(i=1; i<n; i++)
		{
			scanf("%d%d",&x,&y);
			h[i].x=x,h[i].y=y;
			in[x]++,in[y]++;
			add(x,y),add(y,x);
		}
		if(n<=200)
		{
			for(i=1; i<n; i++)
			{
				d[1].clear(),d[0].clear();
				dfs(h[i].x,h[i].y,0),dfs(h[i].y,h[i].x,1);
				int s=0;
				for(j=0; j<d[0].size(); j++)
				{
					ok=1;
					DFS(d[0][j],0,h[i].x,h[i].y,d[0].size()/2);
					if(ok) ans+=d[0][j],s++;
					if(s>=2) break;
				}
				s=0;
				for(j=0; j<d[1].size(); j++)
				{
					ok=1;
					DFS(d[1][j],0,h[i].y,h[i].x,d[1].size()/2);
					if(ok) ans+=d[1][j],s++;
					if(s>=2) break;
				}
			}
		}
		else
		{
			for(i=1; i<=n; i++)
				if(in[i]==1)
				{
					get_dep(i,0);
					break;
				}
			for(i=1; i<n; i++)
				if(i%2) ans+=id[(i+1)/2];
				else ans+=id[i/2]+id[(i+2)/2];
			for(i=n; i>=1; i--)
				if(in[i]==1)
				{
					get_dep(i,0);
					break;
				}
			for(i=1; i<n; i++)
				if(i%2) ans+=id[(i+1)/2];
				else ans+=id[i/2]+id[(i+2)/2];
		}
		printf("%lld\n",ans);
	}
	return 0;
}
