#include<bits/stdc++.h>
using namespace std;

const int N = 300009;
int T, n, tot, Link[N << 1], a[2019][2019], flag1 = 1, deg[N], root;
long long ans;
struct edge{
	int Next, y;
}e[N << 1];

inline void add(int x, int y) {
	e[++ tot].Next = Link[x];
	Link[x] = tot;
	e[tot].y = y;
}

void init() {
	ans = tot = 0;
	flag1 = 1;
	memset(deg, 0, sizeof(deg));
	memset(Link, 0, sizeof(Link));
	memset(a, 0, sizeof(a));
	scanf("%d", &n);
	for (int i = 1; i < n; ++ i) {
		int x, y;
		scanf("%d%d", &x, &y);
		if (n < 2000) a[x][y] = a[y][x] = 1;
		++ deg[x], ++ deg[y];
		add(x, y);
		add(y, x);
	}
	for (int i = 1; i <= n; ++ i) if (deg[i] >= 3) flag1 = 0;
	else if (deg[i] == 1) root = i;
}

bool vis[N];
int sum, cnt1, cnt2;
void dfs1(int x) {
	vis[x] = 1;
	++ sum;
	for (int i = Link[x]; i; i = e[i].Next) {
		int y = e[i].y;
		if (!vis[y] && a[x][y]) dfs1(y);
	}
}

int size[N], cen[N];
void dfs2(int x, int pre, int num) {
	size[x] = 1;
	for (int i = Link[x]; i; i = e[i].Next) {
		int y = e[i].y;
		if (y == pre || !a[x][y]) continue;
		dfs2(y, x, num);
		size[x] += size[y];
		if (num && size[y] > cnt2 / 2) cen[x] = 1;
		if (!num && size[y] > cnt1 / 2) cen[x] = 1;
	}
	if (num == 0 && cnt1 - size[x] > cnt1 / 2) cen[x] = 1;
	else if (num && cnt2 - size[x] > cnt2 / 2) cen[x] = 1;
}

void solve() {
	for (int i = 1; i <= n; ++ i) {
		for (int j = Link[i]; j; j = e[j].Next) {
			int y = e[j].y;
			if (i > y) continue;
			a[i][y] = a[y][i] = sum = 0;
			memset(vis, 0, sizeof(vis));
			memset(size, 0, sizeof(size));
			memset(cen, 0, sizeof(cen));
			dfs1(i);
			cnt1 = sum;
			sum = 0;
			dfs1(y);
			cnt2 = sum;
			dfs2(i, 0, 0);
			dfs2(y, 0, 1);
			a[i][y] = a[y][i] = 1;
			for (int i = 1; i <= n; ++ i) 
				if (!cen[i]) ans += i;
		}
	}
}

int seq[N], now;
void dfs3(int x, int pre) {
	seq[++ now] = x;
	for (int i = Link[x]; i; i = e[i].Next) {
		int y = e[i].y;
		if (y == pre) continue;
		dfs3(y, x);
	}
}

void solve2() {
	now = 0;
	dfs3(root, 0);
	for (int i = 1; i < n; ++ i) {
		if (i & 1) 
			ans += seq[i + 1 >> 1];
		else 
			ans += seq[i >> 1] + seq[(i >> 1) + 1];
		if (n - i & 1)
			ans += seq[i + 1 + n >> 1];
		else
			ans += seq[i + n >> 1] + seq[(i + n >> 1) + 1];
	}
}

inline void outo() {
	printf("%lld\n", ans);
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
    scanf("%d",  &T);
    while(T --) {
    	init();
    	if (flag1) solve2();
    	else solve();
    	outo();
	}
	return 0;
}
