#include<bits/stdc++.h>
using namespace std;
const int MAX_N=5+3e5;
namespace IO{
	const int sz=1<<20;
	char a[sz+5],*p1=a,*p2=a;
	inline char gc(){
//		return getchar();
		return p1==p2?(p2=(p1=a)+fread(a,1,sz,stdin)
			,p1==p2?EOF:*p1++):*p1++;
	}
	template<class T> void gi(T& ret){
		ret=0; char c=gc(); int f=1;
		for(;c<'0'||c>'9';c=gc())
			if(c=='-') f=-1;
		for(;c>='0'&&c<='9';c=gc())
			ret=ret*10+(c-'0');
		ret*=f;
	}
}
using IO::gi;
struct Graph{
	struct Edge{ int to,nxt; }edge[MAX_N*2];
	int head[MAX_N],top;
	void clear(int n){memset(head,-1,sizeof(int)*(n+1)),top=-1; }
	inline void add(int x,int y){
		edge[++top]=(Edge){y,head[x]};
		head[x]=top;
	}
}G;
struct BIT{
	int c[MAX_N],top;
	void clear(int n){ top=n; memset(c,0,sizeof(int)*(top+1)); }
	inline void add(int x,int key){
		for(;x<=top;x+=x&-x) c[x]+=key;
	}
	inline int query(int x){
		int ret=0;
		for(;x;x-=x&-x) ret+=c[x];
		return ret;
	}
	inline int query(int x,int y){
		if(x>y) return 0; 
		x=max(x,1); y=min(y,top);
		if(x>y) return 0;
//		printf("|%d %d|\n",x,y);
		return query(y)-query(x-1); 
	}
}bit1,bit2,bit3;
long long ans1,ans2,ans3;
int sz[MAX_N],e[MAX_N],e2[MAX_N],n;
pair<int,int> hs[MAX_N][2];
struct Q{ int l,r,id; };
template<class T>struct Cont{
	int top; T a[2];
	inline T& operator[](int x){ return a[x]; }
	inline void clear(){ top=0; }
	inline void push_back(T x){ a[top++]=x; }
	inline int size(){ return top; }
};
Cont<Q> a[MAX_N];
void dfs1(int x,int pre){
	sz[x]=1; hs[x][0]=hs[x][1]=make_pair(0,0);
	for(int j=G.head[x];~j;j=G.edge[j].nxt){
		int y=G.edge[j].to;
		if(y!=pre){
			dfs1(y,x);
			pair<int,int> k=make_pair(sz[y],y);
			if(k>hs[x][0]) hs[x][1]=hs[x][0],hs[x][0]=k;
			else if(k>hs[x][1]) hs[x][1]=k;
			sz[x]+=sz[y];
		}
	}
	e[x]=hs[x][0].first; e2[x]=hs[x][1].first;
	int d=hs[x][0].first-hs[x][1].first;
	for(int j=G.head[x];~j;j=G.edge[j].nxt){
		int y=G.edge[j].to;
		if(y!=pre){
			if(y==hs[x][0].second){
				a[y].push_back((Q){2*e[x]-n,min(2*sz[x]-n,d),x});
				a[y].push_back((Q){d+1,min(n-2*e2[x],2*sz[x]-n),x});
			}else{
				a[y].push_back((Q){0,min(n-2*e[x],2*sz[x]-n),x});
			}
		}
	}
}
void dfs2(int x,int pre){
	for(int i=0;i<a[x].size();++i){
		ans3-=1ll*bit1.query(a[x][i].l,a[x][i].r)*a[x][i].id;
//		printf("(%d %d %d %d)",x,a[x][i].l,a[x][i].r,a[x][i].id);
	}
	ans1+=(0ll+bit3.query(n-2*sz[x],n-2*e[x])
		-bit2.query(n-2*sz[x],n-2*e[x])+bit1.query(n-2*sz[x],n-2*e[x]))*x;
	bit2.add(sz[x],1);
	ans2+=1ll*bit2.query(2*e[x],2*sz[x])*x;
	if(sz[1]>=2*e[x]&&sz[1]<=2*sz[x]) ans2-=x;
	bit1.add(sz[x],1);
	for(int j=G.head[x];~j;j=G.edge[j].nxt){
		int y=G.edge[j].to;
		if(y!=pre) dfs2(y,x);
	}
	bit2.add(sz[x],-1);
	for(int i=0;i<a[x].size();++i)
		ans3+=1ll*bit1.query(a[x][i].l,a[x][i].r)*a[x][i].id;
	ans1-=1ll*bit1.query(n-2*sz[x],n-2*e[x])*x;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T; gi(T);
	while(T--){
		gi(n); ans1=ans2=ans3=0; G.clear(n);
		bit1.clear(n); bit2.clear(n); bit3.clear(n);
		for(int i=1;i<=n;++i) a[i].clear();
		for(int i=1;i<n;++i){
			int x,y; gi(x); gi(y);
			G.add(x,y); G.add(y,x);
		}
		dfs1(1,0);
		for(int i=1;i<=n;++i) bit3.add(sz[i],1);
//		for(int i=1;i<=n;++i)
//			printf("[%d %d]",e[i],e2[i]);
		dfs2(1,0);
//		printf("{%lld %lld %lld}",ans1,ans2,ans3);
		printf("%lld\n",ans1+ans2+ans3);
	}
	return 0;
}
