#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
typedef pair<int,int> pii;
#define fir first
#define sec second
#define rep(i,a,b) for (int i = (a); i <= (b); ++ i)
#define rrp(i,a,b) for (int i = (a); i >= (b); -- i)
#define gc() getchar()
template <typename tp>
inline void read(tp& x) {
  x = 0; char tmp; bool key = 0;
  for (tmp = gc(); !isdigit(tmp); tmp = gc())
    key = (tmp == '-');
  for (; isdigit(tmp); tmp = gc())
    x = (x << 3) + (x << 1) + (tmp ^ '0');
  if (key) x = -x;
}
template <typename tp>
inline void ckmn(tp& x,tp y) {
  x = x < y ? x : y;
}
template <typename tp>
inline void ckmx(tp& x,tp y) {
  x = x < y ? y : x;
}

const int N = 300010;
struct edge {
  int la,b;
} con[N << 1];
int tot, fir[N];
void add_edge(int from,int to) {
  con[++tot] = (edge) {fir[from], to};
  fir[from] = tot;
}
int n;
int sz[N], fa[N], rec[N], dcnt;
pii res[N], cal[N];
void init() {
  tot = 0;
  memset(fir, 0, sizeof fir);
  memset(res, 0, sizeof res);
  memset(cal, 0, sizeof cal);
  dcnt = 0;
}
void dfs(int pos) {
  rec[pos] = ++ dcnt;
  sz[pos] = 1;
  int mx = 0;
  for (int i = fir[pos]; i; i = con[i].la) {
    if (con[i].b == fa[pos]) continue;
    fa[con[i].b] = pos;
    dfs(con[i].b);
    sz[pos] += sz[con[i].b];
    mx = max(mx, sz[con[i].b]);
  }
  if (mx <= sz[pos] / 2) res[pos].fir = pos;
  int tmp = 0;
  for (int i = fir[pos]; i; i = con[i].la) {
    if (con[i].b == fa[pos]) continue;
    if (sz[con[i].b] >= (sz[pos] + 1) / 2) {
      tmp = res[con[i].b].fir;
    }
  }
  if (tmp) {
    while (sz[pos] - sz[tmp] > sz[pos] / 2) tmp = fa[tmp];
    if (res[pos].fir != 0 && tmp != res[pos].fir) res[pos].sec = tmp;
    else res[pos].fir = tmp;
    while (sz[tmp] <= sz[pos] / 2) {
      tmp = fa[tmp];
      if (res[pos].fir != 0 && tmp != res[pos].fir) res[pos].sec = tmp;
      else res[pos].fir = tmp;
    }    
  }
}
int sta[N], top, dfn[N];
void move(int& x) {
  if (dfn[x]) x = sta[dfn[x] + 1];
  else x = fa[x];
}
int getsz(int x,int pos) {
  if (!x) return 0;
  if (x == fa[pos]) return n - sz[pos];
  else return sz[x];
}
bool check(int x,int cur) {
  if (!dfn[x])
    return (n - sz[x]) - (n-cur) <= cur / 2;
  else return sz[sta[dfn[x] + 1]] - (n-cur) <= cur / 2;
}
void fsd(int pos) {
  sta[dfn[pos] = ++ top] = pos;
  pii mx = pii(0, 0);
  mx.fir = fa[pos];
  for (int i = fir[pos]; i; i = con[i].la) {
    if (con[i].b == fa[pos]) continue;
    if (getsz(con[i].b, pos) > getsz(mx.fir, pos))
      mx.sec = mx.fir, mx.fir = con[i].b;
    else if (getsz(con[i].b, pos) > getsz(mx.sec, pos))
      mx.sec = con[i].b;
  }
  for (int i = fir[pos]; i; i = con[i].la) {
    if (con[i].b == fa[pos]) continue;
    int mxp = con[i].b == mx.fir ? mx.sec : mx.fir;
    if (getsz(mxp, pos) <= (n - sz[con[i].b]) / 2)
      cal[con[i].b].fir = pos;
    int tmp = (mxp == fa[pos] ? cal[pos].fir : res[mxp].fir);
    if (tmp) {
      while (!check(tmp, n - sz[con[i].b])) move(tmp);
      if (cal[con[i].b].fir != 0 && tmp != cal[con[i].b].fir)
	cal[con[i].b].sec = tmp;
      else cal[con[i].b].fir = tmp;
      int key = 0;
      if (dfn[tmp]) {
	if (sz[sta[dfn[tmp]+1]] - sz[con[i].b] >= (n - sz[con[i].b] + 1) / 2)
	  key = 1;
      } else if ((n - sz[tmp]) - sz[con[i].b] >= (n - sz[con[i].b] + 1) / 2)
	key = 1;
      if (key) {
	move(tmp);
	if (cal[con[i].b].fir != 0 && tmp != cal[con[i].b].fir)
	  cal[con[i].b].sec = tmp;
	else cal[con[i].b].fir = tmp;      
      }
    }
    fsd(con[i].b);
  }
  dfn[pos] = 0;
  -- top;
}
void solve() {
  init();
  read(n);
  int x,y;
  rep (i, 1, n-1) {
    read(x), read(y);
    add_edge(x, y);
    add_edge(y, x);
  }
  dfs(1);
  cal[1] = pii(0, 0);
  fsd(1);
  ll ans = 0;
  // rep (i, 1, n) {
  //   printf("%d:\n", i);
  //   printf(" %d %d\n", res[i].fir, res[i].sec);
  //   printf(" %d %d\n", cal[i].fir, cal[i].sec);    
  // }
  rep (i, 2, n) {
    ans += res[i].fir;
    ans += res[i].sec;
    ans += cal[i].fir;
    ans += cal[i].sec;
  }
  cout << ans << endl;
}
int main() {
  freopen("centroid.in","r",stdin);
  freopen("centroid.out","w",stdout);
  int T;
  read(T);
  while (T --)
    solve();
  return 0;
}
