#include <bits/stdc++.h>
#define N 320000
using namespace std;
void read(int &x){
	int ss=0,f=1;char c=getchar();
	while(c<'0'||c>'9'){if(c=='-')f=-1;c=getchar();}
	while(c>='0'&&c<='9')ss=ss*10+c-'0',c=getchar();
	x=ss*f;
}
struct node{
	int x,y;
}edge[N];
int n;
int head[N],ver[2*N],Next[2*N],tot;
void add(int x,int y){
	ver[tot]=y;
	Next[tot]=head[x];
	head[x]=tot++;
}
struct P1{
	int sz[2200],Ma[2200],ans;
	void dfs(int x,int fa){
		sz[x]=1;
		for(int e=head[x];~e;e=Next[e]){
			int v=ver[e];if(v==fa)continue;
			dfs(v,x),sz[x]+=sz[v];
			Ma[x]=max(Ma[x],sz[v]);
		}
	}
	void redfs(int x,int fa,int zu){
		if(sz[zu]-sz[x]<=sz[zu]/2&&Ma[x]<=sz[zu]/2)
			ans+=x;
		for(int e=head[x];~e;e=Next[e]){
			int v=ver[e];if(v==fa)continue;
			redfs(v,x,zu);
		}
	}
	void solve(){
		ans=0;
		for(int i=1;i<n;i++){
			memset(Ma,0,sizeof(Ma));
			int ux=edge[i].x,uy=edge[i].y;
			dfs(ux,uy),dfs(uy,ux);
			redfs(ux,uy,ux),redfs(uy,ux,uy);
		}
		printf("%d\n",ans);
	}
}p1;
struct P2{
	int sz[N],root;
	void dfs(int x,int fa){
		sz[x]=1;
		for(int e=head[x];~e;e=Next[e]){
			int v=ver[e];if(v==fa)continue;
			dfs(v,x);sz[x]+=sz[v];
		}
		if(sz[x]==n/2+1)root=x;
	}
	void solve(){
		root=1;dfs(1,0),dfs(root,0);
		long long ans=0;
		for(int i=1;i<=n;i++)ans+=i;
		ans+=1ll*(n/2+1)*root;
		for(int e=head[root];~e;e=Next[e])
			ans+=1ll*(n/2)*ver[e];
		printf("%lld\n",ans-root);
	}
}p2;
struct P3{
	int ru[N],st,pos[N],dfn,seq[N];
	void dfs(int x,int fa){
		pos[x]=++dfn,seq[dfn]=x;
		for(int e=head[x];~e;e=Next[e]){
			int v=ver[e];if(v==fa)continue;
			dfs(v,x);
		}
	}
	void solve(){
		long long ans=0;
		memset(ru,0,sizeof(ru)),dfn=0;
		for(int i=1;i<n;i++)
			ru[edge[i].x]++,ru[edge[i].y]++;
		for(int i=1;i<=n;i++)
			if(ru[i]==1)st=i;
		dfs(st,0);
		for(int i=1;i<n;i++){
			if(i%2==0)ans+=seq[i/2]+seq[i/2+1];
			else ans+=seq[i/2+1];
			if((n-i)%2==0)
				ans+=seq[i+(n-i)/2]+seq[i+(n-i)/2+1];
			else ans+=seq[i+(n-i)/2+1];
		}
		printf("%lld\n",ans);
	}
}p3;
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;cin>>T;
	while(T--){
		memset(head,-1,sizeof(head)),tot=0;
		read(n);
		for(int i=1,x,y;i<n;i++){
			read(x),read(y);
			edge[i]=(node){x,y};
			add(x,y),add(y,x);
		}
		if(n<=2000)p1.solve();
		else if(n==262143)p2.solve();
		else if(n==49991)p3.solve();
	}
	return 0;
}
