/*
 * Problem "meal" answered by KingOfWA(ZJ-00047)
 * v1.0 O(m^n)
 * v1.1
 *   Trying to be faster
 */


#include<iostream>
#include<cstdio>
using namespace std;

const int N = 100, M = 2000, MOD = 998244353;
int a[N + 10][M + 10];
int b[M + 10]; //主要食材
int n, m, k, ans;

void Solve(int x, int s, int nowAns){
    if(nowAns == 0) return;
    if(x > n){
        if(s > 1){
            int t = s / 2;
            for(int i = 1; i <= m; ++i){
                if(b[i] > t) return;
            }
            ans = ((long long) ans + nowAns) % MOD;
        }
        return;
    }
    Solve(x + 1, s, nowAns);
    for(int i = 1; i <= m; ++i){
        if(b[i] < n / 2){
            ++b[i];
            Solve(x + 1, s + 1, ((long long)nowAns * a[x][i]) % MOD );
            --b[i];
        }
    }
}

int main(){
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    scanf("%d%d", &n, &m);
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= m; ++j){
            scanf("%d", &a[i][j]);
        }
    }
    ans = 0;
    Solve(1, 0, 1);
    printf("%d\n", ans);
    return 0;
}
