#include<bits/stdc++.h>
#define FOR(i, x, y) for(int i = (x), i##END = (y); i <= i##END; ++i)
#define DOR(i, x, y) for(int i = (x), i##END = (y); i >= i##END; --i)
template<typename T, typename _T> inline bool chk_min(T &x, const _T y) {return y < x ? x = y, 1 : 0;}
template<typename T, typename _T> inline bool chk_max(T &x, const _T y) {return x < y ? x = y, 1 : 0;}
typedef long long ll;
const int N = 3e5 + 5;
template<const int N, const int M, typename T> struct Linked_List
{
	int head[N], nxt[M], tot; T to[M];
	Linked_List() {clear();}
	T &operator [] (const int x) {return to[x];}
	void clear() {memset(head, -1, sizeof(head)), tot = 0;}
	void add(int u, T v) {to[tot] = v, nxt[tot] = head[u], head[u] = tot++;}
	#define EOR(i, G, u) for(int i = G.head[u]; ~i; i = G.nxt[i])
};
Linked_List<N, N << 1, int> G;
int deg[N];
int n;

namespace Subtask1
{
	int sz[N];
	int rt, ff, id1, val1, id2, val2;

	void dfs(int u, int f)
	{
		sz[u] = 1;
		EOR(i, G, u)
		{
			int v = G[i];
			if(v == f) continue;
			dfs(v, u);
			sz[u] += sz[v];
		}
	}

	int calc(int u)
	{
		int tot = n - sz[u];
		if(ff == id1)
		{
			if(val1 - sz[u] > tot / 2) return 0;
			else if(id2 && val2 > tot / 2) return 0;
			else return 1;
		}
		else
		{
			if(val1 > tot / 2) return 0;
			else return 1;
		}
	}

	int redfs(int u, int f)
	{
		int res = calc(u);

		EOR(i, G, u)
		{
			int v = G[i];
			if(v == f) continue;
			res += redfs(v, u);
		}
		return res;
	}

	void Solve()
	{
		ll ans = 0;
		FOR(u, 1, n)
		{
			dfs(u, 0);
			rt = u, id1 = val1 = id2 = val2 = 0;
			EOR(i, G, u)
			{
				int v = G[i];
				if(sz[v] > val1)
				{
					id2 = id1, val2 = val1;
					id1 = v, val1 = sz[v];
				}
				else if(sz[v] > val2)
					id2 = v, val2 = sz[v];
			}
			int res = 0;
			EOR(i, G, u) ff = G[i], res += redfs(G[i], u);
			ans += 1ll * res * u;
		}
		printf("%lld\n", ans);
	}
};

namespace Subtask2
{
	int lfn[N], ori[N], dfn_idx;

	void dfs(int u, int f)
	{
		ori[lfn[u] = ++dfn_idx] = u;
		EOR(i, G, u)
		{
			int v = G[i];
			if(v == f) continue;
			dfs(v, u);
		}
	}
	
	void Solve()
	{
		dfn_idx = 0;
		FOR(i, 1, n) if(deg[i] == 1)
		{
			dfs(i, 0);
			break;
		}
		ll ans = 0;
		FOR(i, 1, n)
		{
			int u = ori[i];
			int l = i - 1, r = n - i;
			if(l == 0 || r == 0 || abs(l - r) <= 1) ans += u * 2;
			else ans += u * 3;
		}
		printf("%lld\n", ans);
	}
};

namespace Subtask3
{
	int sz[N];
	int rt, ff, id1, val1, id2, val2;
	ll ans;

	void dfs(int u, int f)
	{
		sz[u] = 1;
		EOR(i, G, u)
		{
			int v = G[i];
			if(v == f) continue;
			dfs(v, u);
			sz[u] += sz[v];
		}
	}

	int calc(int u)
	{
		int tot = n - sz[u];
		if(ff == id1)
		{
			if(val1 - sz[u] > tot / 2) return 0;
			else if(id2 && val2 > tot / 2) return 0;
			else return 1;
		}
		else
		{
			if(val1 > tot / 2) return 0;
			else return 1;
		}
	}

	int redfs(int u, int f)
	{
		int tot = n - sz[u], res;
		if(ff == id1)
		{
			if(val1 - sz[u] > tot / 2) return 0;
			else if(id2 && val2 > tot / 2) res = 0;
			else res = 1;
		}
		else
		{
			if(val1 > tot / 2) res = 0;
			else return sz[u];
		}

		EOR(i, G, u)
		{
			int v = G[i];
			if(v == f) continue;
			res += redfs(v, u);
		}
		return res;
	}

	void DFS(int u, int f)
	{
		rt = u, id1 = val1 = id2 = val2 = 0;
		EOR(i, G, u)
		{
			int v = G[i];
			if(sz[v] > val1)
			{
				id2 = id1, val2 = val1;
				id1 = v, val1 = sz[v];
			}
			else if(sz[v] > val2)
				id2 = v, val2 = sz[v];
		}
		int res = 0;
		EOR(i, G, u) ff = G[i], res += redfs(G[i], u);
		ans += 1ll * res * u;
		
		EOR(i, G, u)
		{
			int v = G[i];
			if(v == f) continue;
			sz[u] -= sz[v];
			sz[v] += sz[u];
			DFS(v, u);
			sz[v] -= sz[u];
			sz[u] += sz[v];
		}
	}

	void Solve()
	{
		ans = 0;
		dfs(1, 0);
		DFS(1, 0);
		printf("%lld\n", ans);
	}
};

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while(T--)
	{
		scanf("%d", &n);

		bool flg1 = 1;
		G.tot = 0;
		FOR(i, 1, n) G.head[i] = -1, deg[i] = 0;

		FOR(i, 1, n - 1)
		{
			int u, v;
			scanf("%d%d", &u, &v);
			G.add(u, v), G.add(v, u);
			deg[u]++, deg[v]++;
		}
		if(n <= 2000) {Subtask1::Solve(); continue;}
		FOR(i, 1, n) if(deg[i] > 2) flg1 = 0;
		if(flg1) {Subtask2::Solve(); continue;}
		Subtask3::Solve();
	}
	return 0;
}
