#include<bits/stdc++.h>
#define FOR(i, x, y) for(int i = (x), i##END = (y); i <= i##END; ++i)
#define DOR(i, x, y) for(int i = (x), i##END = (y); i >= i##END; --i)
template<typename T, typename _T> inline bool chk_min(T &x, const _T y) {return y < x ? x = y, 1 : 0;}
template<typename T, typename _T> inline bool chk_max(T &x, const _T y) {return x < y ? x = y, 1 : 0;}
typedef long long ll;
const int P = 998244353;
const int N = 105;
const int M = 2005;
int a[N][M];
int n, m;

namespace Subtask1
{
	int cnt[M];
	int ans;

	void dfs(int i, int tot, int ml)
	{
		if(i > n)
		{
			if(tot == 0) return;
			FOR(j, 1, m) if(cnt[j] > (tot / 2)) return;
			(ans += ml) %= P;
			return;
		}
		dfs(i + 1, tot, ml);
		FOR(j, 1, m) if(a[i][j])
		{
			cnt[j]++;
			dfs(i + 1, tot + 1, 1ll * ml * a[i][j] % P);
			cnt[j]--;
		}
	}

	void Solve()
	{
		FOR(i, 1, n) FOR(j, 1, m) scanf("%d", &a[i][j]);
		dfs(1, 0, 1);
		printf("%d\n", ans);
	}
};

namespace Subtask2
{
	int dp[N][2 * N];
	int sum[N];
	int ans;
	#define dp(i, j) dp[i][(j) + N]

	inline void plseq(int &x, int y) {(x += y) >= P ? x -= P : x;}
	inline void mnseq(int &x, int y) {(x -= y) < 0 ? x += P : x;}
	inline int mns(int x, int y) {x -= y; return x < 0 ? x + P : x;}

	void Solve()
	{
		FOR(i, 1, n) FOR(j, 1, m) scanf("%d", &a[i][j]);

		ans = 1;
		FOR(i, 1, n)
		{
			FOR(j, 1, m) plseq(sum[i], a[i][j]);
			ans = 1ll * ans * (sum[i] + 1) % P;
		}
		ans = (ans + P - 1) % P;


		FOR(x, 1, m)
		{
			FOR(i, 0, n) FOR(j, -n, n) dp(i, j) = 0;
			dp(0, 0) = 1;
			FOR(i, 0, n - 1) FOR(j, -n, n) if(dp(i, j))
			{
				plseq(dp(i + 1, j + 1), 1ll * dp(i, j) * a[i + 1][x] % P);
				plseq(dp(i + 1, j - 1), 1ll * dp(i, j) * mns(sum[i + 1], a[i + 1][x]) % P);
				plseq(dp(i + 1, j), dp(i, j));
			}
			FOR(i, 1, n) mnseq(ans, dp(n, i));
		}

		printf("%d\n", ans);
	}
};

int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	/*if(n <= 10 && m <= 3) Subtask1::Solve();
	else */Subtask2::Solve();
	return 0;
}
