#include<bits/stdc++.h>
#define FOR(i, x, y) for(int i = (x), i##END = (y); i <= i##END; ++i)
#define DOR(i, x, y) for(int i = (x), i##END = (y); i >= i##END; --i)
template<typename T, typename _T> inline bool chk_min(T &x, const _T y) {return y < x ? x = y, 1 : 0;}
template<typename T, typename _T> inline bool chk_max(T &x, const _T y) {return x < y ? x = y, 1 : 0;}
typedef long long ll;
int n;

namespace Subtask1
{
	const int N = 405;

	int a[N]; ll s[N];
	ll dp[N][N];

	void Solve()
	{
		FOR(i, 1, n) scanf("%d", &a[i]), s[i] = s[i - 1] + a[i];
		FOR(i, 0, n) FOR(j, 0, n) dp[i][j] = 4.2e18;
		FOR(i, 1, n)
		{
			dp[i][0] = s[i] * s[i];
			FOR(j, 1, i - 1)
			{
				FOR(k, 0, j - 1)
					if((s[j] - s[k]) <= (s[i] - s[j]))
						chk_min(dp[i][j], dp[j][k] + (s[i] - s[j]) * (s[i] - s[j]));
			}
		}
		ll ans = 4.2e18;
		FOR(i, 0, n) chk_min(ans, dp[n][i]);
		printf("%lld\n", ans);
	}
};

namespace Subtask2
{
	const int N = 5005;

	int a[N]; ll s[N];
	ll dp[N][N], mi[N][N];

	void Solve()
	{
		FOR(i, 1, n) scanf("%d", &a[i]), s[i] = s[i - 1] + a[i];
		FOR(i, 0, n) FOR(j, 0, n) dp[i][j] = 4.2e18;
		FOR(i, 1, n)
		{
			dp[i][0] = s[i] * s[i];
			int k = 0;
			FOR(j, 1, i - 1)
			{
				while(k + 1 <= j && s[k] < 2 * s[j] - s[i]) k++;
				chk_min(dp[i][j], mi[j][k] + (s[i] - s[j]) * (s[i] - s[j]));
			}

			mi[i][i] = 4.2e18;
			DOR(j, i - 1, 0) mi[i][j] = std::min(mi[i][j + 1], dp[i][j]);
		}
		ll ans = 4.2e18;
		FOR(i, 0, n) chk_min(ans, dp[n][i]);
		printf("%lld\n", ans);
	}
};

int main()
{
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	int knd;
	scanf("%d%d", &n, &knd);
	if(n <= 400) Subtask1::Solve();
	else Subtask2::Solve();
	return 0;
}
