#include <bits/stdc++.h>

#define rep(i, a, b) for(int i(a), i##_END_(b); i <= i##_END_; i++)
#define drep(i, a, b) for(int i(a), i##_END_(b); i >= i##_END_; i--)

#define File(_) freopen(#_".in", "r", stdin), freopen(#_".out", "w", stdout)

template<class T> inline bool tomax(T &a, T b) {return a < b ? a = b, 1 : 0;}
template<class T> inline bool tomin(T &a, T b) {return b < a ? a = b, 1 : 0;}

typedef long long ll;
typedef double db;

template<int N, int M, class T> struct Link {
#define erep(k, G, o) for(int k(G.HEAD[o]); k; k = G.NXT[k])
	int HEAD[N], NXT[M], tot; T W[M];
	void clear() {memset(HEAD, 0, sizeof HEAD); tot = 0;}
	void add(int x, T w) {NXT[++tot] = HEAD[x]; W[HEAD[x] = tot] = w;}
	T& operator[] (int k) {return W[k];}
};

const int N = 299995 + 5;
Link<N, N * 2, int> G;

bool cur1;

int n;
namespace PBL {
	bool check() {
		return n <= 1999;
	}
	int rev(int a) {
		return ((a - 1) ^ 1) + 1;
	}
	int ban;
	int sz[N], fa[N], mx[N], tsz[N];
	void dfs_init(int o, int f) {
		sz[o] = 1; fa[o] = f;
		erep(k, G, o) {
			int v = G[k];
			if(v == f) continue;
			dfs_init(v, o);
			sz[o] += sz[v];
		}
	}
	ll ans;
	void dfs_mx(int o, int f, int all) {
		mx[o] = 0; tsz[o] = 1;
		erep(k, G, o) {
			int v = G[k];
			if(v == f) continue;
			dfs_mx(v, o, all);
			tomax(mx[o], tsz[v]);
			tsz[o] += tsz[v];
		}
		tomax(mx[o], all - tsz[o]);
		if(mx[o] <= all / 2) ans += o;
	}
	int main() {
		dfs_init(1, 0);
		ans = 0;
		rep(i, 2, n) {
			dfs_mx(i, fa[i], sz[i]);
			dfs_mx(fa[i], i, n - sz[i]);
		}
		printf("%lld\n", ans);
		return 0;
	}
}

namespace PLink {
	bool check() {
		rep(i, 1, n) {
			int c = 0;
			erep(k, G, i) c++;
			if(c > 2) return false;
		}
		return true;
	}
	int vec[N], tot;
	void dfs_vec(int o, int f) {
		vec[++tot] = o;
		erep(k, G, o) {
			int v = G[k];
			if(v == f) continue;
			dfs_vec(v, o);
		}
	}
	int main() {
		rep(i, 1, n) {
			int c = 0;
			erep(k, G, i) c++;
			if(c == 1) {
				tot = 0;
				dfs_vec(i, 0);
				break;
			}
		}
		ll ans = 0;
		rep(i, 1, tot - 1) {
			if(i & 1) ans += vec[(i + 1) >> 1];
			else ans += vec[i >> 1] + vec[(i >> 1) + 1];
			if((tot - i) & 1) ans += vec[tot - ((tot - i) >> 1)];
			else ans += vec[tot - ((tot - i) >> 1)] + vec[tot - ((tot - i) >> 1) + 1];
		}
		printf("%lld\n", ans);
		return 0;
	}
}

namespace P2C {
	bool check() {
		return n == 262143;
	}
	int sz[N], dfn[N], en[N];
	void dfs_sz(int o, int f) {
		static int cur = 0;
		if(f == 0) cur = 0;
		dfn[o] = ++cur;
		sz[o] = 1;
		erep(k, G, o) {
			int v = G[k];
			if(v == f) continue;
			dfs_sz(v, o);
			sz[o] += sz[v];
		}
		en[o] = cur;
	}
	int main() {
		int rt;
		rep(i, 1, n) {
			int c = 0;
			erep(k, G, i) c++;
			if(c == 2) rt = i;
		}
		dfs_sz(rt, 0);
		ll ans = 0;
		rep(i, 1, n) if(i != rt) {
			ans += i;
			erep(k, G, rt) {
				int v = G[k];
				if(dfn[v] <= dfn[i] && dfn[i] <= en[v]) continue;
				ans += v;
			}
		}
		printf("%lld\n", ans);
		return 0;
	}
}

bool cur2;

int main() {
	File(centroid);
	int cas, a, b;
	scanf("%d", &cas);
	while(cas--) {
		scanf("%d", &n);
		G.clear();
		rep(_, 1, n - 1) {
			scanf("%d%d", &a, &b);
			G.add(a, b); G.add(b, a);
		}
		if(PLink::check()) {PLink::main(); continue;}
		// if(P2C::check()) {P2C::main(); continue;}
		if(PBL::check() || true) {PBL::main(); continue;}
	}
	return 0;
}
