// C++ includes used for precompiling -*- C++ -*-

// Copyright (C) 2003-2013 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.

// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
// <http://www.gnu.org/licenses/>.

/** @file stdc++.h
 *  This is an implementation file for a precompiled header.
 */

// 17.4.1.2 Headers

// C
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif
typedef long long ll;
const ll mod=998244353;
//#define debug
#ifdef debug
#define s_u_m 1
#else
#define s_u_m 0
#endif
#define she_(x) \
for(ll error_##x=0;(error_##x<s_u_m)&&(puts("error"#x":"),1);++error_##x)
#define she(x) she_(x)
ll readll() {
	ll x=0,w=1;
	char c=getchar();
	for(;'0'>c||'9'<c;(c^'-')||(w=-w),c=getchar());
	for(;'0'<=c&&'9'>=c;x=(x<<1)+(x<<3)+(c^48),c=getchar());
	return x*w;
}
#define IO(x) \
freopen(#x".in","r",stdin);\
freopen(#x".out","w",stdout);
ll n,m,a[111][1111],f[111],s[111],ans,t[1111];
void dffs(ll c,ll k) {
	if(c>n) {
//		ll zs=s[1],sm=1;
//		for(ll i=2;i<=n;i++) 
//		if(s[i]){
//			if(s[i]==zs) {
//				sm++;
//			}
//			else {
//				sm--;
//				if(sm<0) {
//					zs=s[i],sm=1;
//				}
//			}
//		}
		for(ll i=1;i<=m;i++) {
			t[i]=0;
		}
		ll p=0;
		for(ll i=1;i<=n;i++) 
		if(s[i]){
			p=std::max(p,++t[s[i]]);
		}
//		ll p=0;
//		for(ll i=1;i<=n;i++)p+=(s[i]==zs);
//		she(_0) {
//			for(ll i=1;i<=n;i++) {
//				printf("%lld ",s[i]);
//			}
//			puts("");
//		}
		if((p<<1)>k) {
			she(_1) {
				for(ll i=1;i<=n;i++) {
					printf("%lld ",s[i]);
				}
				printf("\n%lld\n",-1);
			}
			return;
		}
		ll sum=1;
		for(ll i=1;i<=n;i++) 
		if(s[i]){
			sum*=a[i][s[i]];
			sum%=mod;
		}
		ans+=sum;
		ans%=mod;
		she(_0) {
			for(ll i=1;i<=n;i++) {
				printf("%lld ",s[i]);
			}
			printf("\n%lld\n",sum);
		}
		return;
	}
	for(ll i=0;i<=m;i++) {
		s[c]=i;
		dffs(c+1,k+!!i);
	}
}
int main() {
	IO(meal);
	n=readll(),m=readll();
	for(ll i=1;i<=n;i++) {
		for(ll j=1;j<=m;j++) {
			a[i][j]=readll();
			f[i]+=a[i][j];
		}
	}
//	if(n<=5) {
//		for(ll i=0;i<(1<<n);i++) {
//			ll k=0,ans=1;
//			for(ll j=0;j<n;j++) {
//				if(i&(1<<j)) {
//					ans*=f[j];
//					k++;
//				}
//			}
//			for(ll j=0;j<m;j++) {
//				for(ll k=0;k<(1<<n);k++) {
//					if((i|k)==i) {
//						ll s=i^k;
//						for(ll c=0;c<n;c++) {
//							ans-=
//						}
//					}
//				}
//			}
//		}
//	}
	if(n<=10) {
		dffs(1,0);
		printf("%lld",(ans+mod-1)%mod);
		//O(m^n*(n+m))
	}
	return 0;
}
