#include <bits/stdc++.h>
#define maxn 300010
#define LL long long
using namespace std;
struct Edge{
	int to, next;
}edge[maxn << 1];
struct Line{
	int x, y;
}line[maxn];
int num, head[maxn], size[maxn], cntsize, n, a[maxn], deg[maxn];
LL ans;

inline int read(){
	int s = 0, w = 1;
	char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') w = -1;
	for (; isdigit(c); c = getchar()) s = (s << 1) + (s << 3) + (c ^ 48);
	return s * w;
}

void addedge(int x, int y){ edge[++num] = (Edge){y, head[x]}, head[x] = num; }

void dfs(int u, int pre){
	size[u] = 1;
	for (int i = head[u]; i; i = edge[i].next){
		int v = edge[i].to;
		if (v != pre) dfs(v, u), size[u] += size[v];
	}
}

void find(int u, int pre){
	int flag = 1, sum = 0;
	for (int i = head[u]; i; i = edge[i].next){
		int v = edge[i].to;
		if (v != pre){
			find(v, u), sum += size[v];
			if (size[v] > (cntsize >> 1)) flag = 0;
		}
	}
	if (flag && (cntsize - sum - 1) <= (cntsize >> 1)) ans += u;
}

void baoli(){
	for (int i = 1; i < n; ++i){
		dfs(line[i].x, line[i].y);
		cntsize = size[line[i].x];
		find(line[i].x, line[i].y);
		dfs(line[i].y, line[i].x);
		cntsize = size[line[i].y];
		find(line[i].y, line[i].x);
	}
	printf("%lld\n", ans);
}

void dolian(){
	int u = 1;
	while (deg[u] != 1) ++u;
	int m = 0, lst = 0;
	while (1){
		a[++m] = u;
		if (m >= n) break;
		for (int i = head[u]; i; i = edge[i].next){
			int v = edge[i].to;
			if (v != lst){ lst = u, u = v; break; }
		}
	}
//	for (int i = 1; i <= m; ++i) printf("%d ", a[i]);
	for (int i = 1; i < n; ++i){
		ans += a[(i >> 1) + 1];
		if (!(i & 1)) ans += a[i >> 1];
		ans += a[i + ((n - i) >> 1) + 1];
		if (!((n - i) & 1)) ans += a[i + ((n - i) >> 1)];
	}
	printf("%lld\n", ans);
}

void wanquan(){
	int u = 1;
	while (deg[u] != 2 && u < n) ++u;
	LL s = u;
	for (int i = head[u]; i; i = edge[i].next) s += edge[i].to;
	ans = 1LL * n * (n + 1) / 2 + (n >> 1) * s;
	printf("%lld\n", ans);
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T = read();
	while (T--){
		num = 0;
		memset(head, 0, sizeof(head));
		memset(deg, 0, sizeof(deg));
		n = read();
		for (int i = 1; i < n; ++i){
			int x = read(), y = read();
			addedge(x, y), addedge(y, x);
			line[i].x = x, line[i].y = y;
			++deg[x], ++deg[y];
		}
		int lian = 1;
		for (int i = 1; i <= n; ++i)
			lian &= (deg[i] <= 2);
		ans = 0;
		if (lian) dolian(); else
		if (n <= 2000) baoli(); else wanquan();
	}
	return 0;
}
