#include<bits/stdc++.h>
using namespace std;

#define FOR(i,s,t) for(int i=(s),_t=(t); i<=_t; ++i)
#define DOR(i,s,t) for(int i=(s),_t=(t); i>=_t; --i)
#define EOR(i,x) for(int i=Head[x]; ~i; i=Nxt[i])

typedef long long ll;

const int M=(int)4e5+50;

bool ppp;

void chkmx(int &x,int y) {
	if(x<y) x=y;
}

int n;

namespace ST {
	#define ls Tr[p][0]
	#define rs Tr[p][1]
	#define lson L,mid,ls
	#define rson mid+1,R,rs
	int Tr[M*32][2],tot;
	ll sum[M*32];
	void clear() {
		tot=0;
	}
	void build(int L,int R,int &p) {
		p=++tot;
		sum[p]=0;
		if(L==R) return ;
		int mid=L+R>>1;
		build(lson);
		build(rson);
	}
	void Update(int L,int R,int &p,int l,int r,int a) {
		int q=p;p=++tot;
		sum[p]=sum[q];
		ls=Tr[q][0];
		rs=Tr[q][1];
		if(L==l && R==r) {
			sum[p]+=a;
			return ;
		}
		int mid=L+R>>1;
		if(r<=mid) Update(lson,l,r,a);
		else if(l>mid) Update(rson,l,r,a);
		else {
			Update(lson,l,mid,a);
			Update(rson,mid+1,r,a);
		}
	}
	ll Query(int L,int R,int p,int x) {
		if(L==R) return sum[p];
		int mid=L+R>>1;
		if(x<=mid) return  sum[p]+Query(lson,x);
		else return sum[p]+Query(rson,x);
	}
}
int Head[M],E[M<<1],Nxt[M<<1],tol;
void Edge(int x,int y) {
	E[tol]=y;Nxt[tol]=Head[x];Head[x]=tol++;
}
int SZ[M],mx[M];
void dfs_sz(int x,int fr) {
	SZ[x]=1;mx[x]=0;
	EOR(i,x) if(E[i]!=fr) {
		dfs_sz(E[i],x);
		SZ[x]+=SZ[E[i]];
		chkmx(mx[x],SZ[E[i]]);
	}
}
int dfs1(int x,int fr,int lim) {
	int t=0;
	if(SZ[x]<=lim) t=1;
	EOR(i,x) if(E[i]!=fr) {
		t+=dfs1(E[i],x,lim);
	}
	return t;
}
int Solve(int rt) {
	dfs_sz(rt,0);
	int p1=0;
	EOR(i,rt) if(SZ[E[i]]==mx[rt]) p1=E[i];
	if(!p1) return 0;
	int tmp=0,mx2=0;
	EOR(i,rt) if(E[i]!=p1) {
		chkmx(mx2,SZ[E[i]]);
		tmp+=dfs1(E[i],rt,n-mx[rt]*2);
	}
	tmp+=dfs1(p1,rt,n-mx2*2);
	return tmp;
}
int lp[M],rp[M];
int Lt[M],Rt[M],Pos[M];
int root[M];
ll res;
int tid;
int rt1,rt2;
int prt;
void in_dfs(int x,int fr) {
	Lt[x]=++tid;Pos[tid]=x;
	EOR(i,x) if(E[i]!=fr) in_dfs(E[i],x);
	Rt[x]=tid;
}
void dfs(int x,int fr) {
	if(fr) {
		ll t1=ST :: Query(0,n,root[Lt[x]-1],SZ[x])+ST :: Query(0,n,root[n],SZ[x])
			-ST :: Query(0,n,root[Rt[x]],SZ[x]);
//		if(x==1) cerr << t1 << endl;
		t1=t1-ST :: Query(0,n,prt,SZ[x]);
		t1+=ST :: Query(0,n,root[Rt[x]],n-SZ[x])
			-ST :: Query(0,n,root[Lt[x]-1],n-SZ[x]);
//		cerr << x << ": " << t1 << endl;
		res+=t1;
	}
	if(x!=rt1 && x!=rt2) {
		ST :: Update(0,n,prt,lp[x],rp[x],x);
	}
	EOR(i,x) if(E[i]!=fr) dfs(E[i],x);
	if(x!=rt1 && x!=rt2) {
		ST :: Update(0,n,prt,lp[x],rp[x],-x);
	}
}
bool qqq;

int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	for(scanf("%d",&T); T; --T) {
		tol=0;
		memset(Head,-1,sizeof(Head));
		scanf("%d",&n);
		FOR(i,2,n) {
			int x,y;
			scanf("%d%d",&x,&y);
			Edge(x,y);
			Edge(y,x);
		}
		dfs_sz(1,0);
		rt1=0,rt2=0;
		FOR(i,1,n) {
			if(mx[i]<=n/2 && n-SZ[i]<=n/2) {
				if(rt1==0) rt1=i;
				else rt2=i;
			}
		}
		res=1ll*rt1*Solve(rt1);
		if(rt2) res+=1ll*rt2*Solve(rt2);
		dfs_sz(rt1,0);
		FOR(i,1,n) {
			lp[i]=n-2*SZ[i];
			rp[i]=n-2*mx[i];
//			cerr << i << " " << lp[i] << " " << rp[i] << endl;
		}
		ST :: clear();
		tid=0;
		in_dfs(rt1,0);
		ST :: build(0,n,root[1]);
		FOR(i,2,n) {
			root[i]=root[i-1];
			if(Pos[i]!=rt2) {
				ST :: Update(0,n,root[i],lp[Pos[i]],rp[Pos[i]],Pos[i]);
			}
		}
		ST :: build(0,n,prt);
		dfs(rt1,0);
		printf("%lld\n",res);
	}
	return 0;
}
