#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
typedef long long LL;

const int N = 5e5 + 10;

int n, a[N], Tp;
LL f[N], sum[N], ans, b[N];
int que[N], l, r;

template<typename T> T Min(T x, T y) {
	return x > y ? y : x;
}

inline LL Pow(LL x) {
	return x * x;
}


int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &Tp);
	for (int i = 1; i <= n; ++i) {
		scanf("%d", &a[i]);
		sum[i] = sum[i - 1] + a[i];
	}
	l = 1, r = 1;
	for (int i = 1; i <= n; ++i) {
		while (l < r && b[que[l + 1]] + sum[que[l + 1]] <= sum[i])
			l++;
		int j = que[l];
//		printf("%d ", j);
		f[i] = f[j] + Pow(sum[i] - sum[j]);
		b[i] = sum[i] - sum[j];
		
		while (l <= r && b[que[r]] + sum[que[r]] >= b[i] + sum[i])
			r--;
		que[++r] = i;	
	}	
//	puts("");
	printf("%lld\n", f[n]);
	return 0;
}
