#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <iostream>
using namespace std;
typedef long long ll;
const ll inf = 1e18;
typedef unsigned long long ull;
inline int read(){
	int x = 0; char ch = getchar();
	while(ch < '0' || ch > '9') ch = getchar();
	while(ch >= '0' && ch <= '9'){
		x = x*10 + ch - 48;
		ch = getchar();
	}
	return x;
}
ll dp[5123][5123];
ll s[5123];
inline ll sqr(ll x){
	return x*x;
}
int n;
ll DP(int l, int r){
	if(dp[l][r] != -1) return dp[l][r];
	if(r == n) return 0;
	dp[l][r] = inf;
	for(int i(n); i > r && s[i] - s[r] >= s[r] - s[l-1]; --i){
		dp[l][r] = min(dp[l][r], DP(r + 1, i) + sqr(s[i]-s[r]));
	}
	return dp[l][r];
}
int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	memset(dp, -1, sizeof(dp));
	n = read();
	int type = read();
	for(int i(1); i <= n; ++i){
		s[i] = rand(); s[i] += s[i - 1];
	}	
	printf("%lld\n", DP(1, 0));
	return 0;
}

