#include <bits/stdc++.h>
using namespace std;
#define M 300005
template<class T>bool tomax(T &x,T y){
	if(x<y)return x=y,1;
	return 0;
}
template<class T>bool tomin(T &x,T y){
	if(x>y)return x=y,1;
	return 0;
}
typedef long long LL;
template<class T>void Rd(T &x){
	static char c;
	while(c=getchar(),!isdigit(c));
	for(x=0;isdigit(c);c=getchar())
		x=(x<<1)+(x<<3)+(c^48);
}
template<class T>void Ps(T x){
	if(x==0)return;
	Ps(x/10);putchar(x%10^48);
}
template<class T>void Printf(T x){
	if(x==0)putchar(48);
	else Ps(x);
	putchar('\n');
}
bool MM1;
int n;
struct Edge{
	int to,nx;
}edge[M<<1];
int h[M],tt;
void link(int a,int b){
	edge[++tt].to=b;
	edge[tt].nx=h[a];
	h[a]=tt;
}
#define DEG(i,st) for(int i=h[st];i;i=edge[i].nx)
struct EDGE{
	int a,b;
}G[M];
void Link(int a,int b){
	link(a,b),link(b,a);
}
struct P1{
	LL Res;
	int sz[M],TT;
	void dfs(int F,int now){
		sz[now]=1;
		DEG(i,now){
			int to=edge[i].to;
			if(to==F)continue;
			dfs(now,to);
			sz[now]+=sz[to];
		}
	}
	void Find(int F,int now){
		int Son=TT-sz[now];
		DEG(i,now){
			int to=edge[i].to;
			if(to==F)continue;
			Find(now,to);
			tomax(Son,sz[to]);
		}
		if(Son<=(TT>>1))Res+=now;
	}
	LL Work(int id){Res=0;
		for(int i=1;i<=n;i++)h[i]=0;tt=0;
		for(int i=1;i<n;i++){
			if(i==id)continue;
			Link(G[i].a,G[i].b);
		}
		dfs(0,G[id].a);
		TT=sz[G[id].a],Find(0,G[id].a);
		dfs(0,G[id].b);
		TT=sz[G[id].b],Find(0,G[id].b);
		return Res;
	}
	void solve(){
		LL ans=0;
		for(int i=1;i<n;i++)
			ans+=Work(i);
		Printf(ans);
	}
}p1;
struct BIT{
	LL C[M<<1];
	void Add(int x,LL v){
		while(x<=n+n)C[x]+=v,x+=x&-x;
	}
	LL Sum(int x){
		LL ret=0;
		while(x)ret+=C[x],x&=x-1;
		return ret;
	}
	void Update(int l,int r,LL v){
		if(l>r)return;
		Add(l,v);
		if(r!=n+n)Add(r+1,-v);
	}
}C;
struct P2{
	int in[M];
	bool check(){
		for(int i=1;i<=n;i++)in[i]=0;
		for(int i=1;i<n;i++){
			in[G[i].a]++,in[G[i].b]++;
		}
		for(int i=1;i<=n;i++)
			if(in[i]>2)return 0;
		return 1;
	}
	int Px[M],len;
	void dfs(int F,int now){
		Px[++len]=now;
		DEG(i,now){
			int to=edge[i].to;
			if(to==F)continue;
			dfs(now,to);
		}
	}
	void solve(){
		for(int i=1;i<n;i++)Link(G[i].a,G[i].b);
		int rt=0;
		for(int i=1;i<=n;i++)if(in[i]==1)rt=i;
		len=0;
		dfs(0,rt);
		LL ans=0;
		for(int i=1;i<len;i++){
			if(i&1)ans+=Px[1+(i>>1)];
			else ans+=Px[i>>1],ans+=Px[(i>>1)+1];
		}
		reverse(Px+1,Px+1+len);
		for(int i=1;i<len;i++){
			if(i&1)ans+=Px[1+(i>>1)];
			else ans+=Px[i>>1],ans+=Px[(i>>1)+1];
		}
		Printf(ans);
	}
}p2;
struct P3{
	int in[M];
	bool check(){
		return n==262143;
	}
	LL sum[M],Dep[M];
	void dfs(int F,int now,int dep){
		sum[dep]+=now;
		DEG(i,now){
			int to=edge[i].to;
			if(to==F)continue;
			dfs(now,to,dep+1);
		}
	}
	void solve(){
		for(int i=1;i<n;i++)Link(G[i].a,G[i].b);
		for(int i=1;i<=n;i++)in[i]=0,sum[i]=Dep[i]=0;
		for(int i=1;i<n;i++)in[G[i].a]++,in[G[i].b]++;
		int rt=0,base=0;
		for(int i=1;;i++){
			if((1<<i)==n+1){
				base=i;
				break;
			}
		}
		for(int i=1;i<=n;i++)
			if(in[i]==2)rt=i;
		dfs(0,rt,0);
		for(int i=1;i<base;i++){
			int cnt=1<<(i-1);
			int lft=n-(1<<base-i)+1;
			for(int j=1;j<base;j++){
				int Son=lft-(1<<base-j)+1;
				tomax(Son,(1<<base-j-1)-1);
				if(Son<=(lft>>1))Dep[j]+=cnt;
			}
		}
		LL ans=0;
		for(int i=1;i<=n;i++)if(i!=rt)ans+=i;
		for(int i=1;i<base;i++)
			ans+=Dep[i]*sum[i];
		ans+=1LL*rt*(1LL<<base-1);
		Printf(ans);
	}
}p3;
bool MM2;
int main(){
//	printf("%lf\n",(&MM2-&MM1)/1024.0/1024.0);
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	cin>>T;
	while(T--){
		Rd(n);
		for(int i=1;i<n;i++)
			Rd(G[i].a),Rd(G[i].b);
		for(int i=1;i<=n;i++)h[i]=0;tt=0;
		if(p2.check())p2.solve();
		else if(p3.check())p3.solve();
		else p1.solve();
	}
	return 0;
}
