#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll N = 50005;
ll n, T, cnt = 0, tot  =0;
ll x[N], y[N], fir[N], nxt[N*2], to[N*2];
ll siz[N], mx[N], sum = 0, nw, a[N], deg[N];
bool vis[N];
template<class Tp> inline void read(Tp &x) {
    bool f = false; x =0;
    char ch = getchar();
    while (!isdigit(ch)) {if (ch == '-') f = true; ch = getchar();}
    while(isdigit(ch)) x = (x << 3) + (x << 1) + (ch ^ 48), ch = getchar();
    x = f ? -x : x;
}
inline void AddEdge(ll u, ll v) {
    nxt[++cnt] = fir[u];
    fir[u] = cnt, to[cnt] = v;
}
inline void dffs(ll u, ll fa) {
    a[++tot] = u;
    for (ll i = fir[u]; i; i = nxt[i]) {
        ll v = to[i];
        if (v == fa) continue;
        dffs(v, u);
    }
}
inline void dfs(ll u, ll fa) {
    sum ++; siz[u] = 1;
    vis[u] = true;
    for (ll i = fir[u]; i; i = nxt[i]) {
        ll v = to[i];
        if (v == fa) continue;
        if (u == x[nw] && v == y[nw]) continue;
        if (v == x[nw] && u == y[nw]) continue;
        dfs(v, u);
        siz[u] += siz[v];
        mx[u] = max(mx[u], siz[v]);
    }
}
int main() {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    read(T);
    while (T--) {
        read(n);
        if (n <= 5000) {
            cnt = 0;
            memset(fir, 0, sizeof(fir));
            for (ll i = 1; i < n; i++) {
                ll u, v;
                read(u), read(v);
                x[i] = u, y[i] = v;
                AddEdge(u, v);
                AddEdge(v, u);
            }
            ll ans = 0;
            for (nw = 1; nw < n; nw++) {
                sum = 0;
                memset(mx, -1, sizeof(mx));
                memset(vis, false, sizeof(vis));
                dfs(x[nw], 0);
                for (ll i = 1; i <= n; i++) {
                    if (vis[i]) {
                        mx[i] = max(mx[i], sum - siz[i]);
                        if (mx[i] <= sum / 2) {
                            ans += i;
                        }
                    }
                }
                sum = 0;
                memset(mx, -1, sizeof(mx));
                memset(vis, false, sizeof(vis));
                dfs(y[nw], 0);
                for (ll i = 1; i <= n; i++) {
                    if (vis[i]) {
                        mx[i] = max(mx[i], sum - siz[i]);
                        if (mx[i] <= sum / 2) {
                            ans += i;
                        }
                    }
                }
            }
            cout << ans << '\n';
        }
        else {
            cnt = 0; tot = 0;
            memset(fir, 0, sizeof(fir));
            for (ll i = 1; i < n; i++) {
                ll u, v;
                read(u), read(v);
                x[i] = u, y[i] = v;
                AddEdge(u, v);
                AddEdge(v, u);
                deg[u] ++, deg[v]++;
            }
            ll ans = 0, t;
            for (ll i = 1; i <= n; i++) {
                if (deg[i] == 1) t = i;
            }
            dffs(t, 0);
            for (ll i = 1; i < n; i++) {
                ll len1 = i, len2 = n - i;
                if (len1 & 1) {
                    if (i - (len1 / 2) + 1 >= 1 && i - (len1 / 2) + 1 <= n) 
                    ans += a[i - (len1 / 2) + 1];
                }
                else {
                    if (i - (len1 / 2) >= 1 && i - (len1 / 2) <= n)
                    if (i - (len1 / 2) + 1 >= 1 && i - (len1 / 2) + 1 <= n)
                    ans += a[i - (len1 / 2)] + a[i - (len1 / 2) + 1];
                }
                if (len2 & 1) {
                    if (i + 1 + (len2 / 2) - 1 >= 1 && i + 1 + (len2 / 2) - 1 <= n)
                    ans += a[i + 1 + (len2 / 2) - 1];
                }
                else {
                    if (i + 1 + (len2 / 2) - 1 >= 1 && i + 1 + (len2 / 2) - 1 <= n) 
                    if (i + 1 + (len2 / 2) >= 1 && i + 1 + (len2 / 2) <= n)
                    ans += a[i + 1 + (len2 / 2) - 1] + a[i + 1 + (len2 / 2)];
                }
            }
            cout << ans << '\n';
        }
    }
    return 0;
}