#include <bits/stdc++.h>
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define dep(i, a, b) for (int i = (a); i >= (b); --i)
using namespace std;

const int Mod = 998244353;

namespace {
  void add(long long &a, long long b) {
    a += b;
    if (a >= Mod) a -= Mod;
  }
  void del(long long &a, long long b) {
    a -= b;
    if (a < 0) a += Mod;
  }
  long long Add(long long a, long long b) {
    a += b;
    if (a >= Mod) a -= Mod;
    return a;
  }
  long long Del(long long a, long long b) {
    a -= b;
    if (a < 0) a += Mod;
    return a;
  }
  long long mul(long long a, long long b) {
    a *= b; a %= Mod;
    return a;
  }
}

const int N = 100 + 10, M = 2000 + 10;

long long dp[N][N][N], s[N][M], sum[N];

int main() {

  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);

  int n, m; scanf("%d%d", &n, &m);
  rep(i, 1, n) rep(j, 1, m) scanf("%lld", &s[i][j]);
  long long tot = 1;
  rep(i, 1, n) {
    sum[i] = 1;
    rep(j, 1, m) add(sum[i], s[i][j]);
    tot = mul(tot, sum[i]);
  }
  del(tot, 1);
  memset(dp, 0, sizeof dp);
  rep(i, 1, m) {
    dp[0][0][0] = 1;
    rep(j, 1, n) {
      rep(x, 0, j - 1) {
	rep(y, 0, x) {
	  if (dp[j - 1][x][y] == 0) continue;
	  add(dp[j][x][y], dp[j - 1][x][y]);
	  add(dp[j][x + 1][y + 1], mul(dp[j - 1][x][y], s[j][i]));
	  add(dp[j][x + 1][y], mul(dp[j - 1][x][y], Del(sum[j], Add(s[j][i], 1))));
	  dp[j - 1][x][y] = 0;
	}
      }
    }
    rep(x, 1, n) {
      rep(y, (int)(x / 2) + 1, x) {
	del(tot, dp[n][x][y]);
      }
    }
    rep(x, 0, n) rep(y, 0, n) dp[n][x][y] = 0;
  }
  cout << tot << endl;

}
