#include<bits/stdc++.h>
#define ll long long
#define N 300005
using namespace std;
int T, n, pos, in[N];
int dep[N], sz[N], mx[N];
int tot, son[N<<1], nxt[N<<1], lnk[N];
struct node { int x, y; } e[N];
ll ans;

int read() {
	int red = 0, f_f = 1; char ch = getchar();
	while(ch>'9'||ch<'0') { if(ch == '-') f_f = -1; ch = getchar(); }
	while(ch>='0'&&ch<='9') red = red*10+ch-'0', ch = getchar();
	return red * f_f;
}

void mem() { tot = 0; for(int i = 1; i <= n; i++) lnk[i] = 0, in[i] = 0; }

void add(int x, int y) { son[++tot] = y, nxt[tot] = lnk[x], lnk[x] = tot; }

namespace subtask1 {
int all, k, siz[N], minn[2];
bool val[N];

void dfs1(int u, int fa) {
	sz[u] = 1;
	for(int i = lnk[u]; i; i = nxt[i]) {
		int v = son[i];
		if(v == fa) continue;
		dep[v] = dep[u]+1;
		dfs1(v, u);
		sz[u] += sz[v];
	}
}

void dfs(int u, int fa) {
	val[u] = k, siz[u] = 1, mx[u] = 0;
	for(int i = lnk[u]; i; i = nxt[i]) {
		int v = son[i];
		if(v == fa) continue;
		dfs(v, u);
		mx[u] = max(mx[u], siz[v]), siz[u] += siz[v];
	}
	mx[u] = max(mx[u], all-siz[u]);
	minn[k] = min(minn[k], mx[u]);
}

void Main() {
	ans = 0, dep[1] = 1;
	dfs1(1, 0);
	for(int i = 1; i < n; i++) {
		int s = e[i].x, t = e[i].y;
		if(dep[s] > dep[t]) swap(s, t);
		k = 0, all = n-sz[t], minn[0] = minn[1] = n;
		dfs(s, t);
		k = 1, all = sz[t];
		dfs(t, s);
		for(int j = 1; j <= n; j++)
			if(mx[j] == minn[val[j]]) ans += (ll)j;
	}
	printf("%lld\n", ans);
}
}

namespace subtask2 {
int a[N];

void Main() {
	a[1] = pos, ans = 0;
	for(int i = 2; i <= n; i++) {
		for(int j = lnk[pos]; j; j = nxt[j]) {
			int v = son[j];
			if(a[i-2] == v) continue;
			pos = v;
			break;
		}
		a[i] = pos;
	}
	for(int i = 1; i < n; i++) { //cut just after pos i 
		ans += (ll)a[(i+1)>>1] + (ll)a[i+((n-i+1)>>1)];
		if(!(i&1)) ans += (ll)a[(i>>1)+1];
		if(!((n-i)&1)) ans += (ll)a[i+((n-i+1)>>1)+1];
	}
	printf("%lld\n", ans);
}
}

namespace subtask3 {
int mn;

void dfs1(int u, int fa) {
	sz[u] = 1, mx[u] = 0;
	for(int i = lnk[u]; i; i = nxt[i]) {
		int v = son[i];
		if(v == fa) continue;
		dfs1(v, u);
		sz[u] += sz[v], mx[u] = max(mx[u], sz[v]);
	}
	mx[u] = max(mx[u], n-sz[u]);
	mn = min(mn, mx[u]);
}

void dfs(int u, int fa) {
	for(int i = lnk[u]; i; i = nxt[i]) {
		int v = son[i];
		if(v == fa) continue;
		dep[v] = dep[u] + 1;
		dfs(v, u);
	}
}

void Main() {
	mn = n, ans = 0;
	dfs1(1, 0);
	for(int i = 1; i <= n; i++)
		if(mx[i] == mn) { pos = i; break; }
	dep[pos] = 1;
	dfs(pos, 0);
	ans = (ll)(1+n)*n/2-pos;
	for(int i = 1; i <= n; i++) {
		if(dep[i] == 1) ans += (n+1>>1) * i;
		if(dep[i] == 2) ans += ((n+1>>2)+1) * i;
		if(dep[i] == 3 && n >= 8) ans += i;
	}
	printf("%lld\n", ans);
}

}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = read();
	while(T--) {
		n = read();
		mem();
		for(int i = 1; i < n; i++) {
			e[i].x = read(), e[i].y = read(), in[e[i].x]++, in[e[i].y]++;
			add(e[i].x, e[i].y); add(e[i].y, e[i].x);
		}
		if(n <= 2000) { subtask1::Main(); continue; }
		bool flg = 1;
		for(int i = 1; i <= n; i++) {
			if(in[i] > 2) flg = 0;
			if(in[i] == 1) pos = i;
		}
		if(flg) subtask2::Main(); //lian
		else subtask1::Main(); //perfect no
	}
	return 0;
}
