#include <bits/stdc++.h>

const int MOD = 998244353;
inline int add(int x, int y) { return x + y >= MOD ? x + y - MOD : x + y; }
inline int sub(int x, int y) { return x - y < 0 ? x - y + MOD : x - y; }
inline int mul(int x, int y) { return 1LL * x * y % MOD; }

const int MAXN = 1e2 + 10, MAXM = 2e3 + 10;

int n, m;
int a[MAXN][MAXM];

namespace Subtask1 {
	const int N = 45;
	int dp[2][N][N];
	inline void gao() {
		dp[0][0][0] = 1;
		for (int i = 1; i <= n; ++i) {
			int cur = i & 1, lst = cur ^ 1;
			for (int j = 0; j <= n; ++j)
				for (int k = 0; k <= n; ++k) {
					if (j + k > i) continue;
					dp[cur][j][k] = dp[lst][j][k];
					if (j) dp[cur][j][k] = add(dp[cur][j][k], mul(dp[lst][j - 1][k], a[i][1]));
					if (k) dp[cur][j][k] = add(dp[cur][j][k], mul(dp[lst][j][k - 1], a[i][2]));
				}
		}
		int cur = n & 1;
		int ans = 0;
		for (int i = 0; i <= n; ++i)
			for (int j = 0; j <= n; ++j) {
				if (!i && !j) continue;
				if (i == j) ans = add(ans, dp[cur][i][j]);
			}
		printf("%d\n", ans);
	}
};
namespace Subtask2 {
	const int N = 45;
	int dp[2][N][N][N];
	inline void gao() {
		dp[0][0][0][0] = 1;
		for (int i = 1; i <= n; ++i) {
			int cur = i & 1, lst = cur ^ 1;
			for (int j = 0; j <= n; ++j)
				for (int k = 0; k <= n; ++k)
					for (int l = 0; l <= n; ++l) {
						if (j + k + l > i) continue;
						dp[cur][j][k][l] = dp[lst][j][k][l];
						if (j) dp[cur][j][k][l] = add(dp[cur][j][k][l], mul(dp[lst][j - 1][k][l], a[i][1]));
						if (k) dp[cur][j][k][l] = add(dp[cur][j][k][l], mul(dp[lst][j][k - 1][l], a[i][2]));
						if (l) dp[cur][j][k][l] = add(dp[cur][j][k][l], mul(dp[lst][j][k][l - 1], a[i][3]));
					}
		}
		int cur = n & 1;
		int ans = 0;
		for (int i = 0; i <= n; ++i)
			for (int j = 0; j <= n; ++j)
				for (int k = 0; k <= n; ++k) {
					if (!i && !j && !k) continue;
					int sum = i + j + k, QAQ = sum / 2;
					if (i > QAQ || j > QAQ || k > QAQ) continue;
					ans = add(ans, dp[cur][i][j][k]);
				}
		printf("%d\n", ans);
	}
};
namespace Subtask3 {
	const int N = 45, M = 510;
	int dp[N][N], dip[N][N][N], sum[N], h[N], res[N][M];
	inline void gao() {
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= m; ++j) sum[i] = add(sum[i], a[i][j]), h[i] |= a[i][j];
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= m; ++j) res[i][j] = sub(sum[i], a[i][j]);
		dp[0][0] = 1;
		for (int i = 1; i <= n; ++i) {
			for (int j = 0; j <= i; ++j) {
				dp[i][j] = dp[i - 1][j];
				if (j && h[i]) dp[i][j] = add(dp[i][j], mul(dp[i - 1][j - 1], sum[i]));
			}
		}
		int ans = 0;
		for (int i = 1; i <= n; ++i) ans = add(ans, dp[n][i]);
		for (int i = 1; i <= m; ++i) {
			dip[0][0][0] = 1;
			for (int j = 1; j <= n; ++j)
				for (int k = 0; k <= j; ++k)
					for (int l = 0; l <= k; ++l) {
						dip[j][k][l] = dip[j - 1][k][l];
						if (k && h[j] && a[j][i] != sum[j]) dip[j][k][l] = add(dip[j][k][l], mul(dip[j - 1][k - 1][l], res[j][i]));
						if (l && a[j][i]) dip[j][k][l] = add(dip[j][k][l], mul(dip[j - 1][k - 1][l - 1], a[j][i]));
					}
			for (int sum = 1; sum <= n; ++sum) {
				int mid = sum / 2;
				for (int j = mid + 1; j <= sum; ++j) ans = sub(ans, dip[n][sum][j]);
			}
		}
		printf("%d\n", ans);
	}
	/*
	5 5
	1 0 0 1 1
	0 1 0 1 0
	1 1 1 1 0
	1 0 1 0 1
	0 1 1 0 1
	*/
};

int main() {
	freopen("meal.in", "r", stdin); freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j) scanf("%d", &a[i][j]);
	if (m == 2) Subtask1::gao();
	else if (m == 3) Subtask2::gao();
	else Subtask3::gao();
	return 0;
}
