#include <bits/stdc++.h>

typedef long long LL;

const int MAXN = 5e5 + 10;

int n;
int a[MAXN];
int sum[MAXN];

inline void read(int &x) {
	x = 0; register char ch;
	for (ch = getchar(); !isdigit(ch); ch = getchar());
	for (; isdigit(ch); x = x * 10 + (ch ^ 48), ch = getchar());
}
namespace Subtask1 {
	struct Node {
		int sum; LL val;
		inline friend bool operator< (const Node &a, const Node &b) {
			return a.sum < b.sum;
		}
	};
	const int N = 5e3 + 10;
	LL val[N][N], dp[N][N];
	inline int find(int k, int S) {
		int ans = k;
		for (int L = 0, R = k - 1, mid = (L + R) >> 1; L <= R; mid = (L + R) >> 1)
			if (sum[k] - sum[mid] <= S) R = (ans = mid) - 1;
			else L = mid + 1;
		return ans;
	}
	inline void gao() {
		for (int i = 1; i <= n; ++i) {
			for (int j = i; j <= n; ++j)
				val[i][j] = val[i][j - 1] + 2LL * (sum[j - 1] - sum[i - 1]) * a[j] + 1LL * a[j] * a[j];
		}
		for (int i = 1; i <= n; ++i) {
			LL min = 4e18;
			for (int j = i - 1; ~j; --j) {
				int S = sum[i] - sum[j]; LL now = 4e18;
				int pos = find(j, S);
				if (pos != j) now = dp[j][pos] + val[j + 1][i];
				min = std::min(min, now);
				dp[i][j] = min;
			}
			dp[i][0] = val[1][i];
		}
		LL ans = 4e18/*2003101820031019599*/;
		for (int i = 0; i < n; ++i) ans = std::min(ans, dp[n][i]);
		printf("%lld\n", ans);
	}
};

int main() {
	freopen("partition.in", "r", stdin); freopen("partition.out", "w", stdout);
	scanf("%d%*d", &n);
	for (int i = 1; i <= n; ++i) read(a[i]), sum[i] = sum[i - 1] + a[i];
	if (n <= 5000) Subtask1::gao();
	return 0;
}
