#include <cstdio>
#include <algorithm>

typedef long long ll;

const int maxN = 5e5 + 5;
const ll INF = 4e18 + 5;

int n, type;
int a[maxN];
ll S[maxN], dp[405][405];

inline int read() {
	int ans = 0;
	char ch = getchar(), last = ' ';
	while (ch < '0' || ch > '9') last = ch, ch = getchar();
	while (ch >= '0' && ch <= '9') ans = (ans << 1) + (ans << 3) + ch - '0', ch = getchar();
	return last == '-' ? -ans : ans;
}

inline void solve1() {
	dp[0][0] = 0;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j) dp[i][j] = INF;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= i; ++j)
			for (int k = 1; k <= j; ++k)
				if (S[i] - S[j - 1] >= S[j - 1] - S[k - 1]) dp[i][j] = std :: min(dp[i][j], dp[j - 1][k] + (S[i] - S[j - 1]) * (S[i] - S[j - 1]));
	ll ans = INF;
	for (int i = 1; i <= n; ++i) ans = std :: min(ans, dp[n][i]);
	printf("%lld\n", ans);
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	n = read(), type = read();
	if (type == 0) {
		S[0] = 0;
		for (int i = 1; i <= n; ++i) a[i] = read(), S[i] = S[i - 1] + a[i];
		if (n <= 400) solve1();
	}
}
