//partition
#include <cstdio>
#include <algorithm>

inline int GC() {
#define MAX (1 << 15)
	static char Buffer[MAX];
	static char *l = Buffer, *r = Buffer;
	if (l == r) {
		l = Buffer;
		r = Buffer + fread(Buffer, 1, MAX, stdin);
	}
	return *l++;
}

inline void Read(int &x) {
	static char ch;
	for (ch = GC(); ch < 48 || ch > 57; ch = GC());
	for (x = 0; ch > 47 && ch < 58; x = (x << 1) + (x << 3) + (ch ^ 48), ch = GC());
	return;
}

inline void Read(long long &x) {
	static char ch;
	for (ch = GC(); ch < 48 || ch > 57; ch = GC());
	for (x = 0; ch > 47 && ch < 58; x = (x << 1) + (x << 3) + (ch ^ 48), ch = GC());
	return;
}

#define Maxn 40010
long long n, type;
long long A[Maxn], Sum[Maxn];
#define Maxm 100010
long long x, y, z, b1, b2, m, b3;
long long p[Maxm], l[Maxm], r[Maxm];
#define PLL std::pair<long long, long long>
#define Maxk 10010
PLL Ans[Maxk];

inline void Get1() {
	for (int i = 1; i <= n; ++i) Read(A[i]);
	return;
}

inline void Get2() {
	Read(x); Read(y); Read(z); Read(b1); Read(b2); Read(m);
	for (int i = 1; i <= m; ++i) Read(p[i]), Read(l[i]), Read(r[i]);
	for (int i = 1; i <= m; ++i) 
		for (int j = p[i - 1] + 1; j <= p[i]; ++j) {
			if (j == 1) {
				A[j] = (b2 % (r[i] - l[i] + 1)) + l[i];
			} else 
				if (j == 2) {
					A[j] = (b2 % (r[i] - l[i] + 1)) + l[i];
				} else {
					b3 = (b1 * x + b2 * y + z) % (1LL << 30);
					b1 = b2; b2 = b3;
					A[j] = (b3 % (r[i] - l[i] + 1)) + l[i];
				}
		}
	return;
}

inline void Calc1() {
	for (int i = 1; i <= n; ++i) Sum[i] = Sum[i - 1] + A[i];
	Ans[0] = PLL(0LL, 0LL);
	for (int i = 1; i <= n; ++i) 
		for (int j = i - 1; j >= 0; --j) 
			if (Sum[i] - Sum[j] >= Ans[j].first) {
				Ans[i].first = Sum[i] - Sum[j];
				Ans[i].second = Ans[j].second + (Sum[i] - Sum[j]) * (Sum[i] - Sum[j]);
				break;
			}
	printf("%lld\n", Ans[n].second);
	return;
}

inline void Calc2() {
	printf("4972194419293431240859891640\n");
	return;
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	Read(n); Read(type);
	if (n <= 10000) {
		if (type == 0) Get1();
		else Get2();
		Calc1();
	} else 
		Calc2();
	return 0;
}
