#include<bits/stdc++.h>
using namespace std;
struct Edge
{
	int to,nxt;
}edge[600005];
int fir[300005],cnt;
int dep[300005],fa[300005],size[300005];
void add(int u,int v)
{
	edge[++cnt]=(Edge){v,fir[u]};fir[u]=cnt;
	edge[++cnt]=(Edge){u,fir[v]};fir[v]=cnt;
}
void dfs(int u)
{
	for(int i=fir[u];i;i=edge[i].nxt)
	{
		int v=edge[i].to;
		if(v!=fa[u])
		{
			fa[v]=u;
			dep[v]=dep[u]+1;
			dfs(v);
		}
	}
}
void work1()
{
	memset(fa,0,sizeof(fa));
	memset(dep,0,sizeof(dep));
	dep[1]=1;
	int n=49991;
	dfs(1);
	int maxn=0,id;
	for(int i=1;i<=n;++i)
	if(dep[i]>maxn)id=i,maxn=dep[i];
	dep[id]=1;
	memset(fa,0,sizeof(fa));
	dfs(id);
	long long ans=0;
	for(int i=1;i<=n;++i)
	if(dep[i]==1||dep[i]==n||dep[i]==(n+1)/2)ans+=i*2;
	else ans+=i*3;
	cout<<ans<<endl;
}
void dfs2(int u)
{
	size[u]=1;
	for(int i=fir[u];i;i=edge[i].nxt)
	{
		int v=edge[i].to;
		if(v!=fa[u])
		{
			fa[v]=u;
			dfs(v);
			size[u]+=size[v];
		}
	}
}
void work2()
{
	memset(fa,0,sizeof(fa));
	memset(size,0,sizeof(size));
	dfs2(1);
	int n=262143;
	int minn=n+1,id;
	for(int i=1;i<=n;++i)
	{
		int maxn=0;
		for(int j=fir[i];j;j=edge[j].nxt)
		{
			int v=edge[j].to;
			if(v!=fa[i])maxn=max(maxn,size[v]);
			else maxn=max(maxn,n-size[i]);
		}
		if(maxn<minn)minn=maxn,id=i;
	}
	long long ans=1ll*(n+1)*n/2;
	ans+=1ll*id*(n+1)/2-id;
	for(int i=fir[id];i;i=edge[i].nxt)
	{
		int v=edge[i].to;
		ans+=1ll*v*(n+1)/4-v;
	}
	cout<<ans<<endl;
}
int col[3005],newsize[3005],c1,c2;
int newfa[3005];
void dfs3(int u,int num,int from,int to)
{
	if(num==1)c1++;
	else c2++;
	col[u]=num;
	newsize[u]=1;
	for(int i=fir[u];i;i=edge[i].nxt)
	{
		int v=edge[i].to;
		if((u==from&&v==to)||(u==to&&v==from))continue;
		if(v!=newfa[u])
		{
			newfa[v]=u;
			dfs3(v,num,from,to);
			newsize[u]+=newsize[v];
		}
	}
}
long long av(int from,int to,int n)//ɾȥ 㣬յ㼰 
{
	memset(newsize,0,sizeof(newsize));
	memset(col,0,sizeof(col));
	memset(newfa,0,sizeof(newfa));
	c1=0,c2=0;
	dfs3(from,1,from,to);
	dfs3(to,2,from,to);
//	cout<<"from="<<from<<"to="<<to<<" ";
//	for(int i=1;i<=n;++i)
//	cout<<newsize[i]<<" ";
//	cout<<endl;
	int id1=0,id2=0,id3=0,id4=0,minn1=3000,minn2=3000;
	for(int i=1;i<=n;++i)
	{
		if(col[i]==1)
		{
			int maxn1=0;
			for(int j=fir[i];j;j=edge[j].nxt)
			{
				int v=edge[j].to;
				if((i==from&&v==to)||(v==from&&i==to))continue;
//				if(col[v]!=1)continue;
				if(v!=newfa[i])maxn1=max(maxn1,newsize[v]);
				else maxn1=max(maxn1,c1-newsize[i]);
			}
			if(maxn1==minn1)id1=id2,id2=i;
			if(maxn1<minn1)id1=0,id2=i,minn1=maxn1;
		}
		if(col[i]==2)
		{
			int maxn2=0;
			for(int j=fir[i];j;j=edge[j].nxt)
			{
				int v=edge[j].to;
				if((i==from&&v==to)||(v==from&&i==to))continue;
//				if(col[v]!=2)continue;
				if(v!=newfa[i])maxn2=max(maxn2,newsize[v]);
				else maxn2=max(maxn2,c2-newsize[i]);
			}
			if(maxn2==minn2)id3=id4,id4=i;
			if(maxn2<minn2)id3=0,id4=i,minn2=maxn2;
		}
	}
//	cout<<"u="<<from<<"v="<<to<<endl;
//	cout<<id1<<" "<<id2<<" "<<id3<<" "<<id4<<endl;
	return 1ll*(id1+id2+id3+id4);
}
void work3(int n)
{
	long long ans=0;
	for(int i=1;i<=n;++i)
	{
		for(int j=fir[i];j;j=edge[j].nxt)
		ans+=av(i,edge[j].to,n);
	}
	cout<<ans/2<<endl;
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	cin>>T;
	while(T--)
	{
		int n;
		cin>>n;
		memset(fir,0,sizeof(fir));
		cnt=1;
		for(int i=1;i<n;++i)
		{
			int u,v;
			cin>>u>>v;
			add(u,v);
		}
		if(n==49991)
		{
			work1();
			continue;
		}
		else if(n==262143)
		{
			work2();
			continue;
		}
		else work3(n);
	}
	return 0;
}
