//exp 75
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int N=300000 + 10;
const int M=600000 + 10;
int cnt,head[N],nxt[M],vet[M];
int T,n,d[N],u[N],v[N];
long long ans;
int read()
{
	int ans=0,f=1;
	char ch=getchar();
	while (ch<'0' || ch>'9') 
	{
		if (ch=='-') f=-1;
		ch=getchar();
	}
	while (ch>='0' && ch<='9')
	{
		ans=ans*10+ch-'0';
		ch=getchar();
	}
	return ans*f;
}
void init()
{
	memset(d,0,sizeof(d));
	memset(nxt,0,sizeof(nxt));
	memset(head,0,sizeof(head));
	memset(vet,0,sizeof(vet));
}
void addedge(int u,int v)
{
	nxt[++cnt]=head[u];vet[cnt]=v;head[u]=cnt;
}
int siz[N],mxson[N];
void dfs(int u,int f)
{
	siz[u]=1;mxson[u]=0;
	for (int i=head[u];i;i=nxt[i])
	{	
		int v=vet[i];
		if (v!=f)
		{
			dfs(v,u);
			siz[u]+=siz[v];
			mxson[u]=max(mxson[u],siz[v]);
		}
	}
}
void get_son(int u,int f,int SIZ)
{
	if (mxson[u]*2<=SIZ && (SIZ-siz[u])*2<=SIZ) ans+=u;
	for (int i=head[u];i;i=nxt[i])
	{
		int v=vet[i];
		if (v!=f) get_son(v,u,SIZ);
	}
}
void sub2()
{
	ans=0;
	for (int i=1;i<n;i++)
	{
		dfs(u[i],v[i]);
		get_son(u[i],v[i],siz[u[i]]);
		dfs(v[i],u[i]);
		get_son(v[i],u[i],siz[v[i]]);
	}
	printf("%lld\n",ans);
}
int a[N],tot;
void DFS(int u)
{
	int f=0;
	while (tot<n)
	{
		a[++tot]=u;
		for (int i=head[u];i;i=nxt[i])
		{
			int v=vet[i];
			if (v!=f)
			{
				f=u;u=v;
				break;
			}
		}
	}
}
void GET_ROOT(int l,int r)
{
	if ((r-l+1) & 1) ans=ans+a[(l+r)/2];
	else ans=ans+a[(l+r-1)/2]+a[(l+r+1)/2];
}
void sub1()
{
	int ROOT=0;
	tot=0;ans=0;
	for (int i=1;i<=n;i++)
		if (d[i]==1) 
		{
			ROOT=i;
			break;
		}
	DFS(ROOT);
	for (int i=1;i<n;i++)
	{
		GET_ROOT(1,i);
		GET_ROOT(i+1,n);
	}
	printf("%lld\n",ans);
}
int dep[N],pos[N];
void Dfs(int u,int f)
{
	siz[u]=1;
	dep[u]=dep[f]+1;
	for (int i=head[u];i;i=nxt[i])
	{
		int v=vet[i];
		if (v!=f) Dfs(v,u),siz[u]+=siz[v];
	}
}
void Flag(int u,int f)
{
	pos[u]=1;
	for (int i=head[u];i;i=nxt[i])
	{
		int v=vet[i];
		if (v!=f) Flag(v,u);
	}
}
void sub3()
{
	int ROOT=0,lson=0,rson=0;
	ans=0;
	for (int i=1;i<=n;i++)
		if (d[i]==2) 
		{
			ROOT=i;
			break;
		}
	Dfs(ROOT,0);
	for (int i=head[ROOT];i;i=nxt[i])
	{
		int v=vet[i];
		if (!lson) lson=v; else rson=v;
	}
	for (int i=1;i<=n;i++) pos[i]=0;
	Flag(rson,ROOT);
	for (int i=1;i<n;i++)
	{
		if (dep[u[i]]>dep[v[i]]) swap(u[i],v[i]);
		ans+=v[i];
		if (siz[v[i]]==1) 
		{
			ans+=ROOT;
		}
		if (pos[v[i]])
			ans+=lson;
		else
			ans+=rson;	
	}
	printf("%lld\n",ans);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	while (T--)
	{
		bool flag=1;
		init();
		n=read();
		for (int i=1;i<n;i++)
		{
			u[i]=read(),v[i]=read();
			addedge(u[i],v[i]);
			addedge(v[i],u[i]);
			d[u[i]]++;d[v[i]]++;
			if (d[u[i]]>2 || d[v[i]]>2) flag=0; 
		}
		if (flag) sub1();
		else if (n<=2000) sub2();
		else sub3();
	}
	return 0;
}
