#include <cstdio>
#include <algorithm>

const int MOD = 998244353;

int n, m;
long long a[105][2005];

namespace p32
{
int cnt[20], b[20];
long long ans = -1LL;

void check(void)
{
  for (int i = 0; i <= m; ++i)
    cnt[i] = 0;
  for (int i = 1; i <= n; ++i)
    if (b[i] != 0)
      ++cnt[0];
  for (int i = 1; i <= n; ++i)
    if (b[i] != 0)
      ++cnt[b[i]];
  for (int i = 1; i <= m; ++i)
    if (cnt[i] > cnt[0] / 2)
      return;
  long long mul = 1LL;
  for (int i = 1; i <= n; ++i)
    if (b[i] != 0)
      mul = (mul * a[i][b[i]]) % MOD;
  ans = (ans + mul) % MOD;
  return;
}

void dfs(const int x)
{
  if (x == n + 1) {
    check();
    return;
  }
  for (int i = 0; i <= m; ++i) {
    b[x] = i;
    dfs(x + 1);
  }
  return;
}

void solve(void)
{
  dfs(1);
  printf("%lld\n", ans);
  return;
}
}

int main(void)
{
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  scanf("%d%d", &n, &m);
  for (int i = 1; i <= n; ++i)
    for (int j = 1; j <= m; ++j)
      scanf("%lld", &a[i][j]);
  p32::solve();
  return 0;
}
