#include <ctime>
#include <cstdio>
#include <algorithm>

const int kN = 5e5 + 5;

int n, a[kN];

namespace p12
{
bool b[25];

void solve(void)
{
  long long ans = 0x3f3f3f3f3f3f3f3f;
  for (int i = 1; i < 1 << (n - 1); ++i) {
    for (int j = 1; j < n; ++j)
      b[j] = (i & (1 << (j - 1))) > 0;
    b[n] = true;
    long long sum = 0LL;
    int now = 0, last = 0;
    bool label = true;
    for (int j = 1; j <= n; ++j) {
      now += a[j];
      if (b[j]) {
        if (now < last) {
          label = false;
          break;
        }
        last = now;
        sum += 1LL * now * now;
        now = 0;
      }
    }
    if (label)
      ans = std::min(ans, sum);
  }
  printf("%lld\n", ans);
  return;
}
}

namespace pch
{
void solve(void)
{
  srand(time(NULL));
  long long ans = 0x3f3f3f3f3f3f3f3f;
  for (int z = 50000000 / n; z >= 1; --z) {
    long long sum = 0LL;
    int now = 0, last = 0;
    bool label = true;
    for (int j = 1; j < n; ++j) {
      now += a[j];
      if (rand() % 8 != 0 && now >= last) {
        if (now < last) {
          label = false;
          break;
        }
        last = now;
        sum += 1LL * now * now;
        now = 0;
      }
    }
    now += a[n];
    if (now < last)
      label = false;
    sum += 1LL * now * now;
    if (label)
      ans = std::min(ans, sum);
  }
  printf("%lld\n", ans);
  return;
}
}

int main(void)
{
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
  scanf("%d%*d", &n);
  for (int i = 1; i <= n; ++i)
    scanf("%d", &a[i]);
  if (n <= 10)
    p12::solve();
  else
    pch::solve();
  return 0;
}
