#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<vector>
#define pa pair<int,LL>
#define LL long long
using namespace std;
const LL P=9982444353;
const int N=3e5+10;
const LL inf=4e18+5;
int n,m;
LL ans=0;
struct edge{
	int r,nxt;
}e[N<<1];
int cnt;
int fa[N],hed[N],dep[N],du[N],siz[N],son[N],sz[N];
int F[N];
void insert(int u,int v){
	e[++cnt].r=v;e[cnt].nxt=hed[u];hed[u]=cnt;
}
void dfs(int x){
	siz[x]=1;
	for(int i=hed[x];i;i=e[i].nxt){
		if(e[i].r==fa[x]) continue;
		fa[e[i].r]=x;
		dep[e[i].r]=dep[x]+1;
		dfs(e[i].r);
		siz[x]=siz[x]+siz[e[i].r];
	}
}
bool vis[2050];
void sol0(int x,int nn){
	sz[x]=1;
	for(int i=hed[x];i;i=e[i].nxt){
		if(e[i].r==F[x]||vis[e[i].r]) continue;
		F[e[i].r]=x;
		sol0(e[i].r,nn);
		sz[x]=sz[x]+sz[e[i].r];
		son[x]=max(son[x],sz[e[i].r]);
	}
	son[x]=max(son[x],nn-sz[x]);
	if(son[x]<=(nn/2)) ans+=(LL)x;
}
void sol1(int x){
	memset(vis,0,sizeof(vis));
	memset(sz,0,sizeof(sz));
	memset(F,0,sizeof(F));
	memset(son,0,sizeof(son));
	vis[x]=1;
	for(int i=hed[x];i;i=e[i].nxt){
		if(e[i].r==fa[x])sol0(e[i].r,n-siz[x]);
		else sol0(e[i].r,siz[e[i].r]);
	}
	for(int i=hed[x];i;i=e[i].nxt){
		if(e[i].r==fa[x]) continue;
		sol1(e[i].r);
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;scanf("%d",&T);
	int x,y;
	while(T--){
		cnt=0;ans=0;
		memset(fa,0,sizeof(fa));
		memset(hed,0,sizeof(hed));
		memset(dep,0,sizeof(dep));
		memset(siz,0,sizeof(siz));
		memset(du,0,sizeof(du));
		scanf("%d",&n);
		for(int i=1;i<n;++i){
			scanf("%d%d",&x,&y);
			++du[x];++du[y];
			insert(x,y);insert(y,x);
		}
		int flag=1;
		for(int i=1;i<=n;++i) if(du[i]>2) flag=0;
		if(flag==1){
			for(int i=1;i<=n;++i) if(du[i]==1) x=i;
			dfs(x);
			for(int i=1;i<=n;++i){
				if(2*dep[i]<n&&dep[i]) ans=ans+(LL)i;
				if(2*dep[i]+1<n) ans=ans+(LL)i;
				if(2*dep[i]+2<n) ans=ans+(LL)i;
				dep[i]=n-1-dep[i];
				if(2*dep[i]<n&&dep[i]) ans=ans+(LL)i;
				if(2*dep[i]+1<n) ans=ans+(LL)i;
				if(2*dep[i]+2<n) ans=ans+(LL)i;
			}
			cout<<ans<<endl;
			continue;
		}
		if(n<=2000){
			dfs(1);
			//cout<<"y"<<endl;
			sol1(1);
			//cout<<"y"<<endl;
			cout<<ans<<endl;
			continue;
		}
		
	}
}
