#include <bits/stdc++.h>

typedef long long LL;

const LL INF64 = 0x7f7f7f7f7f7f7f7f;
const int N = 5e5;

int n, type;
LL sum[N + 5];

namespace Qiyang {
	const int N = 4e2;
	
	LL f[N + 5][N + 5];
	
	LL sqr(LL x) {
		return x * x;
	}
	void main() {
		for (int i = 1; i <= n; i++) {
			f[i][0] = sqr(sum[i]);
			for (int j = 1; j < i; j++) {
				f[i][j] = INF64;
				for (int k = 0; k < j; k++) {
					if (sum[i] - sum[j] >= sum[j] - sum[k] && f[j][k] != INF64) {
						f[i][j] = std::min(f[i][j], f[j][k] + sqr(sum[i] - sum[j]));
					}
				}
			}
		}
		LL ans = INF64;
		for (int i = 0; i < n; i++) ans = std::min(ans, f[n][i]);
		printf("%lld\n", ans);
	}
}
namespace AK {
	const int N = 5e3;
	
	LL f[N + 5][N + 5];
	
	LL sqr(LL x) {
		return x * x;
	}
	void main() {
		for (int i = 0; i <= n; i++) f[i][0] = sqr(sum[i]);
		for (int j = 1; j < n; j++) {
			int k = j - 1;
			for (; k >= 0 && f[j][k] == INF64; k--);
			for (int i = j + 1; i <= n; i++) {
				if (k >= 0 && sum[i] - sum[j] >= sum[j] - sum[k]) {
					f[i][j] = f[j][k] + sqr(sum[i] - sum[j]);
				} else {
					f[i][j] = INF64;
				}
			}
		}
		LL ans = INF64;
		for (int i = 0; i < n; i++) ans = std::min(ans, f[n][i]);
		printf("%lld\n", ans);
	}
}
namespace IOI {
	#define lson (u << 1)
	#define rson (u << 1 | 1)
	
	const int N = 5e5;
	
	int tag[4 * N + 5], val[4 * N + 5];
	
	void update(int u, int w) {
		tag[u] = val[u] = w;
	}
	void pushDown(int u) {
		if (tag[u] >= 0) {
			update(lson, tag[u]);
			update(rson, tag[u]);
			tag[u] = -1;
		}
	}
	void build(int u, int l, int r) {
		tag[u] = -1, val[u] = 0;
		if (l == r) return;
		int mid = (l + r) >> 1;
		build(lson, l, mid);
		build(rson, mid + 1, r);
	}
	void modify(int u, int l, int r, int x, int y, int w) {
		if (x == l && r == y) return update(u, w);
		pushDown(u);
		int mid = (l + r) >> 1;
		if (y <= mid) {
			modify(lson, l, mid, x, y, w);
		} else if (x > mid) {
			modify(rson, mid + 1, r, x, y, w);
		} else {
			modify(lson, l, mid, x, mid, w);
			modify(rson, mid + 1, r, mid + 1, y, w);
		}
	}
	int query(int u, int l, int r, int x) {
		if (l == r) return val[u];
		pushDown(u);
		int mid = (l + r) >> 1;
		if (x <= mid) {
			return query(lson, l, mid, x);
		} else {
			return query(rson, mid + 1, r, x);
		}
	}
	LL sqr(LL x) {
		return x * x;
	}
	void main() {
		build(1, 1, n);
		for (int j = 1; j < n; j++) {
			int k = query(1, 1, n, j);
			int i = std::lower_bound(sum + 1, sum + n + 1, sum[j] + sum[j] - sum[k]) - sum;
			if (i <= n) modify(1, 1, n, i, n, j);
		}
		LL ans = 0;
		for (int i = n; i > 0; ) {
			int j = query(1, 1, n, i);
			ans += sqr(sum[i] - sum[j]);
			i = j;
		}
		printf("%lld\n", ans);
	}
}
//namespace STD {
//	const int N = 4e7, M = 1e5;
//	
//	int b[N + 5], p[N + 5], q[M + 5], l[M + 5], r[M + 5], x, y, z, m;
//	LL sum[N + 5];
//	
//	void main() {
//		scanf("%d%d%d%d%d%d", &x, &y, &z, &b[1], &b[2], &m);
//		for (int i = 1; i <= m; i++) {
//			scanf("%d%d%d", &q[i], &l[i], &r[i]);
//		}
//		int mod = (1 << 30) - 1;
//		for (int i = 3; i <= n; i++) b[i] = ((LL)x * b[i - 1] + (LL)y * b[i - 2] + z) & mod;
//		q[0] = 0;
//		for (int j = 1; j <= m; j++) {
//			for (int i = q[j - 1] + 1; i <= q[j]; i++) {
//				sum[i] = sum[i - 1] + (b[i] % (r[j] - l[j] + 1)) + l[j];
//			}
//		}
//		for (int i = 0, j = 1; j < n; j++) {
//			p[j] = std::max(p[j], p[j - 1]);
//			for (; i >= 1 && sum[i] >= sum[j] + sum[j] - sum[p[j]]; i--);
//			for (; i <= n && sum[i] < sum[j] + sum[j] - sum[p[j]]; i++);
//			if (i <= n) p[i] = j;
//		}
//		p[n] = std::max(p[n], p[n - 1]);
//		long double ans = 0;
//		for (int i = n; i > 0; ) {
//			int j = p[i];
//			ans += (long double)(sum[i] - sum[j]) * (sum[i] - sum[j]);
//			i = j;
//		}
//		printf("%.0Lf\n", ans);
//	}
//}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &type);
	if (type == 0) {
		for (int i = 1; i <= n; i++) scanf("%lld", &sum[i]), sum[i] += sum[i - 1];
		if (n <= 400) {
			Qiyang::main();
			return 0;
		}
		if (n <= 5000) {
			AK::main();
			return 0;
		}
		if (n <= 500000) {
			IOI::main();
			return 0;
		}
	}
	return 0;
}
