#include<bits/stdc++.h>

typedef long long ull; 

const int N = 3e5; 

int T; 
int n; 

int cnt; 
int head[N + 3], nxt[N << 1 | 3], ed[N << 1 | 3]; 

int fa[N + 3], sz[N + 3]; 
int rd[N + 3]; 

int q[N + 3], f, e; 
bool vis[N + 3]; 
int dep[N + 3]; 

ull res; 

inline int read() {
	int res = 0; char ch = getchar(); while(!isdigit(ch)) ch = getchar(); 
	while(isdigit(ch)) res = res * 10 + ch - '0', ch = getchar(); return res; 
}

inline void addedge(int a, int b) {cnt++; ed[cnt] = b; nxt[cnt] = head[a], head[a] = cnt; }

inline void stage_clear() {
	cnt = 0; memset(head, 0, sizeof(head[0]) * (n + 3)); 
	memset(fa, 0, sizeof(fa[0]) * (n + 3)); res = 0; 
	memset(rd, 0, sizeof(rd[0]) * (n + 3)); 
}

int rt, cnt1, cnt2; 
void dfs1(int u) {
	// printf("u = %d\n", u); // 
	sz[u] = 1; 
	for(int p = head[u]; p; p = nxt[p]) {
		int v = ed[p]; if(v == fa[u]) continue; 
		fa[v] = u; dfs1(v); sz[u] += sz[v]; 
	}
}
void getf(int x, int f) {int u = fa[x]; while(u) sz[u] += sz[x] * f, u = fa[u]; }
void dfs1_1(int u) {
	if(cnt1 >= 2) return ; 
	bool flag = (sz[rt] - sz[u] <= sz[rt] / 2); if(!flag) return ; 
	for(int p = head[u]; p; p = nxt[p]) {
		int v = ed[p]; if(v == fa[u] || v == rt) continue; 
		if(sz[v] > (sz[rt] / 2)) flag = 0; dfs1_1(v); 
	} if(flag) res += u, cnt1++; 
}
void dfs1_2(int u) {
	if(cnt2 >= 2) return ; 
	bool flag = (sz[1] - sz[u] <= sz[1] / 2); if(!flag) return ; 
	for(int p = head[u]; p; p = nxt[p]) {
		int v = ed[p]; if(v == fa[u] || v == rt) continue; 
		if(sz[v] > (sz[1] / 2)) flag = 0; dfs1_2(v); 
	} if(flag) res += u, cnt2++; 
}
void solve1() {
	dfs1(1); 
	for(rt = 2; rt <= n; rt++) {
		cnt1 = cnt2 = 0; dfs1_1(rt); getf(rt, -1); dfs1_2(1); getf(rt, 1); 
	} printf("%lld\n", res); 
}

inline int getv(int a, int b) {
	if((a - b) & 1) return q[(b - a + 1) / 2 + a - 1] + q[(b - a + 1) / 2 + a]; 
	return q[(a + b) >> 1]; 
}
bool isl() {
	for(int i = 1; i <= n; i++) {
		if(rd[i] > 2) return 0; 
	} return 1; 
}
void bfs2() {
	for(int i = 1; i <= n; i++) if(rd[i] == 1) {q[f = e = 1] = i; vis[i] = 1; break; }
	while(f <= e) {
		int u = q[f++]; for(int p = head[u]; p; p = nxt[p]) {
			int v = ed[p]; if(!vis[v]) vis[v] = 1, q[++e] = v; 
		}
	}
}
void solve2() {
	bfs2(); 
	for(int i = 2; i <= n; i++) {
		if(i == 2) res += q[1] + getv(2, n); 
		else if(i == n) res += q[n] + getv(1, n - 1); 
		else res += getv(1, i - 1) + getv(i, n); 
	} printf("%lld\n", res); memset(vis, 0, sizeof(vis[0]) * (n + 3)); 
}

void work() {
	stage_clear(); 
	n = read(); for(int i = 1; i < n; i++) {
		int x = read(), y; y = read(); 
		addedge(x, y), addedge(y, x); 
		rd[x]++; rd[y]++; 
	}
	// printf("n = %d\n", n); // 
	if(n <= 2000) solve1(); 
	else if(isl()) {solve2(); return ; }
	else solve1(); 
}

int main() {
	freopen("centroid.in" , "r", stdin ); 
	freopen("centroid.out", "w", stdout); 
	T = read(); while(T--) work(); 
	return 0; 
}