#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define IN 2000000000LL
#define INF 4000000000000000000LL
#define N 40010000
#define M 500010
ll a[N],s[N],dp[410][410],f[5100],L[5100];
int n,Type;
inline int read(){
	char ch=getchar(); int x=0;
	for (;ch>'9'||ch<'0';ch=getchar());
	for (;ch>='0'&&ch<='9';ch=getchar()) x=x*10+ch-'0';
	return x;
}
struct node{
	ll f; int L;
	node(){}
	node(ll f,int L):f(f),L(L){}
};
struct Tree{
	int Tagy[M<<2];
	ll f[M<<2],Tagx[M<<2];
	int L[M<<2];
	void build(int t,int l,int r){
		if (l==r){
			if (s[l]>=IN) f[t]=INF; else f[t]=s[l]*s[l];
			L[t]=1;
			return;
		}
		int mid=(l+r)>>1;
		build(t<<1,l,mid); build(t<<1|1,mid+1,r);
	}
	void pushdown(int t,int l,int r){
		if (!(Tagx[t] || Tagy[t])) return;
		int mid=l+r>>1;
		if (l==mid){
			if ((s[l]-s[Tagy[t]])>=IN) f[t<<1]=INF; else
			f[t<<1]=Tagx[t]+(s[l]-s[Tagy[t]])*(s[l]-s[Tagy[t]]);
			L[t<<1]=Tagy[t]+1;
		}else{
			Tagx[t<<1]=Tagx[t]; Tagy[t<<1]=Tagy[t];
		}
		if (mid+1==r){
			if ((s[r]-s[Tagy[t]])>=IN) f[t<<1|1]=INF; else
			f[t<<1|1]=Tagx[t]+(s[r]-s[Tagy[t]])*(s[r]-s[Tagy[t]]);
			L[t<<1|1]=Tagy[t]+1;
		}else{
			Tagx[t<<1|1]=Tagx[t]; Tagy[t<<1|1]=Tagy[t];
		}
		Tagx[t]=Tagy[t]=0;
	}
	node query(int t,int l,int r,int x){
		if (l==r){return node(f[t],L[t]);}
		pushdown(t,l,r);
		int mid=(l+r)>>1;
		if (x<=mid) return query(t<<1,l,mid,x); else return query(t<<1|1,mid+1,r,x);
	}
	void change(int t,int l,int r,int LL,int R,ll x,int y){
		if (LL<=l && r<=R){
			Tagx[t]=x; Tagy[t]=y; 
			if (l==r){
				if ((s[l]-s[y])>=IN) f[t]=INF; else f[t]=Tagx[t]+(s[l]-s[y])*(s[l]-s[y]);
				L[t]=y+1;
				Tagx[t]=Tagy[t]=0;
			}
			return;
		}
		pushdown(t,l,r);
		int mid=l+r>>1;
		if (LL<=mid) change(t<<1,l,mid,LL,R,x,y);
		if (R>mid) change(t<<1|1,mid+1,r,LL,R,x,y);
	}
}T;
int main(){
	freopen("partition.in","r",stdin); freopen("partition.out","w",stdout);
	n=read(),Type=read();
	if (Type==1) {return 0;}
	for (int i=1;i<=n;i++) a[i]=read();
	for (int i=1;i<=n;i++) s[i]=s[i-1]+a[i];
	if (n<=400){
		memset(dp,-1,sizeof(dp));
		for (int i=1;i<=n;i++) dp[1][i]=s[i]*s[i];
		for (int i=1;i<n;i++){
			for (int j=i;j<n;j++){
				if (dp[i][j]!=-1){
					for (int k=j+1;k<=n;k++)
						if (s[k]-s[j]>=s[j]-s[i-1]) 
							dp[j+1][k]=(dp[j+1][k]==-1)?(dp[i][j]+(s[k]-s[j])*(s[k]-s[j])):min(dp[j+1][k],dp[i][j]+(s[k]-s[j])*(s[k]-s[j]));
				}
			}
		}
		ll Ans=(ll)4*(ll)1e18;
		for (int i=1;i<=n;i++) if (dp[i][n]!=-1) Ans=min(Ans,dp[i][n]);
		printf("%lld\n",Ans);
		return 0;
	}
	if (n<=5000){
		for (int i=1;i<=n;i++) f[i]=s[i]*s[i],L[i]=1;
		for (int i=1;i<n;i++){
			for (int j=i+1;j<=n;j++){
				if (f[j]>f[i]+(s[j]-s[i])*(s[j]-s[i]) && s[i]-s[L[i]-1]<=s[j]-s[i]){
					f[j]=f[i]+(s[j]-s[i])*(s[j]-s[i]);
					L[j]=i+1;
				}
			}
		}
		printf("%lld\n",f[n]);
	//	for (int i=1;i<=n;i++) printf("%lld ",f[i]); puts("");
	//	for (int i=1;i<=n;i++) printf("%lld ",L[i]); puts("");
		return 0;
	}
	if (n<=500000){
		T.build(1,1,n);
		for (int i=1;i<n;i++){
			node p=T.query(1,1,n,i);
			ll x=s[i]-s[p.L-1];
			int LL=i+1,RR=n,k=n+1;
			while (LL<=RR){
				int mid=(LL+RR)>>1;
				if (s[mid]-s[i]>=x) k=mid,RR=mid-1;
				else LL=mid+1;
			}
			if (k<=n) T.change(1,1,n,k,n,p.f,i);
		}
		printf("%lld\n",(T.query(1,1,n,n)).f);
	//	for (int i=1;i<=n;i++) printf("%lld ",T.query(1,1,n,i).f); puts("");
	//	for (int i=1;i<=n;i++) printf("%d ",T.query(1,1,n,i).L); puts("");
		return 0;
	}
	return 0;
}
