#include <bits/stdc++.h>
using namespace std;

const int N = 100 + 10;
const int M = 2000 + 10;
const int P = 998244353;

int n, m, k;
int a[N][M], b[M];
long long ans;

int read()
{
	int sum = 0;
	char c = getchar(), f;
	while(c < '0' || c > '9') f = c, c = getchar();
	while(c >= '0' && c <= '9') sum = sum * 10 + c - '0', c = getchar();
	if(f == '-') sum *= -1;
	return sum;
}

void DFS(int u, int v, long long sum)
{
	if(sum == 0) return ;
	if(u == n + 1 && v == k) { ans = (ans + sum) % P; return ; }
	if(u == n + 1) return ;
	for(int i = 1; i <= m; i++)
	{
		if(b[i] * 2 + 1 >= k) continue;
		b[i]++;
		DFS(u + 1, v + 1, sum * (long long)a[u][i] % P);
		b[i]--;
	}
	DFS(u + 1, v, sum);
}

void Solve1()
{
	for(k = 1; k <= n; k++) DFS(1, 0, 1);
	printf("%lld\n", ans);
}

int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	n = read(), m = read();
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++)
			a[i][j] = read();
	if(n <= 10) { Solve1(); return 0; }
	return 0;
}
