#include<bits/stdc++.h>
using namespace std;
#define LL long long
char cnc1;
const int M=3e5+5;
int n;
int Head[M],Nxt[M<<1],To[M<<1],edgeCnt;
void addEdge(const int a,const int b) {
	Nxt[++edgeCnt]=Head[a];
	Head[a]=edgeCnt;
	To[edgeCnt]=b;
}
inline void tomax(int &a,const int b) {
	(a<b)&&(a=b);
}
int a[M],b[M];
namespace p40 {
	int Size[M],tot;
	LL Ans=0;
	void predfs(int x,int f) {
		++tot;
		for(int i=Head[x]; i; i=Nxt[i]) {
			const int u=To[i];
			if(u==f)continue;
			predfs(u,x);
		}
	}
	void dfs(int x,int f) {
		Size[x]=1;
		int Max=0;
		for(int i=Head[x]; i; i=Nxt[i]) {
			const int u=To[i];
			if(u==f)continue;
			dfs(u,x),Size[x]+=Size[u];
			tomax(Max,Size[u]);
		}
		tomax(Max,tot-Size[x]);
		if(Max<=(tot>>1))Ans+=x;
	}
	void Solve() {
		Ans=0;
		for(int i=1; i<n; ++i) {
			tot=0;
			predfs(a[i],b[i]);
			dfs(a[i],b[i]);
			tot=0;
			predfs(b[i],a[i]);
			dfs(b[i],a[i]);
		}
		printf("%lld\n",Ans);
	}
}
namespace p55 {
	LL Ans;
	int A[M];
	int Calc(int a,int b) {
		bool flag=(b-a)&1;
		if(flag)return A[(b+a)>>1]+A[(b+a+1)>>1];
		else return A[(b+a)>>1];
	}
	void Solve() {
		Ans=0;
		for(int i=1; i<n; ++i)
			A[i]=a[i];
		A[n]=b[n-1];
		for(int i=1; i<n; ++i) {
			Ans+=Calc(1,i);
			Ans+=Calc(i+1,n);
		}
		printf("%lld\n",Ans);
	}
}
namespace p75 {
	int degree[M];
	int Size[M],L[M],R[M],dfn;
	void dfs(int x,int f) {
		Size[x]=1,L[x]=++dfn;
		for(int i=Head[x]; i; i=Nxt[i]) {
			const int u=To[i];
			if(u==f)continue;
			dfs(u,x);
			Size[x]+=Size[u];
		}
		R[x]=dfn;
	}
	LL Ans=0;
	void Solve() {
		for(int i=1; i<n; ++i) {
			++degree[a[i]];
			++degree[b[i]];
		}
		int Root=0;
		for(int i=1; i<=n; ++i)
			if(degree[i]==2)Root=i;
		Ans=1LL*n*(n+1)/2;
//		printf("Ans=%lld\n",Ans);
		dfs(Root,0);
		Ans-=Root;
//		printf("Root=%d\n",Root);
		int Son1=To[Head[Root]],Son2=To[Nxt[Head[Root]]];
//		printf("Son1=%d Son2=%d\n",Son1,Son2);
		for(int i=1; i<=n; ++i)
			if(i!=Root) {
//				int tot=n-Size[i];
				if(i!=Son1) {
					if(L[Son1]<=L[i]&&R[i]<=R[Son1]);
					else Ans+=Son1;
				}
				if(i!=Son2){
					if(L[Son2]<=L[i]&&R[i]<=R[Son2]);
					else Ans+=Son2;
				}
				if(Size[i]==1)Ans+=Root;
			}
		printf("%lld\n",Ans);
	}
}
char cnc2;
int main() {
//	cerr<<"Memory="<<(&cnc2-&cnc1)*1.0/1024/1024<<"MB"<<endl;
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--) {
		scanf("%d",&n);
		memset(Head,0,sizeof Head);
		edgeCnt=0;
		for(int i=1; i<n; ++i) {
			scanf("%d%d",a+i,b+i);
			addEdge(a[i],b[i]);
			addEdge(b[i],a[i]);
		}
		if(n<=2000)p40::Solve();
		else if(n==49991)p55::Solve();
		else if(n==262143)p75::Solve();
	}
	return 0;
}
