#include<cstdio>
#include<algorithm>
#define ll long long
using namespace std;
int num, T, n, cnt, last[1000005], vis[1000005], sz[1000005], F[1000005], x[1000005], y[1000005], a[1000005], in[1000005];
ll ans;
struct node
{
	int to, next;
}e[1000005];
void add(int a, int b)
{
	e[++cnt].to = b;
	e[cnt].next = last[a];
	last[a] = cnt;
}
void dfs(int x)
{
	vis[x] = 1;
	num++;
	for (int i = last[x]; i; i = e[i].next)
	{
		int V = e[i].to;
		if (vis[V]) continue;
		dfs(V);
	}
}
void solve(int x, int fa)
{
	sz[x] = 1;
	for (int i = last[x]; i; i = e[i].next)
	{
		int V = e[i].to;
		if (V == fa) continue;
		solve(V, x);
		F[x] = max(F[x], sz[V]);
		sz[x] += sz[V];
	}
	F[x] = max(F[x], num - sz[x]);
	if (F[x] <= num / 2) 
	{
		ans += x;
	}
}
void calc(int l, int r)
{
	if ((l + r) % 2 == 0)
	{
		ans += a[(l + r) / 2];
	}
	else
	{
		ans += a[(l + r) / 2];
		ans += a[(l + r) / 2 + 1];
	}
}
int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T--)
	{
		ans = 0;
		scanf("%d", &n);
		for (int i = 1; i < n; i++)
		{
			scanf("%d%d", &x[i], &y[i]);
		}
		if (n <= 2000)
		{
			for (int now = 1; now < n; now++)
			{
				cnt = 0;
				for (int i = 1; i <= n; i++) last[i] = 0;
				for (int i = 1; i < n; i++)
					if (i != now)
					{
						add(x[i], y[i]);
						add(y[i], x[i]);
					}
				for (int i = 1; i <= n; i++)
				{
					vis[i] = 0;
					F[i] = 0;
				}
				num = 0;
				dfs(1);
				solve(1, 0);
				for (int i = 1; i <= n; i++)
				{
					if (!vis[i])
					{
						num = 0;
						dfs(i);
						solve(i, 0);
					}
				}
			}
			printf("%lld\n", ans);
		}
		else
		{
			for (int i = 1; i <= n; i++) in[i] = 0;
			cnt = 0;
			for (int i = 1; i <= n; i++) last[i] = 0;
			for (int i = 1; i < n; i++)
			{
				add(x[i], y[i]);
				add(y[i], x[i]);
			}
			for (int i = 1; i < n; i++)
			{
				in[x[i]]++;
				in[y[i]]++;
			}
			int f = 1;
			for (int i = 1; i <= n; i++)
				if (in[i] > 2)
				{
					f = 0;
					break;
				}
			if (f)
			{
				int rt = 0;
				for (int i = 1; i <= n; i++)
				{
					if (in[i] == 1)
					{
						rt = i;
						break;
					}
				}
				a[1] = rt;
				for (int j = 1; j < n; j++)
				{
					int x = a[j];
					for (int i = last[x]; i; i = e[i].next)
					{
						int V = e[i].to;
						if (V == a[j - 1]) continue;
						a[j + 1] = V;
					}
				}
				for (int i = 1; i < n; i++)
				{
					calc(1, i);
					calc(i + 1, n);
				}
				printf("%lld\n", ans);
			}
		}
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
*/
