#include <cstdio>
typedef long long LL;
const int N = 41, M = 510;
const LL P = 998244353;
inline LL addmod(LL h) { if (h >= P) h -= P; return h; }
inline LL minmod(LL h) { if (h < 0) h += P; return h; }

int n, m;
LL a[N][M], sumaj[N];
LL f[N][N], g[M][N][N][N];
int main() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  scanf("%d %d", &n, &m);
  for (int i = 1; i <= n; ++i)
    for (int j = 1; j <= m; ++j)
      scanf("%lld", &a[i][j]), sumaj[i] = addmod(sumaj[i] + a[i][j]);
  f[0][0] = 1;
  for (int i = 1; i <= n; ++i) {
    f[i][0] = 1;
    for (int j = 1; j <= i; ++j)
      f[i][j] = addmod(f[i - 1][j] + (f[i - 1][j - 1] * sumaj[i]) % P);
  }
  for (int k = 1; k <= m; ++k) {
    g[k][0][0][0] = 1;
    for (int i = 1; i <= n; ++i) {
      g[k][i][0][0] = 1;
      for (int j = 1; j <= i; ++j) {
        for (int w = 0; w <= j; ++w) {
          g[k][i][j][w] = g[k][i - 1][j][w];
          g[k][i][j][w] = addmod(g[k][i][j][w] + (g[k][i - 1][j - 1][w] * minmod(sumaj[i] - a[i][k])) % P);
          if (w > 0)
            g[k][i][j][w] = addmod(g[k][i][j][w] + (g[k][i - 1][j - 1][w - 1]) * a[i][k] % P);
        }
      }
    }
  }
  LL ans = 0;
  for (int j = 1; j <= n; ++j) {
    ans = addmod(ans + f[n][j]);
    for (int k = 1; k <= m; ++k) {
      for (int w = j / 2 + 1; w <= n; ++w)
        ans = minmod(ans - g[k][n][j][w]);
    }
  }
  printf("%lld\n", ans);
  return 0;
}     
