#include <cstdio>

long long read()
{
	char last = '+', ch = getchar();
	while (ch < '0' || ch > '9') last = ch, ch = getchar();
	long long tmp = 0;
	while (ch >= '0' && ch <= '9') tmp = tmp * 10 + ch - 48, ch = getchar();
	if (last == '-') tmp = -tmp;
	return tmp;
}

const int M = 998244353;
const int _n = 100 + 10, _m = 2000 + 10;
int n, m;
int x[_n][_m];
int s[_n];
int ans;
int f[_n][2 * _n];

int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	n = read();
	m = read();
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			x[i][j] = read();
			(s[i] += x[i][j]) %= M;
		}
	}
	ans = 1;
	for (int i = 1; i <= n; i++)
	{
		ans = (long long)ans * (s[i] + 1) % M;
	}
	ans = (ans + M - 1) % M;
	for (int t = 1; t <= m; t++)
	{
		f[0][0 + 105] = 1;
		for (int i = 1; i <= n; i++)
		{
			for (int j = -i; j <= i; j++)
			{
				f[i][j + 105] = f[i - 1][j + 105];
				(f[i][j + 105] += (long long)f[i - 1][j - 1 + 105] * x[i][t] % M) %= M;
				(f[i][j + 105] += (long long)f[i - 1][j + 1 + 105] * (s[i] - x[i][t]) % M) %= M;
				f[i][j + 105] = (f[i][j + 105] + M) % M;
			}
		}
		for (int j = 1; j <= n; j++)
		{
			ans = (ans - f[n][j + 105]) % M;
		}
	}
	ans = (ans + M) % M;
	printf("%d\n", ans);
	return 0;
}




