#include <cstdio>
#include <algorithm>

long long read()
{
	char last = '+', ch = getchar();
	while (ch < '0' || ch > '9') last = ch, ch = getchar();
	long long tmp = 0;
	while (ch >= '0' && ch <= '9') tmp = tmp * 10 + ch - 48, ch = getchar();
	if (last == '-') tmp = -tmp;
	return tmp;
}

const int _n = 500000 + 10;
int n, type;
long long x[_n], s[_n], f[_n];
int pre[_n];

int main()
{
	scanf("%d%d", &n, &type);
	for (int i = 1; i <= n; i++)
	{
		x[i] = read();
		s[i] = s[i - 1] + x[i];
	}
	f[0] = 0;
	f[1] = x[1] * x[1];
	pre[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		f[i] = s[i] * s[i];
		pre[i] = 0;
		for (int j = 1; j <= n; j++)
		{
			if (s[i] - s[j] >= s[j] - s[pre[j]])
			{
				if (f[j] + (s[i] - s[j]) * (s[i] - s[j]) <= f[i])
				{
					f[i] = f[j] + (s[i] - s[j]) * (s[i] - s[j]);
					pre[i] = j;
				}
			}
		}
		printf("%lld\n", 2 * s[i] - s[pre[i]]);
	}
	printf("%lld\n", f[n]);
	return 0;
}
