#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#define For(i, l, r) for(int i = (int)(l); i <= (int)(r); ++i)
#define Rep(i, r, l) for(int i = (int)(r); i >= (int)(l); --i)

using namespace std;
typedef long long LL;
const int MOD = 998244353, INF = 0x3f3f3f3f;
const int N = 110, M = 2010;
int dp[N][N][N], a[N][M], sum[N];

inline void upd(int &x, int y) {x += y; x -= x >= MOD ? MOD : 0;}
inline int add(int x, int y) {x += y; x -= x >= MOD ? MOD : 0; return x;}
inline int dec(int x, int y) {x -= y; x += x < 0 ? MOD : 0; return x;}
inline int mul(int x, int y) {return 1LL * x * y % MOD;}

inline LL read() {
	LL x = 0, f = 1;
	char ch = getchar();
	while(!isdigit(ch) && ch != '-') ch = getchar();
	if (ch == '-') {f = -1; ch = getchar();}
	while(isdigit(ch)) {
		x = (x << 1) + (x << 3) + (ch ^ 48);
		ch = getchar();
	}
	return x * f;
}

inline int gett(int x, int y, int z) {
	if (x < 0 || y < 0 || z < 0) return 0;
	return dp[x][y][z];
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	int n = read(), m = read();
	For(i, 1, n) For(j, 1, m) {
		a[i][j] = read();
		upd(sum[i], a[i][j]);
	}
	int ans = 1;
	For(i, 1, n) ans = mul(ans, sum[i] + 1);
	ans = dec(ans, 1);
	dp[0][0][0] = 1;
	For(j, 1, m) {
		For(i, 1, n) {
			For(al, 0, i) {
				For(gt, 0, al) {
					dp[i][al][gt] = add(gett(i - 1, al, gt), add(mul(gett(i - 1, al - 1, gt), sum[i] - a[i][j]), mul(gett(i - 1, al - 1, gt - 1), a[i][j])));
				}
			}
		}
		For(al, 1, n) For(gt, al / 2 + 1, al) ans = dec(ans, dp[n][al][gt]);
	}
	printf("%d\n", ans);
	fclose(stdin); fclose(stdout);
	return 0;
}
