#include "bits/stdc++.h"

template<typename T>
inline void read(T &x)
{
	x = 0;
	int neg = 0;
	char c = getchar();
	for(; !isdigit(c); c = getchar())
	{
		if(c == '-')
		{
			neg = 1;
		}
	}
	for(; isdigit(c); c = getchar())
	{
		x = x * 10 + c - '0';
	}
	if(neg)
	{
		 x = -x;
	}
}

typedef long long ll;

const int MOD = 998244353;
const int N = 100 + 5;
const int M = 2000 + 5;

int n, m;
int a[N][M];

int dp[N][M];

int ans;

inline int calc(int tar, int pos)
{
	if(tar == 1)
	{
		dp[tar][pos] = n - pos + 1;
		return dp[tar][pos];
	}
	if(dp[tar][pos] != -1)
	{
		return dp[tar][pos];
	}
	int res = a[n - tar + 1][pos];
	for(int i = pos + 1; i <= n - tar + 1; i++)
	{
		res *= calc(tar - 1, i);
		res %= MOD;
	}
	dp[tar][pos] = res;
	return res;
}

int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	
	memset(dp, -1, sizeof(dp));
	read(n);
	read(m);
	
	for(int i = 1; i <= n; i++)
	{
		for(int j = 1; j <= m; j++)
		{
			read(a[i][j]);
		}
	}
	
//	for(int k = 2; k <= n; k++)
//	{
//		for(int i = 1; i <= n; i++)
//		{
//			for(int j = 1; j <= m; j++)
//			{
//			}
//		}
//	}
	for(int i = 2; i <= n; i++)
	{
		ans += calc(i, 1);
		ans %= MOD;
	}
	printf("%d\n", ans);
}
