#include<cstdio>
#include<algorithm>
#include<cstring>
#include<cmath>
using namespace std;
typedef long long ll;
const int maxn=2e5+10;
int head[maxn],nxt[maxn],ver[maxn],tot,from[maxn],vis[maxn];
ll dive[maxn];
ll n,size[maxn];
ll ans;
ll dfs(int u,int fa);
void work(int u);

inline int read(){
	int f=0,w=1;char c;
	while(c<'0'||c>'9'){
		if(c=='-')w=-1;
		c=getchar();
	}
	while(c>='0'&&c<='9'){
		f=f*10+c-'0';
		c=getchar();
	}
		return f*w;
}

inline void add(int u,int v)
{
	ver[++tot]=v;from[tot]=u;nxt[tot]=head[u];head[u]=tot;	
}

int main()
{
		freopen("centroid.in","r",stdin);
		freopen("centroid.out","w",stdout);
	int t;
	t=read();
		while(t--)
{
		tot=0;memset(dive,0,sizeof(dive));
			  memset(size,0,sizeof(size));
			  memset(vis,0,sizeof(vis));
			  ans=0;
	n=read();
		for(int i=1;i<n;i++)
{
	head[i]=ver[i]=nxt[i]=from[i]=0;
}
		for(int i=1;i<n;i++)
	{
		int u,v;u=read();v=read();
		add(u,v);add(v,u);size[i]=1;dive[i]=0;
	}
			size[n]=1;
		for(int i=1;i<=tot;i+=2)
	{
		dfs(from[i],ver[i]);
		work(from[i]);
		dfs(ver[i],from[i]);
//			printf("%lld %lld\n",size[2],size[3]);
		work(ver[i]);
	}
		printf("%lld\n",ans);
}
	fclose(stdin);
	fclose(stdout);
	return 0;
}

ll dfs(int u,int fa)
{
		vis[u]=1;
	for(int i=head[u];i;i=nxt[i])
{
		ll tem=0;
	if(ver[i]==fa)continue;
		tem=dfs(ver[i],u);	
			size[u]+=tem;
			dive[u]=max(dive[u],tem);
}
	return size[u];
}

void work(int u)
{
	ll rec=0x3f3f3f3f;
	ll sum=0;
		for(int i=1;i<=n;i++)
	{
		if(vis[i])sum=max(sum,size[i]);
	}
	
	for(int i=1;i<=n;i++)
{
		if(!vis[i])continue;
	dive[i]=max(dive[i],sum-size[i]);
		if(dive[i]<rec)rec=dive[i];
}
//			printf("%lld %lld\n",dive[2],dive[3]);
	for(int i=1;i<=n;i++)
		if(vis[i]&&dive[i]==rec)ans+=i;
//			printf("%lld\n",ans);
	for(int i=1;i<=n;i++)
{
		size[i]=1;vis[i]=0;dive[i]=0;
}
}
