#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
const int maxn = 1005;
int o,n,x,y,ans,sx,sy;
int xb,first[maxn],nxt[maxn],dx[maxn],last[maxn];
bool del[maxn],g[maxn][maxn];

int sz(int x,int fa) {
	int ans = 1;
	for (int i = first[x]; i; i = nxt[i])
		if (dx[i] != fa && g[x][dx[i]])
			ans += sz(dx[i],x);
	return ans;
}

bool check(int x,int gs) {
	for (int i=first[x]; i; i = nxt[i]) 
		if (g[x][dx[i]])
			if (sz(dx[i],x) > gs / 2)
				return 0;
	return 1;
}

int dfs(int x,int fa,int gs) {
	int ans = 0;
	if (check(x,gs))
		ans = x;
	for (int i=first[x]; i; i = nxt[i])
		if (g[x][dx[i]] && dx[i] != fa)
			ans += dfs(dx[i],x,gs);
	return ans;
}

void build(int x,int y) {
	dx[++xb] = y;
	if (!first[x])
		first[x] = xb; else
		nxt[last[x]] = xb;
	last[x] = xb;
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&o);
	while (o--) {
		memset(g,0,sizeof(g));
		memset(first,0,sizeof(first));
		memset(last,0,sizeof(last));
		memset(dx,0,sizeof(dx));
		memset(nxt,0,sizeof(nxt));
		xb = ans = 0;
		scanf("%d",&n);
		for (int i=1; i<n; i++) {
			scanf("%d%d",&x,&y);
			g[x][y] = g[y][x] = 1;
			build(x,y);
			build(y,x);
		}
		
		for (int i=1; i<=n; i++)
			for (int j=first[i]; j; j = nxt[j]) {
				int x = i,y = dx[j];
				g[x][y] = g[y][x] = 0;
				sx = sz(x,0);
				sy = sz(y,0);
				ans += dfs(x,0,sx);
				ans += dfs(y,0,sy);
				g[x][y] = g[y][x] = 1;
			}
		printf("%d\n",ans / 2);
	}
	return 0;
}
