#include<bits/stdc++.h>
#define fi first
#define se second
#define LL long long
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
using namespace std;
const int N = 1e6 + 10;

template <typename T> void read(T &x) {
   char c = getchar(); int f = 0;
   while (c < '0' || c > '9') f |= (c == '-'), c = getchar();
   for (x = 0; c >= '0' && c <= '9'; c = getchar())
      x = (x << 3) + (x << 1) + (c ^ '0');
   if (f) x = -x;
}

int n, m, E;
int u[N], v[N];
int fir[N], nex[N], arr[N], deg[N];
LL ans = 0;

inline void Add_Edge(int x, int y) {
   nex[++E] = fir[x];
   fir[x] = E; arr[E] = y;
}

namespace Subtask1 {

   int siz[N], tot;
   
   void dfs1(int x, int fa) {
      siz[x] = 1;
      for (int i = fir[x]; i; i = nex[i]) {
	 if (arr[i] == fa) continue;
	 dfs1(arr[i], x);
	 siz[x] += siz[arr[i]];
      }
   }

   void dfs2(int x, int fa) {
      int mx = 0;
      for (int i = fir[x]; i; i = nex[i]) {
	 if (arr[i] == fa) continue;
	 dfs2(arr[i], x);
	 mx = max(mx, siz[arr[i]]);
      }
      mx = max(mx, tot - siz[x]);
      if (mx * 2 <= tot) {
	 ans += x;
	 //	 cout << tot << endl;
	 //	 cout << x << ' ' << mx << ' ' << endl;
      }
   }
   
   void solve(int x, int y) {
      dfs1(x, y);
      tot = siz[x];
      dfs2(x, y);
   }
   
   void main() {
      ans = 0;
      for (int i = 1; i < n; ++i) {
	 solve(u[i], v[i]);
	 //	 puts("---------");
	 solve(v[i], u[i]);
      }
      cout << ans << endl;
   }
}

namespace Subtask2 {

   int o, pos[N], ord[N];
   LL ans = 0;
   
   void dfs(int x, int fa) {
      ord[++o] = x;
      pos[x] = o;
      for (int i = fir[x]; i; i = nex[i]) {
	 if (arr[i] == fa) continue;
	 dfs(arr[i], x);
      }
   }
   
   void main() {
      ans = 0; o = 0;
      for (int i = 1; i <= n; ++i) {
	 if (deg[i] == 1) {
	    dfs(i, 0);
	    break;
	 }
      }
      for (int i = 1; i < n; ++i) {
	 int x = pos[u[i]], y = pos[v[i]];
	 if (x > y) swap(x, y);
	 if (x >= 1) {
	    if (x % 2 == 1) {
	       ans += ord[(x + 1) / 2];
	    }
	    else {
	       ans += ord[x / 2] + ord[x / 2 + 1];
	    }
	 }
	 if (y <= n) {
	    int len = n - y + 1;
	    if (len % 2 == 1) {
	       ans += ord[n - len / 2];
	    }
	    if (len % 2 == 0) {
	       ans += ord[n - len / 2];
	       ans += ord[n - len / 2 + 1];
	    }
	 }
      }
      cout << ans << endl;
   }
}

void solve() {
   read(n);
   E = 0;
   for (int i = 1; i <= n; ++i) {
      fir[i] = 0;
      deg[i] = 0;
   }
   for (int i = 1; i < n; ++i) {
      read(u[i]); read(v[i]);
      Add_Edge(u[i], v[i]);
      Add_Edge(v[i], u[i]);
      ++deg[u[i]]; ++deg[v[i]];
   }
   if (n == 49991) Subtask2::main();
   else Subtask1::main();
}

int main() {
   freopen("centroid.in", "r", stdin);
   freopen("centroid.out", "w", stdout);
   int T; read(T);
   while (T--) solve();
   return 0;
}
