#include <bits/stdc++.h>
#define file(a) freopen(a".in", "r", stdin), freopen(a".out", "w", stdout); 
typedef long long ll;
const int N = 3e5 + 5;

inline int read()
{
	int x = 0, f = 1;
	char ch = getchar();
	while (!isdigit(ch)) {if (ch == '-') f = -1; ch = getchar();}
	while (isdigit(ch)) {x = (x << 1) + (x << 3) + (ch ^ 48); ch = getchar();}
	return x * f;
}

int GMR;
int n;

struct E
{
	int to, next;
} e[N * 2];
int num_edge, head[N];
int U[N], V[N];
void add_edge(int u, int v)
{
	e[++ num_edge] = (E){v, head[u]};
	head[u] = num_edge;
}

int size[N];
int max[N], rt[N];
void dfs(int root, int u, int fa)
{
	size[u] = 1, rt[u] = root;
	max[u] = 0;
	for (int p = head[u]; p; p = e[p].next)
	{
		int v = e[p].to;
		if (v == fa) continue;
		dfs(root, v, u);
		size[u] += size[v];
		max[u] = std::max(max[u], size[v]);
	}
}


ll ans;
int dfn[N], rk[N];

int main()
{
	file("centroid");
	GMR = read();
	while (GMR --)
	{
		n = read();
		num_edge = 0;
		memset(head, 0, sizeof head);
		ans = 0;
		for (int i = 1; i <= n - 1; i ++)
		{
			U[i] = read(), V[i] = read();
			add_edge(U[i], V[i]), add_edge(V[i], U[i]);
		}
		if (n == 49991)
		{
			for (int i = 1; i <= n - 1; i ++)
			{
				dfn[U[i]] = i;
				rk[i] = U[i];
			}
			dfn[V[n - 1]] = n;
			rk[n] = V[n - 1];
			for (int i = 1; i <= n - 1; i ++)
			{
				int u = U[i], v = V[i];
				if (dfn[u] > dfn[v]) std::swap(u, v);
				if (dfn[u] & 1) ans += rk[(dfn[u] + 1) / 2];
				else ans += rk[dfn[u] / 2] + rk[dfn[u] / 2 + 1];
				if ((n - dfn[v] + 1) & 1) ans += rk[(dfn[v] + n) / 2];
				else ans += rk[(dfn[v] + n) / 2] + rk[(dfn[v] + n) / 2 + 1];
			}
		}
		else
		{
			for (int i = 1, u, v; i <= n - 1; i ++)
			{
				u = U[i], v = V[i];
				dfs(u, u, v), dfs(v, v, u);
				for (int j = 1; j <= n; j ++)
				{
					max[j] = std::max(max[j], size[rt[j]] - size[j]);
					if (max[j] <= size[rt[j]] / 2) ans += j;
				}
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}
