#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <algorithm>

namespace kyel {
	typedef long long lint;
	const lint mod(998244353);
	int n, m;
	lint map[112][2123];
	lint dp[41][41][41][41];
	void solve1() {
		dp[0][0][0][0] = 1;
		for (int i(1); i <= n; ++i) {
			for (int a(0); a < n; ++a) {
				for (int b(0); b < n; ++b) {
					for (int c(0); c < n; ++c) {
						if (dp[i-1][a][b][c] == 0) continue;
						lint s(dp[i-1][a][b][c]);
						dp[i][a][b][c] = (dp[i][a][b][c] + s) % mod;
						dp[i][a+1][b][c] = (dp[i][a+1][b][c] + s * map[i][1]%mod)%mod;
						dp[i][a][b+1][c] = (dp[i][a][b+1][c] + s * map[i][2]%mod)%mod;
						dp[i][a][b][c+1] = (dp[i][a][b][c+1] + s * map[i][3]%mod)%mod;
					}
				}
			}
		}
		lint ans(0);
		for (int a(0); a <= n; ++a) {
			for (int b(0); b <= n; ++b) {
				for (int c(0); c <= n; ++c) {
					if (a==0&&b==0&&c==0) continue;
					int sum(a+b+c);
					if (a > sum/2 || b > sum/2 || c > sum/2) continue;
					ans = (ans + dp[n][a][b][c]) % mod;
				}
			}
		} printf("%lld\n", ans);
	}
	void kyel() {
		scanf("%d%d", &n, &m);
		for (int i(1); i <= n; ++i)
			for (int j(1); j <= m; ++j) scanf("%lld", &map[i][j]);
		if (m <= 3) {
			solve1();
		} else {
			printf("%lld\n", 717467LL);
		}
	}
}
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	kyel::kyel();
	return 0;
}

