#include <bits/stdc++.h>
using namespace std;

#define ll long long
const ll N = 40 + 9;
const ll M = 10;
const ll P = 998244353;

inline ll read() {
	ll x = 0, F = 1;
	char op = getchar();
	while (op < '0' || op > '9') {
		if (op == '-') F = -1;
		op = getchar();
	} 
	while (op >= '0' && op <= '9') {
		x = (x << 1) + (x << 3) + (op & 15);
		op = getchar();
	}
	return x * F;
}

ll n, m, a[N][M];

namespace Subtask1 {

ll res = 0, f[N][N][N];

void work() {
	register int i, j, k;
	f[0][0][0] = 1;
	for (i = 1; i <= n; i ++)
		for (j = 0; j <= i; j ++)
			for (k = 0; k <= i - j; k ++) {
				f[i][j][k] = f[i - 1][j][k];
				if (j > 0) f[i][j][k] += f[i - 1][j - 1][k] * a[i][1] % P;
				if (k > 0) f[i][j][k] += f[i - 1][j][k - 1] * a[i][2] % P; 
				f[i][j][k] %= P;
			}
	for (i = 0; i <= n; i ++) {
		for (j = 0; j <= n; j ++) {
			ll sum = i + j;
			if (sum < 2 || sum > n) continue ;
			if (i > (sum >> 1) || j > (sum >> 1)) continue ;
			res += f[n][i][j];
			res %= P;
		}
	}
	printf("%lld\n", res);
	return ;
}

}

namespace Subtask2 {

ll res, f[N][N][N][N];

void work() {
	register ll l, i, j, k;
	
	f[0][0][0][0] = 1;
	for (l = 1; l <= n; l ++) {
		for (i = 0; i <= l; i ++) {
			for (j = 0; j <= l - i; j ++) {
				for (k = 0; k <= l - i - j; k ++) {
					f[l][i][j][k] = f[l - 1][i][j][k];
					if (i > 0) f[l][i][j][k] += f[l - 1][i - 1][j][k] * a[l][1] % P;
					if (j > 0) f[l][i][j][k] += f[l - 1][i][j - 1][k] * a[l][2] % P;
					if (k > 0) f[l][i][j][k] += f[l - 1][i][j][k - 1] * a[l][3] % P;
					f[l][i][j][k] %= P;    
				}
			}
		}
	}
	for (i = 0; i <= n; i ++) {
		for (j = 0; j <= n; j ++) {
			for (k = 0; k <= n; k ++) {
				ll sum = i + j + k;
				if (sum < 2 || sum > n) continue ;	
				if (i > (sum >> 1) || j > (sum >> 1) || k > (sum >> 1)) continue ;
				res += f[n][i][j][k];
				res %= P;
			}
		}
	}
	printf("%lld\n", res);

	return ;
}

}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	
	register ll i, j;
	
	n = read(), m = read();
	for (i = 1; i <= n; i ++) {
		for (j = 1; j <= m; j ++) {
			a[i][j] = read();
		}
	}
	
	if (m == 2) Subtask1 :: work();
 	else Subtask2 :: work();
	
	return 0;
}

