#include <bits/stdc++.h>
#define ll long long
#define N 300010
#define clearr(x) memset(x, 0, sizeof(x))
using namespace std;
int T;

struct ed {
	int f, t, nxt;
};
ed eds[N << 1];
int cnt;
int head[N], siz[N], fa[N];
int n, nn;
int ans;
void addedge(int x, int y) {
	eds[++cnt].f = x;
	eds[cnt].t = y;
	eds[cnt].nxt = head[x];
	head[x] = cnt;
}

int ff, tt;
vector<int> heavy;
int ffa[N];
void dfs(int x) {
	siz[x] = 1;
	bool f = true;
	for (int i = head[x]; i; i = eds[i].nxt) {
		int& u = eds[i].t;
		if (u == ffa[x]) continue;
		if ((u == ff && x == tt) || (u == tt && x == ff)) continue;
		ffa[u] = x;
		dfs(u);
		siz[x] += siz[u];
		if (siz[u] > nn / 2) f = false;
	}
	if (f && (nn - siz[x]) <= nn / 2) {
		heavy.push_back(x);
	}
}

void dfs2(int x) {
	for (int i = head[x]; i; i = eds[i].nxt) {
		int& u = eds[i].t;
		if (u == fa[x]) continue;
		fa[u] = x;
		ff = x, tt = u;
		clearr(ffa); clearr(siz);
		heavy.clear();
		dfs2(u);
		for (int j = 0; j < heavy.size(); j++) ans += heavy[j];
		clearr(ffa); clearr(siz);
		heavy.clear();
		dfs2(x);
		for (int j = 0; j < heavy.size(); j++) ans += heavy[j];
	}
}

void init() {
	clearr(eds);
	clearr(head);
	cnt = 0;
	clearr(siz);
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T--) {
		init();
		scanf("%d", &n);
		for (int i = 1; i < n; i++) {
			int x, y;
			scanf("%d%d", &x, &y);
			addedge(x, y);
			addedge(y, x);
		}
		dfs2(1);
		printf("%d", ans);
	}
	return 0;
}
