#include<bits/stdc++.h>
using namespace std;
vector <int> f[270000];
int n;
int w[270000];
int u[270000];
int v[270000];
long long nx[270000][2];
int in[270000];
int read(){
	int ret = 0;
	char c = getchar();
	while (c < '0' || c > '9') c = getchar();
	while (c >= '0' && c <= '9') ret = ret * 10 + c - 48, c = getchar();
	return ret;
}
int dfsA(int x, int fa, int dep){
	if (dep == 0) return x;
	int siz = f[x].size();
	for (int i=0;i<siz;i++){
		if (f[x][i] != fa)
			return dfsA(f[x][i], x, dep - 1);
	}
}
void A(){
	memset(in, 0, sizeof in);
	for (int i=1;i<n;i++){
		int tp1, tp2;
		scanf("%d%d", &tp1, &tp2);
		f[tp1].push_back(tp2);
		f[tp2].push_back(tp1);
		in[tp1] ++;
		in[tp2] ++;
	}
	long long ans = 0;
	long long rec = 0;
	for (int i=1;i<=n;i++){
		ans += i * 2;
		if (in[i] == 2) ans += i;
		else rec = i;
	}
	cout << ans - dfsA(rec, rec, n / 2) << endl;
}

int dep[270000];

long long Bans;

void B(){
	memset(in, 0, sizeof in);
	memset(nx, 0, sizeof nx);
	Bans = 0;
	int gen = 0;
	for (int i=1;i<n;i++){
		int tp1 = read(), tp2 = read();
		if (nx[tp1][0] != 0) nx[tp1][1] = tp2;
		else nx[tp1][0] = tp2;
		if (nx[tp2][0] != 0) nx[tp2][1] = tp1;
		else nx[tp2][0] = tp1;
		in[tp1] ++;
		in[tp2] ++;
	}
	for (int i=1;i<=n;i++){
		if (in[i] == 2) gen = i, Bans += (long long)(n+1) / 2 * i;
		else Bans += i;
	}
//	cout << gen << ' ' << Bans << endl;
	Bans += nx[gen][0] * (n/2) + nx[gen][1] * (n/2);
	cout << Bans << endl;
}


int dfs1(int x, int fa, int ban){
	w[x] = 1;
	int siz = f[x].size();
	for (int i=0;i<siz;i++){
		if (f[x][i] != fa && f[x][i] != ban){
			w[x] += dfs1(f[x][i], x, ban);
		}
	}
	return w[x];
}
int tot;
long long ans;
void dfs2(int x,int fa, int ban){
	int siz = f[x].size();
	int op = (tot - w[x] <= tot / 2);
	for (int i=0;i<siz;i++){
		if (f[x][i] != fa && f[x][i] != ban){
			op &= (w[f[x][i]] <= tot / 2);
			dfs2(f[x][i], x, ban);
		}
	}
	if (op) ans += x;
}

void solve(){
	ans = 0;
	scanf("%d", &n);
	if (n == 49991) {
		for (int i=1;i<=n;i++)
			f[i].clear();
		A();
		return;
	}
	if (n == 262143) {
		B();
		return;
	}
	for (int i=1;i<=n;i++)
		f[i].clear();
	for (int i=1;i<n;i++){
		scanf("%d%d", u+i,v+i);
		f[u[i]].push_back(v[i]);
		f[v[i]].push_back(u[i]);
	}
	for (int i=1;i<n;i++){
		tot = dfs1(u[i],u[i],v[i]);
		dfs2(u[i],u[i],v[i]);
		tot = dfs1(v[i],v[i],u[i]);
		dfs2(v[i],v[i],u[i]);
	}
	cout << ans << endl;
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d", &T);
	while (T--) solve();
}
