#include<bits/stdc++.h>
using namespace std;
template<typename T>
void read(T &x)
{
	x=0; char ch=getchar();
	while(ch<'0'||ch>'9')ch=getchar();
	while(ch>='0'&&ch<='9')
	{
		x=(x<<3)+(x<<1)+(ch^'0');
		ch=getchar();
	}
}
const int N=300008;
struct Edge
{
	int nxt,frm,to;
}edge[2*N];
int a[N],ecnt,lcnt,head[N],n,size[N],deg[N],col[N],rt;
int son[10];
bool flag1,flag2,vis[N];
long long ans;
void add(int x,int y)
{
	edge[++ecnt]=(Edge){head[x],x,y};
	head[x]=ecnt;
	deg[x]++;
}
void dfs(int x,int fa)
{
	if(flag1)a[++lcnt]=x;
	size[x]=1;
	for(int p=head[x];p;p=edge[p].nxt)
	{
		int u=edge[p].to;
		if(u==fa)continue;
		dfs(u,x);
		size[x]=size[u]+size[x];
	}
}
int getcen(int x,int fa,int maxs)
{
	int tmp=maxs-size[x];
	int ans=0;
	for(int p=head[x];p;p=edge[p].nxt)
	{
		int u=edge[p].to;
		if(u==fa)continue;
		ans+=getcen(u,x,maxs);
		tmp=max(tmp,size[u]);
	}
	if(tmp<=maxs/2)ans+=x;
	return ans;
}
void line()
{
	for(int i=1;i<=n;i++)
		if(deg[i]==1){dfs(i,0); break;}
	for(int i=1;i<n;i++)
	{
		if(i&1)ans+=1ll*a[i/2+1];
		else ans+=1ll*(a[i/2+1]+a[i/2]);
		if((n-i)&1)ans+=1ll*a[i+(n-i)/2+1];
		else ans+=1ll*(a[i+(n-i)/2]+a[i+(n-i)/2+1]);
	}
	printf("%lld\n",ans);
}
void paint(int x,int fa,int c)
{
	col[x]=c;
	for(int p=head[x];p;p=edge[p].nxt)
		if(edge[p].to!=fa)paint(edge[p].to,x,c);
}
void perf()
{
	int rt=1;
	dfs(1,0);
	int c=0;
	for(int p=head[rt];p;p=edge[p].nxt)
		paint(edge[p].to,rt,++c),son[c]=edge[p].to;
	for(int i=1;i<n;i++)
	{
		int u=edge[i*2].frm,v=edge[i*2].to;
		if(size[u]<size[v])swap(u,v);
		ans+=v;
//		cout<<size[son[2-col[v]+1]]<<endl;
		if(size[rt]/2<=(size[rt]-size[v])/2)ans+=1ll*rt;
//		cout<<size[rt]-size[v]<<' '<<size[rt]/2<<endl;
//		cout<<ans<<endl;
		if(size[rt]-size[son[2-col[v]+1]]-size[v]<=(size[rt]-size[v])/2)ans+=1ll*son[2-col[v]+1];
//		cout<<u<<' '<<v<<' '<<size[rt]-size[son[2-col[v]+1]]-size[v]<<' '<<(size[rt]-size[v])/2<<' '<<ans<<endl;
	}
	printf("%lld\n",ans);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	read(T);
	while(T--)
	{
		memset(head,0,sizeof(head));
		memset(vis,false,sizeof(vis));
		memset(deg,0,sizeof(deg));
		ecnt=lcnt=0;
		flag1=flag2=true;
		ans=0;
		read(n);
		for(int i=1;i<n;i++)
		{
			int x,y;
			read(x); read(y);
			add(x,y); add(y,x);
			if(x!=2*y&&x!=2*y+1&&y!=2*x&&y!=2*x+1)flag2=false;
			if(deg[x]>2||deg[y]>2)flag1=false;
		}
		if(flag1){line();continue;}
		if(flag2){perf();continue;}
		for(int i=1;i<n;i++)
		{
			int u=edge[i*2].frm,v=edge[i*2].to;
			dfs(u,v);
//			for(int j=1;j<=n;j++)
//				cout<<size[j]<<' ';
//			cout<<endl;
			ans+=1ll*getcen(u,v,size[u]);
//			cout<<u<<' '<<v<<' '<<ans<<endl;
			dfs(v,u);
			ans+=1ll*getcen(v,u,size[v]);
//		cout<<ans<<endl;
		}
		printf("%lld\n",ans);
	}
	return 0;
}
/*
1
7
1 2
1 3
2 4
2 5
3 6
3 7
*/
