#include<bits/stdc++.h>
#define fi first
#define se second
#define REP(i,s,t) for(int i=s;i<=t;i++)
using namespace std;
const int maxn=3e5+5;
typedef pair<int,int> pii;
typedef long long ll;
int n;
namespace brute{
	struct Edge{int nxt,to;}e[4005];
	int hd[2005],e_cnt;
	void add(int u,int v){
		e[++e_cnt]=(Edge){hd[u],v};
		hd[u]=e_cnt;
	}
	pii inp[2005];
	bool fb[4005];
	int getSize(int u,int r){
		int ret=1;
		for(int i=hd[u];i;i=e[i].nxt) if(e[i].to!=r) ret+=getSize(e[i].to,u);
		return ret;
	}
	int dfs(int u,int r,int siz,int &ans){
		int ret=1;
		bool flg=true;
		for(int i=hd[u];i;i=e[i].nxt) if(e[i].to!=r){
			int tmp=dfs(e[i].to,u,siz,ans);
			ret+=tmp;
			if(tmp*2>siz) flg=false;
		}
		if((siz-ret)*2>siz) flg=false;
		if(flg) ans+=u;
		return ret;
	}
	int find(int u,int r){
		int siz=getSize(u,r),ans=0;
		dfs(u,r,siz,ans);
		return ans;
	}
	void solve(){
		memset(hd,0,sizeof hd); e_cnt=0;
		REP(i,1,n-1){
			int a,b; cin>>a>>b;
			inp[i]=make_pair(a,b);
			add(a,b); add(b,a);
		}
		int ans=0;
		REP(i,1,n-1){
			fb[i*2-1]=fb[i*2]=true;
			ans+=find(inp[i].fi,inp[i].se)+find(inp[i].se,inp[i].fi);
			fb[i*2-1]=fb[i*2]=false;
		}
		cout<<ans<<'\n';
	}
}
namespace chain{
	int ver[maxn];
	struct Edge{int nxt,to;}e[maxn<<1];
	int hd[maxn],e_cnt;
	void add(int u,int v){
		e[++e_cnt]=(Edge){hd[u],v};
		hd[u]=e_cnt;
	}
	int deg[maxn];
	void dfs(int u,int r,int dep){
		ver[dep]=u;
		for(int i=hd[u];i;i=e[i].nxt) if(e[i].to!=r) dfs(e[i].to,u,dep+1);
	}
	int getAns(int l,int r){
		if(r-l+1&1) return ver[l+r>>1];
		return ver[l+r>>1]+ver[(l+r>>1)+1];
	}
	void solve(){
		memset(deg,0,sizeof deg);
		memset(hd,0,sizeof hd); e_cnt=0;
		REP(i,1,n-1){
			int a,b; cin>>a>>b;
			add(a,b); add(b,a);
			deg[a]++; deg[b]++;
		}
		REP(i,1,n) if(deg[i]==1){dfs(i,0,1); break;}
		ll ans=0;
		REP(i,1,n-1) ans+=getAns(1,i)+getAns(i+1,n);
		cout<<ans<<'\n';
	}
}
namespace balance{
	int deg[maxn];
	struct Edge{int nxt,to;}e[maxn<<1];
	int hd[maxn],e_cnt;
	void add(int u,int v){
		e[++e_cnt]=(Edge){hd[u],v};
		hd[u]=e_cnt;
	}
	void solve(){
		memset(deg,0,sizeof deg);
		memset(hd,0,sizeof hd); e_cnt=0;
		int pw=0;
		while((1<<pw)<n) pw++;
		REP(i,1,n-1){
			int a,b; cin>>a>>b;
			deg[a]++; deg[b]++;
			add(a,b); add(b,a);
		}
		REP(i,1,n) if(deg[i]==2){
			int u=0,v=0;
			for(int j=hd[i];j;j=e[j].nxt) if(!u) u=e[j].to; else v=e[j].to;
			cout<<1ll*(1+n)*n/2-i+(1ll<<pw-1)*i+(u+v)*((1ll<<pw)-2)/2<<'\n';
			break;
		}
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int T; cin>>T;
	while(T--){
		cin>>n;
		if(n<=2000) brute::solve();
		else if(n%10==1) chain::solve();
		else balance::solve();
	}
	return 0;
}
