#include <bits/stdc++.h>
using namespace std ;
#define rep(i, a, b) for (int i = a; i <= b; i++)
#define enter puts("")
#define pb push_back
#define mp make_pair
#define siz(a) (int)(a.size())
#define clr(a) memset(a, 0, sizeof(a))

typedef long long ll ;
const int mod = 998244353 ;
const int N = 300010 ;

int n ;
ll ans ;
vector <int> e[N] ;
pair <int, int> edge[N] ;

namespace brute_force {

int Sz, c1, c2 ;
int sz[2010], mxs[2010] ;

void fir(int x, int fa) {
	Sz++ ;
	rep(i, 0, siz(e[x]) - 1) {
		int to = e[x][i] ;
		if (to == fa) continue ;
		fir(to, x) ;
	}
}

void dfs(int x, int fa) {
	sz[x] = 1 ;
	rep(i, 0, siz(e[x]) - 1) {
		int to = e[x][i] ;
		if (to == fa) continue ;
		dfs(to, x) ;
		sz[x] += sz[to] ;
		mxs[x] = max(mxs[x], sz[to]) ;
	}
	mxs[x] = max(mxs[x], Sz - sz[x]) ;
//	if (c1 == -1 || mxs[c1] > mxs[x]) c2 = c1, c1 = x ;
//	else if (c2 == -1 || mxs[c2] > mxs[x]) c2 = x ;
	if (mxs[x] * 2 <= Sz) (c1 == -1 ? c1 = x : c2 = x) ;
}

void main() {
	ans = 0 ;
	rep(i, 1, n - 1) {
		int x = edge[i].first, y = edge[i].second ;
	// 	cout<<"for " << i << endl ;
		Sz = 0 ; clr(mxs) ; c1 = c2 = -1 ; fir(x, y) ; dfs(x, y) ; ans += (c2 != -1 ? c1 + c2 : c1) ;
	//	cout << c1 << " " << c2 << endl ;		
		Sz = 0 ; clr(mxs) ; c1 = c2 = -1 ; fir(y, x) ; dfs(y, x) ; ans += (c2 != -1 ? c1 + c2 : c1) ;
	//	cout << c1 << " " << c2 << endl ;
	//	rep(i, 1, n) printf("%d ", sz[i]) ; enter ;
	}
	printf("%lld\n", ans) ;
}
}

namespace chain {

const int M = 50010 ;

int seq[M] ;	

void main() {
	ans = 0 ;
	int c ;
	rep(i, 1, n) if (siz(e[i]) == 1) c = i ;
	int id = 0, fa = 0, nxt ;
	while (true) {
		seq[++id] = c ;
		if (e[c][0] != fa) nxt = e[c][0] ;
		else {
			if (siz(e[c]) == 1) break ;
			else nxt = e[c][1] ;
		}
		fa = c ; c = nxt ;
	}
//	rep(i, 1, n) printf("%d ", seq[i]) ; enter ;
	ans = 0 ;
	rep(i, 1, n - 1) {
		int x = seq[i], y = seq[i + 1] ;
		int szx = i, szy = n - i ;
		ll lsa = ans ;
		if (szx % 2 == 0) {
			ans += seq[szx / 2] + seq[szx / 2 + 1] ;
		//	printf("%d %d\n", seq[szx / 2], seq[szx / 2 + 1]) ;
		} else {
			ans += seq[(szx + 1) / 2] ;
		//	printf("%d\n", seq[(szx + 1) / 2]) ;
		}
		if (szy % 2 == 0) {
			ans += seq[szy / 2 + i] + seq[szy / 2 + 1 + i] ;
		//	printf("%d %d\n", seq[szy / 2 + i], seq[szy / 2 + 1 + i]) ;
		} else {
			ans += seq[(szy + 1) / 2 + i] ;
		//	printf("%d\n", seq[(szy + 1) / 2 + i]) ;
		}
		//enter ;
	//	printf("%lld\n", ans - lsa) ; 
	}
	printf("%lld\n", ans) ;
}
}

signed main() {
	freopen("centroid.in", "r", stdin) ;
	freopen("centroid.out", "w", stdout) ;
	int t ; scanf("%d", &t) ;
	while (t--) {
		scanf("%d", &n) ;
		rep(i, 1, n) e[i].clear() ;
		rep(i, 1, n - 1) {
			int x, y ; scanf("%d%d", &x, &y) ;
			e[x].pb(y) ; e[y].pb(x) ;
			edge[i] = mp(x, y) ;
		}
//		cerr<<n<<endl;
		if (n <= 2000) brute_force::main() ;
		if (n == 49991) chain::main() ;
	}

	return 0 ;
}

