#include<cstdio>
#include<cmath>
#include<vector>
#include<algorithm>
#include<cstring>
#include<queue>
#define ll long long
using namespace std;
const int N=3e6;
struct Edge {
	int to,nxt;
} e[N*2];
int hea[N],cnt;
void add(int u,int v) {
	e[++cnt].to=v;
	e[cnt].nxt=hea[u];
	hea[u]=cnt;
}
inline int read() {
	int sum=0;
	char c=getchar();
	while(c>'9' || c<'0') c=getchar();
	while(c>='0' && c<='9') {
		sum=sum*10+c-'0';
		c=getchar();
	}
	return sum;
}
int t,n,u[N],v[N],c,be,en,sum[N];
ll ans;
int vis[N];
bool isline() {
	for(int i=1; i<=n; ++i) {
		for(int o=hea[i]; o; o=e[o].nxt) {
			++sum[i];
			if(sum[i]>2) return false;
		}
	}
	return true;
}
bool checkA;
int totp,p[N];
void solveA(int x,int f) {
	checkA=true;
	++totp;
	p[totp]=x;
	for(int i=hea[x]; i; i=e[i].nxt) {
		if(e[i].to!=f) solveA(e[i].to,x),checkA=false;
	}
	if(checkA) {
		for(int i=1; i<n; ++i) {
			if(i%2) ans+=p[(i+1)/2];
			else ans+=p[i/2]+p[i/2+1];
			if((n-i)%2) ans+=p[(n+i+1)/2];
			else ans+=p[(n+i)/2]+p[(n+i)/2+1];
		}
	}
}
vector<int> a[N];
int tot[N],root;
int dfs1(int x,int f) {
	if(vis[x]) return sum[x];
	int s=1;
	vis[x]=1;
	for(int i=hea[x]; i; i=e[i].nxt) {
		if((x==be && e[i].to==en) || (x==en && e[i].to==be) || e[i].to==f) continue;
		++tot[x];
		a[x].push_back(dfs1(e[i].to,x));
		s+=a[x].at(tot[x]);
	}
	sum[x]=s;
	return sum[x];
}
int dfs2(int x,int f) {
	if(vis[x]) return sum[x];
	int s=1;
	vis[x]=-1;
	for(int i=hea[x]; i; i=e[i].nxt) {
		if((x==be && e[i].to==en) || (x==en && e[i].to==be) || e[i].to==f) continue;
		++tot[x];
		a[x].push_back(dfs2(e[i].to,x));
		s+=a[x].at(tot[x]);
	}
	sum[x]=s;
	return sum[x];
}
bool findc(int x) {
	int s=0;
	for(int i=0; i<tot[x]; ++i) {
		if(vis[x]==1) {
			if(a[x].at(i)>sum[u[root]]/2) return false;
		} else {
			if(a[x].at(i)>sum[v[root]]/2) return false;
		}
		s+=a[x].at(i);
	}
	if(vis[x]==1) {
		if(sum[u[root]]-s+1>sum[u[root]]/2) return false;
	} else {
		if(sum[v[root]]-s+1>sum[v[root]]/2) return false;
	}
	return true;
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	t=read();
	while(t--) {
		n=read();
		memset(tot,-1,sizeof(tot));
		memset(hea,0,sizeof(hea));
		ans=0;
		cnt=0;
		for(int i=1; i<=n; ++i) a[i].clear();
		for(int i=1; i<n; ++i) {
			u[i]=read(),v[i]=read();
			add(u[i],v[i]);
			add(v[i],u[i]);
		}
		if(isline()) {
			totp=0;
			solveA(u[1],0);
			printf("%lld\n",ans);
			continue;
		}
		for(int i=1; i<n; ++i) {
			root=i;
			memset(vis,0,sizeof(vis));
			memset(sum,0,sizeof(sum));
			be=u[i];
			en=v[i];
			dfs1(u[i],0);
			dfs2(v[i],0);
			for(int i=1; i<=n; ++i) {
				if(findc(i)) ans+=i;
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}
