#include <cstdio>
#include <vector>
#include <string.h>
using namespace std;
#define maxn 300005
int T,n,ans;
vector<int> a[maxn];
int cnt[maxn];
int sx,sy;

inline int read(){
	register int ret=0,c=getchar();
	while(c<'0'||c>'9')c=getchar();
	while(c>='0'&&c<='9')ret=(ret<<3)+(ret<<1)+(c^48),c=getchar();
	return ret;
}

void dfs(int x,int fa){
//	printf("%d",x);
	if(a[x].size()==1){
		cnt[x]=1;
		return;
	}
	for(int i=0;i<a[x].size();i++)if(a[x][i]!=fa){
		dfs(a[x][i],x);
		cnt[x]+=cnt[a[x][i]];
	}
	cnt[x]++;
}

void dfs1(int x,int fa,int root){
	if(cnt[root]-cnt[x]<=cnt[root]/2){
		bool flag=1;
		for(int i=0;i<a[x].size();i++)if(a[x][i]!=fa){
			if(cnt[a[x][i]]>cnt[root]/2){
				flag=0;
				break;
			}
		}
		if(flag)ans+=x;
	}
	for(int i=0;i<a[x].size();i++)if(a[x][i]!=fa){
		dfs1(a[x][i],x,root);
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	while(T--){
		ans=0;
		n=read();
		memset(a,0,sizeof(a));
		for(int i=1;i<n;i++){
			int x,y;
			x=read();y==read();
			a[x].push_back(y);
			a[y].push_back(x);
		}
		for(int i=1;i<=n;i++){
			for(int j=0;j<a[i].size();j++){
				memset(cnt,0,sizeof(cnt));
				sx=i;sy=a[i][j];
				dfs(sx,sy);
				dfs(sy,sx);
				dfs1(sx,sy,sx);
				dfs1(sy,sx,sy);
			}
		}
		printf("%d\n",ans/2);
	}
	return 0;
}
