#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
using std::cin; using std::cout; using std::cerr; using std::endl;
typedef long long ll;
#define re register
#define dbg(x) cerr << #x << " = " << x << endl;
const int N = 5e5+10;
ll a[N], sum[N]; int n, type;

struct PN3{
	ll f[410][410];
	bool chk(){ return n <= 410; }
	void solve(){
		std::memset(f, 0x3f ,sizeof(f));
		for(int i = 1; i <= n; ++i){
			f[0][i] = sum[i] * sum[i];
			for(int j = 1; j < i; ++j){
				for(int k = j-1; k >= 0 && sum[j]-sum[k] <= sum[i]-sum[j]; --k) f[j][i] = std::min(f[j][i], f[k][j]);
				f[j][i] += (sum[i]-sum[j])*(sum[i]-sum[j]);
				cerr << j << ' ' << i << ' ' << f[i][j] << endl;
			}
		}
		ll ans = f[0][n];
		for(int i = 1; i < n; ++i) ans = std::min(ans, f[i][n]);
		cout << ans << endl;
	}
} n3;

struct PN2{
	bool chk(){ return n <= 5000;}
	ll f[5010][5010], g[5010][5010];
	void solve(){
		std::memset(f, 0x3f, sizeof(f));
		std::memset(g, 0x3f, sizeof(g));
		for(int i = 1; i <= n; ++i){
			f[i][0] = sum[i] * sum[i];
			for(int j = 1; j < i; ++j){
				int l = 0, r = j; ll x = 2*sum[j] - sum[i];
				while(l<r){
					int mid = (l+r)>>1;
					if (sum[mid] >= x) r = mid;
					else l = mid+1;
				}
				int k = l;

				f[i][j] = std::min(f[i][j], g[j][k] + (sum[i]-sum[j])*(sum[i]-sum[j]) );
				// cerr << j << ' ' << i << ' ' << f[i][j] << ' ' << k << endl;
				// cerr << "g " << j << ' ' << k << ' ' << g[j][k] << endl;
			}
			for(int j = i; j >= 0; --j){
				g[i][j] = std::min(g[i][j+1], f[i][j]);
			}
		}
		ll ans = f[0][n];
		for(int i = 1; i < n; ++i) ans = std::min(ans, f[n][i]);
		cout << ans << endl;
	}
} n2;

int main(){
	freopen("partition.in", "r", stdin); freopen("partition.out", "w", stdout);
	std::ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n >> type;
	if (type == 0){
		for(int i = 1; i <= n; ++i) cin >> a[i];
	} else {
	}
	for(int i = 1; i <= n; ++i) sum[i] = sum[i-1] + a[i];
	//if (n3.chk())  n3.solve();
	//else if (n2.chk()) n2.solve();
	n2.solve();
	return 0;
}
