#include <cstdio>
#include <cstring>
#include <algorithm>

int root[300001],lson[8000001],rson[8000001],se[8000001],cnt,n,head[300001],nxt[600001],b[600001],k,T;
int now,size[300001],dfn[300001],ord[300001],seg[1200001],sum[300001];
long long ans;
void push(int s,int t){
	nxt[++k]=head[s];
	head[s]=k;
	b[k]=t;
}
void dfs(int x,int f){
	dfn[x]=++now;
	ord[now]=x;
	size[x]=1;
	for(int i=head[x];i;i=nxt[i])
		if(b[i]!=f){
			dfs(b[i],x);
			size[x]+=size[b[i]];
		}
}
void build(int &pos,int pre,int l,int r,int e){
	pos=++cnt;
	lson[pos]=lson[pre];
	rson[pos]=rson[pre];
	se[pos]=se[pre]+1;
	if(l==r)return;
	if((l+r)>>1>=e)build(lson[pos],lson[pre],l,(l+r)>>1,e);
	else build(rson[pos],rson[pre],((l+r)>>1)+1,r,e);
}
int query(int pos,int l,int r,int el,int er){
	if(el>er)return 0;
	if(!pos)return 0;
	if(el>r||er<l)return 0;
	if(el<=l&&er>=r)return se[pos];
	return query(lson[pos],l,(l+r)>>1,el,er)+query(rson[pos],((l+r)>>1)+1,r,el,er);
}
void Update(int ind,int num){for(;ind<=n;ind+=ind&-ind)seg[ind]+=num;}
int Query(int ind){if(!ind)return 0;int tot=0;for(;ind;ind-=ind&-ind)tot+=seg[ind];return tot;}
#define upd(x) ((mx<x)?skdmx=mx,mx=x:(skdmx<x?skdmx=x:0))
void getans(int x,int f){
	int mx=0,skdmx=0;
	upd(n-size[x]);
	for(int i=head[x];i;i=nxt[i])if(b[i]!=f)upd(size[b[i]]);
	int val=n-size[x]==mx?skdmx:mx,cnt=0,l,r;
	l=std::max(n-2*size[x],0),r=n-2*val;
	cnt+=query(root[dfn[x]-1],1,n,l,r);
	if(l<=r){
		cnt+=sum[r]+Query(r);
		if(l)cnt-=sum[l-1]+Query(l-1);
	}
	cnt-=query(root[dfn[x]+size[x]-1],1,n,l,r);
	for(int i=head[x];i;i=nxt[i])
		if(b[i]!=f){
			val=size[b[i]]==mx?skdmx:mx;
			l=std::max(n-2*(n-size[b[i]]),0),r=n-2*val;
			cnt+=query(root[dfn[b[i]]+size[b[i]]-1],1,n,l,r);
			cnt-=query(root[dfn[b[i]]-1],1,n,l,r);
		}
	ans+=1ll*cnt*x;
	Update(size[x],-1);
	for(int i=head[x];i;i=nxt[i])
		if(b[i]!=f){
			Update(n-size[b[i]],1);
			getans(b[i],x);
			Update(n-size[b[i]],-1);
		}
	Update(size[x],1);
}
int read(){
	int x=0;
	char ch=getchar();
	while(ch<'0'||ch>'9')ch=getchar();
	while(ch>='0'&&ch<='9')x=x*10+ch-'0',ch=getchar();
	return x;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	for(int fd=1;fd<=T;fd++){
		n=read();
		memset(head,0,sizeof head);
		k=cnt=now=ans=0;
		for(int i=1,u,v;i<n;i++){
			u=read(),v=read();
			push(u,v),push(v,u);
		}
		dfs(1,0);
		for(int i=1;i<=n;i++)sum[i]=0;
		for(int i=1;i<=n;i++)root[i]=0,build(root[i],root[i-1],1,n,size[ord[i]]),++sum[size[i]];
		for(int i=1;i<=n;i++)sum[i]+=sum[i-1];
		getans(1,0);
		printf("%lld\n",ans);
	}
	return 0;
}
