#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for(int i = (a); i <= (b); ++i)
#define per(i, a, b) for(int i = (a); i >= (b); --i)
#define cont(i, x) for(int i = head[(x)]; i; i = edge[i].nex)
#define ass(x, y) memset(x, (y), sizeof(x));
#define lb lower_bound
#define file(x) freopen(x".in", "r", stdin), freopen(x".out", "w", stdout)
typedef long long ll;

const int maxn = 2e6 + 100;
const ll mod = 998244353;
const ll linf = 4e18;

int t;

int n;

struct node
{
    int nex, to;
}
edge[maxn];

int head[maxn], tot, in[maxn];

void add(int u, int v)
{
    edge[++tot] = (node){head[u], v};
    head[u] = tot, in[u] ++;
}

namespace sub1
{
    int sz[maxn], father[maxn], maxx[maxn];
    ll ans = 0;
    void dfs(int now, int fa)
    {
        sz[now] = 1, father[now] = fa;
        cont(i, now)
        {
            int to = edge[i].to;
            if(to == fa) continue;
            dfs(to, now);
            sz[now] += sz[to];
        }
    }

    void dfs2(int now, int u, int v)
    {
        sz[now] = 1, maxx[now] = 0;
        cont(i, now)
        {
            int to = edge[i].to;
            if(to == father[now]) continue;
            if(now == u && to == v) continue;
            dfs2(to, u, v);
            sz[now] += sz[to];
            maxx[now] = max(maxx[now], sz[to]);
        }
    }

    void dfs3(int now, int top, int u, int v)
    {
        if(max(maxx[now], sz[top] - sz[now]) <= sz[top] / 2) ans += now;
        cont(i, now)
        {
            int to = edge[i].to;
            if(to == father[now]) continue;
            if(now == u && to == v) continue;
            dfs3(to, top, u, v);
        }
    }

    void solve()
    {
    	ans = 0;
        dfs(1, 0);
        rep(i, 2, n)
        {
            dfs2(i, i, father[i]);
            dfs3(i, i, i, father[i]);
            dfs2(1, father[i], i);
            dfs3(1, 1, father[i], i);
        }
        printf("%lld\n", ans);
    }
}

namespace sub2
{
    int rt1, rt2, sz[maxn];
    ll ans = 0;
    void dfs(int now, int fa)
    {
        sz[now] = 1;
        cont(i, now)
        {
            int to = edge[i].to;
            if(to == fa) continue;
            dfs(to, now);
            sz[now] += sz[to];
        }
    }

    void dfs2(int now, int fa, int dis)
    {
        if(sz[now] > dis) ans += now;
        if(sz[now] > dis + 1) ans += now;
        cont(i, now)
        {
            int to = edge[i].to;
            if(to == fa) continue;
            dfs2(to, now, dis + 1);
        }
    }

    void solve()
    {
        ans = rt1 = rt2 = 0;
        rep(i, 1, n) if(in[i] == 1)
        {
            if(!rt1) rt1 = i;
            else rt2 = i;
        }
        dfs(rt1, 0);
        dfs2(rt1, 0, 0);
        dfs(rt2, 0);
        dfs2(rt2, 0, 0);
        printf("%lld\n", ans);
    }
}

void solve()
{
    scanf("%d", &n);
    rep(i, 1, n - 1)
    {
        int u, v;
        scanf("%d %d", &u, &v);
        add(u, v), add(v, u);
    }
    if(n <= (int)5e3) sub1 :: solve();
    else sub2 :: solve();
    rep(i, 1, tot) edge[i] = (node){0, 0};
    rep(i, 1, n) head[i] = in[i] = 0;
    tot = 0;
}

signed main()
{
	 file("centroid");
    scanf("%d", &t);
    while(t--) solve();
    return 0;
}