#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;
const int N=3e5+5;
int T,n,head[N],to[N<<1],nxt[N<<1],tot=1,ex[N],ey[N],siz[N],sz[N],ans,fa[N],d[N],c[N],f[N][20],t,deg[N],rt;
bool vis[N];

void add_edge(int x,int y){
    to[++tot]=y,nxt[tot]=head[x],head[x]=tot;
}

namespace bf{
    void dfs(int x,int del,int s){
        vis[x]=1,siz[x]=1;
        int max_part=0;
        for (int i=head[x];i;i=nxt[i]){
            int y=to[i];
            if (vis[y] || y==del) continue;
            dfs(y,del,s);
            max_part=max(max_part,siz[y]);
            siz[x]+=siz[y];
        }
        max_part=max(max_part,s-siz[x]);
        if (max_part<=(s>>1)) ans+=x;
    }
    void dfs1(int x){
        vis[x]=1,sz[x]=1;
        for (int i=head[x];i;i=nxt[i]){
            int y=to[i];
            if (vis[y]) continue;
            fa[y]=x;
            dfs1(y);
            sz[x]+=sz[y];
        }
    }
}

namespace A{
    void work(int x,int ed,int s,int del){
        int mid=(d[ed]+d[x])>>1,y=x;
        for (int i=t;i>=0;--i)
            if (d[f[x][i]]>=mid) x=f[x][i];
        ans+=x;
        for (int i=head[x];i;i=nxt[i])
            if (to[i]!=del && d[y]-d[to[i]]<=(s>>1) && d[to[i]]-d[ed]<=(s>>1)) ans+=to[i];
    }
}

namespace B{

}

void dfs(int x){
    vis[x]=1;
    for (int i=head[x];i;i=nxt[i]){
        int y=to[i];
        if (vis[y]) continue;
        d[y]=d[x]+1,f[y][0]=x;
        for (int j=1;(1<<j)<=d[y];++j)
            f[y][j]=f[f[y][j-1]][j-1];
        dfs(y);
    }
}

int main(){
    freopen("centroid.in","r",stdin);
    freopen("centroid.out","w",stdout);
    scanf("%d",&T);
    while (T--){
        memset(head,0,sizeof head); tot=1;
        memset(deg,0,sizeof deg);
        scanf("%d",&n);
        for (int i=1,x,y;i<n;++i){
            scanf("%d%d",&x,&y);
            add_edge(x,y),add_edge(y,x);
            ex[i]=x,ey[i]=y;
            deg[x]++,deg[y]++;
        }
        ans=0;
        if (n<=2000){
            memset(vis,0,sizeof vis);
            bf::dfs1(1);
            for (int i=1;i<n;++i){
                memset(vis,0,sizeof vis);
                memset(siz,0,sizeof siz);
                bf::dfs(ex[i],ey[i],ex[i]==fa[ey[i]]?n-sz[ey[i]]:sz[ex[i]]);
                bf::dfs(ey[i],ex[i],ey[i]==fa[ex[i]]?n-sz[ex[i]]:sz[ey[i]]);
            }
            printf("%d\n",ans);
            continue;
        }
        if (n==49991){
            memset(f,0,sizeof f);
            for (int i=n;i;--i) if (deg[i]==1) rt=i;
            memset(vis,0,sizeof vis); d[rt]=1;
            dfs(rt);
            t=log(n)/log(2)+1,ans=0;
            int md=0,dt;
            for (int i=1;i<=n;++i) if (d[i]>md) md=d[i],dt=i;
            for (int i=1;i<n;++i){
                if (d[ex[i]]>d[ey[i]]) swap(ex[i],ey[i]);
                A::work(ex[i],rt,d[ex[i]]-d[rt]+1,ey[i]);
                A::work(dt,ey[i],d[dt]-d[ey[i]]+1,ex[i]);
            }
            printf("%d\n",ans);
            continue;
        }
        if (n==262143){
            continue;
        }
    }
    return 0;
}