#include<bits/stdc++.h>
#define LL long long
#define Maxn 300010
using namespace std;

struct NODE{
	int to, nxt;
}edge[Maxn << 1];

int tot, head[Maxn], dep[Maxn], dep1[Maxn], size, siz, deg[Maxn];
LL ans;

inline void adds(int u, int v){
	edge[++tot] = (NODE){v, head[u]}, head[u] = tot;
}

inline int read(){
	int x = 0, f = 1; char ch = getchar();
	while (!isdigit(ch)){if (ch == '-') f = -1; ch = getchar(); }
	while (isdigit(ch)){x = (x << 1) + (x << 3) + ch - 48; ch = getchar(); }
	return x * f;
}

void dfs(int u, int fa){
	dep[u] = dep[fa] + 1, size++;
	for (int i = head[u]; i; i = edge[i].nxt){
		int v = edge[i].to;
		if (v != fa) dfs(v, u);
	}
}

void Dfs(int u, int fa){
	siz++;
	for (int i = head[u]; i; i = edge[i].nxt){
		int v = edge[i].to;
		if (v != fa && dep[v]) Dfs(v, u);
	}
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdin);
	int T = read();
	while (T--){
		int n = read();
		tot = 0;ans = 0;
		memset(deg, 0, sizeof(deg));
		memset(head, 0, sizeof(head));
	for (int i = 1; i < n; i++){
		int u = read(), v = read();
		adds(u, v); adds(v, u);
		deg[u]++, deg[v]++;
	}
	int flag = (deg[1] == 1) & (deg[n] == 1);
	if (flag) for (int i = 2; i < n; i++) if (deg[i] != 2){flag = 0; break;}
	if (flag){
		for (int i = 1; i < n; i++){
			if (i & 1) ans += (i + 1) / 2;
			else ans += i + 1;
		}
		for (int i = 1; i < n; i++){
			if ((n + i + 1) & 1) ans += (n + i + 1) / 2;
			else ans += n + i + 1;
		}
		printf("%lld\n", ans);
		continue;
	}
//	dfs(1, 0);
//	flag = 1;
//	for (int i = 2; i <= n; i++) if (dep[i] < dep[i - 1]) flag = 0;
//	if ((1 << dep[n]) - 1 == n){
//		return 0;
//	}
	for (int i = 1; i < n; i++){
		int u = edge[i * 2 - 1].to, v = edge[i * 2].to;
		size = 0;
		memset(dep, 0, sizeof(dep));
		dfs(u, v);
		for (int j = 1; j <= n; j++){
			if (dep[j]){
				for (int k = head[j]; k; k = edge[k].nxt){
					siz = 0;
					if (edge[k].to != v) Dfs(edge[k].to, j);
					if (siz * 2 > size) break;
				}
				if (siz * 2 <= size) ans += j;
			}
		}
		size = n - size;
//		memset(dep, 0, sizeof(dep));
//		dfs(v, u);
		for (int j = 1; j <= n; j++) if (dep[j]) dep[j] = 0; else dep[j] = 1;
		for (int j = 1; j <= n; j++){
			if (dep[j]){
				for (int k = head[j]; k; k = edge[k].nxt){
					siz = 0;
					if (edge[k].to != u) Dfs(edge[k].to, j);
					if (siz * 2 > size) break;
				}
				if (siz * 2 <= size) ans += j;
			}
		}
	}
	printf("%lld\n", ans);
	}
	
	return 0;
}
