#include<cstdio>
#include<iostream>
#define RI register int
#define CI const int&
using namespace std;
typedef long long LL;
const int N=50005;
struct edge
{
	int to,nxt;
}e[N<<1]; int t,n,head[N],cnt,x[N],y[N];
inline void addedge(CI x,CI y)
{
	e[++cnt]=(edge){y,head[x]}; head[x]=cnt;
	e[++cnt]=(edge){x,head[y]}; head[y]=cnt;
}
#define to e[i].to
namespace Case1 //Brute Force
{
	int size[N],mx[N],u,v,vis[N];
	inline void findroot(CI now,CI tim,CI fa=0)
	{
		size[now]=1; vis[now]=tim; mx[now]=0;
		for (RI i=head[now];i;i=e[i].nxt)
		{
			if (to==fa||(now==u&&to==v)||(now==v&&to==u)) continue;
			findroot(to,tim,now); size[now]+=size[to];
			mx[now]=max(mx[now],size[to]);
		}
	}
	inline LL solve(LL ans=0)
	{
		RI i,j,k; for (i=1;i<n;++i)
		{
			for (u=x[i],v=y[i],j=1;j<=n;++j) vis[j]=0;
			int cur=0; for (j=1;j<=n;++j) if (!vis[j])
			{
				for (findroot(j,++cur),k=1;k<=n;++k)
				if (vis[k]==cur&&((max(mx[k],size[j]-size[k])<<1)<=size[j]||size[j]==1)) ans+=k;
			}
		}
		return ans;
	}
};
namespace Case2 //Way Solver
{
	int p[N],deg[N],pos;
	inline void travel(CI now,CI fa=0,CI tot=1)
	{
		p[tot]=now; for (RI i=head[now];i;i=e[i].nxt)
		if (to!=fa) travel(to,now,tot+1);
	}
	inline LL solve(LL ans=0)
	{
		RI i; for (i=1;i<n;++i) ++deg[x[i]],++deg[y[i]];
		for (i=1;i<=n;++i) if (deg[i]==1) { pos=i; break; }
		for (travel(pos),i=1;i<n;++i)
		{
			if (i&1) ans+=p[(i+1)>>1]; else ans+=p[i>>1]+p[(i>>1)+1];
			if ((n-i)&1) ans+=p[(n+i+1)>>1]; else ans+=p[(n+i+1)>>1]+p[((n+i+1)>>1)+1];
		}
		for (i=1;i<=n;++i) deg[i]=0; return ans;
	}
};
#undef to
int main()
{
	freopen("centroid.in","r",stdin); freopen("centroid.out","w",stdout);
	for (scanf("%d",&t);t;--t)
	{
		RI i; for (scanf("%d",&n),i=1;i<n;++i)
		scanf("%d%d",&x[i],&y[i]),addedge(x[i],y[i]);
		printf("%lld\n",n<=1999?Case1::solve():Case2::solve());
		for (i=1;i<=n;++i) head[i]=0; cnt=0;
	}
}
