#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<string>
#include<cmath>
#include<queue>

using namespace std;

typedef long long LL;
const int MAXN = 10005;
struct EDGE {
	int nxt, to;
} edge[MAXN];
int T, n, cnt, U[MAXN], V[MAXN], head[MAXN], vis[MAXN];
inline void addedge(int u, int v) {
	edge[++cnt].to = v; edge[cnt].nxt = head[u]; head[u] = cnt;
}
inline int find_zx() {
	memset(vis, 0, sizeof(vis));
	queue<int> Q;
	Q.push(1);
	int N1 = 0;
	while (!Q.empty()) {
		int u = Q.front();
		Q.pop();
		if (vis[u]) continue;
		vis[u] = 1;
		N1++;
		for (int i = head[u]; ~i; i = edge[i].nxt) {
			int v = edge[i].to;
			if (!vis[v]) {
				Q.push(v);
			}
		}
	}
	while (!Q.empty()) Q.pop();
	for (int i = 1; i <= n; i++)
		if (!vis[i]) {
			Q.push(i);
			break;
		}
	int N2 = 0;
	while (!Q.empty()) {
		int u = Q.front();
		Q.pop();
		if (vis[u]) continue;
		vis[u] = 1;
		N2++;
		for (int i = head[u]; ~i; i = edge[i].nxt) {
			int v = edge[i].to;
			if (!vis[v]) {
				Q.push(v);
			}
		}
	}
	memset(vis, 0, sizeof(vis));
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (!vis[j]) {
				while (!Q.empty()) Q.pop();
				int sz = 0;
				while (!Q.empty()) {
					int u = Q.front();
					Q.pop();
					if (vis[u]) continue;
					vis[u] = 1;
					sz++;
					for (int i = head[u]; ~i; i = edge[i].nxt) {
						int v = edge[i].to;
						if (!vis[v]) {
							Q.push(v);
						}
					}
				}
			}
		}
	}
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		if (n <= 1999) {
			for (int i = 1; i < n; i++) {
				scanf("%d%d", &U[i], &V[i]);
			}
			int ans = 0;
			for (int i = 1; i < n; i++) {
				memset(head, -1, sizeof(head));
				for (int j = 1; j < n; j++) {
					if (i != j) {
						addedge(U[j], V[j]);
						addedge(V[j], U[j]);
					}
				}
				ans += find_zx();
			}
			printf("%d\n", ans);
		} else
		if (n > 1999) {
			for (int u, v, i = 1; i < n; i++)
				scanf("%d%d", &u, &v);
			LL ans = 0;
			for (int i = 1; i < n; i++) {
				LL l = i, r = i + 1;
				LL d1 = (1 + l) / 2, d2 = (r + n) / 2, M1 = (1 + l) % 2, M2 = (r + n) % 2;
				if (M1 == 0) {
					ans += d1;
				} else {
					ans += d1 + d1 + 1;
				}
				if (M2 == 0) {
					ans += d2;
				} else {
					ans += d2 + d2 + 1;
				}
			}
			printf("%lld\n", ans);
		}
	}
	return 0;
}
