#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<string>
#include<cmath>

using namespace std;

typedef long long LL;
const int MAXN = 2005, mod = 998244353;
int n, m, hang[MAXN], lie[MAXN], a[MAXN][MAXN];
LL ans;
inline void dfs(int dijihang, int zuiduo, int daan) {
	if (dijihang == n + 1) {
		for (int i = 1; i <= n; i++)
			if (hang[i] > 1) return ;
		for (int i = 1; i <= m; i++)
			if (lie[i] > zuiduo) return ;
		int tot = 0;
		for (int i = 1; i <= m; i++)
			tot += lie[i];
		if (tot < 1) return ;
//		cerr << "hang: ";
//		for (int i = 1; i <= n; i++)
//			cerr << hang[i] << " ";
//		cerr << "\nlie:  ";
//		for (int i = 1; i <= m; i++)
//			cerr << lie[i] << " ";
//		cerr << '\n';
//		cerr << daan << "\n";
		ans = (ans + daan) % mod;
		return ;
	}
	for (int i = 1; i <= n; i++) {
		hang[dijihang]++;
		lie[dijihang]++;
		dfs(dijihang + 1, zuiduo, daan * a[dijihang][i]);
		hang[dijihang]--;
		lie[dijihang]--;
		dfs(dijihang + 1, zuiduo, daan * a[dijihang][i]);
	}
}
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			scanf("%d", &a[i][j]);
	memset(hang, 0, sizeof(hang));
	memset(lie, 0, sizeof(lie));
	for (int k = 2; k <= n; k++)
		dfs(1, k / 2, 1);
	printf("%lld\n", ans % mod);
	return 0;
}
