#include<bits/stdc++.h>
using namespace std;
const int M=300005;
bool memory_test_begin;
struct edge{
	int to;
	edge*next;
};
edge *G[M],Pool[M*4],*allc=Pool;
int deg[M];
int _,n;
void add_edge(int u,int v){
	*allc=(edge){v,G[u]};
	G[u]=allc++;
}

namespace P_1{
	int sz[M],S[M];
	long long ans;
	void get_G(int u,int fa,int sum){
		int mx=0;
		sz[u]=1;
		for(edge* e=G[u];e!=NULL;e=e->next){
			if(e->to!=fa){
				get_G(e->to,u,sum);
				sz[u]+=sz[e->to];
				mx=max(mx,sz[e->to]);
			}
		}
		mx=max(mx,sum-sz[u]);
		if(mx<=(sum>>1))
			ans+=u;
	}
	void dfs(int u,int fa){
		S[u]=1;
		//cerr << u << "  " << fa << endl;
		for(edge *e=G[u];e!=NULL;e=e->next){
			if(e->to!=fa){
				dfs(e->to,u);
				S[u]+=S[e->to];
				get_G(e->to,u,S[e->to]);
				get_G(u,e->to,n-S[e->to]);
			}
		}
	}
	int main(){
		ans=0;
		dfs(1,-1);
		printf("%lld\n",ans);
		return 0;
	}
}
namespace P_2{
	int id[M],A[M];
	long long ans;
	void dfs(int u,int fa){
		A[id[u]]=u;
		for(edge *e=G[u];e!=NULL;e=e->next){
			if(e->to!=fa){
				id[e->to]=id[u]+1;
				dfs(e->to,u);
			}
		}
	}
	int query(int l,int r){
		if(((r-l+1)&1)==1)
			return A[(l+r)>>1];
		else
			return A[(l+r+1)>>1]+A[(l+r-1)>>1];
	}
	int main(){
		ans=0;
		for(int i=1;i<=n;++i)
			if(deg[i]==1){
				id[i]=1;
				dfs(i,-1);
				break;
			}
		for(int i=1;i<n;++i)
			ans+=query(1,i)+query(i+1,n);
		printf("%lld\n",ans);
		return 0;
	}
}

namespace P_3{
	int A[50];
	long long ans=0;
	/*edge *H[M],Pool[M*2],*allc=Pool;
	int sz[M],S[M],A[M],dep[M],P[M];
	long long ans;
	void get_G(int u,int fa,int sum,int k){
		int mx=0;
		sz[u]=1;
		for(edge* e=H[u];e!=NULL;e=e->next){
			if(e->to!=fa){
				get_G(e->to,u,sum,k);
				sz[u]+=sz[e->to];
				mx=max(mx,sz[e->to]);
			}
		}
		mx=max(mx,sum-sz[u]);
		if(mx<=(sum>>1))
			P[u]+=k;
	}
	void add_edge(int u,int v){
		*allc=(edge){v,H[u]};
		H[u]=allc++;
	}
	void dfs(int u,int fa){
		S[u]=1;
		for(edge *e=H[u];e!=NULL;e=e->next){
			if(e->to!=fa){
				dfs(e->to,u);
				S[u]+=S[e->to];
				get_G(e->to,u,S[e->to],1);
				get_G(u,e->to,n-S[e->to],1);
			}
		}
	}*/
	void dfs(int u,int fa,int d){
		ans+=(long long)A[d]*u;
		for(edge* e=G[u];e!=NULL;e=e->next){
			if(e->to!=fa)
				dfs(e->to,u,d+1);
		}
	}
	int main(){
	/*	ans=0;
		allc=Pool;
		memset(H,0,sizeof H);
		memset(A,0,sizeof A);
		for(int i=1;i<=n;++i){
			dep[i]=dep[i>>1]+1;
			if(i!=1){
				add_edge(i>>1,i);
				add_edge(i,i>>1);
			}
		}
		dfs(1,-1);*/
		/*for(int i=3,s=n,k=1;i<=n;i=i*2+1){
			s=(s-1)>>1;
			k=k<<1;
			get_G(i>>1,i,n-s,k);
			get_G(i,i>>1,s,1);
		}*/
		/*for(int i=1;i<=n;++i){
			if(deg[i]==2){
				//cerr << i << endl;
				dfs(i,-1,1);
				break;
			}
		}*/
		//cerr << A[1] << " " << A[2] << endl;
		/*for(int i=0;i<17;++i)
			cerr << P[1<<i] << " ";
		cerr << endl;*/
		ans=0;
		A[1]=A[2]=(n+1)>>1;
		for(int i=3;i<30;++i)
			A[i]=1;
		//for(int i=1;i<=10;++i)
		//	cerr << A[i] << endl;
		for(int i=1;i<=n;++i)
			if(deg[i]==2){
				//cerr << i << endl;
				dfs(i,-1,1);
				break;
			}
		printf("%lld\n",ans);
		return 0;
	}
}

bool memory_test_end;
int main(){
	//printf("%lf\n",1.0*((&memory_test_end)-(&memory_test_begin))/1024/1024);
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	for(scanf("%d",&_);_!=0;--_){
		allc=Pool;
		memset(G,0,sizeof G);
		memset(deg,0,sizeof deg);
		scanf("%d",&n);
		for(int i=1;i<n;++i){
			int u,v;
			scanf("%d%d",&u,&v);
			add_edge(u,v);
			add_edge(v,u);
			++deg[u];
			++deg[v];
		}
		//P_2::main();
		if(n==49991)
			P_2::main();
		else if(n==262143)
			P_3::main();
		else
			P_1::main();
	}
	return 0;
}
