#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn = 3e5;
int t, dfn[maxn + 10], ed[maxn + 10], dcnt, n, sz[maxn + 10], val[maxn + 10];
vector<int> g[maxn + 10];
ll ans;
struct que {
	int l, r, w;
};
vector<que> q[maxn + 10];

inline void read(int &x) {
	x = 0; char c = getchar();
	for (; c < '0' || c > '9'; c = getchar());
	for (; c >= '0' && c <= '9'; c = getchar()) x = x * 10 + c - '0';
}

struct bit {
	int c[maxn + 10];
	
	void init() {
		memset(c, 0, sizeof c);
	}
	void add(int p, int v) {
		for (; p <= n; p += p & -p) c[p] += v;
	}
	int ask(int p) {
		int ans = 0;
		for (; p; p -= p & -p) ans += c[p];
		return ans;
	}
	int query(int l, int r) {
		l = max(l, 1); r = min(r, n);
		if (l > r) return 0;
		return ask(r) - ask(l - 1);
	}
	
}s1, s2;

void dfssz(int p, int fa) {
	sz[p] = 1; dfn[p] = ++dcnt;
	for (int i = 0; i < (int)g[p].size(); ++i) {
		int e = g[p][i];
		if (e != fa) {
			dfssz(e, p); sz[p] += sz[e];
		}
	}
	ed[p] = dcnt;
	val[dfn[p]] = sz[p];
}

void addask(int l, int r, int wl, int wr, int w){
	if (l > 1)
		q[l - 1].push_back((que){wl, wr, -w});
	q[r].push_back((que){wl, wr, w});
}

void calcans(int p, int fa) {
	int mx = n - sz[p], mxid = 0, secmx = 0;
	for (int i = 0; i < (int)g[p].size(); ++i) {
		int e = g[p][i];
		if (e != fa) {
			if (sz[e] > mx) {
				secmx = mx; mx = sz[e]; mxid = e;
			} else if (sz[e] > secmx) secmx = sz[e];
		}
	}
	int now = mxid ? mx : secmx, s = n - sz[p];
	ans += 1ll * (s1.query(s * 2 - n, n - 2 * now) - s2.query(s * 2 - n, n - 2 * now)) * p;
	addask(1, n, s * 2 - n, n - 2 * now, p); addask(dfn[p], ed[p], s * 2 - n, n - 2 * now, -p);
	for (int i = 0; i < (int)g[p].size(); ++i) {
		int e = g[p][i];
		if (e != fa) {
			int now = mxid == e ? secmx : mx, s = sz[e];
			addask(dfn[e], ed[e], s * 2 - n, n - 2 * now, p);
			s1.add(n - sz[e], 1); s2.add(sz[p], 1);
			calcans(e, p);
			s1.add(n - sz[e], -1); s2.add(sz[p], -1);
		}
	}
}

void solveask() {
	for (int i = 1; i <= n; ++i) {
		s1.add(val[i], 1);
		for (int j = 0; j < (int)q[i].size(); ++j) {
			que e = q[i][j];
			ans += 1ll * e.w * s1.query(e.l, e.r);
		}
	}
}

void solve() {
	dcnt = 0; s1.init(); s2.init(); ans = 0;
	read(n);
	for (int i = 1; i <= n; ++i) {
		g[i].clear(); q[i].clear();
	}
	for (int i = 1; i < n; ++i) {
		int l, r; read(l); read(r);
		g[l].push_back(r); g[r].push_back(l);
	}
	dfssz(1, 0);
	calcans(1, 0);
	solveask();
	printf("%lld\n", ans);
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	read(t);
	while (t--) solve();
}

