#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn = 4e7;
int n, tp;
ll s[maxn + 10], f[maxn + 10], ans;
int res[4];

inline ll calc(int x) {
	return f[x] + s[x];
}

namespace dq {
	int id[maxn + 10], ql = 1, qr = 0;
	
	inline void ins(int i) {
		ll v = calc(i);
		while (qr && v <= calc(id[qr])) --qr;
		id[++qr] = i;
	}
	
	inline int ask(ll v) {
		ql = min(ql, qr);
		while (ql < qr && calc(id[ql + 1]) <= v) ++ql;
		return id[ql];
	}
}

const int base = 1e9;

void addsqr(ll x) {
	ll lo = x % base, hi = x / base;
	ll tmp = lo * lo + res[0];
	res[0] = tmp % base; tmp /= base;
	tmp += lo * hi * 2 + res[1];
	res[1] = tmp % base; tmp /= base;
	tmp += hi * hi + res[2];
	res[2] = tmp % base; tmp /= base;
	res[3] += tmp;
}

void output() {
	for (int i = 3; i >= 0; --i)
		if (res[i]) {
			printf("%d", res[i]);
			for (int j = i - 1; j >= 0; --j)
				printf("%08d", res[j]);
			return;
		}
	printf("0");
}

void solveit() {
	for (int i = 1; i <= n; ++i) s[i] += s[i - 1];
	f[0] = 0;
	dq::ins(0);
	for (int i = 1; i <= n; ++i) {
		f[i] = s[i] - s[dq::ask(s[i])];
		dq::ins(i);
	}
	for (int i = n, lst; i >= 1; i = lst) {
		for (lst = i - 1; lst && s[i] - s[lst] < f[lst]; --lst);
		if (tp == 0) ans += (s[i] - s[lst]) * (s[i] - s[lst]);
		else addsqr(s[i] - s[lst]);
	}
	if (tp == 0) printf("%lld", ans);
	else output();
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &tp);
	if (tp == 0) 
		for (int i = 1; i <= n; ++i) scanf("%lld", &s[i]);
	else {
		ll x, y, z; int m;
		const int mod = (1 << 30) - 1;
		scanf("%lld%lld%lld%d%d%d", &x, &y, &z, &s[1], &s[2], &m);
		for (int i = 3; i <= n; ++i) s[i] = (x * s[i - 1] + y * s[i - 2] + z) & mod;
		for (int i = 1, lst = 0; i <= m; ++i) {
			int p, l, r; scanf("%d%d%d", &p, &l, &r);
			for (int j = lst + 1; j <= p; ++j)
				s[j] = s[j] % (r - l + 1) + l;
			lst = p;
		}
	}
	solveit();
}
