#include<bits/stdc++.h>
using namespace std;
const int M=300005;
int n,du[M],id[M],sgid[M];
struct Edge {
	int a,b;
} E[M];
int head[M],asdf;
struct edge {
	int to,nxt;
} G[M*2];
void add_edge(int a,int b) {
	G[++asdf].to=b;
	G[asdf].nxt=head[a];
	head[a]=asdf;
}
int que_len,que[M],sz[M],son[M];
void dfs(int x,int f) {
	que[++que_len]=x;
	sz[x]=1,son[x]=0;
	for(int i=head[x]; i; i=G[i].nxt) {
		int y=G[i].to;
		if(y==f)continue;
		dfs(y,x);
		if(sz[y]>son[x])son[x]=sz[y];
		sz[x]+=sz[y];
	}
}
void solve1() {
	long long ans=0;
	for(int i=1; i<n; i++) {
		int sum=0;
		que_len=0;
		dfs(E[i].a,E[i].b);
		for(int j=1; j<=que_len; j++) {
			int x=que[j];
			son[x]=max(son[x],que_len-sz[x]);
			if(son[x]<=que_len/2)sum+=x;
		}
		que_len=0;
		dfs(E[i].b,E[i].a);
		for(int j=1; j<=que_len; j++) {
			int x=que[j];
			son[x]=max(son[x],que_len-sz[x]);
			if(son[x]<=que_len/2)sum+=x;
		}
		ans=ans+sum;
	}
	printf("%lld\n",ans);
}
void solve2() {
	int x=1;
	for(int i=1; i<=n; i++)if(du[i]==1)x=i;
	int cnt=0;
	while(id[x]==0) {
		id[x]=++cnt;
		sgid[cnt]=x;
		for(int i=head[x]; i; i=G[i].nxt) {
			int y=G[i].to;
			if(id[y]==0)x=y;
		}
	}
	long long ans=0;
	for(int i=1; i<n; i++) {
		int a=i,b=n-i;
		if(a&1)ans+=sgid[a/2+1];
		else ans+=sgid[a/2]+sgid[a/2+1];
		if(b&1)ans+=sgid[b/2+1+a];
		else ans+=sgid[b/2+a]+sgid[b/2+1+a];
	}
	printf("%lld\n",ans);
}
void dfs3(int x,int f,int c) {
	id[x]=c,sgid[c]=x;
	c<<=1;
	for(int i=head[x]; i; i=G[i].nxt) {
		int y=G[i].to;
		if(y==f)continue;
		dfs3(y,x,c);
		c++;
	}
}
void solve3() {
	que_len=0;
	dfs(1,0);
	int root=1;
	for(int j=1; j<=que_len; j++) {
		int x=que[j];
		son[x]=max(son[x],que_len-sz[x]);
		if(son[x]<=son[root])root=x;
	}
	dfs3(root,0,1);
	long long ans=0;
	for(int i=1; i<n; i++) {
		int a=E[i].a,b=E[i].b;
		int ia=id[a],ib=id[b];
		if(ia>ib)swap(ia,ib),swap(a,b);
		ans+=b;
		if(ib>n/2)ans+=root;
		while(ib>3)ib>>=1;
		ans+=sgid[ib^1];
	}
	printf("%lld\n",ans);
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--) {
		scanf("%d",&n);
		asdf=0;
		for(int i=1; i<=n; i++)head[i]=id[i]=du[i]=0;
		for(int i=1; i<n; i++) {
			int a,b;
			scanf("%d %d",&a,&b);
			du[a]++,du[b]++;
			add_edge(a,b);
			add_edge(b,a);
			E[i].a=a,E[i].b=b;
		}
		if(n==49991)solve2();
		else if(n==262143)solve3();
		else solve1();
	}
	return 0;
}
