#include<cstdio>
#include<cstring>
#include<iostream>
using namespace std;
const int MAXN=3e5+10,INF=5e6+10;
int from[MAXN],to[MAXN],Min,ans,sz[MAXN],Max[MAXN],rt,sum,T,n,in[MAXN],rt2;
int tot,head[MAXN];
struct Edge
{
	int to,nxt;
}e[2*MAXN];
void add(int x,int y)
{
	e[++tot]=(Edge){y,head[x]};
	head[x]=tot;
}
void init()
{
	ans=tot=rt=rt2=0;
	memset(head,0,sizeof(head));
	memset(e,0,sizeof(e));
	memset(in,0,sizeof(in));
}
void dfs(int u,int fa)
{
//	printf("--%d %d\n",u,fa);
	sz[u]=1;
	Max[u]=0;
	for(int i=head[u];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if(v==fa)
			continue;
		dfs(v,u);
		sz[u]+=sz[v];
		Max[u]=max(Max[u],sz[v]);
	}
//	printf("%d %d %d\n",u,sz[u],Max[u]);
}
void dfs2(int u,int fa)
{
	for(int i=head[u];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if(v==fa)
			continue;
		dfs2(v,u);
	}
	Max[u]=max(Max[u],sz[rt]-sz[u]);
	if(Max[u]<Min)
		Min=Max[u],sum=0;
	if(Max[u]==Min)
		sum+=u;
}
void dfs3(int u,int fa)
{
	sz[u]=1;
	to[u]=0;
	for(int i=head[u];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if(v==fa)
			continue;
		to[u]=v;
		dfs3(v,u);
		sz[u]+=sz[v];
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	for(int Case=1;Case<=T;++Case)
	{
		init();
		scanf("%d",&n);
		for(int i=1;i<n;++i)
		{
			scanf("%d%d",&from[i],&to[i]);
			add(from[i],to[i]);
			add(to[i],from[i]);
			++in[from[i]],++in[to[i]];
		}
		if(n==49991)
		{
			for(int i=1;i<=n;++i)
				if(in[i]==1&&rt==0)
					rt=i;
				else
				if(in[i]==1)
					rt2=i;
			dfs3(rt,0);
			int tot=n,now=rt;
			for(tot=n-1;tot>=1;--tot)
			{
				while(max(tot-sz[now],sz[now]-1)>max(tot-sz[to[now]],sz[to[now]]-1)&&to[now]!=0)
					now=to[now];
				ans+=now;
				if(max(tot-sz[now],sz[now]-1)==max(tot-sz[to[now]],sz[to[now]]-1)&&to[now]!=0)
					ans+=to[now];
			}
			dfs3(rt2,0);
			tot=n,now=rt2;
			for(tot=n-1;tot>=1;--tot)
			{
				while(max(tot-sz[now],sz[now]-1)>max(tot-sz[to[now]],sz[to[now]]-1)&&to[now]!=0)
					now=to[now];
				ans+=now;
				if(max(tot-sz[now],sz[now]-1)==max(tot-sz[to[now]],sz[to[now]]-1)&&to[now]!=0)
					ans+=to[now];
			}
			printf("%d\n",ans);
		}
		else
		{
			for(int i=1;i<n;++i)
			{
				Min=INF,sum=0;
				rt=to[i];
				dfs(to[i],from[i]);
				dfs2(to[i],from[i]);
				ans+=sum;
				Min=INF,sum=0;
				rt=from[i];
				dfs(from[i],to[i]);
				dfs2(from[i],to[i]);
				ans+=sum;
			}
			printf("%d\n",ans);
		}
	}
	return 0;
}
