#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
typedef long long ll;
const int N=50,M=510;
const int mod = 998244353;
int a[N][M];
int dp[N][M];
int n,m;
int ans;
void dfs(int i,int fir,int sec,int tot,int sum)
{
	if(fir+sec==tot)
	{
		ans=(ll)(ans+sum)%mod;
		return ;
	}
	if(i>n)return;
	if(n-i+1+fir+sec<tot)return;
	dfs(i+1,fir,sec,tot,sum);
	if(fir<tot/2)dfs(i+1,fir+1,sec,tot,sum*a[i][1]);
	if(sec<tot/2)dfs(i+1,fir,sec+1,tot,sum*a[i][2]);
}

void brute_one()
{
	for(int k=2;k<=n;k+=2)
	{
		dfs(1,0,0,k,1);
//		memset(dp,0,sizeof dp);
//		dp[1][1]=a[1][1];dp[1][0]=a[1][2];
//		for(int i=2;i<=n;i++)
//		{
//			for(int j=0;j<=i;j++)
//			{
//				if(j<=n/2)dp[i][j]+=(ll)dp[i-1][j-1]*a[i][1]%mod;
//				if(i-j<n/2)dp[i][j]+=(ll)dp[i-1][j]*a[i][2]%mod;
//			}
//		}
//		for(int i=1;i<=n;i++)
		
	}
	printf("%d\n",ans);
}

void d2(int i,int fir,int sec,int thi,int tot,int sum)
{
	if(fir+sec+thi==tot)
	{
		ans=(ll)(ans+sum)%mod;
		return ;
	}
	if(i>n)return;
	if(n-i+1+fir+sec+thi<tot)return;
	d2(i+1,fir,sec,thi,tot,sum);
	if(fir<tot/2)d2(i+1,fir+1,sec,thi,tot,sum*a[i][1]);
	if(sec<tot/2)d2(i+1,fir,sec+1,thi,tot,sum*a[i][2]);
	if(thi<tot/2)d2(i+1,fir,sec,thi+1,tot,sum*a[i][3]);
}

void brute_two()
{
	for(int k=2;k<=n;k++)
	{
		d2(1,0,0,0,k,1);
	}
	printf("%d\n",ans);
}

int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++)
		for(int j=1;j<=m;j++)
			scanf("%d",&a[i][j]);
	if(m==2)
	{
		brute_one();
		return 0;
	}
	if(m==3)
	{
		brute_two();
		return 0;
	}
	return 0;
}
/*
15 3
60 25 75
160 53 102
231 219 100
215 122 124
230 115 13
134 180 146
83 2 77
116 141 5
202 184 18
210 76 8
147 149 25
99 119 232
177 18 176
85 206 209
96 223 13
*/
