#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll MOD=998244353;
const int N=300005;

struct Edge{
	int from,to;
}E[N*2];

ll first[N*2],nxt[N*2],point[N*2],e=0,n;
void add_edge(ll x,ll y)
{
	nxt[e]=first[x];
	first[x]=e;
	point[e++]=y;
}

void init()
{
	memset(first,-1,sizeof(first));
	memset(nxt,-1,sizeof(nxt));
	e=0;
}

ll f[2002][2002],sz[N],vis[N],fa[N];
void dfs(ll u,ll F)
{
	vis[u]=1;
	sz[u]=1;
	fa[u]=F;
	for(ll i=first[u];i!=-1;i=nxt[i])
	{
		ll v=point[i];
		if(v==F||!f[u][v]) continue;
		dfs(v,u);
		sz[u]+=sz[v];
	}
}

ll solve(ll x)
{
	memset(vis,0,sizeof(vis));
	ll ret=0;
	dfs(x,-1);
	if(sz[x]==1) 
	{
		return x;
	}
	for(ll i=1;i<=n;i++)
	{
		if(!vis[i]) continue;
		ll bl=1;
		for(ll j=first[i];j!=-1;j=nxt[j])
		{
			ll v=point[j];
			if(!f[i][v]||fa[i]==v) continue;
			if(sz[v]*2>sz[x]) 
			{
				bl=0;
				break;
			} 
		}
		if((sz[x]-sz[i])*2>sz[x]) bl=0;
		if(bl) 
		{
			ret+=i;
		}
	}
	return ret;
}

void subtask1()
{
	ll ans=0;
	for(ll i=1;i<=n;i++)
		for(ll j=1;j<=n;j++) f[i][j]=1;
	for(ll i=1;i<n;i++)
	{
		ll x=E[i].from,y=E[i].to;
		f[x][y]=0; f[y][x]=0;
		ans+=solve(x);
		ans+=solve(y);
		f[x][y]=1; f[y][x]=1;
	}
	printf("%lld\n",ans);
}

ll in[N];
bool judge1()//lian
{
	memset(in,0,sizeof(in));
	for(ll i=1;i<n;i++)
	{
		in[E[i].from]++;
		in[E[i].to]++;
	}
	for(ll i=1;i<=n;i++) if(in[i]>2) return 0;
	return 1;
}

void subtask2()
{
	ll ans=0;
	for(ll i=1;i<=n;i++) 
	{
		if(in[i]==1) ans+=i;
		else ans+=i*2;
	} 
	printf("%lld\n",ans);
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ll T; scanf("%lld",&T);
	while(T--)
	{
		init();
		scanf("%lld",&n);
		for(ll i=1;i<n;i++)
		{
			scanf("%lld%lld",&E[i].from,&E[i].to);
			add_edge(E[i].from,E[i].to);
			add_edge(E[i].to,E[i].from);
		} 
		if(n<=2000) 
		{
			subtask1();
			continue;
		}
		if(judge1())
		{
		 	subtask2();
		 	continue;
		}
		//subtask3();
		continue;
	}
	fclose(stdin); fclose(stdout);
	return 0;
}
