#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;
typedef long long ll;
const int N=2e3+5,M=5e4+5;
typedef long long ll;
int re()
{
	int all=0,key=1;char a=getchar();
	while(a<'0'||a>'9'){if(a=='-') key=-1;a=getchar();}
	while(a<='9'&&a>='0'){all=(all<<3)+(all<<1)+a-'0';a=getchar();}
	return all*key;
}
struct edge{
	int nxt,to,x,y;
}e[N<<1],f[1<<M];
int first[N],tot,n,siz[N];
ll anw;
bool bri[N<<1];
void add(int x,int y)
{
	e[++tot].to=y;
	e[tot].nxt=first[x];
	e[tot].x=x;
	e[tot].y=y;
	first[x]=tot;
}
int first2[M],tot2;
void add2(int x,int y)
{
	f[++tot2].to=y;
	f[tot2].nxt=first2[x];
	first2[x]=tot2;
}
int find(int x){
	if(x&1) return x+1;
	return x-1;
}

int sizson[N];
void query(int x,int fa)
{
	int i,to;
	sizson[x]++;
	for(i=first[x];i;i=e[i].nxt)
	{
		to=e[i].to;
		if(bri[i]==true||to==fa) continue;
		query(to,x);
		sizson[x]+=sizson[to];
	}
}
void dfs(int x,int fa,int sizemax)
{
	bool flag=true;
	int i,to;
	siz[x]++;
	for(i=first[x];i;i=e[i].nxt)
	{
		to=e[i].to;
		if(to==fa||bri[i]==true) continue;
		dfs(to,x,sizemax);
		if(siz[to]>(sizemax/2)) flag=false;
		siz[x]+=siz[to];
	}
	if(sizemax-siz[x]>(sizemax/2)) flag=false;
	if(flag==true) anw+=x;
}
int ru[N],line[N];
void dfs2(int x,int fa,int ste)
{
	line[ste]=x;
	int i,to;
	for(i=first2[x];i;i=f[i].nxt)
	{
		to=f[i].to;
		if(to==fa) continue;
		dfs2(to,x,ste+1);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=re();
	for(int k=1;k<=T;k++)
	{
		int i,x,y,sx,sy;anw=0;
		memset(e,0,sizeof(e));
		memset(bri,false,sizeof(bri));
		memset(first,0,sizeof(first));
		memset(ru,0,sizeof(ru));
		n=re();
		if(n==49991)
		{
			for(i=1;i<=n-1;i++)
			{
				x=re();y=re();
				add2(x,y);
				add2(y,x);
				ru[x]++;
				ru[y]++;
			}
			int hea;
			for(i=1;i<=n;i++)
			{
				if(ru[i]==1){
					hea=i;
					break;
				}
			}
			dfs2(hea,hea,1);
			int l1,r1,l2,r2;
			for(i=1;i<=n-1;i++)
			{
				l1=1;r1=i;
				l2=r1+1;r2=n;
				if(((r1-l1+1)&1)==1)
					anw+=(ll)line[(1+r1)/2];
				if(((r1-l1+1)&1)==0)
					anw+=(ll)line[r1/2]+line[(r1/2)+1];
				if(((r2-l2+1)&1)==1)
					anw+=(ll)line[(l2+r2)/2];
				if(((r2-l2+1)&1)==0)
					anw+=(ll)line[(l2+r2-1)/2]+line[(l2+r2+1)/2];	
			}
			printf("%lld\n",anw);
		}
		else{
			for(i=1;i<=n-1;i++)
			{
				x=re();y=re();
				add(x,y);
				add(y,x);
			}
			for(i=1;i<=tot;i+=2)
			{
				memset(siz,0,sizeof(siz));
				memset(sizson,0,sizeof(siz));
				bri[i]=bri[find(i)]=true;
				x=e[i].x;
				y=e[i].y;
				query(x,x);
				query(y,y);
				sx=sizson[x];
				sy=sizson[y];
				dfs(x,x,sx);
				dfs(y,y,sy);
				bri[i]=bri[find(i)]=false;
			}
			printf("%lld\n",anw);
		}
	}
}
