#include <cstdio>
#include <iostream>
#include <vector>

#define ll unsigned long long

#define inf 18446744073709551614ull

using namespace std;

vector<int> t[300000];
int w[300000], wt[300000];
int n;

void getW(int x, int o, int f)
{
	int c = 1;
	for (int i = 0; i < t[x].size(); i++)
	{
		if (t[x][i] == o) continue;
		getW(t[x][i], x, f);
		c += w[t[x][i]];
	}
	w[x] = c;
	wt[x] = f;
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	int ccc, x, y;
	scanf("%d", &ccc);
	for (int i = 0; i < ccc; i++)
	{
		scanf("%d", &n);
		for (int j = 1; j <= n; j++)
			t[j].clear();
		for (int j = 0; j < n-1; j++)
		{
			scanf("%d%d", &x, &y);
			t[x].push_back(y);
			t[y].push_back(x);
		}
		int tot = 0;
		for (int j = 1; j <= n; j++)
		{
			int cnt = 0;
			for (int k = 0; k < t[j].size(); k++)
				getW(t[j][k], j, t[j][k]);
			
			for (int k = 1; k <= n; k++)
			{
				if (k == j) continue;
				int ow = w[k];
				w[wt[k]] -= ow;
				bool ok = true;
				for (int l = 0; l < t[j].size(); l++)
					if (t[j][l] != k && w[t[j][l]] > (n-ow)/2)
						{ ok = false; break; }
				if (ok) cnt++;
				w[wt[k]] += ow;
			}
			tot += cnt*j;
		}
		printf("%d\n", tot);
	}
	
	return 0;
}
