#include <cstdio>
#include <iostream>

#define ll unsigned long long

#define inf 18446744073709551614ull

using namespace std;

ll n, typ, a[500005] = {0}, sum[500005] = {0};
// dp[i][j] = min{dp[i-k][j-1]+sum(i-k, k)}
ll dp[500005][2] = {0}, mn[500005][2], ans = inf;

int main()
{
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	
	scanf("%d%d", &n, &typ);
	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &a[i]);
		sum[i] = sum[i-1] + a[i];
	}
	
	for (int i = 1; i <= n; i++)
	{
		dp[i][1] = sum[i]*sum[i];
		mn[i][1] = sum[i];
	}
	ans = dp[n][1];
	//printf("%d:%lld\n", 1, ans);
	for (int j = 2; j <= n; j++)
	{
		for (int i = j; i <= n; i++)
		{
			dp[i][j%2] = inf;
			mn[i][j%2] = inf;
			for (int k = j-1; k < i; k++)
			{
				ll p = sum[i] - sum[k];
				if (p < mn[k][(j-1)%2]) continue;
				dp[i][j%2] = min(dp[i][j%2], dp[k][(j-1)%2] + p*p);
				mn[i][j%2] = min(mn[i][j%2], p);
			}
		}
		ans = min(ans, dp[n][j%2]);
		//printf("%d:%lld\n", j, ans);
	}
	printf("%lld", ans);
	return 0;
}
