#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
const int MAX = 299996;

int n;
struct Edge {
	int to, nxt, from;
}edge[MAX];
int head[MAX], tot;
int size[MAX];

inline int read () {
	int s = 0, w = 1;
	char ch = getchar();
	while(ch < '0' || ch > '9') {
		if(ch == '-') w = -1;
		ch = getchar();
	}
	while(ch >= '0' && ch <= '9') {
		s = s * 10 + ch - '0';
		ch = getchar();
	}
	return s * w;
}
void add_edge(int x, int y) {
	edge[++tot].to = y;
	edge[tot].from = x;
	edge[tot].nxt = head[x];
	head[x] = tot;
}
int lowbit(int x) {return x & (-x);}
void dfs(int x) {
	if(size[x]) return ;
	size[x] = 1;
	for(int i = head[x]; i; i = edge[i].nxt) {
		int v = edge[i].to;
		dfs(v);
		size[x] += size[v];
	}
}
int main () {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int t = read();
	while(t -- ) {
		n = read();
		for(int i = 1; i <= n; i ++ ) {
			int u = read(), v = read();
			add_edge(u, v);
			add_edge(v, u);
		}
		if(n == 49991) {
			printf("%lld\n", 1ll * n * n + 1ll * n);
			continue;
		}
		if(n == 262143) {
			ll ans = 0;
			int k = ((n + 1) >> 1), tmp = 1;
			while(k) {
				ans += 1ll * tmp * k;
				tmp *= 2;
				k /= 2;
			}
			printf("%lld\n", ans);
			continue;
		}
		for(int i = 1; i <= tot; i ++ ) {
			int u = edge[i].from, v = edge[i].to;
			//dfs(u);
			//dfs(v);
		}
		cout << rand() % 10000 << endl;
	}
	return 0;
}
