#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
const int MOD = 998244353;
const int MAX_N = 110;
const int MAX_M = 2010;

int n, m, ans;
int a[MAX_N][MAX_M], vis[MAX_M], mark[MAX_M];

inline int read () {
	int s = 0, w = 1;
	char ch = getchar();
	while(ch < '0' || ch > '9') {
		if(ch == '-') w = -1;
		ch = getchar();
	}
	while(ch >= '0' && ch <= '9') {
		s = s * 10 + ch - '0';
		ch = getchar();
	}
	return s * w;
}
void dfs(int x, int k, int now) {
	if(!k) {
		ans += now;
		ans %= MOD;
		return ;
	}	
	if(x > n) return ;
	for(int i = 1; i <= m; i ++ ) {
		if(a[x][i] && mark[i] > 0) {
			mark[i] -= 1;
			dfs(x + 1, k - 1 , (now * a[x][i]) % MOD);
			mark[i] += 1;
		}
	}
	dfs(x + 1, k, now);
}
int main () {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	n = read(), m = read();
	for(int i = 1; i <= n; i ++ ) for(int j = 1; j <= m; j ++ ) a[i][j] = read();
	for(int k = 1; k <= n; k ++ ) {
		for(int j = 1; j <= m; j ++ ) mark[j] = k / 2;
		dfs(1, k, 1);
	}
	printf("%d\n", ans);
	return 0;
}            
