#include<iostream>
#include<cstdio>
#include<cstring>
#define ll long long

using namespace std;

ll inf=4e18;
int n,opt,a[5010],sum[5010],lc[50000010],rc[50000010],cnt;
ll ans,w[50000010];

int read(){
	int ret=0;
	char c=getchar();
	while (c<'0'||c>'9') c=getchar();
	while (c>='0'&&c<='9'){
		ret=ret*10+c-'0';
		c=getchar();
	}
	return ret;
}

void pushup(int u){
	if (!lc[u]&&!rc[u]) w[u]=inf;
	else if (!lc[u]) w[u]=w[rc[u]];
	else if (!rc[u]) w[u]=w[lc[u]];
	else w[u]=min(w[lc[u]],w[rc[u]]);
}

void update(int u,int l,int r,int x,ll val){
	if (l==r){
		if (w[u]==-1) w[u]=val;
		else w[u]=min(w[u],val);
		return;
	}
	int mid=(l+r)>>1;
	if (x<=mid){
		if (!lc[u]) lc[u]=++cnt;
		update(lc[u],l,mid,x,val);
	}
	else{
		if (!rc[u]) rc[u]=++cnt;
		update(rc[u],mid+1,r,x,val);
	}
	pushup(u);
}

ll query(int u,int l,int r,int li,int ri){
	if (l>r||l>ri||li>r||li>ri) return inf;
	if (!u) return inf;
	if (l==li&&r==ri) return w[u];
	int mid=(l+r)>>1;
	return min(query(lc[u],l,mid,li,min(mid,ri)),
			   query(rc[u],mid+1,r,max(mid+1,li),ri));
}

int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	scanf("%d%d",&n,&opt);
	if (opt==0){
		for (int i=1;i<=n;i++)
			a[i]=read();
	}
	for (int i=1;i<=n;i++)
		sum[i]=sum[i-1]+a[i];
	memset(w,-1,sizeof(w));
	cnt=n+1;
	for (int i=1;i<=n+1;i++)
		w[i]=inf;
	update(1,0,0,0,0);
//	cout<<w[n+1]<<endl;
	for (int i=1;i<=n;i++)
		for (int j=0;j<i;j++)
			update(i+1,0,sum[i],sum[i]-sum[j]
					,query(j+1,0,sum[j],0,min(sum[j],sum[i]-sum[j]))
					+(ll)(sum[i]-sum[j])*(sum[i]-sum[j]));
	printf("%lld\n",w[n+1]);
	return 0;
}
