#include <bits/stdc++.h>

#define coint const int

using namespace std;

bool bmm1;

// Start

typedef long long ll;

coint SIZE = 40000000 + 5;
const ll INF = 5e18;

inline ll getInt(void) {
    ll x = 0, ch = getchar();
    for (; ch < '0' || ch > '9'; ch = getchar());
    for (; ch >= '0' && ch <= '9';
         x = (x << 1) + (x << 3) + (ch - '0'), ch = getchar());
    return x;
}

int n, ty;
ll ai[SIZE];

struct P64 {
    static coint SIZE = 5000 + 5;

    ll dp[SIZE][SIZE];
    ll sum[SIZE];

    inline ll getSum(coint le, coint ri) { return sum[ri] - sum[le - 1]; }

    ll solve(void) {
        for (int i = 0; i <= n; ++i)
            for (int j = 1; j <= i + 1; ++j) dp[i][j] = INF;
        sum[0] = 0;
        for (int i = 1; i <= n; ++i) sum[i] = sum[i - 1] + ai[i];

        dp[1][1] = ai[1] * ai[1];
        for (int i = 2; i <= n; ++i) {
            int le = i;
            for (int j = i; j; --j) {
                const ll xsum = getSum(j, i); // <= 5e8
                for (; le > 1 && getSum(le - 1, j - 1) <= xsum; --le);
                dp[i][j] = INF;
                if (le <= j - 1)
                    dp[i][j] = min(INF, dp[j - 1][le] + xsum * xsum);
                //printf("dp[%d][%d] = %lld\n", i, j, dp[i][j]);
            }
            const ll xsum = getSum(1, i);
            dp[i][1] = min(dp[i][1], xsum * xsum);
            for (int j = i - 1; j; --j) dp[i][j] = min(dp[i][j], dp[i][j + 1]);
        }
        return dp[n][1];
    }
} p64;

// End

bool bmm2;

/* Todo:
     * [x] 内存
     * [x] 文件 IO
     * [x] 下标未越界
     * [x] 输出语句
     * [x] 数据类型
     * [x] 取模
     * [x] 初始化
 */

int main(void) {
    //printf("%f\n", (&bmm2 - &bmm1) / 1024.0 / 1024.0);
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
    n = getInt(), ty = getInt();
    if (!ty) {
        for (int i = 1; i <= n; ++i) ai[i] = getInt();
    }
    printf("%lld\n", p64.solve());
    return 0;
}

