#include<bits/stdc++.h>

using namespace std;

const int maxn=3e5+5;

int to[maxn*2];

int nxt[maxn*2];

int head[maxn];
int cnt;
int edge[maxn][2];
int sz[maxn];

int in[maxn];

int mx;

int id[maxn];

int tmp_sz[maxn];

void dfs_init(int u,int pre)
{
	sz[u]=1;
	for(int i=head[u];i;i=nxt[i])
	{
		int v=to[i];
		if(v==pre) continue;
		dfs_init(v,u);
		sz[u]+=sz[v];
	}
}

void add(int u,int v)
{
	to[++cnt]=v;
	nxt[cnt]=head[u];
	head[u]=cnt;
}

int n;

void dfs_solve(int now,int pre,int sum,int limit)
{
	tmp_sz[now]=1;
	int mx_tmp=0;
	for(int i=head[now];i;i=nxt[i])
	{
		int v=to[i];
		if(v==pre||v==limit) continue;
		dfs_solve(v,now,sum,limit);
		mx_tmp=max(tmp_sz[v],mx_tmp);
		tmp_sz[now]+=tmp_sz[v];
	}
	mx_tmp=max(mx_tmp,sum-tmp_sz[now]);
	if(mx_tmp<=sum/2) mx+=now;
}

void dfs_l(int now,int pre,int dep)
{
	if(dep==n+1) return;
	id[dep]=now;
	for(int i=head[now];i;i=nxt[i])
	{
		int v=to[i];
		if(v==pre) continue;
		dfs_l(v,now,dep+1);
	}
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d",&n);
		int u,v;
		for(int i=1;i<=n;i++) 
		{
			head[i]=in[i]=0;
		}
		cnt=0;
		for(int i=1;i<n;i++)
		{
			scanf("%d%d",&u,&v);
			add(u,v);
			add(v,u);
			edge[i][0]=u;
			edge[i][1]=v;
			in[u]++;
			in[v]++;
		}
		int cnt_1=0;
		int cnt_2=0;
		int cnt_3=0;
		int pos;
		for(int i=1;i<=n;i++)
		{
			if(in[i]==1)
			{
				cnt_1++;
				pos=i;
			} 
			else if(in[i]==2) cnt_2++;
			else if(in[i]==3) cnt_3++;
			else break;
		}
		if(cnt_1==2&&cnt_2==n-2)
		{
			dfs_l(pos,0,1);
			long long ans=0;
			for(int i=1;i<n;i++)
			{
				if(i&1)
				{
					ans+=id[i/2+1];
					if(n&1)
					{
						ans+=id[i+(n-i)/2];
						ans+=id[i+1+(n-i)/2];
					}
					else ans+=id[1+i+(n-i)/2];
				}else
				{
					ans+=id[i/2];
					ans+=id[i/2+1];
					if(n%2==0)
					{
						ans+=id[i+(n-i)/2];
						ans+=id[i+1+(n-i)/2];
					}
					else ans+=id[1+i+(n-i)/2];
				}
			}
			printf("%lld\n",ans);
			continue;
		}
		else if(cnt_1==(n+1)/2&&cnt_2==1&&cnt_3==n-(n+1)/2-1&&log(n+1)*log(n+1)==n+1)
		{
			long long ans=0;
			for(int i=head[pos];i;i=nxt[i])
			{
				int v=to[i];
				ans+=(n+1)/2*v*1LL;
			}
			ans+=1LL*pos*(n+1)/2;
			ans+=(1+n)*n*1LL/2;
			ans-=pos;
			printf("%lld\n",ans);
			continue;
		}
		else
		{	
			dfs_init(1,0);
			long long ans=0;
			for(int i=1;i<n;i++)
			{
				u=edge[i][0];
				v=edge[i][1];
				if(sz[u]>sz[v]) swap(u,v);
				mx=0;
				dfs_solve(u,0,sz[u],v);
//				cout<<mx<<" ";
				ans+=mx;
				mx=0;
				dfs_solve(v,0,n-sz[u],u);
//				cout<<mx<<endl;
				ans+=mx;
			}
			printf("%lld",ans);
		}
	}
	return 0;
}
