#include <vector>
#include <stdio.h>
#include <ctype.h>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

inline int read(int x=0,bool w=0,char ch=0) {
	for (;!isdigit(ch);(ch=='-') && (w=1),ch=getchar());
	for (;isdigit(ch);x=(x<<3)+(x<<1)+(ch^48),ch=getchar());
	return (w) ? -x:x;
} 
inline void write(int x) {
	if (x>9) write(x/10);
	putchar(x%10+48);
}
inline void writeln(int x) {
	if (x>=0) write(x); else putchar('-'),write(-x);
	putchar('\n');
}

const int maxn=300007;
int n,sum[maxn],father[maxn],head[maxn],to[maxn],next[maxn],cnt,ans;
bool vis[maxn];
inline void add(int x,int y) {
	cnt++;
	next[cnt]=head[x];
	head[x]=cnt;
	to[cnt]=y;
}
inline void dfs(int now) {
	vis[now]=1;
	sum[now]=1;
	for (register int i=head[now];i;i=next[i]) if (!vis[to[i]]) {
		dfs(to[i]);
		sum[now]+=sum[to[i]];
		father[to[i]]=now;
	}
}
inline int getfather(int x) {
	return (father[x]==x) ? x:getfather(father[x]);
}
inline void modify(int x,int v) {
	sum[x]+=v;
	if (father[x]==x) return;
	modify(father[x],v);
}
inline void findg(int anc) {
	for (register int i=1;i<=n;i++) if (getfather(i)==anc && sum[anc]-sum[i]<=sum[anc]/2) {
		bool flag=0;
		if (head[i]) for (register int k=head[i];k && !flag;k=next[k]) if (to[i]!=father[i] && father[to[i]]==i && sum[to[i]]>sum[anc]/2) flag=1;
		if (!flag) ans+=i;
	}
}

int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t=read();
	while (t--) {
		cnt=0,ans=0;
		memset(vis,0,sizeof(vis));
		memset(father,0,sizeof(father));
		memset(next,0,sizeof(next));
		memset(head,0,sizeof(head));
		memset(sum,0,sizeof(sum));
		n=read();
		for (register int i=1;i<n;i++) {
			int x=read(),y=read();
			add(x,y),add(y,x);
			father[i]=i;
		}
		father[n]=n;
		dfs(1);
		for (register int i=1;i<=n;i++) {
			if (father[i]==i) continue;
			int temp=father[i];
			father[i]=i;
			modify(temp,-sum[i]);
			findg(1),findg(i);
			father[i]=temp;
			modify(temp,sum[i]);
		}
		writeln(ans);
	}
	return 0;
}
