#include <cstdio>
#include <string.h>

inline int read(){
	int x =0; char c =getchar();
	while(c < '0' || c > '9') c =getchar();
	while(c >= '0' && c <= '9') x = (x<<3) + (x<<1) + (48^c), c =getchar();
	return x;
}

int N;
int fst[300000], suml[300000], IN[300000];
int net[600000], to[600000], from[600000];

inline void init(){
	memset(fst, -1, sizeof(fst));
	memset(suml, 0, sizeof(suml));
	for(int i =0; i < N-1; ++i){
		int A =read()-1, B =read()-1;
		to[i] =B, to[i+N-1] =A;
		net[i] =fst[A], net[i+N-1] =fst[B];
		fst[A] =i, fst[B] =i+N-1;
		++suml[A], ++suml[B];
		from[i] =A, from[i+N-1] =B;
		++IN[A], ++IN[B];
	}
	return;
}

long long ANS;

int sze[600000];
	int dfs(int nl){
		if(sze[nl] != 0) return sze[nl];
		sze[nl] =1;
		for(int l =fst[to[nl]]; l != -1; l =net[l]){
			if(to[l] != from[nl]){
				sze[nl] +=dfs(l);
			}
		}
		return sze[nl];
	}
	int CNT, SIZE, NO, DELTA;
	
namespace a{
	
	
	void dfs2(int nw, int last){
		if(CNT > 2) return;
		bool IS =1;
		for(int l =fst[nw]; l != -1; l =net[l]){
			if(to[l] != NO){
				if((to[l] != last && sze[l] > SIZE) || (to[l] == last && sze[l]-DELTA > SIZE)){
					IS =0;
					break;
				}
			}
		}
		if(IS){
			++CNT;
			ANS +=nw+1;
		}
		if(CNT > 2) return;
		for(int l =fst[nw]; l != -1; l =net[l]){
			if(to[l] != NO && to[l] != last){
				dfs2(to[l], nw);
				if(CNT > 2) return;
			}
		}
		return;
	}
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T =read();
	while(T--){
		N =read();
		if(N < 49991 || N == 199995 || N == 299995 || N == 262143){
			init();
			memset(sze, 0, sizeof(sze));
			for(int i =0; i < 2*(N-1); ++i){
				if(sze[i] == 0) sze[i] =dfs(i);
			}
			ANS =0;
			for(int DEL =0; DEL < N-1; ++DEL){
				CNT =0; SIZE =(N-sze[DEL+N-1])/2;
				NO =from[DEL]; DELTA =sze[DEL+N-1];
				a::dfs2(to[DEL], to[DEL]);
				CNT =0; SIZE =(N-sze[DEL])/2;
				NO =to[DEL]; DELTA =sze[DEL];
				a::dfs2(from[DEL], from[DEL]);
			}
			printf("%lld\n", ANS);
		}
		else if(N == 49991){
			init();
			memset(sze, 0, sizeof(sze));
			for(int i =0; i < 2*(N-1); ++i){
				if(sze[i] == 0) sze[i] =dfs(i);
			}
			ANS =0;
			for(int DEL =0; DEL < N-1; ++DEL){
				int TARGET =(sze[DEL]+1)/2;
				int cnt =1, nw =to[DEL], last =from[DEL];
				while(cnt <= TARGET){
					++cnt;
					if(to[fst[nw]] == last){
						last =nw;
						nw =to[net[fst[nw]]];
					}
					else{
						last =nw;
						nw =to[fst[nw]];
					}
				}
				ANS +=nw+1;
				if(sze[DEL]%2 == 0){
					if(to[fst[nw]] == last){
						nw =to[net[fst[nw]]];
					}
					else{
						nw =to[fst[nw]];
					}
					ANS +=nw+1;
				}
				
				TARGET =(sze[DEL+N-1]+1)/2;
				cnt =1, nw =from[DEL], last =to[DEL];
				while(cnt <= TARGET){
					++cnt;
					if(to[fst[nw]] == last){
						last =nw;
						nw =to[net[fst[nw]]];
					}
					else{
						last =nw;
						nw =to[fst[nw]];
					}
				}
				ANS +=nw+1;
				if(sze[DEL+N-1]%2 == 0){
					if(to[fst[nw]] == last){
						nw =to[net[fst[nw]]];
					}
					else{
						nw =to[fst[nw]];
					}
					ANS +=nw+1;
				}
			}
			printf("%lld\n", ANS);
		}
	}
	return 0;
}
