#include <cstdio>

inline int read(){
	int x =0; char c =getchar();
	while(c < '0' || c > '9') c =getchar();
	while(c >= '0' && c <= '9') x = (x<<3) + (x<<1) + (48^c), c =getchar();
	return x;
}

const long long MOD =998244353;
long long ANS;
int a[110][2010], N, M, cntfood[2010], ALL;
bool used[110][2010], usedfood[2010];

void dfs(int nwway, int nwfood, int deep, long long cnt){
	if(deep == ALL){
		ANS = (ANS+cnt)%MOD;
		return;
	}
	used[nwway][nwfood] =1;
	++cntfood[nwfood];
	if(cntfood[nwfood]+1 > ALL/2) usedfood[nwfood] =1;
	for(int i =nwway+1; i+ALL-deep <= N; ++i) for(int j =0; j < M; ++j)
		if(!used[i][j] && !usedfood[j]){
			dfs(i, j, deep+1, cnt*(long long)(a[i][j])%MOD);
		}
	if(cntfood[nwfood]+1 > ALL/2) usedfood[nwfood] =0;
	used[nwway][nwfood] =0;
	--cntfood[nwfood];
	return;
}

int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	N =read(), M =read();
	for(int i =0; i < N; ++i) for(int j =0; j < M; ++j){
		a[i][j] =read();
		if(a[i][j] == 0) used[i][j] =1;
	}
	for(ALL =2; ALL <= N; ++ALL) for(int i =0; i+ALL <= N; ++i) for(int j =0; j < M; ++j)
		if(!used[i][j]) dfs(i, j, 1, (long long)(a[i][j]));
	printf("%lld", ANS);
	return 0;
}
