#include <cstdio>
using namespace std;

int getint()
{
    char ch;
    while((ch=getchar())<'0' || ch>'9')
        ;
    int x = ch^'0';
    while((ch=getchar())>='0' && ch<='9')
        x = (x*10)+(ch^'0');
    return x;
}

#define INFLL 0x7f7f7f7f7f7f7f7fLL

void chkmin(long long& a,long long b)
{
    if(a>b)
    {
        a = b;
    }
}

long long sqr(long long x)
{
    return x*x;
}

long long dp[2005][2005]; // pre data is (j..i-1) and now consider i, ans is dp[i][j]
long long ai[2005];
long long sai[2005];

long long delta[2005][2005];

int main()
{
    freopen("partition.in","r",stdin);
    freopen("partition.out","w",stdout);
    
    int n = getint();
    getint();
    for(int i=1; i<=n; ++i)
    {
        ai[i] = getint();
    }

    for(int i=1; i<=n; ++i)
    {
        sai[i] = sai[i-1]+ai[i];
    }

    for(int i=n; i>=2; --i)
    {
        int prek = n;
        long long minv = INFLL;
        for(int j=1; j<i; ++j)
        {
            for(int k=prek; k>=i; --k)
            {
                if(sai[k]-sai[i-1]<sai[i-1]-sai[j-1])
                {
                    prek = k;
                    break;
                }
                if(dp[k+1][i] == INFLL)
                {
                    continue;
                }
                chkmin(minv, dp[k+1][i]+sqr(sai[k]-sai[i-1]));
            }
            dp[i][j] = minv;
        }
    }

    long long ans = sqr(sai[n]);
    for(int i=2; i<=n; ++i)
    {
        chkmin(ans,dp[i][1]+sqr(sai[i-1]));
    }

    printf("%lld\n",ans);
}