#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <utility>
using namespace std;
const int N = 300000;
int head[N], nxt[N * 2], pnt[N * 2], E;
int size[N], size2[N];
int n;
int ea, eb;
int ans;
int stree;
pair<int, int> edge[N];
void add_edge(int a, int b){
	pnt[E] = b;
	nxt[E] = head[a];
	head[a] = E++;
}
void dfs(int u, int f){
	int i, v;
	size[u] = 1;
	int maxsub = 0;
	for(i = head[u]; i != -1; i = nxt[i]){
		v = pnt[i];
		if(v == f) continue;
		dfs(v, u);
		size[u] += size[v];
		maxsub = max(size[v], maxsub);
	}
	maxsub = max(maxsub, stree - size[u]);
	if(maxsub <= stree / 2){
		ans += u;
	}
}
void dfs2(int u, int f){
	int i, v;
	size2[u] = 1;
	for(i = head[u]; i != -1; i = nxt[i]){
		v = pnt[i];
		if(v == f) continue;
		dfs2(v, u);
		size2[u] += size2[v];
	}
}
int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int t, i, a, b;
	scanf("%d", &t);
	bool flag;
	while(t--){
		ans = 0;
		E = 0;
		memset(head, -1, sizeof(head));
		scanf("%d", &n);
		flag = 1;
		for(i = 1; i < n; i++){
			scanf("%d%d", &a, &b);
			if(a != b + 1 && a != b - 1) flag = 0;
			add_edge(a, b);
			add_edge(b, a);
			edge[i].first = a;
			edge[i].second = b;
		}
		if(flag){
			int ans = 0;
			for(i = 1; i < n; i++){
				if(i % 2 == 1){
					ans += i / 2 + 1;
				}
				if((n - i) % 2 == 1){
					ans += (n + i + 1) / 2;
				}
				if(i % 2 == 0){
					ans += i / 2;
					ans += i / 2 + 1;
				}
				if((n - i) % 2 == 0){
					ans += (n + i + 1) / 2;
					ans += (n + i + 1) / 2 + 1;
				}
			}
			printf("%d\n", ans);
		}
		else{
			dfs2(1, -1);
			for(i = 1; i <= n - 1; i++){
				ea = edge[i].first;
				eb = edge[i].second;
				if(size2[ea] == size2[eb] + 1){
					int tmp = ea;
					ea = eb;
					eb = tmp;
				}
				stree = size2[ea];
				dfs(ea, eb);
				stree = n - size2[ea];
				dfs(eb, ea);
			}
			printf("%d\n", ans);
		}
	}
	return 0;
}
