#include <cstdio>
#include <cstdlib>
#include <cstring>

const long long MOD = 998244353;

int read(){
	int x = 0; char ch = ' ';
	while (ch < '0' || ch > '9') ch = getchar();
	while (ch >= '0' && ch <= '9') x = x * 10 + ch - '0', ch = getchar(); return x;
}

int a[105][4];
long long ans = 0;
int n, m;
int cs[5], cs2[5];
int vis[105];
int I;

void DFS(int flr){
	if (!flr){
		long long cur = 1;
		for (int i = 1; i <= I; i++){
			cur = (cur * a[cs2[i]][cs[i]]) % MOD;
		}
		ans = (ans + cur) % MOD;
		return ;
	}
	for (int i = 1; i <= n; ++i){
		if (vis[i]) continue;
		cs2[flr] = i;
		vis[i] = 1;
		DFS(flr - 1);
		vis[i] = 0;
		cs2[flr] = 0;
	}
}

void solve(int flr, int lftm){
	if (!flr){
		DFS(I); return ;
	}
	for (int i = lftm; i >= 1; --i){
		cs[flr] = i;
		solve(flr - 1, i - 1);
		cs[flr] = 0;
	}
}

int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	n = read(), m = read();
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			a[i][j] = read();
	for (I = 2; I <= m; ++I){
		memset(vis, 0, sizeof(vis));
		memset(cs, 0, sizeof(cs));
		memset(cs2, 0, sizeof(cs2));
		solve(I, m);
	}
	printf("%lld", ans);
	return 0;
}
