#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N=299999;
int t,n;
int read()
{
  int sum=0;
  char c=getchar();
  while(c<'0' || c>'9') c=getchar();
  while(c>='0' && c<='9') sum=(sum<<1)+(sum<<3)+c-'0',c=getchar();
  return sum;
}
struct qwq
{
  int u,v,next;
} edge[N<<1];
int cnt,head[N];
void add(int u,int v){
  edge[++cnt].v=v,edge[cnt].u=u,edge[cnt].next=head[u],head[u]=cnt;
}
ll ans;
int father[N],dot[N];
void dfs(int u,int fa)
{
  dot[u]=1;
  for(int i=head[u] ; i ; i=edge[i].next)
  {
    int v=edge[i].v;
    if(v==fa) continue;
    father[v]=u;
    dfs(v,u);
    dot[u]+=dot[v];
  }
}
ll find(int u,ll fa)
{
  if(!father[u]) return 3;
  if(u==fa) return fa;
  return find(father[u],fa);
}
int main()
{
  freopen("centroid.in","r",stdin);
  freopen("centroid.out","w",stdout);
  t=read();
  while(t--)
  {
    n=read();
    cnt=0;
    int islian=0,perfect=0;
    ans=0;
    memset(head,0,sizeof(head));
    memset(father,0,sizeof(father));
	for(int i=1 ; i<=n-1 ; i++)
    {
      int u=read(),v=read();
      add(u,v),add(v,u);
      if(u!=v+1 && v!=u+1) islian=1;
      if(u!=2*v && u!=v*2+1 && v!=2*u && v!=2*u+1) perfect=1;
	}
	dfs(1,0);
	if(!islian)
	{
	  for(int i=1 ; i<=2*(n-1) ; i+=2)
	  {
	    int u=edge[i].u,v=edge[i].v;
	    if(u>v) swap(u,v);
	    if(u&1) ans+=(ll)(1+u)/2;
	    else ans+=(ll)(1+u)/2+(2+u)/2;
	    int Left=v,Right=n;
		if((u-Left+1)&1) ans+=(ll)(Left+u)/2;
		else ans+=(ll)(Left+u)/2+(Left+u+1)/2;
	  }
	  printf("%lld\n",ans);
	}
	else if(!perfect)
	{
	  for(int i=1 ; i<=2*(n-1) ; i+=2)
	  {
	     int u=edge[i].u,v=edge[i].v;
	     if(u>v) swap(u,v);
	     ans+=v;
	     int sum=n-dot[v];
		 if(sum%2==1) 
		   ans++;
		 else ans++,ans+=find(edge[head[u]].v==v?edge[edge[head[u]].next].v:edge[head[u]].v,2);
	  }
	  printf("%lld\n",ans);
	}
	else
	{
	  for(int i=1 ; i<=2*(n-1) ; i+=2)
	  {
	    int u=edge[i].u,v=edge[i].v;
	    for(int j=head[u] ; j ; j=edge[j].next)
	    {
	      if(edge[j].v!=v)
	        dfs(edge[j].v,u);
	      ans+=dot[edge[i].v];
		}
	  }
	  printf("%lld\n",ans);
	}
  }
  return 0;
}
