#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
using namespace std;

const int p = 998244353;
int n, m, ans = 0;
int a[45][5], b[45], s[5];

void dfs(int t){
	if(s[1] > (n - s[0]) / 2 || s[2] > (n - s[0]) / 2 || s[3] > (n - s[0])/ 2) return;
	if(t > n){
		if(s[0] == n) return;
		int res = 1;
		for(int i = 1; i <= n; i++) res = 1ll * res * a[i][b[i]] % p;
		ans = (ans + res) % p;
		return;
	}
	for(int i = 0; i <= m; i++){
		s[i]++;
		b[t] = i;
		dfs(t + 1);
		s[i]--;
	}
}

int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for(int i = 1; i <= n; i++){
		a[i][0] = 1;
		for(int j = 1; j <= m; j++) scanf("%d", &a[i][j]);
	}
	dfs(1);
	printf("%d\n", ans);
	return 0;
}

