#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
using namespace std;

const int MAXN = 405;
const long long INF = 1ll << 60;
int a[MAXN], sum[MAXN];
long long dp[MAXN][MAXN];

int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	int n;
	scanf("%d", &n);
	for(int i = 1; i <= n; i++){
		scanf("%d", &a[i]);
		sum[i] = sum[i - 1] + a[i];
	}
	for(int i = 1; i <= n; i++) dp[i][1] = 1ll * sum[i] * sum[i];
	for(int i = 2; i <= n; i++){
		for(int j = 2; i <= n; j++){
			dp[i][j] = INF;
			for(int k = 1; k <= j; k++){
				if(sum[i] - sum[j - 1] < sum[j - 1] - sum[k - 1]) continue;
				dp[i][j] = min(dp[i][j], dp[j - 1][k] + 1ll * (sum[i] - sum[j - 1]) * (sum[i] - sum[j - 1]));
			}
		}
	}
	long long ans = INF;
	for(int i = 1; i <= n; i++) ans = min(ans, dp[n][i]);
	printf("%lld\n", ans);
	return 0;
}
