#include <bits/stdc++.h>
#define ll long long
using namespace std;

int n;
namespace task1 {
  const int N = 5010;
  int nt[N << 1], to[N << 1], head[N], cnt = 0;
  void add(int x, int y) {
    to[++cnt] = y;
    nt[cnt] = head[x];
    head[x] = cnt;
  }
  int sz[N];
  
  int mx = 1e9, da = 0, tot;
  void dfs(int u, int fa) {
    sz[u] = 1;
    int pos = 0;
    for(int i = head[u]; i; i = nt[i]) {
      if(to[i] == fa) continue;
      dfs(to[i], u);
      sz[u] += sz[to[i]];
      pos = max(pos, sz[to[i]]);
    }
    pos = max(pos, tot - sz[u]);
    if(pos < mx) mx = pos, da = u;
    else if(pos == mx) da += u;
  }
  
  int f[N], s[N];
  void predfs(int u, int fa) {
    s[u] = 1, f[u] = fa;
    for(int i = head[u]; i; i = nt[i]) {
      if(to[i] == fa) continue;
      predfs(to[i], u);
      s[u] += s[to[i]];
    }
  }
  
  void solve() {
    cnt = 0;
    memset(head, 0, sizeof head);
    for(int i = 2, x, y; i <= n; ++i) {
      scanf("%d%d", &x, &y);
      add(x, y), add(y, x);
    }
    predfs(1, 0);
    int ans = 0;
    for(int i = 1; i < n; ++i) {
      memset(sz, 0, sizeof sz);
      int u = to[i * 2 - 1], v = to[i * 2];
      if(f[u] != v) swap(u, v);
      mx = 1e9, da = 0, tot = s[u];
      dfs(u, v);
//      printf("u = %d, da = %d, mx = %d, tot = %d\n", u, da, mx, tot);
      ans += da;
      mx = 1e9, da = 0, tot = n - s[u];
      dfs(v, u);
//      printf("u = %d, da = %d\n", v, da);
      ans += da;
    }
    printf("%d\n", ans);
  }
}

namespace task2 {
  void solve() {
    ll ans = 0;
    for(int i = 1; i <= n - 1; ++i) {
      if(i & 1) {
        ans += (1 + i) / 2;
      } else {
        ans += 1 + i;
      }
    }
    for(int i = n; i >= 2; --i) {
      if((n + i) & 1) {
        ans += n + i;
      } else {
        ans += (n + i) / 2;
      }
    }
    printf("%lld\n", ans);
  }
}

namespace task3 {
  void solve() {
    ll ans = 1ll * n * (n + 1) / 2 - 1;
    ans += 1ll * (n - 1) / 2 * 5;
    ans += (n + 1) / 2;
    printf("%lld\n", ans);
  }
}

const int N = 3e5 + 10;
int d[N];
int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  int T;
  scanf("%d", &T);
  for(int o = 1; o <= T; ++o) {
    scanf("%d", &n);
    if(n <= 5000) task1::solve();
    else {
      memset(d, 0, sizeof d);
      int mx = 0;
      for(int i = 2, x, y; i <= n; ++i) {
        scanf("%d%d", &x, &y);
        d[x]++, d[y]++;
        mx = max(mx, d[x]);
        mx = max(mx, d[y]);
      }
      if(mx == 2) task2::solve();
      else task3::solve();
    }
  }
  return 0;
}
