#include<bits/stdc++.h>

#define ll long long
#define INF 2147483647

int inp(){
    char c = getchar();
    while(c < '0' || c > '9')
        c = getchar();
    int sum = 0;
    while(c >= '0' && c <= '9'){
        sum = sum * 10 + c - '0';
        c = getchar();
    }
    return sum;
}

int head[100010], nxt[200010], end[200010], u[100010], v[100010];
int ans = 0, tot, size[100010];
void gettot(int cur, int last){
    tot++;
    for(int x = head[cur]; x != -1; x = nxt[x])
        if(end[x] != last)
            gettot(end[x], cur);
}

void dfs(int cur, int last){
    size[cur] = 1;
    int max = 0;
    for(int x = head[cur]; x != -1; x = nxt[x]){
        if(end[x] != last){
            dfs(end[x], cur);
            size[cur] += size[end[x]];
            max = std::max(max, size[end[x]]);
        }
    }
    max = std::max(max, tot - size[cur]);
    if(max <= (tot / 2))
        ans += cur;
}

int solve(int u, int v){
    tot = 0;
    gettot(u, v);
    dfs(u, v);

    tot = 0;
    gettot(v, u);
    dfs(v, u);
}

int cou = 0;
void link(int a, int b){
    nxt[++cou] = head[a];
    head[a] = cou;
    end[cou] = b;
}

namespace chain{
    int dg[1000010];
    int idx = 0, id[1000010], s[1000010];

    void _dfs(int cur, int last){
        id[cur] = ++idx;
        for(int x = head[cur]; x != -1; x = nxt[x]){
            if(end[x] != last)
                dfs(end[x], cur);
        }
    }

    void main(int n){
        idx = 0;
        memset(dg, 0, sizeof(dg));
        for(int i = 1; i < n; i++){
            u[i] = inp();
            v[i] = inp();
            link(u[i], v[i]);
            link(v[i], u[i]);
            dg[u[i]]++;
            dg[v[i]]++;
        }
        for(int i = 1; i <= n; i++)
            if(dg[i] == 1){
                dfs(i, 0);
                break;
            }
        for(int i = 1; i <= n; i++)
            s[id[i]] = i;
        ll ans = 0;
        for(int i = 1; i < n; i++){
            if(i & 1){
                ans += s[(i + 1) >> 1];
            } else {
                ans += s[i >> 1];
                ans += s[(i >> 1) + 1];
            }

            int num = (n - i);
            if(num & 1){
                ans += s[n - (num >> 1)];
            } else {
                ans += s[n - (num >> 1)];
                ans += s[n - (num >> 1) - 1];
            }
        }
        printf("------------------\n");
        printf("%lld\n", ans);
    }
}

int main(){
    freopen("centroid.in", "r", stdin);
    // freopen("centroid.out", "w", stdout);

    for(int T = inp(); T >= 1; T--){
        memset(head, -1, sizeof(head));
        cou = 0;
        int n = inp();
        if(n <= 5000){
            for(int i = 1; i < n; i++){
                u[i] = inp();
                v[i] = inp();
                link(u[i], v[i]);
                link(v[i], u[i]);
            }
            ans = 0;
            for(int i = 1; i < n; i++)
                solve(u[i], v[i]);
            printf("%d\n", ans);
        } else {
            chain::main(n);
        }
    }
}