#include<bits/stdc++.h>

#define ll long long
#define INF 2147483647
#define lowbit(x) ((x) & (-x))
#define mod 998244353

int inp(){
    char c = getchar();
    while(c < '0' || c > '9')
        c = getchar();
    int sum = 0;
    while(c >= '0' && c <= '9'){
        sum = sum * 10 + c - '0';
        c = getchar();
    }
    return sum;
}


int popcount[2000000];
ll a[110][2010];

int used, cnt;
ll ans = 0, n, m;
void dfs(int cur, ll tot){
    if(tot == 0)
        return ;
    if(cur > m){
        if(popcount[used] == cnt)
            ans += tot;
        return ;
    }
    for(int i = 0; i < (1 << n); i++)
        if(!(i & used) && popcount[i] <= (cnt >> 1)){
            used |= i;
            ll mul = 1;
            for(int j = 1; j <= n; j++)
                if(i & (1 << (j - 1))){
                    mul *= a[j][cur];
                    mul %= mod;
                }
            dfs(cur + 1, tot * mul % mod);
            used ^= i;
        }
}

int solve(int nn, int mm){
    n = nn;
    m = mm;
    ans = 0;
    for(cnt = 2; cnt <= n; cnt++)
        dfs(1, 1);
    return ans;
}

namespace M3{
    ll f[100][100][100];

    void main(int n){
        f[0][0][0] = 1;
        for(int T = 1; T <= n; T++)
            for(int i = n; i >= 0; i--)
                for(int j = n; j >= 0; j--)
                    for(int u = n; u >= 0; u--){
                        f[i + 1][j][u] += f[i][j][u] * a[T][1];
                        f[i][j + 1][u] += f[i][j][u] * a[T][2];
                        f[i][j][u + 1] += f[i][j][u] * a[T][3];
                        f[i + 1][j][u] %= mod;
                        f[i][j + 1][u] %= mod;
                        f[i][j][u + 1] %= mod;
                    }
        ll ans = -1;
        for(int i = 0; i <= n; i++){
            for(int j = 0; j <= n; j++)
                for(int u = 0; u <= n; u++){
                    int k = i + j + u;
                    int lim = (k >> 1);
                    if(i <= lim && j <= lim && u <= lim){
                        ans += f[i][j][u];
                        ans %= mod;
                    }
                }
        }
        printf("%lld\n", ans);
    }
}

int main(){
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);

    int n = inp();
    int m = inp();
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            a[i][j] = inp();
    if(m == 3){
        M3::main(n);
        return 0;
    }
    for(int i = 0; i < (1 << n); i++){
        int x = i;
        while(x){
            x -= lowbit(x);
            popcount[i]++;
        }
    }
    solve(n, m);
    printf("%lld\n", ans);
}