#include<bits/stdc++.h>

#define ll long long
#define INF 2147483647
#define mod 998244353

int inp(){
    char c = getchar();
    while(c < '0' || c > '9')
        c = getchar();
    int sum = 0;
    while(c >= '0' && c <= '9'){
        sum = sum * 10 + c - '0';
        c = getchar();
    }
    return sum;
}


ll a[100][100];
namespace M2{
    ll f[100][100];
    
    void main(int n){
        f[0][0] = 1;
        for(int T = 1; T <= n; T++)
            for(int i = n; i >= 0; i--)
                for(int j = n; j >= 0; j--){
                    f[i + 1][j] += f[i][j] * a[i][1];
                    f[i][j + 1] += f[i][j] * a[i][2];
                    f[i + 1][j] %= mod;
                    f[i][j + 1] %= mod;
                }
        ll ans = 0;
        for(int i = 1; i <= n; i++){
            for(int j = 1; j <= n; j++){
                int k = i + j;
                int lim = (i + j) >> 1;
                if(i <= lim && j <= lim){
                    ans += f[i][j];
                    ans %= mod;
                }
            }
        }
        printf("%lld\n", ans);
    }
}

namespace M3{
    ll f[100][100][100];

    void main(int n){
        f[0][0][0] = 1;
        for(int T = 1; T <= n; T++)
            for(int i = n; i >= 0; i--)
                for(int j = n; j >= 0; j--)
                    for(int u = n; u >= 0; u--){
                        f[i + 1][j][u] += f[i][j][u] * a[T][1];
                        f[i][j + 1][u] += f[i][j][u] * a[T][2];
                        f[i][j][u + 1] += f[i][j][u] * a[T][3];
                        f[i + 1][j][u] %= mod;
                        f[i][j + 1][u] %= mod;
                        f[i][j][u + 1] %= mod;
                    }
        ll ans = -1;
        for(int i = 0; i <= n; i++){
            for(int j = 0; j <= n; j++)
                for(int u = 0; u <= n; u++){
                    int k = i + j + u;
                    int lim = (k >> 1);
                    if(i <= lim && j <= lim && u <= lim){
                        ans += f[i][j][u];
                        ans %= mod;
                    }
                }
        }
        printf("%lld\n", ans);
    }
}

int main(){
    int n = inp();
    int m = inp();
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            a[i][j] = inp();
    if(m == 2)
        M2::main(n);
    else
        M3::main(n);
}