#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long N = 4e7 + 10, mod = 1ll << 30;
long long n, type, a[N], x, y, z, m, b[N], p[N], l[N], r[N];

vector<pair<long long, long long> > ans;

int main()
{
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n >> type;
	if (type == 0)
	{
		for (long long i = 1; i <= n; i++)
			cin >> a[i];
	}
	else
	{
		cin >> x >> y >> z >> b[1] >> b[2] >> m;
		for (long long i = 1; i <= m; i++)
			cin >> p[i] >> l[i] >> r[i];
		p[0] = 0;
		for (long long i = 3; i <= n; i++)
			b[i] = (x * b[i - 1] + y * b[i - 2] + z) % mod;
		for (long long i = 1; i <= m; i++)
			for (long long j = p[i - 1] + 1; j <= p[i]; j++)
				a[i] = (b[i] % (r[j] - l[j] + 1)) + l[j];
	}
	ans.push_back(make_pair(a[1], 1)); long long p = 1;
	while (p < n)
	{
		long long tot = 0;
		long long l = p + 1;
		while (tot < ans.back().first && p < n)
			tot += a[++p];
		if (tot < ans.back().first)
		{
			while (ans.size())
			{
				tot += ans.back().first;
				l = ans.back().second;
				ans.pop_back();
				if (ans.empty()) break;
				if (ans.back().first <= tot) break;
			}
			ans.push_back(make_pair(tot, l));
		}
		else ans.push_back(make_pair(tot, l));
	}
	ans.push_back(make_pair(0, n));
	for (int i = 1; i < ans.size() - 1; i++)
	{
		while (ans[i].first - a[ans[i].second] >= ans[i - 1].first + a[ans[i].second] && ans[i].second < ans[i + 1].second)
		{
			ans[i].first -= a[ans[i].second];
			ans[i - 1].first += a[ans[i].second];
			ans[i].second++;
		}
	}
	long long res = 0;
	for (long long i = 0; i < ans.size(); i++)
		res += ans[i].first * ans[i].first;
	cout << res << endl;

	return 0;
}
