#include <bits/stdc++.h>
using namespace std;
int n,cnt=0;
struct node {int to,nxt; } edges[600005];
int x[600005],y[600005],dep[300005],siz[300005],fa[300005],tf[300005],FG,hed[300005];
inline bool isForbidden(int xx,int yy) { return xx==x[FG] && yy==y[FG] || xx==y[FG] && yy==x[FG]; }
inline void addedge(int x,int y) { edges[++cnt] = (node){y,hed[x]}; hed[x] = cnt; }
inline void dfs(int x, int fa, bool tf) { ::fa[x] = fa; ::tf[x] = tf;
    siz[x] = 1; for (int e=hed[x]; e; e=edges[e].nxt) {
        int y=edges[e].to;
        if (!isForbidden(x,y) && y!=fa) {
            dep[y] = dep[x]+1; dfs(y, x, tf);
            siz[x] += siz[y];
        }
    }
}
inline int calcHalfSiz(int p,int x,int y) { return tf[p] ? siz[x]/2 : siz[y]/2; }
inline int hehe(int x,int y) {
    int ret = 0;
    for (int i=1; i<=n; i++) {
        bool ok=1;
        for (int e=hed[i]; e; e=edges[e].nxt) {
            if (!isForbidden(i, edges[e].to) && edges[e].to != fa[i]) {
                if (siz[edges[e].to] > calcHalfSiz(edges[e].to,x,y)) {ok=0; break;}
            }
        }
        if (fa[i] != -1) if (siz[tf[i]?x:y] - siz[i] > calcHalfSiz(i,x,y)) ok =0;
        if (ok) {
            ret += i;
        }
    }
    return ret;
}

int main() {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out","w", stdout);
    int T; scanf("%d", &T);
    while (T--) {
        scanf("%d", &n); memset(hed,0,sizeof(hed)); cnt=0;
        for (int i=1; i<n; i++) {
            scanf("%d%d", &x[i],&y[i]);
            addedge(x[i],y[i]);addedge(y[i],x[i]);
        }
        int sum=0;
        for (int i=1; i<n; i++) {
            memset(siz,0,sizeof(siz));memset(dep,0,sizeof(dep));
            FG = i; dfs(x[i],-1,1); dfs(y[i],-1,0);
            sum+=hehe(x[i],y[i]);
        }
        printf("%d\n", sum);
    }
    return 0;
}
