/*program by mangoyang*/
#include <bits/stdc++.h>
#define inf (0x7f7f7f7f)
#define Max(a, b) ((a) > (b) ? (a) : (b))
#define Min(a, b) ((a) < (b) ? (a) : (b))
typedef long long ll;
using namespace std;
template <class T>
inline void read(T &x){
	int ch = 0, f = 0; x = 0;
	for(; !isdigit(ch); ch = getchar()) if(ch == '-') f = 1;
	for(; isdigit(ch); ch = getchar()) x = x * 10 + ch - 48;
	if(f) x = -x;
}
const int N = 300005;
ll res;
vector<int> g[N];
pair<int, int> ed[N];
int a[N], vis[N], sz[N], mx[N], n, cnt;
inline void dfs(int u, int fa){
	sz[u] = 1, a[++cnt] = u, mx[u] = 0;
	for(int i = 0; i < (int) g[u].size(); i++){
		int v = g[u][i];
		if(v == fa || vis[v]) continue;
		dfs(v, u);
		sz[u] += sz[v];
		mx[u] = Max(mx[u], sz[v]);
	}
}
inline void solve1(){
	for(int i = 1; i <= n; i++) g[i].clear();
	res = 0;	
	for(int i = 1, x, y; i < n; i++){
		read(x), read(y);
		g[x].push_back(y);
		g[y].push_back(x);
		ed[i] = make_pair(x, y);
	}
	for(int i = 1; i < n; i++){
		int x = ed[i].first, y = ed[i].second;
		vis[y] = 1, cnt = 0;
		dfs(x, 0);
		for(int j = 1; j <= cnt; j++){
			int u = a[j];
			if(mx[u] <= sz[x] / 2 && (sz[x] - sz[u]) <= sz[x] / 2)
				res += u;
		}
		vis[y] = 0;
		swap(x, y);
		vis[y] = 1, cnt = 0;
		dfs(x, 0);
		for(int j = 1; j <= cnt; j++){
			int u = a[j];
			if(mx[u] <= sz[x] / 2 && (sz[x] - sz[u]) <= sz[x] / 2)
				res += u;
		}
		vis[y] = 0;
	}
	cout << res << endl;
}
namespace A{
	int id[N];
	inline void getline(int u, int fa){
		id[++cnt] = u;
		for(int i = 0; i < (int) g[u].size(); i++){
			int v = g[u][i];
			if(v == fa) continue;
			getline(v, u);
		}
	}
	inline void Asolve(){
		int rt = 0;
		for(int i = 1; i <= n; i++)
			if((int) g[i].size() == 1) rt = i;
		cnt = 0;
		getline(rt, 0);
		for(int i = 1; i < n; i++){
			if(i & 1) res += id[i/2+1];
			else res += id[i/2], res += id[i/2+1];
		}
		reverse(id + 1, id + n + 1);
		for(int i = 1; i < n; i++){
			if(i & 1) res += id[i/2+1];
			else res += id[i/2], res += id[i/2+1];
		}
		cout << res << endl;
	}
}
namespace B{
	int dep[N], ff[N], allsize, mn, ans1, ans2, dee;
	inline int calc(int u, int fa){
		int mx = 0;
		for(int i = 0; i < (int) g[u].size(); i++){
			int v = g[u][i]; 
			if(v == fa || vis[v]) continue; 
			mx = max(mx, sz[v]);
		}
		mx = max(mx, allsize - sz[u]);
		return mx;
	}
	inline void dfs(int u, int fa){
		sz[u] = 1, dep[u] = dep[fa] + 1, ff[u] = fa;
		for(int i = 0; i < (int) g[u].size(); i++){
			int v = g[u][i];
			if(v == fa) continue;
			dfs(v, u);
			sz[u] += sz[v];
		}
	}
	inline void gao(int u, int fa){
		int now = calc(u, fa);
		if(now <= allsize / 2)
			if(!ans1) ans1 = u; else ans2 = u;
		for(int i = 0; i < (int) g[u].size(); i++){
			int v = g[u][i];
			if(v == fa || vis[v]) continue;
			if(calc(v, u) <= mn) gao(v, u); 
		}
	}
	inline void Bsolve(){
		dfs(1, 0);
		for(int i = 1; i < n; i++){
			int x = ed[i].first, y = ed[i].second;
			if(dep[x] > dep[y]) swap(x, y);
			vis[x] = 1, ans1 = 0, ans2 = 0, mn = inf;
			allsize = sz[y], gao(y, 0);
			res += ans1, res += ans2;
			vis[x] = 0;
			vis[y] = 1;
			for(int j = ff[y]; j; j = ff[j]) sz[j] -= sz[y];
			allsize = sz[1] - sz[y], ans1 = 0, ans2 = 0, mn = inf;
			gao(x, 0);
			vis[y] = 0;
			for(int j = ff[y]; j; j = ff[j]) sz[j] += sz[y];
			res += ans1, res += ans2;
		}
		cout << res << endl;
	}
}
inline void solve2(){
	for(int i = 1; i <= n; i++) g[i].clear();
	res = 0;	
	for(int i = 1, x, y; i < n; i++){
		read(x), read(y);
		g[x].push_back(y);
		g[y].push_back(x);
		ed[i] = make_pair(x, y);
	}
	int flag = 1;
	for(int i = 1; i <= n; i++)
		if((int) g[i].size() > 2) flag = 0;
	if(flag) return (void) (A::Asolve());
	else B::Bsolve();
	
}
int main(){
	freopen("centroid.in", "r", stdin); 
	freopen("centroid.out", "w", stdout);
	int T; read(T); 
	while(T--){
		read(n);
		if(n <= 2000) solve1();
		else solve2();
	}
	return 0;
}
