#include <bits/stdc++.h>
#define N 300001
using namespace std;

int T, n, cnt1, cnt2;
long long ans;
int tot, head[N], c[N], to[N], nex[N];
int vis[1001][1001], flag[N], used[N], a[N], b[N], x[N], y[N];

inline int read() {
	int x = 0, flag = 1;
	char ch = getchar();
	while (!isdigit(ch)) {
		if (ch == '-') flag = -1;
		ch = getchar();
	}
	while (isdigit(ch)) {
		x = x * 10 + ch - 48;
		ch = getchar();
	}
	return x * flag;
}

void add(int x, int y) {
	to[++tot] = y;
	nex[tot] = head[x];
	head[x] = tot;
}

void dfs(int u) {
	used[u] = 1;
	for (int i = head[u]; i; i = nex[i]) {
		int d = to[i];
		if (vis[u][d] || vis[d][u]) continue;
		if (used[d]) continue;
		dfs(d);
	}
}

int DFS(int u) {
	if (flag[u]) return 0;
	used[u] = 1;
	int res = 1;
	for (int i = head[u]; i; i = nex[i]) {
		int d = to[i];
		if (vis[u][d] || vis[d][u]) continue;
		if (used[d]) continue;
		if (flag[d]) continue;
		res += DFS(d);
	}
	return res;
}

bool check1() {
	memset(used, 0, sizeof(used));
	for (int i = 1; i <= cnt1; ++i) {
		if (flag[a[i]]) continue;
		int x = DFS(a[i]);
//		printf("%d ", x);
		if (x > (cnt1 / 2)) {
//			puts("fail");
			return 0;
		}
	}
//	puts("");
	return 1;
}

bool check2() {
	memset(used, 0, sizeof(used));
	for (int i = 1; i <= cnt2; ++i) {
		if (flag[b[i]]) continue;
		int x = DFS(b[i]);
//		printf("%d ", x);
		if (x > (cnt2 / 2)) {
//			puts("fail");
			return 0;
		}
	}
	return 1;
}

void work() {
	memset(used, 0, sizeof(used));
	dfs(1);
	cnt1 = 0, cnt2 = 0;
	for (int i = 1; i <= n; ++i)
	if (used[i]) a[++cnt1] = i;
	else b[++cnt2] = i;
	memset(used, 0, sizeof(used));
//	for (int i = 1; i <= cnt1; ++i) {
//		printf("@%d ", a[i]);
//	}
//	puts("");
//	for (int i = 1; i <= cnt2; ++i) {
//		printf("%d ", b[i]);
//	}
//	puts("");
//	puts("");
	for (int i = 1; i <= cnt1; ++i) {
		flag[a[i]] = 1;
		if (check1()) ans += a[i];
//		printf("$%d\n", ans);
		flag[a[i]] = 0;
	}
	for (int i = 1; i <= cnt2; ++i) {
		flag[b[i]] = 1;
		if (check2()) ans += b[i];
		flag[b[i]] = 0;
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T = read();
	while (T--) {
		tot = 0;
		memset(to, 0, sizeof(to));
		memset(nex, 0, sizeof(nex));
		memset(head, 0, sizeof(head));
		n = read();
		for (int i = 1; i < n; ++i) {
			x[i] = read(), y[i] = read();
			add(x[i], y[i]);
			add(y[i], x[i]);
		}
		bool flag = 1;
		for (int i = 2; i < n; ++i) {
			if (x[i] != y[i - 1]) flag = 0;
		}
		if (flag) {
			ans = 0;
			for (int i = 1; i < n; ++i) {
				c[i] = x[i];
			}
			c[n] = y[n - 1];
			for (int i = 1; i < n; ++i) {
				if (i & 1) ans += c[(i + 1) / 2];
				else ans += c[i / 2] + c[i / 2 + 1];
//				printf("%d\n", ans);
				if ((n - i) & 1) ans += c[n - ((n - i + 1) / 2) + 1];
				else ans += c[n - ((n - i) / 2)] + c[n - ((n - i) / 2) + 1];
//				printf("%d\n", ans);
			}
//			int calc = 1;
//			c[1] = y[n - 1];
//			for (int i = n - 1; i >= 1; --i) {
//				c[++calc] = x[i];
//			}
//			for (int i = 1; i <= n; ++i) {
//				if (i & 1) ans += c[(i + 1) / 2];
//				else ans += c[i / 2] + c[i / 2 + 1];
//			}
			printf("%lld\n", ans);
			continue;
		}
		ans = 0;
		for (int i = 1; i < n; ++i) {
			vis[x[i]][y[i]] = vis[y[i]][x[i]] = 1;
			work();
			vis[x[i]][y[i]] = vis[y[i]][x[i]] = 0;
		}
		printf("%lld\n", ans);
	}
}

/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
