#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
int read(){
	register int x = 0;
	register char f = 1, ch = getchar();
	for (; !isdigit(ch); ch = getchar()) if (ch == '-') f ^= 1;
	for (; isdigit(ch); ch = getchar()) x = (x << 1) + (x << 3) + (ch ^ '0');
	return f ? x : -x;
}
const int N = 300005;
int n, fa[N], sz[N], mx[N], Mx[N];
int edge, to[N << 1], pr[N << 1], hd[N];
long long ans;
void addedge(int u, int v){
	to[++edge] = v, pr[edge] = hd[u], hd[u] = edge;
}
int cnt, son[N], pre[N], suf[N];
void dfs1(int u){
	sz[u] = 1, mx[u] = 0;
	for (register int i = hd[u], v; i; i = pr[i])
		if ((v = to[i]) != fa[u]) fa[v] = u, dfs1(v), sz[u] += sz[v], mx[u] = std :: max(mx[u], sz[v]);
	cnt = 0;
	for (register int i = hd[u], v; i; i = pr[i])
		if ((v = to[i]) != fa[u]) son[++cnt] = v;
	pre[0] = suf[cnt + 1] = 0;
	for (register int i = 1; i <= cnt; ++i) pre[i] = std :: max(pre[i - 1], sz[son[i]]);
	for (register int i = cnt; i; --i) suf[i] = std :: max(suf[i + 1], sz[son[i]]);
	for (register int i = 1; i <= cnt; ++i) Mx[son[i]] = std :: max(pre[i - 1], suf[i + 1]);
}
struct BIT{
	int c[N];
	void clear(){
		for (register int i = 1; i <= n; ++i) c[i] = 0;
	}
	void add(int x, int y){
		for (; x <= n; x += x & -x) c[x] += y;
	}
	int query(int l, int r){
		if (l <= 0) l = 1;
		if (r > n) r = n;
		if (l > r) return 0;
		int s = 0;
		for (; r; r ^= r & -r) s += c[r];
		for (--l; l; l ^= l & -l) s -= c[l];
		return s;
	}
}T;
int idx, dfn[N];
struct node{
	int op, x, l, r, v;
	bool operator < (const node &rhs) const {
		return x < rhs.x || (x == rhs.x && op > rhs.op);
	}
}p[N * 5];
void add(int op, int x1, int y1, int x2, int y2, int v){
	p[++cnt] = (node){op, x2, y1, y2, v};
	p[++cnt] = (node){!op, x1 - 1, y1, y2, v};
}
void dfs2(int u){
	dfn[u] = ++idx;
	ans += 1ll * T.query(1, std :: min(n - (mx[u] << 1), sz[u] << 1)) * u;
	ans -= 1ll * T.query(n - 2 * sz[u], n - 2 * mx[u]) * u;
	add(0, dfn[u], dfn[u] + sz[u], n - 2 * sz[u], n - 2 * mx[u], u);
	add(1, dfn[u], dfn[u] + sz[u], std :: max(n - 2 * sz[fa[u]], 2 * sz[u] - n), n - 2 * Mx[u], fa[u]);
	p[++cnt] = (node){2, dfn[u], sz[u], sz[u], 0};
	T.add(sz[u], 1);
	for (register int i = hd[u], v; i; i = pr[i])
		if ((v = to[i]) != fa[u]) dfs2(v);
	T.add(sz[u], -1);
}
void solve(){
	n = read(), edge = 0;
	for (register int i = 1; i <= n; ++i) hd[i] = 0;
	for (register int i = 1, u, v; i < n; ++i)
		u = read(), v = read(), addedge(u, v), addedge(v, u);
	ans = 0;
	dfs1(1);
	cnt = 0;
	T.clear();
	dfs2(1);
	T.clear();
	for (register int i = 1; i <= n; ++i) T.add(sz[i], 1);
	for (register int i = 1; i <= n; ++i)
		ans += 1ll * T.query(n - 2 * sz[i], n - 2 * mx[i]) * i;
	std :: sort(p + 1, p + 1 + cnt);
	T.clear();
	for (register int i = 1; i <= cnt; ++i){
		if (p[i].op == 2){ T.add(p[i].l, 1); continue; }
		if (p[i].op == 1) ans += 1ll * T.query(p[i].l, p[i].r) * p[i].v;
		else ans -= 1ll * T.query(p[i].l, p[i].r) * p[i].v;
	}
	printf("%lld\n", ans);
}
int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T = read();
	while (T--) solve();
}
