#include<cstdio>
#include<algorithm>
using namespace std;
const int N=300000;
typedef long long LL;
struct E{int to,nxt;}e[N<<1];
int T,n,head[N],cnt,siz[N],mx[N],m,du[N],a[N];
LL ans;
void add(int x,int y){e[++cnt]=(E){y,head[x]};head[x]=cnt;}
void dfs2(int u,int fa)
{
	siz[u]=1; mx[u]=0;
	for (int i=head[u];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if (v!=fa)
		{
			dfs2(v,u);
			siz[u]+=siz[v]; mx[u]=max(mx[u],siz[v]);
		}
	}
}
void dfs3(int u,int fa)
{
	if (mx[u]<=m/2&&m-siz[u]<=m/2) ans+=u;
	for (int i=head[u];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if (v!=fa) dfs3(v,u);
	}
}
void dfs1(int u,int fa)
{
	for (int i=head[u];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if (v!=fa)
		{
			dfs2(u,v); dfs2(v,u);
			m=siz[u]; dfs3(u,v); m=siz[v]; dfs3(v,u);
			dfs1(v,u);
		}
	}
}
void dfs4(int u,int fa)
{
	a[++cnt]=u;
	for (int i=head[u];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if (v!=fa) dfs4(v,u);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--)
	{
		scanf("%d",&n);
		for (int i=1;i<=n;i++) head[i]=0;
		cnt=0; ans=0;
		for (int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			du[u]++; du[v]++;
			add(u,v); add(v,u);
		}
		if (n<2000) dfs1(1,-1);
		else
		{
			int ljj=0;
			for (int i=1;i<=n;i++)
				if (du[i]==1) ljj=i;
			cnt=0;
			dfs4(ljj,-1); a[n+1]=0;
			int l=1,r=n/2+1,x=1,y; ans=a[l];
			if (n%2==1) ans+=a[r]+a[r+1],r++,y=-1; else ans+=a[r],y=1;
			for (int i=2;i<n;i++)
			{
				if (x==1) ans+=a[l]+a[l+1],l++;
				else ans+=a[l];
				if (y==1) ans+=a[r]+a[r+1],r++;
				else ans+=a[r];
				x=-x; y=-y;
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}
