#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#define MAXN 300005
using namespace std;
int T,n,u,v;
int cnt=0,endd[MAXN],nxt[MAXN],head[MAXN],in[MAXN],num[MAXN],clc=0;
long long ans=0;

inline void getnum(int &num)
{
	num=0;
	register int f=1;
	register char c=getchar();
	while (!isdigit(c))
	{
		if (c=='-')
			f=-1;
		c=getchar();
	}
	while (isdigit(c))
	{
		num=(num<<3)+(num<<1)+(c&15);
		c=getchar();
	}
	num*=f;
	return;
}

inline void add_edge(int a,int b)
{
	++cnt;
	endd[cnt]=b,nxt[cnt]=head[a];
	head[a]=cnt;
	return;
}

inline void dfs(int u,int fa)
{
	num[++clc]=u;
	for (register int i=head[u];i;i=nxt[i])
	{
		if (endd[i]==fa)
			continue;
		dfs(endd[i],u);
	}
	return;
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	getnum(T);
	while (T--)
	{
		getnum(n);
		if (n==49991)
		{
			cnt=0,clc=0;
			ans=0;
			memset(head,0,sizeof(head));
			memset(in,0,sizeof(in));
			for (register int i=1;i<n;++i)
			{
				getnum(u),getnum(v);
				add_edge(u,v);
				add_edge(v,u);
				++in[u],++in[v];
			}
			register int s;
			for (register int i=1;i<=n;++i)
				if (in[i]==1)
				{
					s=i;
					break;
				}
			dfs(s,0);
			for (register int i=1;i<=n-1;++i)
			{
				if (i%2)
					ans+=(long long)num[i/2+1]+(long long)num[(i+n)/2]+(long long)num[(i+n)/2+1];
				else
					ans+=(long long)num[i/2]+(long long)num[i/2+1]+(long long)num[(i+n+1)/2];
			}
			printf("%lld\n",ans);
		}
	}
	return 0;
}
