#include <bits/stdc++.h>

const int MAXN = 110;
const int MAXM = 2010;
const int mod = 998244353;
typedef long long LL;
void reduce(int & x) { x += x >> 31 & mod; }
int mul(int a, int b) { return (LL) a * b % mod; }
int mat[MAXN][MAXM];
int n, m, hav[MAXN];
int ans = 0;
void dfs(int x, int v = 1) {
	if (x == n + 1) {
		int cnt = std::accumulate(hav + 1, hav + 1 + m, 0);
		if (!cnt) return ;
		for (int i = 1; i <= m; ++i)
			if (hav[i] > cnt / 2) return ;
		reduce(ans += v - mod);
		return ;
	}
	for (int j = 1; j <= m; ++j) if (mat[x][j]) {
		++hav[j];
		dfs(x + 1, mul(v, mat[x][j]));
		--hav[j];
	}
	dfs(x + 1, v);
}
int main() {
#define FILENAME "meal"
#ifdef FILENAME
	freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".usr", "w", stdout);
#endif
	std::ios_base::sync_with_stdio(false), std::cin.tie(0);
	std::cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			std::cin >> mat[i][j];
	dfs(1);
	std::cout << ans << '\n';
	return 0;
}
