#include<cstdio>
#include<cstring>
using namespace std;
#define N 300005
#define ll long long
struct Edge{
	int v,nxt;
}E[N<<1];
int en,head[N],T,n,du[N],a[N],et,size[N],p[N];
void addedge(int u,int v){
	E[++en].v=v,E[en].nxt=head[u],head[u]=en;
}
void dfs(int u){
	size[u]=1;
	for (int e=head[u];~e;e=E[e].nxt){
		if (e==et||e==et+1) continue;
		int v=E[e].v;
		if (v!=p[u]){
			p[v]=u;
			dfs(v);
			size[u]+=size[v];
		}
	}
}
int getans(int root){
	memset(p,0,sizeof p);
	memset(size,0,sizeof size);
	dfs(root);
	int q=0,m=1;
	for (int i=1;i<=n;i++) if (p[i]>0) m++;
	for (int i=1;i<=n;i++){
		if (i!=root&&p[i]==0) continue;
		bool flag=1;int sum=m-1;
		for (int e=head[i];~e;e=E[e].nxt){
			int v=E[e].v;
			if (v==p[i]||e==et||e==et+1) continue;
			if (size[v]>m/2) flag=0;
			sum-=size[v];
		}
		if (sum<=m/2&&flag) q+=i;
	}
	return q;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--){
		scanf("%d",&n);
		memset(head,-1,sizeof head);memset(du,0,sizeof du);
		memset(E,0,sizeof E);en=-1;bool flag=1;int u,v;
		for (int i=1;i<n;i++){
			scanf("%d%d",&u,&v);
			addedge(u,v);
			addedge(v,u);
			du[u]++,du[v]++;
			if (du[u]>2||du[v]>2) flag=0;
		}
		if (flag){
			int i=1;for (;i<=n;i++) if (du[i]==1) break;
			a[1]=i;ll ans=0;
			for (int i=2;i<=n;i++){
				for (int e=head[a[i-1]];~e;e=E[e].nxt){
					int v=E[e].v;
					if (v!=a[i-2]){
						a[i]=v;break;
					}
				}
			}
			for (int i=1;i<n;i++){
				if (i&1) ans+=a[(i+1)/2];else ans+=a[i/2]+a[i/2+1];
				if ((n-i)&1) ans+=a[n-(n-i)/2];else
				ans+=a[n-(n-i)/2]+a[n-(n-i)/2+1];
			}
			printf("%lld\n",ans);
			continue;
		}else{
			ll ans=0;
			for (et=0;et<=n*2-4;et+=2){
				ans+=getans(E[et].v)+getans(E[et+1].v);
				//printf("%lld\n",ans);
			}
			printf("%lld\n",ans);
		}
	}
	return 0;
} 
