#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

typedef long long LL;
const LL maxn=5e3+5;
LL n, type, a[maxn], s[maxn], f[maxn][maxn];

LL sqr(LL x){ return x*x; }
LL sum(LL l, LL r){
	if (l>r) return 0;
	return s[r]-s[max(l-1, 0ll)]; 
}

int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%lld%lld", &n, &type); LL ans=1e18;
	for (LL i=1; i<=n; ++i){
		scanf("%lld", &a[i]);
		s[i]=s[i-1]+a[i];
	}
	memset(f, 0x7f, sizeof(f)); f[0][0]=0;
	for (LL i=1; i<=n; ++i)
	for (LL j=0; j<i; ++j){
		if (j==0) f[i][0]=sqr(sum(1, i));
		for (LL k=0; k<j; ++k)
			if (sum(j+1, i)>=sum(k+1, j))
				f[i][j]=min(f[i][j], f[j][k]+sqr(sum(j+1, i)));
		}
	for (LL i=0; i<=n; ++i)
		ans=min(ans, f[n][i]);
	printf("%lld\n", ans);
	fclose(stdin); fclose(stdout);
	return 0;
}
