#include <bits/stdc++.h>
using namespace std;
typedef long long LL;

const LL MAX = 4e18 + 1;

int n, typ;

namespace solver1 {
  const int N = 5e3 + 5;
  
  LL a[N], dp[N][N];
  void main() {
    for(int i = 1; i <= n; ++i) {
      scanf("%lld", a + i);
      a[i] += a[i - 1];
    }
    for(int i = 1; i <= n; ++i) {
      dp[i][0] = MAX;
      for(int j = 1; j <= i; ++j) {
	int k = i - j;
	LL sum = a[i] - a[k];
	int l = min(1, k), r = k, res = -1;
	while(l <= r) {
	  int mid = l + r >> 1;
	  if(a[k] - a[k - mid] <= sum) {
	    res = mid, l = mid + 1;
	  } else r = mid - 1;
	}
	dp[i][j] = (res > -1) ? (dp[k][res] + sum * sum) : MAX;
      }
      for(int j = 1; j <= i; ++j)
	dp[i][j] = min(dp[i][j], dp[i][j - 1]);
    }
    printf("%lld\n", dp[n][n]);
  }
}

namespace solver2 {
  const int N = 5e5 + 5;
  const int Bas = 100;
  
  LL a[N], dp[N][102];
  void main() {
    for(int i = 1; i <= n; ++i) {
      scanf("%lld", a + i);
      a[i] += a[i - 1];
    }
    for(int i = 1; i <= n; ++i) {
      dp[i][0] = MAX;
      int up = min(i, Bas);
      for(int j = 1; j <= up; ++j) {
	int k = i - j;
	LL sum = a[i] - a[k];
	int l = min(1, k), r = k, res = -1;
	while(l <= r) {
	  int mid = l + r >> 1;
	  if(a[k] - a[k - mid] <= sum) {
	    res = mid, l = mid + 1;
	  } else r = mid - 1;
	}
	dp[i][j] = (res > -1) ? (dp[k][min(Bas, res)] + sum * sum) : MAX;
      }
      for(int j = 1; j <= up; ++j)
	dp[i][j] = min(dp[i][j], dp[i][j - 1]);
    }
    int up = min(n, Bas);
    printf("%lld\n", dp[n][up]);
  }
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
  scanf("%d%d", &n, &typ);
  if(n <= 5000) {
    solver1 :: main();
  } else solver2 :: main();
  return 0;
}

