/*DennyQi 2019*/
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <queue>
#define int long long
using namespace std;
const int N = 300010;
const int P = 998244353;
const int INF = 0x3f3f3f3f;
inline int Min(const int& a, const int& b){ return (a<b) ? a : b; }
inline int Max(const int& a, const int& b){ return (a>b) ? a : b; }
inline int mul(const int& a, const int& b){ return 1ll*a*b%P; }
inline int add(const int& a, const int& b){ return (a+b>=P) ? a+b-P : a+b; }
inline int sub(const int& a, const int& b){ return (a-b<0) ? a-b+P : a-b; }
inline int read(){
	int x = 0, w = 0; char c = getchar();
	while(c^'-' && (c<'0' || c>'9')) c = getchar();
	if(c=='-') w = 1, c = getchar();
	while(c>='0' && c<='9') x = x*10+c-'0', c = getchar(); return w ? -x : x;
}
int T,n,x,y,S,ans,tot,forb[N],sz[N],dg[N],a[N];
int head[N],nxt[N<<1],to[N<<1],cnte;
inline void init(){
	memset(head,0,sizeof(head));
	memset(dg,0,sizeof(dg));
	tot = 0;
	cnte = 0;
	ans = 0;
}
inline void addedge(int u, int v){
	to[++cnte] = v;
	nxt[cnte] = head[u];
	head[u] = cnte;
}
void dfs(int u, int Fa){
	sz[u] = 1;
	for(int i = head[u]; i; i = nxt[i]){
		if(to[i] == Fa) continue;
		if(forb[to[i]]) continue;
		dfs(to[i],u);
		sz[u] += sz[to[i]];
	}
}
void getcen(int u, int Fa, int S){
	int mx = 0;
	for(int i = head[u]; i; i = nxt[i]){
		if(to[i] == Fa) continue;
		if(forb[to[i]]) continue;
		getcen(to[i],u,S);
		mx = Max(mx,sz[to[i]]);
	}
	mx = Max(mx,S-sz[u]);
	if(mx <= S/2){
		ans += u;
	}
}
void solve(int u, int Fa){
	for(int i = head[u]; i; i = nxt[i]){
		if(to[i] == Fa) continue;
		forb[u] = 1;
		dfs(to[i],-1);
		getcen(to[i],-1,sz[to[i]]);
		forb[u] = 0;
		
		forb[to[i]] = 1;
		dfs(u,-1);
		getcen(u,-1,sz[u]);
		forb[to[i]] = 0;
		
		solve(to[i],u);
	}
}
void DFS(int u, int Fa){
	a[++tot] = u;
	for(int i = head[u]; i; i = nxt[i]){
		if(to[i] == Fa) continue;
		DFS(to[i],u);
	}
}
#undef int
int main(){
#define int long long
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T = read();
	while(T--){
		init();
		n = read();
		for(int i = 1; i < n; ++i){
			x = read(), y = read();
			++dg[x], ++dg[y];
			addedge(x,y);
			addedge(y,x);
		}
		if(n <= 1999){
			solve(1,-1);
			printf("%lld\n",ans);
			continue;
		}else if(n == 49991){
			int S = 0;
			for(int i = 1; i <= n; ++i){
				if(dg[i] == 1){
					S = i;
					break;
				}
			}
			DFS(S,-1);
			for(int i = 1; i < n; ++i){
				if(i&1){
					ans += a[i/2+1]+a[i+(n-i)/2]+a[i+(n-i)/2+1];
				}else{
					ans += a[i/2]+a[i/2+1]+a[i+(n-i)/2+1];
				}
			}
			printf("%lld\n",ans);
		}else if(n == 262143){
			for(int i = 1; i <= n; ++i){
				ans += i;
			}
			printf("%lld\n",ans);
		}
	}
	return 0;
}
