/*DennyQi 2019*/
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <queue>
#define int long long
using namespace std;
const int N = 5010;
const int P = 998244353;
const int INF = 1e17;
inline int Min(const int& a, const int& b){ return (a<b) ? a : b; }
inline int Max(const int& a, const int& b){ return (a>b) ? a : b; }
inline int mul(const int& a, const int& b){ return 1ll*a*b%P; }
inline int add(const int& a, const int& b){ return (a+b>=P) ? a+b-P : a+b; }
inline int sub(const int& a, const int& b){ return (a-b<0) ? a-b+P : a-b; }
inline int read(){
	int x = 0, w = 0; char c = getchar();
	while(c^'-' && (c<'0' || c>'9')) c = getchar();
	if(c=='-') w = 1, c = getchar();
	while(c>='0' && c<='9') x = x*10+c-'0', c = getchar(); return w ? -x : x;
}
int n,tp,ans,a[N],b[N],s[N];
vector <int> tmp;
inline void check(){
	int res = 0;
	int L,R;
	tmp.clear();
	for(int i = 1; i <= n; i = R+1){
		L = i, R = i;
		while(b[R] == 0 && R < n){
			++R;
		}
//		printf("[%lld,%lld] ",L,R);
		tmp.push_back((s[R]-s[L-1])*(s[R]-s[L-1]));
	}
	for(int i = 0, sz = tmp.size(); i < sz-1; ++i){
		if(tmp[i] > tmp[i+1]) return;
	}
	for(int i = 0, sz = tmp.size(); i < sz; ++i){
		res += tmp[i];
	}
//	printf(" => %lld\n",res);
	ans = Min(ans,res);
}
void dfs(int x){
	if(x >= n){
		check();
		return;
	}
	b[x] = 0;
	dfs(x+1);
	b[x] = 1;
	dfs(x+1);
}
#undef int
int main(){
#define int long long
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	n = read(), tp = read();
	for(int i = 1; i <= n; ++i){
		a[i] = read();
	}
	for(int i = 1; i <= n; ++i){
		s[i] = s[i-1]+a[i];
	}
	ans = INF;
	dfs(1);
	printf("%lld\n",ans);
	return 0;
}

