#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#define rep(i,l,r) for(int i=(l);i<=(r);++i)
#define per(i,r,l) for(int i=(r);i>=(l);--i)
#define For(i,u) for(int i=hed[u],v=e[i].to;i;i=e[i].nex,v=e[i].to)
using namespace std;
typedef long long ll;
const int N=3e5+10;
int T,hed[N],d[N],ed,n,u,v;
vector<int> son[N];
struct edge{
	int to,nex;
	edge(int _=0,int __=0):to(_),nex(__){}
}e[N<<1];
inline void add(int u,int v){e[++ed]=edge(v,hed[u]);hed[u]=ed;}
namespace solve1{
	int p[N],cnt;ll ans;
	void dfs(int u,int fa){
		p[++cnt]=u;
		For(i,u) if(v^fa) dfs(v,u);
	}
	void main(){
		cnt=0;ans=0;
		rep(i,1,n) if(d[i]==1){dfs(i,0);break;}
		rep(i,1,n-1){
			ans+=p[(i+1)/2];
			if(i%2==0) ans+=p[i/2+1];
			ans+=p[(n+i+1)/2];
			if((n-i)%2==0) ans+=p[(i+n)/2+1];
		}
		printf("%lld\n",ans);
	}
}
namespace solve2{
	ll ans=0;
	void main(int p){
		int k=(n+1)>>1;
		ans=1ll*p*k;
		rep(i,0,1) ans+=1ll*(k-1)*son[p][i];
		rep(i,1,n) if(i^p) ans+=i;
		printf("%d\n",ans);
	}
}
namespace solve3{
	int fa[N],node,sz[N],f[N],tot,mx;ll ans;
	void dfs1(int u){sz[u]=1;For(i,u) if(v^fa[u]) fa[v]=u,dfs1(v),sz[u]+=sz[v];}
	void dfs(int u,int fa){
		f[u]=1;int mc=0;
		For(i,u) if(v^fa) dfs(v,u),mc=max(mc,f[v]),f[u]+=f[v];
		mc=max(mc,tot-f[u]);
		if(mc<mx) mx=mc,node=u;
		else if(mc==mx) node+=u;
	}
	void main(){
		memset(fa,0,sizeof(fa));dfs1(1);ans=0;
		rep(i,2,n){
			mx=n;tot=sz[i];dfs(i,fa[i]);ans+=node;
			mx=n;tot=n-sz[i];dfs(fa[i],i);ans+=node;
		}
		printf("%lld\n",ans);
	}
}
bool dfs(int u,int fa){
	bool p=1;if(d[u]==1) return 1;
	For(i,u) if(v^fa) son[u].push_back(v),p&=dfs(v,u);
	return p&&son[u].size()==2;
}
int main(){
	freopen("centroid.in","r",stdin);freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		scanf("%d",&n);memset(hed,0,sizeof(hed));memset(d,0,sizeof(d));ed=0;
		rep(i,1,n-1) scanf("%d%d",&u,&v),add(u,v),add(v,u),++d[u],++d[v];
		bool f1=0;
		rep(i,1,n) f1&=d[i]<=2;
		if(f1){solve1::main();continue;}
		bool f2=0;int p;
		rep(i,1,n) son[i].clear();
		rep(i,1,n) if(d[i]==2){
			f2=dfs(i,0);p=i;
			break;
		}
		if(n>5000) solve2::main(p);
		else solve3::main();
	}
	return 0;
}
