#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<cstring>
#include<cctype>
#include<climits>
#include<vector>
#include<queue>
#include<iostream>
#include<map>
#include<cmath>
#define int64 long long
#define ull unsigned long long 
#define y0 qwert
#define y1 asdfg
#define y2 zxcvb
using namespace std;
const int maxn=262150;
int dl[maxn],d[maxn];
bool v[maxn];
int64 ans;
vector<int> a[maxn];
int i,j,n;

void dfs(int x)
{
	int i,j;
	dl[1]=x;
	for(i=2;i<=n;i++)
		for(j=0;j<a[dl[i-1]].size();j++)
		{
			int y=a[dl[i-1]][j];
			if (y==dl[i-2])
				continue;
			dl[i]=y;
		}
}

int dfs3(int x,int fa)
{
	int i,res=1;
	v[x]=1;
	for(i=0;i<a[x].size();i++)
	{
		int y=a[x][i];
		if (y==fa)
			continue;
		res+=dfs3(y,x);
	}
	return res;
}

int dfs4(int x,int fa,int z)
{
	int i,res=1;
	for(i=0;i<a[x].size();i++)
	{
		int y=a[x][i];
		if (y==fa or y==z)
			continue;
		res+=dfs4(y,x,z);
	}
	return res;
}

void calc2(int x,int z)
{
	memset(v,0,sizeof(int)*(n+1));
	int size=dfs3(x,z);
	int i,j;
	//cout<<'-'<<x<<","<<z<<"-"<<endl;
	for(i=1;i<=n;i++)
		if (v[i])
		{
			bool flag=1;
			for(j=0;j<a[i].size();j++)
			{
				int k=a[i][j];
				if (k==i or k==z)
					continue;
				if (dfs4(k,i,z)>size/2)
				{
					flag=0;
					break;
				}
			}
			if (flag)
			{
				ans+=(int64)i;
				//cout<<i<<",";
			}
		}
	//cout<<endl;
}

void dfs2(int x,int fa)
{
	int i;
	for(i=0;i<a[x].size();i++)
	{
		int y=a[x][i];
		if (y==fa)
			continue;
		calc2(x,y);
		calc2(y,x);
		dfs2(y,x);
	}
}
		
void work()
{
	scanf("%d",&n);
	for(i=1;i<=n-1;i++)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		a[x].push_back(y);
		a[y].push_back(x);
		d[x]++;
		d[y]++;
	}
	
	bool flag=1;
	for(i=1;i<=n;i++)
		if (d[i]>2)
			flag=0;
	if (flag)
	{
		for(i=1;i<=n;i++)
			if (d[i]==1)
				break;
		dfs(i);
		for(i=1;i<=n-1;i++)
		{
			int l=((i+1)%2==0 ? (dl[(i+1)/2]) : (dl[(i+1)/2]+dl[(i+1)/2+1]) );
			int r=((i+1+n)%2==0 ? (dl[(i+1+n)/2]) : (dl[(i+1+n)/2]+dl[(i+1+n)/2+1]) );
			ans=ans+(int64)(l+r);
		}
		cout<<ans<<endl;
		goto end;
	}
	
	if (n<=2000)
	{
		dfs2(1,0);
		cout<<ans<<endl;
		goto end;
	}
	if (1)
	{
		for(i=1;i<=n;i++)
			if (d[i]==2)
				break;
		int root=i;
		for(i=1;i<=n;i++)
			ans+=(int64)i;
		ans-=(int64)root;
		for(i=1;i<=65536;i++)
			ans+=(int64)root+a[root][0];
		for(i=1;i<=65536;i++)
			ans+=(int64)root+a[root][1];
		for(i=1;i<=(262142-131072)/2;i++)
			ans+=(int64)a[root][0]+a[root][1];
		cout<<ans<<endl;
		goto end;
	}
	end:
	for(i=1;i<=n;i++)
		if (a[i].size())
			a[i].clear();
	for(i=1;i<=n;i++)
		d[i]=0;
	ans=0;
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
		work();
	fclose(stdin);fclose(stdout);
	return 0;
}
