#include<iostream>
#include<cstring>
#include<cstdio>
#include<cmath>
#include<algorithm>
#define N 300010
using namespace std;
inline int read()
{
	int num=0,neg=1;char c=getchar();
	for(;!isdigit(c);c=getchar())if(c=='-')neg=-1;
	for(;isdigit(c);c=getchar())num=(num<<1)+(num<<3)+c-'0';
	return num*neg;
}
struct edge
{
	int nxt,v,u;
}Edge[N<<1];
int n,m,s,sum,cnt,mx,T,head[N],v[N],siz[N],tot[N];
long long ans,A[N];
inline void Add_edge(int u,int v)
{
	Edge[++cnt].nxt=head[u];
	Edge[cnt].v=v;
	Edge[cnt].u=u;
	head[u]=cnt;
}
inline bool check(int u,int p)
{
	if(siz[s]-siz[u]>siz[s]/2)return 0;
	for(int i=head[u];i;i=Edge[i].nxt)
	{
		int v=Edge[i].v;
		if(siz[v]>siz[u] || v==p)continue;
		if(siz[v]>siz[s]/2)return 0;
	}
	return 1;
}
inline void dfs1(int u,int p,int fa)
{
	siz[u]=1;
	for(int i=head[u];i;i=Edge[i].nxt)
	{
		int v=Edge[i].v;
		if(v==fa || v==p)continue;
		dfs1(v,p,u);
		siz[u]+=siz[v];
	}
}
inline void dfs2(int u,int p,int fa)
{
	if(check(u,p))sum+=u;
	for(int i=head[u];i;i=Edge[i].nxt)
	{
		int v=Edge[i].v;
		if(v==fa || v==p)continue;
		dfs2(v,p,u);
	}
}
inline void work(int u,int p)
{
	sum=0;s=u;
	dfs1(u,p,0);
	dfs2(u,p,0);
	ans+=sum;
}
inline void dfs3(int u,int k,int fa)
{
	A[k]+=u;ans+=u;
	for(int i=head[u];i;i=Edge[i].nxt)
	{
		int v=Edge[i].v;
		if(v==fa)continue;
		dfs3(v,k+1,u);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	while(T--)
	{
		n=read();cnt=ans=0;
		for(int i=0;i<=n;i++)head[i]=siz[i]=tot[i]=0;
		for(int i=1;i<=n-1;i++)
		{
			int u=read(),v=read();
			Add_edge(u,v);Add_edge(v,u);
			tot[v]++;tot[u]++;
		}
		for(int i=1;i<=n;i++)if(tot[i]==1)tot[0]++;
		if(n<=1999)
		{
			for(int i=1;i<=cnt;i+=2)
			{
				work(Edge[i].u,Edge[i].v);
				work(Edge[i].v,Edge[i].u);
			}
			printf("%lld\n",ans);
		}
		else if(tot[0]==2)
		{
			for(int u=1;u<=n;u++)
				if(tot[u]==1)
				{
					for(int j=1;j<=n;j++)
					{
						v[j]=u;
						for(int i=head[u];i;i=Edge[i].nxt)if(Edge[i].v!=v[j-1])u=Edge[i].v;
					}
					break;
				}
			for(int i=1;i<=n-1;i++)
			{
				ans+=v[i/2+1];
				if(i%2==0)ans+=v[i/2];
				ans+=v[i+(n-i)/2+1];
				if((n-i)%2==0)ans+=v[i+(n-i)/2];
			}
			printf("%lld\n",ans);
		}
		else
		{
			for(int i=1;i<=n;i++)if(tot[i]==2)dfs3(i,1,0);
			int k=log2(n+1);
			long long sum=1;

			printf("%lld\n",ans);
		}
	}
	return 0;
}

