#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<cmath>
using namespace std;
int edgenum,head[400005],nex[400005],vet[400005],fa[400005];
int siz[400005],color[400005],szum[400005],f[400005];
int n,m,id[400005],du[400005],root,mxd;
long long ans;
struct node
{
	int u,v;
}e[400005];
void addedge(int u,int v)
{
	edgenum++,vet[edgenum]=v,nex[edgenum]=head[u],head[u]=edgenum;
}
void dfs(int u,int pre,int col)
{
	color[u]=col,siz[u]=1,szum[col]++,fa[u]=pre;
	for (int i=head[u];i!=0;i=nex[i])
		if (color[vet[i]]==0) dfs(vet[i],u,col),siz[u]+=siz[vet[i]];
}
void sao(int u,int pre,int dep)
{
	id[dep]=u;
	for (int i=head[u];i!=0;i=nex[i])
		if (vet[i]!=pre) sao(vet[i],u,dep+1);
}
void cut(int k)
{
//	cout<<" cut "<<e[k].v<<" "<<e[k].u<<endl;
	edgenum=szum[1]=szum[2]=0;
	for (int i=1;i<=n;i++) head[i]=color[i]=siz[i]=0;
	for (int i=1;i<k;i++)
		addedge(e[i].u,e[i].v),addedge(e[i].v,e[i].u);
	for (int i=k+1;i<=m;i++)
		addedge(e[i].u,e[i].v),addedge(e[i].v,e[i].u);
	dfs(e[k].u,0,1),dfs(e[k].v,0,2);
	
	for (int u=1;u<=n;u++)
	{
		f[u]=szum[color[u]]-siz[u];
		for (int i=head[u];i!=0;i=nex[i])
			if (vet[i]!=fa[u]) f[u]=max(siz[vet[i]],f[u]);
//		cout<<"fff "<<u<<" "<<f[u]<<endl;
		if (f[u]<=szum[color[u]]/2) ans+=u;
	}
}
void solve1()
{
	ans=0;
	for (int i=1;i<=m;i++) cut(i);
	printf("%lld\n",ans);
	return;
}
long long calc(int x,int y)
{
	if ((y-x+1)&1) return id[(x+y)/2];
	else return id[(x+y)/2]+id[(x+y)/2+1];
}
void solve2()
{
	ans=0;
	if (mxd>2) return;
	for (int i=1;i<=m;i++)
		addedge(e[i].u,e[i].v),addedge(e[i].v,e[i].u);
	for (int i=1;i<=n;i++)
		if (du[i]==1) root=i;
	sao(root,0,1);
	for (int i=1;i<n;i++)
		ans+=calc(1,i)+calc(i+1,n);
	printf("%lld\n",ans);
}
void solve()
{
	scanf("%d",&n),m=n-1;
	ans=0;
	for (int i=1;i<=m;i++)
		scanf("%d%d",&e[i].u,&e[i].v),du[e[i].u]++,du[e[i].v]++;
	for (int i=1;i<=n;i++) mxd=max(mxd,du[i]);
	if (n<=2000) solve1();
	else solve2();
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int cas;scanf("%d",&cas);
	while (cas--) solve();
	return 0;
}
