#include<iostream>
#include<cstdio>
#include<cstring>

typedef long long ll;
ll read()
{
	ll x=0,f=1;
	char c=getchar();
	while(c<'0'||c>'9')
	{
		if(c=='-')f=-1;
		c=getchar();
	}
	while(c>='0'&&c<='9')
	{
		x=x*10+c-'0';
		c=getchar();
	}
	return f*x;
}

#define MAXN 51
#define MAXM 2011
ll c[MAXM],a[MAXN][MAXM];
ll n,m,ans=0;
const ll mod=998244353;
namespace subtask1
{
	ll f[51][25][25][25];
	void solve()
	{
		f[0][0][0][0]=1;
		for(ll i=1;i<=n;++i)
		{
			for(ll c1=0;c1<=i;++c1)
				for(ll c2=0;c2+c1<=i;++c2)
					for(ll c3=0;c3+c2+c1<=i;++c3)
					{
						ll& cur=f[i][c1][c2][c3];
						cur=f[i-1][c1][c2][c3];
						if(c1>0)cur=(cur+f[i-1][c1-1][c2][c3]*a[i][1])%mod;
						if(c2>0)cur=(cur+f[i-1][c1][c2-1][c3]*a[i][2])%mod;
						if(c3>0)cur=(cur+f[i-1][c1][c2][c3-1]*a[i][3])%mod;
					}
		}
		ll ans=0;
		for(ll c1=0;c1<=n/2;++c1)
			for(ll c2=0;c2<=n/2;++c2)
				for(ll c3=0;c3<=n/2;++c3)
				{
					ll s=c1+c2+c3;
					if(c1<=s/2&&c2<=s/2&&c3<=s/2)ans=(ans+f[n][c1][c2][c3])%mod;
				}
		printf("%lld",(ans-1+mod)%mod);
	}
}
namespace subtask2
{
	ll f[MAXN][MAXN][MAXN];
	void solve()
	{
		f[0][0][0]=1;
		for(ll i=1;i<=n;++i)
		{
			for(ll c1=0;c1<=i;++c1)
				for(ll c2=0;c2+c1<=i;++c2)
					{
						ll& cur=f[i][c1][c2];
						cur=f[i-1][c1][c2];
						if(c1>0)cur=(cur+f[i-1][c1-1][c2]*a[i][1])%mod;
						if(c2>0)cur=(cur+f[i-1][c1][c2-1]*a[i][2])%mod;
						
					}
		}
		ll ans=0;
		for(ll c1=0;c1<=n/2;++c1)
			for(ll c2=0;c2<=n/2;++c2)
				{
					ll s=c1+c2;
					if(c1<=s/2&&c2<=s/2)ans=(ans+f[n][c1][c2])%mod;
				}
		printf("%lld",(ans-1+mod)%mod);
	}
}
namespace subtask3
{
	ll c[MAXN];
	void dfs(ll x,ll f)
	{
		if(x>n)
		{
			bool flag=0;
			ll sum=0;
			for(ll i=1;i<=m;++i)sum+=c[i];
			for(ll i=1;i<=m;++i)
				if(c[i]>sum/2)return;
			ans=(ans+f)%mod;
			return;
		}
		dfs(x+1,f);
		for(ll y=1;y<=m;++y)
			if(c[y]+1<=n/2&&a[x][y])
			{
				++c[y];
				dfs(x+1,f*a[x][y]%mod);
				--c[y];
			}
	}
	void solve()
	{
		dfs(1,1);
		printf("%lld",(ans-1+mod)%mod);
	}
}
int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	n=read(),m=read();
	for(ll i=1;i<=n;++i)
		for(ll j=1;j<=m;++j)a[i][j]=read();
	if(m==3)subtask1::solve();
	else if(m==2)subtask2::solve();
	else subtask3::solve();
	fclose(stdin);fclose(stdout);
	return 0;
}
