#include<iostream>
#include<cstdio>
#include<cmath>
#include<algorithm>
using namespace std;
int tot,head[20000],nex[20000],vet[20000],f[20000],limtu,limtv;
int col[20000],size[20000],u[10000],v[10000];
long long ans;
int read()
{
	int ret(0),flag(1);
	char ch=getchar();
	while (ch<'0'||ch>'9')
	{
		if (ch=='-') flag=-1;
		ch=getchar();
	}
	while (ch>='0'&&ch<='9')
	{
		ret=(ret<<1)+(ret<<3)+ch-48;
		ch=getchar();
	}
	return ret*flag;
}
void add(int u,int v)
{
	tot++;
	nex[tot]=head[u]; head[u]=tot; vet[tot]=v;
}
bool comp(int u,int v)
{
	int tmpu=limtu,tmpv=limtv;
	if (tmpu>tmpv) swap(tmpu,tmpv);
	if (u>v) swap(u,v);
	if (tmpu==u&&tmpv==v) return 1;
	else return 0;
}
bool check(int u)
{
	bool bb(1);
	for (int i=head[u];i;i=nex[i])
	{
		int v=vet[i];
		if (v!=f[u]&&col[u]==col[v]) 
		{
			if (col[u]==1&&size[v]>size[limtu]/2) return 0;
			if (col[u]==0&&size[v]>size[limtv]/2) return 0;
		}
	}
	if (u!=f[u])
	{
		int tmp;
		if (col[u]==1) tmp=size[limtu]-size[u];
		if (col[u]==0) tmp=size[limtv]-size[u];
		//if (u==5) printf("\n waw=%d %d \n",tmp,u);
		if (col[u]==1&&tmp>size[limtu]/2) return 0;
		if (col[u]==0&&tmp>size[limtv]/2) return 0;
	}
	return 1;
}
void dfs(int u,int fa,int c)
{
	size[u]=1; col[u]=c; f[u]=fa;
	for (int i=head[u];i;i=nex[i])
	{
		int v=vet[i];
		if (v!=fa&&!comp(u,v)) 
		{
			dfs(v,u,c);
			size[u]+=size[v];
		}
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=read();
	while (T--)
	{
		ans=0; tot=0;
		int n=read();
		for (int i=1;i<=n;i++) head[i]=0;
		for (int i=1;i<n;i++)
		{
			u[i]=read(),v[i]=read();
			add(u[i],v[i]); add(v[i],u[i]);
		}
		for (int i=1;i<n;i++)
		{
			//printf("%d \n",i);
			//puts("QAQ");
			limtu=u[i],limtv=v[i];
			dfs(u[i],u[i],1); dfs(v[i],v[i],0);
			for (int j=1;j<=n;j++)
			{
				if (check(j)) ans+=j;
				//printf("%d %d %d %d\n",j,check(j),col[j],size[j]);
			}
			
		}
		printf("%d\n",ans);
	}
	return 0;
} 
