#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int T,n;
int Head[300010],Next[600010],To[600010],num_edge;
int ru[300010];
int line[300010],num_line=0,used[600010];
int max_son[300010],son[300010];
void init()
{
	memset(Head,-1,sizeof(Head));
	memset(To,0,sizeof(To));
	memset(Next,0,sizeof(Next));
	num_edge=1;
	memset(ru,0,sizeof(ru));
	memset(line,0,sizeof(line));
	num_line=0;
	memset(used,0,sizeof(used));
}
void add_edge(int x,int y)
{
	num_edge++;
	Next[num_edge]=Head[x];
	Head[x]=num_edge;
	To[num_edge]=y;
}
void solve_line()
{
	for(int i=1;i<=n;i++)
		if(ru[i]==0)
		{
			line[++num_line]=i;
			used[i]=1;
			for(int j=To[Head[i]];used[j]==0;j=To[Head[j]])
				line[++num_line]=j,used[j]=1;
		}
	int ans=0;
	for(int i=1;i<n;i++)
	{
		ans+=line[i/2+1];
		if(i%2==0)
			ans+=line[i/2];
		ans+=line[(i+1+n)/2];
		if((i+1+n)%2==1)
			ans+=line[(i+1+n)/2+1];
	}
	printf("%d\n",ans);
}
int root;
int min_max_son;
int heavy1,heavy2;
void find(int x)
{
	son[x]=1;
	for(int i=Head[x];i!=-1;i=Next[i])
	{
		int v=To[i];
		if(used[i]==0)
		{
			used[i]=used[i^1]=1;
			find(v);
			son[x]+=son[v];
			max_son[x]=max(max_son[x],son[v]);
		}
	}
}
void check(int x)
{
	for(int i=Head[x];i!=-1;i=Next[i])
	{
		int v=To[i];
		if(used[i]==0)
		{
			used[i]=used[i^1]=1;
			find(v);
		}
	}
	int maxx=max(max_son[x],son[root]-son[x]);
	if(min_max_son>maxx)
		heavy1=x,heavy2=0;
	else if(min_max_son==maxx)
		heavy2=x;
}
void solve()
{
	int ans=0;
	for(int i=1;i<n;i++)
	{
		memset(max_son,0,sizeof(max_son));
		memset(son,0,sizeof(son));
		used[(i*2)]=used[(i*2)^1]=1;
		int root1=To[i*2],root2=To[(i*2)^1];
		heavy1=heavy2=0;
		min_max_son=0x7fffffff;
		memset(used,0,sizeof(used));
		find(root1);
		memset(used,0,sizeof(used));
		root=root1;
		check(root1);
		ans+=heavy1+heavy2;
		min_max_son=0x7fffffff;
		heavy1=heavy2=0;
		memset(used,0,sizeof(used));
		find(root2);
		memset(used,0,sizeof(used));
		root=root2;
		check(root2);
		ans+=heavy1+heavy2;
	}
	printf("%d\n",ans);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--)
	{
		init();
		scanf("%d",&n);
		bool flag=0;
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d %d",&u,&v);
			add_edge(u,v);
			add_edge(v,u);
			ru[v]++;
			if(ru[v]>1)
				flag=1;
		}
		if(flag==0)
			solve_line();
		else
			solve();
	}
	return 0;
}
