#include <bits/stdc++.h>
using namespace std;
const int N=5e5+10;
struct Edge {
	int last[2*N],pnt[2*N],nxt[2*N],head[N],E;
	bool ban[2*N];
	void add(int a,int b) {
		last[E]=a;
		pnt[E]=b;
		ban[E]=0;
		nxt[E]=head[a];
		head[a]=E++;
	}
	void init() {
		memset(head,-1,sizeof(head));
		E=0;
	}
} G;
int sz[N],mx[N];
void dfs(int u,int f) {
	//printf("---%d\n",u);
	sz[u]=1;
	for(int i=G.head[u]; i!=-1; i=G.nxt[i]) {
		int v=G.pnt[i];
		if(v==f||G.ban[i])continue;
		dfs(v,u);
		sz[u]+=sz[v];
		mx[u]=max(mx[u],sz[v]);
	}

}

int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	while(scanf("%d",&T)!=EOF) {
		while(T--) {
			G.init();
			int n;
			scanf("%d",&n);
			for(int i=1; i<n; i++) {
				int a,b;
				scanf("%d%d",&a,&b);
				G.add(a,b),G.add(b,a);
			}
		
				int ans=0;
			for(int i=0; i<G.E; i+=2) {
				G.ban[i]=1;
				G.ban[i+1]=1;
				dfs(G.last[i],0);
				for(int j=1; j<=n; j++) {
					if(sz[j]) {
						mx[j]=max(mx[j],sz[G.last[i]]-sz[j]);
						//
					}
					if(max(mx[j],sz[G.last[i]]-sz[j])<=sz[G.last[i]]/2&&sz[j]) {

						//printf("--%d ",j);
						ans+=j;
					}
					//

				}
				memset(sz,0,sizeof(sz));
				memset(mx,0,sizeof(mx));
				//printf("        ");
				dfs(G.pnt[i],0);
				for(int j=1; j<=n; j++) {
					if(sz[j]) {
						mx[j]=max(mx[j],sz[G.pnt[i]]-sz[j]);
						//printf("-----%d %d\n",j,mx[j]);
					}
					if(max(mx[j],sz[G.pnt[i]]-sz[j])<=sz[G.pnt[i]]/2&&sz[j]) {
						ans+=j;
						//printf("--%d ",j);

					}

				}
				//puts("");
				G.ban[i]=0;
				G.ban[i+1]=0;
				memset(sz,0,sizeof(sz));
				memset(mx,0,sizeof(mx));

			}
			printf("%d\n",ans);
		}

	}
	return 0;
}
