#include<iostream>
#include<cstdio>
using namespace std;
int n, m;
int mealN[105][2005];
int used[105];
int used_m[2005], used_n;
int dfs(int dn){
	if(dn == -1){
		for(int i = 0; i != m; ++i){
			used_m[i] = 0;
		}
		used_n = 0;
		for(int i = 0; i != n; ++i){
			if(~used[i]){
				++used_n;
				++used_m[used[i]];
			}
		}
		used_n /= 2;
		for(int i = 0; i != m; ++i){
			if(used_m[i] > used_n){
				return 0;
			}
		}
		long long ans = 1;
		for(int i = 0; i != n; ++i){
			if(~used[i]){
				ans *= mealN[i][used[i]];
				ans %= 998244353;
			}
		}
		return ans;
	}
	long long sum = 0;
	for(int i = 0; i != m; ++i){
		if(mealN[dn][i]){
			used[dn] = i;
			sum += dfs(dn - 1);
		}
	}
	used[dn] = -1;
	sum += dfs(dn - 1);
	return sum % 998244353;
}
int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for(int i = 0; i != n; ++i){
		for(int j = 0; j != m; ++j){
			scanf("%d", &mealN[i][j]);
		}
	}
	int ans = dfs(n - 1);
	printf("%d", ans - 1);
	fclose(stdout);
	fclose(stdin);
	return 0;
}
