#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>

template <typename Tp>
inline void read(Tp &x) {
    x = 0;
    bool f = true; char ch = getchar();
    for ( ; ch < '0' || ch > '9'; ch = getchar()) f ^= ch == '-';
    for ( ; ch >= '0' && ch <= '9'; ch = getchar()) x = x * 10 + (ch ^ 48);
    x = f ? x : -x;
}

const int N = 5e3 + 7;
const long long inf = 4e18;

int A[N], Sum[N], Max[N][N], Pos[N][N], Top[N]; 
long long F[N][N];

int main() {
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
    int n, type;
    read(n), read(type);
    if (type == 0) {
        for (int i = 1; i <= n; ++i) read(A[i]);
        for (int i = 1; i <= n; ++i) Sum[i] = Sum[i - 1] + A[i];
        memset(F, 0x3f, sizeof(F));
        for (int i = n; i; --i)
            for (int j = i + 1; j <= n + 1; ++j) {
                int x = Sum[j - 1] - Sum[i - 1];
                if (j == n + 1) F[i][j] = 1LL * x * x;
                else {
                    int p = std::lower_bound(Max[j] + 1, Max[j] + Top[j] + 1, x) - Max[j];
                    F[i][j] = F[j][Pos[j][p]] + 1LL * x * x; 
                }
                while (Top[i] && F[i][j] <= F[i][Pos[i][Top[i]]]) --Top[i];
                ++Top[i];
                Max[i][Top[i]] = x, Pos[i][Top[i]] = j;
            }
        long long Ans = inf;
        for (int i = 1; i <= n + 1; ++i) Ans = std::min(Ans, F[1][i]);
        printf("%lld\n", Ans);
    }
    return 0;
}