#include <bits/stdc++.h>
using namespace std;

const int N = 3e5 + 5;
const int M = N * 2;

typedef long long LL;


int n, m, x, y, du[N], fir[N], ne[M], to[M], cnt = 1, fa[N], Size[N], Ason[N], Bson[N], s[N], e[N], L[N], R[N], dlc;
LL ans;

bool in(int x, int y) {
  return (L[x] >= L[y]) && (L[x] <= R[y]);
}

void add(int x, int y) {
  ne[++ cnt] = fir[x];
  fir[x] = cnt;
  to[cnt] = y;
}

void link(int x, int y) {
  add(x, y);
  add(y, x);
}

#define Foreachson(i, x) for(int i = fir[x]; i; i = ne[i])

bool cmp(int x, int y) {
  return Size[x] < Size[y];
}

void dfs(int x, int f) {
  fa[x] = f; Size[x] = 1;
  Ason[x] = Bson[x] = 0;
  Foreachson(i, x) {
    int V = to[i];
    if(V == f) continue;
    dfs(V, x);
    Size[x] += Size[V];
    if(cmp(Ason[x], V)) Ason[x] = V;
    else if(cmp(Bson[x], V)) Bson[x] = V;
  }
}

namespace solvervio {
  int All;
  
  void solve(int x, int y) {
    for(int i = 1; i <= n; ++ i) fa[i] = Size[i] = Ason[i] = Bson[i] = 0;
    dfs(x, y);
    All = Size[x];
    int tmp = All / 2;
    for(int i = 1; i <= n; ++ i) {
      if(fa[i]) {
	if(All - Size[i] > tmp || Size[Ason[i]] > tmp) continue;
	ans += i;
      }
    }
  }
  
  void main() {
    for(int i = 1; i < n; ++ i) {
      solve(s[i], e[i]); solve(e[i], s[i]);      
    }
    cout << ans << endl;
  }
}

bool Line() {
  bool ok = 1;
  for(int i = 1; i <= n; ++ i) ok &= (du[i] <= 2);
  return ok;
}

namespace solverLine {

  int P[N], tot;

  void dfs2(int x, int f) {
    P[++ tot] = x;
    Foreachson(i, x) {
      int V = to[i];
      if(V == f) continue;
      dfs2(V, x);
    }
  }

  LL calc(int l, int r) {
    int len = r - l + 1;
    if(len & 1) {
      return P[(l + r) / 2];
    }
    else {
      return P[(l + r) / 2] + P[(l + r) / 2 + 1];
    }
  }
  
  void main() {
    tot = 0;
    for(int i = 1; i <= n; ++ i) {
      if(du[i] == 1) {
	dfs2(i, 0); break;
      }
    }
    for(int i = 1; i < n; ++ i) {
      ans += calc(1, i) + calc(i + 1, n);
    }
    cout << ans << endl;
  }
}

bool Tree() {
  int res = 0;
  for(int i = 1; i <= n; ++ i)
    res += (du[i] == 1);
  if(res != n - (n - 1) / 2) return 0;
  res = 0;
  for(int i = 1; i <= n; ++ i)
    res += du[i] == 2;
  if(res != 1) return 0;
  return 1;
}

namespace solverTree {
  void dfs3(int x, int f) {
    fa[x] = f; Size[x] = 1;
    Ason[x] = Bson[x] = 0;
    L[x] = ++ dlc;
    Foreachson(i, x) {
      int V = to[i];
      if(V == f) continue;
      dfs3(V, x);
      Size[x] += Size[V];
      if(cmp(Ason[x], V)) Ason[x] = V;
      else if(cmp(Bson[x], V)) Bson[x] = V;
    }
    R[x] = dlc;
  }

  void getans(int rt, int x) {
    int All = Size[rt] - Size[x];
    int tmp = All / 2;
    while(1) {
      int l = Ason[rt], r = Bson[rt], Sl = Size[l], Sr = Size[r];
      if(in(x, l)) Sl -= Size[x];
      if(in(x, r)) Sr -= Size[x];
      if(Sl < Sr) {
	swap(l, r); swap(Sl, Sr);
      }
      if(Sl > tmp) {
	rt = l; continue;
      }
      else {
	ans += rt;
	if(Sl == tmp) {
	  ans += l;
	}
	return;
      }
    }
  }

  void main() {
    for(int i = 1; i <= n; ++ i) L[i] = R[i] = 0;
    dlc = 0;
    int x = 0;
    for(int i = 1; i <= n; ++ i) if(du[i] == 2) x = i;
    dfs3(x, 0);
    for(int i = 1; i <= n; ++ i) {
      if(fa[i]) {
	getans(x, i);
	ans = ans + i;
      }
    }
    cout << ans << endl;
  }
}

void input() {
  int t;
  for(cin >> t; t --;) {
    scanf("%d", &n);
    //n = 2000;
    cnt = 1; ans = 0;
    memset(fir, 0, sizeof(fir));
    memset(du, 0, sizeof(du));
    for(int i = 1; i < n; ++ i) {
      scanf("%d%d", &x, &y);
      //x = i + 1;
      //y = rand() % i + 1;
      link(x, y);
      ++ du[x]; ++ du[y];
      s[i] = x, e[i] = y;
    }
    if(n <= 2000) {
      solvervio :: main();
      continue;
    }
    else if(Line()) solverLine :: main();
    else if(Tree()) solverTree :: main();
  }
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  input();
}
