#include <bits/stdc++.h>
using namespace std;

const int N = 1e2 + 5;
const int M = 2e3 + 5;
const int mod = 998244353;

namespace {
  int add(int x) {return (x >= mod) ? x - mod : x;}
  int sub(int x) {return (x < 0) ? x + mod : x;}
  void Add(int &x, int y) {x = add(x + y);}
  void Sub(int &x, int y) {x = sub(x - y);}
  int Pow(int x, int y = mod - 2) {
    int res = 1;
    while(y) {
      if(y & 1)
	res = 1LL * res * x % mod;
      y >>= 1;
      x = 1LL * x * x % mod;
    }
    return res;
  }
}

int n, m, A[N][M], dp[N][N * 2], ans, Sum[N];

int main() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  scanf("%d%d", &n, &m);
  ans = 1;
  for(int i = 1; i <= n; ++ i) {
    Sum[i] = 0;
    for(int j = 1; j <= m; ++ j) {
      scanf("%d", &A[i][j]);
      //A[i][j] = rand() % mod;
      Add(Sum[i], A[i][j]);
    }
    ans = 1LL * ans * add(Sum[i] + 1) % mod;
  }
  Sub(ans, 1);
  //cerr << ans << " " << Pow(5, 3) << endl;
  for(int i = 1; i <= m; ++ i) {
    memset(dp, 0, sizeof(dp));
    dp[0][101] = 1;
    for(register short j = 1; j <= n; ++ j) {
      int a = A[j][i], b = sub(Sum[j] - A[j][i]);
      for(register short k = 101 - j; k <= 101 + j; ++ k) {
	Add(dp[j][k], dp[j - 1][k]);
	Add(dp[j][k - 1], 1LL * dp[j - 1][k] * b % mod);
	Add(dp[j][k + 1], 1LL * dp[j - 1][k] * a % mod);
      }
    }
    for(int j = 102; j < 2 * N; ++ j) Sub(ans, dp[n][j]);
  }
  cout << ans << endl;
}
