#include <bits/stdc++.h>
using namespace std;

const int N = 300005;
const int INF = 0x7ffffff;

int n;
int cnt,head[N];
int size[N],gsize[N];
pair <int,int> p[N];
bool son[N];

struct Edge{
	int to,next;
	bool is;
}E[N<<1];

void init(){
	cnt=0;
	fill(head,head+n+1,0);
	for(int i=1;i<=n<<1;i++){
		E[i].next=0;
		E[i].to=0;
		E[i].is=true;
	}
	memset(p,0,sizeof(p));
	fill(son,son+n+1,false);
	fill(size,size+n+1,0);
	fill(gsize,gsize+n+1,0);
}

void getson(int u,int fa){
	son[u]=true;
	for(int i=head[u];i;i=E[i].next){
		int y=E[i].to;
		if(y==fa || !E[i].is)continue;
		getson(y,u);
	}
}

void dfs(int u,int fa){
	size[u]=1;
	for(int i=head[u];i;i=E[i].next){
		int y=E[i].to;
		if(y==fa || !E[i].is)continue;
		dfs(y,u);
		if(fa!=0)size[u]+=size[y];
		else gsize[u]=max(size[y],gsize[u]);
	}
}

int get(){
	int res=0,mi=INF;
	for(int i=1;i<=n;i++){
		if(gsize[i]==0)continue;
		if(gsize[i]<mi){
			res=i;
			mi=gsize[i];
		}
		else if(gsize[i]==mi){
			res+=i;
		}
	}
	return res;
}

int ans;
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	while(t--){
		ans=0;
		scanf("%d",&n);
		init();
		for(int i=1;i<n;i++){
			int x,y;
			scanf("%d%d",&x,&y);
			E[++cnt]=(Edge){y,head[x],true},head[x]=cnt;
			p[i].first=cnt;
			E[++cnt]=(Edge){x,head[y],true},head[y]=cnt;
			p[i].second=cnt;
		}
		for(int i=1;i<n;i++){
			int x=p[i].first,y=p[i].second;
			E[x].is=false;
			E[y].is=false;
			
			fill(size,size+n+1,0);
			fill(gsize,gsize+n+1,0);
			fill(son,son+n+1,0);
			
			getson(E[x].to,0);
			for(int j=1;j<=n;j++){
				if(son[j])dfs(j,0);
			}
			int t=get();
			if(t)ans+=t;
			else ans+=E[x].to;
			
			fill(size,size+n+1,0);
			fill(gsize,gsize+n+1,0);
			fill(son,son+n+1,0);
			
			getson(E[y].to,0);
			for(int i=1;i<=n;i++){
				if(son[i])dfs(i,0);
			}
			t=get();
			if(t)ans+=t;
			else ans+=E[y].to;
			
			E[x].is=true;
			E[y].is=true;
		}
		cout<<ans<<endl;
	}
	return 0;
}
