#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
typedef long long ll;
template <typename T>
inline void read (T &x) {
    x = 0;
    char ch = getchar();
    while (!isdigit(ch))
        ch = getchar();
    while (isdigit(ch)) {
        x = x * 10 + ch - '0';
        ch = getchar();
    }
}
const int N = 300000;
int t, n, ans, tot, hd[N], to[N << 1], nxt[N << 1], siz[N], fa[N], vis[N];
bool tag[N], used[N << 1];
void dfs (int u) {
    vis[u] = 1;
    // siz[u] = 1;
    for (int i = hd[u]; i; i = nxt[i])
        if (!vis[to[i]]) {
            int v = to[i];
            fa[v] = u;
            dfs(v);
            // siz[u] += siz[v];
        }
}
inline void addedge (int u, int v) {
    to[tot] = v;
    nxt[tot] = hd[u];
    hd[u] = tot++;
}
int limfind (int x, int tr) {
    while (fa[x] != x && fa[x] != tr)
        x = fa[x];
    return x;
}
int main () {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    read(t);
    while (t--) {
        read(n);
        tot = 0;
        for (int i = 1, x, y; i < n; i++)
            read(x), read(y), addedge(x, y), addedge(y, x);
        unsigned arrsiz = (n + 1) << 2;
        for (int u = 1; u <= n; u++)
            for (int i = hd[u]; i; i = nxt[i]) {
                if (used[i])
                    continue;
                for (int j = 1; j <= n; j++)
                    fa[j] = j;
                used[i] = used[i ^ 1] = 1;
                int v = to[i];
                memset(vis, 0, arrsiz);
                vis[v] = 1;
                dfs(u);
                dfs(v);
                int ans = 0, usiz = 0;
                for (int j = 1; j <= n; j++)
                    if (fa[limfind(j, u) == u] && j != v)
                        tag[j] = 1, ++usiz;
                    else
                        tag[j] = 0;
                int vsiz = n - usiz;
                usiz >>= 1, vsiz >>= 1;
                for (int j = 1; j <= n; j++) {
                    int cur = 0;
                    for (int k = 1; k <= n; k++)
                        if (tag[j] == tag[k] && (j == k || fa[limfind(k, j)] == j))
                            ++cur;
                    if (cur <= (tag[j] ? usiz : vsiz))
                        ans += cur;
                }
            }
        printf("%d\n", ans);
    }
}