#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
typedef long long ll;
template <typename T>
inline void read (T &x) {
    x = 0;
    char ch = getchar();
    while (!isdigit(ch))
        ch = getchar();
    while (isdigit(ch)) {
        x = x * 10 + ch - '0';
        ch = getchar();
    }
}
const int N = 40000000 + 1;
int n, type, a[N];
ll sum[N];
ll ans = 0x7fFFffFFffFFffFFll;
void dfs (int dep, ll pre, ll cur) {
    if (cur > ans || cur < 0)
        return;
    if (dep == n) {
        if (cur < ans)
            ans = cur;
        return;
    }
    for (int i = dep + 1; i <= n; i++) {
        ll sg = sum[i] - sum[dep];
        if (sg >= pre)
            dfs(i, sg, cur + sg * sg);
    }
}
int main () {
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
    read(n), read(type);
    if (!type) {
        for (int i = 1; i <= n; i++) {
            read(a[i]);
            sum[i] = sum[i - 1] + a[i];
        }
    }
    dfs(0, 0, 0);
    printf("%lld\n", ans);
}