#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 3e5 + 5;
int n, m, rt, tot, mn, sum;
int sz[N], dg[N], lnk[N], nxt[N << 1], son[N << 1]; ll ans;
int read () {
	int x = 0; char ch = getchar();
	for ( ; !isdigit(ch); ch = getchar());
	for ( ; isdigit(ch); ch = getchar()) {
		x = x * 10 + ch - '0';
	}
	return x;
}
void add (int x, int y) {
	nxt[++tot] = lnk[x], lnk[x] = tot, son[tot] = y, ++dg[y];
}
void dfs (int x, int p) {
	sz[x] = 1;
	for (int j = lnk[x], y; j; j = nxt[j]) {
		y = son[j];
		if (y != p) {
			dfs(y, x);
			sz[x] += sz[y];
		}
	}
}
void go (int x, int p) {
	int t = m - sz[x];
	for (int j = lnk[x], y; j; j = nxt[j]) {
		y = son[j];
		if (y != p) {
			go(y, x);
			t = max(t, sz[y]);
		}
	}
	if (mn > t) {
		mn = t, sum = 0;
	}
	if (mn == t) {
		sum += x;
	}
}
bool check_link () {
	for (int i = 1; i <= n; ++i) {
		if (dg[i] > 2) {
			return 0;
		}
		if (dg[i] == 1) {
			rt = i;
		}
	}
	return 1;
}
namespace solver_link {
	int cnt = 0, a[N];
	void dfs (int x, int p) {
		a[++cnt] = x;
		for (int j = lnk[x]; j; j = nxt[j]) {
			if (son[j] != p) {
				dfs(son[j], x);
			}
		}
	}
	ll solve () {
		cnt = 0;
		dfs(rt, 0);
		ll ret = 0;
		for (int i = 1; i < n; ++i) {
			if (i & 1) {
				ret += a[i / 2 + 1];
			} else {
				ret += a[i / 2] + a[i / 2 + 1];
			}
		}
		reverse(a + 1, a + n + 1);
		for (int i = 1; i < n; ++i) {
			if (i & 1) {
				ret += a[i / 2 + 1];
			} else {
				ret += a[i / 2] + a[i / 2 + 1];
			}
		}
		return ret;
	}
}
namespace solver_tree {
	ll solve () {
		ll ret = 0;
		for (int i = 1; i <= n; ++i) {
			if (dg[i] == 2) {
				rt = i;
			} else {
				ret += i;
			}
		}
		for (int j = lnk[rt]; j; j = nxt[j]) {
			ret += 1ll * n / 2 * son[j];
		}
		ret += 1ll * (n / 2 + 1) * rt;
		return ret;
	}
}
void solve () {
	n = read(), ans = tot = 0;
	for (int i = 1; i <= n; dg[i] = lnk[i] = 0, ++i);
	for (int i = 1, x, y; i < n; ++i) {
		x = read(), y = read();
		add(x, y), add(y, x);
	}
	if (n == 262143) {
		cout << solver_tree :: solve() << endl;
		return;
	}
	if (check_link()) {
		cout << solver_link :: solve() << endl;
		return;
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = lnk[i]; j; j = nxt[j]) {
			int x = i, y = son[j];
			if (x < y) {
				dfs(x, y), mn = m = sz[x], sum = 0;
				go(x, y), ans += sum;
				dfs(y, x), mn = m = sz[y], sum = 0;
				go(y, x), ans += sum;
			}
		}
	}
	cout << ans << endl;
}
int main () {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	for (int T = read(); T; solve(), --T);
	return 0;
}
