#include <bits/stdc++.h>

const int N = 300005;
typedef long long LL;

int n, head[N], tot, size[N], l[N], r[N];
struct edge { int to, nxt; } e[N << 1];

void link(int x, int y) {
	e[++tot] = (edge) { y, head[x] }, head[x] = tot;
	e[++tot] = (edge) { x, head[y] }, head[y] = tot;
}
int min, sum, nown;
int getroot(int x, int f = 0) {
	int max = 0; size[x] = 1;
	for (int i = head[x]; i; i = e[i].nxt) if (e[i].to != f) {
		size[x] += getroot(e[i].to, x);
		max = std::max(max, size[e[i].to]);
	}
	max = std::max(max, nown - size[x]);
	if (max * 2 <= nown) sum += x;
	return size[x];
}

void baoli() {
	LL ans = 0;
	for (int i = 1; i < n; ++i) {
		getroot(l[i], r[i]), getroot(r[i], l[i]);
		min = 0x3f3f3f3f, sum = 0, nown = size[l[i]], getroot(l[i], r[i]);
		ans += sum;
		min = 0x3f3f3f3f, sum = 0, nown = size[r[i]], getroot(r[i], l[i]);
		ans += sum;
	}
	std::cout << ans << '\n';
}
int p[N], idx;
void dfs0(int x, int f = 0) {
	p[++idx] = x;
	for (int i = head[x]; i; i = e[i].nxt)
		if (e[i].to != f) dfs0(e[i].to, x);
}
int solve_chain(int l, int r) {
	if (l + r & 1)
		return p[l + r >> 1] + p[l + r + 1 >> 1];
	else
		return p[l + r >> 1];
}
void solve_chain() {
	int point = 0; idx = 0; LL ans = 0;
	for (int i = 1; i <= n; ++i)
		if (!e[head[i]].nxt) point = i;
	dfs0(point);
	for (int i = 1; i < n; ++i)
		ans += solve_chain(1, i) + solve_chain(i + 1, n);
	std::cout << ans << '\n';
}
void solve_binary_tree() {
	int top, down = 0;
	sum = 0, nown = n, min = 0x3f3f3f3f, getroot(1), top = sum;
	for (int i = head[top]; i; i = e[i].nxt) down += e[i].to;
	std::cout << (LL) top * (n - 1) / 2 + (LL) down * (n - 1) / 2 + (LL) n * (n + 1) / 2 << '\n';
}
void solve() {
	std::cin >> n, tot = 0;
	for (int i = 1; i <= n; ++i) head[i] = 0;
	for (int i = 1; i < n; ++i)
		std::cin >> l[i] >> r[i], link(l[i], r[i]);
	if (n % 10 == 1) solve_chain();
	else if (n % 10 == 3) solve_binary_tree();
	else baoli();
}
int main() {
	std::freopen("centroid.in", "r", stdin), std::freopen("centroid.out", "w", stdout);
	std::ios::sync_with_stdio(0), std::cin.tie(0);
	int tc; std::cin >> tc;
	while (tc--) solve();
	return 0;
}
