#include <bits/stdc++.h>

const int N = 105, M = 2005, mod = 998244353;
typedef long long LL;

int n, m, a[N][M], s[N], ans;

void reduce(int &x) { x += x >> 31 & mod; }

void solve0() {
	ans = 1;
	for (int i = 1; i <= n; ++i)
		ans = (LL) ans * (s[i] + 1) % mod;
	reduce(--ans);
}
void solve1() {
	static LL dp[N][N + N];
	for (int t = 1; t <= m; ++t) {
		std::memset(dp, 0, sizeof dp);
		dp[0][n] = 1;
		for (int i = 0; i < n; ++i) {
			int A = a[i + 1][t], B = s[i + 1] - A; reduce(B);
			for (int j = n - i; j <= n + i; ++j) {
				dp[i + 1][j] += dp[i][j];
				dp[i + 1][j + 1] += A * dp[i][j];
				dp[i + 1][j - 1] += B * dp[i][j];
			}
			for (int j = n - i - 1; j <= n + i + 1; ++j) dp[i + 1][j] %= mod;
		}
		for (int i = n + 1; i <= n + n; ++i) reduce(ans -= dp[n][i]);
	}
}

int main() {
	std::freopen("meal.in", "r", stdin), std::freopen("meal.out", "w", stdout);
	std::ios::sync_with_stdio(0), std::cin.tie(0);
	std::cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			std::cin >> a[i][j], reduce(s[i] += a[i][j] - mod);
	solve0(), solve1();
	std::cout << ans << '\n';
	return 0;
}
