#include <bits/stdc++.h>
#define MOD 998244353
using namespace std;
const int N=300000;
int t,h[N],tot,d[N],st,ed,maxd,s[N],m,sum,p,siz[N],maxn[N];
bool flag=false,used[N];
long long n,ans;

struct edge{
	int t,nex;
};
edge e[N<<1];

long long rd(){
	long long cnt=0;
	char ch=getchar();
	while(ch<'0' || ch>'9') ch=getchar();
	while('0'<=ch && ch<='9'){
		cnt=cnt*10+ch-'0';
		ch=getchar();
	}
	return cnt;
}

void add(int x,int y){
	e[++tot].t=y;
	e[tot].nex=h[x];
	h[x]=tot;
}

void dfs1(int x,int las,int dep){
	d[x]=dep;
	if(d[x]>maxd){
		maxd=d[x];
		st=x;
	}
	for(int i=h[x];i;i=e[i].nex)
		if(e[i].t!=las)
			dfs1(e[i].t,x,dep+1);
}

void dfs2(int x,int las,int dep,int y){
	d[x]=dep;
	if(d[x]>maxd){
		maxd=d[x];
		ed=x;
	}
	for(int i=h[x];i;i=e[i].nex)
		if(e[i].t!=las && e[i].t!=y)
			dfs2(e[i].t,x,dep+1,y);
}

void dfs3(int x){
	if(x==ed){
		flag=true;
		return ;
	}
	for(int i=h[x];i;i=e[i].nex)
		if(d[e[i].t]>d[x]){
			if(flag) return ;
			s[++m]=e[i].t;
			dfs3(e[i].t);
			if(flag) return ;
			--m;
		}
}

void query(int x,int last){
	siz[x]=1;
	for(int i=h[x];i;i=e[i].nex)
		if(e[i].t!=last && !used[e[i].t]){
			query(e[i].t,last);
			siz[x]+=siz[e[i].t];
		}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	t=rd();
	while(t--){
		bool flagA=true;
		ans=tot=0;
		memset(h,0,sizeof(h));
		n=rd();
		for(int i=1;i<n;++i){
			int u=rd(),v=rd();
			if(min(u,v)+1!=max(u,v)) flagA=false;
			add(u,v);
			add(v,u);
		}
		if(flagA){
			ans=18*n*n+5*n-32;
			ans>>=3;
			printf("%lld\n",ans);
		}
		else{
			for(int i=1;i<=tot;i+=2){
				memset(siz,0,sizeof(siz));
				memset(maxn,0,sizeof(maxn));
				memset(used,false,sizeof(used));
				p=sum=flag=m=st=ed=maxd=0;
				dfs1(e[i].t,e[i+1].t,1);
				maxd=0;
				dfs2(st,0,1,e[i+1].t);
				s[++m]=st;
				dfs3(st);
				for(int j=1;j<=m;++j) used[s[j]]=true;
				for(int j=1;j<=m;++j){
					query(s[j],e[i+1].t);
					for(int i=h[s[j]];i;i=e[i].nex)
						if(!used[e[i].t] && e[i].t!=e[i+1].t)
							maxn[s[j]]=max(maxn[s[j]],siz[e[i].t]);
					sum+=siz[s[j]];
				}
				for(int j=1;j<=m;++j){
					if(p<=(sum>>1) && (sum-p-siz[s[j]])<=(sum>>1) && maxn[s[j]]<=(sum>>1)) ans+=s[j];
					p+=siz[s[j]];
				}
				p=sum=flag=m=st=ed=maxd=0;
				dfs1(e[i+1].t,e[i].t,1);
				maxd=0;
				dfs2(st,0,1,e[i].t);
				s[++m]=st;
				dfs3(st);
				for(int j=1;j<=m;++j) used[s[j]]=true;
				for(int j=1;j<=m;++j){
					query(s[j],e[i].t);
					for(int i=h[s[j]];i;i=e[i].nex)
						if(!used[e[i].t] && e[i].t!=e[i+1].t)
							maxn[s[j]]=max(maxn[s[j]],siz[e[i].t]);
					sum+=siz[s[j]];
				}
				for(int j=1;j<=m;++j){
					if(p<=(sum>>1) && (sum-p-siz[s[j]])<=(sum>>1) && maxn[s[j]]<=(sum>>1)) ans+=s[j];
					p+=siz[s[j]];
				}
			}
			printf("%lld\n",ans);
		}
	}
}
