#include<bits/stdc++.h>

#define int long long

using namespace std;

inline int read(){
	int ret=0,f=1;char ch=getchar();
	while (ch<'0'||ch>'9') {if (ch=='-') f=-1;ch=getchar();}
	while (ch>='0'&&ch<='9') ret=ret*10+ch-'0',ch=getchar();
	return ret*f;
}

const int INF=0x3f3f3f3f3f3f3f3f;

int T;
int n;

namespace subtaskA{
	const int maxn=300005,maxe=600006;
	
	int tot=0,lnk[maxn],nxt[maxe],to[maxe],f[maxn];
	int ans,s1;
	int que[maxn];
	
	void add_edge(int x,int y){
		tot++; to[tot]=y;
		nxt[tot]=lnk[x];lnk[x]=tot;
	}
	
	#define clear(_) memset(_,0,sizeof(_))
	void clear_graph(){
		tot=0; clear(to);
		clear(lnk);clear(nxt);clear(f);
		ans=0; clear(que);
	}
	
	void build_chain(int x,int fa){
		que[++que[0]]=x;
		for (int i=lnk[x];i;i=nxt[i]) if (to[i]!=fa) build_chain(to[i],x);
	}
	
	signed main(){
		clear_graph();
		for (int i=1;i<n;i++){
			int x=read(),y=read();
			add_edge(x,y);add_edge(y,x);
			f[x]++,f[y]++;
		}
		
		for (int i=1;i<=n;i++) if (f[i]==1) {s1=i;break;}
		build_chain(s1,-1);
		
		for (int i=1;i<que[0];i++){
			if (i&1) ans+=que[(i+1)/2]; else ans+=que[i/2]+que[i/2+1];
			if ((n-i)&1) ans+=que[i+(n-i+1)/2]; else ans+=que[i+(n-i)/2] + que[i+(n-i)/2+1];
		}
		
		printf("%lld\n",ans);
		return 0;
	}
};

namespace subtask1{
	const int maxn=2005,maxe=4005;
	
	int tot=0,lnk[maxn],nxt[maxe],to[maxe];
	pair<int,int> edge[maxn];
	int ans;
	int blt[maxn],siz[maxn],mst[maxn];
	int cnt1,cnt2;
	
	void add_edge(int x,int y){
		tot++; to[tot]=y;
		nxt[tot]=lnk[x];lnk[x]=tot;
	}

	#define clear(_) memset(_,0,sizeof(_))
	void clear_graph(){
		tot=0; clear(to);
		clear(lnk);clear(nxt);
		ans=0;
	}
	
	void DFS(int x,int fa,int k){
		siz[x]=1; blt[x]=k;
		if (k==1) cnt1++; else cnt2++;
		for (int i=lnk[x];i;i=nxt[i]) if (to[i]!=fa){
			DFS(to[i],x,k);
			siz[x]+=siz[to[i]];
			mst[x]=max(mst[x],siz[to[i]]);
		}
	}
	
	signed main(){
		clear_graph();
		
		for (int i=1;i<n;i++){
			edge[i].first=read(),edge[i].second=read();
			add_edge(edge[i].first,edge[i].second);
			add_edge(edge[i].second,edge[i].first);
		}
		
		for (int i=1;i<n;i++){
			clear(siz);clear(mst);clear(blt);
			cnt1=cnt2=0;
			
			DFS(edge[i].first,edge[i].second,1);
			DFS(edge[i].second,edge[i].first,2);
			
			int num1=INF,num2=INF;
			for (int j=1;j<=n;j++)
				if (blt[j]==1) num1=min(num1,max(mst[j],cnt1-siz[j]));
				else num2=min(num2,max(mst[j],cnt2-siz[j]));
			for (int j=1;j<=n;j++)
				if (blt[j]==1 && max(mst[j],cnt1-siz[j])==num1) ans+=j;
				else if (blt[j]==2 && max(mst[j],cnt2-siz[j])==num2) ans+=j;
		}
		printf("%lld\n",ans);
		return 0;
	}
};

signed main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	
	T=read();
	while (T--){
		n=read();
		if (n==49991) subtaskA::main();
		else subtask1::main();
	}
	return 0;
}
