#include <bits/stdc++.h>
#define rep(i, x, y) for (int i = x; i <= y; i++)
using namespace std;

const int N = 3e5 + 10;
typedef long long ll;
int T, n, siz[N], sz[N], ecnt;
int to[N << 1], nxt[N << 1], lnk[N], cnt, mark[N << 1];
ll sum, ans;
struct edge { int x, y; }e[N];

void add(int x, int y) {
	to[++cnt] = y, nxt[cnt] = lnk[x], lnk[x] = cnt;
	mark[cnt] = 1;
}

void solve(int x, int fa, int k) {
	sz[x] = 1;
	bool ff = 1;
	for (int i = lnk[x]; i; i = nxt[i]) {
		int y = to[i];
		if (!mark[i] || y == fa) continue;
		solve(y, x, k);
		if (sz[y] > k / 2) ff = 0;
		sz[x] += sz[y];
	}
	if ((k - sz[x]) > k / 2) ff = 0;
	if (ff) {
		sum += x;
	}
}

void dfs(int x, int fa) {
	siz[x] = 1;
	for (int i = lnk[x]; i; i = nxt[i]) {
		int y = to[i];
		if (y == fa) continue;
		dfs(y, x);
		siz[x] += siz[y];
		if (mark[i]) {
			mark[i] = mark[i ^ 1] = 0;
			sum = 0;
			solve(x, y, n - siz[y]);
			solve(y, x, siz[y]);
			ans += sum;
			mark[i] = mark[i ^ 1] = 1;
		}
	}
}

void solve() {
	dfs(1, 0);
	printf("%lld\n", ans);
}

bool chk() {
	rep(i, 1, ecnt) if (e[i].x + 1 != e[i].y) return 0;
	return 1;
}
void solve_chain() {
	rep(i, 1, n - 1) {
		if (i & 1) ans += (i + 1) / 2;
		else ans += (i / 2) + (i / 2 + 1);
		if ((n - i) & 1) ans += (n - i + 1) / 2 + i;
		else ans += (n - i) / 2 + i + (n - i) / 2 + 1 + i;
	} printf("%lld\n", ans);
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	cin >> T;
	while (T--) {
		cnt = 1;
		ans = 0;
		cin >> n;
		rep(i, 1, n) lnk[i] = 0;
		ecnt = 0;
		rep(i, 1, n - 1) {
			int x, y; scanf("%d%d", &x, &y);
			add(x, y), add(y, x);
			if (x > y) swap(x, y); e[++ecnt] = (edge){x, y};
		}
		if (n <= 2000) { solve(); continue; }
		if (chk()) { solve_chain(); continue; }
	}
	return 0;
}
