#include <bits/stdc++.h>
#define R register
#define rint R int
#define rchar R char
#define rT R T
#define fileread(a) freopen(a".in", "r", stdin), freopen(a".out", "w", stdout)
using namespace std;

template < class T >
inline T read()
{
	rT x = 0;rint op = 1;rchar ch;
	for (ch = getchar(); !isdigit(ch); ch = getchar()) op = ch=='-'?-1:op;
	for ( ; isdigit(ch); ch = getchar()) x = (x<<3)+(x<<1)+ch-'0';
	return op*x;
}

template < class T >
inline void read(T &x) {x = read<T>();return;}

template < class T >
inline void write(T x) {if (x < 0) putchar('-'), x = -x; if (x>9) write(x/10); putchar(x%10+'0');}

template < class T >
inline void print(T x, char _) {write(x), putchar(_);}

#define int long long
int n;
#define MAXN 300000
vector < int > e[MAXN];

namespace Subtask1
{
	bool check_()
	{
		for (rint i = 1; i <= n; i ++)
		{
			if (e[i].size() > 2) return 0;
			for (rint j = 0; j <  e[i].size(); j ++)
				if (abs(e[i][j]-i) > 1)
					return 0;
		}
		return 1;
	}
	
	void solve()
	{
		rint ans = 0;
		for (rint i = 1; i <= n; i ++) ans += 2*i;
		print(ans, '\n');
	}
}

namespace Subtask2
{
	bool check_()
	{
		for (rint i = 1; i <= (n-1)/2; i ++)
		{
			if (e[i].size()>3) return 0;
			for (rint j = 0; j < e[i].size(); j ++)
				if (abs(e[i][j]-i*2) > 1 && e[i][j] > i) return 0;
		}
		return 1;
	}
	
	inline int qpow(int a, int b)
	{
		rint res = 1;
		for (rint aa = a; b; b >>= 1, aa *= aa) if (b&1) res *= aa;
		return res;
	}
	
	void solve()
	{
		rint ans = 0;
		if (n == 3) return puts("12"), (void)0;
		for (rint dep = 0; dep < log2(n+1); dep ++)
			for (rint i = qpow(2, dep); i < qpow(2, dep+1); i ++)
				ans += i*(qpow(2, log2(n+1)-dep)-2),print(i, ' '), print(ans, '\n');
		for (rint i = qpow(2, log2(n+1)-1); i <= n; i ++)
			ans += i;
		print(ans, '\n');
	}
}

signed main()
{
	fileread("centroid");
	rint T = read<int>();
	while (T --)
	{
		read(n);
		for (rint i = 1; i <= n; i ++) e[i].clear();
		for (rint i = 1, a, b; i < n; i ++)
			read(a), read(b), e[a].push_back(b), e[b].push_back(a);
		if (Subtask1::check_()) Subtask1::solve();
		else if (Subtask2::check_()) Subtask2::solve();
	}
	return 0;
}

