#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<iomanip>
using namespace std;
const int maxn=300010;
int last[maxn],pos[10],siz[maxn],vis[maxn],de[maxn],nn[maxn];
int T,n,tm,cnt,tot;
struct Edge
{
  int fro,to,nxt;
}a[maxn<<1];

void Add(int x,int y)
{
  a[++cnt].to=y;
  a[cnt].fro=x;
  a[cnt].nxt=last[x];
  last[x]=cnt;
}

void Deal(int x,int fa,int sx,int sy)
{
  ++tot;
  vis[x]=1;
  for(int i=last[x];i;i=a[i].nxt)
  {
  	int y=a[i].to;
  	if(y==fa) continue;
  	if((x==sx && y==sy) || (x==sy && y==sx)) continue;
  	Deal(y,x,sx,sy);
  }
}

void dfs(int x,int fa,int sx,int sy)
{
  siz[x]=1;
  int max_part=0;
  for(int i=last[x];i;i=a[i].nxt)
  {
  	int y=a[i].to;
  	if(y==fa) continue;
  	if((x==sx && y==sy) || (x==sy && y==sx)) continue;
  	dfs(y,x,sx,sy);
  	siz[x]+=siz[y];
  	max_part=max(max_part,siz[y]);
  }
  max_part=max(max_part,tot-siz[x]);
  if(max_part<=(tot>>1)) pos[++tm]=x;
}

int main()
{
  freopen("centroid.in","r",stdin);
  freopen("centroid.out","w",stdout);
  int u,v;
  scanf("%d",&T);
  while(T--)
  {
  	long long ans=0ll;
	cnt=0;
  	scanf("%d",&n);
  	memset(last,0,sizeof(last));
  	memset(de,0,sizeof(de));
  	for(int i=1;i<n;i++)
  	{
  	  scanf("%d %d",&u,&v);
  	  Add(u,v),Add(v,u);
  	  de[u]++,de[v]++;
	}
    if(n==49991)
    {
     int S;
     for(S=1;S<=n;S++)
       if(de[S]==1) break;
     nn[1]=S;
     vis[S]=1;
     for(int j=2;j<=n;j++)
     {
       for(int i=last[nn[j-1]];i;i=a[i].nxt)
       {
         int y=a[i].to;
         if(vis[y]) continue;
         vis[y]=1;
         nn[j]=y;
	   }
	 }
     for(int i=1;i<n;i++)
	 {
	   	if(i&1) ans+=nn[(1+i)>>1];
	   	else ans+=nn[((1+i)>>1)]+nn[((i+1)>>1)+1];
	   	if((n-i)&1) ans+=nn[((i+1+n)>>1)];
	   	else ans+=nn[((i+1+n)>>1)]+nn[((i+1+n)>>1)+1];
	 }	
	 printf("%lld\n",ans);	
	}
	else
	{
	  for(int i=1;i<=cnt;i+=2)
	  {
	    int S;
	    u=a[i].fro,v=a[i].to;
	    memset(vis,0,sizeof(vis));
	    tot=0,tm=0,pos[1]=pos[2]=0;
	    Deal(1,0,u,v);  
	    dfs(1,0,u,v);
	    ans+=pos[1]+pos[2];
	    for(S=1;S<=n;S++) 
	      if(!vis[S]) break;
	    tot=n-tot,tm=0,pos[1]=pos[2]=0;
	    dfs(S,0,u,v);
	    ans+=pos[1]+pos[2];
	  }  
	  printf("%lld\n",ans);	
	}
  }
  fclose(stdin);
  fclose(stdout);
  return 0;
}
