#include<cstdio>
#include<algorithm>
#define ll long long
using namespace std;

const int maxn = 5e5 + 5;
int n, ty, a[maxn], len;
ll res[maxn], ans, suf[maxn];

int read(void) {
	char c; while (c = getchar(), c < '0' || c > '9'); int x = c - '0';
	while (c = getchar(), c >= '0' && c <= '9') x = x * 10 + c - '0'; return x;
}

void dfs(int dep, int k, int las, ll tot) {
	if (dep > n) {
	  ans = min(ans, tot);
	  return;
	}
	if (suf[dep] + las < k) return;
	if (tot > ans) return;
	if (dep == n) {
	  if (las + a[dep] < k) return;
	  if (las + a[dep] >= k) {
	  	tot += (las + a[dep]) * (las + a[dep]);
	  	dfs(dep + 1, las + a[dep], 0, tot);
	  	tot -= (las + a[dep]) * (las + a[dep]);
	  }
	  if (las >= k && a[dep] >= las) {
	  	tot += las * las; tot += a[dep] * a[dep];
	  	dfs(dep + 1, a[dep], 0, tot);
	  	tot -= las * las; tot -= a[dep] * a[dep];
	  }
	} 
	else {
	  for (int i = dep; i <= n; ++ i) {
	    if (las + a[dep] >= k) {
	  	  tot += (las + a[dep]) * (las + a[dep]);
	  	  dfs(dep + 1, las + a[dep], 0, tot);
	  	  tot -= (las + a[dep]) * (las + a[dep]);
	    }
	    dfs(dep + 1, k, las + a[dep], tot);
	  }
	}
}

int main() {
	freopen("partition.in", "r", stdin); freopen("partition.out", "w", stdout);
	n = read(); ty = read();
	  for (int i = 1; i <= n; ++ i) a[i] = read();
	  for (int i = n; i >= 1; -- i) suf[i] = suf[i + 1] + a[i];
	ans = 1e18;
	dfs(1, 0, 0, 0);
	printf("%lld", ans);
	return 0;
}
