/*
**   GOODBYE, OI.
**         --THE_UNBEATABLE
*/
#include <bits/stdc++.h>
using namespace std;

const int N = 3e5 + 50;

int n;

struct edge {
  int nxt, to;
} e[N << 1];
int fir[N], cnt, tot, sz[N];
long long ans = 0;
int u[N], v[N];

inline void addedge(int x, int y) {
  e[++ cnt] = (edge) { fir[x], y };
  fir[x] = cnt;
}

inline void Dfs(int x, int f) {
  sz[x] = 1;
  for (int i = fir[x]; i; i = e[i].nxt)
    if (e[i].to != f) {
      Dfs(e[i].to, x); sz[x] += sz[e[i].to];
    }
}

inline void Sfd(int x, int f) {
  bool ok = (tot - sz[x] <= tot / 2);
  for (int i = fir[x]; i; i = e[i].nxt)
    if (e[i].to != f) {
      ok = ok && sz[e[i].to] <= tot / 2;
      Sfd(e[i].to, x);
    }
  if (ok) ans += x;
}

inline void calc(int x, int f) {
  Dfs(x, f);
  tot = sz[x];
  Sfd(x, f);
}

inline void solve() {
  for(int i = 1; i < n; i ++) {
    calc(u[i], v[i]); calc(v[i], u[i]);
  }
}

int deg[N];
inline int line() {
  memset(deg, 0, sizeof deg);
  for (int i = 1; i < n; i ++) {
    deg[u[i]] ++; deg[v[i]] ++;
    if (deg[u[i]] > 2 || deg[v[i]] > 2) return 0;
  }
  for (int i = 1; i <= n; i ++)
    if (deg[i] == 1) return i;
  return 0;
}
inline int XiJin() {
  memset(deg, 0, sizeof deg);
  for (int i = 1; i < n; i ++) {
    deg[u[i]] ++; deg[v[i]] ++;
  }
  for (int i = 1; i <= n; i ++)
    if (deg[i] == 2) return i;
  return 0;
}

int sta[N];

inline void makeout(int x) {
  sta[1] = x;
  for (int i = 1; i < n; i ++) {
    for (int j = fir[sta[i]]; j; j = e[j].nxt)
      if (sta[i - 1] != e[j].to) {
	sta[i + 1] = e[j].to;
	break;
      }
  }
}

inline void JinSaiSanNian() {
  makeout(line());
  for (int i = 1; i < n; i ++) {
    if (i & 1) ans += sta[(i + 1) >> 1];
    else ans += sta[i >> 1] + sta[(i >> 1) + 1];
  }
  reverse(sta + 1, sta + n + 1);
  for (int i = 1; i < n; i ++) {
    if (i & 1) ans += sta[(i + 1) >> 1];
    else ans += sta[i >> 1] + sta[(i >> 1) + 1];
  }
}

inline void YouHeFang() {
  int rt = XiJin(), l, r;
  l = e[fir[rt]].to;
  r = e[e[fir[rt]].nxt].to;
  ans = 1ll * n * (n + 1) / 2 - rt;
  ans += 1ll * (n - 1) * (l + r) / 2;
  ans += 1ll * ( (n + 1) / 2 ) * rt;
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  int T;
  scanf("%d", &T);
  for (; T; T --) {
    cnt = 0; ans = 0;
    memset(fir, 0, sizeof fir);
    scanf("%d", &n);
    for (int i = 1, x, y; i < n; i ++) {
      scanf("%d%d", &x, &y);
      addedge(x, y); addedge(y, x);
      u[i] = x; v[i] = y;
    }
    if (n <= 2000) solve();
    else if (line()) JinSaiSanNian();
    else YouHeFang();
    printf("%lld\n", ans);
  }
  return 0;
}
