#include<cstdio>
#include<algorithm>
using namespace std;
#define rep(i,j,k) for(int i=j;i<=k;i++)
typedef long long ll;
typedef unsigned long long ulx;
int gin(){
	int ret=0;bool fg=0;char ch=getchar();
	while(ch<'0'||ch>'9') fg|=(ch=='-'),ch=getchar();
	ret=ch-'0';ch=getchar();
	while(ch<='9'&&ch>='0') ret=ret*10+ch-'0',ch=getchar();
	if(fg) ret=-1*ret;
	return ret;
}
ll gll(){
	ll ret=0;bool fg=0;char ch=getchar();
	while(ch<'0'||ch>'9') fg|=(ch=='-'),ch=getchar();
	ret=ch-'0';ch=getchar();
	while(ch<='9'&&ch>='0') ret=ret*10ll+ch-'0',ch=getchar();
	if(fg) ret=-1ll*ret;
	return ret;
}

#define maxn 300010

struct edge{
	int v,nxt;
}e[maxn<<1];
int head[maxn],tot;

void add(int u,int v){
	e[++tot].v=v;e[tot].nxt=head[u];head[u]=tot;return ;
}

bool vis[maxn];
int siz[maxn];
int all;
int sg[maxn];
ll ans;

int tim,n;

void getroot(int x,int fa){
	vis[x]=tim;
	siz[x]=1;
	int mxs=0;
	for(int vx,i=head[x];i;i=e[i].nxt){
		vx=e[i].v;
		if(vx==fa) continue;
		getroot(vx,x);
		siz[x]+=siz[vx];
		if(siz[vx]>mxs) mxs=siz[vx];
	}
	mxs=max(mxs,all-siz[x]);
	if(mxs*2<=all) ans+=x;
	return ;
}

void init(){
	rep(i,1,n) head[i]=0;
	tot=0;ans=0;
	return ;
}

void dfs(int x,int fa){
	if(fa){
		vis[x]=++tim;
		all=n-sg[x];
		getroot(fa,x);
		vis[fa]=++tim;
		all=sg[x];
		getroot(x,fa);
	}
	for(int vx,i=head[x];i;i=e[i].nxt){
		vx=e[i].v;
		if(vx==fa) continue;
		dfs(vx,x);
	}
	return ;
}

void dfs_pre(int x,int fa){
	sg[x]=1;
	for(int vx,i=head[x];i;i=e[i].nxt){
		vx=e[i].v;
		if(vx==fa) continue;
		dfs_pre(vx,x);
		sg[x]+=sg[vx];
	}
	return ;
}

int deg[maxn];

namespace subtask2{
	int cct=0,lx[maxn];
	void dfsx(int x,int fa){
		lx[++cct]=x;
		for(int vx,i=head[x];i;i=e[i].nxt){
			vx=e[i].v;
			if(vx==fa) continue;
			dfsx(vx,x);
		}
		return ;
	}
	void MAIN(){
		int rt=0;
		int ax=0;
		rep(i,1,n) if(deg[i]==1) {rt=i;break;}
		dfsx(rt,0);
		rep(i,1,n-1){
			int lim=i/2;
			if(i%2==1)ax+=lx[lim+1];
			else ax+=lx[lim]+lx[lim+1];
			int bt=(n-i);lim=bt/2;
			if(bt%2==1)ax+=lx[i+lim+1];
			else ax+=lx[i+lim]+lx[i+lim+1];
		}
		printf("%d\n",ax);
		return ;
	}
}

void solve(){
	n=gin();
	init();
	bool kg=1;
	rep(i,2,n) {
		int a=gin(),b=gin();
		add(a,b);
		add(b,a);
		deg[a]++;
		deg[b]++;
		if(deg[a]>2||deg[b]>2) kg=0;
	}
	if(kg){
		subtask2::MAIN();
	}else {
		dfs_pre(1,0);
		dfs(1,0);
		printf("%d\n",ans);
	}
	return ;
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	T=gin();
	while(T--) solve();
}
