#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define ll long long

using namespace std;

const int maxn = 5e4 + 7;
int test, n, head[maxn], cnt;

struct edge {
	int nxt, to;
} e[maxn << 1];

void add(int x, int y) {
	e[++cnt] = (edge) {head[x], y};
	head[x] = cnt;
}


int du[maxn], poi[maxn];
ll ans;

void init() {
	memset(head, 0, sizeof(head));
	memset(du, 0, sizeof(du));
	memset(poi, 0, sizeof(poi));
	cnt = 0;
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &test);
	while (test--) {
		ans = 0;
		scanf("%d", &n);
		int u, v;
			for (int i = 1; i < n; i++) {
				scanf("%d%d", &u, &v);
				add(u, v);
				add(v, u);
				du[u]++;
			    du[v]++;
			}
			int x;
			for (int i = 1; i <= n; i++) {
				if (du[i] == 1) {
					x = i;
					break;
				}
			}
			int fa = x, tot = 1;
			poi[1] = x;
			for (int i = 1; i < n; i++) {
				for (int j = head[x]; j; j = e[j].to) {
					if (e[j].to != fa) {
						fa = x;
						x = e[j].to;
						tot++;
						poi[tot] = x;
						break;
					}
				}
			}
			for (int i = 1; i < n; i++) {
				if (i & 1) ans += poi[(i >> 1) + 1];
				else ans += (poi[i >> 1] + poi[(i >> 1) + 1]);
				if ((n - i) & 1) ans += poi[i + (n - i + 1) / 2];
				else ans += (poi[i + (n - i) / 2] + poi[i + (n - i) / 2 + 1]);
			}
			printf("%lld\n", ans);
	}
	return 0;
}
