#include<bits/stdc++.h>
#include<iostream>
#include<cstdio>
#define ll long long
using namespace std;

const ll N=4010;
ll n,ans,v[N],size[N],x[N],y[N];
ll ver[N<<1],Next[N<<1],head[N],tot;

inline ll read(){
	ll x=0,tmp=1;
	char ch=getchar();
	while(!isdigit(ch)){
		if(ch=='-') tmp=-1;
		ch=getchar();
	}
	while(isdigit(ch)){
		x=(x<<3)+(x<<1)+(ch^48);
		ch=getchar();
	}
	return tmp*x;
}

inline void write(ll x){
	if(x<0){
		putchar('-');
		x=-x;
	}
	ll y=10,len=1;
	while(y<=x){
		y=(y<<3)+(y<<1);
		len++;
	}
	while(len--){
		y/=10;
		putchar(x/y+48);
		x%=y;
	}
}

inline void addEdge(ll x,ll y){
	ver[++tot]=y;
	Next[tot]=head[x];
	head[x]=tot;
}

void dfs(ll x){
	v[x]=1; size[x]=1;
	for(ll i=head[x]; i; i=Next[i]){
		ll y=ver[i];
		if(v[y]) continue;
		dfs(y);
		size[x]+=size[y];
	}
}

void query(ll x,ll before,ll sum){
	bool flag=0;
	for(ll i=head[x]; i; i=Next[i]){
		ll y=ver[i];
		if(y==before) continue;
		query(y,x,sum);
		if(size[y]>sum/2) flag=1;
	}
	if(sum-size[x]>sum/2) flag=1;
	if(!flag) ans+=x;
}

inline void clear(){
	memset(v,0,sizeof(v));
	memset(size,0,sizeof(size));
	memset(ver,0,sizeof(ver));
	memset(Next,0,sizeof(Next));
	memset(head,0,sizeof(head));
	tot=0;
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	for(ll T=read(); T; T--){
		n=read();
		for(ll i=1; i<n; i++){
			x[i]=read();
			y[i]=read();
		}
		ans=0;
		for(ll i=1; i<n; i++){
			clear();
			for(ll j=1; j<n; j++){
				if(i==j) continue;
				addEdge(x[j],y[j]);
				addEdge(y[j],x[j]);
			}
			for(ll j=1; j<=n; j++){
				if(!v[j]){
					dfs(j);
					query(j,0,size[j]);
				}
			}
		}
		write(ans); putchar('\n');
	}
	fclose(stdin); fclose(stdout);
	return 0;
}
