#include<fstream>

using namespace std;

ifstream cin("partition.in");
ofstream cout("partition.out");

int a[40000001], n, type;
typedef unsigned long long ullong;
ullong minn = 1000000000000000000ull;

void dfs(int i, ullong all_sum, ullong last_sum)
{
	if (all_sum >= minn)
	{
		return;
	}
	
	if (i == n)
	{
		minn = min(minn, all_sum);
		return;
	}
	
	ullong tsum = 0;
	
	for (int j = i; j < n; ++j)
	{
		tsum += a[j];
		
		if (tsum >= last_sum)
		{
			dfs(j + 1, all_sum + tsum * tsum, tsum);
		}
	}
}

int main()
{
	cin >> n >> type;
	
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
	}
	
	dfs(0, 0, 0);
	cout << minn << "\n";
	return 0;
}
