#include <bits/stdc++.h>
#define _dlt 100
#define int long long

struct edge
{
	int dst;
	int pre;
	int fbd=false;
};

class graph
{
public:
	graph(int v,int e)
	{
		V=new int[v+_dlt];
		E=new edge[e+_dlt];
		for(int i=0;i<v+_dlt;i++)
			V[i]=0;
	}
	void add(int frm,int dst)
	{
		E[cnt].dst=dst;
		E[cnt].pre=V[frm];
		V[frm]=cnt++;
	}
	int *V;
	edge *E;
	int cnt=1;
};

int rcd;

void clt(graph &tre,int *cnt,int *fth,int frm,int pre)
{
	cnt[frm]=1;
	fth[frm]=pre;
	for(int i=tre.V[frm];i!=0;i=tre.E[i].pre)
		if(tre.E[i].dst!=pre)
		{
			clt(tre,cnt,fth,tre.E[i].dst,frm);
			cnt[frm]+=cnt[tre.E[i].dst];
		}
}

void dp(graph &tre,int *cnt,int frm,int root,int pre)
{
	bool wp=true;
	for(int i=tre.V[frm];i!=0;i=tre.E[i].pre)
	{
		if(tre.E[i].dst==pre||tre.E[i].fbd)
			continue;
		if(cnt[tre.E[i].dst]>cnt[root]/2)
		{
			wp=false;
			break;
		}
	}
	if(cnt[root]-cnt[frm]>cnt[root]/2)
		wp=false;
	if(wp)
		rcd+=frm;
	for(int i=tre.V[frm];i!=0;i=tre.E[i].pre)
	{
		if(tre.E[i].dst==pre||tre.E[i].fbd)
			continue;
		dp(tre,cnt,tre.E[i].dst,root,frm);
	}
}

int dfs(graph &tre,int *cnt,int *fth,int frm,int pre)
{
	int tmp,rst=0;
	for(int i=tre.V[frm];i!=0;i=tre.E[i].pre)
		if(tre.E[i].dst!=pre)
		{
			tre.E[i].fbd=true;
			tmp=frm;
			while(tmp!=0)
			{
				cnt[tmp]-=cnt[tre.E[i].dst];
				tmp=fth[tmp];
			}
			rcd=0;
			dp(tre,cnt,1,1,0);
			rst+=rcd;
			rcd=0;
			dp(tre,cnt,tre.E[i].dst,tre.E[i].dst,frm);
			rst+=rcd;
			tmp=frm;
			while(tmp!=0)
			{
				cnt[tmp]+=cnt[tre.E[i].dst];
				tmp=fth[tmp];
			}
			tre.E[i].fbd=false;
		}
	for(int i=tre.V[frm];i!=0;i=tre.E[i].pre)
		if(tre.E[i].dst!=pre)
			rst+=dfs(tre,cnt,fth,tre.E[i].dst,frm);
	return rst;
}

void work()
{
	
	int n,frm,dst;
	std::scanf("%lld",&n);
	int cnt[n+_dlt];
	int fth[n+_dlt];
	graph tre(n,2*n);
	for(int i=1;i<=n-1;i++)
	{
		std::scanf("%lld%lld",&frm,&dst);
		tre.add(frm,dst);
		tre.add(dst,frm);
	}
	clt(tre,cnt,fth,1,0);
	std::printf("%lld\n",dfs(tre,cnt,fth,1,0));
}

signed main()
{
	std::freopen("centroid.in","r",stdin);
	std::freopen("centroid.out","w",stdout);
	int T;
	std::scanf("%lld",&T);
	while(T--)
		work();
	return 0;
}
