#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long

using namespace std;

const int mod = 998244353, N = 123, M = 2345;

ll f[N][N][N], a[N][M];

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	int n, m;
	scanf("%d %d", &n, &m);
	for(int i = 1; i <= n; ++i)	
		for(int j = 1; j <= m; ++j) {
			scanf("%lld", &a[i][j]);
		}
	memset(f, -1, sizeof(f));
	f[0][0][0] = 1;
	ll ans = 0;
	for(int i = 1; i <= n; ++i) {
		int lim = min(i, n / 2);
		for(int j = lim; j > -1; --j) {
			for(int k = lim; k > -1; --k) {
				for(int z = lim; z > -1; --z) {
					if(j + k + z <= i) {
						if(j && a[i][1] && ~f[j-1][k][z]) {
							if(f[j][k][z] == -1) f[j][k][z] = 0;
							f[j][k][z] = (f[j][k][z] + (ll)f[j-1][k][z] * a[i][1]) % mod;
						}
						if(k && a[i][2] && ~f[j][k-1][z]) {
							if(f[j][k][z] == -1) f[j][k][z] = 0;
							f[j][k][z] = (f[j][k][z] + (ll)f[j][k-1][z] * a[i][2]) % mod;
						}
						if(z && a[i][3] && ~f[j][k][z-1]) {
							if(f[j][k][z] == -1) f[j][k][z] = 0;
							f[j][k][z] = (f[j][k][z] + (ll)f[j][k][z-1] * a[i][3]) % mod;
						}
						int tt = j + k + z;
						if(i == n && j <= tt / 2 && k <= tt / 2 && z <= tt / 2 && ~f[j][k][z]) 
							ans = (ans + f[j][k][z]) % mod;
					}
				}
			}
		}
	}
	printf("%lld\n", ans - 1);
	return 0;
}

