/*#include <cstdio>
using namespace std;

#define int long long
#define dd c=getchar()
int read() {int s=0,w=1;char c;while (dd, c>'9'||c<'0') if (c=='-')w=-1;while (c>='0' && c<='9')s=s*10+c-'0', dd;return s*w;}
#undef dd
void write(int x) {if (x<0)putchar('-'),x=-x; if (x>=10) write(x/10); putchar(x%10|'0');}
void wsp(int x) {write(x); putchar(' ');} void wln(int x) {write(x); putchar('\n');}

const int N = 5e5+7;
int n, type;
int a[N], la[N], f[N];
signed main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	n = read(); type = read();
	if (type == 0) {
		for (int i = 1; i <= n; i++) a[i] = read();
	}
	for (int i = 1; i <= n; i++) {
		int l = 1, r = i, j;
		for (int j = i; j; j--) {
			la[i]+=a[j];
			if (la[i] >= la[j-1]) {
				f[i] = f[j-1]+la[i]*la[i];
				break;
			}
		}
	}
	wln(f[n]);
}*/
#include <cstdio>
#include <algorithm>
using namespace std;

#define int long long
#define dd c=getchar()
int read() {int s=0,w=1;char c;while (dd, c>'9'||c<'0') if (c=='-')w=-1;while (c>='0' && c<='9')s=s*10+c-'0', dd;return s*w;}
#undef dd
void write(int x) {if (x<0)putchar('-'),x=-x; if (x>=10) write(x/10); putchar(x%10|'0');}
void wsp(int x) {write(x); putchar(' ');} void wln(int x) {write(x); putchar('\n');}

const int N = 5e5+7;
int n, type;
int a[N], la[N], f[N], s[N], tr[N<<2];

#define ls (ts<<1)
#define rs (ts<<1|1)
void build(int ts, int l, int r) {
	tr[ts] = 4e18;
	if (l == r) return;
	int mid = (l+r)>>1;
	build(ls, l, mid); build(rs, mid+1, r);
}
void insert(int ts, int l, int r, int x, int v) {
	tr[ts] = min(tr[ts], v);
	if (l == r) return;
	int mid = (l+r)>>1;
	if (x <= mid) insert(ls, l, mid, x, v);
	else insert(rs, mid+1, r, x, v);
}
int query(int ts, int l, int r, int L, int R, int v) {
//	printf("%lld %lld %lld %lld %lld\n", l, r, L, R, v);
	if (L > R || tr[ts] > v) return 0;
	if (l == r) return l;
	int mid = (l+r)>>1;
	if (l == L && r == R) {
		if (tr[rs] <= v) return query(rs, mid+1, r, mid+1, R, v);
		else return query(ls, l, mid, L, mid, v);
	}
	if (R <= mid) return query(ls, l, mid, L, R, v);
	else if (L > mid) return query(rs, mid+1, r, L, R, v);
	else return max(query(ls, l, mid, L, mid, v), query(rs, mid+1, r, mid+1, R, v));
}
signed main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	n = read(); type = read();
	if (type == 0) {
		for (int i = 1; i <= n; i++) a[i] = read(), s[i] = s[i-1]+a[i];
	}
	build(1, 1, n);
	for (int i = 1; i <= n; i++) {
		int j = query(1, 1, n, 1, i-1, s[i]);
		la[i] = s[i]-s[j];
		f[i] = f[j]+la[i]*la[i];
		insert(1, 1, n, i, la[i]+s[i]);
	}
	wln(f[n]);
}
