#include<bits/stdc++.h>
using namespace std;
#define FOR(i,x,y) for(int i=(x),i##_END=(y);i<=i##_END;++i)
#define DOR(i,x,y) for(int i=(x),i##_END=(y);i>=i##_END;--i)
#define LL long long
template<const int maxn,const int maxm>struct Link_list{
	int head[maxn],V[maxm],nxt[maxm],tot;
	void clear(){memset(head,tot=0,sizeof head);}
	void add(int a,int b){
		nxt[++tot]=head[a];V[tot]=b;head[a]=tot;
	}
	#define LFOR(i,x,a) for(int i=(a).head[x];i;i=(a).nxt[i])
};
const int M=300005;
Link_list<M,M<<1> E;
int n;
int Cnt[M];

namespace P75{
	void solve(){
		LL tot=1ll*n*(n+1)/2;
		int a=-1;
		FOR(i,1,n){
			if(Cnt[i]==2){
				a=i;
				break;
			}
		}
		LL ans=(tot-a)+1ll*a*(n+1)/2;
		LFOR(i,a,E) {
			ans=ans+1ll*E.V[i]*(n-1)/2;
		}
		printf("%lld\n",ans);
	}
}

namespace P40{
	const int N=2005;
	int ban,col;
	int sz[N],Col[N],mx[N];
	bool vis[N];
	void dfs(int x){
		vis[x]=true;
		Col[x]=col,sz[x]=1,mx[x]=0;
		LFOR(i,x,E){
			int y=E.V[i];
			if(vis[y]||(i+1)/2==ban)continue;
			dfs(y);
			mx[x]=max(mx[x],sz[y]);
			sz[x]+=sz[y];
		}
	}
	void solve(){
		LL ans=0;
		FOR(i,1,E.tot/2){
			ban=i,col=0;
			memset(vis,0,sizeof vis);
			FOR(j,1,n){
				if(vis[j])continue;
				col=j;
				dfs(j);
			}
			FOR(j,1,n){
				int bel=Col[j];
				if(sz[bel]/2>=max(mx[j],sz[bel]-sz[j])){
					ans+=j;
				}
			}
		}
		printf("%lld\n",ans);
	}
}
namespace P55{
	bool vis[M];
	int dep[M];
	LL ans;
	void dfs(int x){
		vis[x]=true;
		LFOR(i,x,E){
			int y=E.V[i];
			if(vis[y])continue;
			dep[y]=dep[x]+1;
			dfs(y);
		}
		if(dep[x]==n/2)ans-=x;
	}
	void solve(){
		memset(vis,0,sizeof vis);
		memset(dep,0,sizeof dep);
		ans=1ll*n*(n+1)/2*3;
		FOR(i,1,n){
			if(Cnt[i]==1){
				dfs(i);
				break;
			}
		}
		FOR(i,1,n)if(Cnt[i]==1)ans-=i;
		printf("%lld\n",ans);
	}
}
/*
2 5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d\n",&T);
	while(T--){
		E.clear();
		memset(Cnt,0,sizeof Cnt);
		
		scanf("%d",&n);
		FOR(i,1,n-1){
			int a,b;
			scanf("%d%d",&a,&b);
			E.add(a,b);E.add(b,a);
			Cnt[a]++,Cnt[b]++;
		}
		
//		P75::solve();
		
		if(n<=2000)P40::solve();
		else if(n==49991)P55::solve();
		else if(n==262143)P75::solve();
	}
	return 0;
}
