#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
#define int ll

int n,m;
const int MAXN = 101;
const int MAXM = 2001;
const int MOD = 998244353;

int cnt[MAXN][MAXM];
int qpow(int a,int b) {
	if(b == 0) return 1;
	int r = qpow(a,b>>1);
	r = r*r%MOD;
	if(b&1) return r*a%MOD;
	return r;
}
int inv[MAXM];
int fact[MAXM];
int fact_inv[MAXM];
int C(int x,int y) {
	if(x < 0 || y < 0) return 0;
	if(y > x) return 0;
	return fact[x] * fact_inv[x-y] % MOD * fact_inv[y] % MOD;
}

namespace Subtask1 {
	void solve() {
		if(m < 2) m = 2;
		int c1 = 0,c2 = 0,c12 = 0;
		for(int i=1;i<=n;i++) {
			if(cnt[i][1]) c1++;
			if(cnt[i][2]) c2++;
			if(cnt[i][1] && cnt[i][2]) c12++;
		}
		
//		cerr<<c1<<' '<<c2<<' '<<c12<<endl;
//		cerr<<qpow(2,0)<<' '<<C(2,0)<<' '<<C(1,1)<<endl;
		
		int ans = 0;
		for(int p1=0;p1<=c1;p1++) {
			for(int p2=0;p2<=c2;p2++) {
				int tot = (p1 + p2) / 2;
				if(p1 > tot || p2 > tot) continue;
				if(p1 + p2 == 0) continue;
//				cerr<<"Calc1 "<<p1<<' '<<p2<<endl;
				for(int i=0;i<=p1;i++) {
					for(int j=0;j<=p2;j++) {
						if(i+j > c12) continue;
//						cerr<<"  Calc2 "<<i<<' '<<j<<endl;
						int val =
							C(i+j,i)
							* C(c12,i+j) % MOD
							* C(c1-c12,p1-i) % MOD
							* C(c2-c12,p2-j) % MOD;
						ans += val;
//						cerr<<"  Calc3 "<<val<<endl;
						ans %= MOD;
					}
				}
			}
		}
		
		printf("%lld\n",ans);
	}
};

signed main() {
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	
	scanf("%lld%lld",&n,&m);
	
	for(int i=1;i<=n;i++){
		for(int j=1;j<=m;j++) {
			scanf("%lld",&cnt[i][j]);
		}
	}
	
	fact[0] = fact[1] = inv[0] = inv[1] = fact_inv[0] = fact_inv[1] = 1;
	for(int i=2;i<=max(n,m);i++) {
		inv[i] = (-(MOD/i) * inv[MOD%i] % MOD + MOD) % MOD;
		fact[i] = fact[i-1] * i % MOD;
		fact_inv[i] = fact_inv[i-1] * inv[i] % MOD;
	}
	
	if(m <= 2 || true) {
		Subtask1::solve();
	}
}

