#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
const int N = 300000 + 5;
int n, t, head[N], cnt = 1, in[N];
inline void ckmax(int &a, int b) {a = max(a, b);}

struct edge {
	int to, nxt;
}e[N << 1];

inline void add(int u, int v) {
	e[++cnt] = (edge) {v, head[u]};
	head[u] = cnt;
}

namespace subtask1 {
	const int maxn = 2000 + 5;
	int cur, siz[maxn], all;
	bool vis[maxn];
	LL ans;
	
	inline void getsize(int u, int pre) {
		siz[u] = 1;
		for(register int i = head[u]; i; i = e[i].nxt) if(i != cur && i != (cur ^ 1) && i != (pre ^ 1)){
			int v = e[i].to;
			getsize(v, i);
			siz[u] += siz[v];
		}
	}
	
	inline void dfs(int u) {
		int maxsize = 0; vis[u] = 1;
 		for(register int i = head[u]; i; i = e[i].nxt) if(i != cur && i != (cur ^ 1)){
			int v = e[i].to;
			if(vis[v]) continue;
			dfs(v);
			ckmax(maxsize, siz[v]);
		}
		ckmax(maxsize, all - siz[u]);
		if(maxsize <= (all / 2)) ans += u;
	}
	
	inline void solve() {
		ans = 0;
		for(int i = 2; i <= 2 * (n - 1); i += 2) {
			cur = i; 
			memset(vis, 0, sizeof(vis));
			for(int u = 1; u <= n; ++u) 
				if(!vis[u]) {
					getsize(u, -1);
					all = siz[u];
					dfs(u);
				}
		}
		printf("%lld\n", ans);
	} 
}

namespace subtask2 {
	int d[N], tmp[N];
	
	inline int f(int l, int r) {
		int len = (r - l + 1);
		if((len % 2 == 1)) return tmp[(l + len / 2)];
		return tmp[(l + r) / 2] + tmp[(l + r) / 2 + 1];
	} 
	void dfs(int u, int fa) {
		tmp[d[u]] = u;
		for(int i = head[u]; i; i = e[i].nxt) {
			int v = e[i].to;
			if(v == fa) continue;
			d[v] = d[u] + 1;
			dfs(v, u);
		}
	}
	
	inline void solve() {
		LL ans = 0;
		for(int i = 1; i <= n; ++i) if(in[i] == 1) {d[i] = 1, dfs(i, 0);break;}
		for(int i = 1; i < n; ++i) ans += f(1, i) + f(i + 1, n);
		printf("%lld\n", ans);
	}
}
  
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &t);
	while(t--) {
		scanf("%d", &n);
		memset(head, 0, sizeof(head)); cnt = 1;
		memset(in, 0, sizeof(in));
		for(int i = 1, u, v; i < n; ++i) {
			scanf("%d%d", &u, &v);
			add(u, v); add(v, u);
			in[u] ++, in[v] ++;
		}
		if(n <= 2000) subtask1::solve();
		else subtask2::solve();
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
