#include <bits/stdc++.h>
using namespace std;
const int N = 40 + 5, M = 10, P = 998244353;
typedef long long LL;
inline void mul(LL &a, LL b) {a = a * b % P;}
inline void add(LL &a, LL b) {a = (a + b) % P;}

int n, m;
LL ans, a[N][M];

namespace subtask1 {
	LL f[N][N][N];
	
	inline void solve() {
		f[0][0][0] = 1;
		for(int i = 0; i < n; ++i) 
			for(int a1 = 0; a1 <= i; ++a1)
				for(int a2 = 0; a2 <= i - a1; ++a2) {
						add(f[i + 1][a1][a2], f[i][a1][a2]);
						add(f[i + 1][a1 + 1][a2], f[i][a1][a2] * a[i + 1][1]);
						add(f[i + 1][a1][a2 + 1], f[i][a1][a2] * a[i + 1][2]);
					}
		LL ans = 0;
		for(int i = 1; i <= (n / 2); ++i) add(ans, f[n][i][i]);
		printf("%lld\n", ans);
	}
}

namespace subtask2 {
	LL f[N][N][N][N];
	
	inline void solve() {
		f[0][0][0][0] = 1;
		for(int i = 0; i < n; ++i) 
			for(int a1 = 0; a1 <= i; ++a1)
				for(int a2 = 0; a2 <= i - a1; ++a2)
					for(int a3 = 0; a3 <= i - a1 - a2; ++a3) {
						add(f[i + 1][a1 + 1][a2][a3], f[i][a1][a2][a3] * a[i + 1][1] % P);
						add(f[i + 1][a1][a2 + 1][a3], f[i][a1][a2][a3] * a[i + 1][2] % P);
						add(f[i + 1][a1][a2][a3 + 1], f[i][a1][a2][a3] * a[i + 1][3] % P);
						add(f[i + 1][a1][a2][a3], f[i][a1][a2][a3]);
					}
		LL ans = 0;
		for(int a1 = 0; a1 <= n; ++a1) 
			for(int a2 = 0; a2 <= n - a1; ++a2)
				for(int a3 = 0; a3 <= n - a1 - a2; ++a3) {
					if(a1 + a2 >= a3 && a1 + a3 >= a2 && a2 + a3 >= a1) add(ans, f[n][a1][a2][a3]);
				}
		printf("%lld\n", ans - 1);
	}
}

namespace subtask3 {
	int len, ls[M];
	LL ans = 0;
	
	void dfs(int i, int sum, LL pi) {
		if(sum + n - i + 1 < len || sum > len) return;
		if(i == n + 1) add(ans, pi);  
		for(int j = 1; j <= m; ++j)
			if(ls[j] < (len / 2) && a[i][j]) {
				ls[j] ++;
				dfs(i + 1, sum + 1, pi * a[i][j] % P);
				ls[j] --;
			}
			dfs(i + 1, sum, pi);  
	}
	
	inline void solve() {
		for(len = 1; len <= n; ++len) {
			memset(ls, 0, sizeof(ls));
			dfs(1, 0, 1);
		}
		printf("%lld\n", ans);
	}
} 

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= m; ++j)
			scanf("%lld", &a[i][j]);
	if(m == 2) subtask1::solve();
	else if(m == 3) subtask2::solve();
	else subtask3::solve();
	fclose(stdin);
	fclose(stdout);
	return 0;
}

