#include <bits/stdc++.h>
using namespace std;
const int maxn=300002;
int n,m;
namespace Tree{
	struct edge{
		int to,nxt;
	}e[maxn<<1];
	int head[maxn],etot;
	int deg[maxn];
	inline void clear(){
		memset(head,0,sizeof(head));
		memset(deg,0,sizeof(deg));
		etot=0;
	}
	inline void add(int u,int v)
	{
		e[++etot].nxt=head[u];
		e[etot].to=v;
		head[u]=etot;
		++deg[v];
	}
	inline int is_link()
	{
		int mxdg=0;
		int hd=0;
		for(int i=1;i<=n;++i)
			mxdg=max(mxdg,deg[i]);
		for(int i=1;i<=n;++i)
			if(deg[i]==1){
				hd=i;
				break;
			}
		return mxdg>2?0:hd;
	}
}
namespace subtask1{
	using Tree::head;
	using Tree::e;
	int cuted;
	long long ans;
	namespace Tree_centroid{
		int s[maxn];//size
		int val[maxn];
		long long deltans=0;
		int mnval=INT_MAX;
		void dfs1(int u,int fa)
		{
			s[u]=1;val[u]=0;
			for(int i=head[u];i;i=e[i].nxt)
				if(fa!=e[i].to)
				{
					dfs1(e[i].to,u);
					s[u]+=s[e[i].to];
					val[u]+=val[e[i].to];
					val[u]+=s[e[i].to];
				}
		}
		void dfs2(int u,int fa,int val,int rt)
		{
			if(val<mnval)
			{
				deltans=u;
				mnval=val;
			}
			else if(val==mnval)
				deltans+=u;
			for(int i=head[u];i;i=e[i].nxt)
				if(fa!=e[i].to)
				{
					dfs2(e[i].to,u,
					val-s[e[i].to]+
					(s[rt]-s[e[i].to]),rt);
				}
		}
		void ff()
		{
			for(int i=1;i<=Tree::etot;i+=2)
			{
				deltans=0;
				mnval=INT_MAX;
				int rt1=e[i].to,rt2=e[i+1].to;
				dfs1(rt1,rt2);
				dfs2(rt1,rt2,val[rt1],rt1);
				ans+=deltans;
				deltans=0;
				mnval=INT_MAX;
				dfs1(rt2,rt1);
				dfs2(rt2,rt1,val[rt2],rt2);
				ans+=deltans;
			}
		}
	}
	long long solve()
	{
		ans=0;
		 Tree_centroid::ff();
		return ans;
	}
}
namespace subtask_list{
	int tot,p[maxn];
	int hd;
	inline void set_link(int flag)
	{
		tot=0;hd=flag;
		for(int i=hd;;)
		{
		//	printf("now i=%d\n",i);
			p[++tot]=i;
			if(i!=hd && Tree::deg[i]==1)
				break;
			for(int k=Tree::head[i];k;k=Tree::e[k].nxt)
				if(Tree::e[k].to!=p[tot-1])
					i=Tree::e[k].to;
		}
	}
	long long ans=0ll;
	long long solve()
	{
		ans=0;
	//	for(int i=1;i<=n;++i)
	//		printf("%d ",p[i]);
		for(int i=1;i<n;++i)
		{
			//[1,i][i+1,n]
			int mid1=(1+i)>>1,mid2=(i+1+n)>>1;
			ans+=p[mid1];ans+=p[mid2];
			if((i&1)==0) ans+=p[mid1+1];
			if(((n-i)&1)==0) ans+=p[mid2+1]; 
		}
		return ans;
	}
}
int main()
{
	int t;
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d",&n);
		Tree::clear();
		for(int i=1;i<n;++i)
		{
			int a,b;
			scanf("%d %d",&a,&b);
			Tree::add(a,b);
			Tree::add(b,a);
		}
		int flag=Tree::is_link();
		long long ans;
		if(!flag) ans=subtask1::solve();
		else 
			subtask_list::set_link(flag),
			ans=subtask_list::solve();
		printf("%lld\n",ans);
	}
	return 0;
}
