#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
using namespace std;
typedef long long ll;
const int p = 998244353;

const int N = 45, M = 507;
int n, m, a[N][M], ans, f[N][N][N];

inline void addmo(int &x, int y) {
	x += y; if (x >= p) x -= p;
}
inline void decmo(int &x, int y) {
	x -= y; if (x < 0) x += p;
}
inline int mo(int x) {
	if (x < 0) return x + p;
	return x >= p ? x - p : x;
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	ans = 1;	
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {  
			scanf("%d", &a[i][j]);
			addmo(a[i][0], a[i][j]);
		}
		ans = (ll)ans * (a[i][0] + 1) % p;
	}
	decmo(ans, 1);
	for (int t = 1; t <= m; ++t) {
		memset(f, 0, sizeof(f));
		f[0][0][0] = 1;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j <= n; ++j)
				for (int k = 0; k <= n; ++k) {
					addmo(f[i + 1][j][k], f[i][j][k]);
					if (j < n) addmo(f[i + 1][j + 1][k], (ll)f[i][j][k] * mo(a[i + 1][0] - a[i + 1][t]) % p);
					if (j < n && k < n) addmo(f[i + 1][j + 1][k + 1], (ll)f[i][j][k] * a[i + 1][t] % p);
				}
		for (int j = 1; j <= n; ++j)
			for (int k = j / 2 + 1; k <= n; ++k)
				decmo(ans, f[n][j][k]);
//		printf("%d %d\n", t, ans);
	}
	printf("%d\n", ans);
	return 0;
}
