#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
using namespace std;
typedef long long ll;

const ll inf = 4e18 + 1;
const int N = 5007;
int n, typ, a[N], last[N];
ll pre[N], f[N][N], val[N];
inline void upmin(ll &x, ll y) {
	if (y < x) x = y;
}

const int buf_size = 2e6;
inline char nc() {
	static char buf[buf_size], *p1 = buf, *p2 = buf;
	return p1==p2&&(p2=(p1=buf)+fread(buf,1,buf_size,stdin),p1==p2)?EOF:*p1++;
}
template <class T>
inline void rd(T &x) {
	x = 0; char ch = nc(); bool f = false;
	while ((ch<'0'||ch>'9')&&ch!='-') ch=nc();
	if (ch=='-') f=true,ch=nc();
	while (ch>='0'&&ch<='9')x=(x<<3)+(x<<1)+ch-'0',ch=nc();
	if (f) x=-x;
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	rd(n), rd(typ); pre[0] = 0;
	for (int i = 1; i <= n; ++i) {
		rd(a[i]);
		pre[i] = pre[i - 1] + a[i];
	}
	for (int i = 1; i <= n; ++i)
		for (int j = 0; j <= i; ++j) f[i][j] = inf; 
	f[0][0] = 0; ; last[0] = 0; val[0] = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < i; ++j) {
			while (last[j] > 0 && pre[j] + pre[j] - pre[i] <= pre[last[j] - 1]) 
				upmin(val[j], f[j][--last[j]]);
			upmin(f[i][j], val[j] + (pre[i] - pre[j]) * (pre[i] - pre[j]));
		}
		val[i] = inf; last[i] = i;
	}
	ll ans = inf;
	for (int j = 0; j < n; ++j) ans = min(ans, f[n][j]);
	printf("%lld\n", ans);
	return 0;
}
