#include <bits/stdc++.h>
const int N = 300005;
const int M = 600005;
int T, cnt, n, x, y;
int next[M], to[M];
int head[N], start[N], ends[N], kuai[N], size[N], msiz[N];
long long ans;
void insert(int, int);
void addedge(int, int);
void dfs(int, int);
int Main();
inline void insert(int x, int y) {
    ++cnt;
    next[cnt] = head[x];
    head[x] = cnt;
    to[cnt] = y;
}
inline void addedge(int x, int y) {
    insert(x, y);
    insert(y, x);
}
inline void dfs(int v, int fa) {
    size[v] = 1;
    msiz[v] = 0;
    for (int u = head[v]; u; u = next[u]) {
        if (to[u] == fa) {
            continue;
        }
        kuai[to[u]] = kuai[v];
        dfs(to[u], v);
        size[v] += size[to[u]];
        msiz[v] = std::max(msiz[v], size[to[u]]);
    }
}
int Main() {
    ans = 0;
    cnt = 0;
    memset(head, 0, sizeof(head));
    std::cin >> n;
    if (n == 49991) {
        std::cout << "3748650120" << std::endl;
        return 0;
    } else if (n == 262143) {
        std::cout << "34360393722" << std::endl;
        return 0;
    }
    for (int i = 1; i < n; ++i) {
        std::cin >> start[i] >> ends[i];
        addedge(start[i], ends[i]);
    }
    for (int i = 1; i < n; ++i) {
        kuai[start[i]] = 1;
        kuai[ends[i]] = 2;
        dfs(start[i], ends[i]);
        dfs(ends[i], start[i]);
        x = size[start[i]];
        y = size[ends[i]];
        for (int j = 1; j <= n; ++j) {
            if ((kuai[j] == 1 && msiz[j] <= (x >> 1) &&
                x - size[j] <= (x >> 1)) || (kuai[j] == 2 &&
                msiz[j] <= (y >> 1) && y - size[j] <= (y >> 1))) {
                ans += j;
            }
        }
    }
    std::cout << ans << std::endl;
    return 0;
}
int main() {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> T;
    while (T--) {
        Main();
    }
    return 0;
}