#include <bits/stdc++.h>
const int C = 23;
const int M = 10;
const int N = 45;
const long long mod = 998244353;
int n, m;
int a[N][M];
long long ans;
int Main1();
int Main2();
int Main1() {
    long long dp[N][C][C];
    memset(dp, 0, sizeof(dp));
    dp[0][0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n >> 1; ++j) {
            for (int k = 0; k <= n >> 1; ++k) {
                (dp[i][j][k] = (j ? dp[i - 1][j - 1][k] * a[i][1] : 0) +
                    (k ? dp[i - 1][j][k - 1] * a[i][2] : 0) +
                    dp[i - 1][j][k]) %= mod;
            }
        }
    }
    for (int i = 0; i <= n >> 1; ++i) {
        for (int j = 0; j <= n >> 1; ++j) {
            if ((!i && !j) || i > (i + j) >> 1 || j > (i + j) >> 1) {
                continue;
            }
            (ans += dp[n][i][j]) %= mod;
        }
    }
    printf("%lld\n", ans);
    return 0;
}
int Main2() {
    long long dp[N][C][C][C];
    memset(dp, 0, sizeof(dp));
    dp[0][0][0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n >> 1; ++j) {
            for (int k = 0; k <= n >> 1; ++k) {
                for (int l = 0; l <= n >> 1; ++l) {
                    if (!i && !j && !k) {
                        continue;
                    }
                    (dp[i][j][k][l] = (j ? dp[i - 1][j - 1][k][l] * a[i][1] : 0)
                        + (k ? dp[i - 1][j][k - 1][l] * a[i][2] : 0)
                        + (l ? dp[i - 1][j][k][l - 1] * a[i][3] : 0)
                        + dp[i - 1][j][k][l]) %= mod;
                }
            }
        }
    }
    for (int i = 0; i <= n >> 1; ++i) {
        for (int j = 0; j <= n >> 1; ++j) {
            for (int k = 0; k <= n >> 1; ++k) {
                if ((!i && !j && !k) || i > (i + j + k) >> 1 ||
                    j > (i + j + k) >> 1 || k > (i + j + k) >> 1) {
                    continue;
                }
                (ans += dp[n][i][j][k]) %= mod;
            }
        }
    }
    printf("%lld\n", ans);
    return 0;
}
int main() {
    freopen("meal.in", "r", stdin);
    freopen("meal.out", "w", stdout);
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            std::cin >> a[i][j];
        }
    }
    if (m == 2) {
        Main1();
    } else {
        Main2();
    }
    return 0;
}