#include <bits/stdc++.h>

template<typename T> inline int chkmax(T &x, T y) { return x < y ? x = y, 1 : 0; }

const int N = 300000;

int n, ans = 0;
struct Edge { int ver, nxt; } e[N << 1];
int head[N], tot = 1;

inline void Add(int x, int y) { e[++tot].ver = y, e[tot].nxt = head[x], head[x] = tot; }

namespace Subtask1 // n^2 
{
	const int MAXN = 2005;

	int sz[MAXN], son[MAXN];
	std::vector<int> rt;
	
	int size[MAXN];
	
	void Dfs1(int x, int fa) 
	{
		size[x] = 1;
		for (int i = head[x]; i; i = e[i].nxt)
		{
			int y = e[i].ver;
			if (y == fa)
				continue;
			Dfs1(y, x);
			size[x] += size[y];
		}
	}
	
	void Dfs2(int x, int fa, int sum) 
	{
		sz[x] = 1;
		for (int i = head[x]; i; i = e[i].nxt) 
		{
			int y = e[i].ver;
			if (y == fa)
				continue;
			Dfs2(y, x, sum);
			sz[x] += sz[y];
			chkmax(son[x], sz[y]);
		}
		chkmax(son[x], sum - sz[x]);
		if (son[x] <= (sum >> 1))
			rt.push_back(x);
	}
	
	bool ex[MAXN][MAXN];
	
	void Work()
	{	
		memset(ex, false, sizeof ex);
		for (int i = 2; i <= tot; i += 2)
		{
			int x = e[i].ver, y = e[i ^ 1].ver;
			if (ex[x][y] or ex[y][x])
				continue;
		
			memset(size, 0, sizeof size);
			rt.clear();
			Dfs1(x, y);
			Dfs2(x, y, size[x]);
			
			for (int j = 0; j < rt.size(); ++j)
				ans += rt[j];
			
			memset(size, 0, sizeof size);
			rt.clear();
			Dfs1(y, x);
			Dfs2(y, x, size[y]);
			
			for (int j = 0; j < rt.size(); ++j)
				ans += rt[j];
				
			memset(son, 0, sizeof son);
			memset(sz, 0, sizeof sz);
		}
		
		printf("%d\n", ans);
	}
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	int T;
	scanf("%d", &T);
	
	while (T--)
	{
		scanf("%d", &n);
		for (int i = 1; i < n; ++i)
		{
			int u, v;
			scanf("%d%d", &u, &v);
			Add(u, v), Add(v, u);
		}
	
		Subtask1::Work();
		
		tot = 1, ans = 0;
		memset(head, 0, sizeof head);
	}
	
	return 0;
}
