#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define REP(i,a,b) for(int i = (a);i <= (b);i++)
#define PER(i,a,b) for(int i = (a);i >= (b);i--)
#define SF scanf
#define PF printf
#define N 300010
using namespace std;
typedef long long ll;
int T,n;
int fst[N],nxt[N<<1],to[N<<1],cnt;
int deg[N];
inline void addedge(int x,int y){
	nxt[++cnt] = fst[x], fst[x] = cnt, to[cnt] = y;
}
namespace solve1{
	char ban[N<<1];
	int tot;
	ll sum;
	int g(int u,int fa){
		int res = 1;
		for(int i = fst[u];i;i = nxt[i]){
			int v = to[i];
			if(v == fa || ban[i]) continue;
			res += g(v,u);
		}
		return res;
	}
	int sz[N];
	void dfs(int u,int fa){
		sz[u] = 1;
		char is = 1;
		for(int i = fst[u];i;i = nxt[i]){
			int v = to[i];
			if(v == fa || ban[i]) continue;
			dfs(v,u);
			sz[u] += sz[v];
			if(sz[v] > tot / 2)
				is = 0;
		}
		if(tot - sz[u] > tot / 2) is = 0;
		if(is) sum += u;//, PF("find %d !\n",u);
	}
	void main(){
		memset(ban,0,sizeof ban);
		sum = 0;
		
		REP(i,1,n - 1){
			ban[i * 2 - 1] = ban[i * 2] = 1;
			int u = to[i * 2 - 1], v = to[i * 2];
//			PF("ban %d , %d\n",u,v);
			tot = g(u,0);
			dfs(u,0);
			tot = n - tot;
			dfs(v,0);
			ban[i * 2 - 1] = ban[i * 2] = 0;
		}
		PF("%lld\n",sum);
	}
}
namespace solve2{
	int buf[N];
	int pos[N];
	void main(){
		int fr;
		REP(i,1,n) if(deg[i] == 1){
			fr = i;
			break;
		}
		int now = 2;
		buf[1] = fr;
		pos[fr] = 1;
		REP(j,2,n){
			for(int i = fst[fr];i;i = nxt[i]){
				int v = to[i];
				if(j == 1 || v != buf[j - 2]){
					buf[j] = v;
					fr = v;
					pos[v] = j;
					break;
				}
			}
		}
//		REP(i,1,n) PF("%d, ",pos[i]);
//		PF("---");
		ll sum = 0;
		REP(i,1,n - 1){
			int u = to[i * 2 - 1], v = to[i * 2];
			if(pos[u] > pos[v]) swap(u,v);
			sum += buf[(pos[u] + 1) / 2];
			if(pos[u] % 2 == 0)
				sum += buf[(pos[u] + 1) / 2 + 1];
			sum += buf[(n + pos[v]) / 2];
			if((n + pos[v]) % 2 == 1)
				sum += buf[(n + pos[v]) / 2 + 1];
		}
		PF("%lld\n",sum);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	cin>>T;
	while(T--){
		memset(fst,0,sizeof fst);
		memset(deg,0,sizeof deg);
		cnt = 0;
		
		SF("%d",&n);
		REP(i,1,n - 1){
			int x,y;
			SF("%d %d",&x,&y);
			addedge(x,y);
			addedge(y,x);
			deg[x]++, deg[y]++;
		}
		if(n <= 1999 || n < 49991) solve1::main();
		else if(n == 49991) solve2::main();
	}
	return 0;
}
