#include <cstdio>
#include <cctype>
#define rep(i,l,r) for(int i=(l);i<=(r);++i)
#define per(i,l,r) for(int i=(l);i>=(r);--i)
#define M 998244353
#define min(a,b) (a<b?a:b)
typedef long long ll;
template <class T>
inline void read(T &x){
	x=0;char c=getchar();
	T fh=1;
	while(!isdigit(c)){
		if(c=='-') fh=-1;
		c=getchar();
	}
	for(;isdigit(c);c=getchar())x=(x<<1)+(x<<3)+(c^48);
	x*=fh;
	return;
}
struct edge;
struct node{
	int siz,tg;
	node *fa;
	edge* head;
} a[300005];
struct edge{
	node* from;
	node* to;
	edge* nxt;
	bool disable;
} e[300005],ee[300005];
int cnt,cntt;
inline void newEdge(node *u, node *v){
	e[++cnt]=(edge){u,v,u->head,0};
	u->head=&e[cnt];
	return;
}
inline void newEdgee(node *u, node *v){
	ee[++cntt]=(edge){u,v,u->head,0};
	u->head=&ee[cntt];
	return;
}
void dfs(node* rt){
	int maxsiz=0;
	rt->siz=1;
	//printf("here\n");
	for(edge* e=rt->head;e;e=e->nxt){
		if(e->to==rt->fa||e->disable) continue;
		e->to->fa=rt;
		//printf("here node %d, try to %d",rt->tg,e->to->tg);
		dfs(e->to);
		rt->siz+=e->to->siz;
	}
}
int minsiz;
ll ans;
int n;
void findcent(node* rt, int N){
	if(N-rt->siz<=rt->siz) minsiz=min(rt->siz,minsiz);
	else {
		minsiz=min(N-rt->siz,minsiz);
		//if(rt->siz==minsiz) ans+=rt->tg;
		return;
	}
	for(edge* e=rt->head;e;e=e->nxt){
		if(e->disable||e->to==rt->fa) continue;
		findcent(e->to,N);
	}
}
void findans(node* rt, int N){
	//printf("here node %d, siz=%d\n",rt->tg,rt->siz);
	int maxsiz=N-rt->siz;
	for(edge* e=rt->head;e;e=e->nxt){
		if(e->disable||e->to==rt->fa) continue;
		if(e->to->siz>maxsiz) maxsiz=e->to->siz;
	}
	if(maxsiz==minsiz){
		ans+=rt->tg;
		return;
	}
	for(edge* e=rt->head;e;e=e->nxt){
		if(e->disable||e->to==rt->fa) continue;
		findans(e->to,N);
	}
}
inline void clean(){
	cnt=cntt=0;
	ans=0;
	rep(i,0,n){
		a[i].tg=i;
		a[i].fa=NULL;
		a[i].head=NULL;
		a[i].siz=0;
	}
}
inline void cleansiz(){
	minsiz=n;
	rep(i,0,n) a[i].siz=0;
}
inline void cleanfa(){
	rep(i,0,n) a[i].fa=NULL;
}
inline void printsiz(){
	//rep(i,1,n) printf("node %d's siz=%d\n",i,a[i].siz);
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T,u,v;
	node* f,*t;
	read(T);
	rep(ppp,1,T){
		read(n);
		clean();
		rep(i,1,n-1){
			read(u);read(v);
			newEdge(&a[u],&a[v]);
			newEdgee(&a[v],&a[u]);
		}
		rep(i,1,cnt){
			e[i].disable=ee[i].disable=1;
			f=e[i].from;t=e[i].to;
			//printf("del edge frome %d to %d\n",f->tg,t->tg,cnt);
			//minsiz=n;
			cleansiz();
			cleanfa();
			dfs(f);
			//printsiz();
			findcent(f,f->siz);
			//printf("h1\n");
			findans(f,f->siz);
			//printf("h3,ans=%lld,minsiz=%d\n",ans,minsiz);
			minsiz=n;
			dfs(t);
			findcent(t,t->siz);
			//printf("h3,ans=%lld,minsiz=%d\n",ans,minsiz);
			findans(t,t->siz);
			//printf("h3,ans=%lld,minsiz=%d\n",ans,minsiz);
			//printf("h4\n");
			e[i].disable=ee[i].disable=0;
		}
		printf("%lld\n",ans);
	}
}
