#include <bits/stdc++.h>

typedef long long ll;
const int N = 300054, M = N * 2, LN = 19;

int n, E = 0;
int to[M], first[N], next[M];
int dep[N], prf[N], sef[N], size[N];
int P[LN][N], *p = *P;
int top, stack[N], istack[N];
int centr[N], ccmpl[N];

inline void addedge(int u, int v) {
	to[++E] = v, next[E] = first[u], first[u] = E;
	to[++E] = u, next[E] = first[v], first[v] = E;
}

inline int Fy(int x) {return x > 0 ? x : p[-x];}

void dfs(int x) {
	int i, y, &z = prf[x], &zz = sef[x]; zz = z = 0, size[x] = 1;
	for (i = 0; i < LN - 1 && P[i][x]; ++i) P[i + 1][x] = P[i][ P[i][x] ];
	for (i = first[x]; i; i = next[i])
		if ((y = to[i]) != p[x]) {
			p[y] = x, dep[y] = dep[x] + 1;
			dfs(y), size[x] += size[y];
			size[y] > size[z] ? (zz = z, z = y) : size[y] > size[zz] ? zz = y : 0;
		}
	if (z) {
		if (y = Fy(centr[z]), size[y] * 2 > size[x]) centr[x] = y;
		else {
			for (; size[p[y]] * 2 <= size[x]; y = p[y]);
			centr[x] = (size[y] * 2 == size[x] ? -y : p[y]);
		}
	} else centr[x] = x;
}

void rdfs(int x) {
	int i, j, y, z, v, Size, nxtSize, Compl = n - size[x], L, R, M;
	stack[top] = x, istack[x] = top++;
	for (i = first[x]; i; i = next[i]) 
		if (p[y = to[i]] == x) {
			stack[top] = y;
			Size = n - size[y];
			z = (y == prf[x] ? sef[x] : prf[x]);
			if (z && size[z] * 2 >= Size) {
				if (v = Fy(centr[z]), size[v] * 2 > Size) ccmpl[y] = v;
				else {
					for (j = LN - 1; j >= 0; --j)
						if (dep[v] > dep[x] + (1 << j) && size[ P[j][v] ] * 2 <= Size)
							v = P[j][v];
					ccmpl[y] = (size[v] * 2 == Size ? -v : p[v]);
				}
			} else if (Compl * 2 >= Size) {
				v = Fy(ccmpl[x]);
				if (!~istack[v]) {
					if (size[v] * 2 > Size) ccmpl[y] = v;
					else {
						for (j = LN - 1; j >= 0; --j)
							if (dep[v] >= (1 << j) && !~istack[ P[j][v] ] && size[ P[j][v] ] * 2 <= Size) v = P[j][v];
						if (~istack[ p[v] ]) {
							nxtSize = (n - (1 + istack[ p[v] ])[stack][size]);
							if (nxtSize * 2 > Size) ccmpl[y] = (size[v] * 2 == Size ? -v : p[v]);
							else v = p[v]; // lift !
						} else ccmpl[y] = (size[v] * 2 == Size ? -v : p[v]);
					}
				}
				if (~istack[v]) {
					for (L = istack[v], R = top; L < R; M = (L + R + 1) / 2, (n - size[ stack[M] ]) * 2 > Size ? R = M - 1 : (L = M));
					v = stack[L], ccmpl[y] = ((n - size[v]) * 2 == Size ? -v : v);
				}
			} else ccmpl[y] = x;
			rdfs(y);
		}
	stack[--top] = 0, istack[x] = -1;
}

void work(std::istream &in, std::ostream &out) {
	int i, u, v; ll ans = 0;
	in >> n, E = top = 0;
	memset(first, 0, (n + 1) << 2);
	for (i = 1; i < n; ++i) in >> u >> v, addedge(u, v);
	dfs(1), assert(size[1] == n);
	memset(istack, -1, (n + 1) << 2);
	rdfs(1);
	for (i = 2; i <= n; ++i) {
		ans += centr[i] > 0 ? centr[i] : p[-centr[i]] - centr[i],
		ans += ccmpl[i] > 0 ? ccmpl[i] : p[-ccmpl[i]] - ccmpl[i];
/*		out << i << ':';
		if (centr[i] > 0) out << ' ' << centr[i];
		else {
			u = -centr[i], v = p[u];
			if (u > v) std::swap(u, v);
			out << ' ' << u << ' ' << v;
		}
		out << '|';

		out << -i << ':';
		if (ccmpl[i] > 0) out << ' ' << ccmpl[i];
		else {
			u = -ccmpl[i], v = p[u];
			if (u > v) std::swap(u, v);
			out << ' ' << u << ' ' << v;
		}
		out << '\n';*/
	}
	out << ans << '\n';
}

int main() {
	int T;
#ifdef ONLINE_JUDGE
	std::ios::sync_with_stdio(false), std::cin.tie(NULL);
	using std::cin;
	using std::cout;
#else
	std::ifstream cin("centroid.in");
	std::ofstream cout("centroid.out");
#endif
	for (cin >> T; T; --T) work(cin, cout);
#ifndef ONLINE_JUDGE
	cin.close(), cout.close();
#endif
	return 0;
}
