#include<iostream>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#define inf 0x3f3f3f3f
#define ll long long
#define N 300010
using namespace std;
ll size[N],T,n,head[N],tot,maxsize[N],root,cnt,ans,root2;
bool cut[N*2];
struct Edge{
	ll v,next;
}edge[N*2];
inline ll read(){
	ll x=0,f=1;char ch=getchar();while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
	while(ch>='0'&&ch<='9'){x=(x<<3)+(x<<1)+ch-48;ch=getchar();}return x*f;
}
inline void add(ll x,ll y){edge[++tot].v=y;edge[tot].next=head[x];head[x]=tot;}
ll dfs(ll x,ll fa){
	bool flag=0;size[x]=maxsize[x]=1;
	for(int i=head[x];i;i=edge[i].next){
		int v=edge[i].v;
		if(v==fa||cut[i])continue;
		flag=1;
		dfs(v,x);
		size[x]+=size[v];
		maxsize[x]=max(maxsize[x],size[v]);
	}return size[x];
}
ll dfs2(ll x,ll fa){
	bool flag=0;
	for(int i=head[x];i;i=edge[i].next){
		int v=edge[i].v;
		if(v==fa||cut[i])continue;
		if(size[v]>=size[x]-size[v]){
			size[x]-=size[v];
			size[v]+=size[x];
			maxsize[v]=max(maxsize[v],size[x]-size[v]);
			return dfs2(v,x);
			flag=1;
		}
	}if(!flag)root=x;return root;
}
ll dfs3(ll x,ll fa){
	for(int i=head[x];i;i=edge[i].next){
		int v=edge[i].v;
		if(v==fa||cut[i])continue;
		if(size[v]>=size[x]-size[v]){
			size[v]=size[x];
			maxsize[v]=max(maxsize[v],size[x]-size[v]);
			return v;
		}		
	}return 0;
}
void init(){
	memset(head,0,sizeof(head));tot=1;memset(size,0,sizeof(size));memset(maxsize,0,sizeof(maxsize));memset(cut,0,sizeof(cut));ans=0; 
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	while(T--){
		init();
		n=read();
		for(int i=1;i<n;i++){
			int x=read(),y=read();
			add(x,y);add(y,x);
		}
		for(int i=2;i<=2*n;i+=2){
			memset(cut,0,sizeof(cut));
			cut[i]=cut[i+1]=1;
			memset(size,0,sizeof(size));memset(maxsize,0,sizeof(maxsize));cnt=0;
			int v=edge[i].v,u=edge[i^1].v;
			size[v]=dfs(v,0);
			root=dfs2(v,0);
			root2=dfs3(root,0);
			ans+=root+root2;
			memset(size,0,sizeof(size));memset(maxsize,0,sizeof(maxsize));
			size[u]=dfs(u,0);
			root=dfs2(u,0);		
			root2=dfs3(root,0);
			ans+=root+root2;
		}
		printf("%lld\n",ans);
	}
	return 0;
}

