#include<bits/stdc++.h>
using namespace std;
const int N=300000;
struct Edge
{
	int from,to,next;
}edge[N<<1];
int head[N],cnt_side=0;
int n,son[N];
int fa[N],rta,rtb;
bool mem[N];
void ADD_EDGE(int from,int to)
{
	++cnt_side;
	edge[cnt_side].to=to;
	edge[cnt_side].from=from;
	edge[cnt_side].next=head[from];
	head[from]=cnt_side;
	return;
}
void INIT()
{
	memset(head,0,sizeof(head));
	memset(edge,0,sizeof(edge));
	memset(son,0,sizeof(son));
	memset(fa,0,sizeof(fa));
	memset(mem,0,sizeof(mem));
	cnt_side=rta=rtb=0;
	scanf("%d",&n);
	int x,y;
	for(int i=1;i<n;++i)
	{
		scanf("%d%d",&x,&y);
		ADD_EDGE(x,y);
		ADD_EDGE(y,x);
	}
	return;
}
int DFS(int t,bool x)
{
	mem[t]=x;
	son[t]=0;
	for(int i=head[t];i!=0;i=edge[i].next)
		if(edge[i].to!=fa[t] && edge[i].to!=rta && edge[i].to!=rtb)
		{
			fa[edge[i].to]=t;
			son[t]+=DFS(edge[i].to,x);
		}
	son[t]++;
	return son[t];
}
int FIND()
{
	int sum=0,root;
	bool x=false;
	for(int i=1;i<=n;++i)
	{
		if(mem[i]) root=rta;
		else root=rtb;
		x=false;
		for(int j=head[i];j!=0;j=edge[j].next)
			if(edge[j].to!=fa[i] && edge[j].to!=rta &&
			   edge[j].to!=rtb && son[edge[j].to]>son[root]/2)
			{ x=true; break; }
		if(x || son[i]*2<son[root]) continue;
		sum+=i;
	}
	return sum;
}
void SOLVE_7()
{
	int ans=0;
	for(int i=1;i<cnt_side;i+=2)
	{
		memset(son,0,sizeof(son));
		memset(mem,false,sizeof(mem));
		rta=edge[i].from,rtb=edge[i].to;
		fa[rta]=rta; fa[rtb]=rtb;
		DFS(rtb,false); DFS(rta,true);
		ans+=FIND();
	}
	printf("%d\n",ans);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t;
	scanf("%d",&t);
	while(t--)
	{
		INIT();
		if(n<=2000) SOLVE_7();
		else printf("%d\n",rand());
	}
	return 0;
}
