#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstring>
#define ll long long
using namespace std;

const int MO = 998244353, N = 107, M = 2007;
int n, m, a[N][M], s[M], vis[N];
ll ans;
inline int read() {
	int ans = 0;
	char ch = getchar();
	while (ch < '0' || ch > '9')
	    ch = getchar();
	while (ch >= '0' && ch <= '9')
	    ans = (ans << 3) + (ans << 1) + ch - 48, ch = getchar();
	return ans;
}
bool check(int x) {
	for (int i = 1; i <= m; ++i)
	if (s[i] > x)
	    return false;
	return true;
}
void dfs(int k, int ss, int num) {
	if (k > m) {
		if (num && check(num / 2))
		    ans = ((ll)ans + ss) % MO;
		return;
	}
	for (int i = 1; i <= n; ++i) 
	if (!vis[i] && a[i][k]) {
		vis[i] = 1;
		s[k]++;
		++num;
		dfs(k + 1, (ll)ss * a[i][k] % MO, num);
		--num;
		s[k]--;
		vis[i] = 0;
	}    
	dfs(k + 1, ss, num);
}
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	
	n = read(), m = read();
	for (int i = 1; i <= n; ++i)
	for (int j = 1; j <= m; ++j)
	    a[i][j] = read();
    dfs(1, 1, 0);
	printf("%d\n", ans);
	return 0;
}
/*
5 5
1 0 0 1 1
0 1 0 1 0
1 1 1 1 0
1 0 1 0 1
0 1 1 0 1
*/
