#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#define maxN 110
#define maxM 2019
#define Mod 998244353
using namespace std;
int n,m,a[maxN][maxM],meal[maxM];
long long ans;
void dfs(int x,long long p,int cnt){
	if (x==n+1){
		if (cnt==0) return;
		int Max=0;
		for (int i=1;i<=m;i++) Max=max(Max,meal[i]);
		if (Max*2>cnt) return;
		ans=(ans+p)%Mod;
		return;
	}
	dfs(x+1,p,cnt);
	for (int i=1;i<=m;i++){
		if (a[x][i]==0) continue;
		meal[i]++;
		if (meal[i]*2<=(cnt+n-x+1)){
			dfs(x+1,p*(long long)(a[x][i])%Mod,cnt+1);
		}
		meal[i]--;
	}
}
void read(int &x){
	char ch=getchar();
	for(;ch<'0' || ch>'9';ch=getchar());
	for(x=0;ch>='0' && ch<='9';ch=getchar())x=x*10+ch-48;
}
void dp2(){
	long long f[50][50][50];
	f[0][0][0]=1;
	for (int i=1;i<=n;i++){
		for (int j=0;j<=i;j++){
			for (int k=0;k<=i-j;k++){
				f[i][j][k]=f[i-1][j][k];
				if (j) f[i][j][k]+=f[i-1][j-1][k]*(long long)a[i][1]%Mod;
				f[i][j][k]%=Mod;
				if (k) f[i][j][k]+=f[i-1][j][k-1]*(long long)a[i][2]%Mod;
				f[i][j][k]%=Mod;
			}
		}
	}
	ans=0;
	for (int i=0;i<=n;i++){
		for (int j=0;j<=n;j++){
			if (i==0 && j==0) continue;
			if (i+j<max(i,j)*2) continue;
			ans+=f[n][i][j];
			ans%=Mod;
		}
	}
	printf("%lld\n",ans);
}
void dp3(){
	long long f[42][42][42],g[42][42][42];
	f[0][0][0]=1;
	for (int i=1;i<=n;i++){
		for (int j=0;j<=i;j++){
			for (int k=0;k<=i-j;k++){
				for (int l=0;l<=i-j-k;l++){
					g[j][k][l]=f[j][k][l];
					if (j) g[j][k][l]+=f[j-1][k][l]*(long long)a[i][1]%Mod;
					g[j][k][l]%=Mod;
					if (k) g[j][k][l]+=f[j][k-1][l]*(long long)a[i][2]%Mod;
					g[j][k][l]%=Mod;
					if (l) g[j][k][l]+=f[j][k][l-1]*(long long)a[i][3]%Mod;
					g[j][k][l]%=Mod;
				}
			}
		}
		if (i==n) continue;
		for (int j=0;j<=i;j++){
			for (int k=0;k<=i-j;k++){
				for (int l=0;l<=i-j-k;l++){
					f[j][k][l]=g[j][k][l];
				}
			}
		}
	}
	ans=0;
	for (int i=0;i<=n;i++){
		for (int j=0;j<=n;j++){
			for (int k=0;k<=n;k++){
				if (i+j+k==0) continue;
				if (i+j+k<max(max(i,j),k)*2) continue;
				ans+=g[i][j][k];
				ans%=Mod;
			}
		}
	}
	printf("%lld\n",ans);
}
int main(){
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	read(n);read(m);
	for (int i=1;i<=n;i++){
		for (int j=1;j<=m;j++){
			read(a[i][j]);
		}
	}
	if (m==2){
		dp2();
		return 0;
	}
	if (m==3){
		dp3();
		return 0;
	}
	ans=0;
	for (int i=1;i<=m;i++) meal[i]=0;
	dfs(1,1,0);
	printf("%lld",ans);
	return 0;
}
