#include <cstdio>
#include <cctype>
#include <cstring>
#include <iostream>
#include <algorithm>

#define reg register
#define ll long long
#define rep(i, a, b) for (reg int i = (a), i##end = (b); i <= i##end; ++i)
#define dep(i, a, b) for (reg int i = (a), i##end = (b); i >= i##end; --i)
using namespace std;

template <typename _typer> inline _typer read() {
    _typer init = 0; int ch = getchar(), k = 0;
    for ( ; !isdigit(ch); ch = getchar()) k = (ch == '-');
    for ( ; isdigit(ch); ch = getchar())
        init = (init << 3) + (init << 1) + (ch ^ 48);
    return k ? -init : init;
}
const ll N = 300005, INF = 1e9;


char aaa;


int n;
struct EDGE {
    int to, nex;
} edge[N << 1];
int head[N], cntedge;
void Addedge(int u, int v) {
    edge[++cntedge] = (EDGE) { v, head[u] };
    head[u] = cntedge;
}


ll Ans;

namespace p40 {
int siz[N];
void GetSiz(int u, int fa) {
    siz[u] = 1;
    for (int i = head[u], v; i; i = edge[i].nex) {
        v = edge[i].to;
        if (v == fa) continue;
        GetSiz(v, u);
        siz[u] += siz[v];
    }
}
int cnt[N];;
void FindRt(int u, int fa, int tot) {
    int mx = tot - siz[u];
    for (int i = head[u], v; i; i = edge[i].nex) {
        v = edge[i].to;
        if (v == fa) continue;
        FindRt(v, u, tot);
        (siz[v] > mx && (mx = siz[v]));
    }
    if (mx <= (tot >> 1)) {
        Ans += u;
//         ++cnt[u];
    }
}
void Work() {
    rep (u, 1, n) {
        for (int i = head[u], v; i; i = edge[i].nex) {
            v = edge[i].to;
            GetSiz(u, v);
            FindRt(u, v, siz[u]);
        }
    }
//     rep (i, 1, n) if (cnt[i] > 1) cerr << i << " " << cnt[i] << endl;
    printf("%lld\n", Ans);
}
}

namespace p55 {
int line[N];
void Work() {
    int Rt = 0;
    rep (u, 1, n) if (!edge[head[u]].nex) {
        Rt = u;
        break;
    }

    line[0] = 0;
    int now = Rt;
    for ( ; line[0] < n; ) {
        line[++line[0]] = now;
        for (int i = head[now], v; i; i = edge[i].nex) {
            v = edge[i].to;
            if (v == line[line[0] - 1]) continue;
            now = v;
            break;
        }
    }

//     rep (i, 1, n) printf("%d%c", line[i], " \n"[i == n]);

    int pos = 1;
    rep (i, 1, n - 1) {
        while (pos <= (i >> 1)) ++pos;
//         cerr << "#" << pos << " " << i << endl;
        Ans += line[pos];
        if (!(i & 1)) Ans += line[pos - 1];
    }

    reverse(line + 1, line + n + 1);

    pos = 1;
    rep (i, 1, n - 1) {
        while (pos <= (i >> 1)) ++pos;
        Ans += line[pos];
        if (!(i & 1)) Ans += line[pos - 1];
    }

    printf("%lld\n", Ans);
}
}

namespace p75 {
int cnt;
void Dfs(int u, int fa) {
    int res = 0;
    for (int i = head[u], v; i; i = edge[i].nex) {
        v = edge[i].to;
        ++res;
        if (v == fa) continue;
        Dfs(v, u);
    }
    if (res == 1) ++cnt;
    if (res != 2) Ans += u;
}
void Work() {
    int Rt = 0;
    rep (u, 1, n) {
        int cnt = 0;
        for (int i = head[u]; i; i = edge[i].nex) ++cnt;
        if (cnt == 2) {
            Rt = u;
            break;
        }
    }

    cnt = 0;
    Dfs(Rt, 0);

    int ls = 0, rs = 0;
    for (int i = head[Rt]; i; i = edge[i].nex) {
        if (!ls) ls = edge[i].to;
        else rs = edge[i].to;
    }
    Ans += 1ll * cnt * (ls + rs + Rt) - ls - rs;
    printf("%lld\n", Ans);
}
}


char bbb;


int _main() {
//     cerr << (&bbb - &aaa) / 1024.0 / 1024 << endl;

    rep (ks, 1, read<int>()) {
        Ans = cntedge = 0;
        memset(head, 0, sizeof head);

        n = read<int>();
        rep (i, 2, n) {
            int x = read<int>(), y = read<int>();
            Addedge(x, y), Addedge(y, x);
        }

        if (n <= 2000) p40::Work();
        else if (n % 10 == 1) p55::Work();
        else if (n % 10 == 3) p75::Work();
    }
    return 0;
}

int main() {
#define offline
#ifdef offline
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    _main();
    fclose(stdin); fclose(stdout);
#else
    _main();
#endif
    return 0;
}

