#include <cstdio>
#include <cctype>
#include <cstring>
#include <iostream>
#include <algorithm>

#define reg register
#define ll long long
#define rep(i, a, b) for (reg int i = (a), i##end = (b); i <= i##end; ++i)
#define dep(i, a, b) for (reg int i = (a), i##end = (b); i >= i##end; --i)
using namespace std;

template <typename _typer> inline _typer read() {
    _typer init = 0; int ch = getchar(), k = 0;
    for ( ; !isdigit(ch); ch = getchar()) k = (ch == '-');
    for ( ; isdigit(ch); ch = getchar())
        init = (init << 3) + (init << 1) + (ch ^ 48);
    return k ? -init : init;
}
const ll N = 40000005, INF = 4e18;


char aaa;


int n, A[N], typ;
ll S[N];


void Upd(ll &x, ll y) { (x > y && (x = y)); }

namespace p36 {
const ll N = 405;
ll f[N][N];
void Work() {
    memset(f, 0x3f, sizeof f);
    rep (i, 1, n) rep (j, 1, i) {
        if (j == 1) f[i][j] = S[i] * S[i];
        dep (l, j - 1, 1) {
            if (S[i] - S[j - 1] < S[j - 1] - S[l - 1]) break;
            Upd(f[i][j], f[j - 1][l] + (S[i] - S[j - 1]) * (S[i] - S[j - 1]));
        }
//         cerr << i << " " << j << " " << f[i][j] << endl;
    }
    ll Ans = S[n] * S[n];
    rep (i, 1, n) Upd(Ans, f[n][i]);
    printf("%lld\n", Ans);
}
}

namespace p64 {
const ll N = 5005;
ll f[N][N], mi[N][N];
void Work() {
    memset(f, 0x3f, sizeof f);
    memset(mi, 0x3f, sizeof mi);
    rep (i, 1, n) {
        int pos = 1;
        rep (j, 1, i) {
            if (j == 1) f[i][j] = S[i] * S[i];
            else {
                while (S[i] - S[j - 1] < S[j - 1] - S[pos - 1]) ++pos;
                f[i][j] = mi[j - 1][pos] + (S[i] - S[j - 1]) * (S[i] - S[j - 1]);
            }
        }
        mi[i][i] = f[i][i];
        dep (j, i - 1, 1) mi[i][j] = min(mi[i][j + 1], f[i][j]);
    }
    printf("%lld\n", min(mi[n][1], S[n] * S[n]));
}
}


char bbb;


int _main() {
//     cerr << (&bbb - &aaa) / 1024.0 / 1024 << endl;

    n = read<int>(), typ = read<int>();
    if (typ == 0) {
        rep (i, 1, n) S[i] = S[i - 1] + (A[i] = read<int>());
        if (n <= 400) p36::Work();
        else if (n <= 5000) p64::Work();
    } else {


    }
    return 0;
}

int main() {
#define offline
#ifdef offline
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
    _main();
    fclose(stdin); fclose(stdout);
#else
    _main();
#endif
    return 0;
}

