#include<iostream>
#include<cstdio>
#include<cstring>
#define ull unsigned long long
using namespace std;

const int N  = 5e5 + 10;

int n, m;

ull ans;
ull a[N], sum[N];

template <typename T>
inline void read(T &x){
	x = 0;
	char c = getchar();
	T op = 1;
	for(; c < '0' || c > '9'; c = getchar())
		if(c == '-')	op = -1;
	for(; c <= '9' && c >= '0'; c = getchar())
		x = (x << 3) + (x << 1) + c - '0';
	x *= op;
}

void dfs(int x, int y, ull s){
	if(s > ans)	return;
	if(x == n){
		if(s < ans) ans = s;
		return;
	}
	for(int i = x + 1; i <= n; ++i)
		if(sum[i] - sum[x] >= sum[x] - sum[y])
			dfs(i, x, s + (sum[i] - sum[x]) * (sum[i] - sum[x]));
}

int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	read(n), read(m);
	for(int i = 1; i <= n; ++i)	
		read(a[i]), sum[i] = sum[i - 1] + a[i];
	ans = sum[n] * sum[n];
	for(int i = 1; i <= n; ++i)
		dfs(i, 0, sum[i] * sum[i]);
	printf("%lld\n", ans);
	return 0;
}

