#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
#define M 600007

ll read(){
	ll s=0,w=1; char ch=getchar();
	while (ch<'0'||ch>'9') {if (ch=='-') w=-1; ch=getchar();}
	while (ch>='0'&&ch<='9') s=(s<<3)+(s<<1)+(ch^'0'), ch=getchar();
	return s*w;
}

void write(ll s){
	if (s<0) putchar('-'), s=-s;
	if (s>9) write(s/10);
	putchar(s%10+'0');
}

void writeln(ll s){
	write(s); puts("");
}

void writeln(){
	puts("");
}

template<class T> void debug(T a,int l,int r){
	for (int i=l;i<=r;i++) write(a[i]),putchar(' '); writeln();
}

int n;

struct Edge{
	int to,next; bool flag;
}e[M];

int head[M],deg[M],t=0;

void addedge(int x,int y){
	e[++t] = (Edge){y,head[x],0}; head[x] = t;
	e[++t] = (Edge){x,head[y],0}; head[y] = t;
	deg[x]++; deg[y]++;
}

int rev(int x){
	if (x&1) return x+1; else return x-1;
}

bool chain(){
	for (int i=1;i<=n;i++) if (deg[i]>2) return 0;
	return 1;
}

namespace sub_chain{
	int a[M],h,tot;
	void dfs(int now,int fa){
		a[++tot] = now;
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to==fa) continue;
			dfs(e[i].to,now);
		}
	}
	void solve(){
		tot=0;
		for (int i=1;i<=n;i++) if (deg[i]==1) h = i;
		dfs(h,0);
		ll ans = 0;
		for (int i=1,lf=1,rt=n-1;i<=n-1;i++,lf++,rt--){
			if (lf%2==0) ans += a[i/2]+a[i/2+1]; else ans += a[(i+1)/2];
			if (rt%2==0) ans += a[(n+i)/2] + a[(n+i)/2+1]; else ans += a[(n+i+1)/2];
		}
		writeln(ans);
	}
}
	
namespace sub_n{
	int sz[M]; vector<int> p;
	void dfs1(int now,int fa){
		sz[now] = 1;
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to!=fa&&!e[i].flag) dfs1(e[i].to,now), sz[now] += sz[e[i].to];
		}
	}
	void dfs2(int now,int fa,int root){
		int flag = 1;
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to!=fa&&!e[i].flag){
				if (sz[e[i].to]>sz[root]/2) flag = 0;
			}
		}
		if (sz[root]-sz[now]>sz[root]/2) flag = 0;
		if (flag) p.push_back(now);
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to!=fa&&!e[i].flag) dfs2(e[i].to,now,root);
		}
	}
	bool vis[M];
	void solve(){
		memset(vis,0,sizeof(vis));
		ll ans = 0;
		for (int i=1;i<=n;i++){
			for (int j=head[i];j;j=e[j].next){
				if (vis[j]) continue;
				p.clear(); vis[j] = vis[rev(j)] = 1;
				e[j].flag = e[rev(j)].flag = 1;
				int v = e[j].to;
				dfs1(i,0); dfs1(v,0);
				dfs2(i,0,i); dfs2(v,0,v);
				for (int o=0;o<p.size();o++) ans += p[o];
				e[j].flag = e[rev(j)].flag = 0;
			}
		}
		writeln(ans);
	}
}

bool tree(){
	for (int i=1;i<=n;i++) if (deg[i]>3) return 0;
	return 1;
}

namespace sub_tree{
	int sz[M],f[M]; vector<int> p; int root; ll ans=0;
	void find_root(){
		for (int i=1;i<=n;i++) if (deg[i]==2){
			int flag = 1;
			for (int j=head[i];j;j=e[j].next){
				if (deg[e[j].to]==1) flag = 0;
			}
			if (flag) root = i;
		}
	}
	void dfs(int now,int fa){
		f[now] = fa;
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to!=fa) dfs(e[i].to,now);
		}
	}
	void dfs2(int now,int fa,int root){
		int flag = 1;
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to!=fa&&!e[i].flag){
				if (sz[e[i].to]>sz[root]/2) flag = 0;
			}
		}
		if (sz[root]-sz[now]>sz[root]/2) flag = 0;
		if (flag) p.push_back(now);
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to!=fa&&!e[i].flag) dfs2(e[i].to,now,root);
		}
	}
	void dfs1(int now,int fa,int root,int Ed){
		if (now!=root){
			p.clear();
			int tmp = now; while (tmp!=root) tmp = f[tmp], sz[tmp] -= sz[now];
			e[Ed].flag = e[rev(Ed)].flag = 1;
			dfs2(root,0,root); dfs2(now,0,now);
			for (int o=0;o<p.size();o++) ans += p[o];
			e[Ed].flag = e[rev(Ed)].flag = 0;
			tmp = now; while (tmp!=root) tmp = f[tmp], sz[tmp] += sz[now];
		}
		for (int i=head[now];i;i=e[i].next){
			if (e[i].to!=fa) dfs1(e[i].to,now,root,i);
		}
	}
	void solve(){
		ans = 0;
		find_root();
		dfs1(root,0,root,0);
	}
}

void MAIN(){
	memset(deg,0,sizeof(deg)); memset(e,0,sizeof(e)); memset(head,0,sizeof(head)); t=0;
	n = read();
	for (int i=1;i<n;i++){
		int x = read(); int y = read();
		addedge(x,y);
	}
	if (n<=2000) sub_n::solve(); else if (chain()) sub_chain::solve(); else if (tree()) sub_tree::solve(); else sub_n::solve();
}

signed main(){
	ios::sync_with_stdio(false);
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ll T = read(); while (T--) MAIN();
	return 0;
}

