#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MOD = 998244353;

int add(int x, int y) {
  return (x += y) >= MOD ? x -= MOD : x;
}

int sub(int x, int y) {
  return (x -= y) < 0 ? x += MOD : x;
}

const int N = 105, M = 1005;

int n, m;
int a[N][M];

namespace subtask_m2 {
  
  int dp[45][45][45];
  
  int main() {
    dp[0][0][0] = 1;
    for (int i = 1; i <= n; i++)
      for (int j = 0; j <= n / 2; j++)
        for (int k = 0; k <= n / 2; k++) {
          dp[i][j][k] = dp[i - 1][j][k];
          if (j) 
            dp[i][j][k] = add(dp[i][j][k], 1ll * dp[i - 1][j - 1][k] * a[i][1] % MOD);
          if (k)
            dp[i][j][k] = add(dp[i][j][k], 1ll * dp[i - 1][j][k - 1] * a[i][2] % MOD);
        }
    int ans = 0;
    for (int i = 1; i <= n / 2; i++)
      ans = add(ans, dp[n][i][i]);
    printf("%d\n", ans);
    return 0;
  }
}

namespace subtask_m3 {
  
  int dp[45][45][45][45];
  
  int main() {
    dp[0][0][0][0] = 1;
    for (int i = 1; i <= n; i++) {
      for (int j = 0; j <= n / 2; j++)
        for (int k = 0; k <= n / 2; k++) {
          for (int t = 0; t <= n / 2; t++) {
            dp[i][j][k][t] = dp[i - 1][j][k][t];
            if (j) 
              dp[i][j][k][t] = add(dp[i][j][k][t], 1ll * dp[i - 1][j - 1][k][t] * a[i][1] % MOD);
            if (k)
              dp[i][j][k][t] = add(dp[i][j][k][t], 1ll * dp[i - 1][j][k - 1][t] * a[i][2] % MOD);
            if (t) 
              dp[i][j][k][t] = add(dp[i][j][k][t], 1ll * dp[i - 1][j][k][t - 1] * a[i][3] % MOD);
          }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
      for (int j = 0; j <= i / 2; j++)
        for (int k = 0; k <= i / 2; k++) {
          int d = i - j - k; 
          if (d < 0 || d > i / 2)
            continue;
          ans = add(ans, dp[n][j][k][d]);
        }
    }
    printf("%d\n", ans);
    return 0;
  }
}

namespace subtask3 {
  int main() {
    printf("%d\n", (int)(1ll * n * m % MOD));
    return 0;
  }
}

int main() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  
  scanf("%d %d", &n, &m);
  
  for (int i = 1; i <= n; i++)
    for (int j = 1; j <= m; j++)
      scanf("%d", &a[i][j]);
  
  if (m == 2) {
    subtask_m2::main();
    return 0;
  }
  
  if (m == 3) {
    subtask_m3::main();
    return 0;
  }
  
  subtask3::main();
  
  return 0; 
}
