#include <fstream>
#include <iostream>

using namespace std;

ifstream fin("partition.in");
ofstream fout("partition.out");

int n;
long long a[500001];

long long get(int l, int r) {
	return a[r] - a[l - 1];
}

long long solve(long long l, int p) {
	if (p == n + 1) return 0;
	long long ans = 4e18;
	for (int i = p + 1; i <= n + 1; i++) {
		long long g = get(p, i - 1);
		if (g < l) continue;
		ans = min(ans, g * g + solve(g, i));
	}
	return ans;
}

int main() {
	int t;
	fin >> n >> t;
	if (t) return 0;
	else for (int i = 1; i <= n; i++) 
		fin >> a[i], a[i] += a[i - 1];
	fout << solve(0, 1) << endl;
}
