#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>

using namespace std;

const int N=300000;

vector <int > g[N];

int T,n,ans;
int vis[N];

void bfs(int u)
{
	queue <int > q;
	q.push(u);
	ans+=u;
	while(!q.empty())
	{
		int u=q.front();
		q.pop();vis[u]=1;
		for(int i=0;i<g[u].size();i++)
		{
			int v=g[u][i];
			if(!vis[v])
			{
				q.push(v);
				ans+=v;
			}
		}
		
	}
	
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	
	cin>>T;
	while(T--)
	{
		cin>>n;
		for(int i=1;i<=n-1;i++)
		{
			int u,v;
			cin>>u>>v;
			int a=min(u,v);
			int b=max(u,v);
			g[a].push_back(b);
		}
		for(int i=1;i<=n;i++)
		{
			if(!vis[i])
			{
				bfs(i);
			}
		}
	}
	cout<<ans<<endl;
	
	return 0;
}