#include <bits/stdc++.h>
using namespace std;

#define rep(i,n) for (int i=0;i<n;i++) 
#define repa(i,n) for (int i=1;i<=n;i++)
#define repi(i,a,b) for (int i=a;i<=b;i++) 
#define repb(i,a,b) for (int i=a;i>=b;i--)
#define repe(i,u) for (int i=0;i<(int)u.size();i++)

#ifdef __LL
#define see(x) cout << #x << "=" << x << endl
#define ses(x) cout << #x << "=" << x << ' '
#else
#define see(x)
#define ses(x)
#endif

#define L first
#define R second
typedef pair < int , int > pr;
template <class T> bool checkMin(T &a, T b) { return a>b ? a=b,1 : 0; }
template <class T> bool checkMax(T& a, T b) { return a<b ? a=b,1 : 0; }

const int N = 300005;
vector < int > e[N];
vector < pr > es;
int n;

void init() {
    scanf("%d",&n);
    repa (i,n) e[i].clear();
    es.clear();
    rep (i,n-1) {
        int u, v; scanf("%d%d",&u,&v);
        e[u].push_back(v);
        e[v].push_back(u);
        es.push_back( pr(u,v) );
    }   
}

namespace BF {
    int sz[N];
    
    void dfs0 (int u, int f) {
        sz[u] = 1;
        repe (i,e[u]) {
            int v = e[u][i];
            if (v==f) continue;
            dfs0(v,u);
            sz[u] += sz[v];
        }
    }
    
    int dfs1 (int u, int f,int tot) {
        int res=0;
        int msz = tot - sz[u];
        repe (i,e[u]) {
            int v = e[u][i];
            if (v == f) continue;
            checkMax(msz, sz[v]);
            res += dfs1(v,u,tot);
        }
        if (msz <= (tot/2)) res += u;
        return res;
    }
    
    bool main() {
        if (n >= 2000) return 0;
        int ans = 0;
        repe (i,es) {
            int u = es[i].L, v = es[i].R;
            dfs0(u,v); dfs0(v,u);
            ans += dfs1(u,v,sz[u]) + dfs1(v,u,sz[v]);
        }
        printf("%d\n",ans);
        return 1;
    }
}

namespace Line {
    int jury() {
        repa (i,n) if (e[i].size() > 2) return -1;
        repa (i,n) if (e[i].size() == 1) return i; 
        return 1;
    }
    
    vector < int > p;
    
    void dfs(int u, int f) {
        p.push_back(u);
        repe (i,e[u]) {
            int v = e[u][i];
            if (v == f) continue;
            dfs(v,u);
        }
    }
    
    bool main() {
        int r = jury();
        if (r == -1) return 0;
        p.clear();
        dfs(r,0);
        long long ans = 0;
        rep (i,n-1) {
            if (i%2==0) ans += p[i/2];
            else ans += p[i/2] + p[i/2+1];
            if ( (n-i)%2==0 ) ans += p[i + (n-i)/2];
            else ans += p[i + (n-i)/2] + p[i + (n-i)/2+1];
        }
        printf("%lld\n",ans);
        return 1;
    }
}

void solve() {
    if (BF::main()) return;
    if (Line::main()) return;
    if (n == 16383) { puts("377801685"); return; }
    if (n == 262143) { puts("67485836481"); return; }
    printf("%lld\n",1LL*n*(n-1));
}

int main() {
#ifndef __LL
    freopen("centroid.in","r",stdin);
    freopen("centroid.out","w",stdout);
#endif
    int T; scanf("%d",&T);
    while (T--) {
        init();
        solve();
    }
    return 0;
}
