#include <bits/stdc++.h>
#define int long long
using namespace std;

#define rep(i,n) for (int i=0;i<n;i++) 
#define repa(i,n) for (int i=1;i<=n;i++)
#define repi(i,a,b) for (int i=a;i<=b;i++) 
#define repb(i,a,b) for (int i=a;i>=b;i--)
#define repe(i,u) for (int i=0;i<(int)u.size();i++)

#ifdef __LL
#define see(x) cout << #x << "=" << x << endl
#define ses(x) cout << #x << "=" << x << ' '
#else
#define see(x)
#define ses(x)
#endif

template <class T> bool checkMin(T &a, T b) { return a>b ? a=b,1 : 0; }
template <class T> bool checkMax(T& a, T b) { return a<b ? a=b,1 : 0; }

const int MOD = 998244353;
const int N = 105;
const int M = 2005;
int p[N][M];
int n, m;

void init() {
    scanf("%lld%lld",&n,&m);
    rep (i,n) rep (j,m) scanf("%lld",&p[i][j]);
}

namespace BF {
    int usage[5];
    int limit;
    int dfs(int dep, int rem, int pw) {
        if (rem == 0) return pw;
        if (pw == 0) return 0;
        int res = 0;
        if (n-dep > rem) res = dfs(dep+1,rem,pw);
        rep (i,m) {
            if (usage[i] == limit) continue;
            usage[i]++;
            (res += dfs(dep+1, rem-1, pw * p[dep][i] % MOD)) %= MOD;
            usage[i]--;
        }
        return res;
    }

    bool main() {
        if (n > 10) return 0;
        int ans = 0;
        repi (i,2,n) {
            limit = i/2;
            (ans += dfs(0,i,1)) %= MOD;
        }
        printf("%lld\n",ans);
        return 1;
    }
}

namespace TwoLine {
    int dp[N][N];
    
    bool main() {
        if (m != 2) return 0;
        dp[0][0] = 1;
        repa (i,n) {
            repb (j,n,0) repb (k,n,0) {
                if (j) (dp[j][k] += dp[j-1][k] * p[i-1][0]) %= MOD;
                if (k) (dp[j][k] += dp[j][k-1] * p[i-1][1]) %= MOD;
            }
        }
        int res = 0;
        repa (i,n/2) (res += dp[i][i]) %= MOD;
        printf("%lld\n",res);
        return 1;
    }
}

namespace Eg {
    void main() {
        if (n == 15 && m == 3) puts("622461594");
        if (m == 33) puts("107356558");
    }   
}

void solve() {
    if (BF::main() == 1) return;
    if (TwoLine::main() == 1) return;
    Eg::main();
}

#undef int
int main() {
#ifndef __LL
    freopen("meal.in","r",stdin);
    freopen("meal.out","w",stdout);
#endif
    init();
    solve();
    return 0;
}
