#include<iostream>
#include<cstdio>
using namespace std;
int x[100005],y[100005],to[200005];
int first[200005]={},next[200005]={};
int a[100005],b[100005],p1[100005],p2[100006];
int t,n,m1,m2,ans,edgenum=0;
void addedge(int xx,int yy){
	edgenum++;
	to[edgenum]=yy;
	next[edgenum]=first[xx];
	first[xx]=edgenum;
}
void build1(int u,int fa){
	m1++; a[m1]=u; p1[a[m1]]=1;
	for(int k=first[u];k;k=next[k]){
		int v=to[k];
		if(v==fa) continue;
		build1(v,u);
	}
}
void build2(int u,int fa){
	m2++; b[m2]=u; p2[b[m2]]=1;
	for(int k=first[u];k;k=next[k]){
		int v=to[k];
		if(v==fa) continue;
		build2(v,u);
	}
}
int type1(int uu,int fa){
    int key=1;
	for(int k=first[uu];k;k=next[k]){
		int v=to[k];
		if(v==fa) continue;
		if(p1[v]==0) continue;
		key+=type1(v,uu);
	}	
	return key;
}
int type2(int uu,int fa){
    int key=1;
	for(int k=first[uu];k;k=next[k]){
		int v=to[k];
		if(v==fa) continue;
		if(p2[v]==0) continue;
		key+=type2(v,uu);
	}	
	return key;
}
void find1(){
	for(int o=1;o<=m1;o++){
		bool flag=1;
		int u=a[o];
		for(int k=first[u];k;k=next[k]){
			int v=to[k];
			if(p1[v]==0) continue;
			if(type1(v,u)>m1/2) flag=0;
		}
		if(flag) ans+=u;
	}
}
void find2(){
	for(int o=1;o<=m2;o++){
		bool flag=1;
		int u=a[o];
		for(int k=first[u];k;k=next[k]){
			int v=to[k];
			if(p2[v]==0) continue;
			if(type2(v,u)>m2/2) flag=0;
		}
		if(flag) ans+=u;
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--){
		scanf("%d",&n);
		for(int i=1;i<n;i++){
			scanf("%d%d",&x[i],&y[i]);
			addedge(x[i],y[i]); addedge(y[i],x[i]);
		}
		ans=0;
		for(int i=1;i<n;i++){
			m1=m2=0;
			for(int i=1;i<=n;i++) p1[i]=p2[i]=0;
			build1(x[i],y[i]); build2(y[i],x[i]);
			find1(); find2();
		}
		printf("%d",ans);
	}
	return 0;
}