#include <bits/stdc++.h>
using namespace std;

const int maxn = 110, maxm = 2e3 + 10;
const int mod = 998244353;

namespace {
  inline int add(int x, int y) { return (x += y) >= mod ? x - mod : x; }
  inline int sub(int x, int y) { return (x -= y) < 0 ? x + mod : x; }
  inline int mul(int x, int y) { return 1ll * x * y % mod; }
}

int n, m, s[maxn], a[maxn][maxm], f[maxn][maxn];

int main(void) {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  scanf("%d%d", &n, &m);
  int ans = 1;
  for(int i = 1; i <= n; i++) {
    s[i] = 0;
    for(int j = 1; j <= m; j++) {
      scanf("%d", &a[i][j]);
      s[i] = add(s[i], a[i][j]);
    }
    ans = add(ans, mul(ans, s[i]));
  }
  for(int i = 1; i <= m; i++) {
    memset(f, 0, sizeof f);
    f[0][0] = 1;
    for(int j = 1; j <= n; j++) {
      int thi = a[j][i];
      int oth = sub(s[j], a[j][i]);
      for(int k = j - 1; ~k; k--) {
	for(int l = k; ~l; l--) {
	  if(!f[k][l]) {
	    continue;
	  }
	  f[k + 1][l + 1] = add(f[k + 1][l + 1], mul(f[k][l], thi));
	  f[k + 1][l] = add(f[k + 1][l], mul(f[k][l], oth));
	}
      }
    }
    for(int j = 1; j <= n; j++) {
      for(int k = j; k < 2 * j; k++) {
	//cerr << "id = " << i << ", all = " << k << ", u = " << j << ", f = " << f[k][j] << endl;
	ans = sub(ans, f[k][j]);
      }
    }
  }
  cout << sub(ans, 1) << endl;
  return 0;
}
	 
