#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <cctype>

inline int get_uint () {
  register char c = getchar();
  register int x = 0;
  while (!isdigit(c)) c = getchar();
  for (; isdigit(c); c = getchar()) x = (((x << 2) + x) << 1) + (c ^ 48);
  return x;
}

const int MOD = 998244353;

inline void trim (int &x) {
  x -= MOD, x += (x >> 31) & MOD;
}

const int MAXN = 110;
const int MAXM = 2010;

int n, m, a[MAXN][MAXM], s[MAXN];
int f[MAXN][MAXN];

int main () {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
  n = get_uint();
  m = get_uint();
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      a[i][j] = get_uint();
      trim(s[i] += a[i][j]);
    }
  }
  int all = 1;
  for (int i = 1; i <= n; i++) {
    all = 1LL * all * (s[i] + 1) % MOD;
  }
  trim(all += MOD - 1);
  int bad = 0;
  for (int j = 1; j <= m; j++) {
    memset(f, 0, sizeof(f));
    f[0][0] = 1;
    for (int i = 1; i <= n; i++) {
      for (int k = i - 1; k >= 0; k--) {
        for (int l = i - 1 - k; l >= 0; l--) {
          const int &p = f[k][l];
          if (!p) continue;
          trim(f[k + 1][l] += 1LL * p * a[i][j] % MOD);
          trim(f[k][l + 1] += 1LL * p * (s[i] - a[i][j] + MOD) % MOD);
        }
      }
    }
    for (int k = 1; k <= n; k++) {
      for (int l = 0; k + l <= n && l < k; l++) {
        trim(bad += f[k][l]);
      }
    }
    // printf("%d => %d\n", j, bad);/
  }
  trim(all += MOD - bad);
  printf("%d\n", all);
  return 0;
}
