#include<cstdio>
#include<cstring>
using namespace std;
int edgenum, head[300005], nex[300005], vet[300005], grf[300005];
int uu[300005], vv[300005];
bool vis[300005];
void add(int u, int v) {
	++edgenum;
	vet[edgenum]=v;
	nex[edgenum]=head[u];
	head[u]=edgenum;
}
int siz[300005], zx[300005];
int banned;
void dfs(int s, int root) {
	siz[s]=1;
	grf[s]=root;
	vis[s]=true;
	for(register int e=head[s]; e; e=nex[e]) {
		int v=vet[e];
		if(uu[banned]==s&&vv[banned]==v||uu[banned]==v&&vv[banned]==s)continue;
		if(!vis[v]) {
			dfs(v, root);
			siz[s]+=siz[v];
		}

	}
}
int dep[300005];
void dd(int s, int fa) {
	for(register int e=head[s]; e; e=nex[e]) {
		if(vet[e]==fa)continue;
		dep[vet[e]]=dep[s]+1;
		dd(vet[e], s);
	}
}
inline int min(int x, int y) {
	return x<y?x:y;
}
inline int max(int x, int y) {
	return x>y?x:y;
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d", &T);
	while(T--) {

		int n;
		scanf("%d", &n);
		int ans=0;
		edgenum=0;
		memset(head, 0, sizeof(head));
		memset(nex, 0, sizeof(nex));
		memset(vet, 0, sizeof(vet));
		memset(dep, 0, sizeof(dep));
		bool lian=true, perf=true;
		for(register int i=1; i<n; ++i) {
			scanf("%d%d", &uu[i], &vv[i]), add(uu[i], vv[i]), add(vv[i], uu[i]);
			if(uu[i]+1!=vv[i]&&vv[i]+1!=uu[i])lian=false;
			if(!(2*min(uu[i], vv[i])==max(uu[i], vv[i])||2*min(uu[i], vv[i])==max(uu[i], vv[i])-1))perf=false;
		}
		if(lian) {
			long long ans=0;
			for(register int i=1; i<n; ++i) {
				if((1+i)%2==0)ans+=(1+i)/2;
				else ans+=(1+i);
				if((i+1+n)%2==0)ans+=(i+1+n)/2;
				else ans+=(i+1+n);
			}
			printf("%lld\n", ans);
		} else if(n<=7) {
			dep[1]=1;
			dd(1, 0);
			for(banned=1; banned<n; ++banned) {
				memset(siz, 0, sizeof(siz));
				memset(grf, 0, sizeof(grf));
				memset(vis, 0 ,sizeof(vis));
				//	if(uu[banned-1]==vv[banned]&&vv[banned-1]==uu[banned])continue;
				for(int i=1; i<=n; ++i)
					if(!vis[i])
						dfs(i, i);
				int kk=dep[uu[banned]]>dep[vv[banned]]?uu[banned]:vv[banned];
				for(int i=1; i<=n; ++i) {
					if(siz[grf[i]]-siz[i]<=siz[grf[i]]/2) {
						bool flag=true;
						for(register int e=head[i]; e; e=nex[e]) {
							if(uu[banned]==i&&vv[banned]==vet[e]||vv[banned]==vet[e]&&uu[banned]==i)continue;
							if(dep[vet[e]]>dep[i]&&siz[vet[e]]>siz[grf[i]]/2) {
								flag=false;
								break;
							}
						}
						if(flag)++zx[i], ans+=i;;
					}

				}
			}
//	for(register int i=1; i<1<<n; ++i)printf("%d ", zx[i]);
			printf("%d\n", ans);
		} else {
			for(register int i=1; i<=n; ++i) {
				if((1<<i)-1==n)printf("%lld\n", 1ll*((1ll<<(i-1))*3+n-3));
			}
		}
	}
	return 0;
}
