// 36pts + 0~16pts
//         ~~~~~~~~~~~
//         : SA() [对拍结果 58% 加辅助初始化函数结果 43%]
#include <bits/stdc++.h>
using namespace std;
#define file_io_locat(name){freopen(name".in","r",stdin);freopen(name".out","w", stdout);}

template <typename nt> nt read() {
    bool flg = 0; nt nit = 0; char ch = getchar();
    while (!isdigit(ch) && ch != '-') ch = getchar(); if (ch == '-') {flg = 1; ch = getchar();}
    while(isdigit(ch)) {nit = (((nit<< 2)+nit)<<1)+(ch&15);ch= getchar();} return flg?(~nit+1):nit;
}

int n, type;
int a[40000007];
long long qzs[40000007];
long long f[40000007];
long long finalAns = 4000000000000000009LL;
typedef int GetInInt(void);
GetInInt *getint = read<int>;

#ifdef LTT
long long dfs_cnt;
#endif
void dfs(int u, long long mx, long long tot, long long ans)
{
#ifdef LTT
    dfs_cnt++;
#endif
    if (tot > mx) return;
    // if (ans > finalAns) return;
    // if (ans + tot * tot > finalAns) return;
    if (ans + tot * tot + qzs[u] > finalAns) return;
    if (!u) {
        ans += tot * tot;
        finalAns = min(finalAns, ans);
        return;
    }
    if (tot + a[u] <= mx) dfs(u - 1, mx, tot + a[u], ans);
    dfs(u - 1, tot, a[u], ans + tot * tot);
}

#define bRand() (rand() * RAND_MAX + rand())
#define bRandMax (RAND_MAX * RAND_MAX)
#define rndDouble() ((double)bRand() / bRandMax)

void magic_SA()
{
    long long tot = 0, sum = 0, mx = 4e18;
    for (int i = n; i >= 1; i--) {
        // printf("i = %d : ", i);
        if (tot + a[i] > mx) {
            // printf("[Case 1] must add.\n");
            if (a[i] > mx) {
                return;
                // printf("a[i] > Mx!! Fail!! Return!!\n");
            }
            sum += tot * tot;
            mx = tot;
            tot = a[i];
            if (sum >= finalAns) return;
            continue;
        }
        if (exp(i / n) / 2 > rndDouble()) {
            // printf("[Case 2] random ok => SA.\n");
            tot += a[i];
        } else {
            // printf("[Case 3] random fail => TanXin.\n");
            sum += tot * tot;
            mx = tot;
            if (a[i] > mx) return;
            tot = a[i];
            if (sum >= finalAns) return;
            continue;
        }
    }
    finalAns = min(finalAns, sum + tot * tot);
}

void MagicCase()
{
    // magic_SA();
    // printf("%lld", finalAns);
    // return;
    while (clock() < 1.86 * CLOCKS_PER_SEC) {
        magic_SA();
    }
    printf("%lld", finalAns);
}

#define _correctAnswer
void correctAnswer()
{
    finalAns = 0;
    long long tot = 0, mn = 0, where = 0;
    for (int i = 1; i <= n; i++) {
        if (tot >= mn) {
            finalAns += tot * tot;
            mn = tot;
            tot = 0;
            // where++;
        }
        tot += a[i];
        // f[i] = where;
    }
    finalAns += (mn + tot) * (mn + tot);
}

int main()
{
    srand(time(0) ^ clock() ^ 20170933);
    file_io_locat("partition");
    n = read<int>();
    type = read<int>();
    for (int i = 1; i <= n; i++) {
        a[i] = getint();
        qzs[i] = qzs[i - 1] + (long long)a[i] * a[i];
        // sum[i] = sum[i - 1] + a[i];
    }
    // for (int i = n; i >= 1; i--) {
    // }
    if (n <= 100) {
        dfs(n, 4e18, 0, 0); // O(2^n)
        printf("%lld", finalAns);
    } else {
// #ifdef _correctAnswer
        correctAnswer();
// #endif 
        MagicCase();
    }
    return 0;
}