#include <bits/stdc++.h>
using namespace std;

bool chain;
const int N = 3e5;
int n, degree[N], to[N << 1], nxt[N << 1], head[N], tot, t, a[N], cnt, x[N], y[N], sz[N], f[N];
long long ans;

inline void addedge(int x, int y)
{
	to[++tot] = y;
	nxt[tot] = head[x];
	head[x] = tot;
}

void search(int x, int pre)
{
	a[++cnt] = x;
	for (int i = head[x]; i; i = nxt[i])
	{
		if (to[i] == pre) continue;
		search(to[i], x);
	}
}

inline void doit() 
{
	cnt = 0;
	int front;
	for (int i = 1; i <= n; i++)
		if (degree[i] == 1) 
		{
			front = i;
			break;
		}
	search(front, 0);
	for (int i = 1; i < n; i++)
	{
		ans += a[(i + 1) >> 1];
		if (!(i & 1)) ans += a[((i + 1) >> 1) + 1];
		ans += a[(i + 1 + n) >> 1];
		if (!((i ^ n) & 1)) ans += a[((i + 1 + n) >> 1) + 1];
	}
	printf("%lld\n", ans);
}

void dfs(int x, int fa, int sum)
{
	bool flag = 1;
	if (sz[x] * 2 < sum) flag = 0;
	for (int i = head[x]; i; i = nxt[i])
	{
		int y = to[i];
		if (y == fa) continue;
		if (sz[y] * 2 > sum) flag = 0;
		dfs(y, x, sum);
	}
	if (flag) ans += x;
}

void init(int x, int fa)
{
	sz[x] = 1, f[x] = fa;
	for (int i = head[x]; i; i = nxt[i])
	{
		int y = to[i];
		if (y == fa) continue;
		init(y, x);
		sz[x] += sz[y];
	}
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &t);
	while (t--)
	{
		scanf("%d", &n);
		chain = 1;
		memset(degree, 0, sizeof degree);
		memset(head, 0, sizeof head);
		tot = 0; ans = 0;
		for (int i = 1; i < n; i++) 
		{
			scanf("%d%d", x + i, y + i);
			addedge(x[i], y[i]); addedge(y[i], x[i]); ++degree[x[i]], ++degree[y[i]];
			if (degree[x[i]] > 2 || degree[y[i]] > 2) chain = 0;
		}
		if (chain) doit(); 
		else 
		{
			for (int i = 1; i < n; i++) 
				init(x[i], y[i]), dfs(x[i], y[i], sz[x[i]]), init(y[i], x[i]), dfs(y[i], x[i], sz[y[i]]);
			printf("%lld\n", ans);
		}
	}
}
