#include<bits/stdc++.h>
#define FOR(i,a,b) for(int i=(a),i##_end_=(b);i<=i##_end_;i++)
#define DOR(i,a,b) for(int i=(a),i##_end_=(b);i>=i##_end_;i--)
#define ll long long
#define M 105
#define N 2005
#define P 998244353
using namespace std;

template<class _>void Add(_ &a,_ b){
	a+=b;
	if(a>=P)a-=P;
}

template<class _>void Del(_ &a,_ b){
	a-=b;
	if(a<0)a+=P;
}

int n,m;
int A[M][N];

struct P1{

	int mark[15][5];
	int ans;

	void check(){
		int tot=0;
		FOR(i,1,n){
			FOR(j,1,m){
				tot+=mark[i][j];
			}
		}
		if(tot<=1)return;
		int res=1;
		FOR(j,1,m){
			int cnt=0;
			FOR(i,1,n){
				cnt+=mark[i][j];
			}
			if(cnt>tot/2)return;
		}
		FOR(i,1,n){
			FOR(j,1,m){
				if(!mark[i][j])continue;
				res=1ll*res*A[i][j]%P;
			}
		}
		ans=(ans+res)%P;
	}

	void dfs(int x,int y){
		if(x==n+1){
			check();
			return;
		}
		if(y==m+1){
			dfs(x+1,1);
			return;
		}
		if(A[x][y]==0)dfs(x,y+1);
		else {
			mark[x][y]=1;
			dfs(x+1,1);
			mark[x][y]=0;
			dfs(x,y+1);
		}
	}

	void solve(){
		dfs(1,1);
		printf("%d\n",ans);
	}

}p1;

struct P2{

	ll sum[M];
	ll dp[M][M];
	ll Dp[M][M*2];
	ll tot[M];
	ll ans;

	void solve(){
		FOR(i,1,n){
			sum[i]=0;
			int f=0;
			FOR(j,1,m){
				if(A[i][j])f=1,sum[i]=(sum[i]+A[i][j])%P;
			}
			if(f==0)sum[i]=0;
		}
		dp[1][0]=1;
		dp[1][1]=sum[1];
		FOR(i,2,n){
			dp[i][0]=1;
			FOR(j,1,i){
				dp[i][j]=(dp[i-1][j]+1ll*dp[i-1][j-1]*sum[i])%P;
			}
		}
		FOR(i,1,n)Add(ans,dp[n][i]);
		FOR(t,1,m){
			FOR(j,1,n){
				tot[j]=sum[j];
				tot[j]=((sum[j]-A[j][t])%P+P)%P;
			}
			memset(Dp,0,sizeof(Dp));
			Dp[1][101]=A[1][t];
			Dp[1][99]=tot[1];
			Dp[1][100]=1;
			FOR(i,1,n-1){
				FOR(j,0,n+100){
					if(Dp[i][j]==0)continue;
					if(j<n+100)Add(Dp[i+1][j+1],Dp[i][j]*A[i+1][t]%P);
					if(j>0)Add(Dp[i+1][j-1],Dp[i][j]*tot[i+1]%P);
					Add(Dp[i+1][j],Dp[i][j]);
				}
			}
			FOR(i,101,n+100)Del(ans,Dp[n][i]);
		}
		printf("%lld\n",ans);
	}

}p2;

int main(){
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	scanf("%d%d",&n,&m);
	FOR(i,1,n){
		FOR(j,1,m){
			scanf("%d",&A[i][j]);
		}
	}
//	if(n*m<=30)p1.solve();
	/*else*/ p2.solve();
	return 0;
}
