#include <bits/stdc++.h>
using namespace std;
int sze[300010], wson[300010];
int head[300010], tot, n, t;
long long ans;
struct edge {
    int v, nxt;
} e[600010];
inline void addedge(int u, int v) {
    e[++tot].v = v;
    e[tot].nxt = head[u];
    head[u] = tot;
}
int dp[300010];
int mid1 = 0, mid2 = 0;
int son[300010], cnt;
int tag;
int fat[300010];
inline void init() {
    tot = 0;
    ans = 0;
    tag = cnt = 0;
    memset(head, 0, sizeof head);
    memset(sze, 0, sizeof sze);
    memset(wson, 0, sizeof wson);
    memset(dp, 0, sizeof dp);
}
inline void dfs_for_size(int now, int fa) {
    fat[now] = fa;
    sze[now] = 1;
    wson[now] = 0;
    for (int i = head[now]; i; i = e[i].nxt) {
        if (e[i].v == fa) continue;
        dfs_for_size(e[i].v, now);
        sze[now] += sze[e[i].v];
        if (sze[e[i].v] > sze[wson[now]]) wson[now] = e[i].v;
    }
}
inline void dp1(int now, int fa) {
    if (wson[now] == 0) {
        dp[now] = now;
        if (fa) ans += now;
        return;
    }
    for (int i = head[now]; i; i = e[i].nxt) {
        if (e[i].v == fa) continue;
        dp1(e[i].v, now);
    }
    dp[now] = dp[wson[now]];
    while ((sze[now] - sze[dp[now]]) > sze[now] / 2) dp[now] = fat[dp[now]];
    if (fa) {
        ans += dp[now];
        if (dp[now] != now && (sze[wson[fat[dp[now]]]] <= sze[now] / 2 && (sze[now] - sze[fat[dp[now]]]) <= n / 2))
            ans += fat[dp[now]];
    }
}
inline int cmp(int a, int b) {
    return sze[a] > sze[b];
}
inline int get_mid(int now, int fa, int ban, int sum) {
    int ans = 0, max_sze = 0;
    for (int i = head[now]; i; i = e[i].nxt) {
        if (e[i].v == ban || e[i].v == fa) continue;
        ans = get_mid(e[i].v, now, ban, sum);
        max_sze = max(max_sze, sze[e[i].v]);
        if (ans) return ans;
    }
    if (sum - sze[now] <= sum / 2 && max_sze <= sum / 2) return now;
    return 0;
}
inline void dp2(int now, int fa) {
    int m = n - sze[now];
    while (dp[now] != mid1 && (m - sze[dp[now]] > m / 2 || sze[wson[dp[now]]] > m / 2)) dp[now] = fat[dp[now]];
    ans += dp[now];
    if (dp[now] != mid1) {
        int d = fat[dp[now]];
        if (d == mid1) {
            int chk;
            if (tag == 1) {
                chk = cnt == 1 ? 0 : sze[son[2]];
            }
            else chk = sze[son[1]];
            if (chk <= m / 2) ans += mid1;
        }
        else {
            if (m - sze[d] <= m / 2 && sze[wson[d]] <= m / 2) ans += d;
        }
    }
    if (mid2 != dp[now] && mid2 != dp[fat[now]]) {
        int chk = n - sze[mid2];
        if (son[tag] != mid2) {
            chk = max(chk, sze[wson[mid2]]);
            if (chk <= m / 2) ans += mid2;
        }
    }
    vector <int> son;
    for (int i = head[now]; i; i = e[i].nxt) {
        if (e[i].v == fa) continue;
        son.push_back(e[i].v);
    }
    sort(son.begin(), son.end(), cmp);
    if (son.size()) dp[son[0]] = dp[now], dp2(son[0], now);
    for (int i = 1; i < son.size(); i++) dp[son[i]] = dp[son[i - 1]], dp2(son[i], now);
}
inline void dp3(int now, int fa, int tag) {
    for (int i = head[now]; i; i = e[i].nxt) if (e[i].v != fa) dp3(e[i].v, now, tag);
    int m = n - sze[now];
    if (tag == -1) {
        if (n - sze[mid2] <= m / 2 && sze[wson[mid2]] <= m / 2) ans += mid2;
    }
    else {
        if (n - sze[mid2] <= m / 2 && max(tag, sze[wson[mid2]] - sze[now]) <= m / 2) ans += mid2;
    }
}
int main() {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    scanf("%d", &t);
    while (t--) {
        init();
        scanf("%d", &n);
        for (int i = 1; i < n; i++) {
            int u, v;
            scanf("%d%d", &u, &v);
            addedge(u, v);
            addedge(v, u);
        }
        dfs_for_size(1, 0);
        mid1 = 0, mid2 = 0;
        for (int i = 1; i <= n; i++) {
            if (sze[wson[i]] <= n / 2 && (n - sze[i]) <= n / 2) {
                if (mid1 == 0) mid1 = i;
                else mid2 = i;
            }
        }
        for (int i = head[mid1]; i; i = e[i].nxt) {
            son[++cnt] = e[i].v;
        }
        dfs_for_size(mid1, 0);
        sort(son + 1, son + 1 + cnt, cmp);
        dp[son[1]] = get_mid(mid1, 0, son[1], n - sze[son[1]]);
        if (dp[son[1]] == 0) dp[son[1]] = mid1;
        tag = 1;
        dp2(son[1], mid1);
        if (cnt) {
            dp[son[2]] = get_mid(mid1, 0, son[2], n - sze[son[2]]);
            for (int i = 2; i <= cnt; i++) {
                tag = i;
                dp2(son[i], mid1);
                if (i != cnt) dp[son[i + 1]] = dp[son[i]];
            }
        }
        dp1(mid1, 0);
        cnt = 0;
        for (int i = head[mid2]; i; i = e[i].nxt) {
            if (e[i].v == mid1) continue;
            son[++cnt] = e[i].v;
        }
        sort(son + 1, son + 1 + cnt, cmp);
        for (int i = 2; i <= cnt; i++) dp3(son[i], mid2, -1);
        if (cnt) dp3(son[1], mid2, cnt == 1 ? 0 : sze[son[2]]);
        printf("%lld\n", ans);
        fflush(stdout);
    }
    return 0;
}