#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

typedef long long li;

const int maxn = 5e5;
const li infl = ~0LLU >> 2;

int n, type;
int a[maxn];
int f[maxn + 1];
li psum[maxn + 1];
int act[maxn + 1];

template <class T>
inline void Min(T &x, T y) {
  if (y < x) x = y;
}

template <class T>
inline void Max(T &x, T y) {
  if (y > x) x = y;
}

int main(void) {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);

  scanf("%d%d", &n, &type);
  psum[0] = 0;
  for (int i = 0; i < n; ++i) {
    scanf("%d", a + i);
    psum[i + 1] = psum[i] + a[i];
  }

  int max_tran = 0;
  for (int i = 0; i <= n; ++i) {
    Max(max_tran, act[i]);
    f[i] = max_tran;
    li part = psum[i] - psum[f[i]];
    li least = psum[i] + part;
    int j = lower_bound(psum, psum + n + 1, least) - psum;
    Max(act[j], i);
  }

  li ans = 0;
  for (int i = n; i > 0; i = f[i]) {
    li part = psum[i] - psum[f[i]];
    ans += part * part;
  }
  printf("%lld\n", ans);
  return 0;
}
