#define FILE_NAME "brackets"
//*INDENT OFF*
#include<bits/stdc++.h>
using namespace std;
template<typename T>
bool tomin(T &x,T y) { if(y<x) { x=y; return true; } return false; }
template<typename T>
bool tomax(T &x,T y) { if(x<y) { x=y; return true; } return false; }
typedef long long ll;
#define FILE_IO freopen(FILE_NAME".in","r",stdin);freopen(FILE_NAME".out","w",stdout)
//*INDENT ON*
const int M=5e5+5;
int n,fa[M];
ll Ans[M];
char S[M];
vector<int>E[M];
namespace P_20 {
	int Stk[M],top;
	int Check() {
		int n=top,ret=0;
		for(int l=1;l<=n;l++) {
			int t=0;
			for(int i=l;i<=n;i++) {
				t+=Stk[i];
				if(t==0) ret++;
				else if(t<0) break;
			}
		}
		return ret;
	}
	void dfs0(int x) {
		Stk[++top]=S[x];
		Ans[x]=Check();
		for(int i=0;i<E[x].size();i++) {
			int v=E[x][i];
			if(v==fa[x]) continue;
			dfs0(v);
		}
		--top;
	}
	ll GetAns() {
		ll t=0;
		for(int i=1;i<=n;i++) {
			t=t^((ll)i*Ans[i]);
		}
		return t;
	}
	void Solve() {
		dfs0(1);
		cout<<GetAns()<<endl;
	}
}
namespace P_X {
	int StkNow[M],StkL[M],top,Ltop,St[M],PreStkL[M],PreStkNow[M],PreLtop[M];
	void Check(int x) {
		if(S[x]==1) {
			PreLtop[x]=Ltop;
			++Ltop;
			PreStkL[x]=StkL[Ltop];
			StkL[Ltop]=0;
			PreStkNow[x]=StkNow[Ltop];
			StkNow[Ltop]=0;
			St[x]=1;
		} else {
			PreLtop[x]=Ltop;
			--Ltop;
			if(Ltop<0) {
				Ltop=0;
				PreStkL[x]=StkL[Ltop];
				StkL[Ltop]=0;
				PreStkNow[x]=StkNow[Ltop];
				StkNow[Ltop]=0;
				St[x]=2;
			} else {
				PreStkNow[x]=StkNow[Ltop];
				Ans[x]+=++StkNow[Ltop];
				St[x]=3;
			}
		}
	}
	void Check_rollback(int x) {
		if(St[x]==3) {
			--StkNow[Ltop];
			Ltop=PreLtop[x];
		} else if(St[x]==2) {
			StkNow[Ltop]=PreStkNow[x];
			StkL[Ltop]=PreStkL[x];
			Ltop=PreLtop[x];
		} else {
			StkNow[Ltop]=PreStkNow[x];
			StkL[Ltop]=PreStkL[x];
			Ltop=PreLtop[x];
		}
	}
	void dfs0(int x) {
		Ans[x]=Ans[fa[x]];
		Check(x);
		for(int i=0;i<E[x].size();i++) {
			int v=E[x][i];
			if(v==fa[x]) continue;
			dfs0(v);
		}
		Check_rollback(x);
	}
	ll GetAns() {
		ll t=0;
		for(int i=1;i<=n;i++) {
			t=t^((ll)i*Ans[i]);
		}
		return t;
	}
	void Solve() {
		dfs0(1);
		cout<<GetAns()<<endl;
	}
}
int main() {
	FILE_IO;
	scanf("%d",&n);
	scanf("%s",S+1);
	for(int i=1;i<=n;i++) S[i]=(S[i]=='(')?1:-1;
	for(int i=2;i<=n;i++) {
		scanf("%d",&fa[i]);
		E[fa[i]].push_back(i);
	}
	if(n<=100) P_20::Solve();
	else P_X::Solve();
	return 0;
}
/*
*/
