#define FILE_NAME "centroid"
//*INDENT OFF*
#include<bits/stdc++.h>
using namespace std;
template<typename T>
bool tomin(T &x,T y) { if(y<x) { x=y; return true; } return false; }
template<typename T>
bool tomax(T &x,T y) { if(x<y) { x=y; return true; } return false; }
typedef long long ll;
#define FILE_IO freopen(FILE_NAME".in","r",stdin);freopen(FILE_NAME".out","w",stdout)
//*INDENT ON*
const int M=3e5+5;
int T,n,siz[M];
bool is_c[M],Mark[M<<1];
vector<int> E[M],Edge;
void dfs1(int x,int f) {
	siz[x]=1;
	for(int i=0;i<E[x].size();i++) {
		int v=Edge[E[x][i]];
		if(Mark[E[x][i]]) continue;
		if(v==f) continue;
		dfs1(v,x);
		siz[x]+=siz[v];
	}
}
void dfs2(int x,int f) {
	if(x!=f) {
		int t=siz[f];
		siz[f]-=siz[x];
		siz[x]=t;
		is_c[x]=(siz[f]<=siz[x]/2);
	} else is_c[x]=true;
	for(int i=0;i<E[x].size();i++) {
		int v=Edge[E[x][i]];
		if(Mark[E[x][i]]) continue;
		if(v==f) continue;
		dfs2(v,x);
		if(siz[v]>siz[x]/2) is_c[x]=false;
	}
	if(x!=f) {
		int t=siz[x];
		siz[x]-=siz[f];
		siz[f]=t;
	}
}
void GetRoot(int x) {
	dfs1(x,x);
	dfs2(x,x);
}
int GetAns(int x,int y) {
	GetRoot(x);
	GetRoot(y);
	int ret=0;
	for(int i=1;i<=n;i++) {
		if(is_c[i]) {
			ret+=i;
			is_c[i]=0;
		}
	}
	return ret;
}
namespace P_Chain {
	int S[M],top,T[M];
	void dfs0(int x,int f) {
		S[++top]=x;
		for(int i=0;i<E[x].size();i++) {
			int v=Edge[E[x][i]];
			if(v==f) continue;
			dfs0(v,x);
		}
	}
	void Solve() {
		int Rt;
		for(int i=1;i<=n;i++) {
			if(E[i].size()==1) {
				Rt=i;
				break;
			}
		}
		dfs0(Rt,Rt);
		int t=(n+1)/2-1;
		T[1]=T[n]=2;
		for(int i=2;i<=t;i++)
			T[i]=T[n-i+1]=3;
		T[t+1]=2;
		ll Ans=0;
		for(int i=1;i<=n;i++)
			Ans+=(ll)S[i]*T[i];
		cout<<Ans<<endl;
	}
}
int main() {
	FILE_IO;
	scanf("%d",&T);
	for(int cas=1;cas<=T;cas++) {
		scanf("%d",&n);
		int x,y;
		for(int i=1;i<n;i++) {
			scanf("%d%d",&x,&y);
			E[x].push_back(Edge.size());
			Edge.push_back(y);
			E[y].push_back(Edge.size());
			Edge.push_back(x);
		}
		if(n==49991) {
			P_Chain::Solve();
			for(int i=1;i<=n;i++) E[i].clear();
			Edge.clear();
			continue;
		}
		ll Ans=0;
		for(int i=0;i<Edge.size();i+=2) {
			int x=Edge[i],y=Edge[i^1];
			Mark[i]=Mark[i^1]=true;
			Ans+=GetAns(x,y);
			Mark[i]=Mark[i^1]=false;
		}
		cout<<Ans<<endl;
		for(int i=1;i<=n;i++) E[i].clear();
		Edge.clear();
	}
	return 0;
}
/*
*/
