#include<bits/stdc++.h>
#define ll long long
inline ll rd() {
	ll x=0,f=1;
	char ch=getchar();
	while(!(ch>='0'&&ch<='9')&&ch!='-'&&ch!=EOF) ch=getchar();
	if (ch=='-') ch=getchar(),f=-1;
	while(ch>='0'&&ch<='9') x=x*10+ch-'0',ch=getchar();
	return x*f;
}
#define maxn 300005
int T;
bool tag[maxn<<1];
int nx[maxn<<1],to[maxn<<1],hd[maxn],cnt;
inline void add(int u,int v) {
	nx[++cnt]=hd[u],to[cnt]=v,hd[u]=cnt;
}
int d[maxn];
int X[maxn],Y[maxn];
int n;
namespace subtask1 {
	int f[maxn],sz[maxn];
	int dfs(int u,int fa) {
		sz[u]=1;
		for(int i=hd[u];i;i=nx[i]) if (!tag[i]&&to[i]!=fa) {
			int x=dfs(to[i],u);
			sz[u]+=x;
			f[u]=std::max(f[u],x);
		}
		return sz[u];
	}
	int query(int u,int S,int fa) {
		int ans=0;
		if (std::max(f[u],S-sz[u])<=S/2) ans+=u;
		for(int i=hd[u];i;i=nx[i]) if (!tag[i]&&to[i]!=fa) {
			ans+=query(to[i],S,u);
		}
		return ans;
	}
	void main() {
		ll ans=0;
		for(int i=1;i<n;i++) {
			memset(f,0,sizeof f);
			tag[i*2]=tag[i*2+1]=1;
			int x=dfs(X[i],0);
			int y=dfs(Y[i],0);
			ans+=query(X[i],x,0);
			ans+=query(Y[i],y,0);
			tag[i*2]=tag[i*2+1]=0;
		}
		printf("%lld\n",ans);
	}
}
namespace subtask2 {
	int dep[maxn],adep[maxn];
	int solve(int l,int r) {
		if ((r-l+1)%2==0) return adep[(l+r)>>1]+adep[((l+r)>>1)+1];
		else return adep[(l+r)>>1];
	}
	void main() {
		memset(dep,0,sizeof dep);
		ll ans=0;
		int top=0;
		for(int i=1;i<=n;i++) {
			if (d[i]==1) top=i;
		}
		dep[top]=1,adep[1]=top;
		for(int i=top;d[i]>1||i==top;) {
			int la=i;
			for(int j=hd[i];j;j=nx[j]) if (!dep[to[j]]) {
				i=to[j];
				break;
			}
			dep[i]=dep[la]+1;
			adep[dep[i]]=i;
		}
		for(int i=1;i<n;i++) {
			ans+=solve(1,i)+solve(i+1,n);
		}
		printf("%lld\n",ans);
	}
}
namespace subtask3 {
	int sz[maxn];
	int fa[maxn];
	void dfs(int u) {
		sz[u]=1;
		for(int i=hd[u];i;i=nx[i]) if (to[i]!=fa[u])
			fa[to[i]]=u,dfs(to[i]),sz[u]+=sz[to[i]];
	}
	int calcsz(int u,int v) {
		if (fa[u]==v) return n-sz[u];
		else return sz[v];
	}
	int solve(int u,int nowsz,int S,int fa) {
		int mx=0,po;
		for(int i=hd[u];i;i=nx[i]) if (to[i]!=fa&&!tag[i]) {
			if (calcsz(u,to[i])>mx) mx=calcsz(u,to[i]),po=to[i];
		}
		int ans=0;
		if (std::max(S-nowsz,mx)<=S/2) ans+=u;
		if (mx)
			ans+=solve(po,mx,S,u);
		return ans;
	}
	void main() {
		dfs(1);
		ll ans=0;
		for(int i=1;i<n;i++) {
			tag[i*2]=tag[i*2+1]=1;
			if (fa[X[i]]==Y[i]) {
				ans+=solve(X[i],sz[X[i]],sz[X[i]],0);
				ans+=solve(Y[i],sz[1]-sz[X[i]],sz[1]-sz[X[i]],0);
			}
			else {
				ans+=solve(Y[i],sz[Y[i]],sz[Y[i]],0);
				ans+=solve(X[i],sz[1]-sz[Y[i]],sz[1]-sz[Y[i]],0);
			}
			tag[i*2]=tag[i*2+1]=0;
		}
		printf("%lld\n",ans);
	}
}
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=rd();
	while(T--) {
		n=rd();
		memset(hd,0,sizeof hd),cnt=1;
		memset(d,0,sizeof d);
		for(int i=1;i<n;i++) {
			int x=rd(),y=rd();
			X[i]=x,Y[i]=y;
			add(x,y),add(y,x);
			d[x]++,d[y]++;
		}
		if (n<=2000) {
			subtask1::main();
			continue;
		}
		bool flag=1;
		for(int i=1;i<=n;i++) {
			if (d[i]>2) flag=0;
		}
		if (flag) {
			subtask2::main();
			continue;
		}
		subtask3::main();
		
	}
	return 0;
}
