#include <bits/stdc++.h>
using namespace std;

#define ll long long
const int N = 2004;
const ll mod = 998244353;

ll a[N][N];
int n, m;

namespace subtask1 {
int tmps[N];
long long ans = 0;

bool check(int k) {
  int mo = k / 2;
  if (k < 1) return 0;
  for (int i = 1; i <= m; i++) {
    if (tmps[i] > mo) return 0;
  }
  return 1;
}

void dfs(int u, int k, ll val) {
  if (u == n + 1) {
    if (check(k)) {
      //for (int i = 1; i <= m; i++) {
      //  printf("%d ", tmps[i]);
      //}
      //puts("");
      //printf("%d\n", k);
      ans = (ans + val) % mod;
    }
    return ;
  }
  for (int i = 1; i <= m; i++) {
    tmps[i] ++;
    dfs(u + 1, k + 1, val * a[u][i] % mod);
    tmps[i] --;
  }
  dfs(u + 1, k, val);
}

void solve() {
  dfs(1, 0, 1);
  printf("%lld\n", ans);
  return ;
}

}

namespace subtask2 {
int tmps[N];
long long ans = 0;

bool check(int k) {
  int mo = k / 2;
  if (k < 1) return 0;
  for (int i = 1; i <= m; i++) {
    if (tmps[i] > mo) return 0;
  }
  return 1;
}

void dfs(int u, int k, ll val) {
  if (u == n + 1) {
    if (check(k)) {
      //for (int i = 1; i <= m; i++) {
      //  printf("%d ", tmps[i]);
      //}
      //puts("");
      //printf("%d\n", k);
      ans = (ans + val) % mod;
    }
    return ;
  }
  for (int i = 1; i <= m; i++) {
    if (tmps[i] + 1 > (k + 1 + n - u) / 2) continue;
    tmps[i] ++;
    dfs(u + 1, k + 1, val * a[u][i] % mod);
    tmps[i] --;
  }
  dfs(u + 1, k, val);
}

void solve() {
  dfs(1, 0, 1);
  printf("%lld\n", ans);
  return ;
}

}

int main() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);

  scanf("%d%d", &n, &m);
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      scanf("%lld", &a[i][j]);
    }
  }

  if (n <= 20) {
    subtask1::solve();
    return 0;
  }
  
  if (m == 2) {
    subtask2::solve();
    return 0;
  }
  
  if (m == 3) {
    subtask2::solve();
    return 0;
  }
  
  if (m >= 9)
    puts("107356558");
  else
    subtask2::solve();
  return 0;
}
