#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int N=800005;
int Next[N],head[N],vet[N],edge,Size[N],x[N],y[N],a[N],deg[N];
int n,Q,notallow,root,num,sum1,sum2,Alone;
long long ans;
inline int read(){
	char ch=getchar();
	int x=0;bool flag=0;
	while (ch<'0'||ch>'9') flag|=(ch=='-'),ch=getchar();
	while (ch>='0'&&ch<='9') x=(x<<3)+(x<<1)+ch-48,ch=getchar();
	if (flag) return -x; else return x;
}
inline void add(int u,int v){
	Next[++edge]=head[u];
	head[u]=edge;
	vet[edge]=v;
}
void dfs(int u,int fa){
	Size[u]=1;
	for (int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if (v==fa||i==notallow||i==(notallow^1)) continue;
		dfs(v,u);
		Size[u]+=Size[v];
	}
}
void dfs2(int u,int fa){
	bool flag=1;
	for (int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if (v==fa||i==notallow||i==(notallow^1)) continue;
		dfs2(v,u);
		if (Size[v]>(Size[root]>>1)) flag=0;
	}
	if (flag&&(Size[root]-Size[u])<=(Size[root]>>1)) ans+=u;
}
void Dfs(int u,int fa){
	a[++num]=u;
	for (int i=head[u];i;i=Next[i]){
		int v=vet[i];
		if (v==fa) continue;
		Dfs(v,u);
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	Q=read();
	while (Q--){
		memset(head,0,sizeof(head));
		memset(deg,0,sizeof(deg));
		edge=1;ans=0;sum1=sum2=0;
		n=read();
		for (int i=1;i<n;++i){
			x[i]=read();
			y[i]=read();
			add(x[i],y[i]);
			add(y[i],x[i]);
			deg[x[i]]++;
			deg[y[i]]++;
		}
		if (n<=5000){
			for (int i=1;i<n;++i){
				memset(Size,0,sizeof(Size));
				notallow=i+i;
				root=x[i];
				dfs(x[i],0);
				dfs2(x[i],0);
				root=y[i];
				dfs(y[i],0);
				dfs2(y[i],0);
			}
			printf("%lld\n",ans);
			continue;
		}
		for (int i=1;i<=n;++i) {
			if (deg[i]==2) ++sum2;
			if (deg[i]==1) ++sum1;
		}
		if (sum1==2&&sum2==n-2){
			for (int i=1;i<=n;++i) 
				if (deg[i]==1) {
					Alone=i;
					break;
				}
			num=0;
			Dfs(Alone,0);
			if (n&1) {
				ans=3LL*n*(n+1);
				ans=ans/2;
				ans=ans-a[1]-a[n]-a[(n+1)>>1];
			} else {
				ans=3LL*n*(n+1);
				ans=ans/2;
				ans=ans-a[1]-a[n]-a[n>>1]-a[(n>>1)+1];
			}
			printf("%lld\n",ans);
		}
	}
	return 0;
}
