#include <cstdio>
#include <algorithm>
#include <cstring>
#define For(i,l,r) for(int i=l;i<=r;i++)
#define Dor(i,l,r) for(int i=l;i>=r;i--)
#define ll long long
#define N 300005
using namespace std;

struct node{
	int nxt,arr;
}edge[N*2];
int t,n,u[N],v[N];
int head[N*2],cnt,sz[N],Maxson[N],a,b;
ll ans;
void add(int x,int y){
	edge[++cnt].nxt=head[x];
	head[x]=cnt;
	edge[cnt].arr=y;
}

void dfs1(int t,int f){
	sz[t]=1;
	for(int i=head[t];i;i=edge[i].nxt){
		int v=edge[i].arr;
		if (v!=f){
			if ((v==a && t==b) || (v==b && t==a)) continue;
			dfs1(v,t);
			sz[t]+=sz[v];
		}
	}
}
void dfs2(int t,int f){
	for(int i=head[t];i;i=edge[i].nxt){
		int v=edge[i].arr;
		if (v!=f){
			if ((v==a && t==b) || (v==b && t==a)) continue;
			if (sz[v]>Maxson[t]) Maxson[t]=sz[v];
			dfs2(v,t);
		}
	}
}
void dfs3(int t,int f,int x){
	if (max(Maxson[t],x-sz[t])<=x/2) ans+=t;
	for(int i=head[t];i;i=edge[i].nxt){
		int v=edge[i].arr;
		if (v!=f){
			if ((v==a && t==b) || (v==b && t==a)) continue;
			dfs3(v,t,x);
		}
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while (t--){
		memset(head,0,sizeof(head));
		cnt=0;
		ans=0;
		scanf("%d",&n);
		For(i,1,n-1){
			scanf("%d%d",&u[i],&v[i]);
			add(u[i],v[i]);
			add(v[i],u[i]);
		}
		For(i,1,n-1){
			memset(Maxson,0,sizeof(Maxson));
			memset(sz,0,sizeof(sz));
			a=u[i];
			b=v[i];
			dfs1(u[i],0);
			dfs2(u[i],0);
			dfs3(u[i],0,sz[u[i]]);
			memset(Maxson,0,sizeof(Maxson));
			memset(sz,0,sizeof(sz));
			dfs1(v[i],0);
			dfs2(v[i],0);
			dfs3(v[i],0,sz[v[i]]);
		}
		printf("%lld\n",ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
