#include<bits/stdc++.h>
using namespace std;

const int N=3e5+10;
int n;
struct Edge {
	int to,next;
	bool tag;
} edge[N<<1];
int head[N]; 
int tmp;
int du[N];
int maxdu;
void add(int x,int y) {
	++tmp;
	edge[tmp].to=y;
	edge[tmp].next=head[x];
	head[x]=tmp;
	edge[tmp].tag=0;
}
void init() {
	scanf("%d",&n);
	tmp=-1;
	memset(head,-1,sizeof(head));
	memset(du,0,sizeof(du));
	for(int i=1; i<n; i++) {
		int x,y;
		scanf("%d%d",&x,&y);
		add(x,y);
		add(y,x);
		du[x]++; du[y]++;
		maxdu=max(maxdu,max(du[x],du[y]));
	}
}

namespace task1{
    int id[N];
    int cnt;
    
    void bl(int nod,int fa){
	    id[++cnt]=nod;
	    for(int i=head[nod];i!=-1;i=edge[i].next){
		    int t=edge[i].to;
		    if(t==fa) continue;
		    bl(t,nod);
		}
	}
	
	void work(){
	    cnt=0; memset(id,0,sizeof(id));
	    int st=-1;
	    for(int i=1;i<=n;i++)
	    if(du[i]==1) { st=i; break; }
	    bl(st,st);
	    
	    long long ans=0;
	    for(int i=1;i<n;i++){
		    if(i&1){
			    ans+=id[i/2+1];
			}else{
			    ans+=id[i/2]+id[i/2+1];
			}
			
			if((n-i)&1){
			    ans+=id[(n-i)/2+1+i];
			}else{
			    ans+=id[(n-i)/2+i]+id[(n-i)/2+i+1];
			}
		}
		printf("%lld\n",ans);
	}
}

namespace task2 {
	int sz[N];
	int f[N];
	void get(int nod,int fa) {
		f[nod]=fa;
		sz[nod]=1;
		for(int i=head[nod]; i!=-1; i=edge[i].next) {
			int t=edge[i].to;
			if(t==fa) continue;
			get(t,nod);
			sz[nod]+=sz[t];
		}
	}

	long long ans;
	void geth(int nod,int fa,int tot) {
		int maxx=0;
		for(int i=head[nod]; i!=-1; i=edge[i].next) {
			int t=edge[i].to;
			if(t==fa) continue;
			if(edge[i].tag) continue;
			maxx=max(maxx,sz[t]);
			geth(t,nod,tot);
		}
		maxx=max(maxx,tot-sz[nod]);
		if(maxx+maxx<=tot) ans+=nod;
	}

	void dfs(int nod,int fa) {
		for(int i=head[nod]; i!=-1; i=edge[i].next) {
			int t=edge[i].to;
			if(t==fa) continue;
			edge[i].tag=edge[i^1].tag=1;
			for(int j=nod;;j=f[j]) { sz[j]-=sz[t]; if(j==1) break; }
			geth(1,1,sz[1]);
			geth(t,t,sz[t]);
			for(int j=nod;;j=f[j]) { sz[j]+=sz[t]; if(j==1) break; }
			edge[i].tag=edge[i^1].tag=0;
			dfs(t,nod);
		}
	}
    
    void work(){
	    get(1,1);
	    ans=0;
	    dfs(1,1);
	    printf("%lld\n",ans);
	}
}

int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--) {
		init();
		if(maxdu==2) {
			task1::work();
			continue;
		}
		task2::work();
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}

