#include<cstdio>
#include<cstring>
#include<map>
using namespace std;
typedef long long ll;
const int N=1e5+5;
map<ll,int> Map;
int Head[N],vet[N<<1],Next[N<<1];
int ind[N],a[N],depth[N];
int n,u,v,tot1,tot2,edgenum,T;
ll ans;
bool vis[N];
struct edge{ int u,v; } E[N];
inline void addedge(int u, int v){
	edgenum++;
	Map[(ll)u*n+v]=edgenum;
	vet[edgenum]=v;
	Next[edgenum]=Head[u];
	Head[u]=edgenum;
}
int dfs1(int u, int f){
	int sz=1;
	for (int e=Head[u]; e; e=Next[e]){
		int v=vet[e];
		if (vis[e] || v==f) continue;
		sz+=dfs1(v,u);
	}
	return sz;
}
int dfs(int u, int f, int tot){
	int sz=1,mx=0;
	for (int e=Head[u]; e; e=Next[e]){
		int v=vet[e];
		if (vis[e] || v==f) continue;
		int sz1=dfs(v,u,tot);
		sz+=sz1; mx=max(mx,sz1);
	}
	mx=max(mx,tot-sz);
	if (mx<=tot/2) ans+=u;
	return sz;
}
inline int read(){
	int num=0; char ch=getchar();
	while (ch<'0' || ch>'9') ch=getchar();
	while (ch>='0' && ch<='9') num=(num<<3)+(num<<1)+ch-'0',ch=getchar();
	return num;
}
inline void init(){
	edgenum=0; Map.clear(); ans=0;
	memset(Head,0,sizeof(Head));
	memset(ind,0,sizeof(ind));
	memset(a,0,sizeof(a));
	memset(depth,0,sizeof(depth));
}
namespace S1{
	void dfs(int u, int f){
		depth[u]=depth[f]+1;
		a[depth[u]]=u;
		for (int e=Head[u]; e; e=Next[e]){
			int v=vet[e];
			if (v==f) continue;
			dfs(v,u);
		}
	}
	void main(){
		for (int i=1; i<=n; i++) if (ind[i]==1){ dfs(i,0); break; }
		for (int i=1; i<n; i++){
			int t1=i,t2=i+1;
			if (t1%2==0) ans+=(ll)a[t1/2]+a[t1/2+1];
			else ans+=(ll)a[(t1+1)/2];
			if ((n-t2+1)%2==0) ans+=(ll)a[t2+(n-t2+1)/2-1]+a[t2+(n-t2+1)/2];
			else ans+=(ll)a[t2+(n-t2+2)/2-1];
		}
		printf("%lld\n",ans);
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T=read();
	for (; T; T--){
		n=read(); init();
		for (int i=1; i<n; i++){
			u=read(); v=read();
			E[i]=(edge){u,v};
			ind[u]++; ind[v]++;
			addedge(u,v); addedge(v,u);
		}
		bool flag=0;
		for (int i=1; i<=n; i++)
			if (ind[i]>2){ flag=1; break; }
		if (!flag){ S1::main(); continue; }
		for (int i=1; i<n; i++){
			vis[Map[(ll)E[i].u*n+E[i].v]]=vis[Map[(ll)E[i].v*n+E[i].u]]=1;
			tot1=dfs1(E[i].u,0); tot2=dfs1(E[i].v,0);
			dfs(E[i].u,0,tot1); dfs(E[i].v,0,tot2);
			vis[Map[(ll)E[i].u*n+E[i].v]]=vis[Map[(ll)E[i].v*n+E[i].u]]=0;
		}
		printf("%lld\n",ans);
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
