#include <bits/stdc++.h>
using namespace std;

template <typename T>

void read(T &a)
{
	T x = 0,f = 1;
	char ch = getchar();
	while (ch > '9' || ch <'0')
	{
		if (ch == '-') f = -1;
		ch = getchar();
	}
	while (ch <= '9' && ch >= '0')
	{
		x = (x << 1) + (x << 3) + ch - '0';
		ch = getchar();
	}
	a = x * f;
}

int n,pnt[600005],nxt[600005],head[300005],E = 0;

void add_edge(int u,int v)
{
	pnt[E] = v;
	nxt[E] = head[u];
	head[u] = E++;
}

struct node
{
	std::vector<int> children;
}tr[300005];
bool vis[300005];

void dfs(int x)
{
	vis[x] = 1;
	for (int i = head[x]; i != -1; i = nxt[i])
	{
		int v = pnt[i];
		if (vis[v]) continue;
		vis[v] = 1;
		tr[x].children.push_back(v);
		dfs(v);
	}
}

int dfs2(int e,int x)
{
	for (int i = head[x]; i != -1; i = nxt[i])
	{
		if (i == e) continue;
		int v = pnt[i];
		dfs2(e,v);
	}
}

int main()
{
	int t;
	read(t);
	while (t--)
	{
		read(n);
		for (int i = 1; i <= n; i++)
		{
			vis[i] = 0;
			head[i] = -1;
		}
		for (int i = 1; i < n; i++)
		{
			int u,v;
			read(u);
			read(v);
			add_edge(u,v);
			add_edge(v,u);
		}
		dfs(1);
		int ans = 0;
		for (int u = 1; u <= n; u++)
		{
			for (int i = head[u]; i != -1; i = nxt[i])
			{
				for (int j = 1; j <= n; j++) vis[j] = 0;
				ans += dfs2(i,u);
				for (int j = 1; j <= n; j++) vis[j] = 0;
				ans += dfs2(i,1);
			}
		}
		ans /= 2;
		printf("%d",ans);
	}
	return 0;
}