#include<bits/stdc++.h>
#define LL long long
using namespace std;
const int N=300005;

int n,T,head[N],tot;
struct edge{
	int v,nxt;
}e[N<<1];
void addedge(int u,int v){
	e[++tot]=(edge){v,head[u]};
	head[u]=tot;
	e[++tot]=(edge){u,head[v]};
	head[v]=tot;
}
namespace task1{
	int E[2005][2],sz[2005],ans;
	void dfs(int x,int fa){
		sz[x]=1;
		for(int i=head[x];i;i=e[i].nxt){
			if(e[i].v==fa)continue;
			dfs(e[i].v,x);
			sz[x]+=sz[e[i].v];
		}
	}
	void dfs2(int x,int y,int fa){
		int mx=y-sz[x];
		for(int i=head[x];i;i=e[i].nxt){
			if(e[i].v==fa)continue;
			dfs2(e[i].v,y,x);
			mx=max(mx,sz[e[i].v]);
		}
		if(mx<=y/2)ans+=x;
	}
	void main(){
		tot=ans=0;
		for(int i=1;i<=n;i++)head[i]=0;
		for(int i=1;i<n;i++){
			scanf("%d%d",&E[i][0],&E[i][1]);
			addedge(E[i][0],E[i][1]);
		}
		for(int i=1;i<n;i++){
			dfs(E[i][0],E[i][1]);
			dfs(E[i][1],E[i][0]);
			dfs2(E[i][0],sz[E[i][0]],E[i][1]);
			dfs2(E[i][1],sz[E[i][1]],E[i][0]);
		}
		printf("%d\n",ans);
	}
}
namespace task2{
	int d[50005],id[50005],E[50005][2],du[50005];
	LL ans;
	void dfs(int x,int fa){
		d[x]=d[fa]+1;
		id[d[x]]=x;
		for(int i=head[x];i;i=e[i].nxt){
			if(e[i].v==fa)continue;
			dfs(e[i].v,x);
		}
	}
	void main(){
		tot=ans=d[0]=0;
		for(int i=1;i<=n;i++)head[i]=0,du[i]=0;
		for(int i=1;i<n;i++){
			scanf("%d%d",&E[i][0],&E[i][1]);
			addedge(E[i][0],E[i][1]);
			du[E[i][0]]++;
			du[E[i][1]]++;
		}
		int x;
		for(x=1;x<=n;x++)
			if(du[x]==1)break;
		dfs(x,0);
		for(int i=1;i<n;i++){
			if(d[E[i][0]]>d[E[i][1]])swap(E[i][0],E[i][1]);
			int dep=d[E[i][0]];
			if(dep&1)ans+=id[dep/2+1];
			else{
				ans+=id[dep/2]+id[dep/2+1];
			}
			dep=n+d[E[i][1]];
			if(dep&1)ans+=id[dep/2+1]+id[dep/2];
			else{
				ans+=id[dep/2];
			}
		}
		printf("%lld\n",ans);
	}
}
namespace task3{
	int E[270005][2];
	LL ans;
	void main(){
		ans=0;
		for(int i=1;i<n;i++){
			scanf("%d%d",&E[i][0],&E[i][1]);
			addedge(E[i][0],E[i][1]);
		}
		for(int i=1;i<n;i++){
			int u=E[i][0],v=E[i][1];
			if(u<v)swap(u,v);
			if(u>n/2){
				ans+=u;
				ans++;
			}
			else{
				ans+=u;
			}
		}
		ans+=5*((n-3)/4);
		printf("%lld\n",ans);
	}
}
namespace task4{
	int sz[N],son[N],id[N],cnt,id2[N],E[N][2];
	LL ans;
	void dfs1(int x,int fa){
		sz[x]=1;
		for(int i=head[x];i;i=e[i].nxt){
			if(fa==e[i].v)continue;
			dfs1(e[i].v,x);
			sz[x]+=sz[e[i].v];
			if(sz[e[i].v]>sz[son[x]])son[x]=e[i].v;
		}
	}
	void dfs2(int x,int fa){
		id[x]=++cnt;
		if(son[x])dfs2(son[x],x);
		for(int i=head[x];i;i=e[i].nxt){
			if(fa==e[i].v||e[i].v==son[x])continue;
			dfs2(e[i].v,x);
		}
	}
	void main(){
		tot=ans=cnt=0;
		for(int i=1;i<=n;i++)head[i]=0,son[i]=0;
		for(int i=1;i<n;i++){
			scanf("%d%d",&E[i][0],&E[i][1]);
			addedge(E[i][0],E[i][1]);
		}
		dfs1(1,0);
		dfs2(1,0);
		for(int i=1;i<=n;i++){
			id2[id[i]]=i;
		}
		for(int i=1;i<n;i++){
			int u=E[i][0],v=E[i][1];
			if(id[u]<id[v])swap(u,v);
			int S=n-sz[u];
			if(S&1){
				int p=S/2+1;
				if(p<=id[v])ans+=id2[p];
				else ans+=id2[p+sz[u]];
			}
			else{
				int p=S/2+1;
				if(p<=id[v])ans+=id2[p];
				else ans+=id2[p+sz[u]];
				p=S/2;
				if(p<=id[v])ans+=id2[p];
				else ans+=id2[p+sz[u]];
			}
			S=sz[u];
			if(S&1){
				int p=S/2+1;
				ans+=id2[u+p-1];
			}
			else{
				int p=S/2+1;
				ans+=id2[u+p-1];
				p=S/2;
				ans+=id2[u+p-1];
			}
		}
		printf("%lld\n",ans);
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		scanf("%d",&n);
		if(n<=2000)task1::main();
		else if(n==49991)task2::main();
		else if(n==262143)task3::main();
		else task4::main();
	}
}
