#include <bits/stdc++.h>
using namespace std;
const int maxn = 3e5 + 10;
vector<int> E[maxn];
int t, n, m, u, v, V, G;
int size[maxn], fa[maxn], depth[maxn], mxson[maxn], L[maxn], R[maxn], tot, node[maxn];
long long ans;
void dfs(int x){
	size[x] = 1;
	mxson[x] = 0;
	L[x] = ++tot;
	node[tot] = x;
	//cerr << x << endl;
	for(vector<int>::iterator i = E[x].begin(); i != E[x].end(); i++){
		if(*i == fa[x]) continue;
		fa[*i] = x;
		depth[*i] = depth[x] + 1;
		dfs(*i);
		size[x] += size[*i];
		mxson[x] = max(mxson[x], size[*i]);
	}
	if(mxson[x] <= n/2 && size[x] >= (n+1)/2) 
		G = x;
	R[x] = tot;
}
bool instack[maxn];
stack<int> S;
void dfs1(int x){
	for(vector<int>::iterator i = E[x].begin(); i != E[x].end(); i++){
		if(*i == fa[x]) continue;
		instack[*i] = true;
		dfs1(*i);
		V = size[*i];
		//cerr << x << "---" << *i << endl;
		//cerr << S.size() << endl;
		for(int k = 1; k <= n; k++){
			if(!instack[k] && k != G){
				if(mxson[k] <= (n-V)/2 && size[k] >= (n-V+1)/2){
					ans += k;
					//cerr << k << endl;
				}
			}
		}
		while(!S.empty()){
			int key = S.top();
			S.pop();
			if(mxson[key] <= V/2 && size[key] >= (V+1)/2){
				ans += key;
				//cerr << key << endl;
			}
		}
		int mxsize = 0;
		for(vector<int>::iterator j = E[G].begin(); j != E[G].end(); j++){
			if(instack[*j]) mxsize = max(mxsize, size[*j] - V);
			else mxsize = max(mxsize, size[*j]);
		}
		if(mxsize <= (n-V)/2){ ans += G; }
		if(x == G) memset(instack, 0, sizeof(instack));
	}
	for(int i = L[x]; i <= R[x]; i++)
		S.push(node[i]);
}
int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &t);
	while(t--){
		while(!S.empty()) S.pop();
		ans = 0;
		scanf("%d", &n);
		for(int i = 1; i < n; i++){
			scanf("%d%d", &u, &v);
			E[u].push_back(v);
			E[v].push_back(u);
		}
		fa[1] = 0;
		depth[1] = 0;
		dfs(1);
		//cerr << "###" << endl;
		//cerr << G << endl;
		depth[G] = 0;
		fa[G] = 0;
		tot = 0;
		memset(node, 0, sizeof(node));
		dfs(G);
	//	for(int i = 1; i <= n; i++)
	//		cerr << size[i] << " " << mxson[i] << endl;
		dfs1(G);
		printf("%lld\n", ans);
		for(int i = 1; i <= n; i++) E[i].clear();
	}
	return 0;
}
